#ifndef mozilla_dom_BindingNames_h
#define mozilla_dom_BindingNames_h

#include <stddef.h>
#include <stdint.h>
#include "mozilla/Attributes.h"

namespace mozilla::dom {

enum class BindingNamesOffset : uint16_t {
  ANGLE_instanced_arrays = 0,
  APZHitResultFlags = 23,
  AbortController = 41,
  AbortSignal = 57,
  AbstractRange = 69,
  AccessibleNode = 83,
  Addon = 98,
  AddonEvent = 104,
  AddonInstall = 115,
  AddonManager = 128,
  AddonManagerPermissions = 141,
  AnalyserNode = 165,
  Animation = 178,
  AnimationEffect = 188,
  AnimationEvent = 204,
  AnimationPlaybackEvent = 219,
  AnimationTimeline = 242,
  AnonymousContent = 260,
  Attr = 277,
  Audio = 282,
  AudioBuffer = 288,
  AudioBufferSourceNode = 300,
  AudioContext = 322,
  AudioDestinationNode = 335,
  AudioListener = 356,
  AudioNode = 370,
  AudioParam = 380,
  AudioParamMap = 391,
  AudioProcessingEvent = 405,
  AudioScheduledSourceNode = 426,
  AudioTrack = 451,
  AudioTrackList = 462,
  AudioWorklet = 477,
  AudioWorkletGlobalScope = 490,
  AudioWorkletNode = 514,
  AudioWorkletProcessor = 531,
  AuthenticatorAssertionResponse = 553,
  AuthenticatorAttestationResponse = 584,
  AuthenticatorResponse = 617,
  BarProp = 639,
  BaseAudioContext = 647,
  BatteryManager = 664,
  BeforeUnloadEvent = 679,
  BiquadFilterNode = 697,
  Blob = 714,
  BlobEvent = 719,
  BroadcastChannel = 729,
  BrowsingContext = 746,
  BrowsingContextGroup = 762,
  ByteLengthQueuingStrategy = 783,
  CDATASection = 809,
  CSS = 822,
  CSS2Properties = 826,
  CSSAnimation = 841,
  CSSConditionRule = 854,
  CSSContainerRule = 871,
  CSSCounterStyleRule = 888,
  CSSFontFaceRule = 908,
  CSSFontFeatureValuesRule = 924,
  CSSGroupingRule = 949,
  CSSImportRule = 965,
  CSSKeyframeRule = 979,
  CSSKeyframesRule = 995,
  CSSLayerBlockRule = 1012,
  CSSLayerStatementRule = 1030,
  CSSMediaRule = 1052,
  CSSMozDocumentRule = 1065,
  CSSNamespaceRule = 1084,
  CSSPageRule = 1101,
  CSSPseudoElement = 1113,
  CSSRule = 1130,
  CSSRuleList = 1138,
  CSSScrollTimelineRule = 1150,
  CSSStyleDeclaration = 1172,
  CSSStyleRule = 1192,
  CSSStyleSheet = 1205,
  CSSSupportsRule = 1219,
  CSSTransition = 1235,
  Cache = 1249,
  CacheStorage = 1255,
  CallbackDebuggerNotification = 1268,
  CanonicalBrowsingContext = 1297,
  CanvasCaptureMediaStream = 1322,
  CanvasGradient = 1347,
  CanvasPattern = 1362,
  CanvasRenderingContext2D = 1376,
  CaretPosition = 1401,
  CaretStateChangedEvent = 1415,
  ChannelMergerNode = 1438,
  ChannelSplitterNode = 1456,
  ChannelWrapper = 1476,
  CharacterData = 1491,
  CheckerboardReportService = 1505,
  ChildProcessMessageManager = 1531,
  ChildSHistory = 1558,
  ChromeMessageBroadcaster = 1572,
  ChromeMessageSender = 1597,
  ChromeNodeList = 1617,
  ChromeUtils = 1632,
  ChromeWorker = 1644,
  Client = 1657,
  Clients = 1664,
  Clipboard = 1672,
  ClipboardEvent = 1682,
  ClipboardItem = 1697,
  ClonedErrorHolder = 1711,
  CloseEvent = 1729,
  CommandEvent = 1740,
  Comment = 1753,
  CompositionEvent = 1761,
  ConsoleInstance = 1778,
  ConstantSourceNode = 1794,
  ContentFrameMessageManager = 1813,
  ContentProcessMessageManager = 1840,
  ConvolverNode = 1869,
  CountQueuingStrategy = 1883,
  CreateOfferRequest = 1904,
  Credential = 1923,
  CredentialsContainer = 1934,
  Crypto = 1955,
  CryptoKey = 1962,
  CustomElementRegistry = 1972,
  CustomEvent = 1994,
  DOMException = 2006,
  DOMImplementation = 2019,
  DOMLocalization = 2037,
  DOMMatrix = 2053,
  DOMMatrixReadOnly = 2063,
  DOMParser = 2081,
  DOMPoint = 2091,
  DOMPointReadOnly = 2100,
  DOMQuad = 2117,
  DOMRect = 2125,
  DOMRectList = 2133,
  DOMRectReadOnly = 2145,
  DOMRequest = 2161,
  DOMStringList = 2172,
  DOMStringMap = 2186,
  DOMTokenList = 2199,
  DataTransfer = 2212,
  DataTransferItem = 2225,
  DataTransferItemList = 2242,
  DebuggerNotification = 2263,
  DebuggerNotificationObserver = 2284,
  DedicatedWorkerGlobalScope = 2313,
  DelayNode = 2340,
  DeprecationReportBody = 2350,
  DeviceAcceleration = 2372,
  DeviceLightEvent = 2391,
  DeviceMotionEvent = 2408,
  DeviceOrientationEvent = 2426,
  DeviceRotationRate = 2449,
  Directory = 2468,
  Document = 2478,
  DocumentFragment = 2487,
  DocumentL10n = 2504,
  DocumentTimeline = 2517,
  DocumentType = 2534,
  DominatorTree = 2547,
  DragEvent = 2561,
  DynamicsCompressorNode = 2571,
  EXT_blend_minmax = 2594,
  EXT_color_buffer_float = 2611,
  EXT_color_buffer_half_float = 2634,
  EXT_disjoint_timer_query = 2662,
  EXT_float_blend = 2687,
  EXT_frag_depth = 2703,
  EXT_sRGB = 2718,
  EXT_shader_texture_lod = 2727,
  EXT_texture_compression_bptc = 2750,
  EXT_texture_compression_rgtc = 2779,
  EXT_texture_filter_anisotropic = 2808,
  EXT_texture_norm16 = 2839,
  Element = 2858,
  ElementInternals = 2866,
  ErrorEvent = 2883,
  Event = 2894,
  EventCallbackDebuggerNotification = 2900,
  EventCounts = 2934,
  EventSource = 2946,
  EventTarget = 2958,
  Exception = 2970,
  ExtendableEvent = 2980,
  ExtendableMessageEvent = 2996,
  ExtensionAlarms = 3019,
  ExtensionBrowser = 3035,
  ExtensionEventManager = 3052,
  ExtensionMockAPI = 3074,
  ExtensionPort = 3091,
  ExtensionRuntime = 3105,
  ExtensionTest = 3122,
  External = 3136,
  FeaturePolicy = 3145,
  FeaturePolicyViolationReportBody = 3159,
  FetchEvent = 3192,
  FetchObserver = 3203,
  File = 3217,
  FileList = 3222,
  FileReader = 3231,
  FileReaderSync = 3242,
  FileSystem = 3257,
  FileSystemDirectoryEntry = 3268,
  FileSystemDirectoryHandle = 3293,
  FileSystemDirectoryIterator = 3319,
  FileSystemDirectoryReader = 3347,
  FileSystemEntry = 3373,
  FileSystemFileEntry = 3389,
  FileSystemFileHandle = 3409,
  FileSystemHandle = 3430,
  FileSystemSyncAccessHandle = 3447,
  FileSystemWritableFileStream = 3474,
  Flex = 3503,
  FlexItemValues = 3508,
  FlexLineValues = 3523,
  FluentBundle = 3538,
  FluentBundleAsyncIterator = 3551,
  FluentBundleIterator = 3577,
  FluentPattern = 3598,
  FluentResource = 3612,
  FocusEvent = 3627,
  FontFace = 3638,
  FontFaceSet = 3647,
  FontFaceSetIterator = 3659,
  FontFaceSetLoadEvent = 3679,
  FormData = 3700,
  FormData_Iterator = 3709,
  FormDataEvent = 3727,
  FrameCrashedEvent = 3741,
  FrameLoader = 3759,
  GPU = 3771,
  GPUAdapter = 3775,
  GPUBindGroup = 3786,
  GPUBindGroupLayout = 3799,
  GPUBuffer = 3818,
  GPUBufferUsage = 3828,
  GPUCanvasContext = 3843,
  GPUColorWrite = 3860,
  GPUCommandBuffer = 3874,
  GPUCommandEncoder = 3891,
  GPUCompilationInfo = 3909,
  GPUCompilationMessage = 3928,
  GPUComputePassEncoder = 3950,
  GPUComputePipeline = 3972,
  GPUDevice = 3991,
  GPUDeviceLostInfo = 4001,
  GPUMapMode = 4019,
  GPUOutOfMemoryError = 4030,
  GPUPipelineLayout = 4050,
  GPUQuerySet = 4068,
  GPUQueue = 4080,
  GPURenderBundle = 4089,
  GPURenderBundleEncoder = 4105,
  GPURenderPassEncoder = 4128,
  GPURenderPipeline = 4149,
  GPUSampler = 4167,
  GPUShaderModule = 4178,
  GPUShaderStage = 4194,
  GPUSupportedFeatures = 4209,
  GPUSupportedLimits = 4230,
  GPUTexture = 4249,
  GPUTextureUsage = 4260,
  GPUTextureView = 4276,
  GPUUncapturedErrorEvent = 4291,
  GPUValidationError = 4315,
  GainNode = 4334,
  Gamepad = 4343,
  GamepadAxisMoveEvent = 4351,
  GamepadButton = 4372,
  GamepadButtonEvent = 4386,
  GamepadEvent = 4405,
  GamepadHapticActuator = 4418,
  GamepadLightIndicator = 4440,
  GamepadPose = 4462,
  GamepadServiceTest = 4474,
  GamepadTouch = 4493,
  Geolocation = 4506,
  GeolocationCoordinates = 4518,
  GeolocationPosition = 4541,
  GeolocationPositionError = 4561,
  GetUserMediaRequest = 4586,
  GleanCategory = 4606,
  GleanImpl = 4620,
  GleanLabeled = 4630,
  GleanPingsImpl = 4643,
  Grid = 4658,
  GridArea = 4663,
  GridDimension = 4672,
  GridLine = 4686,
  GridLines = 4695,
  GridTrack = 4705,
  GridTracks = 4715,
  HTMLAllCollection = 4726,
  HTMLAnchorElement = 4744,
  HTMLAreaElement = 4762,
  HTMLAudioElement = 4778,
  HTMLBRElement = 4795,
  HTMLBaseElement = 4809,
  HTMLBodyElement = 4825,
  HTMLButtonElement = 4841,
  HTMLCanvasElement = 4859,
  HTMLCollection = 4877,
  HTMLDListElement = 4892,
  HTMLDataElement = 4909,
  HTMLDataListElement = 4925,
  HTMLDetailsElement = 4945,
  HTMLDialogElement = 4964,
  HTMLDirectoryElement = 4982,
  HTMLDivElement = 5003,
  HTMLDocument = 5018,
  HTMLElement = 5031,
  HTMLEmbedElement = 5043,
  HTMLFieldSetElement = 5060,
  HTMLFontElement = 5080,
  HTMLFormControlsCollection = 5096,
  HTMLFormElement = 5123,
  HTMLFrameElement = 5139,
  HTMLFrameSetElement = 5156,
  HTMLHRElement = 5176,
  HTMLHeadElement = 5190,
  HTMLHeadingElement = 5206,
  HTMLHtmlElement = 5225,
  HTMLIFrameElement = 5241,
  HTMLImageElement = 5259,
  HTMLInputElement = 5276,
  HTMLLIElement = 5293,
  HTMLLabelElement = 5307,
  HTMLLegendElement = 5324,
  HTMLLinkElement = 5342,
  HTMLMapElement = 5358,
  HTMLMarqueeElement = 5373,
  HTMLMediaElement = 5392,
  HTMLMenuElement = 5409,
  HTMLMenuItemElement = 5425,
  HTMLMetaElement = 5445,
  HTMLMeterElement = 5461,
  HTMLModElement = 5478,
  HTMLOListElement = 5493,
  HTMLObjectElement = 5510,
  HTMLOptGroupElement = 5528,
  HTMLOptionElement = 5548,
  HTMLOptionsCollection = 5566,
  HTMLOutputElement = 5588,
  HTMLParagraphElement = 5606,
  HTMLParamElement = 5627,
  HTMLPictureElement = 5644,
  HTMLPreElement = 5663,
  HTMLProgressElement = 5678,
  HTMLQuoteElement = 5698,
  HTMLScriptElement = 5715,
  HTMLSelectElement = 5733,
  HTMLSlotElement = 5751,
  HTMLSourceElement = 5767,
  HTMLSpanElement = 5785,
  HTMLStyleElement = 5801,
  HTMLTableCaptionElement = 5818,
  HTMLTableCellElement = 5842,
  HTMLTableColElement = 5863,
  HTMLTableElement = 5883,
  HTMLTableRowElement = 5900,
  HTMLTableSectionElement = 5920,
  HTMLTemplateElement = 5944,
  HTMLTextAreaElement = 5964,
  HTMLTimeElement = 5984,
  HTMLTitleElement = 6000,
  HTMLTrackElement = 6017,
  HTMLUListElement = 6034,
  HTMLUnknownElement = 6051,
  HTMLVideoElement = 6070,
  HashChangeEvent = 6087,
  Headers = 6103,
  Headers_Iterator = 6111,
  HeapSnapshot = 6128,
  History = 6141,
  IDBCursor = 6149,
  IDBCursorWithValue = 6159,
  IDBDatabase = 6178,
  IDBFactory = 6190,
  IDBFileHandle = 6201,
  IDBFileRequest = 6215,
  IDBIndex = 6230,
  IDBKeyRange = 6239,
  IDBLocaleAwareKeyRange = 6251,
  IDBMutableFile = 6274,
  IDBObjectStore = 6289,
  IDBOpenDBRequest = 6304,
  IDBRequest = 6321,
  IDBTransaction = 6332,
  IDBVersionChangeEvent = 6347,
  IIRFilterNode = 6369,
  IOUtils = 6383,
  IdleDeadline = 6391,
  Image = 6404,
  ImageBitmap = 6410,
  ImageBitmapRenderingContext = 6422,
  ImageCapture = 6450,
  ImageCaptureError = 6463,
  ImageCaptureErrorEvent = 6481,
  ImageData = 6504,
  ImageDocument = 6514,
  InputEvent = 6528,
  InspectorFontFace = 6539,
  InspectorUtils = 6557,
  InstallTriggerImpl = 6572,
  IntersectionObserver = 6591,
  IntersectionObserverEntry = 6612,
  IntlUtils = 6638,
  JSProcessActorChild = 6648,
  JSProcessActorParent = 6668,
  JSWindowActorChild = 6689,
  JSWindowActorParent = 6708,
  KeyEvent = 6728,
  KeyboardEvent = 6737,
  KeyframeEffect = 6751,
  L10nFileSource = 6766,
  L10nOverlays = 6781,
  L10nRegistry = 6794,
  LegacyMozTCPSocket = 6807,
  Localization = 6826,
  Location = 6839,
  Lock = 6848,
  LockManager = 6853,
  MIDIAccess = 6865,
  MIDIConnectionEvent = 6876,
  MIDIInput = 6896,
  MIDIInputMap = 6906,
  MIDIMessageEvent = 6919,
  MIDIOutput = 6936,
  MIDIOutputMap = 6947,
  MIDIPort = 6961,
  MOZ_debug = 6970,
  MatchGlob = 6980,
  MatchPattern = 6990,
  MatchPatternSet = 7003,
  MathMLElement = 7019,
  MediaCapabilities = 7033,
  MediaCapabilitiesInfo = 7051,
  MediaControlService = 7073,
  MediaController = 7093,
  MediaDeviceInfo = 7109,
  MediaDevices = 7125,
  MediaElementAudioSourceNode = 7138,
  MediaEncryptedEvent = 7166,
  MediaError = 7186,
  MediaKeyError = 7197,
  MediaKeyMessageEvent = 7211,
  MediaKeySession = 7232,
  MediaKeyStatusMap = 7248,
  MediaKeyStatusMap_Iterator = 7266,
  MediaKeySystemAccess = 7293,
  MediaKeys = 7314,
  MediaList = 7324,
  MediaMetadata = 7334,
  MediaQueryList = 7348,
  MediaQueryListEvent = 7363,
  MediaRecorder = 7383,
  MediaRecorderErrorEvent = 7397,
  MediaSession = 7421,
  MediaSource = 7434,
  MediaStream = 7446,
  MediaStreamAudioDestinationNode = 7458,
  MediaStreamAudioSourceNode = 7490,
  MediaStreamError = 7517,
  MediaStreamEvent = 7534,
  MediaStreamTrack = 7551,
  MediaStreamTrackAudioSourceNode = 7568,
  MediaStreamTrackEvent = 7600,
  MerchantValidationEvent = 7622,
  MessageBroadcaster = 7646,
  MessageChannel = 7665,
  MessageEvent = 7680,
  MessageListenerManager = 7693,
  MessagePort = 7716,
  MessageSender = 7728,
  MimeType = 7742,
  MimeTypeArray = 7751,
  MouseEvent = 7765,
  MouseScrollEvent = 7776,
  MozCanvasPrintState = 7793,
  MozDocumentMatcher = 7813,
  MozDocumentObserver = 7832,
  MozQueryInterface = 7852,
  MozSharedMap = 7870,
  MozSharedMap_Iterator = 7883,
  MozSharedMapChangeEvent = 7905,
  MozStorageAsyncStatementParams = 7929,
  MozStorageStatementParams = 7960,
  MozStorageStatementRow = 7986,
  MozWritableSharedMap = 8009,
  MutationEvent = 8030,
  MutationObserver = 8044,
  MutationRecord = 8061,
  NamedNodeMap = 8076,
  NavigationPreloadManager = 8089,
  Navigator = 8114,
  NetworkInformation = 8124,
  Node = 8143,
  NodeFilter = 8148,
  NodeIterator = 8159,
  NodeList = 8172,
  Notification = 8181,
  NotificationEvent = 8194,
  NotifyPaintEvent = 8212,
  OES_draw_buffers_indexed = 8229,
  OES_element_index_uint = 8254,
  OES_fbo_render_mipmap = 8277,
  OES_standard_derivatives = 8299,
  OES_texture_float = 8324,
  OES_texture_float_linear = 8342,
  OES_texture_half_float = 8367,
  OES_texture_half_float_linear = 8390,
  OES_vertex_array_object = 8420,
  OVR_multiview2 = 8444,
  OfflineAudioCompletionEvent = 8459,
  OfflineAudioContext = 8487,
  OfflineResourceList = 8507,
  OffscreenCanvas = 8527,
  OffscreenCanvasRenderingContext2D = 8543,
  Option = 8577,
  OscillatorNode = 8584,
  PageTransitionEvent = 8599,
  PaintRequest = 8619,
  PaintRequestList = 8632,
  PaintWorkletGlobalScope = 8649,
  PannerNode = 8673,
  ParentProcessMessageManager = 8684,
  Path2D = 8712,
  PathUtils = 8719,
  PaymentAddress = 8729,
  PaymentMethodChangeEvent = 8744,
  PaymentRequest = 8769,
  PaymentRequestUpdateEvent = 8784,
  PaymentResponse = 8810,
  Performance = 8826,
  PerformanceEntry = 8838,
  PerformanceEntryEvent = 8855,
  PerformanceEventTiming = 8877,
  PerformanceMark = 8900,
  PerformanceMeasure = 8916,
  PerformanceNavigation = 8935,
  PerformanceNavigationTiming = 8957,
  PerformanceObserver = 8985,
  PerformanceObserverEntryList = 9005,
  PerformancePaintTiming = 9034,
  PerformanceResourceTiming = 9057,
  PerformanceServerTiming = 9083,
  PerformanceTiming = 9107,
  PeriodicWave = 9125,
  PermissionStatus = 9138,
  Permissions = 9155,
  PlacesBookmark = 9167,
  PlacesBookmarkAddition = 9182,
  PlacesBookmarkChanged = 9205,
  PlacesBookmarkGuid = 9227,
  PlacesBookmarkMoved = 9246,
  PlacesBookmarkRemoved = 9266,
  PlacesBookmarkTags = 9288,
  PlacesBookmarkTime = 9307,
  PlacesBookmarkTitle = 9326,
  PlacesBookmarkUrl = 9346,
  PlacesEvent = 9364,
  PlacesFavicon = 9376,
  PlacesHistoryCleared = 9390,
  PlacesObservers = 9411,
  PlacesPurgeCaches = 9427,
  PlacesRanking = 9445,
  PlacesVisit = 9459,
  PlacesVisitRemoved = 9471,
  PlacesVisitTitle = 9490,
  PlacesWeakCallbackWrapper = 9507,
  Plugin = 9533,
  PluginArray = 9540,
  PluginCrashedEvent = 9552,
  PointerEvent = 9571,
  PopStateEvent = 9584,
  PopupBlockedEvent = 9598,
  PopupPositionedEvent = 9616,
  PositionStateEvent = 9637,
  PrecompiledScript = 9656,
  PrioEncoder = 9674,
  ProcessMessageManager = 9686,
  ProcessingInstruction = 9708,
  ProgressEvent = 9730,
  PromiseDebugging = 9744,
  PromiseNativeHandler = 9761,
  PromiseRejectionEvent = 9782,
  PublicKeyCredential = 9804,
  PushEvent = 9824,
  PushManager = 9834,
  PushManagerImpl = 9846,
  PushMessageData = 9862,
  PushSubscription = 9878,
  PushSubscriptionOptions = 9895,
  RadioNodeList = 9919,
  Range = 9933,
  ReadableByteStreamController = 9939,
  ReadableStream = 9968,
  ReadableStreamBYOBReader = 9983,
  ReadableStreamBYOBRequest = 10008,
  ReadableStreamDefaultController = 10034,
  ReadableStreamDefaultReader = 10066,
  Report = 10094,
  ReportBody = 10101,
  ReportingObserver = 10112,
  Request = 10130,
  ResizeObserver = 10138,
  ResizeObserverEntry = 10153,
  ResizeObserverSize = 10173,
  Response = 10192,
  SVGAElement = 10201,
  SVGAngle = 10213,
  SVGAnimateElement = 10222,
  SVGAnimateMotionElement = 10240,
  SVGAnimateTransformElement = 10264,
  SVGAnimatedAngle = 10291,
  SVGAnimatedBoolean = 10308,
  SVGAnimatedEnumeration = 10327,
  SVGAnimatedInteger = 10350,
  SVGAnimatedLength = 10369,
  SVGAnimatedLengthList = 10387,
  SVGAnimatedNumber = 10409,
  SVGAnimatedNumberList = 10427,
  SVGAnimatedPreserveAspectRatio = 10449,
  SVGAnimatedRect = 10480,
  SVGAnimatedString = 10496,
  SVGAnimatedTransformList = 10514,
  SVGAnimationElement = 10539,
  SVGCircleElement = 10559,
  SVGClipPathElement = 10576,
  SVGComponentTransferFunctionElement = 10595,
  SVGDefsElement = 10631,
  SVGDescElement = 10646,
  SVGElement = 10661,
  SVGEllipseElement = 10672,
  SVGFEBlendElement = 10690,
  SVGFEColorMatrixElement = 10708,
  SVGFEComponentTransferElement = 10732,
  SVGFECompositeElement = 10762,
  SVGFEConvolveMatrixElement = 10784,
  SVGFEDiffuseLightingElement = 10811,
  SVGFEDisplacementMapElement = 10839,
  SVGFEDistantLightElement = 10867,
  SVGFEDropShadowElement = 10892,
  SVGFEFloodElement = 10915,
  SVGFEFuncAElement = 10933,
  SVGFEFuncBElement = 10951,
  SVGFEFuncGElement = 10969,
  SVGFEFuncRElement = 10987,
  SVGFEGaussianBlurElement = 11005,
  SVGFEImageElement = 11030,
  SVGFEMergeElement = 11048,
  SVGFEMergeNodeElement = 11066,
  SVGFEMorphologyElement = 11088,
  SVGFEOffsetElement = 11111,
  SVGFEPointLightElement = 11130,
  SVGFESpecularLightingElement = 11153,
  SVGFESpotLightElement = 11182,
  SVGFETileElement = 11204,
  SVGFETurbulenceElement = 11221,
  SVGFilterElement = 11244,
  SVGForeignObjectElement = 11261,
  SVGGElement = 11285,
  SVGGeometryElement = 11297,
  SVGGradientElement = 11316,
  SVGGraphicsElement = 11335,
  SVGImageElement = 11354,
  SVGLength = 11370,
  SVGLengthList = 11380,
  SVGLineElement = 11394,
  SVGLinearGradientElement = 11409,
  SVGMPathElement = 11434,
  SVGMarkerElement = 11450,
  SVGMaskElement = 11467,
  SVGMatrix = 11482,
  SVGMetadataElement = 11492,
  SVGNumber = 11511,
  SVGNumberList = 11521,
  SVGPathElement = 11535,
  SVGPathSeg = 11550,
  SVGPathSegArcAbs = 11561,
  SVGPathSegArcRel = 11578,
  SVGPathSegClosePath = 11595,
  SVGPathSegCurvetoCubicAbs = 11615,
  SVGPathSegCurvetoCubicRel = 11641,
  SVGPathSegCurvetoCubicSmoothAbs = 11667,
  SVGPathSegCurvetoCubicSmoothRel = 11699,
  SVGPathSegCurvetoQuadraticAbs = 11731,
  SVGPathSegCurvetoQuadraticRel = 11761,
  SVGPathSegCurvetoQuadraticSmoothAbs = 11791,
  SVGPathSegCurvetoQuadraticSmoothRel = 11827,
  SVGPathSegLinetoAbs = 11863,
  SVGPathSegLinetoHorizontalAbs = 11883,
  SVGPathSegLinetoHorizontalRel = 11913,
  SVGPathSegLinetoRel = 11943,
  SVGPathSegLinetoVerticalAbs = 11963,
  SVGPathSegLinetoVerticalRel = 11991,
  SVGPathSegList = 12019,
  SVGPathSegMovetoAbs = 12034,
  SVGPathSegMovetoRel = 12054,
  SVGPatternElement = 12074,
  SVGPoint = 12092,
  SVGPointList = 12101,
  SVGPolygonElement = 12114,
  SVGPolylineElement = 12132,
  SVGPreserveAspectRatio = 12151,
  SVGRadialGradientElement = 12174,
  SVGRect = 12199,
  SVGRectElement = 12207,
  SVGSVGElement = 12222,
  SVGScriptElement = 12236,
  SVGSetElement = 12253,
  SVGStopElement = 12267,
  SVGStringList = 12282,
  SVGStyleElement = 12296,
  SVGSwitchElement = 12312,
  SVGSymbolElement = 12329,
  SVGTSpanElement = 12346,
  SVGTextContentElement = 12362,
  SVGTextElement = 12384,
  SVGTextPathElement = 12399,
  SVGTextPositioningElement = 12418,
  SVGTitleElement = 12444,
  SVGTransform = 12460,
  SVGTransformList = 12473,
  SVGUnitTypes = 12490,
  SVGUseElement = 12503,
  SVGViewElement = 12517,
  Sanitizer = 12532,
  Scheduler = 12542,
  Screen = 12552,
  ScreenLuminance = 12559,
  ScreenOrientation = 12575,
  ScriptProcessorNode = 12593,
  ScrollAreaEvent = 12613,
  ScrollViewChangeEvent = 12629,
  SecurityPolicyViolationEvent = 12651,
  Selection = 12680,
  ServiceWorker = 12690,
  ServiceWorkerContainer = 12704,
  ServiceWorkerGlobalScope = 12727,
  ServiceWorkerRegistration = 12752,
  SessionStoreFormData = 12778,
  SessionStoreScrollData = 12799,
  SessionStoreUtils = 12822,
  ShadowRoot = 12840,
  SharedWorker = 12851,
  SharedWorkerGlobalScope = 12864,
  SimpleGestureEvent = 12888,
  SourceBuffer = 12907,
  SourceBufferList = 12920,
  SpeechGrammar = 12937,
  SpeechGrammarList = 12951,
  SpeechRecognition = 12969,
  SpeechRecognitionAlternative = 12987,
  SpeechRecognitionError = 13016,
  SpeechRecognitionEvent = 13039,
  SpeechRecognitionResult = 13062,
  SpeechRecognitionResultList = 13086,
  SpeechSynthesis = 13114,
  SpeechSynthesisErrorEvent = 13130,
  SpeechSynthesisEvent = 13156,
  SpeechSynthesisUtterance = 13177,
  SpeechSynthesisVoice = 13202,
  StaticRange = 13223,
  StereoPannerNode = 13235,
  Storage = 13252,
  StorageEvent = 13260,
  StorageManager = 13273,
  StreamFilter = 13288,
  StreamFilterDataEvent = 13301,
  StructuredCloneHolder = 13323,
  StructuredCloneTester = 13345,
  StyleSheet = 13367,
  StyleSheetApplicableStateChangeEvent = 13378,
  StyleSheetList = 13415,
  SubmitEvent = 13430,
  SubtleCrypto = 13442,
  SyncMessageSender = 13455,
  SyncReadFile = 13473,
  TCPServerSocket = 13486,
  TCPServerSocketEvent = 13502,
  TCPSocket = 13523,
  TCPSocketErrorEvent = 13533,
  TCPSocketEvent = 13553,
  TaskController = 13568,
  TaskPriorityChangeEvent = 13583,
  TaskSignal = 13607,
  TelemetryStopwatch = 13618,
  TestUtils = 13637,
  TestingDeprecatedInterface = 13647,
  Text = 13674,
  TextClause = 13679,
  TextDecoder = 13690,
  TextEncoder = 13702,
  TextMetrics = 13714,
  TextTrack = 13726,
  TextTrackCue = 13736,
  TextTrackCueList = 13749,
  TextTrackList = 13766,
  TimeEvent = 13780,
  TimeRanges = 13790,
  Touch = 13801,
  TouchEvent = 13807,
  TouchList = 13818,
  TrackEvent = 13828,
  TransformStream = 13839,
  TransformStreamDefaultController = 13855,
  TransitionEvent = 13888,
  TreeColumn = 13904,
  TreeColumns = 13915,
  TreeContentView = 13927,
  TreeWalker = 13943,
  U2F = 13954,
  UDPMessageEvent = 13958,
  UDPSocket = 13974,
  UIEvent = 13984,
  URL = 13992,
  URLSearchParams = 13996,
  URLSearchParams_Iterator = 14012,
  UserInteraction = 14037,
  UserProximityEvent = 14053,
  VRDisplay = 14072,
  VRDisplayCapabilities = 14082,
  VRDisplayEvent = 14104,
  VREyeParameters = 14119,
  VRFieldOfView = 14135,
  VRFrameData = 14149,
  VRMockController = 14161,
  VRMockDisplay = 14178,
  VRPose = 14192,
  VRServiceTest = 14199,
  VRStageParameters = 14213,
  VTTCue = 14231,
  VTTRegion = 14238,
  ValidityState = 14248,
  VideoPlaybackQuality = 14262,
  VideoTrack = 14283,
  VideoTrackList = 14294,
  VisualViewport = 14309,
  WEBGL_color_buffer_float = 14324,
  WEBGL_compressed_texture_astc = 14349,
  WEBGL_compressed_texture_etc = 14379,
  WEBGL_compressed_texture_etc1 = 14408,
  WEBGL_compressed_texture_pvrtc = 14438,
  WEBGL_compressed_texture_s3tc = 14469,
  WEBGL_compressed_texture_s3tc_srgb = 14499,
  WEBGL_debug_renderer_info = 14534,
  WEBGL_debug_shaders = 14560,
  WEBGL_depth_texture = 14580,
  WEBGL_draw_buffers = 14600,
  WEBGL_explicit_present = 14619,
  WEBGL_lose_context = 14642,
  WaveShaperNode = 14661,
  WebExtensionContentScript = 14676,
  WebExtensionPolicy = 14702,
  WebGL2RenderingContext = 14721,
  WebGLActiveInfo = 14744,
  WebGLBuffer = 14760,
  WebGLContextEvent = 14772,
  WebGLFramebuffer = 14790,
  WebGLProgram = 14807,
  WebGLQuery = 14820,
  WebGLRenderbuffer = 14831,
  WebGLRenderingContext = 14849,
  WebGLSampler = 14871,
  WebGLShader = 14884,
  WebGLShaderPrecisionFormat = 14896,
  WebGLSync = 14923,
  WebGLTexture = 14933,
  WebGLTransformFeedback = 14946,
  WebGLUniformLocation = 14969,
  WebGLVertexArrayObject = 14990,
  WebKitCSSMatrix = 15013,
  WebSocket = 15029,
  WheelEvent = 15039,
  Window = 15050,
  WindowClient = 15057,
  WindowContext = 15070,
  WindowGlobalChild = 15084,
  WindowGlobalParent = 15102,
  WindowRoot = 15121,
  Worker = 15132,
  WorkerDebuggerGlobalScope = 15139,
  WorkerGlobalScope = 15165,
  WorkerLocation = 15183,
  WorkerNavigator = 15198,
  WorkerTestUtils = 15214,
  Worklet = 15230,
  WorkletGlobalScope = 15238,
  WritableStream = 15257,
  WritableStreamDefaultController = 15272,
  WritableStreamDefaultWriter = 15304,
  XMLDocument = 15332,
  XMLHttpRequest = 15344,
  XMLHttpRequestEventTarget = 15359,
  XMLHttpRequestUpload = 15385,
  XMLSerializer = 15406,
  XPathEvaluator = 15420,
  XPathExpression = 15435,
  XPathResult = 15451,
  XRBoundedReferenceSpace = 15463,
  XRFrame = 15487,
  XRInputSource = 15495,
  XRInputSourceArray = 15509,
  XRInputSourceEvent = 15528,
  XRInputSourcesChangeEvent = 15547,
  XRPose = 15573,
  XRReferenceSpace = 15580,
  XRReferenceSpaceEvent = 15597,
  XRRenderState = 15619,
  XRRigidTransform = 15633,
  XRSession = 15650,
  XRSessionEvent = 15660,
  XRSpace = 15675,
  XRSystem = 15683,
  XRView = 15692,
  XRViewerPose = 15699,
  XRViewport = 15712,
  XRWebGLLayer = 15723,
  XSLTProcessor = 15736,
  XULCommandEvent = 15750,
  XULElement = 15766,
  XULFrameElement = 15777,
  XULMenuElement = 15793,
  XULPopupElement = 15808,
  XULTextElement = 15824,
  XULTreeElement = 15839,
  console = 15854,
  webkitSpeechGrammar = 15862,
  webkitSpeechGrammarList = 15882,
  webkitSpeechRecognition = 15906,
  webkitURL = 15930,
};

namespace binding_detail {
extern const char sBindingNames[];
}  // namespace binding_detail

MOZ_ALWAYS_INLINE const char* BindingName(BindingNamesOffset aOffset) {
  return binding_detail::sBindingNames + static_cast<size_t>(aOffset);
}

} // namespace mozilla::dom


#endif // mozilla_dom_BindingNames_h
