/* THIS FILE IS AUTOGENERATED FROM L10nRegistry.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_L10nRegistryBinding_h
#define mozilla_dom_L10nRegistryBinding_h

#include "FluentBinding.h"
#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/FakeString.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"
#include "mozilla/dom/UnionMember.h"
#include "mozilla/intl/FluentBundle.h"

namespace mozilla {

namespace dom {

struct FileSourceOptionsAtoms;
struct FluentBundleAddResourceOptions;
struct FluentBundleIteratorResultAtoms;
struct FluentBundleOptions;
struct L10nFileSourceMockFileAtoms;
struct L10nRegistryOptionsAtoms;
struct NativePropertyHooks;
class ProtoAndIfaceCache;
struct ResourceIdAtoms;

} // namespace dom

namespace intl {

class FluentBundle;
class FluentBundleAsyncIterator;
struct FluentBundleAsyncIteratorAtoms;
class FluentBundleIterator;
struct FluentBundleIteratorAtoms;
class L10nFileSource;
struct L10nFileSourceAtoms;
class L10nRegistry;
struct L10nRegistryAtoms;

} // namespace intl

} // namespace mozilla

namespace mozilla::dom {

enum class L10nFileSourceHasFileStatus : uint8_t {
  Present,
  Missing,
  Unknown,
  EndGuard_
};

namespace L10nFileSourceHasFileStatusValues {
extern const EnumEntry strings[4];

static constexpr size_t Count = 3;

// Our "strings" contains an extra entry with a null string.
static_assert(mozilla::ArrayLength(strings) - 1 == Count,
              "Mismatch between enum strings and enum count");

static_assert(static_cast<size_t>(L10nFileSourceHasFileStatus::EndGuard_) == Count,
              "Mismatch between enum value and enum count");

inline auto GetString(L10nFileSourceHasFileStatus stringId) {
  MOZ_ASSERT(static_cast<uint8_t>(stringId) < Count);
  const EnumEntry& entry = strings[static_cast<uint8_t>(stringId)];
  return Span<const char>{entry.value, entry.length};
}
} // namespace L10nFileSourceHasFileStatusValues

bool
ToJSValue(JSContext* aCx, L10nFileSourceHasFileStatus aArgument, JS::MutableHandle<JS::Value> aValue);


struct FileSourceOptions : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR FluentBundleAddResourceOptions mAddResourceOptions;

  FileSourceOptions();

  explicit inline FileSourceOptions(const FastDictionaryInitializer& )
    : mAddResourceOptions(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline FileSourceOptions(const FileSourceOptions& aOther)
    : mAddResourceOptions(FastDictionaryInitializer())
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  FileSourceOptions&
  operator=(const FileSourceOptions& aOther);

private:
  static bool
  InitIds(JSContext* cx, FileSourceOptionsAtoms* atomsCache);
};

namespace binding_detail {
struct FastFileSourceOptions : public FileSourceOptions
{
  inline FastFileSourceOptions()
    : FileSourceOptions(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct FluentBundleIteratorResult : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR bool mDone;
  MOZ_INIT_OUTSIDE_CTOR RefPtr<mozilla::intl::FluentBundle> mValue;

  FluentBundleIteratorResult();

  explicit inline FluentBundleIteratorResult(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline FluentBundleIteratorResult(const FluentBundleIteratorResult& aOther)
  {
    *this = aOther;
  }

  bool
  Init(const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);

  inline void
  TraverseForCC(nsCycleCollectionTraversalCallback& aCallback, uint32_t aFlags)
  {
    ImplCycleCollectionTraverse(aCallback, mValue, "mValue", aFlags);
  }

  inline void
  UnlinkForCC()
  {
    ImplCycleCollectionUnlink(mValue);
  }

  FluentBundleIteratorResult&
  operator=(const FluentBundleIteratorResult& aOther);

private:
  static bool
  InitIds(JSContext* cx, FluentBundleIteratorResultAtoms* atomsCache);
};

namespace binding_detail {
struct FastFluentBundleIteratorResult : public FluentBundleIteratorResult
{
  inline FastFluentBundleIteratorResult()
    : FluentBundleIteratorResult(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct L10nFileSourceMockFile : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR nsCString mPath;
  MOZ_INIT_OUTSIDE_CTOR nsCString mSource;

  L10nFileSourceMockFile();

  explicit inline L10nFileSourceMockFile(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline L10nFileSourceMockFile(const L10nFileSourceMockFile& aOther)
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  L10nFileSourceMockFile&
  operator=(const L10nFileSourceMockFile& aOther);

  bool
  operator==(const L10nFileSourceMockFile& aOther) const;

private:
  static bool
  InitIds(JSContext* cx, L10nFileSourceMockFileAtoms* atomsCache);
};

namespace binding_detail {
struct FastL10nFileSourceMockFile : public L10nFileSourceMockFile
{
  inline FastL10nFileSourceMockFile()
    : L10nFileSourceMockFile(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct L10nRegistryOptions : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR FluentBundleOptions mBundleOptions;

  L10nRegistryOptions();

  explicit inline L10nRegistryOptions(const FastDictionaryInitializer& )
    : mBundleOptions(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline L10nRegistryOptions(const L10nRegistryOptions& aOther)
    : mBundleOptions(FastDictionaryInitializer())
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  L10nRegistryOptions&
  operator=(const L10nRegistryOptions& aOther);

private:
  static bool
  InitIds(JSContext* cx, L10nRegistryOptionsAtoms* atomsCache);
};

namespace binding_detail {
struct FastL10nRegistryOptions : public L10nRegistryOptions
{
  inline FastL10nRegistryOptions()
    : L10nRegistryOptions(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


struct ResourceId : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR bool mOptional;
  MOZ_INIT_OUTSIDE_CTOR nsCString mPath;

  ResourceId();

  explicit inline ResourceId(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline ResourceId(const ResourceId& aOther)
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  ResourceId&
  operator=(const ResourceId& aOther);

  bool
  operator==(const ResourceId& aOther) const;

private:
  static bool
  InitIds(JSContext* cx, ResourceIdAtoms* atomsCache);
};

namespace binding_detail {
struct FastResourceId : public ResourceId
{
  inline FastResourceId()
    : ResourceId(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


class UTF8StringOrResourceId
{
  friend class UTF8StringOrResourceIdArgument;
  enum Type
  {
    eUninitialized,
    eUTF8String,
    eResourceId
  };

  union Value
  {
    UnionMember<binding_detail::FakeString<char> > mUTF8String;
    UnionMember<binding_detail::FastResourceId > mResourceId;

  };

  Type mType;
  Value mValue;

  UTF8StringOrResourceId(const UTF8StringOrResourceId&) = delete;
  UTF8StringOrResourceId& operator=(const UTF8StringOrResourceId&) = delete;
public:
  explicit inline UTF8StringOrResourceId()
    : mType(eUninitialized)
  {
  }

  inline ~UTF8StringOrResourceId()
  {
    Uninit();
  }

  inline binding_detail::FakeString<char>&
  RawSetAsUTF8String()
  {
    if (mType == eUTF8String) {
      return mValue.mUTF8String.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eUTF8String;
    return mValue.mUTF8String.SetValue();
  }

  inline binding_detail::FakeString<char>&
  SetAsUTF8String()
  {
    if (mType == eUTF8String) {
      return mValue.mUTF8String.Value();
    }
    Uninit();
    mType = eUTF8String;
    return mValue.mUTF8String.SetValue();
  }

  inline bool
  IsUTF8String() const
  {
    return mType == eUTF8String;
  }

  inline binding_detail::FakeString<char>&
  GetAsUTF8String()
  {
    MOZ_RELEASE_ASSERT(IsUTF8String(), "Wrong type!");
    return mValue.mUTF8String.Value();
  }

  inline const nsACString&
  GetAsUTF8String() const
  {
    MOZ_RELEASE_ASSERT(IsUTF8String(), "Wrong type!");
    return mValue.mUTF8String.Value();
  }

  inline binding_detail::FastResourceId&
  RawSetAsResourceId()
  {
    if (mType == eResourceId) {
      return mValue.mResourceId.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eResourceId;
    return mValue.mResourceId.SetValue();
  }

  inline binding_detail::FastResourceId&
  SetAsResourceId()
  {
    if (mType == eResourceId) {
      return mValue.mResourceId.Value();
    }
    Uninit();
    mType = eResourceId;
    return mValue.mResourceId.SetValue();
  }

  inline bool
  IsResourceId() const
  {
    return mType == eResourceId;
  }

  inline binding_detail::FastResourceId&
  GetAsResourceId()
  {
    MOZ_RELEASE_ASSERT(IsResourceId(), "Wrong type!");
    return mValue.mResourceId.Value();
  }

  inline const ResourceId&
  GetAsResourceId() const
  {
    MOZ_RELEASE_ASSERT(IsResourceId(), "Wrong type!");
    return mValue.mResourceId.Value();
  }

  inline void
  Uninit()
  {
    switch (mType) {
      case eUninitialized: {
        break;
      }
      case eUTF8String: {
        DestroyUTF8String();
        break;
      }
      case eResourceId: {
        DestroyResourceId();
        break;
      }
    }
  }

private:
  inline void
  DestroyUTF8String()
  {
    MOZ_RELEASE_ASSERT(IsUTF8String(), "Wrong type!");
    mValue.mUTF8String.Destroy();
    mType = eUninitialized;
  }

  inline void
  DestroyResourceId()
  {
    MOZ_RELEASE_ASSERT(IsResourceId(), "Wrong type!");
    mValue.mResourceId.Destroy();
    mType = eUninitialized;
  }
};


class OwningUTF8StringOrResourceId : public AllOwningUnionBase
{
  enum Type
  {
    eUninitialized,
    eUTF8String,
    eResourceId
  };

  union Value
  {
    UnionMember<nsCString > mUTF8String;
    UnionMember<ResourceId > mResourceId;

  };

  Type mType;
  Value mValue;

public:
  explicit inline OwningUTF8StringOrResourceId()
    : mType(eUninitialized)
  {
  }

  explicit inline OwningUTF8StringOrResourceId(const OwningUTF8StringOrResourceId& aOther)
    : mType(eUninitialized)
  {
    *this = aOther;
  }

  inline ~OwningUTF8StringOrResourceId()
  {
    Uninit();
  }

  nsCString&
  RawSetAsUTF8String();

  nsCString&
  SetAsUTF8String();

  bool
  TrySetToUTF8String(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  template <int N>
  inline void
  SetStringLiteral(const nsCString::char_type (&aData)[N])
  {
    RawSetAsUTF8String().AssignLiteral(aData);
  }

  inline bool
  IsUTF8String() const
  {
    return mType == eUTF8String;
  }

  inline nsCString&
  GetAsUTF8String()
  {
    MOZ_RELEASE_ASSERT(IsUTF8String(), "Wrong type!");
    return mValue.mUTF8String.Value();
  }

  inline nsCString const &
  GetAsUTF8String() const
  {
    MOZ_RELEASE_ASSERT(IsUTF8String(), "Wrong type!");
    return mValue.mUTF8String.Value();
  }

  ResourceId&
  RawSetAsResourceId();

  ResourceId&
  SetAsResourceId();

  bool
  TrySetToResourceId(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  bool
  TrySetToResourceId(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  inline bool
  IsResourceId() const
  {
    return mType == eResourceId;
  }

  inline ResourceId&
  GetAsResourceId()
  {
    MOZ_RELEASE_ASSERT(IsResourceId(), "Wrong type!");
    return mValue.mResourceId.Value();
  }

  inline ResourceId const &
  GetAsResourceId() const
  {
    MOZ_RELEASE_ASSERT(IsResourceId(), "Wrong type!");
    return mValue.mResourceId.Value();
  }

  void
  Uninit();

  OwningUTF8StringOrResourceId&
  operator=(const OwningUTF8StringOrResourceId& aOther);

private:
  void
  DestroyUTF8String();

  void
  DestroyResourceId();
};


namespace FluentBundleAsyncIterator_Binding {

  typedef mozilla::intl::FluentBundleAsyncIterator NativeType;

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::intl::FluentBundleAsyncIterator* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::FluentBundleAsyncIterator,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

} // namespace FluentBundleAsyncIterator_Binding



namespace FluentBundleIterator_Binding {

  typedef mozilla::intl::FluentBundleIterator NativeType;

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::intl::FluentBundleIterator* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::FluentBundleIterator,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

} // namespace FluentBundleIterator_Binding



namespace L10nFileSource_Binding {

  typedef mozilla::intl::L10nFileSource NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::intl::L10nFileSource* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  ClearCachedLocalesValue(mozilla::intl::L10nFileSource* aObject);

  void
  ClearCachedIndexValue(mozilla::intl::L10nFileSource* aObject);

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::L10nFileSource,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::L10nFileSource,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace L10nFileSource_Binding



namespace L10nRegistry_Binding {

  typedef mozilla::intl::L10nRegistry NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::intl::L10nRegistry* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::L10nRegistry,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::L10nRegistry,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace L10nRegistry_Binding



} // namespace mozilla::dom

#endif // mozilla_dom_L10nRegistryBinding_h
