/* THIS FILE IS AUTOGENERATED FROM Performance.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_PerformanceBinding_h
#define mozilla_dom_PerformanceBinding_h

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/FakeString.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"
#include "mozilla/dom/RootedDictionary.h"
#include "mozilla/dom/UnionMember.h"

namespace mozilla {
namespace dom {

struct NativePropertyHooks;
class OwningStringOrDouble;
class Performance;
struct PerformanceAtoms;
struct PerformanceMarkOptionsAtoms;
struct PerformanceMeasureOptionsAtoms;
class ProtoAndIfaceCache;
class StringOrDouble;

} // namespace dom
} // namespace mozilla

namespace mozilla::dom {

struct PerformanceMarkOptions : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR JS::Value mDetail;
  MOZ_INIT_OUTSIDE_CTOR Optional<double> mStartTime;

  PerformanceMarkOptions();

  explicit inline PerformanceMarkOptions(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

private:
  PerformanceMarkOptions(const PerformanceMarkOptions&) = delete;
  PerformanceMarkOptions& operator=(const PerformanceMarkOptions&) = delete;

  static bool
  InitIds(JSContext* cx, PerformanceMarkOptionsAtoms* atomsCache);

public:
  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);
};

namespace binding_detail {
struct FastPerformanceMarkOptions : public PerformanceMarkOptions
{
  inline FastPerformanceMarkOptions()
    : PerformanceMarkOptions(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


class StringOrDouble
{
  friend class StringOrDoubleArgument;
  enum Type
  {
    eUninitialized,
    eString,
    eDouble
  };

  union Value
  {
    UnionMember<binding_detail::FakeString<char16_t> > mString;
    UnionMember<double > mDouble;

  };

  Type mType;
  Value mValue;

  StringOrDouble(const StringOrDouble&) = delete;
  StringOrDouble& operator=(const StringOrDouble&) = delete;
public:
  explicit inline StringOrDouble()
    : mType(eUninitialized)
  {
  }

  inline ~StringOrDouble()
  {
    Uninit();
  }

  inline binding_detail::FakeString<char16_t>&
  RawSetAsString()
  {
    if (mType == eString) {
      return mValue.mString.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eString;
    return mValue.mString.SetValue();
  }

  inline binding_detail::FakeString<char16_t>&
  SetAsString()
  {
    if (mType == eString) {
      return mValue.mString.Value();
    }
    Uninit();
    mType = eString;
    return mValue.mString.SetValue();
  }

  inline bool
  IsString() const
  {
    return mType == eString;
  }

  inline binding_detail::FakeString<char16_t>&
  GetAsString()
  {
    MOZ_RELEASE_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  inline const nsAString&
  GetAsString() const
  {
    MOZ_RELEASE_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  inline double&
  RawSetAsDouble()
  {
    if (mType == eDouble) {
      return mValue.mDouble.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eDouble;
    return mValue.mDouble.SetValue();
  }

  inline double&
  SetAsDouble()
  {
    if (mType == eDouble) {
      return mValue.mDouble.Value();
    }
    Uninit();
    mType = eDouble;
    return mValue.mDouble.SetValue();
  }

  inline bool
  IsDouble() const
  {
    return mType == eDouble;
  }

  inline double&
  GetAsDouble()
  {
    MOZ_RELEASE_ASSERT(IsDouble(), "Wrong type!");
    return mValue.mDouble.Value();
  }

  inline double
  GetAsDouble() const
  {
    MOZ_RELEASE_ASSERT(IsDouble(), "Wrong type!");
    return mValue.mDouble.Value();
  }

  inline void
  Uninit()
  {
    switch (mType) {
      case eUninitialized: {
        break;
      }
      case eString: {
        DestroyString();
        break;
      }
      case eDouble: {
        DestroyDouble();
        break;
      }
    }
  }

  bool
  ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const;

private:
  inline void
  DestroyString()
  {
    MOZ_RELEASE_ASSERT(IsString(), "Wrong type!");
    mValue.mString.Destroy();
    mType = eUninitialized;
  }

  inline void
  DestroyDouble()
  {
    MOZ_RELEASE_ASSERT(IsDouble(), "Wrong type!");
    mValue.mDouble.Destroy();
    mType = eUninitialized;
  }
};


class OwningStringOrDouble : public AllOwningUnionBase
{
  enum Type
  {
    eUninitialized,
    eString,
    eDouble
  };

  union Value
  {
    UnionMember<nsString > mString;
    UnionMember<double > mDouble;

  };

  Type mType;
  Value mValue;

public:
  explicit inline OwningStringOrDouble()
    : mType(eUninitialized)
  {
  }

  explicit inline OwningStringOrDouble(const OwningStringOrDouble& aOther)
    : mType(eUninitialized)
  {
    *this = aOther;
  }

  inline ~OwningStringOrDouble()
  {
    Uninit();
  }

  nsString&
  RawSetAsString();

  nsString&
  SetAsString();

  bool
  TrySetToString(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  template <int N>
  inline void
  SetStringLiteral(const nsString::char_type (&aData)[N])
  {
    RawSetAsString().AssignLiteral(aData);
  }

  inline bool
  IsString() const
  {
    return mType == eString;
  }

  inline nsString&
  GetAsString()
  {
    MOZ_RELEASE_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  inline nsString const &
  GetAsString() const
  {
    MOZ_RELEASE_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  double&
  RawSetAsDouble();

  double&
  SetAsDouble();

  bool
  TrySetToDouble(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  bool
  TrySetToDouble(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  inline bool
  IsDouble() const
  {
    return mType == eDouble;
  }

  inline double&
  GetAsDouble()
  {
    MOZ_RELEASE_ASSERT(IsDouble(), "Wrong type!");
    return mValue.mDouble.Value();
  }

  inline double const &
  GetAsDouble() const
  {
    MOZ_RELEASE_ASSERT(IsDouble(), "Wrong type!");
    return mValue.mDouble.Value();
  }

  void
  Uninit();

  bool
  ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const;

  OwningStringOrDouble&
  operator=(const OwningStringOrDouble& aOther);

private:
  void
  DestroyString();

  void
  DestroyDouble();
};


struct PerformanceMeasureOptions : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR JS::Value mDetail;
  MOZ_INIT_OUTSIDE_CTOR Optional<double> mDuration;
  MOZ_INIT_OUTSIDE_CTOR Optional<OwningStringOrDouble> mEnd;
  MOZ_INIT_OUTSIDE_CTOR Optional<OwningStringOrDouble> mStart;

  PerformanceMeasureOptions();

  explicit inline PerformanceMeasureOptions(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

private:
  PerformanceMeasureOptions(const PerformanceMeasureOptions&) = delete;
  PerformanceMeasureOptions& operator=(const PerformanceMeasureOptions&) = delete;

  static bool
  InitIds(JSContext* cx, PerformanceMeasureOptionsAtoms* atomsCache);

public:
  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);
};

namespace binding_detail {
struct FastPerformanceMeasureOptions : public PerformanceMeasureOptions
{
  inline FastPerformanceMeasureOptions()
    : PerformanceMeasureOptions(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


class StringOrPerformanceMeasureOptions
{
  friend class StringOrPerformanceMeasureOptionsArgument;
  enum Type
  {
    eUninitialized,
    eString,
    ePerformanceMeasureOptions
  };

  union Value
  {
    UnionMember<binding_detail::FakeString<char16_t> > mString;
    UnionMember<RootedDictionary<binding_detail::FastPerformanceMeasureOptions> > mPerformanceMeasureOptions;

  };

  Type mType;
  Value mValue;

  StringOrPerformanceMeasureOptions(const StringOrPerformanceMeasureOptions&) = delete;
  StringOrPerformanceMeasureOptions& operator=(const StringOrPerformanceMeasureOptions&) = delete;
public:
  explicit inline StringOrPerformanceMeasureOptions()
    : mType(eUninitialized)
  {
  }

  inline ~StringOrPerformanceMeasureOptions()
  {
    Uninit();
  }

  inline binding_detail::FakeString<char16_t>&
  RawSetAsString()
  {
    if (mType == eString) {
      return mValue.mString.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eString;
    return mValue.mString.SetValue();
  }

  inline binding_detail::FakeString<char16_t>&
  SetAsString()
  {
    if (mType == eString) {
      return mValue.mString.Value();
    }
    Uninit();
    mType = eString;
    return mValue.mString.SetValue();
  }

  inline bool
  IsString() const
  {
    return mType == eString;
  }

  inline binding_detail::FakeString<char16_t>&
  GetAsString()
  {
    MOZ_RELEASE_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  inline const nsAString&
  GetAsString() const
  {
    MOZ_RELEASE_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  inline RootedDictionary<binding_detail::FastPerformanceMeasureOptions>&
  RawSetAsPerformanceMeasureOptions(JSContext* cx)
  {
    if (mType == ePerformanceMeasureOptions) {
      return mValue.mPerformanceMeasureOptions.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = ePerformanceMeasureOptions;
    return mValue.mPerformanceMeasureOptions.SetValue(cx);
  }

  inline RootedDictionary<binding_detail::FastPerformanceMeasureOptions>&
  SetAsPerformanceMeasureOptions(JSContext* cx)
  {
    if (mType == ePerformanceMeasureOptions) {
      return mValue.mPerformanceMeasureOptions.Value();
    }
    Uninit();
    mType = ePerformanceMeasureOptions;
    return mValue.mPerformanceMeasureOptions.SetValue(cx);
  }

  inline bool
  IsPerformanceMeasureOptions() const
  {
    return mType == ePerformanceMeasureOptions;
  }

  inline RootedDictionary<binding_detail::FastPerformanceMeasureOptions>&
  GetAsPerformanceMeasureOptions()
  {
    MOZ_RELEASE_ASSERT(IsPerformanceMeasureOptions(), "Wrong type!");
    return mValue.mPerformanceMeasureOptions.Value();
  }

  inline const PerformanceMeasureOptions&
  GetAsPerformanceMeasureOptions() const
  {
    MOZ_RELEASE_ASSERT(IsPerformanceMeasureOptions(), "Wrong type!");
    return mValue.mPerformanceMeasureOptions.Value();
  }

  inline void
  Uninit()
  {
    switch (mType) {
      case eUninitialized: {
        break;
      }
      case eString: {
        DestroyString();
        break;
      }
      case ePerformanceMeasureOptions: {
        DestroyPerformanceMeasureOptions();
        break;
      }
    }
  }

private:
  inline void
  DestroyString()
  {
    MOZ_RELEASE_ASSERT(IsString(), "Wrong type!");
    mValue.mString.Destroy();
    mType = eUninitialized;
  }

  inline void
  DestroyPerformanceMeasureOptions()
  {
    MOZ_RELEASE_ASSERT(IsPerformanceMeasureOptions(), "Wrong type!");
    mValue.mPerformanceMeasureOptions.Destroy();
    mType = eUninitialized;
  }
};


class OwningStringOrPerformanceMeasureOptions : public AllOwningUnionBase
{
  enum Type
  {
    eUninitialized,
    eString,
    ePerformanceMeasureOptions
  };

  union Value
  {
    UnionMember<nsString > mString;
    UnionMember<PerformanceMeasureOptions > mPerformanceMeasureOptions;

  };

  Type mType;
  Value mValue;

  OwningStringOrPerformanceMeasureOptions(const OwningStringOrPerformanceMeasureOptions&) = delete;
  OwningStringOrPerformanceMeasureOptions& operator=(const OwningStringOrPerformanceMeasureOptions&) = delete;
public:
  explicit inline OwningStringOrPerformanceMeasureOptions()
    : mType(eUninitialized)
  {
  }

  inline ~OwningStringOrPerformanceMeasureOptions()
  {
    Uninit();
  }

  nsString&
  RawSetAsString();

  nsString&
  SetAsString();

  bool
  TrySetToString(JSContext* cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  template <int N>
  inline void
  SetStringLiteral(const nsString::char_type (&aData)[N])
  {
    RawSetAsString().AssignLiteral(aData);
  }

  inline bool
  IsString() const
  {
    return mType == eString;
  }

  inline nsString&
  GetAsString()
  {
    MOZ_RELEASE_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  inline nsString const &
  GetAsString() const
  {
    MOZ_RELEASE_ASSERT(IsString(), "Wrong type!");
    return mValue.mString.Value();
  }

  PerformanceMeasureOptions&
  RawSetAsPerformanceMeasureOptions();

  PerformanceMeasureOptions&
  SetAsPerformanceMeasureOptions();

  bool
  TrySetToPerformanceMeasureOptions(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  bool
  TrySetToPerformanceMeasureOptions(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  inline bool
  IsPerformanceMeasureOptions() const
  {
    return mType == ePerformanceMeasureOptions;
  }

  inline PerformanceMeasureOptions&
  GetAsPerformanceMeasureOptions()
  {
    MOZ_RELEASE_ASSERT(IsPerformanceMeasureOptions(), "Wrong type!");
    return mValue.mPerformanceMeasureOptions.Value();
  }

  inline PerformanceMeasureOptions const &
  GetAsPerformanceMeasureOptions() const
  {
    MOZ_RELEASE_ASSERT(IsPerformanceMeasureOptions(), "Wrong type!");
    return mValue.mPerformanceMeasureOptions.Value();
  }

  void
  Uninit();

  void
  TraceUnion(JSTracer* trc);

private:
  void
  DestroyString();

  void
  DestroyPerformanceMeasureOptions();
};


namespace Performance_Binding {

  typedef mozilla::dom::Performance NativeType;

  MOZ_CAN_RUN_SCRIPT bool
  CollectJSONAttributes(JSContext* cx, JS::Handle<JSObject*> obj, mozilla::dom::Performance* self, JS::Rooted<JSObject*>& result);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::dom::Performance* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::Performance,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::Performance,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace Performance_Binding



} // namespace mozilla::dom

#endif // mozilla_dom_PerformanceBinding_h
