/* THIS FILE IS AUTOGENERATED FROM ReadableStreamDefaultReader.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_ReadableStreamDefaultReaderBinding_h
#define mozilla_dom_ReadableStreamDefaultReaderBinding_h

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/FakeString.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"
#include "mozilla/dom/UnionMember.h"

namespace mozilla {
namespace dom {

struct NativePropertyHooks;
class OwningReadableStreamDefaultReaderOrReadableStreamBYOBReader;
class ProtoAndIfaceCache;
class ReadableStreamBYOBReader;
class ReadableStreamDefaultReader;
struct ReadableStreamDefaultReaderAtoms;
struct ReadableStreamReadResultAtoms;

} // namespace dom
} // namespace mozilla

namespace mozilla::dom {

enum class ReadableStreamType : uint8_t {
  Bytes,
  EndGuard_
};

namespace ReadableStreamTypeValues {
extern const EnumEntry strings[2];

static constexpr size_t Count = 1;

// Our "strings" contains an extra entry with a null string.
static_assert(mozilla::ArrayLength(strings) - 1 == Count,
              "Mismatch between enum strings and enum count");

static_assert(static_cast<size_t>(ReadableStreamType::EndGuard_) == Count,
              "Mismatch between enum value and enum count");

inline auto GetString(ReadableStreamType stringId) {
  MOZ_ASSERT(static_cast<uint8_t>(stringId) < Count);
  const EnumEntry& entry = strings[static_cast<uint8_t>(stringId)];
  return Span<const char>{entry.value, entry.length};
}
} // namespace ReadableStreamTypeValues

bool
ToJSValue(JSContext* aCx, ReadableStreamType aArgument, JS::MutableHandle<JS::Value> aValue);


void
ImplCycleCollectionTraverse(nsCycleCollectionTraversalCallback& aCallback, OwningReadableStreamDefaultReaderOrReadableStreamBYOBReader& aUnion, const char* aName, uint32_t aFlags = 0);


void
ImplCycleCollectionUnlink(OwningReadableStreamDefaultReaderOrReadableStreamBYOBReader& aUnion);


class ReadableStreamDefaultReaderOrReadableStreamBYOBReader
{
  friend class ReadableStreamDefaultReaderOrReadableStreamBYOBReaderArgument;
  enum Type
  {
    eUninitialized,
    eReadableStreamDefaultReader,
    eReadableStreamBYOBReader
  };

  union Value
  {
    UnionMember<NonNull<mozilla::dom::ReadableStreamDefaultReader> > mReadableStreamDefaultReader;
    UnionMember<NonNull<mozilla::dom::ReadableStreamBYOBReader> > mReadableStreamBYOBReader;

  };

  Type mType;
  Value mValue;

  ReadableStreamDefaultReaderOrReadableStreamBYOBReader(const ReadableStreamDefaultReaderOrReadableStreamBYOBReader&) = delete;
  ReadableStreamDefaultReaderOrReadableStreamBYOBReader& operator=(const ReadableStreamDefaultReaderOrReadableStreamBYOBReader&) = delete;
public:
  explicit inline ReadableStreamDefaultReaderOrReadableStreamBYOBReader()
    : mType(eUninitialized)
  {
  }

  inline ~ReadableStreamDefaultReaderOrReadableStreamBYOBReader()
  {
    Uninit();
  }

  inline NonNull<mozilla::dom::ReadableStreamDefaultReader>&
  RawSetAsReadableStreamDefaultReader()
  {
    if (mType == eReadableStreamDefaultReader) {
      return mValue.mReadableStreamDefaultReader.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eReadableStreamDefaultReader;
    return mValue.mReadableStreamDefaultReader.SetValue();
  }

  inline NonNull<mozilla::dom::ReadableStreamDefaultReader>&
  SetAsReadableStreamDefaultReader()
  {
    if (mType == eReadableStreamDefaultReader) {
      return mValue.mReadableStreamDefaultReader.Value();
    }
    Uninit();
    mType = eReadableStreamDefaultReader;
    return mValue.mReadableStreamDefaultReader.SetValue();
  }

  inline bool
  IsReadableStreamDefaultReader() const
  {
    return mType == eReadableStreamDefaultReader;
  }

  inline NonNull<mozilla::dom::ReadableStreamDefaultReader>&
  GetAsReadableStreamDefaultReader()
  {
    MOZ_RELEASE_ASSERT(IsReadableStreamDefaultReader(), "Wrong type!");
    return mValue.mReadableStreamDefaultReader.Value();
  }

  inline mozilla::dom::ReadableStreamDefaultReader&
  GetAsReadableStreamDefaultReader() const
  {
    MOZ_RELEASE_ASSERT(IsReadableStreamDefaultReader(), "Wrong type!");
    return mValue.mReadableStreamDefaultReader.Value();
  }

  inline NonNull<mozilla::dom::ReadableStreamBYOBReader>&
  RawSetAsReadableStreamBYOBReader()
  {
    if (mType == eReadableStreamBYOBReader) {
      return mValue.mReadableStreamBYOBReader.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eReadableStreamBYOBReader;
    return mValue.mReadableStreamBYOBReader.SetValue();
  }

  inline NonNull<mozilla::dom::ReadableStreamBYOBReader>&
  SetAsReadableStreamBYOBReader()
  {
    if (mType == eReadableStreamBYOBReader) {
      return mValue.mReadableStreamBYOBReader.Value();
    }
    Uninit();
    mType = eReadableStreamBYOBReader;
    return mValue.mReadableStreamBYOBReader.SetValue();
  }

  inline bool
  IsReadableStreamBYOBReader() const
  {
    return mType == eReadableStreamBYOBReader;
  }

  inline NonNull<mozilla::dom::ReadableStreamBYOBReader>&
  GetAsReadableStreamBYOBReader()
  {
    MOZ_RELEASE_ASSERT(IsReadableStreamBYOBReader(), "Wrong type!");
    return mValue.mReadableStreamBYOBReader.Value();
  }

  inline mozilla::dom::ReadableStreamBYOBReader&
  GetAsReadableStreamBYOBReader() const
  {
    MOZ_RELEASE_ASSERT(IsReadableStreamBYOBReader(), "Wrong type!");
    return mValue.mReadableStreamBYOBReader.Value();
  }

  inline void
  Uninit()
  {
    switch (mType) {
      case eUninitialized: {
        break;
      }
      case eReadableStreamDefaultReader: {
        DestroyReadableStreamDefaultReader();
        break;
      }
      case eReadableStreamBYOBReader: {
        DestroyReadableStreamBYOBReader();
        break;
      }
    }
  }

  bool
  ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const;

private:
  inline void
  DestroyReadableStreamDefaultReader()
  {
    MOZ_RELEASE_ASSERT(IsReadableStreamDefaultReader(), "Wrong type!");
    mValue.mReadableStreamDefaultReader.Destroy();
    mType = eUninitialized;
  }

  inline void
  DestroyReadableStreamBYOBReader()
  {
    MOZ_RELEASE_ASSERT(IsReadableStreamBYOBReader(), "Wrong type!");
    mValue.mReadableStreamBYOBReader.Destroy();
    mType = eUninitialized;
  }
};


class OwningReadableStreamDefaultReaderOrReadableStreamBYOBReader : public AllOwningUnionBase
{
  friend void ImplCycleCollectionUnlink(OwningReadableStreamDefaultReaderOrReadableStreamBYOBReader& aUnion);
  enum Type
  {
    eUninitialized,
    eReadableStreamDefaultReader,
    eReadableStreamBYOBReader
  };

  union Value
  {
    UnionMember<OwningNonNull<mozilla::dom::ReadableStreamDefaultReader> > mReadableStreamDefaultReader;
    UnionMember<OwningNonNull<mozilla::dom::ReadableStreamBYOBReader> > mReadableStreamBYOBReader;

  };

  Type mType;
  Value mValue;

public:
  explicit inline OwningReadableStreamDefaultReaderOrReadableStreamBYOBReader()
    : mType(eUninitialized)
  {
  }

  explicit inline OwningReadableStreamDefaultReaderOrReadableStreamBYOBReader(const OwningReadableStreamDefaultReaderOrReadableStreamBYOBReader& aOther)
    : mType(eUninitialized)
  {
    *this = aOther;
  }

  inline ~OwningReadableStreamDefaultReaderOrReadableStreamBYOBReader()
  {
    Uninit();
  }

  OwningNonNull<mozilla::dom::ReadableStreamDefaultReader>&
  RawSetAsReadableStreamDefaultReader();

  OwningNonNull<mozilla::dom::ReadableStreamDefaultReader>&
  SetAsReadableStreamDefaultReader();

  bool
  TrySetToReadableStreamDefaultReader(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  bool
  TrySetToReadableStreamDefaultReader(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  inline bool
  IsReadableStreamDefaultReader() const
  {
    return mType == eReadableStreamDefaultReader;
  }

  inline OwningNonNull<mozilla::dom::ReadableStreamDefaultReader>&
  GetAsReadableStreamDefaultReader()
  {
    MOZ_RELEASE_ASSERT(IsReadableStreamDefaultReader(), "Wrong type!");
    return mValue.mReadableStreamDefaultReader.Value();
  }

  inline OwningNonNull<mozilla::dom::ReadableStreamDefaultReader> const &
  GetAsReadableStreamDefaultReader() const
  {
    MOZ_RELEASE_ASSERT(IsReadableStreamDefaultReader(), "Wrong type!");
    return mValue.mReadableStreamDefaultReader.Value();
  }

  OwningNonNull<mozilla::dom::ReadableStreamBYOBReader>&
  RawSetAsReadableStreamBYOBReader();

  OwningNonNull<mozilla::dom::ReadableStreamBYOBReader>&
  SetAsReadableStreamBYOBReader();

  bool
  TrySetToReadableStreamBYOBReader(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  bool
  TrySetToReadableStreamBYOBReader(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  inline bool
  IsReadableStreamBYOBReader() const
  {
    return mType == eReadableStreamBYOBReader;
  }

  inline OwningNonNull<mozilla::dom::ReadableStreamBYOBReader>&
  GetAsReadableStreamBYOBReader()
  {
    MOZ_RELEASE_ASSERT(IsReadableStreamBYOBReader(), "Wrong type!");
    return mValue.mReadableStreamBYOBReader.Value();
  }

  inline OwningNonNull<mozilla::dom::ReadableStreamBYOBReader> const &
  GetAsReadableStreamBYOBReader() const
  {
    MOZ_RELEASE_ASSERT(IsReadableStreamBYOBReader(), "Wrong type!");
    return mValue.mReadableStreamBYOBReader.Value();
  }

  void
  Uninit();

  bool
  ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const;

  OwningReadableStreamDefaultReaderOrReadableStreamBYOBReader&
  operator=(const OwningReadableStreamDefaultReaderOrReadableStreamBYOBReader& aOther);

private:
  void
  DestroyReadableStreamDefaultReader();

  void
  DestroyReadableStreamBYOBReader();
};


struct ReadableStreamReadResult : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Optional<bool> mDone;
  MOZ_INIT_OUTSIDE_CTOR JS::Value mValue;

  ReadableStreamReadResult();

  explicit inline ReadableStreamReadResult(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

private:
  ReadableStreamReadResult(const ReadableStreamReadResult&) = delete;
  ReadableStreamReadResult& operator=(const ReadableStreamReadResult&) = delete;

  static bool
  InitIds(JSContext* cx, ReadableStreamReadResultAtoms* atomsCache);

public:
  bool
  Init(const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  ToObjectInternal(JSContext* cx, JS::MutableHandle<JS::Value> rval) const;

  void
  TraceDictionary(JSTracer* trc);
};

namespace binding_detail {
struct FastReadableStreamReadResult : public ReadableStreamReadResult
{
  inline FastReadableStreamReadResult()
    : ReadableStreamReadResult(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace ReadableStreamDefaultReader_Binding {

  typedef mozilla::dom::ReadableStreamDefaultReader NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::dom::ReadableStreamDefaultReader* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::ReadableStreamDefaultReader,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::ReadableStreamDefaultReader,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace ReadableStreamDefaultReader_Binding



} // namespace mozilla::dom

#endif // mozilla_dom_ReadableStreamDefaultReaderBinding_h
