/* THIS FILE IS AUTOGENERATED FROM Sanitizer.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_SanitizerBinding_h
#define mozilla_dom_SanitizerBinding_h

#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/FakeString.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"
#include "mozilla/dom/Record.h"
#include "mozilla/dom/UnionMember.h"

namespace mozilla {
namespace dom {

class Document;
class DocumentFragment;
struct NativePropertyHooks;
class OwningDocumentFragmentOrDocument;
class ProtoAndIfaceCache;
class Sanitizer;
struct SanitizerAtoms;
struct SanitizerConfigAtoms;

} // namespace dom
} // namespace mozilla

namespace mozilla::dom {

void
ImplCycleCollectionTraverse(nsCycleCollectionTraversalCallback& aCallback, OwningDocumentFragmentOrDocument& aUnion, const char* aName, uint32_t aFlags = 0);


void
ImplCycleCollectionUnlink(OwningDocumentFragmentOrDocument& aUnion);


class DocumentFragmentOrDocument
{
  friend class DocumentFragmentOrDocumentArgument;
  enum Type
  {
    eUninitialized,
    eDocumentFragment,
    eDocument
  };

  union Value
  {
    UnionMember<NonNull<mozilla::dom::DocumentFragment> > mDocumentFragment;
    UnionMember<NonNull<mozilla::dom::Document> > mDocument;

  };

  Type mType;
  Value mValue;

  DocumentFragmentOrDocument(const DocumentFragmentOrDocument&) = delete;
  DocumentFragmentOrDocument& operator=(const DocumentFragmentOrDocument&) = delete;
public:
  explicit inline DocumentFragmentOrDocument()
    : mType(eUninitialized)
  {
  }

  inline ~DocumentFragmentOrDocument()
  {
    Uninit();
  }

  inline NonNull<mozilla::dom::DocumentFragment>&
  RawSetAsDocumentFragment()
  {
    if (mType == eDocumentFragment) {
      return mValue.mDocumentFragment.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eDocumentFragment;
    return mValue.mDocumentFragment.SetValue();
  }

  inline NonNull<mozilla::dom::DocumentFragment>&
  SetAsDocumentFragment()
  {
    if (mType == eDocumentFragment) {
      return mValue.mDocumentFragment.Value();
    }
    Uninit();
    mType = eDocumentFragment;
    return mValue.mDocumentFragment.SetValue();
  }

  inline bool
  IsDocumentFragment() const
  {
    return mType == eDocumentFragment;
  }

  inline NonNull<mozilla::dom::DocumentFragment>&
  GetAsDocumentFragment()
  {
    MOZ_RELEASE_ASSERT(IsDocumentFragment(), "Wrong type!");
    return mValue.mDocumentFragment.Value();
  }

  inline mozilla::dom::DocumentFragment&
  GetAsDocumentFragment() const
  {
    MOZ_RELEASE_ASSERT(IsDocumentFragment(), "Wrong type!");
    return mValue.mDocumentFragment.Value();
  }

  inline NonNull<mozilla::dom::Document>&
  RawSetAsDocument()
  {
    if (mType == eDocument) {
      return mValue.mDocument.Value();
    }
    MOZ_ASSERT(mType == eUninitialized);
    mType = eDocument;
    return mValue.mDocument.SetValue();
  }

  inline NonNull<mozilla::dom::Document>&
  SetAsDocument()
  {
    if (mType == eDocument) {
      return mValue.mDocument.Value();
    }
    Uninit();
    mType = eDocument;
    return mValue.mDocument.SetValue();
  }

  inline bool
  IsDocument() const
  {
    return mType == eDocument;
  }

  inline NonNull<mozilla::dom::Document>&
  GetAsDocument()
  {
    MOZ_RELEASE_ASSERT(IsDocument(), "Wrong type!");
    return mValue.mDocument.Value();
  }

  inline mozilla::dom::Document&
  GetAsDocument() const
  {
    MOZ_RELEASE_ASSERT(IsDocument(), "Wrong type!");
    return mValue.mDocument.Value();
  }

  inline void
  Uninit()
  {
    switch (mType) {
      case eUninitialized: {
        break;
      }
      case eDocumentFragment: {
        DestroyDocumentFragment();
        break;
      }
      case eDocument: {
        DestroyDocument();
        break;
      }
    }
  }

  bool
  ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const;

private:
  inline void
  DestroyDocumentFragment()
  {
    MOZ_RELEASE_ASSERT(IsDocumentFragment(), "Wrong type!");
    mValue.mDocumentFragment.Destroy();
    mType = eUninitialized;
  }

  inline void
  DestroyDocument()
  {
    MOZ_RELEASE_ASSERT(IsDocument(), "Wrong type!");
    mValue.mDocument.Destroy();
    mType = eUninitialized;
  }
};


class OwningDocumentFragmentOrDocument : public AllOwningUnionBase
{
  friend void ImplCycleCollectionUnlink(OwningDocumentFragmentOrDocument& aUnion);
  enum Type
  {
    eUninitialized,
    eDocumentFragment,
    eDocument
  };

  union Value
  {
    UnionMember<OwningNonNull<mozilla::dom::DocumentFragment> > mDocumentFragment;
    UnionMember<OwningNonNull<mozilla::dom::Document> > mDocument;

  };

  Type mType;
  Value mValue;

public:
  explicit inline OwningDocumentFragmentOrDocument()
    : mType(eUninitialized)
  {
  }

  explicit inline OwningDocumentFragmentOrDocument(const OwningDocumentFragmentOrDocument& aOther)
    : mType(eUninitialized)
  {
    *this = aOther;
  }

  inline ~OwningDocumentFragmentOrDocument()
  {
    Uninit();
  }

  OwningNonNull<mozilla::dom::DocumentFragment>&
  RawSetAsDocumentFragment();

  OwningNonNull<mozilla::dom::DocumentFragment>&
  SetAsDocumentFragment();

  bool
  TrySetToDocumentFragment(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  bool
  TrySetToDocumentFragment(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  inline bool
  IsDocumentFragment() const
  {
    return mType == eDocumentFragment;
  }

  inline OwningNonNull<mozilla::dom::DocumentFragment>&
  GetAsDocumentFragment()
  {
    MOZ_RELEASE_ASSERT(IsDocumentFragment(), "Wrong type!");
    return mValue.mDocumentFragment.Value();
  }

  inline OwningNonNull<mozilla::dom::DocumentFragment> const &
  GetAsDocumentFragment() const
  {
    MOZ_RELEASE_ASSERT(IsDocumentFragment(), "Wrong type!");
    return mValue.mDocumentFragment.Value();
  }

  OwningNonNull<mozilla::dom::Document>&
  RawSetAsDocument();

  OwningNonNull<mozilla::dom::Document>&
  SetAsDocument();

  bool
  TrySetToDocument(BindingCallContext& cx, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  bool
  TrySetToDocument(JSContext* cx_, JS::Handle<JS::Value> value, bool& tryNext, bool passedToJSImpl = false);

  inline bool
  IsDocument() const
  {
    return mType == eDocument;
  }

  inline OwningNonNull<mozilla::dom::Document>&
  GetAsDocument()
  {
    MOZ_RELEASE_ASSERT(IsDocument(), "Wrong type!");
    return mValue.mDocument.Value();
  }

  inline OwningNonNull<mozilla::dom::Document> const &
  GetAsDocument() const
  {
    MOZ_RELEASE_ASSERT(IsDocument(), "Wrong type!");
    return mValue.mDocument.Value();
  }

  void
  Uninit();

  bool
  ToJSVal(JSContext* cx, JS::Handle<JSObject*> scopeObj, JS::MutableHandle<JS::Value> rval) const;

  OwningDocumentFragmentOrDocument&
  operator=(const OwningDocumentFragmentOrDocument& aOther);

private:
  void
  DestroyDocumentFragment();

  void
  DestroyDocument();
};


struct SanitizerConfig : public DictionaryBase
{
  MOZ_INIT_OUTSIDE_CTOR Optional<Record<nsString, Sequence<nsString>>> mAllowAttributes;
  MOZ_INIT_OUTSIDE_CTOR Optional<bool> mAllowComments;
  MOZ_INIT_OUTSIDE_CTOR Optional<bool> mAllowCustomElements;
  MOZ_INIT_OUTSIDE_CTOR Optional<Sequence<nsString>> mAllowElements;
  MOZ_INIT_OUTSIDE_CTOR Optional<Sequence<nsString>> mBlockElements;
  MOZ_INIT_OUTSIDE_CTOR Optional<Record<nsString, Sequence<nsString>>> mDropAttributes;
  MOZ_INIT_OUTSIDE_CTOR Optional<Sequence<nsString>> mDropElements;

  SanitizerConfig();

  explicit inline SanitizerConfig(const FastDictionaryInitializer& )
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

private:
  SanitizerConfig(const SanitizerConfig&) = delete;
  SanitizerConfig& operator=(const SanitizerConfig&) = delete;

  static bool
  InitIds(JSContext* cx, SanitizerConfigAtoms* atomsCache);

public:
  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);
};

namespace binding_detail {
struct FastSanitizerConfig : public SanitizerConfig
{
  inline FastSanitizerConfig()
    : SanitizerConfig(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace Sanitizer_Binding {

  typedef mozilla::dom::Sanitizer NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::dom::Sanitizer* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::Sanitizer,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::Sanitizer,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace Sanitizer_Binding



} // namespace mozilla::dom

#endif // mozilla_dom_SanitizerBinding_h
