/* THIS FILE IS AUTOGENERATED FROM VRDisplayEvent.webidl BY Codegen.py - DO NOT EDIT */

#ifndef mozilla_dom_VRDisplayEventBinding_h
#define mozilla_dom_VRDisplayEventBinding_h

#include "EventBinding.h"
#include "js/CallAndConstruct.h"
#include "js/RootingAPI.h"
#include "js/TypeDecls.h"
#include "mozilla/ArrayUtils.h"
#include "mozilla/Span.h"
#include "mozilla/dom/BindingDeclarations.h"
#include "mozilla/dom/Nullable.h"
#include "mozilla/dom/PrototypeList.h"
#include "mozilla/dom/VRDisplay.h"

namespace mozilla {
namespace dom {

struct NativePropertyHooks;
class ProtoAndIfaceCache;
class VRDisplay;
class VRDisplayEvent;
struct VRDisplayEventAtoms;
struct VRDisplayEventInitAtoms;

} // namespace dom
} // namespace mozilla

namespace mozilla::dom {

enum class VRDisplayEventReason : uint8_t {
  Mounted,
  Navigation,
  Requested,
  Unmounted,
  EndGuard_
};

namespace VRDisplayEventReasonValues {
extern const EnumEntry strings[5];

static constexpr size_t Count = 4;

// Our "strings" contains an extra entry with a null string.
static_assert(mozilla::ArrayLength(strings) - 1 == Count,
              "Mismatch between enum strings and enum count");

static_assert(static_cast<size_t>(VRDisplayEventReason::EndGuard_) == Count,
              "Mismatch between enum value and enum count");

inline auto GetString(VRDisplayEventReason stringId) {
  MOZ_ASSERT(static_cast<uint8_t>(stringId) < Count);
  const EnumEntry& entry = strings[static_cast<uint8_t>(stringId)];
  return Span<const char>{entry.value, entry.length};
}
} // namespace VRDisplayEventReasonValues

bool
ToJSValue(JSContext* aCx, VRDisplayEventReason aArgument, JS::MutableHandle<JS::Value> aValue);


struct VRDisplayEventInit : public EventInit
{
  MOZ_INIT_OUTSIDE_CTOR OwningNonNull<mozilla::dom::VRDisplay> mDisplay;
  MOZ_INIT_OUTSIDE_CTOR Optional<VRDisplayEventReason> mReason;

  VRDisplayEventInit();

  explicit inline VRDisplayEventInit(const FastDictionaryInitializer& )
    : EventInit(FastDictionaryInitializer())
  {
    // Do nothing here; this is used by our "Fast" subclass
  }

  explicit inline VRDisplayEventInit(const VRDisplayEventInit& aOther)
    : EventInit(FastDictionaryInitializer())
  {
    *this = aOther;
  }

  bool
  Init(BindingCallContext& cx, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  bool
  Init(JSContext* cx_, JS::Handle<JS::Value> val, const char* sourceDescription = "Value", bool passedToJSImpl = false);

  void
  TraceDictionary(JSTracer* trc);

  inline void
  TraverseForCC(nsCycleCollectionTraversalCallback& aCallback, uint32_t aFlags)
  {
    ImplCycleCollectionTraverse(aCallback, mDisplay, "mDisplay", aFlags);
  }

  inline void
  UnlinkForCC()
  {
    ImplCycleCollectionUnlink(mDisplay);
  }

  VRDisplayEventInit&
  operator=(const VRDisplayEventInit& aOther);

private:
  static bool
  InitIds(JSContext* cx, VRDisplayEventInitAtoms* atomsCache);
};

namespace binding_detail {
struct FastVRDisplayEventInit : public VRDisplayEventInit
{
  inline FastVRDisplayEventInit()
    : VRDisplayEventInit(FastDictionaryInitializer())
  {
    // Doesn't matter what int we pass to the parent constructor
  }
};
} // namespace binding_detail


namespace VRDisplayEvent_Binding {

  typedef mozilla::dom::VRDisplayEvent NativeType;

  bool
  ConstructorEnabled(JSContext* aCx, JS::Handle<JSObject*> aObj);

  const JSClass*
  GetJSClass();

  bool
  Wrap(JSContext* aCx, mozilla::dom::VRDisplayEvent* aObject, nsWrapperCache* aCache, JS::Handle<JSObject*> aGivenProto, JS::MutableHandle<JSObject*> aReflector);

  template <class T>
  inline JSObject* Wrap(JSContext* aCx, T* aObject, JS::Handle<JSObject*> aGivenProto)
  {
    JS::Rooted<JSObject*> reflector(aCx);
    return Wrap(aCx, aObject, aObject, aGivenProto, &reflector) ? reflector.get() : nullptr;
  }

  void
  CreateInterfaceObjects(JSContext* aCx, JS::Handle<JSObject*> aGlobal, ProtoAndIfaceCache& aProtoAndIfaceCache, bool aDefineOnGlobal);

  inline JS::Handle<JSObject*> GetProtoObjectHandle(JSContext* aCx)
  {
    /* Get the interface prototype object for this class.  This will create the
       object as needed. */
    return GetPerInterfaceObjectHandle(aCx, prototypes::id::VRDisplayEvent,
                                       &CreateInterfaceObjects,
                                       /* aDefineOnGlobal = */ true);

  }

  inline JS::Handle<JSObject*> GetConstructorObjectHandle(JSContext* aCx, bool aDefineOnGlobal = true)
  {
    /* Get the interface object for this class.  This will create the object as
       needed. */

    return GetPerInterfaceObjectHandle(aCx, constructors::id::VRDisplayEvent,
                                       &CreateInterfaceObjects,
                                       aDefineOnGlobal);
  }

  JSObject*
  GetConstructorObject(JSContext* aCx);

} // namespace VRDisplayEvent_Binding



} // namespace mozilla::dom

#endif // mozilla_dom_VRDisplayEventBinding_h
