/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

/* Generated with cbindgen:0.23.0 */

/* DO NOT MODIFY THIS MANUALLY! This file was generated using cbindgen.
 *
 * This file is generated based on the configuration in
 * `gfx/wgpu_bindings/moz.build`, which directs the build system module
 * `build/RunCbindgen.py` to run the following command at the top of
 * the object file directory:
 * 
 *     $CBINDGEN $TOPSRCDIR --lockfile $TOPSRCDIR/Cargo.lock --crate wgpu_bindings --metadata config/cbindgen-metadata.json --cpp-compat > gfx/wgpu_bindings/wgpu_ffi_generated.h
 *
 * where:
 * - $TOPSRCDIR is the top of the Firefox source tree, and
 * - $CBINDGEN is the path to the cbindgen executable provided by mozbuild (the exact version often matters)
 */

struct WGPUByteBuf;
typedef uint64_t WGPUNonZeroU64;
typedef uint64_t WGPUOption_BufferSize;
typedef uint32_t WGPUOption_NonZeroU32;
typedef uint8_t WGPUOption_NonZeroU8;
typedef uint64_t WGPUOption_AdapterId;
typedef uint64_t WGPUOption_BufferId;
typedef uint64_t WGPUOption_PipelineLayoutId;
typedef uint64_t WGPUOption_BindGroupLayoutId;
typedef uint64_t WGPUOption_SamplerId;
typedef uint64_t WGPUOption_SurfaceId;
typedef uint64_t WGPUOption_TextureViewId;


#include <stdarg.h>
#include <stdbool.h>
#include <stdint.h>
#include <stdlib.h>

#define WGPUSHADER_STAGE_COUNT 3

#define WGPUEPOCH_MASK ((1 << WGPUEPOCH_BITS) - 1)

#define WGPUDESIRED_NUM_FRAMES 3

#define WGPUMAX_ANISOTROPY 16

#define WGPUMAX_BIND_GROUPS 8

#define WGPUMAX_VERTEX_BUFFERS 16

#define WGPUMAX_COLOR_TARGETS 8

#define WGPUMAX_MIP_LEVELS 16

/**
 * Maximum binding size for the shaders that only support `i32` indexing.
 * Interestingly, the index itself can't reach that high, because the minimum
 * element size is 4 bytes, but the compiler toolchain still computes the
 * offset at some intermediate point, internally, as i32.
 */
#define WGPUMAX_I32_BINDING_SIZE (1 << 31)

#define WGPUVENDOR 32902

#define WGPUDEVICE_KABY_LAKE_MASK 22784

#define WGPUDEVICE_SKY_LAKE_MASK 6400

/**
 * Buffer-Texture copies must have [`bytes_per_row`] aligned to this number.
 *
 * This doesn't apply to [`Queue::write_texture`][Qwt].
 *
 * [`bytes_per_row`]: ImageDataLayout::bytes_per_row
 * [Qwt]: ../wgpu/struct.Queue.html#method.write_texture
 */
#define WGPUCOPY_BYTES_PER_ROW_ALIGNMENT 256

/**
 * Alignment all push constants need
 */
#define WGPUPUSH_CONSTANT_ALIGNMENT 4

/**
 * Maximum queries in a query set
 */
#define WGPUQUERY_SET_MAX_QUERIES 8192

/**
 * How edges should be handled in texture addressing.
 *
 * Corresponds to [WebGPU `GPUAddressMode`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gpuaddressmode).
 */
enum WGPUAddressMode {
  /**
   * Clamp the value to the edge of the texture
   *
   * -0.25 -> 0.0
   * 1.25  -> 1.0
   */
  WGPUAddressMode_ClampToEdge = 0,
  /**
   * Repeat the texture in a tiling fashion
   *
   * -0.25 -> 0.75
   * 1.25 -> 0.25
   */
  WGPUAddressMode_Repeat = 1,
  /**
   * Repeat the texture, mirroring it every repeat
   *
   * -0.25 -> 0.25
   * 1.25 -> 0.75
   */
  WGPUAddressMode_MirrorRepeat = 2,
  /**
   * Clamp the value to the border of the texture
   * Requires feature [`Features::ADDRESS_MODE_CLAMP_TO_BORDER`]
   *
   * -0.25 -> border
   * 1.25 -> border
   */
  WGPUAddressMode_ClampToBorder = 3,
  /**
   * Must be last for serialization purposes
   */
  WGPUAddressMode_Sentinel,
};

/**
 * ASTC block dimensions
 */
enum WGPUAstcBlock {
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px).
   */
  WGPUAstcBlock_B4x4,
  /**
   * 5x4 block compressed texture. 16 bytes per block (6.4 bit/px).
   */
  WGPUAstcBlock_B5x4,
  /**
   * 5x5 block compressed texture. 16 bytes per block (5.12 bit/px).
   */
  WGPUAstcBlock_B5x5,
  /**
   * 6x5 block compressed texture. 16 bytes per block (4.27 bit/px).
   */
  WGPUAstcBlock_B6x5,
  /**
   * 6x6 block compressed texture. 16 bytes per block (3.56 bit/px).
   */
  WGPUAstcBlock_B6x6,
  /**
   * 8x5 block compressed texture. 16 bytes per block (3.2 bit/px).
   */
  WGPUAstcBlock_B8x5,
  /**
   * 8x6 block compressed texture. 16 bytes per block (2.67 bit/px).
   */
  WGPUAstcBlock_B8x6,
  /**
   * 8x8 block compressed texture. 16 bytes per block (2 bit/px).
   */
  WGPUAstcBlock_B8x8,
  /**
   * 10x5 block compressed texture. 16 bytes per block (2.56 bit/px).
   */
  WGPUAstcBlock_B10x5,
  /**
   * 10x6 block compressed texture. 16 bytes per block (2.13 bit/px).
   */
  WGPUAstcBlock_B10x6,
  /**
   * 10x8 block compressed texture. 16 bytes per block (1.6 bit/px).
   */
  WGPUAstcBlock_B10x8,
  /**
   * 10x10 block compressed texture. 16 bytes per block (1.28 bit/px).
   */
  WGPUAstcBlock_B10x10,
  /**
   * 12x10 block compressed texture. 16 bytes per block (1.07 bit/px).
   */
  WGPUAstcBlock_B12x10,
  /**
   * 12x12 block compressed texture. 16 bytes per block (0.89 bit/px).
   */
  WGPUAstcBlock_B12x12,
  /**
   * Must be last for serialization purposes
   */
  WGPUAstcBlock_Sentinel,
};

/**
 * ASTC RGBA channel
 */
enum WGPUAstcChannel {
  /**
   * 8 bit integer RGBA, [0, 255] converted to/from linear-color float [0, 1] in shader.
   *
   * [`Features::TEXTURE_COMPRESSION_ASTC_LDR`] must be enabled to use this channel.
   */
  WGPUAstcChannel_Unorm,
  /**
   * 8 bit integer RGBA, Srgb-color [0, 255] converted to/from linear-color float [0, 1] in shader.
   *
   * [`Features::TEXTURE_COMPRESSION_ASTC_LDR`] must be enabled to use this channel.
   */
  WGPUAstcChannel_UnormSrgb,
  /**
   * floating-point RGBA, linear-color float can be outside of the [0, 1] range.
   *
   * [`Features::TEXTURE_COMPRESSION_ASTC_HDR`] must be enabled to use this channel.
   */
  WGPUAstcChannel_Hdr,
  /**
   * Must be last for serialization purposes
   */
  WGPUAstcChannel_Sentinel,
};

/**
 * Alpha blend factor.
 *
 * Alpha blending is very complicated: see the OpenGL or Vulkan spec for more information.
 *
 * Corresponds to [WebGPU `GPUBlendFactor`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gpublendfactor).
 */
enum WGPUBlendFactor {
  /**
   * 0.0
   */
  WGPUBlendFactor_Zero = 0,
  /**
   * 1.0
   */
  WGPUBlendFactor_One = 1,
  /**
   * S.component
   */
  WGPUBlendFactor_Src = 2,
  /**
   * 1.0 - S.component
   */
  WGPUBlendFactor_OneMinusSrc = 3,
  /**
   * S.alpha
   */
  WGPUBlendFactor_SrcAlpha = 4,
  /**
   * 1.0 - S.alpha
   */
  WGPUBlendFactor_OneMinusSrcAlpha = 5,
  /**
   * D.component
   */
  WGPUBlendFactor_Dst = 6,
  /**
   * 1.0 - D.component
   */
  WGPUBlendFactor_OneMinusDst = 7,
  /**
   * D.alpha
   */
  WGPUBlendFactor_DstAlpha = 8,
  /**
   * 1.0 - D.alpha
   */
  WGPUBlendFactor_OneMinusDstAlpha = 9,
  /**
   * min(S.alpha, 1.0 - D.alpha)
   */
  WGPUBlendFactor_SrcAlphaSaturated = 10,
  /**
   * Constant
   */
  WGPUBlendFactor_Constant = 11,
  /**
   * 1.0 - Constant
   */
  WGPUBlendFactor_OneMinusConstant = 12,
  /**
   * Must be last for serialization purposes
   */
  WGPUBlendFactor_Sentinel,
};

/**
 * Alpha blend operation.
 *
 * Alpha blending is very complicated: see the OpenGL or Vulkan spec for more information.
 *
 * Corresponds to [WebGPU `GPUBlendOperation`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gpublendoperation).
 */
enum WGPUBlendOperation {
  /**
   * Src + Dst
   */
  WGPUBlendOperation_Add = 0,
  /**
   * Src - Dst
   */
  WGPUBlendOperation_Subtract = 1,
  /**
   * Dst - Src
   */
  WGPUBlendOperation_ReverseSubtract = 2,
  /**
   * min(Src, Dst)
   */
  WGPUBlendOperation_Min = 3,
  /**
   * max(Src, Dst)
   */
  WGPUBlendOperation_Max = 4,
  /**
   * Must be last for serialization purposes
   */
  WGPUBlendOperation_Sentinel,
};

enum WGPUBufferMapAsyncStatus {
  WGPUBufferMapAsyncStatus_Success,
  WGPUBufferMapAsyncStatus_Error,
  WGPUBufferMapAsyncStatus_Aborted,
  WGPUBufferMapAsyncStatus_Unknown,
  WGPUBufferMapAsyncStatus_ContextLost,
  /**
   * Must be last for serialization purposes
   */
  WGPUBufferMapAsyncStatus_Sentinel,
};

/**
 * Comparison function used for depth and stencil operations.
 *
 * Corresponds to [WebGPU `GPUCompareFunction`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gpucomparefunction).
 */
enum WGPUCompareFunction {
  /**
   * Function never passes
   */
  WGPUCompareFunction_Never = 1,
  /**
   * Function passes if new value less than existing value
   */
  WGPUCompareFunction_Less = 2,
  /**
   * Function passes if new value is equal to existing value
   */
  WGPUCompareFunction_Equal = 3,
  /**
   * Function passes if new value is less than or equal to existing value
   */
  WGPUCompareFunction_LessEqual = 4,
  /**
   * Function passes if new value is greater than existing value
   */
  WGPUCompareFunction_Greater = 5,
  /**
   * Function passes if new value is not equal to existing value
   */
  WGPUCompareFunction_NotEqual = 6,
  /**
   * Function passes if new value is greater than or equal to existing value
   */
  WGPUCompareFunction_GreaterEqual = 7,
  /**
   * Function always passes
   */
  WGPUCompareFunction_Always = 8,
  /**
   * Must be last for serialization purposes
   */
  WGPUCompareFunction_Sentinel,
};

/**
 * Supported physical device types.
 */
enum WGPUDeviceType
#ifdef __cplusplus
  : uint8_t
#endif // __cplusplus
 {
  /**
   * Other.
   */
  WGPUDeviceType_Other,
  /**
   * Integrated GPU with shared CPU/GPU memory.
   */
  WGPUDeviceType_IntegratedGpu,
  /**
   * Discrete GPU with separate CPU/GPU memory.
   */
  WGPUDeviceType_DiscreteGpu,
  /**
   * Virtual / Hosted.
   */
  WGPUDeviceType_VirtualGpu,
  /**
   * Cpu / Software Rendering.
   */
  WGPUDeviceType_Cpu,
  /**
   * Must be last for serialization purposes
   */
  WGPUDeviceType_Sentinel,
};
#ifndef __cplusplus
typedef uint8_t WGPUDeviceType;
#endif // __cplusplus

/**
 * Face of a vertex.
 *
 * Corresponds to [WebGPU `GPUCullMode`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gpucullmode),
 * except that the `"none"` value is represented using `Option<Face>` instead.
 */
enum WGPUFace {
  /**
   * Front face
   */
  WGPUFace_Front = 0,
  /**
   * Back face
   */
  WGPUFace_Back = 1,
  /**
   * Must be last for serialization purposes
   */
  WGPUFace_Sentinel,
};

/**
 * Texel mixing mode when sampling between texels.
 *
 * Corresponds to [WebGPU `GPUFilterMode`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gpufiltermode).
 */
enum WGPUFilterMode {
  /**
   * Nearest neighbor sampling.
   *
   * This creates a pixelated effect when used as a mag filter
   */
  WGPUFilterMode_Nearest = 0,
  /**
   * Linear Interpolation
   *
   * This makes textures smooth but blurry when used as a mag filter.
   */
  WGPUFilterMode_Linear = 1,
  /**
   * Must be last for serialization purposes
   */
  WGPUFilterMode_Sentinel,
};

/**
 * Vertex winding order which classifies the "front" face of a triangle.
 *
 * Corresponds to [WebGPU `GPUFrontFace`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gpufrontface).
 */
enum WGPUFrontFace {
  /**
   * Triangles with vertices in counter clockwise order are considered the front face.
   *
   * This is the default with right handed coordinate spaces.
   */
  WGPUFrontFace_Ccw = 0,
  /**
   * Triangles with vertices in clockwise order are considered the front face.
   *
   * This is the default with left handed coordinate spaces.
   */
  WGPUFrontFace_Cw = 1,
  /**
   * Must be last for serialization purposes
   */
  WGPUFrontFace_Sentinel,
};

enum WGPUHostMap {
  WGPUHostMap_Read,
  WGPUHostMap_Write,
  /**
   * Must be last for serialization purposes
   */
  WGPUHostMap_Sentinel,
};

/**
 * Format of indices used with pipeline.
 *
 * Corresponds to [WebGPU `GPUIndexFormat`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gpuindexformat).
 */
enum WGPUIndexFormat {
  /**
   * Indices are 16 bit unsigned integers.
   */
  WGPUIndexFormat_Uint16 = 0,
  /**
   * Indices are 32 bit unsigned integers.
   */
  WGPUIndexFormat_Uint32 = 1,
  /**
   * Must be last for serialization purposes
   */
  WGPUIndexFormat_Sentinel,
};

/**
 * Operation to perform to the output attachment at the start of a renderpass.
 */
enum WGPULoadOp {
  /**
   * Clear the output attachment with the clear color. Clearing is faster than loading.
   */
  WGPULoadOp_Clear = 0,
  /**
   * Do not clear output attachment.
   */
  WGPULoadOp_Load = 1,
  /**
   * Must be last for serialization purposes
   */
  WGPULoadOp_Sentinel,
};

/**
 * Type of drawing mode for polygons
 */
enum WGPUPolygonMode {
  /**
   * Polygons are filled
   */
  WGPUPolygonMode_Fill = 0,
  /**
   * Polygons are drawn as line segments
   */
  WGPUPolygonMode_Line = 1,
  /**
   * Polygons are drawn as points
   */
  WGPUPolygonMode_Point = 2,
  /**
   * Must be last for serialization purposes
   */
  WGPUPolygonMode_Sentinel,
};

/**
 * Power Preference when choosing a physical adapter.
 *
 * Corresponds to [WebGPU `GPUPowerPreference`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gpupowerpreference).
 */
enum WGPUPowerPreference {
  /**
   * Adapter that uses the least possible power. This is often an integrated GPU.
   */
  WGPUPowerPreference_LowPower = 0,
  /**
   * Adapter that has the highest performance. This is often a discrete GPU.
   */
  WGPUPowerPreference_HighPerformance = 1,
  /**
   * Must be last for serialization purposes
   */
  WGPUPowerPreference_Sentinel,
};

/**
 * Primitive type the input mesh is composed of.
 *
 * Corresponds to [WebGPU `GPUPrimitiveTopology`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gpuprimitivetopology).
 */
enum WGPUPrimitiveTopology {
  /**
   * Vertex data is a list of points. Each vertex is a new point.
   */
  WGPUPrimitiveTopology_PointList = 0,
  /**
   * Vertex data is a list of lines. Each pair of vertices composes a new line.
   *
   * Vertices `0 1 2 3` create two lines `0 1` and `2 3`
   */
  WGPUPrimitiveTopology_LineList = 1,
  /**
   * Vertex data is a strip of lines. Each set of two adjacent vertices form a line.
   *
   * Vertices `0 1 2 3` create three lines `0 1`, `1 2`, and `2 3`.
   */
  WGPUPrimitiveTopology_LineStrip = 2,
  /**
   * Vertex data is a list of triangles. Each set of 3 vertices composes a new triangle.
   *
   * Vertices `0 1 2 3 4 5` create two triangles `0 1 2` and `3 4 5`
   */
  WGPUPrimitiveTopology_TriangleList = 3,
  /**
   * Vertex data is a triangle strip. Each set of three adjacent vertices form a triangle.
   *
   * Vertices `0 1 2 3 4 5` creates four triangles `0 1 2`, `2 1 3`, `2 3 4`, and `4 3 5`
   */
  WGPUPrimitiveTopology_TriangleStrip = 4,
  /**
   * Must be last for serialization purposes
   */
  WGPUPrimitiveTopology_Sentinel,
};

enum WGPURawBindingType {
  WGPURawBindingType_UniformBuffer,
  WGPURawBindingType_StorageBuffer,
  WGPURawBindingType_ReadonlyStorageBuffer,
  WGPURawBindingType_Sampler,
  WGPURawBindingType_SampledTexture,
  WGPURawBindingType_ReadonlyStorageTexture,
  WGPURawBindingType_WriteonlyStorageTexture,
  /**
   * Must be last for serialization purposes
   */
  WGPURawBindingType_Sentinel,
};

enum WGPURawTextureSampleType {
  WGPURawTextureSampleType_Float,
  WGPURawTextureSampleType_UnfilterableFloat,
  WGPURawTextureSampleType_Uint,
  WGPURawTextureSampleType_Sint,
  WGPURawTextureSampleType_Depth,
  /**
   * Must be last for serialization purposes
   */
  WGPURawTextureSampleType_Sentinel,
};

/**
 * Operation to perform on the stencil value.
 *
 * Corresponds to [WebGPU `GPUStencilOperation`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gpustenciloperation).
 */
enum WGPUStencilOperation {
  /**
   * Keep stencil value unchanged.
   */
  WGPUStencilOperation_Keep = 0,
  /**
   * Set stencil value to zero.
   */
  WGPUStencilOperation_Zero = 1,
  /**
   * Replace stencil value with value provided in most recent call to
   * [`RenderPass::set_stencil_reference`][RPssr].
   *
   * [RPssr]: ../wgpu/struct.RenderPass.html#method.set_stencil_reference
   */
  WGPUStencilOperation_Replace = 2,
  /**
   * Bitwise inverts stencil value.
   */
  WGPUStencilOperation_Invert = 3,
  /**
   * Increments stencil value by one, clamping on overflow.
   */
  WGPUStencilOperation_IncrementClamp = 4,
  /**
   * Decrements stencil value by one, clamping on underflow.
   */
  WGPUStencilOperation_DecrementClamp = 5,
  /**
   * Increments stencil value by one, wrapping on overflow.
   */
  WGPUStencilOperation_IncrementWrap = 6,
  /**
   * Decrements stencil value by one, wrapping on underflow.
   */
  WGPUStencilOperation_DecrementWrap = 7,
  /**
   * Must be last for serialization purposes
   */
  WGPUStencilOperation_Sentinel,
};

/**
 * Operation to perform to the output attachment at the end of a renderpass.
 */
enum WGPUStoreOp {
  /**
   * Discards the content of the render target. If you don't care about the contents of the target, this can be faster.
   */
  WGPUStoreOp_Discard = 0,
  /**
   * Store the result of the renderpass.
   */
  WGPUStoreOp_Store = 1,
  /**
   * Must be last for serialization purposes
   */
  WGPUStoreOp_Sentinel,
};

/**
 * Kind of data the texture holds.
 *
 * Corresponds to [WebGPU `GPUTextureAspect`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gputextureaspect).
 */
enum WGPUTextureAspect {
  /**
   * Depth, Stencil, and Color.
   */
  WGPUTextureAspect_All,
  /**
   * Stencil.
   */
  WGPUTextureAspect_StencilOnly,
  /**
   * Depth.
   */
  WGPUTextureAspect_DepthOnly,
  /**
   * Must be last for serialization purposes
   */
  WGPUTextureAspect_Sentinel,
};

/**
 * Dimensionality of a texture.
 *
 * Corresponds to [WebGPU `GPUTextureDimension`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gputexturedimension).
 */
enum WGPUTextureDimension {
  /**
   * 1D texture
   */
  WGPUTextureDimension_D1,
  /**
   * 2D texture
   */
  WGPUTextureDimension_D2,
  /**
   * 3D texture
   */
  WGPUTextureDimension_D3,
  /**
   * Must be last for serialization purposes
   */
  WGPUTextureDimension_Sentinel,
};

/**
 * Dimensions of a particular texture view.
 *
 * Corresponds to [WebGPU `GPUTextureViewDimension`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gputextureviewdimension).
 */
enum WGPUTextureViewDimension {
  /**
   * A one dimensional texture. `texture1D` in glsl shaders.
   */
  WGPUTextureViewDimension_D1,
  /**
   * A two dimensional texture. `texture2D` in glsl shaders.
   */
  WGPUTextureViewDimension_D2,
  /**
   * A two dimensional array texture. `texture2DArray` in glsl shaders.
   */
  WGPUTextureViewDimension_D2Array,
  /**
   * A cubemap texture. `textureCube` in glsl shaders.
   */
  WGPUTextureViewDimension_Cube,
  /**
   * A cubemap array texture. `textureCubeArray` in glsl shaders.
   */
  WGPUTextureViewDimension_CubeArray,
  /**
   * A three dimensional texture. `texture3D` in glsl shaders.
   */
  WGPUTextureViewDimension_D3,
  /**
   * Must be last for serialization purposes
   */
  WGPUTextureViewDimension_Sentinel,
};

/**
 * Vertex Format for a [`VertexAttribute`] (input).
 *
 * Corresponds to [WebGPU `GPUVertexFormat`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gpuvertexformat).
 */
enum WGPUVertexFormat {
  /**
   * Two unsigned bytes (u8). `uvec2` in shaders.
   */
  WGPUVertexFormat_Uint8x2 = 0,
  /**
   * Four unsigned bytes (u8). `uvec4` in shaders.
   */
  WGPUVertexFormat_Uint8x4 = 1,
  /**
   * Two signed bytes (i8). `ivec2` in shaders.
   */
  WGPUVertexFormat_Sint8x2 = 2,
  /**
   * Four signed bytes (i8). `ivec4` in shaders.
   */
  WGPUVertexFormat_Sint8x4 = 3,
  /**
   * Two unsigned bytes (u8). [0, 255] converted to float [0, 1] `vec2` in shaders.
   */
  WGPUVertexFormat_Unorm8x2 = 4,
  /**
   * Four unsigned bytes (u8). [0, 255] converted to float [0, 1] `vec4` in shaders.
   */
  WGPUVertexFormat_Unorm8x4 = 5,
  /**
   * Two signed bytes (i8). [-127, 127] converted to float [-1, 1] `vec2` in shaders.
   */
  WGPUVertexFormat_Snorm8x2 = 6,
  /**
   * Four signed bytes (i8). [-127, 127] converted to float [-1, 1] `vec4` in shaders.
   */
  WGPUVertexFormat_Snorm8x4 = 7,
  /**
   * Two unsigned shorts (u16). `uvec2` in shaders.
   */
  WGPUVertexFormat_Uint16x2 = 8,
  /**
   * Four unsigned shorts (u16). `uvec4` in shaders.
   */
  WGPUVertexFormat_Uint16x4 = 9,
  /**
   * Two signed shorts (i16). `ivec2` in shaders.
   */
  WGPUVertexFormat_Sint16x2 = 10,
  /**
   * Four signed shorts (i16). `ivec4` in shaders.
   */
  WGPUVertexFormat_Sint16x4 = 11,
  /**
   * Two unsigned shorts (u16). [0, 65535] converted to float [0, 1] `vec2` in shaders.
   */
  WGPUVertexFormat_Unorm16x2 = 12,
  /**
   * Four unsigned shorts (u16). [0, 65535] converted to float [0, 1] `vec4` in shaders.
   */
  WGPUVertexFormat_Unorm16x4 = 13,
  /**
   * Two signed shorts (i16). [-32767, 32767] converted to float [-1, 1] `vec2` in shaders.
   */
  WGPUVertexFormat_Snorm16x2 = 14,
  /**
   * Four signed shorts (i16). [-32767, 32767] converted to float [-1, 1] `vec4` in shaders.
   */
  WGPUVertexFormat_Snorm16x4 = 15,
  /**
   * Two half-precision floats (no Rust equiv). `vec2` in shaders.
   */
  WGPUVertexFormat_Float16x2 = 16,
  /**
   * Four half-precision floats (no Rust equiv). `vec4` in shaders.
   */
  WGPUVertexFormat_Float16x4 = 17,
  /**
   * One single-precision float (f32). `float` in shaders.
   */
  WGPUVertexFormat_Float32 = 18,
  /**
   * Two single-precision floats (f32). `vec2` in shaders.
   */
  WGPUVertexFormat_Float32x2 = 19,
  /**
   * Three single-precision floats (f32). `vec3` in shaders.
   */
  WGPUVertexFormat_Float32x3 = 20,
  /**
   * Four single-precision floats (f32). `vec4` in shaders.
   */
  WGPUVertexFormat_Float32x4 = 21,
  /**
   * One unsigned int (u32). `uint` in shaders.
   */
  WGPUVertexFormat_Uint32 = 22,
  /**
   * Two unsigned ints (u32). `uvec2` in shaders.
   */
  WGPUVertexFormat_Uint32x2 = 23,
  /**
   * Three unsigned ints (u32). `uvec3` in shaders.
   */
  WGPUVertexFormat_Uint32x3 = 24,
  /**
   * Four unsigned ints (u32). `uvec4` in shaders.
   */
  WGPUVertexFormat_Uint32x4 = 25,
  /**
   * One signed int (i32). `int` in shaders.
   */
  WGPUVertexFormat_Sint32 = 26,
  /**
   * Two signed ints (i32). `ivec2` in shaders.
   */
  WGPUVertexFormat_Sint32x2 = 27,
  /**
   * Three signed ints (i32). `ivec3` in shaders.
   */
  WGPUVertexFormat_Sint32x3 = 28,
  /**
   * Four signed ints (i32). `ivec4` in shaders.
   */
  WGPUVertexFormat_Sint32x4 = 29,
  /**
   * One double-precision float (f64). `double` in shaders. Requires VERTEX_ATTRIBUTE_64BIT features.
   */
  WGPUVertexFormat_Float64 = 30,
  /**
   * Two double-precision floats (f64). `dvec2` in shaders. Requires VERTEX_ATTRIBUTE_64BIT features.
   */
  WGPUVertexFormat_Float64x2 = 31,
  /**
   * Three double-precision floats (f64). `dvec3` in shaders. Requires VERTEX_ATTRIBUTE_64BIT features.
   */
  WGPUVertexFormat_Float64x3 = 32,
  /**
   * Four double-precision floats (f64). `dvec4` in shaders. Requires VERTEX_ATTRIBUTE_64BIT features.
   */
  WGPUVertexFormat_Float64x4 = 33,
  /**
   * Must be last for serialization purposes
   */
  WGPUVertexFormat_Sentinel,
};

/**
 * Rate that determines when vertex data is advanced.
 *
 * Corresponds to [WebGPU `GPUVertexStepMode`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gpuvertexstepmode).
 */
enum WGPUVertexStepMode {
  /**
   * Vertex data is advanced every vertex.
   */
  WGPUVertexStepMode_Vertex = 0,
  /**
   * Vertex data is advanced every instance.
   */
  WGPUVertexStepMode_Instance = 1,
  /**
   * Must be last for serialization purposes
   */
  WGPUVertexStepMode_Sentinel,
};

struct WGPUAttachmentOps;

/**
 * Pipeline layout creation flags.
 */
struct WGPUBindGroupLayoutFlags;

/**
 * Similar to `wgt::BufferUsages` but for internal use.
 */
struct WGPUBufferUses;

struct WGPUClient;

struct WGPUComputePass;

/**
 * Binary flags listing features that may or may not be present on downlevel adapters.
 *
 * A downlevel adapter is a GPU adapter that WGPU supports, but with potentially limited
 * features, due to the lack of hardware feature support.
 *
 * Flags that are **not** present for a downlevel adapter or device usually indicates
 * non-compliance with the WebGPU specification, but not always.
 *
 * You can check whether a set of flags is compliant through the
 * [`DownlevelCapabilities::is_webgpu_compliant()`] function.
 */
struct WGPUDownlevelFlags;

/**
 * Texture format capability flags.
 */
struct WGPUFormatAspects;

struct WGPUGlobal;

/**
 * Instance initialization flags.
 */
struct WGPUInstanceFlags;

struct WGPUMemoryFlags;

/**
 * Pipeline layout creation flags.
 */
struct WGPUPipelineLayoutFlags;

struct WGPUPrivateCapabilities;

/**
 * Flags that affect internal code paths but do not
 * change the exposed feature set.
 */
struct WGPUPrivateCapabilities;

struct WGPUPrivateCapabilities;

/**
 * Set of internal capabilities, which don't show up in the exposed
 * device geometry, but affect the code paths taken internally.
 */
struct WGPUPrivateCapabilities;

struct WGPURenderBundleEncoder;

struct WGPURenderPass;

struct WGPUTableTypes;

/**
 * Texture format capability flags.
 */
struct WGPUTextureFormatCapabilities;

/**
 * Similar to `wgt::TextureUsages` but for internal use.
 */
struct WGPUTextureUses;

struct WGPUUpdateAfterBindTypes;

struct WGPUWorkarounds;

/**
 * Flags that indicate necessary workarounds for specific devices or driver bugs
 */
struct WGPUWorkarounds;

/**
 * Workaround flags.
 */
struct WGPUWorkarounds;

struct WGPUByteBuf {
  const uint8_t *data;
  uintptr_t len;
  uintptr_t capacity;
};

#if defined(WGPU_FEATURE_ID32)
typedef uint32_t WGPUNonZeroId;
#endif

#if !defined(WGPU_FEATURE_ID32)
typedef uint64_t WGPUNonZeroId;
#endif

typedef WGPUNonZeroId WGPUId_Device_Dummy;

typedef WGPUId_Device_Dummy WGPUDeviceId;

struct WGPUInfrastructure {
  struct WGPUClient *client;
  const uint8_t *error;
};

typedef WGPUNonZeroId WGPUId_Adapter_Dummy;

typedef WGPUId_Adapter_Dummy WGPUAdapterId;

/**
 * Represents the sets of limits an adapter/device supports.
 *
 * We provide three different defaults.
 * - [`Limits::downlevel_defaults()`]. This is a set of limits that is guaranteed to work on almost
 *   all backends, including "downlevel" backends such as OpenGL and D3D11, other than WebGL. For
 *   most applications we recommend using these limits, assuming they are high enough for your
 *   application, and you do not intent to support WebGL.
 * - [`Limits::downlevel_webgl2_defaults()`] This is a set of limits that is lower even than the
 *   [`downlevel_defaults()`], configured to be low enough to support running in the browser using
 *   WebGL2.
 * - [`Limits::default()`]. This is the set of limits that is guarenteed to work on all modern
 *   backends and is guarenteed to be supported by WebGPU. Applications needing more modern
 *   features can use this as a reasonable set of limits if they are targetting only desktop and
 *   modern mobile devices.
 *
 * We recommend starting with the most restrictive limits you can and manually increasing the
 * limits you need boosted. This will let you stay running on all hardware that supports the limits
 * you need.
 *
 * Limits "better" than the default must be supported by the adapter and requested when requesting
 * a device. If limits "better" than the adapter supports are requested, requesting a device will
 * panic. Once a device is requested, you may only use resources up to the limits requested _even_
 * if the adapter supports "better" limits.
 *
 * Requesting limits that are "better" than you need may cause performance to decrease because the
 * implementation needs to support more than is needed. You should ideally only request exactly
 * what you need.
 *
 * Corresponds to [WebGPU `GPUSupportedLimits`](
 * https://gpuweb.github.io/gpuweb/#gpusupportedlimits).
 *
 * [`downlevel_defaults()`]: Limits::downlevel_defaults
 */
struct WGPULimits {
  /**
   * Maximum allowed value for the `size.width` of a texture created with `TextureDimension::D1`.
   * Defaults to 8192. Higher is "better".
   */
  uint32_t max_texture_dimension_1d;
  /**
   * Maximum allowed value for the `size.width` and `size.height` of a texture created with `TextureDimension::D2`.
   * Defaults to 8192. Higher is "better".
   */
  uint32_t max_texture_dimension_2d;
  /**
   * Maximum allowed value for the `size.width`, `size.height`, and `size.depth_or_array_layers`
   * of a texture created with `TextureDimension::D3`.
   * Defaults to 2048. Higher is "better".
   */
  uint32_t max_texture_dimension_3d;
  /**
   * Maximum allowed value for the `size.depth_or_array_layers` of a texture created with
   * `TextureDimension::D1` or `TextureDimension::D2`.
   * Defaults to 256. Higher is "better".
   */
  uint32_t max_texture_array_layers;
  /**
   * Amount of bind groups that can be attached to a pipeline at the same time. Defaults to 4. Higher is "better".
   */
  uint32_t max_bind_groups;
  /**
   * Amount of uniform buffer bindings that can be dynamic in a single pipeline. Defaults to 8. Higher is "better".
   */
  uint32_t max_dynamic_uniform_buffers_per_pipeline_layout;
  /**
   * Amount of storage buffer bindings that can be dynamic in a single pipeline. Defaults to 4. Higher is "better".
   */
  uint32_t max_dynamic_storage_buffers_per_pipeline_layout;
  /**
   * Amount of sampled textures visible in a single shader stage. Defaults to 16. Higher is "better".
   */
  uint32_t max_sampled_textures_per_shader_stage;
  /**
   * Amount of samplers visible in a single shader stage. Defaults to 16. Higher is "better".
   */
  uint32_t max_samplers_per_shader_stage;
  /**
   * Amount of storage buffers visible in a single shader stage. Defaults to 8. Higher is "better".
   */
  uint32_t max_storage_buffers_per_shader_stage;
  /**
   * Amount of storage textures visible in a single shader stage. Defaults to 8. Higher is "better".
   */
  uint32_t max_storage_textures_per_shader_stage;
  /**
   * Amount of uniform buffers visible in a single shader stage. Defaults to 12. Higher is "better".
   */
  uint32_t max_uniform_buffers_per_shader_stage;
  /**
   * Maximum size in bytes of a binding to a uniform buffer. Defaults to 64 KB. Higher is "better".
   */
  uint32_t max_uniform_buffer_binding_size;
  /**
   * Maximum size in bytes of a binding to a storage buffer. Defaults to 128 MB. Higher is "better".
   */
  uint32_t max_storage_buffer_binding_size;
  /**
   * Maximum length of `VertexState::buffers` when creating a `RenderPipeline`.
   * Defaults to 8. Higher is "better".
   */
  uint32_t max_vertex_buffers;
  /**
   * Maximum length of `VertexBufferLayout::attributes`, summed over all `VertexState::buffers`,
   * when creating a `RenderPipeline`.
   * Defaults to 16. Higher is "better".
   */
  uint32_t max_vertex_attributes;
  /**
   * Maximum value for `VertexBufferLayout::array_stride` when creating a `RenderPipeline`.
   * Defaults to 2048. Higher is "better".
   */
  uint32_t max_vertex_buffer_array_stride;
  /**
   * Amount of storage available for push constants in bytes. Defaults to 0. Higher is "better".
   * Requesting more than 0 during device creation requires [`Features::PUSH_CONSTANTS`] to be enabled.
   *
   * Expect the size to be:
   * - Vulkan: 128-256 bytes
   * - DX12: 256 bytes
   * - Metal: 4096 bytes
   * - DX11 & OpenGL don't natively support push constants, and are emulated with uniforms,
   *   so this number is less useful but likely 256.
   */
  uint32_t max_push_constant_size;
  /**
   * Required `BufferBindingType::Uniform` alignment for `BufferBinding::offset`
   * when creating a `BindGroup`, or for `set_bind_group` `dynamicOffsets`.
   * Defaults to 256. Lower is "better".
   */
  uint32_t min_uniform_buffer_offset_alignment;
  /**
   * Required `BufferBindingType::Storage` alignment for `BufferBinding::offset`
   * when creating a `BindGroup`, or for `set_bind_group` `dynamicOffsets`.
   * Defaults to 256. Lower is "better".
   */
  uint32_t min_storage_buffer_offset_alignment;
  /**
   * Maximum allowed number of components (scalars) of input or output locations for
   * inter-stage communication (vertex outputs to fragment inputs). Defaults to 60.
   */
  uint32_t max_inter_stage_shader_components;
  /**
   * Maximum number of bytes used for workgroup memory in a compute entry point. Defaults to
   * 16352.
   */
  uint32_t max_compute_workgroup_storage_size;
  /**
   * Maximum value of the product of the `workgroup_size` dimensions for a compute entry-point.
   * Defaults to 256.
   */
  uint32_t max_compute_invocations_per_workgroup;
  /**
   * The maximum value of the workgroup_size X dimension for a compute stage `ShaderModule` entry-point.
   * Defaults to 256.
   */
  uint32_t max_compute_workgroup_size_x;
  /**
   * The maximum value of the workgroup_size Y dimension for a compute stage `ShaderModule` entry-point.
   * Defaults to 256.
   */
  uint32_t max_compute_workgroup_size_y;
  /**
   * The maximum value of the workgroup_size Z dimension for a compute stage `ShaderModule` entry-point.
   * Defaults to 64.
   */
  uint32_t max_compute_workgroup_size_z;
  /**
   * The maximum value for each dimension of a `ComputePass::dispatch(x, y, z)` operation.
   * Defaults to 65535.
   */
  uint32_t max_compute_workgroups_per_dimension;
};

/**
 * Features that are not guaranteed to be supported.
 *
 * These are either part of the webgpu standard, or are extension features supported by
 * wgpu when targeting native.
 *
 * If you want to use a feature, you need to first verify that the adapter supports
 * the feature. If the adapter does not support the feature, requesting a device with it enabled
 * will panic.
 *
 * Corresponds to [WebGPU `GPUFeatureName`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gpufeaturename).
 */
typedef uint64_t WGPUFeatures;
/**
 * By default, polygon depth is clipped to 0-1 range before/during rasterization.
 * Anything outside of that range is rejected, and respective fragments are not touched.
 *
 * With this extension, we can disabling clipping. That allows
 * shadow map occluders to be rendered into a tighter depth range.
 *
 * Supported platforms:
 * - desktops
 * - some mobile chips
 *
 * This is a web and native feature.
 */
#define WGPUFeatures_DEPTH_CLIP_CONTROL (uint64_t)(1 << 0)
/**
 * Enables BCn family of compressed textures. All BCn textures use 4x4 pixel blocks
 * with 8 or 16 bytes per block.
 *
 * Compressed textures sacrifice some quality in exchange for significantly reduced
 * bandwidth usage.
 *
 * Support for this feature guarantees availability of [`TextureUsages::COPY_SRC | TextureUsages::COPY_DST | TextureUsages::TEXTURE_BINDING`] for BCn formats.
 * [`Features::TEXTURE_ADAPTER_SPECIFIC_FORMAT_FEATURES`] may enable additional usages.
 *
 * Supported Platforms:
 * - desktops
 *
 * This is a web and native feature.
 */
#define WGPUFeatures_TEXTURE_COMPRESSION_BC (uint64_t)(1 << 1)
/**
 * Allows non-zero value for the "first instance" in indirect draw calls.
 *
 * Supported Platforms:
 * - Vulkan (mostly)
 * - DX12
 * - Metal
 *
 * This is a web and native feature.
 */
#define WGPUFeatures_INDIRECT_FIRST_INSTANCE (uint64_t)(1 << 2)
/**
 * Enables use of Timestamp Queries. These queries tell the current gpu timestamp when
 * all work before the query is finished. Call [`CommandEncoder::write_timestamp`],
 * [`RenderPassEncoder::write_timestamp`], or [`ComputePassEncoder::write_timestamp`] to
 * write out a timestamp.
 *
 * They must be resolved using [`CommandEncoder::resolve_query_sets`] into a buffer,
 * then the result must be multiplied by the timestamp period [`Queue::get_timestamp_period`]
 * to get the timestamp in nanoseconds. Multiple timestamps can then be diffed to get the
 * time for operations between them to finish.
 *
 * Due to wgpu-hal limitations, this is only supported on vulkan for now.
 *
 * Supported Platforms:
 * - Vulkan (works)
 * - DX12 (works)
 *
 * This is a web and native feature.
 */
#define WGPUFeatures_TIMESTAMP_QUERY (uint64_t)(1 << 3)
/**
 * Enables use of Pipeline Statistics Queries. These queries tell the count of various operations
 * performed between the start and stop call. Call [`RenderPassEncoder::begin_pipeline_statistics_query`] to start
 * a query, then call [`RenderPassEncoder::end_pipeline_statistics_query`] to stop one.
 *
 * They must be resolved using [`CommandEncoder::resolve_query_sets`] into a buffer.
 * The rules on how these resolve into buffers are detailed in the documentation for [`PipelineStatisticsTypes`].
 *
 * Due to wgpu-hal limitations, this is only supported on vulkan for now.
 *
 * Supported Platforms:
 * - Vulkan (works)
 * - DX12 (works)
 *
 * This is a web and native feature.
 */
#define WGPUFeatures_PIPELINE_STATISTICS_QUERY (uint64_t)(1 << 4)
/**
 * Allows shaders to acquire the FP16 ability
 *
 * Note: this is not supported in naga yet，only through spir-v passthrough right now.
 *
 * Supported Platforms:
 * - Vulkan
 * - Metal
 *
 * This is a web and native feature.
 */
#define WGPUFeatures_SHADER_FLOAT16 (uint64_t)(1 << 5)
/**
 * Webgpu only allows the MAP_READ and MAP_WRITE buffer usage to be matched with
 * COPY_DST and COPY_SRC respectively. This removes this requirement.
 *
 * This is only beneficial on systems that share memory between CPU and GPU. If enabled
 * on a system that doesn't, this can severely hinder performance. Only use if you understand
 * the consequences.
 *
 * Supported platforms:
 * - All
 *
 * This is a native only feature.
 */
#define WGPUFeatures_MAPPABLE_PRIMARY_BUFFERS (uint64_t)(1 << 16)
/**
 * Allows the user to create uniform arrays of textures in shaders:
 *
 * eg. `uniform texture2D textures[10]`.
 *
 * If [`Features::STORAGE_RESOURCE_BINDING_ARRAY`] is supported as well as this, the user
 * may also create uniform arrays of storage textures.
 *
 * eg. `uniform image2D textures[10]`.
 *
 * This capability allows them to exist and to be indexed by dynamically uniform
 * values.
 *
 * Supported platforms:
 * - DX12
 * - Metal (with MSL 2.0+ on macOS 10.13+)
 * - Vulkan
 *
 * This is a native only feature.
 */
#define WGPUFeatures_TEXTURE_BINDING_ARRAY (uint64_t)(1 << 17)
/**
 * Allows the user to create arrays of buffers in shaders:
 *
 * eg. `uniform myBuffer { .... } buffer_array[10]`.
 *
 * This capability allows them to exist and to be indexed by dynamically uniform
 * values.
 *
 * If [`Features::STORAGE_RESOURCE_BINDING_ARRAY`] is supported as well as this, the user
 * may also create arrays of storage buffers.
 *
 * eg. `buffer myBuffer { ... } buffer_array[10]`
 *
 * Supported platforms:
 * - DX12
 * - Vulkan
 *
 * This is a native only feature.
 */
#define WGPUFeatures_BUFFER_BINDING_ARRAY (uint64_t)(1 << 18)
/**
 * Allows the user to create uniform arrays of storage buffers or textures in shaders,
 * if resp. [`Features::BUFFER_BINDING_ARRAY`] or [`Features::TEXTURE_BINDING_ARRAY`]
 * is supported.
 *
 * This capability allows them to exist and to be indexed by dynamically uniform
 * values.
 *
 * Supported platforms:
 * - Metal (with MSL 2.2+ on macOS 10.13+)
 * - Vulkan
 *
 * This is a native only feature.
 */
#define WGPUFeatures_STORAGE_RESOURCE_BINDING_ARRAY (uint64_t)(1 << 19)
/**
 * Allows shaders to index sampled texture and storage buffer resource arrays with dynamically non-uniform values:
 *
 * eg. `texture_array[vertex_data]`
 *
 * In order to use this capability, the corresponding GLSL extension must be enabled like so:
 *
 * `#extension GL_EXT_nonuniform_qualifier : require`
 *
 * and then used either as `nonuniformEXT` qualifier in variable declaration:
 *
 * eg. `layout(location = 0) nonuniformEXT flat in int vertex_data;`
 *
 * or as `nonuniformEXT` constructor:
 *
 * eg. `texture_array[nonuniformEXT(vertex_data)]`
 *
 * HLSL does not need any extension.
 *
 * Supported platforms:
 * - DX12
 * - Metal (with MSL 2.0+ on macOS 10.13+)
 * - Vulkan 1.2+ (or VK_EXT_descriptor_indexing)'s shaderSampledImageArrayNonUniformIndexing & shaderStorageBufferArrayNonUniformIndexing feature)
 *
 * This is a native only feature.
 */
#define WGPUFeatures_SAMPLED_TEXTURE_AND_STORAGE_BUFFER_ARRAY_NON_UNIFORM_INDEXING (uint64_t)(1 << 20)
/**
 * Allows shaders to index uniform buffer and storage texture resource arrays with dynamically non-uniform values:
 *
 * eg. `texture_array[vertex_data]`
 *
 * In order to use this capability, the corresponding GLSL extension must be enabled like so:
 *
 * `#extension GL_EXT_nonuniform_qualifier : require`
 *
 * and then used either as `nonuniformEXT` qualifier in variable declaration:
 *
 * eg. `layout(location = 0) nonuniformEXT flat in int vertex_data;`
 *
 * or as `nonuniformEXT` constructor:
 *
 * eg. `texture_array[nonuniformEXT(vertex_data)]`
 *
 * HLSL does not need any extension.
 *
 * Supported platforms:
 * - DX12
 * - Metal (with MSL 2.0+ on macOS 10.13+)
 * - Vulkan 1.2+ (or VK_EXT_descriptor_indexing)'s shaderUniformBufferArrayNonUniformIndexing & shaderStorageTextureArrayNonUniformIndexing feature)
 *
 * This is a native only feature.
 */
#define WGPUFeatures_UNIFORM_BUFFER_AND_STORAGE_TEXTURE_ARRAY_NON_UNIFORM_INDEXING (uint64_t)(1 << 21)
/**
 * Allows the user to create bind groups continaing arrays with less bindings than the BindGroupLayout.
 *
 * This is a native only feature.
 */
#define WGPUFeatures_PARTIALLY_BOUND_BINDING_ARRAY (uint64_t)(1 << 22)
/**
 * Allows the user to call [`RenderPass::multi_draw_indirect`] and [`RenderPass::multi_draw_indexed_indirect`].
 *
 * Allows multiple indirect calls to be dispatched from a single buffer.
 *
 * Supported platforms:
 * - DX12
 * - Vulkan
 *
 * This is a native only feature.
 */
#define WGPUFeatures_MULTI_DRAW_INDIRECT (uint64_t)(1 << 23)
/**
 * Allows the user to call [`RenderPass::multi_draw_indirect_count`] and [`RenderPass::multi_draw_indexed_indirect_count`].
 *
 * This allows the use of a buffer containing the actual number of draw calls.
 *
 * Supported platforms:
 * - DX12
 * - Vulkan 1.2+ (or VK_KHR_draw_indirect_count)
 *
 * This is a native only feature.
 */
#define WGPUFeatures_MULTI_DRAW_INDIRECT_COUNT (uint64_t)(1 << 24)
/**
 * Allows the use of push constants: small, fast bits of memory that can be updated
 * inside a [`RenderPass`].
 *
 * Allows the user to call [`RenderPass::set_push_constants`], provide a non-empty array
 * to [`PipelineLayoutDescriptor`], and provide a non-zero limit to [`Limits::max_push_constant_size`].
 *
 * A block of push constants can be declared with `layout(push_constant) uniform Name {..}` in shaders.
 *
 * Supported platforms:
 * - DX12
 * - Vulkan
 * - Metal
 * - DX11 (emulated with uniforms)
 * - OpenGL (emulated with uniforms)
 *
 * This is a native only feature.
 */
#define WGPUFeatures_PUSH_CONSTANTS (uint64_t)(1 << 25)
/**
 * Allows the use of [`AddressMode::ClampToBorder`] with a border color
 * other than [`SamplerBorderColor::Zero`].
 *
 * Supported platforms:
 * - DX12
 * - Vulkan
 * - Metal (macOS 10.12+ only)
 * - DX11
 * - OpenGL
 *
 * This is a web and native feature.
 */
#define WGPUFeatures_ADDRESS_MODE_CLAMP_TO_BORDER (uint64_t)(1 << 26)
/**
 * Allows the user to set [`PolygonMode::Line`] in [`PrimitiveState::polygon_mode`]
 *
 * This allows drawing polygons/triangles as lines (wireframe) instead of filled
 *
 * Supported platforms:
 * - DX12
 * - Vulkan
 * - Metal
 *
 * This is a native only feature.
 */
#define WGPUFeatures_POLYGON_MODE_LINE (uint64_t)(1 << 27)
/**
 * Allows the user to set [`PolygonMode::Point`] in [`PrimitiveState::polygon_mode`]
 *
 * This allows only drawing the vertices of polygons/triangles instead of filled
 *
 * Supported platforms:
 * - DX12
 * - Vulkan
 *
 * This is a native only feature.
 */
#define WGPUFeatures_POLYGON_MODE_POINT (uint64_t)(1 << 28)
/**
 * Enables ETC family of compressed textures. All ETC textures use 4x4 pixel blocks.
 * ETC2 RGB and RGBA1 are 8 bytes per block. RTC2 RGBA8 and EAC are 16 bytes per block.
 *
 * Compressed textures sacrifice some quality in exchange for significantly reduced
 * bandwidth usage.
 *
 * Support for this feature guarantees availability of [`TextureUsages::COPY_SRC | TextureUsages::COPY_DST | TextureUsages::TEXTURE_BINDING`] for ETC2 formats.
 * [`Features::TEXTURE_ADAPTER_SPECIFIC_FORMAT_FEATURES`] may enable additional usages.
 *
 * Supported Platforms:
 * - Intel/Vulkan
 * - Mobile (some)
 *
 * This is a native-only feature.
 */
#define WGPUFeatures_TEXTURE_COMPRESSION_ETC2 (uint64_t)(1 << 29)
/**
 * Enables ASTC family of compressed textures. ASTC textures use pixel blocks varying from 4x4 to 12x12.
 * Blocks are always 16 bytes.
 *
 * Compressed textures sacrifice some quality in exchange for significantly reduced
 * bandwidth usage.
 *
 * Support for this feature guarantees availability of [`TextureUsages::COPY_SRC | TextureUsages::COPY_DST | TextureUsages::TEXTURE_BINDING`] for ASTC formats.
 * [`Features::TEXTURE_ADAPTER_SPECIFIC_FORMAT_FEATURES`] may enable additional usages.
 *
 * Supported Platforms:
 * - Intel/Vulkan
 * - Mobile (some)
 *
 * This is a native-only feature.
 */
#define WGPUFeatures_TEXTURE_COMPRESSION_ASTC_LDR (uint64_t)(1 << 30)
/**
 * Enables device specific texture format features.
 *
 * See `TextureFormatFeatures` for a listing of the features in question.
 *
 * By default only texture format properties as defined by the WebGPU specification are allowed.
 * Enabling this feature flag extends the features of each format to the ones supported by the current device.
 * Note that without this flag, read/write storage access is not allowed at all.
 *
 * This extension does not enable additional formats.
 *
 * This is a native-only feature.
 */
#define WGPUFeatures_TEXTURE_ADAPTER_SPECIFIC_FORMAT_FEATURES (uint64_t)(1 << 31)
/**
 * Enables 64-bit floating point types in SPIR-V shaders.
 *
 * Note: even when supported by GPU hardware, 64-bit floating point operations are
 * frequently between 16 and 64 _times_ slower than equivalent operations on 32-bit floats.
 *
 * Supported Platforms:
 * - Vulkan
 *
 * This is a native-only feature.
 */
#define WGPUFeatures_SHADER_FLOAT64 (uint64_t)(1 << 32)
/**
 * Enables using 64-bit types for vertex attributes.
 *
 * Requires SHADER_FLOAT64.
 *
 * Supported Platforms: N/A
 *
 * This is a native-only feature.
 */
#define WGPUFeatures_VERTEX_ATTRIBUTE_64BIT (uint64_t)(1 << 33)
/**
 * Allows the user to set a overestimation-conservative-rasterization in [`PrimitiveState::conservative`]
 *
 * Processing of degenerate triangles/lines is hardware specific.
 * Only triangles are supported.
 *
 * Supported platforms:
 * - Vulkan
 *
 * This is a native only feature.
 */
#define WGPUFeatures_CONSERVATIVE_RASTERIZATION (uint64_t)(1 << 34)
/**
 * Enables bindings of writable storage buffers and textures visible to vertex shaders.
 *
 * Note: some (tiled-based) platforms do not support vertex shaders with any side-effects.
 *
 * Supported Platforms:
 * - All
 *
 * This is a native-only feature.
 */
#define WGPUFeatures_VERTEX_WRITABLE_STORAGE (uint64_t)(1 << 35)
/**
 * Enables clear to zero for textures.
 *
 * Supported platforms:
 * - All
 *
 * This is a native only feature.
 */
#define WGPUFeatures_CLEAR_TEXTURE (uint64_t)(1 << 36)
/**
 * Enables creating shader modules from SPIR-V binary data (unsafe).
 *
 * SPIR-V data is not parsed or interpreted in any way; you can use
 * [`wgpu::make_spirv_raw!`] to check for alignment and magic number when converting from
 * raw bytes.
 *
 * Supported platforms:
 * - Vulkan, in case shader's requested capabilities and extensions agree with
 * Vulkan implementation.
 *
 * This is a native only feature.
 */
#define WGPUFeatures_SPIRV_SHADER_PASSTHROUGH (uint64_t)(1 << 37)
/**
 * Enables `builtin(primitive_index)` in fragment shaders.
 *
 * Note: enables geometry processing for pipelines using the builtin.
 * This may come with a significant performance impact on some hardware.
 * Other pipelines are not affected.
 *
 * Supported platforms:
 * - Vulkan
 *
 * This is a native only feature.
 */
#define WGPUFeatures_SHADER_PRIMITIVE_INDEX (uint64_t)(1 << 38)
/**
 * Enables multiview render passes and `builtin(view_index)` in vertex shaders.
 *
 * Supported platforms:
 * - Vulkan
 *
 * This is a native only feature.
 */
#define WGPUFeatures_MULTIVIEW (uint64_t)(1 << 39)
/**
 * Enables normalized `16-bit` texture formats.
 *
 * Supported platforms:
 * - Vulkan
 * - DX12
 * - Metal
 *
 * This is a native only feature.
 */
#define WGPUFeatures_TEXTURE_FORMAT_16BIT_NORM (uint64_t)(1 << 40)
/**
 * Allows the use of [`AddressMode::ClampToBorder`] with a border color
 * of [`SamplerBorderColor::Zero`].
 *
 * Supported platforms:
 * - DX12
 * - Vulkan
 * - Metal
 * - DX11
 * - OpenGL
 *
 * This is a native only feature.
 */
#define WGPUFeatures_ADDRESS_MODE_CLAMP_TO_ZERO (uint64_t)(1 << 41)
/**
 * Supported Platforms:
 * - Metal
 *
 * This is a native-only feature.
 */
#define WGPUFeatures_TEXTURE_COMPRESSION_ASTC_HDR (uint64_t)(1 << 42)

struct WGPUAdapterInformation {
  WGPUAdapterId id;
  WGPUDeviceType ty;
  struct WGPULimits limits;
  WGPUFeatures features;
};

typedef const char *WGPURawString;

/**
 * Describes a [`Device`](../wgpu/struct.Device.html).
 *
 * Corresponds to [WebGPU `GPUDeviceDescriptor`](
 * https://gpuweb.github.io/gpuweb/#gpudevicedescriptor).
 */
struct WGPUDeviceDescriptor {
  /**
   * Debug label for the device.
   */
  WGPURawString label;
  /**
   * Features that the device should support. If any feature is not supported by
   * the adapter, creating a device will panic.
   */
  WGPUFeatures features;
  /**
   * Limits that the device should support. If any limit is "better" than the limit exposed by
   * the adapter, creating a device will panic.
   */
  struct WGPULimits limits;
};

typedef WGPUNonZeroId WGPUId_Buffer_Dummy;

typedef WGPUId_Buffer_Dummy WGPUBufferId;

/**
 * Integral type used for buffer offsets.
 */
typedef uint64_t WGPUBufferAddress;

/**
 * Different ways that you can use a buffer.
 *
 * The usages determine what kind of memory the buffer is allocated from and what
 * actions the buffer can partake in.
 *
 * Corresponds to [WebGPU `GPUBufferUsageFlags`](
 * https://gpuweb.github.io/gpuweb/#typedefdef-gpubufferusageflags).
 */
typedef uint32_t WGPUBufferUsages;
/**
 * Allow a buffer to be mapped for reading using [`Buffer::map_async`] + [`Buffer::get_mapped_range`].
 * This does not include creating a buffer with [`BufferDescriptor::mapped_at_creation`] set.
 *
 * If [`Features::MAPPABLE_PRIMARY_BUFFERS`] isn't enabled, the only other usage a buffer
 * may have is COPY_DST.
 */
#define WGPUBufferUsages_MAP_READ (uint32_t)(1 << 0)
/**
 * Allow a buffer to be mapped for writing using [`Buffer::map_async`] + [`Buffer::get_mapped_range_mut`].
 * This does not include creating a buffer with `mapped_at_creation` set.
 *
 * If [`Features::MAPPABLE_PRIMARY_BUFFERS`] feature isn't enabled, the only other usage a buffer
 * may have is COPY_SRC.
 */
#define WGPUBufferUsages_MAP_WRITE (uint32_t)(1 << 1)
/**
 * Allow a buffer to be the source buffer for a [`CommandEncoder::copy_buffer_to_buffer`] or [`CommandEncoder::copy_buffer_to_texture`]
 * operation.
 */
#define WGPUBufferUsages_COPY_SRC (uint32_t)(1 << 2)
/**
 * Allow a buffer to be the destination buffer for a [`CommandEncoder::copy_buffer_to_buffer`], [`CommandEncoder::copy_texture_to_buffer`],
 * [`CommandEncoder::clear_buffer`] or [`Queue::write_buffer`] operation.
 */
#define WGPUBufferUsages_COPY_DST (uint32_t)(1 << 3)
/**
 * Allow a buffer to be the index buffer in a draw operation.
 */
#define WGPUBufferUsages_INDEX (uint32_t)(1 << 4)
/**
 * Allow a buffer to be the vertex buffer in a draw operation.
 */
#define WGPUBufferUsages_VERTEX (uint32_t)(1 << 5)
/**
 * Allow a buffer to be a [`BufferBindingType::Uniform`] inside a bind group.
 */
#define WGPUBufferUsages_UNIFORM (uint32_t)(1 << 6)
/**
 * Allow a buffer to be a [`BufferBindingType::Storage`] inside a bind group.
 */
#define WGPUBufferUsages_STORAGE (uint32_t)(1 << 7)
/**
 * Allow a buffer to be the indirect buffer in an indirect draw call.
 */
#define WGPUBufferUsages_INDIRECT (uint32_t)(1 << 8)

/**
 * Describes a [`Buffer`](../wgpu/struct.Buffer.html).
 *
 * Corresponds to [WebGPU `GPUBufferDescriptor`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpubufferdescriptor).
 */
struct WGPUBufferDescriptor {
  /**
   * Debug label of a buffer. This will show up in graphics debuggers for easy identification.
   */
  WGPURawString label;
  /**
   * Size of a buffer.
   */
  WGPUBufferAddress size;
  /**
   * Usages of a buffer. If the buffer is used in any way that isn't specified here, the operation
   * will panic.
   */
  WGPUBufferUsages usage;
  /**
   * Allows a buffer to be mapped immediately after they are made. It does not have to be [`BufferUsages::MAP_READ`] or
   * [`BufferUsages::MAP_WRITE`], all buffers are allowed to be mapped at creation.
   */
  bool mapped_at_creation;
};

typedef WGPUNonZeroId WGPUId_Texture_Dummy;

typedef WGPUId_Texture_Dummy WGPUTextureId;

/**
 * Extent of a texture related operation.
 *
 * Corresponds to [WebGPU `GPUExtent3D`](
 * https://gpuweb.github.io/gpuweb/#typedefdef-gpuextent3d).
 */
struct WGPUExtent3d {
  /**
   *
   */
  uint32_t width;
  /**
   *
   */
  uint32_t height;
  /**
   *
   */
  uint32_t depth_or_array_layers;
};

/**
 * Underlying texture data format.
 *
 * If there is a conversion in the format (such as srgb -> linear), the conversion listed here is for
 * loading from texture in a shader. When writing to the texture, the opposite conversion takes place.
 *
 * Corresponds to [WebGPU `GPUTextureFormat`](
 * https://gpuweb.github.io/gpuweb/#enumdef-gputextureformat).
 */
enum WGPUTextureFormat_Tag {
  /**
   * Red channel only. 8 bit integer per channel. [0, 255] converted to/from float [0, 1] in shader.
   */
  WGPUTextureFormat_R8Unorm,
  /**
   * Red channel only. 8 bit integer per channel. [-127, 127] converted to/from float [-1, 1] in shader.
   */
  WGPUTextureFormat_R8Snorm,
  /**
   * Red channel only. 8 bit integer per channel. Unsigned in shader.
   */
  WGPUTextureFormat_R8Uint,
  /**
   * Red channel only. 8 bit integer per channel. Signed in shader.
   */
  WGPUTextureFormat_R8Sint,
  /**
   * Red channel only. 16 bit integer per channel. Unsigned in shader.
   */
  WGPUTextureFormat_R16Uint,
  /**
   * Red channel only. 16 bit integer per channel. Signed in shader.
   */
  WGPUTextureFormat_R16Sint,
  /**
   * Red channel only. 16 bit integer per channel. [0, 65535] converted to/from float [0, 1] in shader.
   *
   * [`Features::TEXTURE_FORMAT_16BIT_NORM`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_R16Unorm,
  /**
   * Red channel only. 16 bit integer per channel. [0, 65535] converted to/from float [-1, 1] in shader.
   *
   * [`Features::TEXTURE_FORMAT_16BIT_NORM`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_R16Snorm,
  /**
   * Red channel only. 16 bit float per channel. Float in shader.
   */
  WGPUTextureFormat_R16Float,
  /**
   * Red and green channels. 8 bit integer per channel. [0, 255] converted to/from float [0, 1] in shader.
   */
  WGPUTextureFormat_Rg8Unorm,
  /**
   * Red and green channels. 8 bit integer per channel. [-127, 127] converted to/from float [-1, 1] in shader.
   */
  WGPUTextureFormat_Rg8Snorm,
  /**
   * Red and green channels. 8 bit integer per channel. Unsigned in shader.
   */
  WGPUTextureFormat_Rg8Uint,
  /**
   * Red and green channels. 8 bit integer per channel. Signed in shader.
   */
  WGPUTextureFormat_Rg8Sint,
  /**
   * Red channel only. 32 bit integer per channel. Unsigned in shader.
   */
  WGPUTextureFormat_R32Uint,
  /**
   * Red channel only. 32 bit integer per channel. Signed in shader.
   */
  WGPUTextureFormat_R32Sint,
  /**
   * Red channel only. 32 bit float per channel. Float in shader.
   */
  WGPUTextureFormat_R32Float,
  /**
   * Red and green channels. 16 bit integer per channel. Unsigned in shader.
   */
  WGPUTextureFormat_Rg16Uint,
  /**
   * Red and green channels. 16 bit integer per channel. Signed in shader.
   */
  WGPUTextureFormat_Rg16Sint,
  /**
   * Red and green channels. 16 bit integer per channel. [0, 65535] converted to/from float [0, 1] in shader.
   *
   * [`Features::TEXTURE_FORMAT_16BIT_NORM`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Rg16Unorm,
  /**
   * Red and green channels. 16 bit integer per channel. [0, 65535] converted to/from float [-1, 1] in shader.
   *
   * [`Features::TEXTURE_FORMAT_16BIT_NORM`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Rg16Snorm,
  /**
   * Red and green channels. 16 bit float per channel. Float in shader.
   */
  WGPUTextureFormat_Rg16Float,
  /**
   * Red, green, blue, and alpha channels. 8 bit integer per channel. [0, 255] converted to/from float [0, 1] in shader.
   */
  WGPUTextureFormat_Rgba8Unorm,
  /**
   * Red, green, blue, and alpha channels. 8 bit integer per channel. Srgb-color [0, 255] converted to/from linear-color float [0, 1] in shader.
   */
  WGPUTextureFormat_Rgba8UnormSrgb,
  /**
   * Red, green, blue, and alpha channels. 8 bit integer per channel. [-127, 127] converted to/from float [-1, 1] in shader.
   */
  WGPUTextureFormat_Rgba8Snorm,
  /**
   * Red, green, blue, and alpha channels. 8 bit integer per channel. Unsigned in shader.
   */
  WGPUTextureFormat_Rgba8Uint,
  /**
   * Red, green, blue, and alpha channels. 8 bit integer per channel. Signed in shader.
   */
  WGPUTextureFormat_Rgba8Sint,
  /**
   * Blue, green, red, and alpha channels. 8 bit integer per channel. [0, 255] converted to/from float [0, 1] in shader.
   */
  WGPUTextureFormat_Bgra8Unorm,
  /**
   * Blue, green, red, and alpha channels. 8 bit integer per channel. Srgb-color [0, 255] converted to/from linear-color float [0, 1] in shader.
   */
  WGPUTextureFormat_Bgra8UnormSrgb,
  /**
   * Red, green, blue, and alpha channels. 10 bit integer for RGB channels, 2 bit integer for alpha channel. [0, 1023] ([0, 3] for alpha) converted to/from float [0, 1] in shader.
   */
  WGPUTextureFormat_Rgb10a2Unorm,
  /**
   * Red, green, and blue channels. 11 bit float with no sign bit for RG channels. 10 bit float with no sign bit for blue channel. Float in shader.
   */
  WGPUTextureFormat_Rg11b10Float,
  /**
   * Red and green channels. 32 bit integer per channel. Unsigned in shader.
   */
  WGPUTextureFormat_Rg32Uint,
  /**
   * Red and green channels. 32 bit integer per channel. Signed in shader.
   */
  WGPUTextureFormat_Rg32Sint,
  /**
   * Red and green channels. 32 bit float per channel. Float in shader.
   */
  WGPUTextureFormat_Rg32Float,
  /**
   * Red, green, blue, and alpha channels. 16 bit integer per channel. Unsigned in shader.
   */
  WGPUTextureFormat_Rgba16Uint,
  /**
   * Red, green, blue, and alpha channels. 16 bit integer per channel. Signed in shader.
   */
  WGPUTextureFormat_Rgba16Sint,
  /**
   * Red, green, blue, and alpha channels. 16 bit integer per channel. [0, 65535] converted to/from float [0, 1] in shader.
   *
   * [`Features::TEXTURE_FORMAT_16BIT_NORM`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Rgba16Unorm,
  /**
   * Red, green, blue, and alpha. 16 bit integer per channel. [0, 65535] converted to/from float [-1, 1] in shader.
   *
   * [`Features::TEXTURE_FORMAT_16BIT_NORM`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Rgba16Snorm,
  /**
   * Red, green, blue, and alpha channels. 16 bit float per channel. Float in shader.
   */
  WGPUTextureFormat_Rgba16Float,
  /**
   * Red, green, blue, and alpha channels. 32 bit integer per channel. Unsigned in shader.
   */
  WGPUTextureFormat_Rgba32Uint,
  /**
   * Red, green, blue, and alpha channels. 32 bit integer per channel. Signed in shader.
   */
  WGPUTextureFormat_Rgba32Sint,
  /**
   * Red, green, blue, and alpha channels. 32 bit float per channel. Float in shader.
   */
  WGPUTextureFormat_Rgba32Float,
  /**
   * Special depth format with 32 bit floating point depth.
   */
  WGPUTextureFormat_Depth32Float,
  /**
   * Special depth format with at least 24 bit integer depth.
   */
  WGPUTextureFormat_Depth24Plus,
  /**
   * Special depth/stencil format with at least 24 bit integer depth and 8 bits integer stencil.
   */
  WGPUTextureFormat_Depth24PlusStencil8,
  /**
   * Packed unsigned float with 9 bits mantisa for each RGB component, then a common 5 bits exponent
   */
  WGPUTextureFormat_Rgb9e5Ufloat,
  /**
   * 4x4 block compressed texture. 8 bytes per block (4 bit/px). 4 color + alpha pallet. 5 bit R + 6 bit G + 5 bit B + 1 bit alpha.
   * [0, 63] ([0, 1] for alpha) converted to/from float [0, 1] in shader.
   *
   * Also known as DXT1.
   *
   * [`Features::TEXTURE_COMPRESSION_BC`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Bc1RgbaUnorm,
  /**
   * 4x4 block compressed texture. 8 bytes per block (4 bit/px). 4 color + alpha pallet. 5 bit R + 6 bit G + 5 bit B + 1 bit alpha.
   * Srgb-color [0, 63] ([0, 1] for alpha) converted to/from linear-color float [0, 1] in shader.
   *
   * Also known as DXT1.
   *
   * [`Features::TEXTURE_COMPRESSION_BC`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Bc1RgbaUnormSrgb,
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px). 4 color pallet. 5 bit R + 6 bit G + 5 bit B + 4 bit alpha.
   * [0, 63] ([0, 15] for alpha) converted to/from float [0, 1] in shader.
   *
   * Also known as DXT3.
   *
   * [`Features::TEXTURE_COMPRESSION_BC`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Bc2RgbaUnorm,
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px). 4 color pallet. 5 bit R + 6 bit G + 5 bit B + 4 bit alpha.
   * Srgb-color [0, 63] ([0, 255] for alpha) converted to/from linear-color float [0, 1] in shader.
   *
   * Also known as DXT3.
   *
   * [`Features::TEXTURE_COMPRESSION_BC`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Bc2RgbaUnormSrgb,
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px). 4 color pallet + 8 alpha pallet. 5 bit R + 6 bit G + 5 bit B + 8 bit alpha.
   * [0, 63] ([0, 255] for alpha) converted to/from float [0, 1] in shader.
   *
   * Also known as DXT5.
   *
   * [`Features::TEXTURE_COMPRESSION_BC`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Bc3RgbaUnorm,
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px). 4 color pallet + 8 alpha pallet. 5 bit R + 6 bit G + 5 bit B + 8 bit alpha.
   * Srgb-color [0, 63] ([0, 255] for alpha) converted to/from linear-color float [0, 1] in shader.
   *
   * Also known as DXT5.
   *
   * [`Features::TEXTURE_COMPRESSION_BC`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Bc3RgbaUnormSrgb,
  /**
   * 4x4 block compressed texture. 8 bytes per block (4 bit/px). 8 color pallet. 8 bit R.
   * [0, 255] converted to/from float [0, 1] in shader.
   *
   * Also known as RGTC1.
   *
   * [`Features::TEXTURE_COMPRESSION_BC`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Bc4RUnorm,
  /**
   * 4x4 block compressed texture. 8 bytes per block (4 bit/px). 8 color pallet. 8 bit R.
   * [-127, 127] converted to/from float [-1, 1] in shader.
   *
   * Also known as RGTC1.
   *
   * [`Features::TEXTURE_COMPRESSION_BC`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Bc4RSnorm,
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px). 8 color red pallet + 8 color green pallet. 8 bit RG.
   * [0, 255] converted to/from float [0, 1] in shader.
   *
   * Also known as RGTC2.
   *
   * [`Features::TEXTURE_COMPRESSION_BC`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Bc5RgUnorm,
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px). 8 color red pallet + 8 color green pallet. 8 bit RG.
   * [-127, 127] converted to/from float [-1, 1] in shader.
   *
   * Also known as RGTC2.
   *
   * [`Features::TEXTURE_COMPRESSION_BC`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Bc5RgSnorm,
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px). Variable sized pallet. 16 bit unsigned float RGB. Float in shader.
   *
   * Also known as BPTC (float).
   *
   * [`Features::TEXTURE_COMPRESSION_BC`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Bc6hRgbUfloat,
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px). Variable sized pallet. 16 bit signed float RGB. Float in shader.
   *
   * Also known as BPTC (float).
   *
   * [`Features::TEXTURE_COMPRESSION_BC`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Bc6hRgbSfloat,
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px). Variable sized pallet. 8 bit integer RGBA.
   * [0, 255] converted to/from float [0, 1] in shader.
   *
   * Also known as BPTC (unorm).
   *
   * [`Features::TEXTURE_COMPRESSION_BC`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Bc7RgbaUnorm,
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px). Variable sized pallet. 8 bit integer RGBA.
   * Srgb-color [0, 255] converted to/from linear-color float [0, 1] in shader.
   *
   * Also known as BPTC (unorm).
   *
   * [`Features::TEXTURE_COMPRESSION_BC`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Bc7RgbaUnormSrgb,
  /**
   * 4x4 block compressed texture. 8 bytes per block (4 bit/px). Complex pallet. 8 bit integer RGB.
   * [0, 255] converted to/from float [0, 1] in shader.
   *
   * [`Features::TEXTURE_COMPRESSION_ETC2`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Etc2Rgb8Unorm,
  /**
   * 4x4 block compressed texture. 8 bytes per block (4 bit/px). Complex pallet. 8 bit integer RGB.
   * Srgb-color [0, 255] converted to/from linear-color float [0, 1] in shader.
   *
   * [`Features::TEXTURE_COMPRESSION_ETC2`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Etc2Rgb8UnormSrgb,
  /**
   * 4x4 block compressed texture. 8 bytes per block (4 bit/px). Complex pallet. 8 bit integer RGB + 1 bit alpha.
   * [0, 255] ([0, 1] for alpha) converted to/from float [0, 1] in shader.
   *
   * [`Features::TEXTURE_COMPRESSION_ETC2`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Etc2Rgb8A1Unorm,
  /**
   * 4x4 block compressed texture. 8 bytes per block (4 bit/px). Complex pallet. 8 bit integer RGB + 1 bit alpha.
   * Srgb-color [0, 255] ([0, 1] for alpha) converted to/from linear-color float [0, 1] in shader.
   *
   * [`Features::TEXTURE_COMPRESSION_ETC2`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Etc2Rgb8A1UnormSrgb,
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px). Complex pallet. 8 bit integer RGB + 8 bit alpha.
   * [0, 255] converted to/from float [0, 1] in shader.
   *
   * [`Features::TEXTURE_COMPRESSION_ETC2`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Etc2Rgba8Unorm,
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px). Complex pallet. 8 bit integer RGB + 8 bit alpha.
   * Srgb-color [0, 255] converted to/from linear-color float [0, 1] in shader.
   *
   * [`Features::TEXTURE_COMPRESSION_ETC2`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_Etc2Rgba8UnormSrgb,
  /**
   * 4x4 block compressed texture. 8 bytes per block (4 bit/px). Complex pallet. 11 bit integer R.
   * [0, 255] converted to/from float [0, 1] in shader.
   *
   * [`Features::TEXTURE_COMPRESSION_ETC2`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_EacR11Unorm,
  /**
   * 4x4 block compressed texture. 8 bytes per block (4 bit/px). Complex pallet. 11 bit integer R.
   * [-127, 127] converted to/from float [-1, 1] in shader.
   *
   * [`Features::TEXTURE_COMPRESSION_ETC2`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_EacR11Snorm,
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px). Complex pallet. 11 bit integer R + 11 bit integer G.
   * [0, 255] converted to/from float [0, 1] in shader.
   *
   * [`Features::TEXTURE_COMPRESSION_ETC2`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_EacRg11Unorm,
  /**
   * 4x4 block compressed texture. 16 bytes per block (8 bit/px). Complex pallet. 11 bit integer R + 11 bit integer G.
   * [-127, 127] converted to/from float [-1, 1] in shader.
   *
   * [`Features::TEXTURE_COMPRESSION_ETC2`] must be enabled to use this texture format.
   */
  WGPUTextureFormat_EacRg11Snorm,
  /**
   * block compressed texture. 16 bytes per block.
   *
   * Features [`TEXTURE_COMPRESSION_ASTC_LDR`] or [`TEXTURE_COMPRESSION_ASTC_HDR`]
   * must be enabled to use this texture format.
   *
   * [`TEXTURE_COMPRESSION_ASTC_LDR`]: Features::TEXTURE_COMPRESSION_ASTC_LDR
   * [`TEXTURE_COMPRESSION_ASTC_HDR`]: Features::TEXTURE_COMPRESSION_ASTC_HDR
   */
  WGPUTextureFormat_Astc,
  /**
   * Must be last for serialization purposes
   */
  WGPUTextureFormat_Sentinel,
};

struct WGPUTextureFormat_WGPUAstc_Body {
  /**
   * compressed block dimensions
   */
  enum WGPUAstcBlock block;
  /**
   *
   */
  enum WGPUAstcChannel channel;
};

struct WGPUTextureFormat {
  enum WGPUTextureFormat_Tag tag;
  union {
    struct WGPUTextureFormat_WGPUAstc_Body astc;
  };
};

/**
 * Different ways that you can use a texture.
 *
 * The usages determine what kind of memory the texture is allocated from and what
 * actions the texture can partake in.
 *
 * Corresponds to [WebGPU `GPUTextureUsageFlags`](
 * https://gpuweb.github.io/gpuweb/#typedefdef-gputextureusageflags).
 */
typedef uint32_t WGPUTextureUsages;
/**
 * Allows a texture to be the source in a [`CommandEncoder::copy_texture_to_buffer`] or
 * [`CommandEncoder::copy_texture_to_texture`] operation.
 */
#define WGPUTextureUsages_COPY_SRC (uint32_t)(1 << 0)
/**
 * Allows a texture to be the destination in a  [`CommandEncoder::copy_buffer_to_texture`],
 * [`CommandEncoder::copy_texture_to_texture`], or [`Queue::write_texture`] operation.
 */
#define WGPUTextureUsages_COPY_DST (uint32_t)(1 << 1)
/**
 * Allows a texture to be a [`BindingType::Texture`] in a bind group.
 */
#define WGPUTextureUsages_TEXTURE_BINDING (uint32_t)(1 << 2)
/**
 * Allows a texture to be a [`BindingType::StorageTexture`] in a bind group.
 */
#define WGPUTextureUsages_STORAGE_BINDING (uint32_t)(1 << 3)
/**
 * Allows a texture to be an output attachment of a renderpass.
 */
#define WGPUTextureUsages_RENDER_ATTACHMENT (uint32_t)(1 << 4)

/**
 * Describes a [`Texture`](../wgpu/struct.Texture.html).
 *
 * Corresponds to [WebGPU `GPUTextureDescriptor`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gputexturedescriptor).
 */
struct WGPUTextureDescriptor {
  /**
   * Debug label of the texture. This will show up in graphics debuggers for easy identification.
   */
  WGPURawString label;
  /**
   * Size of the texture. All components must be greater than zero. For a
   * regular 1D/2D texture, the unused sizes will be 1. For 2DArray textures,
   * Z is the number of 2D textures in that array.
   */
  struct WGPUExtent3d size;
  /**
   * Mip count of texture. For a texture with no extra mips, this must be 1.
   */
  uint32_t mip_level_count;
  /**
   * Sample count of texture. If this is not 1, texture must have [`BindingType::Texture::multisampled`] set to true.
   */
  uint32_t sample_count;
  /**
   * Dimensions of the texture.
   */
  enum WGPUTextureDimension dimension;
  /**
   * Format of the texture.
   */
  struct WGPUTextureFormat format;
  /**
   * Allowed usages of the texture. If used in other ways, the operation will panic.
   */
  WGPUTextureUsages usage;
};

typedef WGPUNonZeroId WGPUId_TextureView_Dummy;

typedef WGPUId_TextureView_Dummy WGPUTextureViewId;

struct WGPUTextureViewDescriptor {
  WGPURawString label;
  const struct WGPUTextureFormat *format;
  const enum WGPUTextureViewDimension *dimension;
  enum WGPUTextureAspect aspect;
  uint32_t base_mip_level;
  uint32_t mip_level_count;
  uint32_t base_array_layer;
  uint32_t array_layer_count;
};

typedef WGPUNonZeroId WGPUId_Sampler_Dummy;

typedef WGPUId_Sampler_Dummy WGPUSamplerId;

struct WGPUSamplerDescriptor {
  WGPURawString label;
  enum WGPUAddressMode address_modes[3];
  enum WGPUFilterMode mag_filter;
  enum WGPUFilterMode min_filter;
  enum WGPUFilterMode mipmap_filter;
  float lod_min_clamp;
  float lod_max_clamp;
  const enum WGPUCompareFunction *compare;
  uint8_t anisotropy_clamp;
};

typedef WGPUNonZeroId WGPUId_CommandBuffer_Dummy;

typedef WGPUId_CommandBuffer_Dummy WGPUCommandBufferId;

typedef WGPUCommandBufferId WGPUCommandEncoderId;

/**
 * Describes a [`CommandEncoder`](../wgpu/struct.CommandEncoder.html).
 *
 * Corresponds to [WebGPU `GPUCommandEncoderDescriptor`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpucommandencoderdescriptor).
 */
struct WGPUCommandEncoderDescriptor {
  /**
   * Debug label for the command encoder. This will show up in graphics debuggers for easy identification.
   */
  WGPURawString label;
};

struct WGPURenderBundleEncoderDescriptor {
  WGPURawString label;
  const struct WGPUTextureFormat *color_formats;
  uintptr_t color_formats_length;
  const struct WGPUTextureFormat *depth_stencil_format;
  bool depth_read_only;
  bool stencil_read_only;
  uint32_t sample_count;
};

typedef WGPUNonZeroId WGPUId_RenderBundle;

typedef WGPUId_RenderBundle WGPURenderBundleId;

/**
 * Describes a [`RenderBundle`](../wgpu/struct.RenderBundle.html).
 *
 * Corresponds to [WebGPU `GPURenderBundleDescriptor`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpurenderbundledescriptor).
 */
struct WGPURenderBundleDescriptor {
  /**
   * Debug label of the render bundle encoder. This will show up in graphics debuggers for easy identification.
   */
  WGPURawString label;
};

struct WGPUComputePassDescriptor {
  WGPURawString label;
};

/**
 * RGBA double precision color.
 *
 * This is not to be used as a generic color type, only for specific wgpu interfaces.
 */
struct WGPUColor {
  /**
   *
   */
  double r;
  /**
   *
   */
  double g;
  /**
   *
   */
  double b;
  /**
   *
   */
  double a;
};
#define WGPUColor_TRANSPARENT (WGPUColor){ .r = 0.0, .g = 0.0, .b = 0.0, .a = 0.0 }
#define WGPUColor_BLACK (WGPUColor){ .r = 0.0, .g = 0.0, .b = 0.0, .a = 1.0 }
#define WGPUColor_WHITE (WGPUColor){ .r = 1.0, .g = 1.0, .b = 1.0, .a = 1.0 }
#define WGPUColor_RED (WGPUColor){ .r = 1.0, .g = 0.0, .b = 0.0, .a = 1.0 }
#define WGPUColor_GREEN (WGPUColor){ .r = 0.0, .g = 1.0, .b = 0.0, .a = 1.0 }
#define WGPUColor_BLUE (WGPUColor){ .r = 0.0, .g = 0.0, .b = 1.0, .a = 1.0 }

/**
 * Describes an individual channel within a render pass, such as color, depth, or stencil.
 */
struct WGPUPassChannel_Color {
  /**
   * Operation to perform to the output attachment at the start of a renderpass. This must be clear if it
   * is the first renderpass rendering to a swap chain image.
   */
  enum WGPULoadOp load_op;
  /**
   * Operation to perform to the output attachment at the end of a renderpass.
   */
  enum WGPUStoreOp store_op;
  /**
   * If load_op is [`LoadOp::Clear`], the attachment will be cleared to this color.
   */
  struct WGPUColor clear_value;
  /**
   * If true, the relevant channel is not changed by a renderpass, and the corresponding attachment
   * can be used inside the pass by other read-only usages.
   */
  bool read_only;
};

/**
 * Describes a color attachment to a render pass.
 */
struct WGPURenderPassColorAttachment {
  /**
   * The view to use as an attachment.
   */
  WGPUTextureViewId view;
  /**
   * The view that will receive the resolved output if multisampling is used.
   */
  WGPUOption_TextureViewId resolve_target;
  /**
   * What operations will be performed on this color attachment.
   */
  struct WGPUPassChannel_Color channel;
};

/**
 * Describes an individual channel within a render pass, such as color, depth, or stencil.
 */
struct WGPUPassChannel_f32 {
  /**
   * Operation to perform to the output attachment at the start of a renderpass. This must be clear if it
   * is the first renderpass rendering to a swap chain image.
   */
  enum WGPULoadOp load_op;
  /**
   * Operation to perform to the output attachment at the end of a renderpass.
   */
  enum WGPUStoreOp store_op;
  /**
   * If load_op is [`LoadOp::Clear`], the attachment will be cleared to this color.
   */
  float clear_value;
  /**
   * If true, the relevant channel is not changed by a renderpass, and the corresponding attachment
   * can be used inside the pass by other read-only usages.
   */
  bool read_only;
};

/**
 * Describes an individual channel within a render pass, such as color, depth, or stencil.
 */
struct WGPUPassChannel_u32 {
  /**
   * Operation to perform to the output attachment at the start of a renderpass. This must be clear if it
   * is the first renderpass rendering to a swap chain image.
   */
  enum WGPULoadOp load_op;
  /**
   * Operation to perform to the output attachment at the end of a renderpass.
   */
  enum WGPUStoreOp store_op;
  /**
   * If load_op is [`LoadOp::Clear`], the attachment will be cleared to this color.
   */
  uint32_t clear_value;
  /**
   * If true, the relevant channel is not changed by a renderpass, and the corresponding attachment
   * can be used inside the pass by other read-only usages.
   */
  bool read_only;
};

/**
 * Describes a depth/stencil attachment to a render pass.
 */
struct WGPURenderPassDepthStencilAttachment {
  /**
   * The view to use as an attachment.
   */
  WGPUTextureViewId view;
  /**
   * What operations will be performed on the depth part of the attachment.
   */
  struct WGPUPassChannel_f32 depth;
  /**
   * What operations will be performed on the stencil part of the attachment.
   */
  struct WGPUPassChannel_u32 stencil;
};

struct WGPURenderPassDescriptor {
  WGPURawString label;
  const struct WGPURenderPassColorAttachment *color_attachments;
  uintptr_t color_attachments_length;
  const struct WGPURenderPassDepthStencilAttachment *depth_stencil_attachment;
};

typedef WGPUNonZeroId WGPUId_BindGroupLayout_Dummy;

typedef WGPUId_BindGroupLayout_Dummy WGPUBindGroupLayoutId;

/**
 * Describes the shader stages that a binding will be visible from.
 *
 * These can be combined so something that is visible from both vertex and fragment shaders can be defined as:
 *
 * `ShaderStages::VERTEX | ShaderStages::FRAGMENT`
 *
 * Corresponds to [WebGPU `GPUShaderStageFlags`](
 * https://gpuweb.github.io/gpuweb/#typedefdef-gpushaderstageflags).
 */
typedef uint32_t WGPUShaderStages;
/**
 * Binding is not visible from any shader stage.
 */
#define WGPUShaderStages_NONE (uint32_t)0
/**
 * Binding is visible from the vertex shader of a render pipeline.
 */
#define WGPUShaderStages_VERTEX (uint32_t)(1 << 0)
/**
 * Binding is visible from the fragment shader of a render pipeline.
 */
#define WGPUShaderStages_FRAGMENT (uint32_t)(1 << 1)
/**
 * Binding is visible from the compute shader of a compute pipeline.
 */
#define WGPUShaderStages_COMPUTE (uint32_t)(1 << 2)
/**
 * Binding is visible from the vertex and fragment shaders of a render pipeline.
 */
#define WGPUShaderStages_VERTEX_FRAGMENT (uint32_t)((WGPUShaderStages_VERTEX).bits | (WGPUShaderStages_FRAGMENT).bits)

struct WGPUBindGroupLayoutEntry {
  uint32_t binding;
  WGPUShaderStages visibility;
  enum WGPURawBindingType ty;
  bool has_dynamic_offset;
  WGPUOption_BufferSize min_binding_size;
  const enum WGPUTextureViewDimension *view_dimension;
  const enum WGPURawTextureSampleType *texture_sample_type;
  bool multisampled;
  const struct WGPUTextureFormat *storage_texture_format;
  bool sampler_filter;
  bool sampler_compare;
};

struct WGPUBindGroupLayoutDescriptor {
  WGPURawString label;
  const struct WGPUBindGroupLayoutEntry *entries;
  uintptr_t entries_length;
};

typedef WGPUNonZeroId WGPUId_PipelineLayout_Dummy;

typedef WGPUId_PipelineLayout_Dummy WGPUPipelineLayoutId;

struct WGPUPipelineLayoutDescriptor {
  WGPURawString label;
  const WGPUBindGroupLayoutId *bind_group_layouts;
  uintptr_t bind_group_layouts_length;
};

typedef WGPUNonZeroId WGPUId_BindGroup_Dummy;

typedef WGPUId_BindGroup_Dummy WGPUBindGroupId;

struct WGPUBindGroupEntry {
  uint32_t binding;
  WGPUOption_BufferId buffer;
  WGPUBufferAddress offset;
  WGPUOption_BufferSize size;
  WGPUOption_SamplerId sampler;
  WGPUOption_TextureViewId texture_view;
};

struct WGPUBindGroupDescriptor {
  WGPURawString label;
  WGPUBindGroupLayoutId layout;
  const struct WGPUBindGroupEntry *entries;
  uintptr_t entries_length;
};

typedef WGPUNonZeroId WGPUId_ShaderModule_Dummy;

typedef WGPUId_ShaderModule_Dummy WGPUShaderModuleId;

struct WGPUShaderModuleDescriptor {
  WGPURawString label;
  const uint8_t *code;
  uintptr_t code_length;
};

typedef WGPUNonZeroId WGPUId_ComputePipeline_Dummy;

typedef WGPUId_ComputePipeline_Dummy WGPUComputePipelineId;

struct WGPUProgrammableStageDescriptor {
  WGPUShaderModuleId module;
  WGPURawString entry_point;
};

struct WGPUComputePipelineDescriptor {
  WGPURawString label;
  WGPUOption_PipelineLayoutId layout;
  struct WGPUProgrammableStageDescriptor stage;
};

typedef WGPUNonZeroId WGPUId_RenderPipeline_Dummy;

typedef WGPUId_RenderPipeline_Dummy WGPURenderPipelineId;

/**
 * Integral type used for binding locations in shaders.
 */
typedef uint32_t WGPUShaderLocation;

/**
 * Vertex inputs (attributes) to shaders.
 *
 * Arrays of these can be made with the [`vertex_attr_array`]
 * macro. Vertex attributes are assumed to be tightly packed.
 *
 * Corresponds to [WebGPU `GPUVertexAttribute`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpuvertexattribute).
 *
 * [`vertex_attr_array`]: ../wgpu/macro.vertex_attr_array.html
 */
struct WGPUVertexAttribute {
  /**
   * Format of the input
   */
  enum WGPUVertexFormat format;
  /**
   * Byte offset of the start of the input
   */
  WGPUBufferAddress offset;
  /**
   * Location for this input. Must match the location in the shader.
   */
  WGPUShaderLocation shader_location;
};

struct WGPUVertexBufferLayout {
  WGPUBufferAddress array_stride;
  enum WGPUVertexStepMode step_mode;
  const struct WGPUVertexAttribute *attributes;
  uintptr_t attributes_length;
};

struct WGPUVertexState {
  struct WGPUProgrammableStageDescriptor stage;
  const struct WGPUVertexBufferLayout *buffers;
  uintptr_t buffers_length;
};

struct WGPUPrimitiveState {
  enum WGPUPrimitiveTopology topology;
  const enum WGPUIndexFormat *strip_index_format;
  enum WGPUFrontFace front_face;
  const enum WGPUFace *cull_mode;
  enum WGPUPolygonMode polygon_mode;
  bool unclipped_depth;
};

/**
 * Describes a blend component of a [`BlendState`].
 *
 * Corresponds to [WebGPU `GPUBlendComponent`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpublendcomponent).
 */
struct WGPUBlendComponent {
  /**
   * Multiplier for the source, which is produced by the fragment shader.
   */
  enum WGPUBlendFactor src_factor;
  /**
   * Multiplier for the destination, which is stored in the target.
   */
  enum WGPUBlendFactor dst_factor;
  /**
   * The binary operation applied to the source and destination,
   * multiplied by their respective factors.
   */
  enum WGPUBlendOperation operation;
};
/**
 * Default blending state that replaces destination with the source.
 */
#define WGPUBlendComponent_REPLACE (WGPUBlendComponent){ .src_factor = WGPUBlendFactor_One, .dst_factor = WGPUBlendFactor_Zero, .operation = WGPUBlendOperation_Add }
/**
 * Blend state of (1 * src) + ((1 - src_alpha) * dst)
 */
#define WGPUBlendComponent_OVER (WGPUBlendComponent){ .src_factor = WGPUBlendFactor_One, .dst_factor = WGPUBlendFactor_OneMinusSrcAlpha, .operation = WGPUBlendOperation_Add }

/**
 * Describe the blend state of a render pipeline,
 * within [`ColorTargetState`].
 *
 * See the OpenGL or Vulkan spec for more information.
 *
 * Corresponds to [WebGPU `GPUBlendState`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpublendstate).
 */
struct WGPUBlendState {
  /**
   * Color equation.
   */
  struct WGPUBlendComponent color;
  /**
   * Alpha equation.
   */
  struct WGPUBlendComponent alpha;
};
/**
 * Blend mode that does no color blending, just overwrites the output with the contents of the shader.
 */
#define WGPUBlendState_REPLACE (WGPUBlendState){ .color = WGPUBlendComponent_REPLACE, .alpha = WGPUBlendComponent_REPLACE }
/**
 * Blend mode that does standard alpha blending with non-premultiplied alpha.
 */
#define WGPUBlendState_ALPHA_BLENDING (WGPUBlendState){ .color = (WGPUBlendComponent){ .src_factor = WGPUBlendFactor_SrcAlpha, .dst_factor = WGPUBlendFactor_OneMinusSrcAlpha, .operation = WGPUBlendOperation_Add }, .alpha = WGPUBlendComponent_OVER }
/**
 * Blend mode that does standard alpha blending with premultiplied alpha.
 */
#define WGPUBlendState_PREMULTIPLIED_ALPHA_BLENDING (WGPUBlendState){ .color = WGPUBlendComponent_OVER, .alpha = WGPUBlendComponent_OVER }

/**
 * Color write mask. Disabled color channels will not be written to.
 *
 * Corresponds to [WebGPU `GPUColorWriteFlags`](
 * https://gpuweb.github.io/gpuweb/#typedefdef-gpucolorwriteflags).
 */
typedef uint32_t WGPUColorWrites;
/**
 * Enable red channel writes
 */
#define WGPUColorWrites_RED (uint32_t)(1 << 0)
/**
 * Enable green channel writes
 */
#define WGPUColorWrites_GREEN (uint32_t)(1 << 1)
/**
 * Enable blue channel writes
 */
#define WGPUColorWrites_BLUE (uint32_t)(1 << 2)
/**
 * Enable alpha channel writes
 */
#define WGPUColorWrites_ALPHA (uint32_t)(1 << 3)
/**
 * Enable red, green, and blue channel writes
 */
#define WGPUColorWrites_COLOR (uint32_t)(((WGPUColorWrites_RED).bits | (WGPUColorWrites_GREEN).bits) | (WGPUColorWrites_BLUE).bits)
/**
 * Enable writes to all channels.
 */
#define WGPUColorWrites_ALL (uint32_t)((((WGPUColorWrites_RED).bits | (WGPUColorWrites_GREEN).bits) | (WGPUColorWrites_BLUE).bits) | (WGPUColorWrites_ALPHA).bits)

struct WGPUColorTargetState {
  struct WGPUTextureFormat format;
  const struct WGPUBlendState *blend;
  WGPUColorWrites write_mask;
};

struct WGPUFragmentState {
  struct WGPUProgrammableStageDescriptor stage;
  const struct WGPUColorTargetState *targets;
  uintptr_t targets_length;
};

/**
 * Describes stencil state in a render pipeline.
 *
 * If you are not using stencil state, set this to [`StencilFaceState::IGNORE`].
 *
 * Corresponds to [WebGPU `GPUStencilFaceState`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpustencilfacestate).
 */
struct WGPUStencilFaceState {
  /**
   * Comparison function that determines if the fail_op or pass_op is used on the stencil buffer.
   */
  enum WGPUCompareFunction compare;
  /**
   * Operation that is preformed when stencil test fails.
   */
  enum WGPUStencilOperation fail_op;
  /**
   * Operation that is performed when depth test fails but stencil test succeeds.
   */
  enum WGPUStencilOperation depth_fail_op;
  /**
   * Operation that is performed when stencil test success.
   */
  enum WGPUStencilOperation pass_op;
};
/**
 * Ignore the stencil state for the face.
 */
#define WGPUStencilFaceState_IGNORE (WGPUStencilFaceState){ .compare = WGPUCompareFunction_Always, .fail_op = WGPUStencilOperation_Keep, .depth_fail_op = WGPUStencilOperation_Keep, .pass_op = WGPUStencilOperation_Keep }

/**
 * State of the stencil operation (fixed-pipeline stage).
 *
 * For use in [`DepthStencilState`].
 *
 * Corresponds to a portion of [WebGPU `GPUDepthStencilState`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpudepthstencilstate).
 */
struct WGPUStencilState {
  /**
   * Front face mode.
   */
  struct WGPUStencilFaceState front;
  /**
   * Back face mode.
   */
  struct WGPUStencilFaceState back;
  /**
   * Stencil values are AND'd with this mask when reading and writing from the stencil buffer. Only low 8 bits are used.
   */
  uint32_t read_mask;
  /**
   * Stencil values are AND'd with this mask when writing to the stencil buffer. Only low 8 bits are used.
   */
  uint32_t write_mask;
};

/**
 * Describes the biasing setting for the depth target.
 *
 * For use in [`DepthStencilState`].
 *
 * Corresponds to a portion of [WebGPU `GPUDepthStencilState`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpudepthstencilstate).
 */
struct WGPUDepthBiasState {
  /**
   * Constant depth biasing factor, in basic units of the depth format.
   */
  int32_t constant;
  /**
   * Slope depth biasing factor.
   */
  float slope_scale;
  /**
   * Depth bias clamp value (absolute).
   */
  float clamp;
};

/**
 * Describes the depth/stencil state in a render pipeline.
 *
 * Corresponds to [WebGPU `GPUDepthStencilState`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpudepthstencilstate).
 */
struct WGPUDepthStencilState {
  /**
   * Format of the depth/stencil buffer, must be special depth format. Must match the the format
   * of the depth/stencil attachment in [`CommandEncoder::begin_render_pass`][CEbrp].
   *
   * [CEbrp]: ../wgpu/struct.CommandEncoder.html#method.begin_render_pass
   */
  struct WGPUTextureFormat format;
  /**
   * If disabled, depth will not be written to.
   */
  bool depth_write_enabled;
  /**
   * Comparison function used to compare depth values in the depth test.
   */
  enum WGPUCompareFunction depth_compare;
  /**
   * Stencil state.
   */
  struct WGPUStencilState stencil;
  /**
   * Depth bias state.
   */
  struct WGPUDepthBiasState bias;
};

/**
 * Describes the multi-sampling state of a render pipeline.
 *
 * Corresponds to [WebGPU `GPUMultisampleState`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpumultisamplestate).
 */
struct WGPUMultisampleState {
  /**
   * The number of samples calculated per pixel (for MSAA). For non-multisampled textures,
   * this should be `1`
   */
  uint32_t count;
  /**
   * Bitmask that restricts the samples of a pixel modified by this pipeline. All samples
   * can be enabled using the value `!0`
   */
  uint64_t mask;
  /**
   * When enabled, produces another sample mask per pixel based on the alpha output value, that
   * is ANDed with the sample_mask and the primitive coverage to restrict the set of samples
   * affected by a primitive.
   *
   * The implicit mask produced for alpha of zero is guaranteed to be zero, and for alpha of one
   * is guaranteed to be all 1-s.
   */
  bool alpha_to_coverage_enabled;
};

struct WGPURenderPipelineDescriptor {
  WGPURawString label;
  WGPUOption_PipelineLayoutId layout;
  const struct WGPUVertexState *vertex;
  struct WGPUPrimitiveState primitive;
  const struct WGPUFragmentState *fragment;
  const struct WGPUDepthStencilState *depth_stencil;
  struct WGPUMultisampleState multisample;
};

/**
 * Origin of a copy to/from a texture.
 *
 * Corresponds to [WebGPU `GPUOrigin3D`](
 * https://gpuweb.github.io/gpuweb/#typedefdef-gpuorigin3d).
 */
struct WGPUOrigin3d {
  /**
   *
   */
  uint32_t x;
  /**
   *
   */
  uint32_t y;
  /**
   *
   */
  uint32_t z;
};
/**
 * Zero origin.
 */
#define WGPUOrigin3d_ZERO (WGPUOrigin3d){ .x = 0, .y = 0, .z = 0 }

/**
 * View of a texture which can be used to copy to/from a buffer/texture.
 *
 * Corresponds to [WebGPU `GPUImageCopyTexture`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpuimagecopytexture).
 */
struct WGPUImageCopyTexture_TextureId {
  /**
   * The texture to be copied to/from.
   */
  WGPUTextureId texture;
  /**
   * The target mip level of the texture.
   */
  uint32_t mip_level;
  /**
   * The base texel of the texture in the selected `mip_level`.
   */
  struct WGPUOrigin3d origin;
  /**
   * The copy aspect.
   */
  enum WGPUTextureAspect aspect;
};

typedef struct WGPUImageCopyTexture_TextureId WGPUImageCopyTexture;

/**
 * Layout of a texture in a buffer's memory.
 *
 * The bytes per row and rows per image can be hard to figure out so here are some examples:
 *
 * | Resolution | Format | Bytes per block | Pixels per block | Bytes per row                          | Rows per image               |
 * |------------|--------|-----------------|------------------|----------------------------------------|------------------------------|
 * | 256x256    | RGBA8  | 4               | 1 * 1 * 1        | 256 * 4 = Some(1024)                   | None                         |
 * | 32x16x8    | RGBA8  | 4               | 1 * 1 * 1        | 32 * 4 = 128 padded to 256 = Some(256) | None                         |
 * | 256x256    | BC3    | 16              | 4 * 4 * 1        | 16 * (256 / 4) = 1024 = Some(1024)     | None                         |
 * | 64x64x8    | BC3    | 16              | 4 * 4 * 1        | 16 * (64 / 4) = 256 = Some(256)        | 64 / 4 = 16 = Some(16)       |
 *
 * Corresponds to [WebGPU `GPUImageDataLayout`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpuimagedatalayout).
 */
struct WGPUImageDataLayout {
  /**
   * Offset into the buffer that is the start of the texture. Must be a multiple of texture block size.
   * For non-compressed textures, this is 1.
   */
  WGPUBufferAddress offset;
  /**
   * Bytes per "row" in an image.
   *
   * A row is one row of pixels or of compressed blocks in the x direction.
   *
   * This value is required if there are multiple rows (i.e. height or depth is more than one pixel or pixel block for compressed textures)
   *
   * Must be a multiple of 256 for [`CommandEncoder::copy_buffer_to_texture`][CEcbtt]
   * and [`CommandEncoder::copy_texture_to_buffer`][CEcttb]. You must manually pad the
   * image such that this is a multiple of 256. It will not affect the image data.
   *
   * [`Queue::write_texture`][Qwt] does not have this requirement.
   *
   * Must be a multiple of the texture block size. For non-compressed textures, this is 1.
   *
   * [CEcbtt]: ../wgpu/struct.CommandEncoder.html#method.copy_buffer_to_texture
   * [CEcttb]: ../wgpu/struct.CommandEncoder.html#method.copy_texture_to_buffer
   * [Qwt]: ../wgpu/struct.Queue.html#method.write_texture
   */
  uint32_t bytes_per_row;
  /**
   * "Rows" that make up a single "image".
   *
   * A row is one row of pixels or of compressed blocks in the x direction.
   *
   * An image is one layer in the z direction of a 3D image or 2DArray texture.
   *
   * The amount of rows per image may be larger than the actual amount of rows of data.
   *
   * Required if there are multiple images (i.e. the depth is more than one).
   */
  uint32_t rows_per_image;
};

/**
 * View of a buffer which can be used to copy to/from a texture.
 *
 * Corresponds to [WebGPU `GPUImageCopyBuffer`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpuimagecopybuffer).
 */
struct WGPUImageCopyBuffer_BufferId {
  /**
   * The buffer to be copied to/from.
   */
  WGPUBufferId buffer;
  /**
   * The layout of the texture data in this buffer.
   */
  struct WGPUImageDataLayout layout;
};

typedef struct WGPUImageCopyBuffer_BufferId WGPUImageCopyBuffer;

typedef void *WGPUFactoryParam;

typedef WGPUNonZeroId WGPUId_QuerySet_Dummy;

typedef WGPUId_QuerySet_Dummy WGPUQuerySetId;

typedef WGPUNonZeroId WGPUId_Surface;

typedef WGPUId_Surface WGPUSurfaceId;

struct WGPUIdentityRecyclerFactory {
  WGPUFactoryParam param;
  void (*free_adapter)(WGPUAdapterId, WGPUFactoryParam);
  void (*free_device)(WGPUDeviceId, WGPUFactoryParam);
  void (*free_pipeline_layout)(WGPUPipelineLayoutId, WGPUFactoryParam);
  void (*free_shader_module)(WGPUShaderModuleId, WGPUFactoryParam);
  void (*free_bind_group_layout)(WGPUBindGroupLayoutId, WGPUFactoryParam);
  void (*free_bind_group)(WGPUBindGroupId, WGPUFactoryParam);
  void (*free_command_buffer)(WGPUCommandBufferId, WGPUFactoryParam);
  void (*free_render_bundle)(WGPURenderBundleId, WGPUFactoryParam);
  void (*free_render_pipeline)(WGPURenderPipelineId, WGPUFactoryParam);
  void (*free_compute_pipeline)(WGPUComputePipelineId, WGPUFactoryParam);
  void (*free_query_set)(WGPUQuerySetId, WGPUFactoryParam);
  void (*free_buffer)(WGPUBufferId, WGPUFactoryParam);
  void (*free_texture)(WGPUTextureId, WGPUFactoryParam);
  void (*free_texture_view)(WGPUTextureViewId, WGPUFactoryParam);
  void (*free_sampler)(WGPUSamplerId, WGPUFactoryParam);
  void (*free_surface)(WGPUSurfaceId, WGPUFactoryParam);
};

/**
 * Options for requesting adapter.
 *
 * Corresponds to [WebGPU `GPURequestAdapterOptions`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpurequestadapteroptions).
 */
struct WGPURequestAdapterOptions_SurfaceId {
  /**
   * Power preference for the adapter.
   */
  enum WGPUPowerPreference power_preference;
  /**
   * Indicates that only a fallback adapter can be returned. This is generally a "software"
   * implementation on the system.
   */
  bool force_fallback_adapter;
  /**
   * Surface that is required to be presentable with the requested adapter. This does not
   * create the surface, only guarantees that the adapter can present to said surface.
   */
  WGPUOption_SurfaceId compatible_surface;
};

typedef struct WGPURequestAdapterOptions_SurfaceId WGPURequestAdapterOptions;

/**
 * A fixed-capacity, null-terminated error buffer owned by C++.
 *
 * This type points to space owned by a C++ `mozilla::webgpu::ErrorBuffer`
 * object, owned by our callers in `WebGPUParent.cpp`. If we catch a
 * `Result::Err` here, we convert the error to a string, copy as much of that
 * string as fits into this buffer, and null-terminate it. The caller
 * determines whether a error occurred by simply checking if there's any text
 * before the first null byte.
 *
 * C++ callers of Rust functions that expect one of these structs can create a
 * `mozilla::webgpu::ErrorBuffer` object, and call its `ToFFI` method to
 * construct a value of this type, available to C++ as
 * `mozilla::webgpu::ffi::WGPUErrorBuffer`.
 */
struct WGPUErrorBuffer {
  char *string;
  uintptr_t capacity;
};

typedef void (*WGPUBufferMapCallback)(enum WGPUBufferMapAsyncStatus status, uint8_t *userdata);

struct WGPUBufferMapOperation {
  enum WGPUHostMap host;
  WGPUBufferMapCallback callback;
  uint8_t *user_data;
};

/**
 * Describes a [`CommandBuffer`](../wgpu/struct.CommandBuffer.html).
 *
 * Corresponds to [WebGPU `GPUCommandBufferDescriptor`](
 * https://gpuweb.github.io/gpuweb/#dictdef-gpucommandbufferdescriptor).
 */
struct WGPUCommandBufferDescriptor {
  /**
   * Debug label of this command buffer.
   */
  WGPURawString label;
};

typedef WGPUDeviceId WGPUQueueId;

/**
 * Integral type used for dynamic bind group offsets.
 */
typedef uint32_t WGPUDynamicOffset;

/**
 * Size of a single occlusion/timestamp query, when copied into a buffer, in bytes.
 */
#define WGPUQUERY_SIZE 8























































































































/**
 * An offset into the query resolve buffer has to be aligned to this.
 */
#define WGPUQUERY_RESOLVE_BUFFER_ALIGNMENT 256

/**
 * Buffer to buffer copy as well as buffer clear offsets and sizes must be aligned to this number.
 */
#define WGPUCOPY_BUFFER_ALIGNMENT 4

/**
 * Size to align mappings.
 */
#define WGPUMAP_ALIGNMENT 8

/**
 * Vertex buffer strides have to be aligned to this number.
 */
#define WGPUVERTEX_STRIDE_ALIGNMENT 4





























#ifdef __cplusplus
extern "C" {
#endif // __cplusplus

WGPU_INLINE
void wgpu_client_drop_action(struct WGPUClient *aClient,
                             const struct WGPUByteBuf *aByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_client_kill_device_id(const struct WGPUClient *aClient,
                                WGPUDeviceId aId)
WGPU_FUNC;

WGPU_INLINE
struct WGPUInfrastructure wgpu_client_new(void)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe because improper use may lead to memory
 * problems. For example, a double-free may occur if the function is called
 * twice on the same raw pointer.
 */
WGPU_INLINE
void wgpu_client_delete(struct WGPUClient *aClient)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given pointer is
 * valid for `id_length` elements.
 */
WGPU_INLINE
uintptr_t wgpu_client_make_adapter_ids(const struct WGPUClient *aClient,
                                       WGPUAdapterId *aIds,
                                       uintptr_t aIdLength)
WGPU_FUNC;

WGPU_INLINE
void wgpu_client_fill_default_limits(struct WGPULimits *aLimits)
WGPU_FUNC;

WGPU_INLINE
void wgpu_client_adapter_extract_info(const struct WGPUByteBuf *aByteBuf,
                                      struct WGPUAdapterInformation *aInfo)
WGPU_FUNC;

WGPU_INLINE
void wgpu_client_serialize_device_descriptor(const struct WGPUDeviceDescriptor *aDesc,
                                             struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
WGPUDeviceId wgpu_client_make_device_id(const struct WGPUClient *aClient,
                                        WGPUAdapterId aAdapterId)
WGPU_FUNC;

WGPU_INLINE
WGPUBufferId wgpu_client_make_buffer_id(const struct WGPUClient *aClient,
                                        WGPUDeviceId aDeviceId)
WGPU_FUNC;

WGPU_INLINE
WGPUBufferId wgpu_client_create_buffer(const struct WGPUClient *aClient,
                                       WGPUDeviceId aDeviceId,
                                       const struct WGPUBufferDescriptor *aDesc,
                                       struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
WGPUTextureId wgpu_client_create_texture(const struct WGPUClient *aClient,
                                         WGPUDeviceId aDeviceId,
                                         const struct WGPUTextureDescriptor *aDesc,
                                         struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
WGPUTextureViewId wgpu_client_create_texture_view(const struct WGPUClient *aClient,
                                                  WGPUDeviceId aDeviceId,
                                                  const struct WGPUTextureViewDescriptor *aDesc,
                                                  struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
WGPUSamplerId wgpu_client_create_sampler(const struct WGPUClient *aClient,
                                         WGPUDeviceId aDeviceId,
                                         const struct WGPUSamplerDescriptor *aDesc,
                                         struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
WGPUCommandEncoderId wgpu_client_make_encoder_id(const struct WGPUClient *aClient,
                                                 WGPUDeviceId aDeviceId)
WGPU_FUNC;

WGPU_INLINE
WGPUCommandEncoderId wgpu_client_create_command_encoder(const struct WGPUClient *aClient,
                                                        WGPUDeviceId aDeviceId,
                                                        const struct WGPUCommandEncoderDescriptor *aDesc,
                                                        struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
struct WGPURenderBundleEncoder *wgpu_device_create_render_bundle_encoder(WGPUDeviceId aDeviceId,
                                                                         const struct WGPURenderBundleEncoderDescriptor *aDesc,
                                                                         struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_bundle_encoder_destroy(struct WGPURenderBundleEncoder *aPass)
WGPU_FUNC;

WGPU_INLINE
WGPURenderBundleId wgpu_client_create_render_bundle(const struct WGPUClient *aClient,
                                                    struct WGPURenderBundleEncoder *aEncoder,
                                                    WGPUDeviceId aDeviceId,
                                                    const struct WGPURenderBundleDescriptor *aDesc,
                                                    struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
struct WGPUComputePass *wgpu_command_encoder_begin_compute_pass(WGPUCommandEncoderId aEncoderId,
                                                                const struct WGPUComputePassDescriptor *aDesc)
WGPU_FUNC;

WGPU_INLINE
void wgpu_compute_pass_finish(struct WGPUComputePass *aPass,
                              struct WGPUByteBuf *aOutput)
WGPU_FUNC;

WGPU_INLINE
void wgpu_compute_pass_destroy(struct WGPUComputePass *aPass)
WGPU_FUNC;

WGPU_INLINE
struct WGPURenderPass *wgpu_command_encoder_begin_render_pass(WGPUCommandEncoderId aEncoderId,
                                                              const struct WGPURenderPassDescriptor *aDesc)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_finish(struct WGPURenderPass *aPass,
                             struct WGPUByteBuf *aOutput)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_destroy(struct WGPURenderPass *aPass)
WGPU_FUNC;

WGPU_INLINE
WGPUBindGroupLayoutId wgpu_client_create_bind_group_layout(const struct WGPUClient *aClient,
                                                           WGPUDeviceId aDeviceId,
                                                           const struct WGPUBindGroupLayoutDescriptor *aDesc,
                                                           struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
WGPUPipelineLayoutId wgpu_client_create_pipeline_layout(const struct WGPUClient *aClient,
                                                        WGPUDeviceId aDeviceId,
                                                        const struct WGPUPipelineLayoutDescriptor *aDesc,
                                                        struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
WGPUBindGroupId wgpu_client_create_bind_group(const struct WGPUClient *aClient,
                                              WGPUDeviceId aDeviceId,
                                              const struct WGPUBindGroupDescriptor *aDesc,
                                              struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
WGPUShaderModuleId wgpu_client_create_shader_module(const struct WGPUClient *aClient,
                                                    WGPUDeviceId aDeviceId,
                                                    const struct WGPUShaderModuleDescriptor *aDesc,
                                                    struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
WGPUComputePipelineId wgpu_client_create_compute_pipeline(const struct WGPUClient *aClient,
                                                          WGPUDeviceId aDeviceId,
                                                          const struct WGPUComputePipelineDescriptor *aDesc,
                                                          struct WGPUByteBuf *aBb,
                                                          WGPUOption_PipelineLayoutId *aImplicitPipelineLayoutId,
                                                          WGPUOption_BindGroupLayoutId *aImplicitBindGroupLayoutIds)
WGPU_FUNC;

WGPU_INLINE
WGPURenderPipelineId wgpu_client_create_render_pipeline(const struct WGPUClient *aClient,
                                                        WGPUDeviceId aDeviceId,
                                                        const struct WGPURenderPipelineDescriptor *aDesc,
                                                        struct WGPUByteBuf *aBb,
                                                        WGPUOption_PipelineLayoutId *aImplicitPipelineLayoutId,
                                                        WGPUOption_BindGroupLayoutId *aImplicitBindGroupLayoutIds)
WGPU_FUNC;

WGPU_INLINE
void wgpu_command_encoder_copy_buffer_to_buffer(WGPUBufferId aSrc,
                                                WGPUBufferAddress aSrcOffset,
                                                WGPUBufferId aDst,
                                                WGPUBufferAddress aDstOffset,
                                                WGPUBufferAddress aSize,
                                                struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
void wgpu_command_encoder_copy_texture_to_buffer(WGPUImageCopyTexture aSrc,
                                                 WGPUImageCopyBuffer aDst,
                                                 struct WGPUExtent3d aSize,
                                                 struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
void wgpu_command_encoder_copy_buffer_to_texture(WGPUImageCopyBuffer aSrc,
                                                 WGPUImageCopyTexture aDst,
                                                 struct WGPUExtent3d aSize,
                                                 struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
void wgpu_command_encoder_copy_texture_to_texture(WGPUImageCopyTexture aSrc,
                                                  WGPUImageCopyTexture aDst,
                                                  struct WGPUExtent3d aSize,
                                                  struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
void wgpu_command_encoder_push_debug_group(WGPURawString aMarker,
                                           struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
void wgpu_command_encoder_pop_debug_group(struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
void wgpu_command_encoder_insert_debug_marker(WGPURawString aMarker,
                                              struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
void wgpu_queue_write_buffer(WGPUBufferId aDst,
                             WGPUBufferAddress aOffset,
                             struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
void wgpu_queue_write_texture(struct WGPUImageCopyTexture_TextureId aDst,
                              struct WGPUImageDataLayout aLayout,
                              struct WGPUExtent3d aSize,
                              struct WGPUByteBuf *aBb)
WGPU_FUNC;

WGPU_INLINE
struct WGPUGlobal *wgpu_server_new(struct WGPUIdentityRecyclerFactory aFactory)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe because improper use may lead to memory
 * problems. For example, a double-free may occur if the function is called
 * twice on the same raw pointer.
 */
WGPU_INLINE
void wgpu_server_delete(struct WGPUGlobal *aGlobal)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_poll_all_devices(const struct WGPUGlobal *aGlobal,
                                  bool aForceWait)
WGPU_FUNC;

/**
 * Request an adapter according to the specified options.
 * Provide the list of IDs to pick from.
 *
 * Returns the index in this list, or -1 if unable to pick.
 *
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given pointer is
 * valid for `id_length` elements.
 */
WGPU_INLINE
int8_t wgpu_server_instance_request_adapter(const struct WGPUGlobal *aGlobal,
                                            const WGPURequestAdapterOptions *aDesc,
                                            const WGPUAdapterId *aIds,
                                            uintptr_t aIdLength,
                                            struct WGPUErrorBuffer aErrorBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_adapter_pack_info(const struct WGPUGlobal *aGlobal,
                                   WGPUOption_AdapterId aSelfId,
                                   struct WGPUByteBuf *aByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_adapter_request_device(const struct WGPUGlobal *aGlobal,
                                        WGPUAdapterId aSelfId,
                                        const struct WGPUByteBuf *aByteBuf,
                                        WGPUDeviceId aNewId,
                                        struct WGPUErrorBuffer aErrorBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_adapter_drop(const struct WGPUGlobal *aGlobal,
                              WGPUAdapterId aAdapterId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_device_drop(const struct WGPUGlobal *aGlobal,
                             WGPUDeviceId aSelfId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_device_create_buffer(const struct WGPUGlobal *aGlobal,
                                      WGPUDeviceId aSelfId,
                                      const struct WGPUBufferDescriptor *aDesc,
                                      WGPUBufferId aNewId,
                                      struct WGPUErrorBuffer aErrorBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_buffer_map(const struct WGPUGlobal *aGlobal,
                            WGPUBufferId aBufferId,
                            WGPUBufferAddress aStart,
                            WGPUBufferAddress aSize,
                            struct WGPUBufferMapOperation aOperation)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given pointer is
 * valid for `size` elements.
 */
WGPU_INLINE
uint8_t *wgpu_server_buffer_get_mapped_range(const struct WGPUGlobal *aGlobal,
                                             WGPUBufferId aBufferId,
                                             WGPUBufferAddress aStart,
                                             WGPUBufferAddress aSize)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_buffer_unmap(const struct WGPUGlobal *aGlobal,
                              WGPUBufferId aBufferId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_buffer_drop(const struct WGPUGlobal *aGlobal,
                             WGPUBufferId aSelfId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_device_action(const struct WGPUGlobal *aGlobal,
                               WGPUDeviceId aSelfId,
                               const struct WGPUByteBuf *aByteBuf,
                               struct WGPUErrorBuffer aErrorBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_texture_action(const struct WGPUGlobal *aGlobal,
                                WGPUTextureId aSelfId,
                                const struct WGPUByteBuf *aByteBuf,
                                struct WGPUErrorBuffer aErrorBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_command_encoder_action(const struct WGPUGlobal *aGlobal,
                                        WGPUCommandEncoderId aSelfId,
                                        const struct WGPUByteBuf *aByteBuf,
                                        struct WGPUErrorBuffer aErrorBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_device_create_encoder(const struct WGPUGlobal *aGlobal,
                                       WGPUDeviceId aSelfId,
                                       const struct WGPUCommandEncoderDescriptor *aDesc,
                                       WGPUCommandEncoderId aNewId,
                                       struct WGPUErrorBuffer aErrorBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_encoder_finish(const struct WGPUGlobal *aGlobal,
                                WGPUCommandEncoderId aSelfId,
                                const struct WGPUCommandBufferDescriptor *aDesc,
                                struct WGPUErrorBuffer aErrorBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_encoder_drop(const struct WGPUGlobal *aGlobal,
                              WGPUCommandEncoderId aSelfId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_command_buffer_drop(const struct WGPUGlobal *aGlobal,
                                     WGPUCommandBufferId aSelfId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_render_bundle_drop(const struct WGPUGlobal *aGlobal,
                                    WGPURenderBundleId aSelfId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_encoder_copy_texture_to_buffer(const struct WGPUGlobal *aGlobal,
                                                WGPUCommandEncoderId aSelfId,
                                                const WGPUImageCopyTexture *aSource,
                                                const WGPUImageCopyBuffer *aDestination,
                                                const struct WGPUExtent3d *aSize)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given pointer is
 * valid for `command_buffer_id_length` elements.
 */
WGPU_INLINE
void wgpu_server_queue_submit(const struct WGPUGlobal *aGlobal,
                              WGPUQueueId aSelfId,
                              const WGPUCommandBufferId *aCommandBufferIds,
                              uintptr_t aCommandBufferIdLength,
                              struct WGPUErrorBuffer aErrorBuf)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given pointer is
 * valid for `data_length` elements.
 */
WGPU_INLINE
void wgpu_server_queue_write_action(const struct WGPUGlobal *aGlobal,
                                    WGPUQueueId aSelfId,
                                    const struct WGPUByteBuf *aByteBuf,
                                    const uint8_t *aData,
                                    uintptr_t aDataLength,
                                    struct WGPUErrorBuffer aErrorBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_bind_group_layout_drop(const struct WGPUGlobal *aGlobal,
                                        WGPUBindGroupLayoutId aSelfId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_pipeline_layout_drop(const struct WGPUGlobal *aGlobal,
                                      WGPUPipelineLayoutId aSelfId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_bind_group_drop(const struct WGPUGlobal *aGlobal,
                                 WGPUBindGroupId aSelfId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_shader_module_drop(const struct WGPUGlobal *aGlobal,
                                    WGPUShaderModuleId aSelfId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_compute_pipeline_drop(const struct WGPUGlobal *aGlobal,
                                       WGPUComputePipelineId aSelfId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_render_pipeline_drop(const struct WGPUGlobal *aGlobal,
                                      WGPURenderPipelineId aSelfId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_texture_drop(const struct WGPUGlobal *aGlobal,
                              WGPUTextureId aSelfId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_texture_view_drop(const struct WGPUGlobal *aGlobal,
                                   WGPUTextureViewId aSelfId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_sampler_drop(const struct WGPUGlobal *aGlobal,
                              WGPUSamplerId aSelfId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_compute_pipeline_get_bind_group_layout(const struct WGPUGlobal *aGlobal,
                                                        WGPUComputePipelineId aSelfId,
                                                        uint32_t aIndex,
                                                        WGPUBindGroupLayoutId aAssignId,
                                                        struct WGPUErrorBuffer aErrorBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_render_pipeline_get_bind_group_layout(const struct WGPUGlobal *aGlobal,
                                                       WGPURenderPipelineId aSelfId,
                                                       uint32_t aIndex,
                                                       WGPUBindGroupLayoutId aAssignId,
                                                       struct WGPUErrorBuffer aErrorBuf)
WGPU_FUNC;

/**
 * Encode the freeing of the selected ID into a byte buf.
 */
WGPU_INLINE
void wgpu_server_adapter_free(WGPUAdapterId aId,
                              struct WGPUByteBuf *aDropByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_device_free(WGPUDeviceId aId,
                             struct WGPUByteBuf *aDropByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_shader_module_free(WGPUShaderModuleId aId,
                                    struct WGPUByteBuf *aDropByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_pipeline_layout_free(WGPUPipelineLayoutId aId,
                                      struct WGPUByteBuf *aDropByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_bind_group_layout_free(WGPUBindGroupLayoutId aId,
                                        struct WGPUByteBuf *aDropByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_bind_group_free(WGPUBindGroupId aId,
                                 struct WGPUByteBuf *aDropByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_command_buffer_free(WGPUCommandBufferId aId,
                                     struct WGPUByteBuf *aDropByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_render_bundle_free(WGPURenderBundleId aId,
                                    struct WGPUByteBuf *aDropByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_render_pipeline_free(WGPURenderPipelineId aId,
                                      struct WGPUByteBuf *aDropByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_compute_pipeline_free(WGPUComputePipelineId aId,
                                       struct WGPUByteBuf *aDropByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_buffer_free(WGPUBufferId aId,
                             struct WGPUByteBuf *aDropByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_texture_free(WGPUTextureId aId,
                              struct WGPUByteBuf *aDropByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_texture_view_free(WGPUTextureViewId aId,
                                   struct WGPUByteBuf *aDropByteBuf)
WGPU_FUNC;

WGPU_INLINE
void wgpu_server_sampler_free(WGPUSamplerId aId,
                              struct WGPUByteBuf *aDropByteBuf)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given pointer is
 * valid for `offset_length` elements.
 */
WGPU_INLINE
void wgpu_render_bundle_set_bind_group(struct WGPURenderBundleEncoder *aBundle,
                                       uint32_t aIndex,
                                       WGPUBindGroupId aBindGroupId,
                                       const WGPUDynamicOffset *aOffsets,
                                       uintptr_t aOffsetLength)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_bundle_set_pipeline(struct WGPURenderBundleEncoder *aBundle,
                                     WGPURenderPipelineId aPipelineId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_bundle_set_vertex_buffer(struct WGPURenderBundleEncoder *aBundle,
                                          uint32_t aSlot,
                                          WGPUBufferId aBufferId,
                                          WGPUBufferAddress aOffset,
                                          WGPUOption_BufferSize aSize)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_bundle_set_index_buffer(struct WGPURenderBundleEncoder *aEncoder,
                                         WGPUBufferId aBuffer,
                                         enum WGPUIndexFormat aIndexFormat,
                                         WGPUBufferAddress aOffset,
                                         WGPUOption_BufferSize aSize)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given pointer is
 * valid for `data` elements.
 */
WGPU_INLINE
void wgpu_render_bundle_set_push_constants(struct WGPURenderBundleEncoder *aPass,
                                           WGPUShaderStages aStages,
                                           uint32_t aOffset,
                                           uint32_t aSizeBytes,
                                           const uint8_t *aData)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_bundle_draw(struct WGPURenderBundleEncoder *aBundle,
                             uint32_t aVertexCount,
                             uint32_t aInstanceCount,
                             uint32_t aFirstVertex,
                             uint32_t aFirstInstance)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_bundle_draw_indexed(struct WGPURenderBundleEncoder *aBundle,
                                     uint32_t aIndexCount,
                                     uint32_t aInstanceCount,
                                     uint32_t aFirstIndex,
                                     int32_t aBaseVertex,
                                     uint32_t aFirstInstance)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_bundle_draw_indirect(struct WGPURenderBundleEncoder *aBundle,
                                      WGPUBufferId aBufferId,
                                      WGPUBufferAddress aOffset)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_bundle_draw_indexed_indirect(struct WGPURenderBundleEncoder *aBundle,
                                              WGPUBufferId aBufferId,
                                              WGPUBufferAddress aOffset)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given `label`
 * is a valid null-terminated string.
 */
WGPU_INLINE
void wgpu_render_bundle_push_debug_group(struct WGPURenderBundleEncoder *aBundle,
                                         WGPURawString aLabel)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_bundle_pop_debug_group(struct WGPURenderBundleEncoder *aBundle)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given `label`
 * is a valid null-terminated string.
 */
WGPU_INLINE
void wgpu_render_bundle_insert_debug_marker(struct WGPURenderBundleEncoder *aBundle,
                                            WGPURawString aLabel)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given pointer is
 * valid for `offset_length` elements.
 */
WGPU_INLINE
void wgpu_compute_pass_set_bind_group(struct WGPUComputePass *aPass,
                                      uint32_t aIndex,
                                      WGPUBindGroupId aBindGroupId,
                                      const WGPUDynamicOffset *aOffsets,
                                      uintptr_t aOffsetLength)
WGPU_FUNC;

WGPU_INLINE
void wgpu_compute_pass_set_pipeline(struct WGPUComputePass *aPass,
                                    WGPUComputePipelineId aPipelineId)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given pointer is
 * valid for `size_bytes` bytes.
 */
WGPU_INLINE
void wgpu_compute_pass_set_push_constant(struct WGPUComputePass *aPass,
                                         uint32_t aOffset,
                                         uint32_t aSizeBytes,
                                         const uint8_t *aData)
WGPU_FUNC;

WGPU_INLINE
void wgpu_compute_pass_dispatch_workgroups(struct WGPUComputePass *aPass,
                                           uint32_t aGroupsX,
                                           uint32_t aGroupsY,
                                           uint32_t aGroupsZ)
WGPU_FUNC;

WGPU_INLINE
void wgpu_compute_pass_dispatch_workgroups_indirect(struct WGPUComputePass *aPass,
                                                    WGPUBufferId aBufferId,
                                                    WGPUBufferAddress aOffset)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given `label`
 * is a valid null-terminated string.
 */
WGPU_INLINE
void wgpu_compute_pass_push_debug_group(struct WGPUComputePass *aPass,
                                        WGPURawString aLabel,
                                        uint32_t aColor)
WGPU_FUNC;

WGPU_INLINE
void wgpu_compute_pass_pop_debug_group(struct WGPUComputePass *aPass)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given `label`
 * is a valid null-terminated string.
 */
WGPU_INLINE
void wgpu_compute_pass_insert_debug_marker(struct WGPUComputePass *aPass,
                                           WGPURawString aLabel,
                                           uint32_t aColor)
WGPU_FUNC;

WGPU_INLINE
void wgpu_compute_pass_write_timestamp(struct WGPUComputePass *aPass,
                                       WGPUQuerySetId aQuerySetId,
                                       uint32_t aQueryIndex)
WGPU_FUNC;

WGPU_INLINE
void wgpu_compute_pass_begin_pipeline_statistics_query(struct WGPUComputePass *aPass,
                                                       WGPUQuerySetId aQuerySetId,
                                                       uint32_t aQueryIndex)
WGPU_FUNC;

WGPU_INLINE
void wgpu_compute_pass_end_pipeline_statistics_query(struct WGPUComputePass *aPass)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given pointer is
 * valid for `offset_length` elements.
 */
WGPU_INLINE
void wgpu_render_pass_set_bind_group(struct WGPURenderPass *aPass,
                                     uint32_t aIndex,
                                     WGPUBindGroupId aBindGroupId,
                                     const WGPUDynamicOffset *aOffsets,
                                     uintptr_t aOffsetLength)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_set_pipeline(struct WGPURenderPass *aPass,
                                   WGPURenderPipelineId aPipelineId)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_set_vertex_buffer(struct WGPURenderPass *aPass,
                                        uint32_t aSlot,
                                        WGPUBufferId aBufferId,
                                        WGPUBufferAddress aOffset,
                                        WGPUOption_BufferSize aSize)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_set_index_buffer(struct WGPURenderPass *aPass,
                                       WGPUBufferId aBuffer,
                                       enum WGPUIndexFormat aIndexFormat,
                                       WGPUBufferAddress aOffset,
                                       WGPUOption_BufferSize aSize)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_set_blend_constant(struct WGPURenderPass *aPass,
                                         const struct WGPUColor *aColor)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_set_stencil_reference(struct WGPURenderPass *aPass,
                                            uint32_t aValue)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_set_viewport(struct WGPURenderPass *aPass,
                                   float aX,
                                   float aY,
                                   float aW,
                                   float aH,
                                   float aDepthMin,
                                   float aDepthMax)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_set_scissor_rect(struct WGPURenderPass *aPass,
                                       uint32_t aX,
                                       uint32_t aY,
                                       uint32_t aW,
                                       uint32_t aH)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given pointer is
 * valid for `size_bytes` bytes.
 */
WGPU_INLINE
void wgpu_render_pass_set_push_constants(struct WGPURenderPass *aPass,
                                         WGPUShaderStages aStages,
                                         uint32_t aOffset,
                                         uint32_t aSizeBytes,
                                         const uint8_t *aData)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_draw(struct WGPURenderPass *aPass,
                           uint32_t aVertexCount,
                           uint32_t aInstanceCount,
                           uint32_t aFirstVertex,
                           uint32_t aFirstInstance)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_draw_indexed(struct WGPURenderPass *aPass,
                                   uint32_t aIndexCount,
                                   uint32_t aInstanceCount,
                                   uint32_t aFirstIndex,
                                   int32_t aBaseVertex,
                                   uint32_t aFirstInstance)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_draw_indirect(struct WGPURenderPass *aPass,
                                    WGPUBufferId aBufferId,
                                    WGPUBufferAddress aOffset)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_draw_indexed_indirect(struct WGPURenderPass *aPass,
                                            WGPUBufferId aBufferId,
                                            WGPUBufferAddress aOffset)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_multi_draw_indirect(struct WGPURenderPass *aPass,
                                          WGPUBufferId aBufferId,
                                          WGPUBufferAddress aOffset,
                                          uint32_t aCount)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_multi_draw_indexed_indirect(struct WGPURenderPass *aPass,
                                                  WGPUBufferId aBufferId,
                                                  WGPUBufferAddress aOffset,
                                                  uint32_t aCount)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_multi_draw_indirect_count(struct WGPURenderPass *aPass,
                                                WGPUBufferId aBufferId,
                                                WGPUBufferAddress aOffset,
                                                WGPUBufferId aCountBufferId,
                                                WGPUBufferAddress aCountBufferOffset,
                                                uint32_t aMaxCount)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_multi_draw_indexed_indirect_count(struct WGPURenderPass *aPass,
                                                        WGPUBufferId aBufferId,
                                                        WGPUBufferAddress aOffset,
                                                        WGPUBufferId aCountBufferId,
                                                        WGPUBufferAddress aCountBufferOffset,
                                                        uint32_t aMaxCount)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given `label`
 * is a valid null-terminated string.
 */
WGPU_INLINE
void wgpu_render_pass_push_debug_group(struct WGPURenderPass *aPass,
                                       WGPURawString aLabel,
                                       uint32_t aColor)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_pop_debug_group(struct WGPURenderPass *aPass)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given `label`
 * is a valid null-terminated string.
 */
WGPU_INLINE
void wgpu_render_pass_insert_debug_marker(struct WGPURenderPass *aPass,
                                          WGPURawString aLabel,
                                          uint32_t aColor)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_write_timestamp(struct WGPURenderPass *aPass,
                                      WGPUQuerySetId aQuerySetId,
                                      uint32_t aQueryIndex)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_begin_pipeline_statistics_query(struct WGPURenderPass *aPass,
                                                      WGPUQuerySetId aQuerySetId,
                                                      uint32_t aQueryIndex)
WGPU_FUNC;

WGPU_INLINE
void wgpu_render_pass_end_pipeline_statistics_query(struct WGPURenderPass *aPass)
WGPU_FUNC;

/**
 * # Safety
 *
 * This function is unsafe as there is no guarantee that the given pointer is
 * valid for `render_bundle_ids_length` elements.
 */
WGPU_INLINE
void wgpu_render_pass_execute_bundles(struct WGPURenderPass *aPass,
                                      const WGPURenderBundleId *aRenderBundleIds,
                                      uintptr_t aRenderBundleIdsLength)
WGPU_FUNC;

#ifdef __cplusplus
} // extern "C"
#endif // __cplusplus
