#include "AudioWorkletGlobalScopeBinding.h"
#include "AudioWorkletProcessorBinding.h"
#include "ConsoleBinding.h"
#include "EventTargetBinding.h"
#include "MessagePortBinding.h"
#include "PaintWorkletGlobalScopeBinding.h"
#include "QueuingStrategyBinding.h"
#include "ReadableByteStreamControllerBinding.h"
#include "ReadableStreamBYOBReaderBinding.h"
#include "ReadableStreamBYOBRequestBinding.h"
#include "ReadableStreamBinding.h"
#include "ReadableStreamDefaultControllerBinding.h"
#include "ReadableStreamDefaultReaderBinding.h"
#include "TransformStreamBinding.h"
#include "TransformStreamDefaultControllerBinding.h"
#include "WorkletGlobalScopeBinding.h"
#include "WritableStreamBinding.h"
#include "WritableStreamDefaultControllerBinding.h"
#include "WritableStreamDefaultWriterBinding.h"

namespace mozilla::dom {
bool
RegisterWorkletBindings(JSContext* aCx, JS::Handle<JSObject*> aObj)
{
  if (!AudioWorkletGlobalScope_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!AudioWorkletProcessor_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ByteLengthQueuingStrategy_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ConsoleInstance_Binding::ConstructorEnabled(aCx, aObj) && !ConsoleInstance_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!CountQueuingStrategy_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!EventTarget_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!MessagePort_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!PaintWorkletGlobalScope_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ReadableByteStreamController_Binding::ConstructorEnabled(aCx, aObj) && !ReadableByteStreamController_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!ReadableStream_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ReadableStreamBYOBReader_Binding::ConstructorEnabled(aCx, aObj) && !ReadableStreamBYOBReader_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ReadableStreamBYOBRequest_Binding::ConstructorEnabled(aCx, aObj) && !ReadableStreamBYOBRequest_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ReadableStreamDefaultController_Binding::ConstructorEnabled(aCx, aObj) && !ReadableStreamDefaultController_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (ReadableStreamDefaultReader_Binding::ConstructorEnabled(aCx, aObj) && !ReadableStreamDefaultReader_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (TransformStream_Binding::ConstructorEnabled(aCx, aObj) && !TransformStream_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (TransformStreamDefaultController_Binding::ConstructorEnabled(aCx, aObj) && !TransformStreamDefaultController_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!WorkletGlobalScope_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WritableStream_Binding::ConstructorEnabled(aCx, aObj) && !WritableStream_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WritableStreamDefaultController_Binding::ConstructorEnabled(aCx, aObj) && !WritableStreamDefaultController_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (WritableStreamDefaultWriter_Binding::ConstructorEnabled(aCx, aObj) && !WritableStreamDefaultWriter_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  if (!console_Binding::GetConstructorObject(aCx)) {
    return false;
  }

  return true;
}

} // namespace mozilla::dom

