//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/IPCBlob.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"


//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union RemoteLazyStream|
//
namespace mozilla {
auto RemoteLazyStream::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TRemoteLazyInputStream:
        {
            (ptr_RemoteLazyInputStream())->~RemoteLazyInputStream__tdef();
            break;
        }
    case TIPCStream:
        {
            (ptr_IPCStream())->~IPCStream__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT RemoteLazyStream::RemoteLazyStream(RemoteLazyInputStream* aOther)
{
    new (mozilla::KnownNotNull, ptr_RemoteLazyInputStream()) RefPtr<RemoteLazyInputStream>(aOther);
    mType = TRemoteLazyInputStream;
}

MOZ_IMPLICIT RemoteLazyStream::RemoteLazyStream(RefPtr<RemoteLazyInputStream>&& aOther)
{
    new (mozilla::KnownNotNull, ptr_RemoteLazyInputStream()) RefPtr<RemoteLazyInputStream>(std::move(aOther));
    mType = TRemoteLazyInputStream;
}

MOZ_IMPLICIT RemoteLazyStream::RemoteLazyStream(const IPCStream& aOther)
{
    new (mozilla::KnownNotNull, ptr_IPCStream()) IPCStream(aOther);
    mType = TIPCStream;
}

MOZ_IMPLICIT RemoteLazyStream::RemoteLazyStream(IPCStream&& aOther)
{
    new (mozilla::KnownNotNull, ptr_IPCStream()) IPCStream(std::move(aOther));
    mType = TIPCStream;
}

MOZ_IMPLICIT RemoteLazyStream::RemoteLazyStream(const RemoteLazyStream& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TRemoteLazyInputStream:
        {
            new (mozilla::KnownNotNull, ptr_RemoteLazyInputStream()) RefPtr<RemoteLazyInputStream>((aOther).get_RemoteLazyInputStream());
            break;
        }
    case TIPCStream:
        {
            new (mozilla::KnownNotNull, ptr_IPCStream()) IPCStream((aOther).get_IPCStream());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT RemoteLazyStream::RemoteLazyStream(RemoteLazyStream&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case TRemoteLazyInputStream:
        {
            new (mozilla::KnownNotNull, ptr_RemoteLazyInputStream()) RefPtr<RemoteLazyInputStream>(std::move((aOther).get_RemoteLazyInputStream()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case TIPCStream:
        {
            new (mozilla::KnownNotNull, ptr_IPCStream()) IPCStream(std::move((aOther).get_IPCStream()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

RemoteLazyStream::~RemoteLazyStream()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto RemoteLazyStream::operator=(RemoteLazyInputStream* aRhs) -> RemoteLazyStream&
{
    if (MaybeDestroy(TRemoteLazyInputStream)) {
        new (mozilla::KnownNotNull, ptr_RemoteLazyInputStream()) RefPtr<RemoteLazyInputStream>;
    }
    (*(ptr_RemoteLazyInputStream())) = aRhs;
    mType = TRemoteLazyInputStream;
    return (*(this));
}

auto RemoteLazyStream::operator=(RefPtr<RemoteLazyInputStream>&& aRhs) -> RemoteLazyStream&
{
    if (MaybeDestroy(TRemoteLazyInputStream)) {
        new (mozilla::KnownNotNull, ptr_RemoteLazyInputStream()) RefPtr<RemoteLazyInputStream>;
    }
    (*(ptr_RemoteLazyInputStream())) = std::move(aRhs);
    mType = TRemoteLazyInputStream;
    return (*(this));
}

auto RemoteLazyStream::operator=(const IPCStream& aRhs) -> RemoteLazyStream&
{
    if (MaybeDestroy(TIPCStream)) {
        new (mozilla::KnownNotNull, ptr_IPCStream()) IPCStream;
    }
    (*(ptr_IPCStream())) = aRhs;
    mType = TIPCStream;
    return (*(this));
}

auto RemoteLazyStream::operator=(IPCStream&& aRhs) -> RemoteLazyStream&
{
    if (MaybeDestroy(TIPCStream)) {
        new (mozilla::KnownNotNull, ptr_IPCStream()) IPCStream;
    }
    (*(ptr_IPCStream())) = std::move(aRhs);
    mType = TIPCStream;
    return (*(this));
}

auto RemoteLazyStream::operator=(const RemoteLazyStream& aRhs) -> RemoteLazyStream&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TRemoteLazyInputStream:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_RemoteLazyInputStream()) RefPtr<RemoteLazyInputStream>;
            }
            (*(ptr_RemoteLazyInputStream())) = (aRhs).get_RemoteLazyInputStream();
            break;
        }
    case TIPCStream:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_IPCStream()) IPCStream;
            }
            (*(ptr_IPCStream())) = (aRhs).get_IPCStream();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto RemoteLazyStream::operator=(RemoteLazyStream&& aRhs) -> RemoteLazyStream&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TRemoteLazyInputStream:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_RemoteLazyInputStream()) RefPtr<RemoteLazyInputStream>;
            }
            (*(ptr_RemoteLazyInputStream())) = std::move((aRhs).get_RemoteLazyInputStream());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case TIPCStream:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_IPCStream()) IPCStream;
            }
            (*(ptr_IPCStream())) = std::move((aRhs).get_IPCStream());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

} // namespace mozilla

namespace IPC {
auto ParamTraits<mozilla::RemoteLazyStream>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    typedef mozilla::RemoteLazyStream union__;
    int type = (aVar).type();
    IPC::WriteParam(aWriter, type);
    // Sentinel = 'RemoteLazyStream'
    (aWriter)->WriteSentinel(911672953);

    switch (type) {
    case union__::TRemoteLazyInputStream:
        {
            IPC::WriteParam(aWriter, (aVar).get_RemoteLazyInputStream());
            // Sentinel = 'TRemoteLazyInputStream'
            (aWriter)->WriteSentinel(1677986013);
            return;
        }
    case union__::TIPCStream:
        {
            IPC::WriteParam(aWriter, (aVar).get_IPCStream());
            // Sentinel = 'TIPCStream'
            (aWriter)->WriteSentinel(311690141);
            return;
        }
    default:
        {
            aWriter->FatalError("unknown union type");
            return;
        }
    }
}

auto ParamTraits<mozilla::RemoteLazyStream>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    typedef mozilla::RemoteLazyStream union__;
    int type = 0;
    if ((!(IPC::ReadParam(aReader, (&(type)))))) {
        aReader->FatalError("Error deserializing type of union RemoteLazyStream");
        return false;
    }
    // Sentinel = 'RemoteLazyStream'
    if ((!((aReader)->ReadSentinel(911672953)))) {
        mozilla::ipc::SentinelReadError("Error deserializing type of union RemoteLazyStream");
        return false;
    }

    switch (type) {
    case union__::TRemoteLazyInputStream:
        {
            RefPtr<mozilla::RemoteLazyInputStream> tmp = RefPtr<mozilla::RemoteLazyInputStream>();
            (*(aVar)) = std::move(tmp);
            if ((!(IPC::ReadParam(aReader, (&((aVar)->get_RemoteLazyInputStream())))))) {
                aReader->FatalError("Error deserializing variant TRemoteLazyInputStream of union RemoteLazyStream");
                return false;
            }
            // Sentinel = 'TRemoteLazyInputStream'
            if ((!((aReader)->ReadSentinel(1677986013)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant TRemoteLazyInputStream of union RemoteLazyStream");
                return false;
            }
            return true;
        }
    case union__::TIPCStream:
        {
            mozilla::ipc::IPCStream tmp = mozilla::ipc::IPCStream();
            (*(aVar)) = std::move(tmp);
            if ((!(IPC::ReadParam(aReader, (&((aVar)->get_IPCStream())))))) {
                aReader->FatalError("Error deserializing variant TIPCStream of union RemoteLazyStream");
                return false;
            }
            // Sentinel = 'TIPCStream'
            if ((!((aReader)->ReadSentinel(311690141)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant TIPCStream of union RemoteLazyStream");
                return false;
            }
            return true;
        }
    default:
        {
            aReader->FatalError("unknown union type");
            return false;
        }
    }
}

} // namespace IPC

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct IPCFile|
//
namespace mozilla {
namespace dom {
} // namespace dom
} // namespace mozilla

namespace IPC {
auto ParamTraits<mozilla::dom::IPCFile>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    IPC::WriteParam(aWriter, (aVar).name());
    // Sentinel = 'name'
    (aWriter)->WriteSentinel(69075362);
    IPC::WriteParam(aWriter, (aVar).DOMPath());
    // Sentinel = 'DOMPath'
    (aWriter)->WriteSentinel(150012526);
    IPC::WriteParam(aWriter, (aVar).fullPath());
    // Sentinel = 'fullPath'
    (aWriter)->WriteSentinel(247595841);
    IPC::WriteParam(aWriter, (aVar).isDirectory());
    // Sentinel = 'isDirectory'
    (aWriter)->WriteSentinel(446497938);
    (aWriter)->WriteBytes((&((aVar).lastModified())), 8);
    // Sentinel = 'lastModified'
    (aWriter)->WriteSentinel(531629270);
}

auto ParamTraits<mozilla::dom::IPCFile>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    if ((!(IPC::ReadParam(aReader, (&((aVar)->name())))))) {
        aReader->FatalError("Error deserializing 'name' (nsString) member of 'IPCFile'");
        return false;
    }
    // Sentinel = 'name'
    if ((!((aReader)->ReadSentinel(69075362)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'name' (nsString) member of 'IPCFile'");
        return false;
    }
    if ((!(IPC::ReadParam(aReader, (&((aVar)->DOMPath())))))) {
        aReader->FatalError("Error deserializing 'DOMPath' (nsString) member of 'IPCFile'");
        return false;
    }
    // Sentinel = 'DOMPath'
    if ((!((aReader)->ReadSentinel(150012526)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'DOMPath' (nsString) member of 'IPCFile'");
        return false;
    }
    if ((!(IPC::ReadParam(aReader, (&((aVar)->fullPath())))))) {
        aReader->FatalError("Error deserializing 'fullPath' (nsString) member of 'IPCFile'");
        return false;
    }
    // Sentinel = 'fullPath'
    if ((!((aReader)->ReadSentinel(247595841)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'fullPath' (nsString) member of 'IPCFile'");
        return false;
    }
    if ((!(IPC::ReadParam(aReader, (&((aVar)->isDirectory())))))) {
        aReader->FatalError("Error deserializing 'isDirectory' (bool) member of 'IPCFile'");
        return false;
    }
    // Sentinel = 'isDirectory'
    if ((!((aReader)->ReadSentinel(446497938)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'isDirectory' (bool) member of 'IPCFile'");
        return false;
    }
    if ((!((aReader)->ReadBytesInto((&((aVar)->lastModified())), 8)))) {
        aReader->FatalError("Error bulk reading fields from int64_t");
        return false;
    }
    // Sentinel = 'lastModified'
    if ((!((aReader)->ReadSentinel(531629270)))) {
        mozilla::ipc::SentinelReadError("Error bulk reading fields from int64_t");
        return false;
    }
    return true;
}

} // namespace IPC

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct IPCBlob|
//
namespace mozilla {
namespace dom {
auto IPCBlob::StaticAssertions() const -> void
{
    static_assert(
        (offsetof(IPCBlob, fileId_) - offsetof(IPCBlob, size_)) == 8,
        "Bad assumptions about field layout!");
}

} // namespace dom
} // namespace mozilla

namespace IPC {
auto ParamTraits<mozilla::dom::IPCBlob>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    IPC::WriteParam(aWriter, (aVar).type());
    // Sentinel = 'type'
    (aWriter)->WriteSentinel(75760067);
    IPC::WriteParam(aWriter, (aVar).blobImplType());
    // Sentinel = 'blobImplType'
    (aWriter)->WriteSentinel(521077972);
    IPC::WriteParam(aWriter, (aVar).inputStream());
    // Sentinel = 'inputStream'
    (aWriter)->WriteSentinel(469370013);
    IPC::WriteParam(aWriter, (aVar).file());
    // Sentinel = 'file'
    (aWriter)->WriteSentinel(68420001);
    (aWriter)->WriteBytes((&((aVar).size())), 16);
    // Sentinel = 'size | fileId'
    (aWriter)->WriteSentinel(572916933);
}

auto ParamTraits<mozilla::dom::IPCBlob>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    if ((!(IPC::ReadParam(aReader, (&((aVar)->type())))))) {
        aReader->FatalError("Error deserializing 'type' (nsString) member of 'IPCBlob'");
        return false;
    }
    // Sentinel = 'type'
    if ((!((aReader)->ReadSentinel(75760067)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'type' (nsString) member of 'IPCBlob'");
        return false;
    }
    if ((!(IPC::ReadParam(aReader, (&((aVar)->blobImplType())))))) {
        aReader->FatalError("Error deserializing 'blobImplType' (nsString) member of 'IPCBlob'");
        return false;
    }
    // Sentinel = 'blobImplType'
    if ((!((aReader)->ReadSentinel(521077972)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'blobImplType' (nsString) member of 'IPCBlob'");
        return false;
    }
    if ((!(IPC::ReadParam(aReader, (&((aVar)->inputStream())))))) {
        aReader->FatalError("Error deserializing 'inputStream' (RemoteLazyStream) member of 'IPCBlob'");
        return false;
    }
    // Sentinel = 'inputStream'
    if ((!((aReader)->ReadSentinel(469370013)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'inputStream' (RemoteLazyStream) member of 'IPCBlob'");
        return false;
    }
    if ((!(IPC::ReadParam(aReader, (&((aVar)->file())))))) {
        aReader->FatalError("Error deserializing 'file' (IPCFile?) member of 'IPCBlob'");
        return false;
    }
    // Sentinel = 'file'
    if ((!((aReader)->ReadSentinel(68420001)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'file' (IPCFile?) member of 'IPCBlob'");
        return false;
    }
    if ((!((aReader)->ReadBytesInto((&((aVar)->size())), 16)))) {
        aReader->FatalError("Error bulk reading fields from uint64_t");
        return false;
    }
    // Sentinel = 'size | fileId'
    if ((!((aReader)->ReadSentinel(572916933)))) {
        mozilla::ipc::SentinelReadError("Error bulk reading fields from uint64_t");
        return false;
    }
    return true;
}

} // namespace IPC
