//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/layers/PAPZChild.h"
#include "mozilla/GfxMessageUtils.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/layers/APZChild.h"
#include "mozilla/layers/LayersMessageUtils.h"
#include "mozilla/layers/RemoteContentController.h"
#include "mozilla/layers/RepaintRequest.h"
#include "mozilla/layers/ScrollableLayerGuid.h"
#include "nsRegion.h"

#include "mozilla/layers/PCompositorBridgeChild.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace layers {


MOZ_IMPLICIT PAPZChild::PAPZChild() :
    mozilla::ipc::IProtocol(PAPZMsgStart, mozilla::ipc::ChildSide)
{
    MOZ_COUNT_CTOR(PAPZChild);
}

PAPZChild::~PAPZChild()
{
    MOZ_COUNT_DTOR(PAPZChild);
}

auto PAPZChild::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PAPZChild::Manager() const -> PCompositorBridgeChild*
{
    return static_cast<PCompositorBridgeChild*>(IProtocol::Manager());
}

auto PAPZChild::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    arr__.SetCapacity(total);

}

auto PAPZChild::Send__delete__(PAPZChild* actor) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    UniquePtr<IPC::Message> msg__ = PAPZ::Msg___delete__((actor)->Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            actor};

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    IPC::WriteParam((&(writer__)), actor);
    // Sentinel = 'actor'
    ((&(writer__)))->WriteSentinel(102892058);



    if (mozilla::ipc::LoggingEnabledFor("PAPZChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PAPZChild",
            actor->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PAPZ::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(std::move(msg__));

    IProtocol* mgr = actor->Manager();
    actor->DestroySubtree(Deletion);
    actor->ClearSubtree();
    mgr->RemoveManagee(PAPZMsgStart, actor);
    return sendok__;
}

auto PAPZChild::SendDestroy() -> bool
{
    UniquePtr<IPC::Message> msg__ = PAPZ::Msg_Destroy(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};





    if (mozilla::ipc::LoggingEnabledFor("PAPZChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PAPZChild",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PAPZ::Msg_Destroy", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PAPZChild::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PAPZChild::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PAPZChild::OnMessageReceived(const Message& msg__) -> PAPZChild::Result
{
    switch (msg__.type()) {
    case MANAGED_ENDPOINT_BOUND_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            return MsgProcessed;
        }
    case MANAGED_ENDPOINT_DROPPED_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            IProtocol* mgr = this->Manager();
            this->DestroySubtree(ManagedEndpointDropped);
            this->ClearSubtree();
            mgr->RemoveManagee(PAPZMsgStart, this);
            return MsgProcessed;
        }
    case PAPZ::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    case PAPZ::Msg_LayerTransforms__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PAPZChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PAPZChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PAPZ::Msg_LayerTransforms", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsTArray<MatrixMessage> aTransforms{};

            if ((!(IPC::ReadParam((&(reader__)), (&(aTransforms)))))) {
                FatalError("Error deserializing 'MatrixMessage[]'");
                return MsgValueError;
            }
            // Sentinel = 'aTransforms'
            if ((!(((&(reader__)))->ReadSentinel(446235793)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'MatrixMessage[]'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<APZChild*>(this))->RecvLayerTransforms(std::move(aTransforms));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PAPZ::Msg_RequestContentRepaint__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PAPZChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PAPZChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PAPZ::Msg_RequestContentRepaint", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            RepaintRequest request{};

            if ((!(IPC::ReadParam((&(reader__)), (&(request)))))) {
                FatalError("Error deserializing 'RepaintRequest'");
                return MsgValueError;
            }
            // Sentinel = 'request'
            if ((!(((&(reader__)))->ReadSentinel(202703626)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'RepaintRequest'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<APZChild*>(this))->RecvRequestContentRepaint(std::move(request));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PAPZ::Msg_UpdateOverscrollVelocity__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PAPZChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PAPZChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PAPZ::Msg_UpdateOverscrollVelocity", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            ScrollableLayerGuid aGuid{};
            float aX{};
            float aY{};
            bool aIsRootContent{};

            if ((!(IPC::ReadParam((&(reader__)), (&(aGuid)))))) {
                FatalError("Error deserializing 'ScrollableLayerGuid'");
                return MsgValueError;
            }
            // Sentinel = 'aGuid'
            if ((!(((&(reader__)))->ReadSentinel(94044651)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ScrollableLayerGuid'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(aX)))))) {
                FatalError("Error deserializing 'float'");
                return MsgValueError;
            }
            // Sentinel = 'aX'
            if ((!(((&(reader__)))->ReadSentinel(18612410)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'float'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(aY)))))) {
                FatalError("Error deserializing 'float'");
                return MsgValueError;
            }
            // Sentinel = 'aY'
            if ((!(((&(reader__)))->ReadSentinel(18677947)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'float'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(aIsRootContent)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            // Sentinel = 'aIsRootContent'
            if ((!(((&(reader__)))->ReadSentinel(683410845)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'bool'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<APZChild*>(this))->RecvUpdateOverscrollVelocity(std::move(aGuid), std::move(aX), std::move(aY), std::move(aIsRootContent));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PAPZ::Msg_UpdateOverscrollOffset__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PAPZChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PAPZChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PAPZ::Msg_UpdateOverscrollOffset", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            ScrollableLayerGuid aGuid{};
            float aX{};
            float aY{};
            bool aIsRootContent{};

            if ((!(IPC::ReadParam((&(reader__)), (&(aGuid)))))) {
                FatalError("Error deserializing 'ScrollableLayerGuid'");
                return MsgValueError;
            }
            // Sentinel = 'aGuid'
            if ((!(((&(reader__)))->ReadSentinel(94044651)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ScrollableLayerGuid'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(aX)))))) {
                FatalError("Error deserializing 'float'");
                return MsgValueError;
            }
            // Sentinel = 'aX'
            if ((!(((&(reader__)))->ReadSentinel(18612410)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'float'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(aY)))))) {
                FatalError("Error deserializing 'float'");
                return MsgValueError;
            }
            // Sentinel = 'aY'
            if ((!(((&(reader__)))->ReadSentinel(18677947)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'float'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(aIsRootContent)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            // Sentinel = 'aIsRootContent'
            if ((!(((&(reader__)))->ReadSentinel(683410845)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'bool'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<APZChild*>(this))->RecvUpdateOverscrollOffset(std::move(aGuid), std::move(aX), std::move(aY), std::move(aIsRootContent));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PAPZ::Msg_NotifyMozMouseScrollEvent__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PAPZChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PAPZChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PAPZ::Msg_NotifyMozMouseScrollEvent", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            ViewID aScrollId{};
            nsString aEvent{};

            if ((!(IPC::ReadParam((&(reader__)), (&(aScrollId)))))) {
                FatalError("Error deserializing 'ViewID'");
                return MsgValueError;
            }
            // Sentinel = 'aScrollId'
            if ((!(((&(reader__)))->ReadSentinel(293602174)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ViewID'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(aEvent)))))) {
                FatalError("Error deserializing 'nsString'");
                return MsgValueError;
            }
            // Sentinel = 'aEvent'
            if ((!(((&(reader__)))->ReadSentinel(133956196)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsString'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<APZChild*>(this))->RecvNotifyMozMouseScrollEvent(std::move(aScrollId), std::move(aEvent));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PAPZ::Msg_NotifyAPZStateChange__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PAPZChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PAPZChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PAPZ::Msg_NotifyAPZStateChange", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            ScrollableLayerGuid aGuid{};
            GeckoContentController_APZStateChange aChange{};
            int aArg{};

            if ((!(IPC::ReadParam((&(reader__)), (&(aGuid)))))) {
                FatalError("Error deserializing 'ScrollableLayerGuid'");
                return MsgValueError;
            }
            // Sentinel = 'aGuid'
            if ((!(((&(reader__)))->ReadSentinel(94044651)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ScrollableLayerGuid'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(aChange)))))) {
                FatalError("Error deserializing 'GeckoContentController_APZStateChange'");
                return MsgValueError;
            }
            // Sentinel = 'aChange'
            if ((!(((&(reader__)))->ReadSentinel(172556968)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'GeckoContentController_APZStateChange'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(aArg)))))) {
                FatalError("Error deserializing 'int'");
                return MsgValueError;
            }
            // Sentinel = 'aArg'
            if ((!(((&(reader__)))->ReadSentinel(60162428)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'int'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<APZChild*>(this))->RecvNotifyAPZStateChange(std::move(aGuid), std::move(aChange), std::move(aArg));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PAPZ::Msg_NotifyFlushComplete__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PAPZChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PAPZChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PAPZ::Msg_NotifyFlushComplete", OTHER);

            mozilla::ipc::IPCResult __ok = (static_cast<APZChild*>(this))->RecvNotifyFlushComplete();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PAPZ::Msg_NotifyAsyncScrollbarDragInitiated__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PAPZChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PAPZChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PAPZ::Msg_NotifyAsyncScrollbarDragInitiated", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            uint64_t aDragBlockId{};
            ViewID aScrollId{};
            ScrollDirection aDirection{};

            if ((!(IPC::ReadParam((&(reader__)), (&(aDragBlockId)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            // Sentinel = 'aDragBlockId'
            if ((!(((&(reader__)))->ReadSentinel(484246648)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(aScrollId)))))) {
                FatalError("Error deserializing 'ViewID'");
                return MsgValueError;
            }
            // Sentinel = 'aScrollId'
            if ((!(((&(reader__)))->ReadSentinel(293602174)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ViewID'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(aDirection)))))) {
                FatalError("Error deserializing 'ScrollDirection'");
                return MsgValueError;
            }
            // Sentinel = 'aDirection'
            if ((!(((&(reader__)))->ReadSentinel(356647939)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ScrollDirection'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<APZChild*>(this))->RecvNotifyAsyncScrollbarDragInitiated(std::move(aDragBlockId), std::move(aScrollId), std::move(aDirection));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PAPZ::Msg_NotifyAsyncScrollbarDragRejected__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PAPZChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PAPZChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PAPZ::Msg_NotifyAsyncScrollbarDragRejected", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            ViewID aScrollId{};

            if ((!(IPC::ReadParam((&(reader__)), (&(aScrollId)))))) {
                FatalError("Error deserializing 'ViewID'");
                return MsgValueError;
            }
            // Sentinel = 'aScrollId'
            if ((!(((&(reader__)))->ReadSentinel(293602174)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ViewID'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<APZChild*>(this))->RecvNotifyAsyncScrollbarDragRejected(std::move(aScrollId));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PAPZ::Msg_NotifyAsyncAutoscrollRejected__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PAPZChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PAPZChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PAPZ::Msg_NotifyAsyncAutoscrollRejected", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            ViewID aScrollId{};

            if ((!(IPC::ReadParam((&(reader__)), (&(aScrollId)))))) {
                FatalError("Error deserializing 'ViewID'");
                return MsgValueError;
            }
            // Sentinel = 'aScrollId'
            if ((!(((&(reader__)))->ReadSentinel(293602174)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'ViewID'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<APZChild*>(this))->RecvNotifyAsyncAutoscrollRejected(std::move(aScrollId));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PAPZ::Msg_Destroy__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PAPZChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PAPZChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PAPZ::Msg_Destroy", OTHER);

            mozilla::ipc::IPCResult __ok = (static_cast<APZChild*>(this))->RecvDestroy();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PAPZChild::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PAPZChild::Result
{
    return MsgNotKnown;
}

auto PAPZChild::OnCallReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PAPZChild::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PAPZChild::ClearSubtree() -> void
{
}



} // namespace layers
} // namespace mozilla
namespace IPC {
auto ParamTraits<mozilla::layers::PAPZChild*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<mozilla::layers::PAPZChild*>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");

    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aReader->GetActor()->ReadActor(aReader, true, "PAPZ", PAPZMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::layers::PAPZChild*>(actor.value());
    return true;
}

} // namespace IPC
