//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PBackgroundStorageParent.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/dom/quota/SerializationHelpers.h"

#include "mozilla/ipc/PBackgroundParent.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace dom {


MOZ_IMPLICIT PBackgroundStorageParent::PBackgroundStorageParent() :
    mozilla::ipc::IProtocol(PBackgroundStorageMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PBackgroundStorageParent);
}

PBackgroundStorageParent::~PBackgroundStorageParent()
{
    MOZ_COUNT_DTOR(PBackgroundStorageParent);
}

auto PBackgroundStorageParent::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PBackgroundStorageParent::Manager() const -> PBackgroundParent*
{
    return static_cast<PBackgroundParent*>(IProtocol::Manager());
}

auto PBackgroundStorageParent::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    arr__.SetCapacity(total);

}

auto PBackgroundStorageParent::Send__delete__(PBackgroundStorageParent* actor) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    UniquePtr<IPC::Message> msg__ = PBackgroundStorage::Msg___delete__((actor)->Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            actor};

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    IPC::WriteParam((&(writer__)), actor);
    // Sentinel = 'actor'
    ((&(writer__)))->WriteSentinel(102892058);



    if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PBackgroundStorageParent",
            actor->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PBackgroundStorage::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(std::move(msg__));

    IProtocol* mgr = actor->Manager();
    actor->DestroySubtree(Deletion);
    actor->ClearSubtree();
    mgr->RemoveManagee(PBackgroundStorageMsgStart, actor);
    return sendok__;
}

auto PBackgroundStorageParent::SendObserve(
        const nsCString& topic,
        const nsString& originAttributesPattern,
        const nsCString& originScope) -> bool
{
    UniquePtr<IPC::Message> msg__ = PBackgroundStorage::Msg_Observe(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), topic);
    // Sentinel = 'topic'
    ((&(writer__)))->WriteSentinel(109707808);
    IPC::WriteParam((&(writer__)), originAttributesPattern);
    // Sentinel = 'originAttributesPattern'
    ((&(writer__)))->WriteSentinel(1917913486);
    IPC::WriteParam((&(writer__)), originScope);
    // Sentinel = 'originScope'
    ((&(writer__)))->WriteSentinel(459080835);




    if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PBackgroundStorageParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_Observe", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PBackgroundStorageParent::SendOriginsHavingData(const nsTArray<nsCString>& origins) -> bool
{
    UniquePtr<IPC::Message> msg__ = PBackgroundStorage::Msg_OriginsHavingData(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), origins);
    // Sentinel = 'origins'
    ((&(writer__)))->WriteSentinel(200213244);




    if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PBackgroundStorageParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_OriginsHavingData", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PBackgroundStorageParent::SendLoadItem(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const nsString& key,
        const nsString& value) -> bool
{
    UniquePtr<IPC::Message> msg__ = PBackgroundStorage::Msg_LoadItem(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), originSuffix);
    // Sentinel = 'originSuffix'
    ((&(writer__)))->WriteSentinel(544736510);
    IPC::WriteParam((&(writer__)), originNoSuffix);
    // Sentinel = 'originNoSuffix'
    ((&(writer__)))->WriteSentinel(721618363);
    IPC::WriteParam((&(writer__)), key);
    // Sentinel = 'key'
    ((&(writer__)))->WriteSentinel(42402122);
    IPC::WriteParam((&(writer__)), value);
    // Sentinel = 'value'
    ((&(writer__)))->WriteSentinel(107610654);




    if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PBackgroundStorageParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_LoadItem", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PBackgroundStorageParent::SendLoadDone(
        const nsCString& originSuffix,
        const nsCString& originNoSuffix,
        const nsresult& rv) -> bool
{
    UniquePtr<IPC::Message> msg__ = PBackgroundStorage::Msg_LoadDone(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), originSuffix);
    // Sentinel = 'originSuffix'
    ((&(writer__)))->WriteSentinel(544736510);
    IPC::WriteParam((&(writer__)), originNoSuffix);
    // Sentinel = 'originNoSuffix'
    ((&(writer__)))->WriteSentinel(721618363);
    IPC::WriteParam((&(writer__)), rv);
    // Sentinel = 'rv'
    ((&(writer__)))->WriteSentinel(22806761);




    if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PBackgroundStorageParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_LoadDone", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PBackgroundStorageParent::SendLoadUsage(
        const nsCString& scope,
        const int64_t& usage) -> bool
{
    UniquePtr<IPC::Message> msg__ = PBackgroundStorage::Msg_LoadUsage(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), scope);
    // Sentinel = 'scope'
    ((&(writer__)))->WriteSentinel(107086363);
    IPC::WriteParam((&(writer__)), usage);
    // Sentinel = 'usage'
    ((&(writer__)))->WriteSentinel(108003862);




    if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PBackgroundStorageParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_LoadUsage", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PBackgroundStorageParent::SendError(const nsresult& rv) -> bool
{
    UniquePtr<IPC::Message> msg__ = PBackgroundStorage::Msg_Error(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), rv);
    // Sentinel = 'rv'
    ((&(writer__)))->WriteSentinel(22806761);




    if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PBackgroundStorageParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_Error", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PBackgroundStorageParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PBackgroundStorageParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PBackgroundStorageParent::OnMessageReceived(const Message& msg__) -> PBackgroundStorageParent::Result
{
    switch (msg__.type()) {
    case MANAGED_ENDPOINT_BOUND_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            return MsgProcessed;
        }
    case MANAGED_ENDPOINT_DROPPED_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            IProtocol* mgr = this->Manager();
            this->DestroySubtree(ManagedEndpointDropped);
            this->ClearSubtree();
            mgr->RemoveManagee(PBackgroundStorageMsgStart, this);
            return MsgProcessed;
        }
    case PBackgroundStorage::Msg_DeleteMe__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_DeleteMe", OTHER);

            mozilla::ipc::IPCResult __ok = (this)->RecvDeleteMe();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBackgroundStorage::Msg_AsyncPreload__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_AsyncPreload", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsCString originSuffix{};
            nsCString originNoSuffix{};
            bool priority{};

            if ((!(IPC::ReadParam((&(reader__)), (&(originSuffix)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'originSuffix'
            if ((!(((&(reader__)))->ReadSentinel(544736510)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(originNoSuffix)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'originNoSuffix'
            if ((!(((&(reader__)))->ReadSentinel(721618363)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(priority)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            // Sentinel = 'priority'
            if ((!(((&(reader__)))->ReadSentinel(262865795)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'bool'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (this)->RecvAsyncPreload(std::move(originSuffix), std::move(originNoSuffix), std::move(priority));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBackgroundStorage::Msg_AsyncGetUsage__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_AsyncGetUsage", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsCString scope{};

            if ((!(IPC::ReadParam((&(reader__)), (&(scope)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'scope'
            if ((!(((&(reader__)))->ReadSentinel(107086363)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (this)->RecvAsyncGetUsage(std::move(scope));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBackgroundStorage::Msg_AsyncAddItem__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_AsyncAddItem", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsCString originSuffix{};
            nsCString originNoSuffix{};
            nsString key{};
            nsString value{};

            if ((!(IPC::ReadParam((&(reader__)), (&(originSuffix)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'originSuffix'
            if ((!(((&(reader__)))->ReadSentinel(544736510)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(originNoSuffix)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'originNoSuffix'
            if ((!(((&(reader__)))->ReadSentinel(721618363)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(key)))))) {
                FatalError("Error deserializing 'nsString'");
                return MsgValueError;
            }
            // Sentinel = 'key'
            if ((!(((&(reader__)))->ReadSentinel(42402122)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(value)))))) {
                FatalError("Error deserializing 'nsString'");
                return MsgValueError;
            }
            // Sentinel = 'value'
            if ((!(((&(reader__)))->ReadSentinel(107610654)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsString'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (this)->RecvAsyncAddItem(std::move(originSuffix), std::move(originNoSuffix), std::move(key), std::move(value));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBackgroundStorage::Msg_AsyncUpdateItem__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_AsyncUpdateItem", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsCString originSuffix{};
            nsCString originNoSuffix{};
            nsString key{};
            nsString value{};

            if ((!(IPC::ReadParam((&(reader__)), (&(originSuffix)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'originSuffix'
            if ((!(((&(reader__)))->ReadSentinel(544736510)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(originNoSuffix)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'originNoSuffix'
            if ((!(((&(reader__)))->ReadSentinel(721618363)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(key)))))) {
                FatalError("Error deserializing 'nsString'");
                return MsgValueError;
            }
            // Sentinel = 'key'
            if ((!(((&(reader__)))->ReadSentinel(42402122)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(value)))))) {
                FatalError("Error deserializing 'nsString'");
                return MsgValueError;
            }
            // Sentinel = 'value'
            if ((!(((&(reader__)))->ReadSentinel(107610654)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsString'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (this)->RecvAsyncUpdateItem(std::move(originSuffix), std::move(originNoSuffix), std::move(key), std::move(value));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBackgroundStorage::Msg_AsyncRemoveItem__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_AsyncRemoveItem", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsCString originSuffix{};
            nsCString originNoSuffix{};
            nsString key{};

            if ((!(IPC::ReadParam((&(reader__)), (&(originSuffix)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'originSuffix'
            if ((!(((&(reader__)))->ReadSentinel(544736510)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(originNoSuffix)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'originNoSuffix'
            if ((!(((&(reader__)))->ReadSentinel(721618363)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(key)))))) {
                FatalError("Error deserializing 'nsString'");
                return MsgValueError;
            }
            // Sentinel = 'key'
            if ((!(((&(reader__)))->ReadSentinel(42402122)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsString'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (this)->RecvAsyncRemoveItem(std::move(originSuffix), std::move(originNoSuffix), std::move(key));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBackgroundStorage::Msg_AsyncClear__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_AsyncClear", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsCString originSuffix{};
            nsCString originNoSuffix{};

            if ((!(IPC::ReadParam((&(reader__)), (&(originSuffix)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'originSuffix'
            if ((!(((&(reader__)))->ReadSentinel(544736510)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(originNoSuffix)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'originNoSuffix'
            if ((!(((&(reader__)))->ReadSentinel(721618363)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (this)->RecvAsyncClear(std::move(originSuffix), std::move(originNoSuffix));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBackgroundStorage::Msg_AsyncFlush__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_AsyncFlush", OTHER);

            mozilla::ipc::IPCResult __ok = (this)->RecvAsyncFlush();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBackgroundStorage::Msg_Startup__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_Startup", OTHER);

            mozilla::ipc::IPCResult __ok = (this)->RecvStartup();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBackgroundStorage::Msg_ClearAll__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_ClearAll", OTHER);

            mozilla::ipc::IPCResult __ok = (this)->RecvClearAll();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBackgroundStorage::Msg_ClearMatchingOrigin__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_ClearMatchingOrigin", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsCString originNoSuffix{};

            if ((!(IPC::ReadParam((&(reader__)), (&(originNoSuffix)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'originNoSuffix'
            if ((!(((&(reader__)))->ReadSentinel(721618363)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (this)->RecvClearMatchingOrigin(std::move(originNoSuffix));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBackgroundStorage::Msg_ClearMatchingOriginAttributes__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_ClearMatchingOriginAttributes", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            OriginAttributesPattern pattern{};

            if ((!(IPC::ReadParam((&(reader__)), (&(pattern)))))) {
                FatalError("Error deserializing 'OriginAttributesPattern'");
                return MsgValueError;
            }
            // Sentinel = 'pattern'
            if ((!(((&(reader__)))->ReadSentinel(200409855)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'OriginAttributesPattern'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (this)->RecvClearMatchingOriginAttributes(std::move(pattern));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PBackgroundStorage::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PBackgroundStorageParent::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PBackgroundStorageParent::Result
{
    switch (msg__.type()) {
    case PBackgroundStorage::Msg_Preload__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PBackgroundStorage::Msg_Preload", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsCString originSuffix{};
            nsCString originNoSuffix{};
            uint32_t alreadyLoadedCount{};

            if ((!(IPC::ReadParam((&(reader__)), (&(originSuffix)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'originSuffix'
            if ((!(((&(reader__)))->ReadSentinel(544736510)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(originNoSuffix)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'originNoSuffix'
            if ((!(((&(reader__)))->ReadSentinel(721618363)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(alreadyLoadedCount)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            // Sentinel = 'alreadyLoadedCount'
            if ((!(((&(reader__)))->ReadSentinel(1143015221)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            reader__.EndRead();
            int32_t id__ = Id();
            nsTArray<nsString> keys{};
            nsTArray<nsString> values{};
            nsresult rv{};
            mozilla::ipc::IPCResult __ok = (this)->RecvPreload(std::move(originSuffix), std::move(originNoSuffix), std::move(alreadyLoadedCount), (&(keys)), (&(values)), (&(rv)));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            reply__ = PBackgroundStorage::Reply_Preload(id__);
            IPC::MessageWriter writer__{
                    (*(reply__)),
                    this};

            IPC::WriteParam((&(writer__)), keys);
            // Sentinel = 'keys'
            ((&(writer__)))->WriteSentinel(71565757);
            IPC::WriteParam((&(writer__)), values);
            // Sentinel = 'values'
            ((&(writer__)))->WriteSentinel(150667921);
            IPC::WriteParam((&(writer__)), rv);
            // Sentinel = 'rv'
            ((&(writer__)))->WriteSentinel(22806761);

            if (mozilla::ipc::LoggingEnabledFor("PBackgroundStorageParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PBackgroundStorageParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Sending reply ",
                    reply__->type(),
                    mozilla::ipc::MessageDirection::eSending);
            }
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PBackgroundStorageParent::OnCallReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PBackgroundStorageParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PBackgroundStorageParent::ClearSubtree() -> void
{
}



} // namespace dom
} // namespace mozilla
namespace IPC {
auto ParamTraits<mozilla::dom::PBackgroundStorageParent*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<mozilla::dom::PBackgroundStorageParent*>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");

    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aReader->GetActor()->ReadActor(aReader, true, "PBackgroundStorage", PBackgroundStorageMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::dom::PBackgroundStorageParent*>(actor.value());
    return true;
}

} // namespace IPC
