//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PFileSystemRequestChild.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/RemoteLazyInputStream.h"
#include "mozilla/dom/FileSystemTaskBase.h"
#include "mozilla/ipc/IPCCore.h"

#include "mozilla/ipc/PBackgroundChild.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace dom {


MOZ_IMPLICIT PFileSystemRequestChild::PFileSystemRequestChild() :
    mozilla::ipc::IProtocol(PFileSystemRequestMsgStart, mozilla::ipc::ChildSide)
{
    MOZ_COUNT_CTOR(PFileSystemRequestChild);
}

PFileSystemRequestChild::~PFileSystemRequestChild()
{
    MOZ_COUNT_DTOR(PFileSystemRequestChild);
}

auto PFileSystemRequestChild::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PFileSystemRequestChild::Manager() const -> PBackgroundChild*
{
    return static_cast<PBackgroundChild*>(IProtocol::Manager());
}

auto PFileSystemRequestChild::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    arr__.SetCapacity(total);

}

auto PFileSystemRequestChild::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PFileSystemRequestChild::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PFileSystemRequestChild::OnMessageReceived(const Message& msg__) -> PFileSystemRequestChild::Result
{
    switch (msg__.type()) {
    case MANAGED_ENDPOINT_BOUND_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            return MsgProcessed;
        }
    case MANAGED_ENDPOINT_DROPPED_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            IProtocol* mgr = this->Manager();
            this->DestroySubtree(ManagedEndpointDropped);
            this->ClearSubtree();
            mgr->RemoveManagee(PFileSystemRequestMsgStart, this);
            return MsgProcessed;
        }
    case PFileSystemRequest::Msg___delete____ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PFileSystemRequestChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PFileSystemRequestChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PFileSystemRequest::Msg___delete__", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            PFileSystemRequestChild* actor{};
            FileSystemResponseValue response{};

            if ((!(IPC::ReadParam((&(reader__)), (&(actor)))))) {
                FatalError("Error deserializing 'PFileSystemRequest'");
                return MsgValueError;
            }
            if ((!((*((&(actor))))))) {
                FatalError("Error deserializing 'PFileSystemRequest'");
                return MsgValueError;
            }
            // Sentinel = 'actor'
            if ((!(((&(reader__)))->ReadSentinel(102892058)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'PFileSystemRequest'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(response)))))) {
                FatalError("Error deserializing 'FileSystemResponseValue'");
                return MsgValueError;
            }
            // Sentinel = 'response'
            if ((!(((&(reader__)))->ReadSentinel(260965232)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'FileSystemResponseValue'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<FileSystemTaskChildBase*>(this))->Recv__delete__(std::move(response));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }


            IProtocol* mgr = actor->Manager();
            actor->DestroySubtree(Deletion);
            actor->ClearSubtree();
            mgr->RemoveManagee(PFileSystemRequestMsgStart, actor);

            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PFileSystemRequestChild::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PFileSystemRequestChild::Result
{
    return MsgNotKnown;
}

auto PFileSystemRequestChild::OnCallReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PFileSystemRequestChild::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PFileSystemRequestChild::ClearSubtree() -> void
{
}



} // namespace dom
} // namespace mozilla
namespace IPC {
auto ParamTraits<mozilla::dom::PFileSystemRequestChild*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<mozilla::dom::PFileSystemRequestChild*>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");

    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aReader->GetActor()->ReadActor(aReader, true, "PFileSystemRequest", PFileSystemRequestMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::dom::PFileSystemRequestChild*>(actor.value());
    return true;
}

} // namespace IPC
