//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PHttpTransactionParent.h"
#include "mozilla/AntiTrackingIPCUtils.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/TimeStamp.h"
#include "mozilla/dom/PropertyBagUtils.h"
#include "mozilla/dom/ReferrerInfoUtils.h"
#include "mozilla/dom/SessionHistoryEntry.h"
#include "mozilla/ipc/URIUtils.h"
#include "mozilla/net/CacheInfoIPCTypes.h"
#include "mozilla/net/ClassOfService.h"
#include "mozilla/net/HttpTransactionParent.h"
#include "mozilla/net/NeckoMessageUtils.h"
#include "nsDOMNavigationTiming.h"
#include "nsHttp.h"
#include "nsHttpHeaderArray.h"
#include "nsHttpRequestHead.h"
#include "nsHttpResponseHead.h"
#include "nsIPropertyBag2.h"

#include "mozilla/net/PSocketProcessParent.h"
#include "mozilla/net/PInputChannelThrottleQueueParent.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace net {


MOZ_IMPLICIT PHttpTransactionParent::PHttpTransactionParent() :
    mozilla::ipc::IProtocol(PHttpTransactionMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PHttpTransactionParent);
}

PHttpTransactionParent::~PHttpTransactionParent()
{
    MOZ_COUNT_DTOR(PHttpTransactionParent);
}

auto PHttpTransactionParent::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PHttpTransactionParent::Manager() const -> PSocketProcessParent*
{
    return static_cast<PSocketProcessParent*>(IProtocol::Manager());
}

auto PHttpTransactionParent::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    arr__.SetCapacity(total);

}

auto PHttpTransactionParent::Send__delete__(PHttpTransactionParent* actor) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    UniquePtr<IPC::Message> msg__ = PHttpTransaction::Msg___delete__((actor)->Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            actor};

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    IPC::WriteParam((&(writer__)), actor);
    // Sentinel = 'actor'
    ((&(writer__)))->WriteSentinel(102892058);



    if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PHttpTransactionParent",
            actor->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PHttpTransaction::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(std::move(msg__));

    IProtocol* mgr = actor->Manager();
    actor->DestroySubtree(Deletion);
    actor->ClearSubtree();
    mgr->RemoveManagee(PHttpTransactionMsgStart, actor);
    return sendok__;
}

auto PHttpTransactionParent::SendInit(
        const uint32_t& caps,
        const HttpConnectionInfoCloneArgs& aArgs,
        const nsHttpRequestHead& reqHeaders,
        const mozilla::Maybe<IPCStream>& requestBody,
        const uint64_t& reqContentLength,
        const bool& reqBodyIncludesHeaders,
        const uint64_t& topLevelOuterContentWindowId,
        const uint8_t& httpTrafficCategory,
        const uint64_t& requestContextID,
        const ClassOfService& classOfService,
        const uint32_t& initialRwin,
        const bool& responseTimeoutEnabled,
        const uint64_t& channelId,
        const bool& hasTransactionObserver,
        const mozilla::Maybe<H2PushedStreamArg>& pushedStreamArg,
        const mozilla::Maybe<PInputChannelThrottleQueueParent*>& throttleQueue,
        const bool& aIsDocumentLoad,
        const TimeStamp& aRedirectStart,
        const TimeStamp& aRedirectEnd) -> bool
{
    UniquePtr<IPC::Message> msg__ = PHttpTransaction::Msg_Init(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), caps);
    // Sentinel = 'caps'
    ((&(writer__)))->WriteSentinel(67502504);
    IPC::WriteParam((&(writer__)), aArgs);
    // Sentinel = 'aArgs'
    ((&(writer__)))->WriteSentinel(92602863);
    IPC::WriteParam((&(writer__)), reqHeaders);
    // Sentinel = 'reqHeaders'
    ((&(writer__)))->WriteSentinel(367264773);
    IPC::WriteParam((&(writer__)), requestBody);
    // Sentinel = 'requestBody'
    ((&(writer__)))->WriteSentinel(466814104);
    IPC::WriteParam((&(writer__)), reqContentLength);
    // Sentinel = 'reqContentLength'
    ((&(writer__)))->WriteSentinel(927794822);
    IPC::WriteParam((&(writer__)), reqBodyIncludesHeaders);
    // Sentinel = 'reqBodyIncludesHeaders'
    ((&(writer__)))->WriteSentinel(1689127114);
    IPC::WriteParam((&(writer__)), topLevelOuterContentWindowId);
    // Sentinel = 'topLevelOuterContentWindowId'
    ((&(writer__)))->WriteSentinel(2779974491);
    IPC::WriteParam((&(writer__)), httpTrafficCategory);
    // Sentinel = 'httpTrafficCategory'
    ((&(writer__)))->WriteSentinel(1295058878);
    IPC::WriteParam((&(writer__)), requestContextID);
    // Sentinel = 'requestContextID'
    ((&(writer__)))->WriteSentinel(956761724);
    IPC::WriteParam((&(writer__)), classOfService);
    // Sentinel = 'classOfService'
    ((&(writer__)))->WriteSentinel(704710045);
    IPC::WriteParam((&(writer__)), initialRwin);
    // Sentinel = 'initialRwin'
    ((&(writer__)))->WriteSentinel(458818699);
    IPC::WriteParam((&(writer__)), responseTimeoutEnabled);
    // Sentinel = 'responseTimeoutEnabled'
    ((&(writer__)))->WriteSentinel(1769408770);
    IPC::WriteParam((&(writer__)), channelId);
    // Sentinel = 'channelId'
    ((&(writer__)))->WriteSentinel(301138823);
    IPC::WriteParam((&(writer__)), hasTransactionObserver);
    // Sentinel = 'hasTransactionObserver'
    ((&(writer__)))->WriteSentinel(1727531275);
    IPC::WriteParam((&(writer__)), pushedStreamArg);
    // Sentinel = 'pushedStreamArg'
    ((&(writer__)))->WriteSentinel(833160720);
    IPC::WriteParam((&(writer__)), throttleQueue);
    // Sentinel = 'throttleQueue'
    ((&(writer__)))->WriteSentinel(653919612);
    IPC::WriteParam((&(writer__)), aIsDocumentLoad);
    // Sentinel = 'aIsDocumentLoad'
    ((&(writer__)))->WriteSentinel(774440413);
    IPC::WriteParam((&(writer__)), aRedirectStart);
    // Sentinel = 'aRedirectStart'
    ((&(writer__)))->WriteSentinel(690554274);
    IPC::WriteParam((&(writer__)), aRedirectEnd);
    // Sentinel = 'aRedirectEnd'
    ((&(writer__)))->WriteSentinel(505808043);




    if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PHttpTransactionParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PHttpTransaction::Msg_Init", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PHttpTransactionParent::SendCancelPump(const nsresult& status) -> bool
{
    UniquePtr<IPC::Message> msg__ = PHttpTransaction::Msg_CancelPump(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), status);
    // Sentinel = 'status'
    ((&(writer__)))->WriteSentinel(154731173);




    if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PHttpTransactionParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PHttpTransaction::Msg_CancelPump", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PHttpTransactionParent::SendSuspendPump() -> bool
{
    UniquePtr<IPC::Message> msg__ = PHttpTransaction::Msg_SuspendPump(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};





    if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PHttpTransactionParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PHttpTransaction::Msg_SuspendPump", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PHttpTransactionParent::SendResumePump() -> bool
{
    UniquePtr<IPC::Message> msg__ = PHttpTransaction::Msg_ResumePump(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};





    if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PHttpTransactionParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PHttpTransaction::Msg_ResumePump", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PHttpTransactionParent::SendSetDNSWasRefreshed() -> bool
{
    UniquePtr<IPC::Message> msg__ = PHttpTransaction::Msg_SetDNSWasRefreshed(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};





    if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PHttpTransactionParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PHttpTransaction::Msg_SetDNSWasRefreshed", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PHttpTransactionParent::SendDontReuseConnection() -> bool
{
    UniquePtr<IPC::Message> msg__ = PHttpTransaction::Msg_DontReuseConnection(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};





    if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PHttpTransactionParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PHttpTransaction::Msg_DontReuseConnection", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PHttpTransactionParent::SendSetH2WSConnRefTaken() -> bool
{
    UniquePtr<IPC::Message> msg__ = PHttpTransaction::Msg_SetH2WSConnRefTaken(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};





    if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PHttpTransactionParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PHttpTransaction::Msg_SetH2WSConnRefTaken", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PHttpTransactionParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PHttpTransactionParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PHttpTransactionParent::OnMessageReceived(const Message& msg__) -> PHttpTransactionParent::Result
{
    switch (msg__.type()) {
    case MANAGED_ENDPOINT_BOUND_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            return MsgProcessed;
        }
    case MANAGED_ENDPOINT_DROPPED_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            IProtocol* mgr = this->Manager();
            this->DestroySubtree(ManagedEndpointDropped);
            this->ClearSubtree();
            mgr->RemoveManagee(PHttpTransactionMsgStart, this);
            return MsgProcessed;
        }
    case PHttpTransaction::Msg_OnStartRequest__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PHttpTransactionParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PHttpTransaction::Msg_OnStartRequest", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsresult status{};
            mozilla::Maybe<nsHttpResponseHead> responseHead{};
            nsCString securityInfoSerialization{};
            bool proxyConnectFailed{};
            TimingStructArgs timings{};
            int32_t proxyConnectResponseCode{};
            nsTArray<uint8_t> dataForSniffer{};
            mozilla::Maybe<nsCString> altSvcUsed{};
            bool dataToChildProcess{};
            bool restarted{};
            uint32_t HTTPSSVCReceivedStage{};
            bool supportsHttp3{};

            if ((!(IPC::ReadParam((&(reader__)), (&(status)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            // Sentinel = 'status'
            if ((!(((&(reader__)))->ReadSentinel(154731173)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(responseHead)))))) {
                FatalError("Error deserializing 'nsHttpResponseHead?'");
                return MsgValueError;
            }
            // Sentinel = 'responseHead'
            if ((!(((&(reader__)))->ReadSentinel(549651682)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsHttpResponseHead?'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(securityInfoSerialization)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'securityInfoSerialization'
            if ((!(((&(reader__)))->ReadSentinel(2263026275)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(proxyConnectFailed)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            // Sentinel = 'proxyConnectFailed'
            if ((!(((&(reader__)))->ReadSentinel(1194002258)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(timings)))))) {
                FatalError("Error deserializing 'TimingStructArgs'");
                return MsgValueError;
            }
            // Sentinel = 'timings'
            if ((!(((&(reader__)))->ReadSentinel(200868604)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'TimingStructArgs'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(proxyConnectResponseCode)))))) {
                FatalError("Error deserializing 'int32_t'");
                return MsgValueError;
            }
            // Sentinel = 'proxyConnectResponseCode'
            if ((!(((&(reader__)))->ReadSentinel(2099382743)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'int32_t'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(dataForSniffer)))))) {
                FatalError("Error deserializing 'uint8_t[]'");
                return MsgValueError;
            }
            // Sentinel = 'dataForSniffer'
            if ((!(((&(reader__)))->ReadSentinel(690816399)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint8_t[]'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(altSvcUsed)))))) {
                FatalError("Error deserializing 'nsCString?'");
                return MsgValueError;
            }
            // Sentinel = 'altSvcUsed'
            if ((!(((&(reader__)))->ReadSentinel(370344959)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString?'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(dataToChildProcess)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            // Sentinel = 'dataToChildProcess'
            if ((!(((&(reader__)))->ReadSentinel(1114769185)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(restarted)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            // Sentinel = 'restarted'
            if ((!(((&(reader__)))->ReadSentinel(323421135)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(HTTPSSVCReceivedStage)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            // Sentinel = 'HTTPSSVCReceivedStage'
            if ((!(((&(reader__)))->ReadSentinel(1328154523)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(supportsHttp3)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            // Sentinel = 'supportsHttp3'
            if ((!(((&(reader__)))->ReadSentinel(663487844)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'bool'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<HttpTransactionParent*>(this))->RecvOnStartRequest(std::move(status), std::move(responseHead), std::move(securityInfoSerialization), std::move(proxyConnectFailed), std::move(timings), std::move(proxyConnectResponseCode), std::move(dataForSniffer), std::move(altSvcUsed), std::move(dataToChildProcess), std::move(restarted), std::move(HTTPSSVCReceivedStage), std::move(supportsHttp3));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpTransaction::Msg_OnTransportStatus__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PHttpTransactionParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PHttpTransaction::Msg_OnTransportStatus", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsresult status{};
            int64_t progress{};
            int64_t progressMax{};
            mozilla::Maybe<NetworkAddressArg> networkAddressArg{};

            if ((!(IPC::ReadParam((&(reader__)), (&(status)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            // Sentinel = 'status'
            if ((!(((&(reader__)))->ReadSentinel(154731173)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(progress)))))) {
                FatalError("Error deserializing 'int64_t'");
                return MsgValueError;
            }
            // Sentinel = 'progress'
            if ((!(((&(reader__)))->ReadSentinel(261292918)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'int64_t'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(progressMax)))))) {
                FatalError("Error deserializing 'int64_t'");
                return MsgValueError;
            }
            // Sentinel = 'progressMax'
            if ((!(((&(reader__)))->ReadSentinel(471205020)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'int64_t'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(networkAddressArg)))))) {
                FatalError("Error deserializing 'NetworkAddressArg?'");
                return MsgValueError;
            }
            // Sentinel = 'networkAddressArg'
            if ((!(((&(reader__)))->ReadSentinel(1062471403)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'NetworkAddressArg?'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<HttpTransactionParent*>(this))->RecvOnTransportStatus(std::move(status), std::move(progress), std::move(progressMax), std::move(networkAddressArg));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpTransaction::Msg_OnDataAvailable__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PHttpTransactionParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PHttpTransaction::Msg_OnDataAvailable", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsCString data{};
            uint64_t offset{};
            uint32_t count{};

            if ((!(IPC::ReadParam((&(reader__)), (&(data)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'data'
            if ((!(((&(reader__)))->ReadSentinel(67109275)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(offset)))))) {
                FatalError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            // Sentinel = 'offset'
            if ((!(((&(reader__)))->ReadSentinel(147653256)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint64_t'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(count)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            // Sentinel = 'count'
            if ((!(((&(reader__)))->ReadSentinel(106889770)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<HttpTransactionParent*>(this))->RecvOnDataAvailable(std::move(data), std::move(offset), std::move(count));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpTransaction::Msg_OnStopRequest__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PHttpTransactionParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PHttpTransaction::Msg_OnStopRequest", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsresult status{};
            bool responseIsComplete{};
            int64_t transferSize{};
            TimingStructArgs timings{};
            mozilla::Maybe<nsHttpHeaderArray> responseTrailers{};
            mozilla::Maybe<TransactionObserverResult> transactionObserverResult{};
            TimeStamp lastActiveTabOptimization{};
            uint32_t caps{};
            HttpConnectionInfoCloneArgs connInfoArgs{};

            if ((!(IPC::ReadParam((&(reader__)), (&(status)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            // Sentinel = 'status'
            if ((!(((&(reader__)))->ReadSentinel(154731173)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(responseIsComplete)))))) {
                FatalError("Error deserializing 'bool'");
                return MsgValueError;
            }
            // Sentinel = 'responseIsComplete'
            if ((!(((&(reader__)))->ReadSentinel(1188956005)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'bool'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(transferSize)))))) {
                FatalError("Error deserializing 'int64_t'");
                return MsgValueError;
            }
            // Sentinel = 'transferSize'
            if ((!(((&(reader__)))->ReadSentinel(551814401)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'int64_t'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(timings)))))) {
                FatalError("Error deserializing 'TimingStructArgs'");
                return MsgValueError;
            }
            // Sentinel = 'timings'
            if ((!(((&(reader__)))->ReadSentinel(200868604)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'TimingStructArgs'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(responseTrailers)))))) {
                FatalError("Error deserializing 'nsHttpHeaderArray?'");
                return MsgValueError;
            }
            // Sentinel = 'responseTrailers'
            if ((!(((&(reader__)))->ReadSentinel(961873590)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsHttpHeaderArray?'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(transactionObserverResult)))))) {
                FatalError("Error deserializing 'TransactionObserverResult?'");
                return MsgValueError;
            }
            // Sentinel = 'transactionObserverResult'
            if ((!(((&(reader__)))->ReadSentinel(2271873646)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'TransactionObserverResult?'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(lastActiveTabOptimization)))))) {
                FatalError("Error deserializing 'TimeStamp'");
                return MsgValueError;
            }
            // Sentinel = 'lastActiveTabOptimization'
            if ((!(((&(reader__)))->ReadSentinel(2190412335)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'TimeStamp'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(caps)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            // Sentinel = 'caps'
            if ((!(((&(reader__)))->ReadSentinel(67502504)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(connInfoArgs)))))) {
                FatalError("Error deserializing 'HttpConnectionInfoCloneArgs'");
                return MsgValueError;
            }
            // Sentinel = 'connInfoArgs'
            if ((!(((&(reader__)))->ReadSentinel(521340104)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'HttpConnectionInfoCloneArgs'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<HttpTransactionParent*>(this))->RecvOnStopRequest(std::move(status), std::move(responseIsComplete), std::move(transferSize), std::move(timings), std::move(responseTrailers), std::move(transactionObserverResult), std::move(lastActiveTabOptimization), std::move(caps), std::move(connInfoArgs));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpTransaction::Msg_OnInitFailed__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PHttpTransactionParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PHttpTransaction::Msg_OnInitFailed", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsresult status{};

            if ((!(IPC::ReadParam((&(reader__)), (&(status)))))) {
                FatalError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            // Sentinel = 'status'
            if ((!(((&(reader__)))->ReadSentinel(154731173)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsresult'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<HttpTransactionParent*>(this))->RecvOnInitFailed(std::move(status));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpTransaction::Msg_OnH2PushStream__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PHttpTransactionParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PHttpTransaction::Msg_OnH2PushStream", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            uint32_t pushedStreamId{};
            nsCString resourceUrl{};
            nsCString requestString{};

            if ((!(IPC::ReadParam((&(reader__)), (&(pushedStreamId)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            // Sentinel = 'pushedStreamId'
            if ((!(((&(reader__)))->ReadSentinel(731579811)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(resourceUrl)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'resourceUrl'
            if ((!(((&(reader__)))->ReadSentinel(471270556)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(requestString)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'requestString'
            if ((!(((&(reader__)))->ReadSentinel(650970497)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<HttpTransactionParent*>(this))->RecvOnH2PushStream(std::move(pushedStreamId), std::move(resourceUrl), std::move(requestString));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpTransaction::Msg_EarlyHint__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PHttpTransactionParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PHttpTransactionParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PHttpTransaction::Msg_EarlyHint", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsCString value{};

            if ((!(IPC::ReadParam((&(reader__)), (&(value)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'value'
            if ((!(((&(reader__)))->ReadSentinel(107610654)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<HttpTransactionParent*>(this))->RecvEarlyHint(std::move(value));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PHttpTransaction::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PHttpTransactionParent::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PHttpTransactionParent::Result
{
    return MsgNotKnown;
}

auto PHttpTransactionParent::OnCallReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PHttpTransactionParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PHttpTransactionParent::ClearSubtree() -> void
{
}



} // namespace net
} // namespace mozilla
namespace IPC {
auto ParamTraits<mozilla::net::PHttpTransactionParent*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<mozilla::net::PHttpTransactionParent*>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");

    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aReader->GetActor()->ReadActor(aReader, true, "PHttpTransaction", PHttpTransactionMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::net::PHttpTransactionParent*>(actor.value());
    return true;
}

} // namespace IPC
