//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PTCPServerSocketChild.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/dom/network/TCPServerSocketChild.h"
#include "mozilla/dom/network/TCPServerSocketParent.h"
#include "mozilla/net/NeckoMessageUtils.h"

#include "mozilla/net/PNeckoChild.h"
#include "mozilla/net/PTCPSocketChild.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace net {


auto PTCPServerSocketChild::Recv__delete__() -> mozilla::ipc::IPCResult
{
    return IPC_OK();
}

MOZ_IMPLICIT PTCPServerSocketChild::PTCPServerSocketChild() :
    mozilla::ipc::IProtocol(PTCPServerSocketMsgStart, mozilla::ipc::ChildSide)
{
    MOZ_COUNT_CTOR(PTCPServerSocketChild);
}

PTCPServerSocketChild::~PTCPServerSocketChild()
{
    MOZ_COUNT_DTOR(PTCPServerSocketChild);
}

auto PTCPServerSocketChild::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PTCPServerSocketChild::Manager() const -> PNeckoChild*
{
    return static_cast<PNeckoChild*>(IProtocol::Manager());
}

auto PTCPServerSocketChild::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    arr__.SetCapacity(total);

}

auto PTCPServerSocketChild::SendClose() -> bool
{
    UniquePtr<IPC::Message> msg__ = PTCPServerSocket::Msg_Close(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};





    if (mozilla::ipc::LoggingEnabledFor("PTCPServerSocketChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PTCPServerSocketChild",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PTCPServerSocket::Msg_Close", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PTCPServerSocketChild::SendRequestDelete() -> bool
{
    UniquePtr<IPC::Message> msg__ = PTCPServerSocket::Msg_RequestDelete(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};





    if (mozilla::ipc::LoggingEnabledFor("PTCPServerSocketChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PTCPServerSocketChild",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PTCPServerSocket::Msg_RequestDelete", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PTCPServerSocketChild::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PTCPServerSocketChild::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PTCPServerSocketChild::OnMessageReceived(const Message& msg__) -> PTCPServerSocketChild::Result
{
    switch (msg__.type()) {
    case MANAGED_ENDPOINT_BOUND_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            return MsgProcessed;
        }
    case MANAGED_ENDPOINT_DROPPED_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            IProtocol* mgr = this->Manager();
            this->DestroySubtree(ManagedEndpointDropped);
            this->ClearSubtree();
            mgr->RemoveManagee(PTCPServerSocketMsgStart, this);
            return MsgProcessed;
        }
    case PTCPServerSocket::Msg_CallbackAccept__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PTCPServerSocketChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PTCPServerSocketChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PTCPServerSocket::Msg_CallbackAccept", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            PTCPSocketChild* socket{};

            if ((!(IPC::ReadParam((&(reader__)), (&(socket)))))) {
                FatalError("Error deserializing 'PTCPSocket'");
                return MsgValueError;
            }
            if ((!((*((&(socket))))))) {
                FatalError("Error deserializing 'PTCPSocket'");
                return MsgValueError;
            }
            // Sentinel = 'socket'
            if ((!(((&(reader__)))->ReadSentinel(149815946)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'PTCPSocket'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<mozilla::dom::TCPServerSocketChild*>(this))->RecvCallbackAccept(std::move(socket));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PTCPServerSocket::Msg___delete____ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PTCPServerSocketChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PTCPServerSocketChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PTCPServerSocket::Msg___delete__", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            PTCPServerSocketChild* actor{};

            if ((!(IPC::ReadParam((&(reader__)), (&(actor)))))) {
                FatalError("Error deserializing 'PTCPServerSocket'");
                return MsgValueError;
            }
            if ((!((*((&(actor))))))) {
                FatalError("Error deserializing 'PTCPServerSocket'");
                return MsgValueError;
            }
            // Sentinel = 'actor'
            if ((!(((&(reader__)))->ReadSentinel(102892058)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'PTCPServerSocket'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<mozilla::dom::TCPServerSocketChild*>(this))->Recv__delete__();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }


            IProtocol* mgr = actor->Manager();
            actor->DestroySubtree(Deletion);
            actor->ClearSubtree();
            mgr->RemoveManagee(PTCPServerSocketMsgStart, actor);

            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PTCPServerSocketChild::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PTCPServerSocketChild::Result
{
    return MsgNotKnown;
}

auto PTCPServerSocketChild::OnCallReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PTCPServerSocketChild::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PTCPServerSocketChild::ClearSubtree() -> void
{
}



} // namespace net
} // namespace mozilla
namespace IPC {
auto ParamTraits<mozilla::net::PTCPServerSocketChild*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<mozilla::net::PTCPServerSocketChild*>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");

    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aReader->GetActor()->ReadActor(aReader, true, "PTCPServerSocket", PTCPServerSocketMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::net::PTCPServerSocketChild*>(actor.value());
    return true;
}

} // namespace IPC
