//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PTCPServerSocketParent.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/dom/network/TCPServerSocketChild.h"
#include "mozilla/dom/network/TCPServerSocketParent.h"
#include "mozilla/net/NeckoMessageUtils.h"

#include "mozilla/net/PNeckoParent.h"
#include "mozilla/net/PTCPSocketParent.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace net {


MOZ_IMPLICIT PTCPServerSocketParent::PTCPServerSocketParent() :
    mozilla::ipc::IProtocol(PTCPServerSocketMsgStart, mozilla::ipc::ParentSide)
{
    MOZ_COUNT_CTOR(PTCPServerSocketParent);
}

PTCPServerSocketParent::~PTCPServerSocketParent()
{
    MOZ_COUNT_DTOR(PTCPServerSocketParent);
}

auto PTCPServerSocketParent::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PTCPServerSocketParent::Manager() const -> PNeckoParent*
{
    return static_cast<PNeckoParent*>(IProtocol::Manager());
}

auto PTCPServerSocketParent::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    arr__.SetCapacity(total);

}

auto PTCPServerSocketParent::SendCallbackAccept(PTCPSocketParent* socket) -> bool
{
    UniquePtr<IPC::Message> msg__ = PTCPServerSocket::Msg_CallbackAccept(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    MOZ_RELEASE_ASSERT(socket, "NULL actor value passed to non-nullable param");
    IPC::WriteParam((&(writer__)), socket);
    // Sentinel = 'socket'
    ((&(writer__)))->WriteSentinel(149815946);




    if (mozilla::ipc::LoggingEnabledFor("PTCPServerSocketParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PTCPServerSocketParent",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PTCPServerSocket::Msg_CallbackAccept", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PTCPServerSocketParent::Send__delete__(PTCPServerSocketParent* actor) -> bool
{
    if (!actor || !actor->CanSend()) {
        NS_WARNING("Attempt to __delete__ missing or closed actor");
        return false;
    }
    UniquePtr<IPC::Message> msg__ = PTCPServerSocket::Msg___delete__((actor)->Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            actor};

    MOZ_RELEASE_ASSERT(actor, "NULL actor value passed to non-nullable param");
    IPC::WriteParam((&(writer__)), actor);
    // Sentinel = 'actor'
    ((&(writer__)))->WriteSentinel(102892058);



    if (mozilla::ipc::LoggingEnabledFor("PTCPServerSocketParent")) {
        mozilla::ipc::LogMessageForProtocol(
            "PTCPServerSocketParent",
            actor->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PTCPServerSocket::Msg___delete__", OTHER);

    bool sendok__ = (actor)->ChannelSend(std::move(msg__));

    IProtocol* mgr = actor->Manager();
    actor->DestroySubtree(Deletion);
    actor->ClearSubtree();
    mgr->RemoveManagee(PTCPServerSocketMsgStart, actor);
    return sendok__;
}

auto PTCPServerSocketParent::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PTCPServerSocketParent::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PTCPServerSocketParent::OnMessageReceived(const Message& msg__) -> PTCPServerSocketParent::Result
{
    switch (msg__.type()) {
    case MANAGED_ENDPOINT_BOUND_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            return MsgProcessed;
        }
    case MANAGED_ENDPOINT_DROPPED_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            IProtocol* mgr = this->Manager();
            this->DestroySubtree(ManagedEndpointDropped);
            this->ClearSubtree();
            mgr->RemoveManagee(PTCPServerSocketMsgStart, this);
            return MsgProcessed;
        }
    case PTCPServerSocket::Msg_Close__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PTCPServerSocketParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PTCPServerSocketParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PTCPServerSocket::Msg_Close", OTHER);

            mozilla::ipc::IPCResult __ok = (static_cast<mozilla::dom::TCPServerSocketParent*>(this))->RecvClose();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PTCPServerSocket::Msg_RequestDelete__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PTCPServerSocketParent")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PTCPServerSocketParent",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PTCPServerSocket::Msg_RequestDelete", OTHER);

            mozilla::ipc::IPCResult __ok = (static_cast<mozilla::dom::TCPServerSocketParent*>(this))->RecvRequestDelete();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PTCPServerSocket::Reply___delete____ID:
        {
            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PTCPServerSocketParent::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PTCPServerSocketParent::Result
{
    return MsgNotKnown;
}

auto PTCPServerSocketParent::OnCallReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PTCPServerSocketParent::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PTCPServerSocketParent::ClearSubtree() -> void
{
}



} // namespace net
} // namespace mozilla
namespace IPC {
auto ParamTraits<mozilla::net::PTCPServerSocketParent*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<mozilla::net::PTCPServerSocketParent*>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");

    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aReader->GetActor()->ReadActor(aReader, true, "PTCPServerSocket", PTCPServerSocketMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::net::PTCPServerSocketParent*>(actor.value());
    return true;
}

} // namespace IPC
