//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/net/PUDPSocketChild.h"
#include "mozilla/ProfilerLabels.h"
#include "mozilla/dom/network/UDPSocketChild.h"
#include "mozilla/dom/network/UDPSocketParent.h"
#include "mozilla/ipc/IPCCore.h"
#include "mozilla/net/DNS.h"
#include "mozilla/net/NeckoMessageUtils.h"
#include "prio.h"

#include "mozilla/net/PNeckoChild.h"
#include "mozilla/ipc/PBackgroundChild.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"

namespace mozilla {
namespace net {


auto PUDPSocketChild::Recv__delete__() -> mozilla::ipc::IPCResult
{
    return IPC_OK();
}

MOZ_IMPLICIT PUDPSocketChild::PUDPSocketChild() :
    mozilla::ipc::IProtocol(PUDPSocketMsgStart, mozilla::ipc::ChildSide)
{
    MOZ_COUNT_CTOR(PUDPSocketChild);
}

PUDPSocketChild::~PUDPSocketChild()
{
    MOZ_COUNT_DTOR(PUDPSocketChild);
}

auto PUDPSocketChild::OtherPid() const -> ::base::ProcessId
{
    ::base::ProcessId pid =
        ::mozilla::ipc::IProtocol::ToplevelProtocol()->OtherPidMaybeInvalid();
    MOZ_RELEASE_ASSERT(pid != ::base::kInvalidProcessId);
    return pid;
}

auto PUDPSocketChild::AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const -> void
{
    uint32_t total = 0;
    arr__.SetCapacity(total);

}

auto PUDPSocketChild::SendBind(
        const UDPAddressInfo& addressInfo,
        const bool& addressReuse,
        const bool& loopback,
        const uint32_t& recvBufferSize,
        const uint32_t& sendBufferSize) -> bool
{
    UniquePtr<IPC::Message> msg__ = PUDPSocket::Msg_Bind(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), addressInfo);
    // Sentinel = 'addressInfo'
    ((&(writer__)))->WriteSentinel(445580403);
    IPC::WriteParam((&(writer__)), addressReuse);
    // Sentinel = 'addressReuse'
    ((&(writer__)))->WriteSentinel(530908395);
    IPC::WriteParam((&(writer__)), loopback);
    // Sentinel = 'loopback'
    ((&(writer__)))->WriteSentinel(253166412);
    IPC::WriteParam((&(writer__)), recvBufferSize);
    // Sentinel = 'recvBufferSize'
    ((&(writer__)))->WriteSentinel(709100966);
    IPC::WriteParam((&(writer__)), sendBufferSize);
    // Sentinel = 'sendBufferSize'
    ((&(writer__)))->WriteSentinel(705693088);




    if (mozilla::ipc::LoggingEnabledFor("PUDPSocketChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PUDPSocketChild",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PUDPSocket::Msg_Bind", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PUDPSocketChild::SendConnect(const UDPAddressInfo& addressInfo) -> bool
{
    UniquePtr<IPC::Message> msg__ = PUDPSocket::Msg_Connect(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), addressInfo);
    // Sentinel = 'addressInfo'
    ((&(writer__)))->WriteSentinel(445580403);




    if (mozilla::ipc::LoggingEnabledFor("PUDPSocketChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PUDPSocketChild",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PUDPSocket::Msg_Connect", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PUDPSocketChild::SendOutgoingData(
        const UDPData& data,
        const UDPSocketAddr& addr) -> bool
{
    UniquePtr<IPC::Message> msg__ = PUDPSocket::Msg_OutgoingData(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), data);
    // Sentinel = 'data'
    ((&(writer__)))->WriteSentinel(67109275);
    IPC::WriteParam((&(writer__)), addr);
    // Sentinel = 'addr'
    ((&(writer__)))->WriteSentinel(65929628);




    if (mozilla::ipc::LoggingEnabledFor("PUDPSocketChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PUDPSocketChild",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PUDPSocket::Msg_OutgoingData", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PUDPSocketChild::SendJoinMulticast(
        const nsCString& multicastAddress,
        const nsCString& iface) -> bool
{
    UniquePtr<IPC::Message> msg__ = PUDPSocket::Msg_JoinMulticast(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), multicastAddress);
    // Sentinel = 'multicastAddress'
    ((&(writer__)))->WriteSentinel(948700829);
    IPC::WriteParam((&(writer__)), iface);
    // Sentinel = 'iface'
    ((&(writer__)))->WriteSentinel(100139513);




    if (mozilla::ipc::LoggingEnabledFor("PUDPSocketChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PUDPSocketChild",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PUDPSocket::Msg_JoinMulticast", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PUDPSocketChild::SendLeaveMulticast(
        const nsCString& multicastAddress,
        const nsCString& iface) -> bool
{
    UniquePtr<IPC::Message> msg__ = PUDPSocket::Msg_LeaveMulticast(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};

    IPC::WriteParam((&(writer__)), multicastAddress);
    // Sentinel = 'multicastAddress'
    ((&(writer__)))->WriteSentinel(948700829);
    IPC::WriteParam((&(writer__)), iface);
    // Sentinel = 'iface'
    ((&(writer__)))->WriteSentinel(100139513);




    if (mozilla::ipc::LoggingEnabledFor("PUDPSocketChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PUDPSocketChild",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PUDPSocket::Msg_LeaveMulticast", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PUDPSocketChild::SendClose() -> bool
{
    UniquePtr<IPC::Message> msg__ = PUDPSocket::Msg_Close(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};





    if (mozilla::ipc::LoggingEnabledFor("PUDPSocketChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PUDPSocketChild",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PUDPSocket::Msg_Close", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PUDPSocketChild::SendRequestDelete() -> bool
{
    UniquePtr<IPC::Message> msg__ = PUDPSocket::Msg_RequestDelete(Id());
    IPC::MessageWriter writer__{
            (*(msg__)),
            this};





    if (mozilla::ipc::LoggingEnabledFor("PUDPSocketChild")) {
        mozilla::ipc::LogMessageForProtocol(
            "PUDPSocketChild",
            this->ToplevelProtocol()->OtherPidMaybeInvalid(),
            "Sending ",
            msg__->type(),
            mozilla::ipc::MessageDirection::eSending);
    }
    AUTO_PROFILER_LABEL("PUDPSocket::Msg_RequestDelete", OTHER);

    bool sendok__ = ChannelSend(std::move(msg__));
    return sendok__;
}

auto PUDPSocketChild::RemoveManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PUDPSocketChild::DeallocManagee(
        int32_t aProtocolId,
        IProtocol* aListener) -> void
{
    FatalError("unreached");
    return;
}

auto PUDPSocketChild::OnMessageReceived(const Message& msg__) -> PUDPSocketChild::Result
{
    switch (msg__.type()) {
    case MANAGED_ENDPOINT_BOUND_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            return MsgProcessed;
        }
    case MANAGED_ENDPOINT_DROPPED_MESSAGE_TYPE:
        {
            if (!mAwaitingManagedEndpointBind) {
                NS_WARNING("Unexpected managed endpoint lifecycle message after actor bound!");
                return MsgNotAllowed;
            }
            mAwaitingManagedEndpointBind = false;
            IProtocol* mgr = this->Manager();
            this->DestroySubtree(ManagedEndpointDropped);
            this->ClearSubtree();
            mgr->RemoveManagee(PUDPSocketMsgStart, this);
            return MsgProcessed;
        }
    case PUDPSocket::Msg_CallbackOpened__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PUDPSocketChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PUDPSocketChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PUDPSocket::Msg_CallbackOpened", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            UDPAddressInfo addressInfo{};

            if ((!(IPC::ReadParam((&(reader__)), (&(addressInfo)))))) {
                FatalError("Error deserializing 'UDPAddressInfo'");
                return MsgValueError;
            }
            // Sentinel = 'addressInfo'
            if ((!(((&(reader__)))->ReadSentinel(445580403)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'UDPAddressInfo'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<mozilla::dom::UDPSocketChild*>(this))->RecvCallbackOpened(std::move(addressInfo));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg_CallbackConnected__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PUDPSocketChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PUDPSocketChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PUDPSocket::Msg_CallbackConnected", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            UDPAddressInfo addressInfo{};

            if ((!(IPC::ReadParam((&(reader__)), (&(addressInfo)))))) {
                FatalError("Error deserializing 'UDPAddressInfo'");
                return MsgValueError;
            }
            // Sentinel = 'addressInfo'
            if ((!(((&(reader__)))->ReadSentinel(445580403)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'UDPAddressInfo'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<mozilla::dom::UDPSocketChild*>(this))->RecvCallbackConnected(std::move(addressInfo));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg_CallbackClosed__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PUDPSocketChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PUDPSocketChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PUDPSocket::Msg_CallbackClosed", OTHER);

            mozilla::ipc::IPCResult __ok = (static_cast<mozilla::dom::UDPSocketChild*>(this))->RecvCallbackClosed();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg_CallbackReceivedData__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PUDPSocketChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PUDPSocketChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PUDPSocket::Msg_CallbackReceivedData", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            UDPAddressInfo addressInfo{};
            nsTArray<uint8_t> data{};

            if ((!(IPC::ReadParam((&(reader__)), (&(addressInfo)))))) {
                FatalError("Error deserializing 'UDPAddressInfo'");
                return MsgValueError;
            }
            // Sentinel = 'addressInfo'
            if ((!(((&(reader__)))->ReadSentinel(445580403)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'UDPAddressInfo'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(data)))))) {
                FatalError("Error deserializing 'uint8_t[]'");
                return MsgValueError;
            }
            // Sentinel = 'data'
            if ((!(((&(reader__)))->ReadSentinel(67109275)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint8_t[]'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<mozilla::dom::UDPSocketChild*>(this))->RecvCallbackReceivedData(std::move(addressInfo), std::move(data));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg_CallbackError__ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PUDPSocketChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PUDPSocketChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PUDPSocket::Msg_CallbackError", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            nsCString message{};
            nsCString filename{};
            uint32_t lineNumber{};

            if ((!(IPC::ReadParam((&(reader__)), (&(message)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'message'
            if ((!(((&(reader__)))->ReadSentinel(197198566)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(filename)))))) {
                FatalError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            // Sentinel = 'filename'
            if ((!(((&(reader__)))->ReadSentinel(246547266)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'nsCString'");
                return MsgValueError;
            }
            if ((!(IPC::ReadParam((&(reader__)), (&(lineNumber)))))) {
                FatalError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            // Sentinel = 'lineNumber'
            if ((!(((&(reader__)))->ReadSentinel(374932498)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'uint32_t'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<mozilla::dom::UDPSocketChild*>(this))->RecvCallbackError(std::move(message), std::move(filename), std::move(lineNumber));
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }

            return MsgProcessed;
        }
    case PUDPSocket::Msg___delete____ID:
        {
            if (mozilla::ipc::LoggingEnabledFor("PUDPSocketChild")) {
                mozilla::ipc::LogMessageForProtocol(
                    "PUDPSocketChild",
                    this->ToplevelProtocol()->OtherPidMaybeInvalid(),
                    "Received ",
                    (&(msg__))->type(),
                    mozilla::ipc::MessageDirection::eReceiving);
            }
            AUTO_PROFILER_LABEL("PUDPSocket::Msg___delete__", OTHER);

            IPC::MessageReader reader__{
                    msg__,
                    this};
            PUDPSocketChild* actor{};

            if ((!(IPC::ReadParam((&(reader__)), (&(actor)))))) {
                FatalError("Error deserializing 'PUDPSocket'");
                return MsgValueError;
            }
            if ((!((*((&(actor))))))) {
                FatalError("Error deserializing 'PUDPSocket'");
                return MsgValueError;
            }
            // Sentinel = 'actor'
            if ((!(((&(reader__)))->ReadSentinel(102892058)))) {
                mozilla::ipc::SentinelReadError("Error deserializing 'PUDPSocket'");
                return MsgValueError;
            }
            reader__.EndRead();
            mozilla::ipc::IPCResult __ok = (static_cast<mozilla::dom::UDPSocketChild*>(this))->Recv__delete__();
            if ((!(__ok))) {
                mozilla::ipc::ProtocolErrorBreakpoint("Handler returned error code!");
                // Error handled in mozilla::ipc::IPCResult
                return MsgProcessingError;
            }


            IProtocol* mgr = actor->Manager();
            actor->DestroySubtree(Deletion);
            actor->ClearSubtree();
            mgr->RemoveManagee(PUDPSocketMsgStart, actor);

            return MsgProcessed;
        }
    default:
        return MsgNotKnown;
    }
}

auto PUDPSocketChild::OnMessageReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PUDPSocketChild::Result
{
    return MsgNotKnown;
}

auto PUDPSocketChild::OnCallReceived(
        const Message& msg__,
        UniquePtr<Message>& reply__) -> PUDPSocketChild::Result
{
    MOZ_ASSERT_UNREACHABLE("message protocol not supported");
    return MsgNotKnown;
}

auto PUDPSocketChild::ClearSubtree() -> void
{
}



} // namespace net
} // namespace mozilla
namespace IPC {
auto ParamTraits<mozilla::net::PUDPSocketChild*>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    MOZ_RELEASE_ASSERT(
        aWriter->GetActor(),
        "Cannot serialize managed actors without an actor");

    int32_t id;
    if (!aVar) {
        id = 0;  // kNullActorId
    } else {
        id = aVar->Id();
        if (id == 1) {  // kFreedActorId
            aVar->FatalError("Actor has been |delete|d");
        }
        MOZ_RELEASE_ASSERT(
            aWriter->GetActor()->GetIPCChannel() == aVar->GetIPCChannel(),
            "Actor must be from the same channel as the"
            " actor it's being sent over");
        MOZ_RELEASE_ASSERT(
            aVar->CanSend(),
            "Actor must still be open when sending");
    }

    IPC::WriteParam(aWriter, id);
}

auto ParamTraits<mozilla::net::PUDPSocketChild*>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    MOZ_RELEASE_ASSERT(
        aReader->GetActor(),
        "Cannot deserialize managed actors without an actor");

    mozilla::Maybe<mozilla::ipc::IProtocol*> actor =
        aReader->GetActor()->ReadActor(aReader, true, "PUDPSocket", PUDPSocketMsgStart);
    if (actor.isNothing()) {
        return false;
    }

    *aVar = static_cast<mozilla::net::PUDPSocketChild*>(actor.value());
    return true;
}

} // namespace IPC
