//
// Automatically generated by ipdlc.
// Edit at your own risk
//


#include "mozilla/dom/PrefsTypes.h"

#include "ipc/IPCMessageUtils.h"
#include "ipc/IPCMessageUtilsSpecializations.h"
#include "nsIFile.h"
#include "mozilla/ipc/Endpoint.h"
#include "mozilla/ipc/ProtocolMessageUtils.h"
#include "mozilla/ipc/ProtocolUtils.h"
#include "mozilla/ipc/ShmemMessageUtils.h"
#include "mozilla/ipc/TaintingIPCUtils.h"


//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |union PrefValue|
//
namespace mozilla {
namespace dom {
auto PrefValue::MaybeDestroy(Type aNewType) -> bool
{
    if ((mType) == (T__None)) {
        return true;
    }
    if ((mType) == (aNewType)) {
        return false;
    }
    switch (mType) {
    case TnsCString:
        {
            (ptr_nsCString())->~nsCString__tdef();
            break;
        }
    case Tint32_t:
        {
            (ptr_int32_t())->~int32_t__tdef();
            break;
        }
    case Tbool:
        {
            (ptr_bool())->~bool__tdef();
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("not reached");
            break;
        }
    }
    return true;
}

MOZ_IMPLICIT PrefValue::PrefValue(const nsCString& aOther)
{
    new (mozilla::KnownNotNull, ptr_nsCString()) nsCString(aOther);
    mType = TnsCString;
}

MOZ_IMPLICIT PrefValue::PrefValue(nsCString&& aOther)
{
    new (mozilla::KnownNotNull, ptr_nsCString()) nsCString(std::move(aOther));
    mType = TnsCString;
}

MOZ_IMPLICIT PrefValue::PrefValue(const int32_t& aOther)
{
    new (mozilla::KnownNotNull, ptr_int32_t()) int32_t(aOther);
    mType = Tint32_t;
}

MOZ_IMPLICIT PrefValue::PrefValue(int32_t&& aOther)
{
    new (mozilla::KnownNotNull, ptr_int32_t()) int32_t(std::move(aOther));
    mType = Tint32_t;
}

MOZ_IMPLICIT PrefValue::PrefValue(const bool& aOther)
{
    new (mozilla::KnownNotNull, ptr_bool()) bool(aOther);
    mType = Tbool;
}

MOZ_IMPLICIT PrefValue::PrefValue(bool&& aOther)
{
    new (mozilla::KnownNotNull, ptr_bool()) bool(std::move(aOther));
    mType = Tbool;
}

MOZ_IMPLICIT PrefValue::PrefValue(const PrefValue& aOther)
{
    (aOther).AssertSanity();
    switch ((aOther).type()) {
    case TnsCString:
        {
            new (mozilla::KnownNotNull, ptr_nsCString()) nsCString((aOther).get_nsCString());
            break;
        }
    case Tint32_t:
        {
            new (mozilla::KnownNotNull, ptr_int32_t()) int32_t((aOther).get_int32_t());
            break;
        }
    case Tbool:
        {
            new (mozilla::KnownNotNull, ptr_bool()) bool((aOther).get_bool());
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    mType = (aOther).type();
}

MOZ_IMPLICIT PrefValue::PrefValue(PrefValue&& aOther)
{
    (aOther).AssertSanity();
    Type t = (aOther).type();
    switch (t) {
    case TnsCString:
        {
            new (mozilla::KnownNotNull, ptr_nsCString()) nsCString(std::move((aOther).get_nsCString()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case Tint32_t:
        {
            new (mozilla::KnownNotNull, ptr_int32_t()) int32_t(std::move((aOther).get_int32_t()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case Tbool:
        {
            new (mozilla::KnownNotNull, ptr_bool()) bool(std::move((aOther).get_bool()));
            static_cast<void>((aOther).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            return;
        }
    }
    (aOther).mType = T__None;
    mType = t;
}

PrefValue::~PrefValue()
{
    static_cast<void>(MaybeDestroy(T__None));
}

auto PrefValue::operator=(const nsCString& aRhs) -> PrefValue&
{
    if (MaybeDestroy(TnsCString)) {
        new (mozilla::KnownNotNull, ptr_nsCString()) nsCString;
    }
    (*(ptr_nsCString())) = aRhs;
    mType = TnsCString;
    return (*(this));
}

auto PrefValue::operator=(nsCString&& aRhs) -> PrefValue&
{
    if (MaybeDestroy(TnsCString)) {
        new (mozilla::KnownNotNull, ptr_nsCString()) nsCString;
    }
    (*(ptr_nsCString())) = std::move(aRhs);
    mType = TnsCString;
    return (*(this));
}

auto PrefValue::operator=(const int32_t& aRhs) -> PrefValue&
{
    if (MaybeDestroy(Tint32_t)) {
        new (mozilla::KnownNotNull, ptr_int32_t()) int32_t;
    }
    (*(ptr_int32_t())) = aRhs;
    mType = Tint32_t;
    return (*(this));
}

auto PrefValue::operator=(int32_t&& aRhs) -> PrefValue&
{
    if (MaybeDestroy(Tint32_t)) {
        new (mozilla::KnownNotNull, ptr_int32_t()) int32_t;
    }
    (*(ptr_int32_t())) = std::move(aRhs);
    mType = Tint32_t;
    return (*(this));
}

auto PrefValue::operator=(const bool& aRhs) -> PrefValue&
{
    if (MaybeDestroy(Tbool)) {
        new (mozilla::KnownNotNull, ptr_bool()) bool;
    }
    (*(ptr_bool())) = aRhs;
    mType = Tbool;
    return (*(this));
}

auto PrefValue::operator=(bool&& aRhs) -> PrefValue&
{
    if (MaybeDestroy(Tbool)) {
        new (mozilla::KnownNotNull, ptr_bool()) bool;
    }
    (*(ptr_bool())) = std::move(aRhs);
    mType = Tbool;
    return (*(this));
}

auto PrefValue::operator=(const PrefValue& aRhs) -> PrefValue&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TnsCString:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_nsCString()) nsCString;
            }
            (*(ptr_nsCString())) = (aRhs).get_nsCString();
            break;
        }
    case Tint32_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_int32_t()) int32_t;
            }
            (*(ptr_int32_t())) = (aRhs).get_int32_t();
            break;
        }
    case Tbool:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_bool()) bool;
            }
            (*(ptr_bool())) = (aRhs).get_bool();
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    mType = t;
    return (*(this));
}

auto PrefValue::operator=(PrefValue&& aRhs) -> PrefValue&
{
    (aRhs).AssertSanity();
    Type t = (aRhs).type();
    switch (t) {
    case TnsCString:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_nsCString()) nsCString;
            }
            (*(ptr_nsCString())) = std::move((aRhs).get_nsCString());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case Tint32_t:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_int32_t()) int32_t;
            }
            (*(ptr_int32_t())) = std::move((aRhs).get_int32_t());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case Tbool:
        {
            if (MaybeDestroy(t)) {
                new (mozilla::KnownNotNull, ptr_bool()) bool;
            }
            (*(ptr_bool())) = std::move((aRhs).get_bool());
            static_cast<void>((aRhs).MaybeDestroy(T__None));
            break;
        }
    case T__None:
        {
            static_cast<void>(MaybeDestroy(t));
            break;
        }
    default:
        {
            mozilla::ipc::LogicError("unreached");
            break;
        }
    }
    (aRhs).mType = T__None;
    mType = t;
    return (*(this));
}

} // namespace dom
} // namespace mozilla

namespace IPC {
auto ParamTraits<mozilla::dom::PrefValue>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    typedef mozilla::dom::PrefValue union__;
    int type = (aVar).type();
    IPC::WriteParam(aWriter, type);
    // Sentinel = 'PrefValue'
    (aWriter)->WriteSentinel(290784139);

    switch (type) {
    case union__::TnsCString:
        {
            IPC::WriteParam(aWriter, (aVar).get_nsCString());
            // Sentinel = 'TnsCString'
            (aWriter)->WriteSentinel(353960944);
            return;
        }
    case union__::Tint32_t:
        {
            IPC::WriteParam(aWriter, (aVar).get_int32_t());
            // Sentinel = 'Tint32_t'
            (aWriter)->WriteSentinel(217252568);
            return;
        }
    case union__::Tbool:
        {
            IPC::WriteParam(aWriter, (aVar).get_bool());
            // Sentinel = 'Tbool'
            (aWriter)->WriteSentinel(96993793);
            return;
        }
    default:
        {
            aWriter->FatalError("unknown union type");
            return;
        }
    }
}

auto ParamTraits<mozilla::dom::PrefValue>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    typedef mozilla::dom::PrefValue union__;
    int type = 0;
    if ((!(IPC::ReadParam(aReader, (&(type)))))) {
        aReader->FatalError("Error deserializing type of union PrefValue");
        return false;
    }
    // Sentinel = 'PrefValue'
    if ((!((aReader)->ReadSentinel(290784139)))) {
        mozilla::ipc::SentinelReadError("Error deserializing type of union PrefValue");
        return false;
    }

    switch (type) {
    case union__::TnsCString:
        {
            nsCString tmp = nsCString();
            (*(aVar)) = std::move(tmp);
            if ((!(IPC::ReadParam(aReader, (&((aVar)->get_nsCString())))))) {
                aReader->FatalError("Error deserializing variant TnsCString of union PrefValue");
                return false;
            }
            // Sentinel = 'TnsCString'
            if ((!((aReader)->ReadSentinel(353960944)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant TnsCString of union PrefValue");
                return false;
            }
            return true;
        }
    case union__::Tint32_t:
        {
            int32_t tmp = int32_t();
            (*(aVar)) = std::move(tmp);
            if ((!(IPC::ReadParam(aReader, (&((aVar)->get_int32_t())))))) {
                aReader->FatalError("Error deserializing variant Tint32_t of union PrefValue");
                return false;
            }
            // Sentinel = 'Tint32_t'
            if ((!((aReader)->ReadSentinel(217252568)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant Tint32_t of union PrefValue");
                return false;
            }
            return true;
        }
    case union__::Tbool:
        {
            bool tmp = bool();
            (*(aVar)) = std::move(tmp);
            if ((!(IPC::ReadParam(aReader, (&((aVar)->get_bool())))))) {
                aReader->FatalError("Error deserializing variant Tbool of union PrefValue");
                return false;
            }
            // Sentinel = 'Tbool'
            if ((!((aReader)->ReadSentinel(96993793)))) {
                mozilla::ipc::SentinelReadError("Error deserializing variant Tbool of union PrefValue");
                return false;
            }
            return true;
        }
    default:
        {
            aReader->FatalError("unknown union type");
            return false;
        }
    }
}

} // namespace IPC

//-----------------------------------------------------------------------------
// Method definitions for the IPDL type |struct Pref|
//
namespace mozilla {
namespace dom {
} // namespace dom
} // namespace mozilla

namespace IPC {
auto ParamTraits<mozilla::dom::Pref>::Write(
        IPC::MessageWriter* aWriter,
        const paramType& aVar) -> void
{
    IPC::WriteParam(aWriter, (aVar).name());
    // Sentinel = 'name'
    (aWriter)->WriteSentinel(69075362);
    IPC::WriteParam(aWriter, (aVar).isLocked());
    // Sentinel = 'isLocked'
    (aWriter)->WriteSentinel(241369903);
    IPC::WriteParam(aWriter, (aVar).isSanitized());
    // Sentinel = 'isSanitized'
    (aWriter)->WriteSentinel(452658312);
    IPC::WriteParam(aWriter, (aVar).defaultValue());
    // Sentinel = 'defaultValue'
    (aWriter)->WriteSentinel(529597667);
    IPC::WriteParam(aWriter, (aVar).userValue());
    // Sentinel = 'userValue'
    (aWriter)->WriteSentinel(317850557);
}

auto ParamTraits<mozilla::dom::Pref>::Read(
        IPC::MessageReader* aReader,
        paramType* aVar) -> bool
{
    if ((!(IPC::ReadParam(aReader, (&((aVar)->name())))))) {
        aReader->FatalError("Error deserializing 'name' (nsCString) member of 'Pref'");
        return false;
    }
    // Sentinel = 'name'
    if ((!((aReader)->ReadSentinel(69075362)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'name' (nsCString) member of 'Pref'");
        return false;
    }
    if ((!(IPC::ReadParam(aReader, (&((aVar)->isLocked())))))) {
        aReader->FatalError("Error deserializing 'isLocked' (bool) member of 'Pref'");
        return false;
    }
    // Sentinel = 'isLocked'
    if ((!((aReader)->ReadSentinel(241369903)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'isLocked' (bool) member of 'Pref'");
        return false;
    }
    if ((!(IPC::ReadParam(aReader, (&((aVar)->isSanitized())))))) {
        aReader->FatalError("Error deserializing 'isSanitized' (bool) member of 'Pref'");
        return false;
    }
    // Sentinel = 'isSanitized'
    if ((!((aReader)->ReadSentinel(452658312)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'isSanitized' (bool) member of 'Pref'");
        return false;
    }
    if ((!(IPC::ReadParam(aReader, (&((aVar)->defaultValue())))))) {
        aReader->FatalError("Error deserializing 'defaultValue' (PrefValue?) member of 'Pref'");
        return false;
    }
    // Sentinel = 'defaultValue'
    if ((!((aReader)->ReadSentinel(529597667)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'defaultValue' (PrefValue?) member of 'Pref'");
        return false;
    }
    if ((!(IPC::ReadParam(aReader, (&((aVar)->userValue())))))) {
        aReader->FatalError("Error deserializing 'userValue' (PrefValue?) member of 'Pref'");
        return false;
    }
    // Sentinel = 'userValue'
    if ((!((aReader)->ReadSentinel(317850557)))) {
        mozilla::ipc::SentinelReadError("Error deserializing 'userValue' (PrefValue?) member of 'Pref'");
        return false;
    }
    return true;
}

} // namespace IPC
