//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef FetchTypes_h
#define FetchTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/ProtocolUtilsFwd.h"
#include "mozilla/ipc/Shmem.h"

// Headers for typedefs
#include "mozilla/RemoteLazyInputStream.h"
#include "mozilla/dom/FetchDriver.h"
#include "mozilla/dom/HeadersBinding.h"
#include "mozilla/dom/ReferrerPolicyBinding.h"
#include "mozilla/dom/RequestBinding.h"
#include "mozilla/dom/ResponseBinding.h"
#include "nsID.h"
#include "mozilla/ipc/IPCStream.h"
#include "mozilla/ipc/IPCChannelInfo.h"
#include "mozilla/ipc/PBackgroundSharedTypes.h"
#include "mozilla/dom/PerformanceTimingTypes.h"
#include "mozilla/net/NeckoChannelParams.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct HeadersEntry|
//
namespace mozilla {
namespace dom {
class HeadersEntry final
{
private:

public:
    MOZ_IMPLICIT HeadersEntry() :
        name_(),
        value_()
    {
    }

    MOZ_IMPLICIT HeadersEntry(
            const nsCString& _name,
            const nsCString& _value) :
        name_(_name),
        value_(_value)
    {
    }

    nsCString&
    name()
    {
        return name_;
    }
    const nsCString&
    name() const
    {
        return name_;
    }

    nsCString&
    value()
    {
        return value_;
    }
    const nsCString&
    value() const
    {
        return value_;
    }

private:
    nsCString name_;
    nsCString value_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::HeadersEntry>
{
    typedef mozilla::dom::HeadersEntry paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ParentToParentStream|
//
namespace mozilla {
namespace dom {
class ParentToParentStream final
{
private:

public:
    MOZ_IMPLICIT ParentToParentStream() :
        uuid_()
    {
    }

    MOZ_IMPLICIT ParentToParentStream(const nsID& _uuid) :
        uuid_(_uuid)
    {
    }

    nsID&
    uuid()
    {
        return uuid_;
    }
    const nsID&
    uuid() const
    {
        return uuid_;
    }

private:
    nsID uuid_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::ParentToParentStream>
{
    typedef mozilla::dom::ParentToParentStream paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ParentToChildStream|
//
namespace mozilla {
namespace dom {
class ParentToChildStream final
{
private:
    typedef mozilla::RemoteLazyInputStream RemoteLazyInputStream;

public:
    MOZ_IMPLICIT ParentToChildStream() :
        stream_()
    {
    }

    MOZ_IMPLICIT ParentToChildStream(RemoteLazyInputStream* _stream) :
        stream_(_stream)
    {
    }

    RefPtr<RemoteLazyInputStream>&
    stream()
    {
        return stream_;
    }
    RemoteLazyInputStream*
    stream() const
    {
        return stream_;
    }

private:
    RefPtr<RemoteLazyInputStream> stream_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::ParentToChildStream>
{
    typedef mozilla::dom::ParentToChildStream paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ChildToParentStream|
//
namespace mozilla {
namespace dom {
class ChildToParentStream final
{
private:
    typedef mozilla::ipc::IPCStream IPCStream;

public:
    MOZ_IMPLICIT ChildToParentStream() :
        stream_()
    {
    }

    MOZ_IMPLICIT ChildToParentStream(const IPCStream& _stream) :
        stream_(_stream)
    {
    }

    IPCStream&
    stream()
    {
        return stream_;
    }
    const IPCStream&
    stream() const
    {
        return stream_;
    }

private:
    IPCStream stream_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::ChildToParentStream>
{
    typedef mozilla::dom::ChildToParentStream paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union BodyStreamVariant|
//
namespace mozilla {
namespace dom {
class BodyStreamVariant final
{
public:
    enum Type {
        T__None,
        TParentToParentStream = 1,
        TParentToChildStream,
        TChildToParentStream,
        T__Last = TChildToParentStream
    };

private:
    typedef mozilla::dom::ParentToParentStream ParentToParentStream;
    typedef mozilla::dom::ParentToChildStream ParentToChildStream;
    typedef mozilla::dom::ChildToParentStream ChildToParentStream;
    typedef ParentToParentStream ParentToParentStream__tdef;
    typedef ParentToChildStream ParentToChildStream__tdef;
    typedef ChildToParentStream ChildToParentStream__tdef;

    union Value {
        mozilla::AlignedStorage2<ParentToParentStream> VParentToParentStream;
        mozilla::AlignedStorage2<ParentToChildStream> VParentToChildStream;
        mozilla::AlignedStorage2<ChildToParentStream> VChildToParentStream;
    };

    ParentToParentStream*
    ptr_ParentToParentStream()
    {
        return ((mValue).VParentToParentStream).addr();
    }
    const ParentToParentStream*
    constptr_ParentToParentStream() const
    {
        return ((mValue).VParentToParentStream).addr();
    }
    ParentToChildStream*
    ptr_ParentToChildStream()
    {
        return ((mValue).VParentToChildStream).addr();
    }
    const ParentToChildStream*
    constptr_ParentToChildStream() const
    {
        return ((mValue).VParentToChildStream).addr();
    }
    ChildToParentStream*
    ptr_ChildToParentStream()
    {
        return ((mValue).VChildToParentStream).addr();
    }
    const ChildToParentStream*
    constptr_ChildToParentStream() const
    {
        return ((mValue).VChildToParentStream).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT BodyStreamVariant() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT BodyStreamVariant(const ParentToParentStream& aOther);

    MOZ_IMPLICIT BodyStreamVariant(ParentToParentStream&& aOther);

    MOZ_IMPLICIT BodyStreamVariant(const ParentToChildStream& aOther);

    MOZ_IMPLICIT BodyStreamVariant(ParentToChildStream&& aOther);

    MOZ_IMPLICIT BodyStreamVariant(const ChildToParentStream& aOther);

    MOZ_IMPLICIT BodyStreamVariant(ChildToParentStream&& aOther);

    MOZ_IMPLICIT BodyStreamVariant(const BodyStreamVariant& aOther);

    MOZ_IMPLICIT BodyStreamVariant(BodyStreamVariant&& aOther);

    ~BodyStreamVariant();

    Type
    type() const
    {
        return mType;
    }

    BodyStreamVariant&
    operator=(const ParentToParentStream& aRhs);

    BodyStreamVariant&
    operator=(ParentToParentStream&& aRhs);

    BodyStreamVariant&
    operator=(const ParentToChildStream& aRhs);

    BodyStreamVariant&
    operator=(ParentToChildStream&& aRhs);

    BodyStreamVariant&
    operator=(const ChildToParentStream& aRhs);

    BodyStreamVariant&
    operator=(ChildToParentStream&& aRhs);

    BodyStreamVariant&
    operator=(const BodyStreamVariant& aRhs);

    BodyStreamVariant&
    operator=(BodyStreamVariant&& aRhs);

    ParentToParentStream&
    get_ParentToParentStream()
    {
        AssertSanity(TParentToParentStream);
        return (*(ptr_ParentToParentStream()));
    }
    const ParentToParentStream&
    get_ParentToParentStream() const
    {
        AssertSanity(TParentToParentStream);
        return (*(constptr_ParentToParentStream()));
    }
    operator ParentToParentStream&()
    {
        return get_ParentToParentStream();
    }
    operator const ParentToParentStream&() const
    {
        return get_ParentToParentStream();
    }

    ParentToChildStream&
    get_ParentToChildStream()
    {
        AssertSanity(TParentToChildStream);
        return (*(ptr_ParentToChildStream()));
    }
    const ParentToChildStream&
    get_ParentToChildStream() const
    {
        AssertSanity(TParentToChildStream);
        return (*(constptr_ParentToChildStream()));
    }
    operator ParentToChildStream&()
    {
        return get_ParentToChildStream();
    }
    operator const ParentToChildStream&() const
    {
        return get_ParentToChildStream();
    }

    ChildToParentStream&
    get_ChildToParentStream()
    {
        AssertSanity(TChildToParentStream);
        return (*(ptr_ChildToParentStream()));
    }
    const ChildToParentStream&
    get_ChildToParentStream() const
    {
        AssertSanity(TChildToParentStream);
        return (*(constptr_ChildToParentStream()));
    }
    operator ChildToParentStream&()
    {
        return get_ChildToParentStream();
    }
    operator const ChildToParentStream&() const
    {
        return get_ChildToParentStream();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::BodyStreamVariant>
{
    typedef mozilla::dom::BodyStreamVariant paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCInternalRequest|
//
namespace mozilla {
namespace dom {
class IPCInternalRequest final
{
private:
    typedef mozilla::dom::HeadersEntry HeadersEntry;
    typedef mozilla::dom::BodyStreamVariant BodyStreamVariant;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;
    typedef mozilla::net::RedirectHistoryEntryInfo RedirectHistoryEntryInfo;

public:
    MOZ_IMPLICIT IPCInternalRequest() :
        method_(),
        urlList_(),
        headersGuard_(),
        headers_(),
        body_(),
        preferredAlternativeDataType_(),
        referrer_(),
        referrerPolicy_(),
        requestMode_(),
        requestCredentials_(),
        cacheMode_(),
        requestRedirect_(),
        integrity_(),
        fragment_(),
        principalInfo_(),
        interceptionTriggeringPrincipalInfo_(),
        interceptionRedirectChain_(),
        interceptionFromThirdParty_(),
        bodySize_(),
        contentPolicyType_(),
        interceptionContentPolicyType_()
    {
    }

    MOZ_IMPLICIT IPCInternalRequest(
            const nsCString& _method,
            const nsTArray<nsCString>& _urlList,
            const HeadersGuardEnum& _headersGuard,
            const nsTArray<HeadersEntry>& _headers,
            const mozilla::Maybe<BodyStreamVariant>& _body,
            const int64_t& _bodySize,
            const nsCString& _preferredAlternativeDataType,
            const uint32_t& _contentPolicyType,
            const nsString& _referrer,
            const ReferrerPolicy& _referrerPolicy,
            const RequestMode& _requestMode,
            const RequestCredentials& _requestCredentials,
            const RequestCache& _cacheMode,
            const RequestRedirect& _requestRedirect,
            const nsString& _integrity,
            const nsCString& _fragment,
            const mozilla::Maybe<PrincipalInfo>& _principalInfo,
            const mozilla::Maybe<PrincipalInfo>& _interceptionTriggeringPrincipalInfo,
            const uint32_t& _interceptionContentPolicyType,
            const nsTArray<RedirectHistoryEntryInfo>& _interceptionRedirectChain,
            const bool& _interceptionFromThirdParty) :
        method_(_method),
        urlList_(_urlList),
        headersGuard_(_headersGuard),
        headers_(_headers),
        body_(_body),
        preferredAlternativeDataType_(_preferredAlternativeDataType),
        referrer_(_referrer),
        referrerPolicy_(_referrerPolicy),
        requestMode_(_requestMode),
        requestCredentials_(_requestCredentials),
        cacheMode_(_cacheMode),
        requestRedirect_(_requestRedirect),
        integrity_(_integrity),
        fragment_(_fragment),
        principalInfo_(_principalInfo),
        interceptionTriggeringPrincipalInfo_(_interceptionTriggeringPrincipalInfo),
        interceptionRedirectChain_(_interceptionRedirectChain),
        interceptionFromThirdParty_(_interceptionFromThirdParty),
        bodySize_(_bodySize),
        contentPolicyType_(_contentPolicyType),
        interceptionContentPolicyType_(_interceptionContentPolicyType)
    {
    }

    nsCString&
    method()
    {
        return method_;
    }
    const nsCString&
    method() const
    {
        return method_;
    }

    nsTArray<nsCString>&
    urlList()
    {
        return urlList_;
    }
    const nsTArray<nsCString>&
    urlList() const
    {
        return urlList_;
    }

    HeadersGuardEnum&
    headersGuard()
    {
        return headersGuard_;
    }
    const HeadersGuardEnum&
    headersGuard() const
    {
        return headersGuard_;
    }

    nsTArray<HeadersEntry>&
    headers()
    {
        return headers_;
    }
    const nsTArray<HeadersEntry>&
    headers() const
    {
        return headers_;
    }

    mozilla::Maybe<BodyStreamVariant>&
    body()
    {
        return body_;
    }
    const mozilla::Maybe<BodyStreamVariant>&
    body() const
    {
        return body_;
    }

    int64_t&
    bodySize()
    {
        return bodySize_;
    }
    const int64_t&
    bodySize() const
    {
        return bodySize_;
    }

    nsCString&
    preferredAlternativeDataType()
    {
        return preferredAlternativeDataType_;
    }
    const nsCString&
    preferredAlternativeDataType() const
    {
        return preferredAlternativeDataType_;
    }

    uint32_t&
    contentPolicyType()
    {
        return contentPolicyType_;
    }
    const uint32_t&
    contentPolicyType() const
    {
        return contentPolicyType_;
    }

    nsString&
    referrer()
    {
        return referrer_;
    }
    const nsString&
    referrer() const
    {
        return referrer_;
    }

    ReferrerPolicy&
    referrerPolicy()
    {
        return referrerPolicy_;
    }
    const ReferrerPolicy&
    referrerPolicy() const
    {
        return referrerPolicy_;
    }

    RequestMode&
    requestMode()
    {
        return requestMode_;
    }
    const RequestMode&
    requestMode() const
    {
        return requestMode_;
    }

    RequestCredentials&
    requestCredentials()
    {
        return requestCredentials_;
    }
    const RequestCredentials&
    requestCredentials() const
    {
        return requestCredentials_;
    }

    RequestCache&
    cacheMode()
    {
        return cacheMode_;
    }
    const RequestCache&
    cacheMode() const
    {
        return cacheMode_;
    }

    RequestRedirect&
    requestRedirect()
    {
        return requestRedirect_;
    }
    const RequestRedirect&
    requestRedirect() const
    {
        return requestRedirect_;
    }

    nsString&
    integrity()
    {
        return integrity_;
    }
    const nsString&
    integrity() const
    {
        return integrity_;
    }

    nsCString&
    fragment()
    {
        return fragment_;
    }
    const nsCString&
    fragment() const
    {
        return fragment_;
    }

    mozilla::Maybe<PrincipalInfo>&
    principalInfo()
    {
        return principalInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    principalInfo() const
    {
        return principalInfo_;
    }

    mozilla::Maybe<PrincipalInfo>&
    interceptionTriggeringPrincipalInfo()
    {
        return interceptionTriggeringPrincipalInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    interceptionTriggeringPrincipalInfo() const
    {
        return interceptionTriggeringPrincipalInfo_;
    }

    uint32_t&
    interceptionContentPolicyType()
    {
        return interceptionContentPolicyType_;
    }
    const uint32_t&
    interceptionContentPolicyType() const
    {
        return interceptionContentPolicyType_;
    }

    nsTArray<RedirectHistoryEntryInfo>&
    interceptionRedirectChain()
    {
        return interceptionRedirectChain_;
    }
    const nsTArray<RedirectHistoryEntryInfo>&
    interceptionRedirectChain() const
    {
        return interceptionRedirectChain_;
    }

    bool&
    interceptionFromThirdParty()
    {
        return interceptionFromThirdParty_;
    }
    const bool&
    interceptionFromThirdParty() const
    {
        return interceptionFromThirdParty_;
    }

private:
    void
    StaticAssertions() const;
    nsCString method_;
    CopyableTArray<nsCString> urlList_;
    HeadersGuardEnum headersGuard_;
    CopyableTArray<HeadersEntry> headers_;
    mozilla::Maybe<BodyStreamVariant> body_;
    nsCString preferredAlternativeDataType_;
    nsString referrer_;
    ReferrerPolicy referrerPolicy_;
    RequestMode requestMode_;
    RequestCredentials requestCredentials_;
    RequestCache cacheMode_;
    RequestRedirect requestRedirect_;
    nsString integrity_;
    nsCString fragment_;
    mozilla::Maybe<PrincipalInfo> principalInfo_;
    mozilla::Maybe<PrincipalInfo> interceptionTriggeringPrincipalInfo_;
    CopyableTArray<RedirectHistoryEntryInfo> interceptionRedirectChain_;
    bool interceptionFromThirdParty_;
    int64_t bodySize_;
    uint32_t contentPolicyType_;
    uint32_t interceptionContentPolicyType_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::IPCInternalRequest>
{
    typedef mozilla::dom::IPCInternalRequest paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct InternalResponseMetadata|
//
namespace mozilla {
namespace dom {
class InternalResponseMetadata final
{
private:
    typedef mozilla::dom::HeadersEntry HeadersEntry;
    typedef mozilla::ipc::IPCChannelInfo IPCChannelInfo;
    typedef mozilla::ipc::PrincipalInfo PrincipalInfo;

public:
    MOZ_IMPLICIT InternalResponseMetadata() :
        type_(),
        urlList_(),
        statusText_(),
        headersGuard_(),
        headers_(),
        errorCode_(),
        alternativeDataType_(),
        channelInfo_(),
        principalInfo_(),
        status_()
    {
    }

    MOZ_IMPLICIT InternalResponseMetadata(
            const ResponseType& _type,
            const nsTArray<nsCString>& _urlList,
            const uint16_t& _status,
            const nsCString& _statusText,
            const HeadersGuardEnum& _headersGuard,
            const nsTArray<HeadersEntry>& _headers,
            const nsresult& _errorCode,
            const nsCString& _alternativeDataType,
            const IPCChannelInfo& _channelInfo,
            const mozilla::Maybe<PrincipalInfo>& _principalInfo) :
        type_(_type),
        urlList_(_urlList),
        statusText_(_statusText),
        headersGuard_(_headersGuard),
        headers_(_headers),
        errorCode_(_errorCode),
        alternativeDataType_(_alternativeDataType),
        channelInfo_(_channelInfo),
        principalInfo_(_principalInfo),
        status_(_status)
    {
    }

    ResponseType&
    type()
    {
        return type_;
    }
    const ResponseType&
    type() const
    {
        return type_;
    }

    nsTArray<nsCString>&
    urlList()
    {
        return urlList_;
    }
    const nsTArray<nsCString>&
    urlList() const
    {
        return urlList_;
    }

    uint16_t&
    status()
    {
        return status_;
    }
    const uint16_t&
    status() const
    {
        return status_;
    }

    nsCString&
    statusText()
    {
        return statusText_;
    }
    const nsCString&
    statusText() const
    {
        return statusText_;
    }

    HeadersGuardEnum&
    headersGuard()
    {
        return headersGuard_;
    }
    const HeadersGuardEnum&
    headersGuard() const
    {
        return headersGuard_;
    }

    nsTArray<HeadersEntry>&
    headers()
    {
        return headers_;
    }
    const nsTArray<HeadersEntry>&
    headers() const
    {
        return headers_;
    }

    nsresult&
    errorCode()
    {
        return errorCode_;
    }
    const nsresult&
    errorCode() const
    {
        return errorCode_;
    }

    nsCString&
    alternativeDataType()
    {
        return alternativeDataType_;
    }
    const nsCString&
    alternativeDataType() const
    {
        return alternativeDataType_;
    }

    IPCChannelInfo&
    channelInfo()
    {
        return channelInfo_;
    }
    const IPCChannelInfo&
    channelInfo() const
    {
        return channelInfo_;
    }

    mozilla::Maybe<PrincipalInfo>&
    principalInfo()
    {
        return principalInfo_;
    }
    const mozilla::Maybe<PrincipalInfo>&
    principalInfo() const
    {
        return principalInfo_;
    }

private:
    ResponseType type_;
    CopyableTArray<nsCString> urlList_;
    nsCString statusText_;
    HeadersGuardEnum headersGuard_;
    CopyableTArray<HeadersEntry> headers_;
    nsresult errorCode_;
    nsCString alternativeDataType_;
    IPCChannelInfo channelInfo_;
    mozilla::Maybe<PrincipalInfo> principalInfo_;
    uint16_t status_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::InternalResponseMetadata>
{
    typedef mozilla::dom::InternalResponseMetadata paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ParentToParentInternalResponse|
//
namespace mozilla {
namespace dom {
class ParentToParentInternalResponse final
{
private:
    typedef mozilla::dom::InternalResponseMetadata InternalResponseMetadata;
    typedef mozilla::dom::ParentToParentStream ParentToParentStream;

public:
    MOZ_IMPLICIT ParentToParentInternalResponse() :
        metadata_(),
        body_(),
        alternativeBody_(),
        bodySize_()
    {
    }

    MOZ_IMPLICIT ParentToParentInternalResponse(
            const InternalResponseMetadata& _metadata,
            const mozilla::Maybe<ParentToParentStream>& _body,
            const int64_t& _bodySize,
            const mozilla::Maybe<ParentToParentStream>& _alternativeBody) :
        metadata_(_metadata),
        body_(_body),
        alternativeBody_(_alternativeBody),
        bodySize_(_bodySize)
    {
    }

    InternalResponseMetadata&
    metadata()
    {
        return metadata_;
    }
    const InternalResponseMetadata&
    metadata() const
    {
        return metadata_;
    }

    mozilla::Maybe<ParentToParentStream>&
    body()
    {
        return body_;
    }
    const mozilla::Maybe<ParentToParentStream>&
    body() const
    {
        return body_;
    }

    int64_t&
    bodySize()
    {
        return bodySize_;
    }
    const int64_t&
    bodySize() const
    {
        return bodySize_;
    }

    mozilla::Maybe<ParentToParentStream>&
    alternativeBody()
    {
        return alternativeBody_;
    }
    const mozilla::Maybe<ParentToParentStream>&
    alternativeBody() const
    {
        return alternativeBody_;
    }

private:
    InternalResponseMetadata metadata_;
    mozilla::Maybe<ParentToParentStream> body_;
    mozilla::Maybe<ParentToParentStream> alternativeBody_;
    int64_t bodySize_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::ParentToParentInternalResponse>
{
    typedef mozilla::dom::ParentToParentInternalResponse paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ParentToChildInternalResponse|
//
namespace mozilla {
namespace dom {
class ParentToChildInternalResponse final
{
private:
    typedef mozilla::dom::InternalResponseMetadata InternalResponseMetadata;
    typedef mozilla::dom::ParentToChildStream ParentToChildStream;

public:
    MOZ_IMPLICIT ParentToChildInternalResponse() :
        metadata_(),
        body_(),
        alternativeBody_(),
        bodySize_()
    {
    }

    MOZ_IMPLICIT ParentToChildInternalResponse(
            const InternalResponseMetadata& _metadata,
            const mozilla::Maybe<ParentToChildStream>& _body,
            const int64_t& _bodySize,
            const mozilla::Maybe<ParentToChildStream>& _alternativeBody) :
        metadata_(_metadata),
        body_(_body),
        alternativeBody_(_alternativeBody),
        bodySize_(_bodySize)
    {
    }

    InternalResponseMetadata&
    metadata()
    {
        return metadata_;
    }
    const InternalResponseMetadata&
    metadata() const
    {
        return metadata_;
    }

    mozilla::Maybe<ParentToChildStream>&
    body()
    {
        return body_;
    }
    const mozilla::Maybe<ParentToChildStream>&
    body() const
    {
        return body_;
    }

    int64_t&
    bodySize()
    {
        return bodySize_;
    }
    const int64_t&
    bodySize() const
    {
        return bodySize_;
    }

    mozilla::Maybe<ParentToChildStream>&
    alternativeBody()
    {
        return alternativeBody_;
    }
    const mozilla::Maybe<ParentToChildStream>&
    alternativeBody() const
    {
        return alternativeBody_;
    }

private:
    InternalResponseMetadata metadata_;
    mozilla::Maybe<ParentToChildStream> body_;
    mozilla::Maybe<ParentToChildStream> alternativeBody_;
    int64_t bodySize_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::ParentToChildInternalResponse>
{
    typedef mozilla::dom::ParentToChildInternalResponse paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ChildToParentInternalResponse|
//
namespace mozilla {
namespace dom {
class ChildToParentInternalResponse final
{
private:
    typedef mozilla::dom::InternalResponseMetadata InternalResponseMetadata;
    typedef mozilla::dom::ChildToParentStream ChildToParentStream;

public:
    MOZ_IMPLICIT ChildToParentInternalResponse() :
        metadata_(),
        body_(),
        alternativeBody_(),
        bodySize_()
    {
    }

    MOZ_IMPLICIT ChildToParentInternalResponse(
            const InternalResponseMetadata& _metadata,
            const mozilla::Maybe<ChildToParentStream>& _body,
            const int64_t& _bodySize,
            const mozilla::Maybe<ChildToParentStream>& _alternativeBody) :
        metadata_(_metadata),
        body_(_body),
        alternativeBody_(_alternativeBody),
        bodySize_(_bodySize)
    {
    }

    InternalResponseMetadata&
    metadata()
    {
        return metadata_;
    }
    const InternalResponseMetadata&
    metadata() const
    {
        return metadata_;
    }

    mozilla::Maybe<ChildToParentStream>&
    body()
    {
        return body_;
    }
    const mozilla::Maybe<ChildToParentStream>&
    body() const
    {
        return body_;
    }

    int64_t&
    bodySize()
    {
        return bodySize_;
    }
    const int64_t&
    bodySize() const
    {
        return bodySize_;
    }

    mozilla::Maybe<ChildToParentStream>&
    alternativeBody()
    {
        return alternativeBody_;
    }
    const mozilla::Maybe<ChildToParentStream>&
    alternativeBody() const
    {
        return alternativeBody_;
    }

private:
    InternalResponseMetadata metadata_;
    mozilla::Maybe<ChildToParentStream> body_;
    mozilla::Maybe<ChildToParentStream> alternativeBody_;
    int64_t bodySize_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::ChildToParentInternalResponse>
{
    typedef mozilla::dom::ChildToParentInternalResponse paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ResponseTiming|
//
namespace mozilla {
namespace dom {
class ResponseTiming final
{
private:
    typedef mozilla::dom::IPCPerformanceTimingData IPCPerformanceTimingData;

public:
    MOZ_IMPLICIT ResponseTiming() :
        timingData_(),
        initiatorType_(),
        entryName_()
    {
    }

    MOZ_IMPLICIT ResponseTiming(
            const IPCPerformanceTimingData& _timingData,
            const nsString& _initiatorType,
            const nsString& _entryName) :
        timingData_(_timingData),
        initiatorType_(_initiatorType),
        entryName_(_entryName)
    {
    }

    IPCPerformanceTimingData&
    timingData()
    {
        return timingData_;
    }
    const IPCPerformanceTimingData&
    timingData() const
    {
        return timingData_;
    }

    nsString&
    initiatorType()
    {
        return initiatorType_;
    }
    const nsString&
    initiatorType() const
    {
        return initiatorType_;
    }

    nsString&
    entryName()
    {
        return entryName_;
    }
    const nsString&
    entryName() const
    {
        return entryName_;
    }

private:
    IPCPerformanceTimingData timingData_;
    nsString initiatorType_;
    nsString entryName_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::ResponseTiming>
{
    typedef mozilla::dom::ResponseTiming paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ResponseEndArgs|
//
namespace mozilla {
namespace dom {
class ResponseEndArgs final
{
private:
    typedef FetchDriverObserver::EndReason EndReason;
    typedef mozilla::dom::ResponseTiming ResponseTiming;

public:
    MOZ_IMPLICIT ResponseEndArgs() :
        endReason_(),
        timing_()
    {
    }

    MOZ_IMPLICIT ResponseEndArgs(
            const EndReason& _endReason,
            const mozilla::Maybe<ResponseTiming>& _timing) :
        endReason_(_endReason),
        timing_(_timing)
    {
    }

    EndReason&
    endReason()
    {
        return endReason_;
    }
    const EndReason&
    endReason() const
    {
        return endReason_;
    }

    mozilla::Maybe<ResponseTiming>&
    timing()
    {
        return timing_;
    }
    const mozilla::Maybe<ResponseTiming>&
    timing() const
    {
        return timing_;
    }

private:
    EndReason endReason_;
    mozilla::Maybe<ResponseTiming> timing_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::ResponseEndArgs>
{
    typedef mozilla::dom::ResponseEndArgs paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

#endif // ifndef FetchTypes_h
