//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PServiceWorkerRegistrationParent_h
#define PServiceWorkerRegistrationParent_h

#include "mozilla/dom/PServiceWorkerRegistration.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "mozilla/ErrorResult.h"
#include "mozilla/dom/ServiceWorkerRegistrationBinding.h"

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla
namespace mozilla {
namespace ipc {
class PBackgroundChild;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace ipc {
class PBackgroundParent;
} // namespace ipc
} // namespace mozilla

namespace mozilla {
namespace dom {


class PServiceWorkerRegistrationParent :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::ipc::PBackgroundParent;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef mozilla::CopyableErrorResult CopyableErrorResult;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef mozilla::dom::IPCNavigationPreloadState IPCNavigationPreloadState;
    typedef mozilla::dom::IPCServiceWorkerRegistrationDescriptor IPCServiceWorkerRegistrationDescriptor;
    typedef mozilla::dom::IPCServiceWorkerRegistrationDescriptorList IPCServiceWorkerRegistrationDescriptorList;
    typedef mozilla::dom::IPCServiceWorkerRegistrationDescriptorListOrCopyableErrorResult IPCServiceWorkerRegistrationDescriptorListOrCopyableErrorResult;
    typedef mozilla::dom::IPCServiceWorkerRegistrationDescriptorOrCopyableErrorResult IPCServiceWorkerRegistrationDescriptorOrCopyableErrorResult;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef mozilla::ipc::PBackgroundChild PBackgroundChild;
    typedef mozilla::ipc::PBackgroundParent PBackgroundParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;

public:
    typedef std::function<void(Tuple<const bool&, const CopyableErrorResult&>)> UnregisterResolver;
    typedef std::function<void(const IPCServiceWorkerRegistrationDescriptorOrCopyableErrorResult&)> UpdateResolver;
    typedef std::function<void(const bool&)> SetNavigationPreloadEnabledResolver;
    typedef std::function<void(const bool&)> SetNavigationPreloadHeaderResolver;
    typedef std::function<void(const mozilla::Maybe<IPCNavigationPreloadState>&)> GetNavigationPreloadStateResolver;

protected:
    virtual mozilla::ipc::IPCResult
    RecvTeardown() = 0;
    virtual mozilla::ipc::IPCResult
    RecvUnregister(UnregisterResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvUpdate(
            const nsCString& aNewestWorkerScriptUrl,
            UpdateResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetNavigationPreloadEnabled(
            const bool& aEnabled,
            SetNavigationPreloadEnabledResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvSetNavigationPreloadHeader(
            const nsCString& aHeader,
            SetNavigationPreloadHeaderResolver&& aResolve) = 0;
    virtual mozilla::ipc::IPCResult
    RecvGetNavigationPreloadState(GetNavigationPreloadStateResolver&& aResolve) = 0;
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PServiceWorkerRegistrationParent();

    virtual ~PServiceWorkerRegistrationParent();

    NS_INLINE_DECL_PURE_VIRTUAL_REFCOUNTING
protected:
    void ActorAlloc() final { AddRef(); }
    void ActorDealloc() final { Release(); }
public:
    ::base::ProcessId
    OtherPid() const;

    PBackgroundParent*
    Manager() const;

    void
    AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const override;

    [[nodiscard]] static bool
    Send__delete__(PServiceWorkerRegistrationParent* actor);

    [[nodiscard]] bool
    SendUpdateState(const IPCServiceWorkerRegistrationDescriptor& aDescriptor);

    [[nodiscard]] bool
    SendFireUpdateFound();

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

private:
    void
    ClearSubtree();

    bool mAwaitingManagedEndpointBind = false;

};


} // namespace dom
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <mozilla::dom::PServiceWorkerRegistrationParent*>
{
    typedef mozilla::dom::PServiceWorkerRegistrationParent* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

#endif // ifndef PServiceWorkerRegistrationParent_h
