//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PerformanceTimingTypes_h
#define PerformanceTimingTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/ProtocolUtilsFwd.h"
#include "mozilla/ipc/Shmem.h"

// Headers for typedefs
#include "mozilla/TimeStamp.h"
#include "nsDOMNavigationTiming.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCServerTiming|
//
namespace mozilla {
namespace dom {
class IPCServerTiming final
{
private:

public:
    MOZ_IMPLICIT IPCServerTiming() :
        name_(),
        description_(),
        duration_()
    {
    }

    MOZ_IMPLICIT IPCServerTiming(
            const nsCString& _name,
            const double& _duration,
            const nsCString& _description) :
        name_(_name),
        description_(_description),
        duration_(_duration)
    {
    }

    nsCString&
    name()
    {
        return name_;
    }
    const nsCString&
    name() const
    {
        return name_;
    }

    double&
    duration()
    {
        return duration_;
    }
    const double&
    duration() const
    {
        return duration_;
    }

    nsCString&
    description()
    {
        return description_;
    }
    const nsCString&
    description() const
    {
        return description_;
    }

private:
    nsCString name_;
    nsCString description_;
    double duration_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::IPCServerTiming>
{
    typedef mozilla::dom::IPCServerTiming paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct IPCPerformanceTimingData|
//
namespace mozilla {
namespace dom {
class IPCPerformanceTimingData final
{
private:
    typedef mozilla::dom::IPCServerTiming IPCServerTiming;
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT IPCPerformanceTimingData() :
        serverTiming_(),
        nextHopProtocol_(),
        asyncOpen_(),
        redirectStart_(),
        redirectEnd_(),
        domainLookupStart_(),
        domainLookupEnd_(),
        connectStart_(),
        secureConnectionStart_(),
        connectEnd_(),
        requestStart_(),
        responseStart_(),
        cacheReadStart_(),
        responseEnd_(),
        cacheReadEnd_(),
        workerStart_(),
        workerRequestStart_(),
        workerResponseEnd_(),
        zeroTime_(),
        fetchStart_(),
        allRedirectsSameOrigin_(),
        allRedirectsPassTAO_(),
        secureConnection_(),
        timingAllowed_(),
        initialized_(),
        encodedBodySize_(),
        transferSize_(),
        decodedBodySize_(),
        redirectCount_()
    {
    }

    MOZ_IMPLICIT IPCPerformanceTimingData(
            const nsTArray<IPCServerTiming>& _serverTiming,
            const nsString& _nextHopProtocol,
            const TimeStamp& _asyncOpen,
            const TimeStamp& _redirectStart,
            const TimeStamp& _redirectEnd,
            const TimeStamp& _domainLookupStart,
            const TimeStamp& _domainLookupEnd,
            const TimeStamp& _connectStart,
            const TimeStamp& _secureConnectionStart,
            const TimeStamp& _connectEnd,
            const TimeStamp& _requestStart,
            const TimeStamp& _responseStart,
            const TimeStamp& _cacheReadStart,
            const TimeStamp& _responseEnd,
            const TimeStamp& _cacheReadEnd,
            const TimeStamp& _workerStart,
            const TimeStamp& _workerRequestStart,
            const TimeStamp& _workerResponseEnd,
            const DOMHighResTimeStamp& _zeroTime,
            const DOMHighResTimeStamp& _fetchStart,
            const uint64_t& _encodedBodySize,
            const uint64_t& _transferSize,
            const uint64_t& _decodedBodySize,
            const uint8_t& _redirectCount,
            const bool& _allRedirectsSameOrigin,
            const bool& _allRedirectsPassTAO,
            const bool& _secureConnection,
            const bool& _timingAllowed,
            const bool& _initialized) :
        serverTiming_(_serverTiming),
        nextHopProtocol_(_nextHopProtocol),
        asyncOpen_(_asyncOpen),
        redirectStart_(_redirectStart),
        redirectEnd_(_redirectEnd),
        domainLookupStart_(_domainLookupStart),
        domainLookupEnd_(_domainLookupEnd),
        connectStart_(_connectStart),
        secureConnectionStart_(_secureConnectionStart),
        connectEnd_(_connectEnd),
        requestStart_(_requestStart),
        responseStart_(_responseStart),
        cacheReadStart_(_cacheReadStart),
        responseEnd_(_responseEnd),
        cacheReadEnd_(_cacheReadEnd),
        workerStart_(_workerStart),
        workerRequestStart_(_workerRequestStart),
        workerResponseEnd_(_workerResponseEnd),
        zeroTime_(_zeroTime),
        fetchStart_(_fetchStart),
        allRedirectsSameOrigin_(_allRedirectsSameOrigin),
        allRedirectsPassTAO_(_allRedirectsPassTAO),
        secureConnection_(_secureConnection),
        timingAllowed_(_timingAllowed),
        initialized_(_initialized),
        encodedBodySize_(_encodedBodySize),
        transferSize_(_transferSize),
        decodedBodySize_(_decodedBodySize),
        redirectCount_(_redirectCount)
    {
    }

    nsTArray<IPCServerTiming>&
    serverTiming()
    {
        return serverTiming_;
    }
    const nsTArray<IPCServerTiming>&
    serverTiming() const
    {
        return serverTiming_;
    }

    nsString&
    nextHopProtocol()
    {
        return nextHopProtocol_;
    }
    const nsString&
    nextHopProtocol() const
    {
        return nextHopProtocol_;
    }

    TimeStamp&
    asyncOpen()
    {
        return asyncOpen_;
    }
    const TimeStamp&
    asyncOpen() const
    {
        return asyncOpen_;
    }

    TimeStamp&
    redirectStart()
    {
        return redirectStart_;
    }
    const TimeStamp&
    redirectStart() const
    {
        return redirectStart_;
    }

    TimeStamp&
    redirectEnd()
    {
        return redirectEnd_;
    }
    const TimeStamp&
    redirectEnd() const
    {
        return redirectEnd_;
    }

    TimeStamp&
    domainLookupStart()
    {
        return domainLookupStart_;
    }
    const TimeStamp&
    domainLookupStart() const
    {
        return domainLookupStart_;
    }

    TimeStamp&
    domainLookupEnd()
    {
        return domainLookupEnd_;
    }
    const TimeStamp&
    domainLookupEnd() const
    {
        return domainLookupEnd_;
    }

    TimeStamp&
    connectStart()
    {
        return connectStart_;
    }
    const TimeStamp&
    connectStart() const
    {
        return connectStart_;
    }

    TimeStamp&
    secureConnectionStart()
    {
        return secureConnectionStart_;
    }
    const TimeStamp&
    secureConnectionStart() const
    {
        return secureConnectionStart_;
    }

    TimeStamp&
    connectEnd()
    {
        return connectEnd_;
    }
    const TimeStamp&
    connectEnd() const
    {
        return connectEnd_;
    }

    TimeStamp&
    requestStart()
    {
        return requestStart_;
    }
    const TimeStamp&
    requestStart() const
    {
        return requestStart_;
    }

    TimeStamp&
    responseStart()
    {
        return responseStart_;
    }
    const TimeStamp&
    responseStart() const
    {
        return responseStart_;
    }

    TimeStamp&
    cacheReadStart()
    {
        return cacheReadStart_;
    }
    const TimeStamp&
    cacheReadStart() const
    {
        return cacheReadStart_;
    }

    TimeStamp&
    responseEnd()
    {
        return responseEnd_;
    }
    const TimeStamp&
    responseEnd() const
    {
        return responseEnd_;
    }

    TimeStamp&
    cacheReadEnd()
    {
        return cacheReadEnd_;
    }
    const TimeStamp&
    cacheReadEnd() const
    {
        return cacheReadEnd_;
    }

    TimeStamp&
    workerStart()
    {
        return workerStart_;
    }
    const TimeStamp&
    workerStart() const
    {
        return workerStart_;
    }

    TimeStamp&
    workerRequestStart()
    {
        return workerRequestStart_;
    }
    const TimeStamp&
    workerRequestStart() const
    {
        return workerRequestStart_;
    }

    TimeStamp&
    workerResponseEnd()
    {
        return workerResponseEnd_;
    }
    const TimeStamp&
    workerResponseEnd() const
    {
        return workerResponseEnd_;
    }

    DOMHighResTimeStamp&
    zeroTime()
    {
        return zeroTime_;
    }
    const DOMHighResTimeStamp&
    zeroTime() const
    {
        return zeroTime_;
    }

    DOMHighResTimeStamp&
    fetchStart()
    {
        return fetchStart_;
    }
    const DOMHighResTimeStamp&
    fetchStart() const
    {
        return fetchStart_;
    }

    uint64_t&
    encodedBodySize()
    {
        return encodedBodySize_;
    }
    const uint64_t&
    encodedBodySize() const
    {
        return encodedBodySize_;
    }

    uint64_t&
    transferSize()
    {
        return transferSize_;
    }
    const uint64_t&
    transferSize() const
    {
        return transferSize_;
    }

    uint64_t&
    decodedBodySize()
    {
        return decodedBodySize_;
    }
    const uint64_t&
    decodedBodySize() const
    {
        return decodedBodySize_;
    }

    uint8_t&
    redirectCount()
    {
        return redirectCount_;
    }
    const uint8_t&
    redirectCount() const
    {
        return redirectCount_;
    }

    bool&
    allRedirectsSameOrigin()
    {
        return allRedirectsSameOrigin_;
    }
    const bool&
    allRedirectsSameOrigin() const
    {
        return allRedirectsSameOrigin_;
    }

    bool&
    allRedirectsPassTAO()
    {
        return allRedirectsPassTAO_;
    }
    const bool&
    allRedirectsPassTAO() const
    {
        return allRedirectsPassTAO_;
    }

    bool&
    secureConnection()
    {
        return secureConnection_;
    }
    const bool&
    secureConnection() const
    {
        return secureConnection_;
    }

    bool&
    timingAllowed()
    {
        return timingAllowed_;
    }
    const bool&
    timingAllowed() const
    {
        return timingAllowed_;
    }

    bool&
    initialized()
    {
        return initialized_;
    }
    const bool&
    initialized() const
    {
        return initialized_;
    }

private:
    void
    StaticAssertions() const;
    CopyableTArray<IPCServerTiming> serverTiming_;
    nsString nextHopProtocol_;
    TimeStamp asyncOpen_;
    TimeStamp redirectStart_;
    TimeStamp redirectEnd_;
    TimeStamp domainLookupStart_;
    TimeStamp domainLookupEnd_;
    TimeStamp connectStart_;
    TimeStamp secureConnectionStart_;
    TimeStamp connectEnd_;
    TimeStamp requestStart_;
    TimeStamp responseStart_;
    TimeStamp cacheReadStart_;
    TimeStamp responseEnd_;
    TimeStamp cacheReadEnd_;
    TimeStamp workerStart_;
    TimeStamp workerRequestStart_;
    TimeStamp workerResponseEnd_;
    DOMHighResTimeStamp zeroTime_;
    DOMHighResTimeStamp fetchStart_;
    bool allRedirectsSameOrigin_;
    bool allRedirectsPassTAO_;
    bool secureConnection_;
    bool timingAllowed_;
    bool initialized_;
    uint64_t encodedBodySize_;
    uint64_t transferSize_;
    uint64_t decodedBodySize_;
    uint8_t redirectCount_;
};
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::IPCPerformanceTimingData>
{
    typedef mozilla::dom::IPCPerformanceTimingData paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

#endif // ifndef PerformanceTimingTypes_h
