//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef SessionStoreTypes_h
#define SessionStoreTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/ProtocolUtilsFwd.h"
#include "mozilla/ipc/Shmem.h"
#include "mozilla/dom/DOMTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Checkbox|
//
namespace mozilla {
namespace dom {
namespace sessionstore {
class Checkbox final
{
private:

public:
    MOZ_IMPLICIT Checkbox() :
        value_()
    {
    }

    MOZ_IMPLICIT Checkbox(const bool& _value) :
        value_(_value)
    {
    }

    bool&
    value()
    {
        return value_;
    }
    const bool&
    value() const
    {
        return value_;
    }

private:
    bool value_;
};
} // namespace sessionstore
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::sessionstore::Checkbox>
{
    typedef mozilla::dom::sessionstore::Checkbox paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TextField|
//
namespace mozilla {
namespace dom {
namespace sessionstore {
class TextField final
{
private:

public:
    MOZ_IMPLICIT TextField() :
        value_()
    {
    }

    MOZ_IMPLICIT TextField(const nsString& _value) :
        value_(_value)
    {
    }

    nsString&
    value()
    {
        return value_;
    }
    const nsString&
    value() const
    {
        return value_;
    }

private:
    nsString value_;
};
} // namespace sessionstore
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::sessionstore::TextField>
{
    typedef mozilla::dom::sessionstore::TextField paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FileList|
//
namespace mozilla {
namespace dom {
namespace sessionstore {
class FileList final
{
private:

public:
    MOZ_IMPLICIT FileList() :
        valueList_()
    {
    }

    MOZ_IMPLICIT FileList(const nsTArray<nsString>& _valueList) :
        valueList_(_valueList)
    {
    }

    nsTArray<nsString>&
    valueList()
    {
        return valueList_;
    }
    const nsTArray<nsString>&
    valueList() const
    {
        return valueList_;
    }

private:
    CopyableTArray<nsString> valueList_;
};
} // namespace sessionstore
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::sessionstore::FileList>
{
    typedef mozilla::dom::sessionstore::FileList paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct SingleSelect|
//
namespace mozilla {
namespace dom {
namespace sessionstore {
class SingleSelect final
{
private:

public:
    MOZ_IMPLICIT SingleSelect() :
        value_(),
        index_()
    {
    }

    MOZ_IMPLICIT SingleSelect(
            const uint32_t& _index,
            const nsString& _value) :
        value_(_value),
        index_(_index)
    {
    }

    uint32_t&
    index()
    {
        return index_;
    }
    const uint32_t&
    index() const
    {
        return index_;
    }

    nsString&
    value()
    {
        return value_;
    }
    const nsString&
    value() const
    {
        return value_;
    }

private:
    nsString value_;
    uint32_t index_;
};
} // namespace sessionstore
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::sessionstore::SingleSelect>
{
    typedef mozilla::dom::sessionstore::SingleSelect paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MultipleSelect|
//
namespace mozilla {
namespace dom {
namespace sessionstore {
class MultipleSelect final
{
private:

public:
    MOZ_IMPLICIT MultipleSelect() :
        valueList_()
    {
    }

    MOZ_IMPLICIT MultipleSelect(const nsTArray<nsString>& _valueList) :
        valueList_(_valueList)
    {
    }

    nsTArray<nsString>&
    valueList()
    {
        return valueList_;
    }
    const nsTArray<nsString>&
    valueList() const
    {
        return valueList_;
    }

private:
    CopyableTArray<nsString> valueList_;
};
} // namespace sessionstore
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::sessionstore::MultipleSelect>
{
    typedef mozilla::dom::sessionstore::MultipleSelect paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union FormEntryValue|
//
namespace mozilla {
namespace dom {
namespace sessionstore {
class FormEntryValue final
{
public:
    enum Type {
        T__None,
        TCheckbox = 1,
        TTextField,
        TFileList,
        TSingleSelect,
        TMultipleSelect,
        T__Last = TMultipleSelect
    };

private:
    typedef mozilla::dom::sessionstore::Checkbox Checkbox;
    typedef mozilla::dom::sessionstore::TextField TextField;
    typedef mozilla::dom::sessionstore::FileList FileList;
    typedef mozilla::dom::sessionstore::SingleSelect SingleSelect;
    typedef mozilla::dom::sessionstore::MultipleSelect MultipleSelect;
    typedef Checkbox Checkbox__tdef;
    typedef TextField TextField__tdef;
    typedef FileList FileList__tdef;
    typedef SingleSelect SingleSelect__tdef;
    typedef MultipleSelect MultipleSelect__tdef;

    union Value {
        mozilla::AlignedStorage2<Checkbox> VCheckbox;
        mozilla::AlignedStorage2<TextField> VTextField;
        mozilla::AlignedStorage2<FileList> VFileList;
        mozilla::AlignedStorage2<SingleSelect> VSingleSelect;
        mozilla::AlignedStorage2<MultipleSelect> VMultipleSelect;
    };

    Checkbox*
    ptr_Checkbox()
    {
        return ((mValue).VCheckbox).addr();
    }
    const Checkbox*
    constptr_Checkbox() const
    {
        return ((mValue).VCheckbox).addr();
    }
    TextField*
    ptr_TextField()
    {
        return ((mValue).VTextField).addr();
    }
    const TextField*
    constptr_TextField() const
    {
        return ((mValue).VTextField).addr();
    }
    FileList*
    ptr_FileList()
    {
        return ((mValue).VFileList).addr();
    }
    const FileList*
    constptr_FileList() const
    {
        return ((mValue).VFileList).addr();
    }
    SingleSelect*
    ptr_SingleSelect()
    {
        return ((mValue).VSingleSelect).addr();
    }
    const SingleSelect*
    constptr_SingleSelect() const
    {
        return ((mValue).VSingleSelect).addr();
    }
    MultipleSelect*
    ptr_MultipleSelect()
    {
        return ((mValue).VMultipleSelect).addr();
    }
    const MultipleSelect*
    constptr_MultipleSelect() const
    {
        return ((mValue).VMultipleSelect).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT FormEntryValue() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT FormEntryValue(const Checkbox& aOther);

    MOZ_IMPLICIT FormEntryValue(Checkbox&& aOther);

    MOZ_IMPLICIT FormEntryValue(const TextField& aOther);

    MOZ_IMPLICIT FormEntryValue(TextField&& aOther);

    MOZ_IMPLICIT FormEntryValue(const FileList& aOther);

    MOZ_IMPLICIT FormEntryValue(FileList&& aOther);

    MOZ_IMPLICIT FormEntryValue(const SingleSelect& aOther);

    MOZ_IMPLICIT FormEntryValue(SingleSelect&& aOther);

    MOZ_IMPLICIT FormEntryValue(const MultipleSelect& aOther);

    MOZ_IMPLICIT FormEntryValue(MultipleSelect&& aOther);

    MOZ_IMPLICIT FormEntryValue(const FormEntryValue& aOther);

    MOZ_IMPLICIT FormEntryValue(FormEntryValue&& aOther);

    ~FormEntryValue();

    Type
    type() const
    {
        return mType;
    }

    FormEntryValue&
    operator=(const Checkbox& aRhs);

    FormEntryValue&
    operator=(Checkbox&& aRhs);

    FormEntryValue&
    operator=(const TextField& aRhs);

    FormEntryValue&
    operator=(TextField&& aRhs);

    FormEntryValue&
    operator=(const FileList& aRhs);

    FormEntryValue&
    operator=(FileList&& aRhs);

    FormEntryValue&
    operator=(const SingleSelect& aRhs);

    FormEntryValue&
    operator=(SingleSelect&& aRhs);

    FormEntryValue&
    operator=(const MultipleSelect& aRhs);

    FormEntryValue&
    operator=(MultipleSelect&& aRhs);

    FormEntryValue&
    operator=(const FormEntryValue& aRhs);

    FormEntryValue&
    operator=(FormEntryValue&& aRhs);

    Checkbox&
    get_Checkbox()
    {
        AssertSanity(TCheckbox);
        return (*(ptr_Checkbox()));
    }
    const Checkbox&
    get_Checkbox() const
    {
        AssertSanity(TCheckbox);
        return (*(constptr_Checkbox()));
    }
    operator Checkbox&()
    {
        return get_Checkbox();
    }
    operator const Checkbox&() const
    {
        return get_Checkbox();
    }

    TextField&
    get_TextField()
    {
        AssertSanity(TTextField);
        return (*(ptr_TextField()));
    }
    const TextField&
    get_TextField() const
    {
        AssertSanity(TTextField);
        return (*(constptr_TextField()));
    }
    operator TextField&()
    {
        return get_TextField();
    }
    operator const TextField&() const
    {
        return get_TextField();
    }

    FileList&
    get_FileList()
    {
        AssertSanity(TFileList);
        return (*(ptr_FileList()));
    }
    const FileList&
    get_FileList() const
    {
        AssertSanity(TFileList);
        return (*(constptr_FileList()));
    }
    operator FileList&()
    {
        return get_FileList();
    }
    operator const FileList&() const
    {
        return get_FileList();
    }

    SingleSelect&
    get_SingleSelect()
    {
        AssertSanity(TSingleSelect);
        return (*(ptr_SingleSelect()));
    }
    const SingleSelect&
    get_SingleSelect() const
    {
        AssertSanity(TSingleSelect);
        return (*(constptr_SingleSelect()));
    }
    operator SingleSelect&()
    {
        return get_SingleSelect();
    }
    operator const SingleSelect&() const
    {
        return get_SingleSelect();
    }

    MultipleSelect&
    get_MultipleSelect()
    {
        AssertSanity(TMultipleSelect);
        return (*(ptr_MultipleSelect()));
    }
    const MultipleSelect&
    get_MultipleSelect() const
    {
        AssertSanity(TMultipleSelect);
        return (*(constptr_MultipleSelect()));
    }
    operator MultipleSelect&()
    {
        return get_MultipleSelect();
    }
    operator const MultipleSelect&() const
    {
        return get_MultipleSelect();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace sessionstore
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::sessionstore::FormEntryValue>
{
    typedef mozilla::dom::sessionstore::FormEntryValue paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FormEntry|
//
namespace mozilla {
namespace dom {
namespace sessionstore {
class FormEntry final
{
private:
    typedef mozilla::dom::sessionstore::FormEntryValue FormEntryValue;

public:
    MOZ_IMPLICIT FormEntry() :
        id_(),
        value_()
    {
    }

    MOZ_IMPLICIT FormEntry(
            const nsString& _id,
            const FormEntryValue& _value) :
        id_(_id),
        value_(_value)
    {
    }

    nsString&
    id()
    {
        return id_;
    }
    const nsString&
    id() const
    {
        return id_;
    }

    FormEntryValue&
    value()
    {
        return value_;
    }
    const FormEntryValue&
    value() const
    {
        return value_;
    }

private:
    nsString id_;
    FormEntryValue value_;
};
} // namespace sessionstore
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::sessionstore::FormEntry>
{
    typedef mozilla::dom::sessionstore::FormEntry paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FormData|
//
namespace mozilla {
namespace dom {
namespace sessionstore {
class FormData final
{
private:
    typedef mozilla::dom::sessionstore::FormEntry FormEntry;

public:
    MOZ_IMPLICIT FormData() :
        hasData_(),
        id_(),
        xpath_(),
        innerHTML_(),
        uri_()
    {
    }

    MOZ_IMPLICIT FormData(
            const bool& _hasData,
            const nsTArray<FormEntry>& _id,
            const nsTArray<FormEntry>& _xpath,
            const nsString& _innerHTML,
            const nsCString& _uri) :
        hasData_(_hasData),
        id_(_id),
        xpath_(_xpath),
        innerHTML_(_innerHTML),
        uri_(_uri)
    {
    }

    bool&
    hasData()
    {
        return hasData_;
    }
    const bool&
    hasData() const
    {
        return hasData_;
    }

    nsTArray<FormEntry>&
    id()
    {
        return id_;
    }
    const nsTArray<FormEntry>&
    id() const
    {
        return id_;
    }

    nsTArray<FormEntry>&
    xpath()
    {
        return xpath_;
    }
    const nsTArray<FormEntry>&
    xpath() const
    {
        return xpath_;
    }

    nsString&
    innerHTML()
    {
        return innerHTML_;
    }
    const nsString&
    innerHTML() const
    {
        return innerHTML_;
    }

    nsCString&
    uri()
    {
        return uri_;
    }
    const nsCString&
    uri() const
    {
        return uri_;
    }

private:
    bool hasData_;
    CopyableTArray<FormEntry> id_;
    CopyableTArray<FormEntry> xpath_;
    nsString innerHTML_;
    nsCString uri_;
};
} // namespace sessionstore
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::sessionstore::FormData>
{
    typedef mozilla::dom::sessionstore::FormData paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct DocShellRestoreState|
//
namespace mozilla {
namespace dom {
namespace sessionstore {
class DocShellRestoreState final
{
private:

public:
    MOZ_IMPLICIT DocShellRestoreState() :
        URI_(),
        docShellCaps_()
    {
    }

    MOZ_IMPLICIT DocShellRestoreState(
            nsIURI* _URI,
            const nsCString& _docShellCaps) :
        URI_(_URI),
        docShellCaps_(_docShellCaps)
    {
    }

    RefPtr<nsIURI>&
    URI()
    {
        return URI_;
    }
    nsIURI*
    URI() const
    {
        return URI_;
    }

    nsCString&
    docShellCaps()
    {
        return docShellCaps_;
    }
    const nsCString&
    docShellCaps() const
    {
        return docShellCaps_;
    }

private:
    RefPtr<nsIURI> URI_;
    nsCString docShellCaps_;
};
} // namespace sessionstore
} // namespace dom
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::dom::sessionstore::DocShellRestoreState>
{
    typedef mozilla::dom::sessionstore::DocShellRestoreState paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

#endif // ifndef SessionStoreTypes_h
