//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PExtensions_h
#define PExtensions_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/ProtocolUtilsFwd.h"
#include "mozilla/ipc/Shmem.h"
#include "mozilla/dom/DOMTypes.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FrameTransitionData|
//
namespace mozilla {
namespace extensions {
class FrameTransitionData final
{
private:

public:
    MOZ_IMPLICIT FrameTransitionData() :
        clientRedirect_(),
        formSubmit_(),
        forwardBack_(),
        reload_(),
        serverRedirect_()
    {
    }

    MOZ_IMPLICIT FrameTransitionData(
            const bool& _clientRedirect,
            const bool& _formSubmit,
            const bool& _forwardBack,
            const bool& _reload,
            const bool& _serverRedirect) :
        clientRedirect_(_clientRedirect),
        formSubmit_(_formSubmit),
        forwardBack_(_forwardBack),
        reload_(_reload),
        serverRedirect_(_serverRedirect)
    {
    }

    bool&
    clientRedirect()
    {
        return clientRedirect_;
    }
    const bool&
    clientRedirect() const
    {
        return clientRedirect_;
    }

    bool&
    formSubmit()
    {
        return formSubmit_;
    }
    const bool&
    formSubmit() const
    {
        return formSubmit_;
    }

    bool&
    forwardBack()
    {
        return forwardBack_;
    }
    const bool&
    forwardBack() const
    {
        return forwardBack_;
    }

    bool&
    reload()
    {
        return reload_;
    }
    const bool&
    reload() const
    {
        return reload_;
    }

    bool&
    serverRedirect()
    {
        return serverRedirect_;
    }
    const bool&
    serverRedirect() const
    {
        return serverRedirect_;
    }

private:
    bool clientRedirect_;
    bool formSubmit_;
    bool forwardBack_;
    bool reload_;
    bool serverRedirect_;
};
} // namespace extensions
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::extensions::FrameTransitionData>
{
    typedef mozilla::extensions::FrameTransitionData paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

namespace mozilla {
namespace extensions {
class PExtensionsParent;
} // namespace extensions
} // namespace mozilla
namespace mozilla {
namespace extensions {
class PExtensionsChild;
} // namespace extensions
} // namespace mozilla

//-----------------------------------------------------------------------------
// Code common to PExtensionsChild and PExtensionsParent
//
namespace mozilla {
namespace extensions {
namespace PExtensions {

nsresult
CreateEndpoints(
        base::ProcessId aParentDestPid,
        base::ProcessId aChildDestPid,
        mozilla::ipc::Endpoint<mozilla::extensions::PExtensionsParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::extensions::PExtensionsChild>* aChild);

nsresult
CreateEndpoints(
        mozilla::ipc::Endpoint<mozilla::extensions::PExtensionsParent>* aParent,
        mozilla::ipc::Endpoint<mozilla::extensions::PExtensionsChild>* aChild);

enum MessageType {
    PExtensionsStart = PExtensionsMsgStart << 16,
    Msg___delete____ID,
    Reply___delete____ID,
    Msg_DocumentChange__ID,
    Msg_HistoryChange__ID,
    Msg_StateChange__ID,
    Msg_CreatedNavigationTarget__ID,
    Msg_DOMContentLoaded__ID,
    PExtensionsEnd
};

mozilla::UniquePtr<IPC::Message>
Msg___delete__(int32_t routingId);
mozilla::UniquePtr<IPC::Message>
Reply___delete__(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_DocumentChange(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_HistoryChange(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_StateChange(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_CreatedNavigationTarget(int32_t routingId);

mozilla::UniquePtr<IPC::Message>
Msg_DOMContentLoaded(int32_t routingId);



} // namespace PExtensions
} // namespace extensions
} // namespace mozilla

#endif // ifndef PExtensions_h
