//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef LayersMessages_h
#define LayersMessages_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/ProtocolUtilsFwd.h"
#include "mozilla/ipc/Shmem.h"

// Headers for typedefs
#include "Units.h"
#include "mozilla/HalIPCUtils.h"
#include "mozilla/MotionPathUtils.h"
#include "mozilla/ServoStyleConsts.h"
#include "mozilla/TimeStamp.h"
#include "mozilla/WidgetUtils.h"
#include "mozilla/gfx/2D.h"
#include "mozilla/gfx/Matrix.h"
#include "mozilla/gfx/Point.h"
#include "mozilla/gfx/Types.h"
#include "mozilla/ipc/CrossProcessSemaphore.h"
#include "mozilla/layers/LayersTypes.h"
#include "mozilla/layers/ScrollableLayerGuid.h"
#include "nsCSSPropertyID.h"
#include "nsColor.h"
#include "nsPoint.h"
#include "nsRect.h"
#include "mozilla/layers/LayersSurfaces.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TargetConfig|
//
namespace mozilla {
namespace layers {
class TargetConfig final
{
private:
    typedef mozilla::gfx::IntRect IntRect;
    typedef mozilla::ScreenRotation ScreenRotation;
    typedef hal::ScreenOrientation ScreenOrientation;

public:
    MOZ_IMPLICIT TargetConfig() :
        naturalBounds_(),
        rotation_(),
        orientation_(),
        clearRegion_()
    {
    }

    MOZ_IMPLICIT TargetConfig(
            const IntRect& _naturalBounds,
            const ScreenRotation& _rotation,
            const ScreenOrientation& _orientation,
            const nsIntRegion& _clearRegion) :
        naturalBounds_(_naturalBounds),
        rotation_(_rotation),
        orientation_(_orientation),
        clearRegion_(_clearRegion)
    {
    }

    IntRect&
    naturalBounds()
    {
        return naturalBounds_;
    }
    const IntRect&
    naturalBounds() const
    {
        return naturalBounds_;
    }

    ScreenRotation&
    rotation()
    {
        return rotation_;
    }
    const ScreenRotation&
    rotation() const
    {
        return rotation_;
    }

    ScreenOrientation&
    orientation()
    {
        return orientation_;
    }
    const ScreenOrientation&
    orientation() const
    {
        return orientation_;
    }

    nsIntRegion&
    clearRegion()
    {
        return clearRegion_;
    }
    const nsIntRegion&
    clearRegion() const
    {
        return clearRegion_;
    }

private:
    IntRect naturalBounds_;
    ScreenRotation rotation_;
    ScreenOrientation orientation_;
    nsIntRegion clearRegion_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::TargetConfig>
{
    typedef mozilla::layers::TargetConfig paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpAttachCompositable|
//
namespace mozilla {
namespace layers {
class OpAttachCompositable final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;
    typedef mozilla::layers::CompositableHandle CompositableHandle;

public:
    MOZ_IMPLICIT OpAttachCompositable() :
        layer_(),
        compositable_()
    {
    }

    MOZ_IMPLICIT OpAttachCompositable(
            const LayerHandle& _layer,
            const CompositableHandle& _compositable) :
        layer_(_layer),
        compositable_(_compositable)
    {
    }

    LayerHandle&
    layer()
    {
        return layer_;
    }
    const LayerHandle&
    layer() const
    {
        return layer_;
    }

    CompositableHandle&
    compositable()
    {
        return compositable_;
    }
    const CompositableHandle&
    compositable() const
    {
        return compositable_;
    }

private:
    LayerHandle layer_;
    CompositableHandle compositable_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::OpAttachCompositable>
{
    typedef mozilla::layers::OpAttachCompositable paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpAttachAsyncCompositable|
//
namespace mozilla {
namespace layers {
class OpAttachAsyncCompositable final
{
private:
    typedef mozilla::layers::LayerHandle LayerHandle;
    typedef mozilla::layers::CompositableHandle CompositableHandle;

public:
    MOZ_IMPLICIT OpAttachAsyncCompositable() :
        layer_(),
        compositable_()
    {
    }

    MOZ_IMPLICIT OpAttachAsyncCompositable(
            const LayerHandle& _layer,
            const CompositableHandle& _compositable) :
        layer_(_layer),
        compositable_(_compositable)
    {
    }

    LayerHandle&
    layer()
    {
        return layer_;
    }
    const LayerHandle&
    layer() const
    {
        return layer_;
    }

    CompositableHandle&
    compositable()
    {
        return compositable_;
    }
    const CompositableHandle&
    compositable() const
    {
        return compositable_;
    }

private:
    LayerHandle layer_;
    CompositableHandle compositable_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::OpAttachAsyncCompositable>
{
    typedef mozilla::layers::OpAttachAsyncCompositable paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CubicBezierFunction|
//
namespace mozilla {
namespace layers {
class CubicBezierFunction final
{
private:

public:
    MOZ_IMPLICIT CubicBezierFunction() :
        x1_(),
        y1_(),
        x2_(),
        y2_()
    {
    }

    MOZ_IMPLICIT CubicBezierFunction(
            const float& _x1,
            const float& _y1,
            const float& _x2,
            const float& _y2) :
        x1_(_x1),
        y1_(_y1),
        x2_(_x2),
        y2_(_y2)
    {
    }

    float&
    x1()
    {
        return x1_;
    }
    const float&
    x1() const
    {
        return x1_;
    }

    float&
    y1()
    {
        return y1_;
    }
    const float&
    y1() const
    {
        return y1_;
    }

    float&
    x2()
    {
        return x2_;
    }
    const float&
    x2() const
    {
        return x2_;
    }

    float&
    y2()
    {
        return y2_;
    }
    const float&
    y2() const
    {
        return y2_;
    }

private:
    void
    StaticAssertions() const;
    float x1_;
    float y1_;
    float x2_;
    float y2_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::CubicBezierFunction>
{
    typedef mozilla::layers::CubicBezierFunction paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct StepFunction|
//
namespace mozilla {
namespace layers {
class StepFunction final
{
private:

public:
    MOZ_IMPLICIT StepFunction() :
        steps_(),
        type_()
    {
    }

    MOZ_IMPLICIT StepFunction(
            const int& _steps,
            const uint8_t& _type) :
        steps_(_steps),
        type_(_type)
    {
    }

    int&
    steps()
    {
        return steps_;
    }
    const int&
    steps() const
    {
        return steps_;
    }

    uint8_t&
    type()
    {
        return type_;
    }
    const uint8_t&
    type() const
    {
        return type_;
    }

private:
    int steps_;
    uint8_t type_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::StepFunction>
{
    typedef mozilla::layers::StepFunction paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union TimingFunction|
//
namespace mozilla {
namespace layers {
class TimingFunction final
{
public:
    enum Type {
        T__None,
        Tnull_t = 1,
        TCubicBezierFunction,
        TStepFunction,
        T__Last = TStepFunction
    };

private:
    typedef mozilla::null_t null_t;
    typedef mozilla::layers::CubicBezierFunction CubicBezierFunction;
    typedef mozilla::layers::StepFunction StepFunction;
    typedef null_t null_t__tdef;
    typedef CubicBezierFunction CubicBezierFunction__tdef;
    typedef StepFunction StepFunction__tdef;

    union Value {
        mozilla::AlignedStorage2<null_t> Vnull_t;
        mozilla::AlignedStorage2<CubicBezierFunction> VCubicBezierFunction;
        mozilla::AlignedStorage2<StepFunction> VStepFunction;
    };

    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }
    CubicBezierFunction*
    ptr_CubicBezierFunction()
    {
        return ((mValue).VCubicBezierFunction).addr();
    }
    const CubicBezierFunction*
    constptr_CubicBezierFunction() const
    {
        return ((mValue).VCubicBezierFunction).addr();
    }
    StepFunction*
    ptr_StepFunction()
    {
        return ((mValue).VStepFunction).addr();
    }
    const StepFunction*
    constptr_StepFunction() const
    {
        return ((mValue).VStepFunction).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT TimingFunction() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT TimingFunction(const null_t& aOther);

    MOZ_IMPLICIT TimingFunction(null_t&& aOther);

    MOZ_IMPLICIT TimingFunction(const CubicBezierFunction& aOther);

    MOZ_IMPLICIT TimingFunction(CubicBezierFunction&& aOther);

    MOZ_IMPLICIT TimingFunction(const StepFunction& aOther);

    MOZ_IMPLICIT TimingFunction(StepFunction&& aOther);

    MOZ_IMPLICIT TimingFunction(const TimingFunction& aOther);

    MOZ_IMPLICIT TimingFunction(TimingFunction&& aOther);

    ~TimingFunction();

    Type
    type() const
    {
        return mType;
    }

    TimingFunction&
    operator=(const null_t& aRhs);

    TimingFunction&
    operator=(null_t&& aRhs);

    TimingFunction&
    operator=(const CubicBezierFunction& aRhs);

    TimingFunction&
    operator=(CubicBezierFunction&& aRhs);

    TimingFunction&
    operator=(const StepFunction& aRhs);

    TimingFunction&
    operator=(StepFunction&& aRhs);

    TimingFunction&
    operator=(const TimingFunction& aRhs);

    TimingFunction&
    operator=(TimingFunction&& aRhs);

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

    CubicBezierFunction&
    get_CubicBezierFunction()
    {
        AssertSanity(TCubicBezierFunction);
        return (*(ptr_CubicBezierFunction()));
    }
    const CubicBezierFunction&
    get_CubicBezierFunction() const
    {
        AssertSanity(TCubicBezierFunction);
        return (*(constptr_CubicBezierFunction()));
    }
    operator CubicBezierFunction&()
    {
        return get_CubicBezierFunction();
    }
    operator const CubicBezierFunction&() const
    {
        return get_CubicBezierFunction();
    }

    StepFunction&
    get_StepFunction()
    {
        AssertSanity(TStepFunction);
        return (*(ptr_StepFunction()));
    }
    const StepFunction&
    get_StepFunction() const
    {
        AssertSanity(TStepFunction);
        return (*(constptr_StepFunction()));
    }
    operator StepFunction&()
    {
        return get_StepFunction();
    }
    operator const StepFunction&() const
    {
        return get_StepFunction();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::TimingFunction>
{
    typedef mozilla::layers::TimingFunction paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LayerColor|
//
namespace mozilla {
namespace layers {
class LayerColor final
{
private:
    typedef mozilla::gfx::DeviceColor DeviceColor;

public:
    MOZ_IMPLICIT LayerColor() :
        value_()
    {
    }

    MOZ_IMPLICIT LayerColor(const DeviceColor& _value) :
        value_(_value)
    {
    }

    DeviceColor&
    value()
    {
        return value_;
    }
    const DeviceColor&
    value() const
    {
        return value_;
    }

private:
    DeviceColor value_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::LayerColor>
{
    typedef mozilla::layers::LayerColor paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union Animatable|
//
namespace mozilla {
namespace layers {
class Animatable final
{
public:
    enum Type {
        T__None,
        Tnull_t = 1,
        Tfloat,
        Tnscolor,
        TStyleRotate,
        TStyleScale,
        TStyleTranslate,
        TStyleTransform,
        TStyleOffsetPath,
        TLengthPercentage,
        TStyleOffsetRotate,
        TStylePositionOrAuto,
        T__Last = TStylePositionOrAuto
    };

private:
    typedef mozilla::null_t null_t;
    typedef mozilla::StyleRotate StyleRotate;
    typedef mozilla::StyleScale StyleScale;
    typedef mozilla::StyleTranslate StyleTranslate;
    typedef mozilla::StyleTransform StyleTransform;
    typedef mozilla::StyleOffsetPath StyleOffsetPath;
    typedef mozilla::LengthPercentage LengthPercentage;
    typedef mozilla::StyleOffsetRotate StyleOffsetRotate;
    typedef mozilla::StylePositionOrAuto StylePositionOrAuto;
    typedef null_t null_t__tdef;
    typedef float float__tdef;
    typedef nscolor nscolor__tdef;
    typedef StyleRotate StyleRotate__tdef;
    typedef StyleScale StyleScale__tdef;
    typedef StyleTranslate StyleTranslate__tdef;
    typedef StyleTransform StyleTransform__tdef;
    typedef StyleOffsetPath StyleOffsetPath__tdef;
    typedef LengthPercentage LengthPercentage__tdef;
    typedef StyleOffsetRotate StyleOffsetRotate__tdef;
    typedef StylePositionOrAuto StylePositionOrAuto__tdef;

    union Value {
        mozilla::AlignedStorage2<null_t> Vnull_t;
        mozilla::AlignedStorage2<float> Vfloat;
        mozilla::AlignedStorage2<nscolor> Vnscolor;
        mozilla::AlignedStorage2<StyleRotate> VStyleRotate;
        mozilla::AlignedStorage2<StyleScale> VStyleScale;
        mozilla::AlignedStorage2<StyleTranslate> VStyleTranslate;
        mozilla::AlignedStorage2<StyleTransform> VStyleTransform;
        mozilla::AlignedStorage2<StyleOffsetPath> VStyleOffsetPath;
        mozilla::AlignedStorage2<LengthPercentage> VLengthPercentage;
        mozilla::AlignedStorage2<StyleOffsetRotate> VStyleOffsetRotate;
        mozilla::AlignedStorage2<StylePositionOrAuto> VStylePositionOrAuto;
    };

    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }
    float*
    ptr_float()
    {
        return ((mValue).Vfloat).addr();
    }
    const float*
    constptr_float() const
    {
        return ((mValue).Vfloat).addr();
    }
    nscolor*
    ptr_nscolor()
    {
        return ((mValue).Vnscolor).addr();
    }
    const nscolor*
    constptr_nscolor() const
    {
        return ((mValue).Vnscolor).addr();
    }
    StyleRotate*
    ptr_StyleRotate()
    {
        return ((mValue).VStyleRotate).addr();
    }
    const StyleRotate*
    constptr_StyleRotate() const
    {
        return ((mValue).VStyleRotate).addr();
    }
    StyleScale*
    ptr_StyleScale()
    {
        return ((mValue).VStyleScale).addr();
    }
    const StyleScale*
    constptr_StyleScale() const
    {
        return ((mValue).VStyleScale).addr();
    }
    StyleTranslate*
    ptr_StyleTranslate()
    {
        return ((mValue).VStyleTranslate).addr();
    }
    const StyleTranslate*
    constptr_StyleTranslate() const
    {
        return ((mValue).VStyleTranslate).addr();
    }
    StyleTransform*
    ptr_StyleTransform()
    {
        return ((mValue).VStyleTransform).addr();
    }
    const StyleTransform*
    constptr_StyleTransform() const
    {
        return ((mValue).VStyleTransform).addr();
    }
    StyleOffsetPath*
    ptr_StyleOffsetPath()
    {
        return ((mValue).VStyleOffsetPath).addr();
    }
    const StyleOffsetPath*
    constptr_StyleOffsetPath() const
    {
        return ((mValue).VStyleOffsetPath).addr();
    }
    LengthPercentage*
    ptr_LengthPercentage()
    {
        return ((mValue).VLengthPercentage).addr();
    }
    const LengthPercentage*
    constptr_LengthPercentage() const
    {
        return ((mValue).VLengthPercentage).addr();
    }
    StyleOffsetRotate*
    ptr_StyleOffsetRotate()
    {
        return ((mValue).VStyleOffsetRotate).addr();
    }
    const StyleOffsetRotate*
    constptr_StyleOffsetRotate() const
    {
        return ((mValue).VStyleOffsetRotate).addr();
    }
    StylePositionOrAuto*
    ptr_StylePositionOrAuto()
    {
        return ((mValue).VStylePositionOrAuto).addr();
    }
    const StylePositionOrAuto*
    constptr_StylePositionOrAuto() const
    {
        return ((mValue).VStylePositionOrAuto).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT Animatable() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT Animatable(const null_t& aOther);

    MOZ_IMPLICIT Animatable(null_t&& aOther);

    MOZ_IMPLICIT Animatable(const float& aOther);

    MOZ_IMPLICIT Animatable(float&& aOther);

    MOZ_IMPLICIT Animatable(const nscolor& aOther);

    MOZ_IMPLICIT Animatable(nscolor&& aOther);

    MOZ_IMPLICIT Animatable(const StyleRotate& aOther);

    MOZ_IMPLICIT Animatable(StyleRotate&& aOther);

    MOZ_IMPLICIT Animatable(const StyleScale& aOther);

    MOZ_IMPLICIT Animatable(StyleScale&& aOther);

    MOZ_IMPLICIT Animatable(const StyleTranslate& aOther);

    MOZ_IMPLICIT Animatable(StyleTranslate&& aOther);

    MOZ_IMPLICIT Animatable(const StyleTransform& aOther);

    MOZ_IMPLICIT Animatable(StyleTransform&& aOther);

    MOZ_IMPLICIT Animatable(const StyleOffsetPath& aOther);

    MOZ_IMPLICIT Animatable(StyleOffsetPath&& aOther);

    MOZ_IMPLICIT Animatable(const LengthPercentage& aOther);

    MOZ_IMPLICIT Animatable(LengthPercentage&& aOther);

    MOZ_IMPLICIT Animatable(const StyleOffsetRotate& aOther);

    MOZ_IMPLICIT Animatable(StyleOffsetRotate&& aOther);

    MOZ_IMPLICIT Animatable(const StylePositionOrAuto& aOther);

    MOZ_IMPLICIT Animatable(StylePositionOrAuto&& aOther);

    MOZ_IMPLICIT Animatable(const Animatable& aOther);

    MOZ_IMPLICIT Animatable(Animatable&& aOther);

    ~Animatable();

    Type
    type() const
    {
        return mType;
    }

    Animatable&
    operator=(const null_t& aRhs);

    Animatable&
    operator=(null_t&& aRhs);

    Animatable&
    operator=(const float& aRhs);

    Animatable&
    operator=(float&& aRhs);

    Animatable&
    operator=(const nscolor& aRhs);

    Animatable&
    operator=(nscolor&& aRhs);

    Animatable&
    operator=(const StyleRotate& aRhs);

    Animatable&
    operator=(StyleRotate&& aRhs);

    Animatable&
    operator=(const StyleScale& aRhs);

    Animatable&
    operator=(StyleScale&& aRhs);

    Animatable&
    operator=(const StyleTranslate& aRhs);

    Animatable&
    operator=(StyleTranslate&& aRhs);

    Animatable&
    operator=(const StyleTransform& aRhs);

    Animatable&
    operator=(StyleTransform&& aRhs);

    Animatable&
    operator=(const StyleOffsetPath& aRhs);

    Animatable&
    operator=(StyleOffsetPath&& aRhs);

    Animatable&
    operator=(const LengthPercentage& aRhs);

    Animatable&
    operator=(LengthPercentage&& aRhs);

    Animatable&
    operator=(const StyleOffsetRotate& aRhs);

    Animatable&
    operator=(StyleOffsetRotate&& aRhs);

    Animatable&
    operator=(const StylePositionOrAuto& aRhs);

    Animatable&
    operator=(StylePositionOrAuto&& aRhs);

    Animatable&
    operator=(const Animatable& aRhs);

    Animatable&
    operator=(Animatable&& aRhs);

    bool
    operator==(const null_t& aRhs) const;

    bool
    operator==(const float& aRhs) const;

    bool
    operator==(const nscolor& aRhs) const;

    bool
    operator==(const StyleRotate& aRhs) const;

    bool
    operator==(const StyleScale& aRhs) const;

    bool
    operator==(const StyleTranslate& aRhs) const;

    bool
    operator==(const StyleTransform& aRhs) const;

    bool
    operator==(const StyleOffsetPath& aRhs) const;

    bool
    operator==(const LengthPercentage& aRhs) const;

    bool
    operator==(const StyleOffsetRotate& aRhs) const;

    bool
    operator==(const StylePositionOrAuto& aRhs) const;

    bool
    operator==(const Animatable& aRhs) const;

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

    float&
    get_float()
    {
        AssertSanity(Tfloat);
        return (*(ptr_float()));
    }
    const float&
    get_float() const
    {
        AssertSanity(Tfloat);
        return (*(constptr_float()));
    }
    operator float&()
    {
        return get_float();
    }
    operator const float&() const
    {
        return get_float();
    }

    nscolor&
    get_nscolor()
    {
        AssertSanity(Tnscolor);
        return (*(ptr_nscolor()));
    }
    const nscolor&
    get_nscolor() const
    {
        AssertSanity(Tnscolor);
        return (*(constptr_nscolor()));
    }
    operator nscolor&()
    {
        return get_nscolor();
    }
    operator const nscolor&() const
    {
        return get_nscolor();
    }

    StyleRotate&
    get_StyleRotate()
    {
        AssertSanity(TStyleRotate);
        return (*(ptr_StyleRotate()));
    }
    const StyleRotate&
    get_StyleRotate() const
    {
        AssertSanity(TStyleRotate);
        return (*(constptr_StyleRotate()));
    }
    operator StyleRotate&()
    {
        return get_StyleRotate();
    }
    operator const StyleRotate&() const
    {
        return get_StyleRotate();
    }

    StyleScale&
    get_StyleScale()
    {
        AssertSanity(TStyleScale);
        return (*(ptr_StyleScale()));
    }
    const StyleScale&
    get_StyleScale() const
    {
        AssertSanity(TStyleScale);
        return (*(constptr_StyleScale()));
    }
    operator StyleScale&()
    {
        return get_StyleScale();
    }
    operator const StyleScale&() const
    {
        return get_StyleScale();
    }

    StyleTranslate&
    get_StyleTranslate()
    {
        AssertSanity(TStyleTranslate);
        return (*(ptr_StyleTranslate()));
    }
    const StyleTranslate&
    get_StyleTranslate() const
    {
        AssertSanity(TStyleTranslate);
        return (*(constptr_StyleTranslate()));
    }
    operator StyleTranslate&()
    {
        return get_StyleTranslate();
    }
    operator const StyleTranslate&() const
    {
        return get_StyleTranslate();
    }

    StyleTransform&
    get_StyleTransform()
    {
        AssertSanity(TStyleTransform);
        return (*(ptr_StyleTransform()));
    }
    const StyleTransform&
    get_StyleTransform() const
    {
        AssertSanity(TStyleTransform);
        return (*(constptr_StyleTransform()));
    }
    operator StyleTransform&()
    {
        return get_StyleTransform();
    }
    operator const StyleTransform&() const
    {
        return get_StyleTransform();
    }

    StyleOffsetPath&
    get_StyleOffsetPath()
    {
        AssertSanity(TStyleOffsetPath);
        return (*(ptr_StyleOffsetPath()));
    }
    const StyleOffsetPath&
    get_StyleOffsetPath() const
    {
        AssertSanity(TStyleOffsetPath);
        return (*(constptr_StyleOffsetPath()));
    }
    operator StyleOffsetPath&()
    {
        return get_StyleOffsetPath();
    }
    operator const StyleOffsetPath&() const
    {
        return get_StyleOffsetPath();
    }

    LengthPercentage&
    get_LengthPercentage()
    {
        AssertSanity(TLengthPercentage);
        return (*(ptr_LengthPercentage()));
    }
    const LengthPercentage&
    get_LengthPercentage() const
    {
        AssertSanity(TLengthPercentage);
        return (*(constptr_LengthPercentage()));
    }
    operator LengthPercentage&()
    {
        return get_LengthPercentage();
    }
    operator const LengthPercentage&() const
    {
        return get_LengthPercentage();
    }

    StyleOffsetRotate&
    get_StyleOffsetRotate()
    {
        AssertSanity(TStyleOffsetRotate);
        return (*(ptr_StyleOffsetRotate()));
    }
    const StyleOffsetRotate&
    get_StyleOffsetRotate() const
    {
        AssertSanity(TStyleOffsetRotate);
        return (*(constptr_StyleOffsetRotate()));
    }
    operator StyleOffsetRotate&()
    {
        return get_StyleOffsetRotate();
    }
    operator const StyleOffsetRotate&() const
    {
        return get_StyleOffsetRotate();
    }

    StylePositionOrAuto&
    get_StylePositionOrAuto()
    {
        AssertSanity(TStylePositionOrAuto);
        return (*(ptr_StylePositionOrAuto()));
    }
    const StylePositionOrAuto&
    get_StylePositionOrAuto() const
    {
        AssertSanity(TStylePositionOrAuto);
        return (*(constptr_StylePositionOrAuto()));
    }
    operator StylePositionOrAuto&()
    {
        return get_StylePositionOrAuto();
    }
    operator const StylePositionOrAuto&() const
    {
        return get_StylePositionOrAuto();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::Animatable>
{
    typedef mozilla::layers::Animatable paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct AnimationSegment|
//
namespace mozilla {
namespace layers {
class AnimationSegment final
{
private:
    typedef mozilla::layers::Animatable Animatable;
    typedef mozilla::layers::TimingFunction TimingFunction;

public:
    MOZ_IMPLICIT AnimationSegment() :
        startState_(),
        endState_(),
        sampleFn_(),
        startPortion_(),
        endPortion_(),
        startComposite_(),
        endComposite_()
    {
    }

    MOZ_IMPLICIT AnimationSegment(
            const Animatable& _startState,
            const Animatable& _endState,
            const float& _startPortion,
            const float& _endPortion,
            const uint8_t& _startComposite,
            const uint8_t& _endComposite,
            const TimingFunction& _sampleFn) :
        startState_(_startState),
        endState_(_endState),
        sampleFn_(_sampleFn),
        startPortion_(_startPortion),
        endPortion_(_endPortion),
        startComposite_(_startComposite),
        endComposite_(_endComposite)
    {
    }

    Animatable&
    startState()
    {
        return startState_;
    }
    const Animatable&
    startState() const
    {
        return startState_;
    }

    Animatable&
    endState()
    {
        return endState_;
    }
    const Animatable&
    endState() const
    {
        return endState_;
    }

    float&
    startPortion()
    {
        return startPortion_;
    }
    const float&
    startPortion() const
    {
        return startPortion_;
    }

    float&
    endPortion()
    {
        return endPortion_;
    }
    const float&
    endPortion() const
    {
        return endPortion_;
    }

    uint8_t&
    startComposite()
    {
        return startComposite_;
    }
    const uint8_t&
    startComposite() const
    {
        return startComposite_;
    }

    uint8_t&
    endComposite()
    {
        return endComposite_;
    }
    const uint8_t&
    endComposite() const
    {
        return endComposite_;
    }

    TimingFunction&
    sampleFn()
    {
        return sampleFn_;
    }
    const TimingFunction&
    sampleFn() const
    {
        return sampleFn_;
    }

private:
    void
    StaticAssertions() const;
    Animatable startState_;
    Animatable endState_;
    TimingFunction sampleFn_;
    float startPortion_;
    float endPortion_;
    uint8_t startComposite_;
    uint8_t endComposite_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::AnimationSegment>
{
    typedef mozilla::layers::AnimationSegment paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct MotionPathData|
//
namespace mozilla {
namespace layers {
class MotionPathData final
{
private:
    typedef mozilla::CSSPoint CSSPoint;
    typedef mozilla::RayReferenceData RayReferenceData;

public:
    MOZ_IMPLICIT MotionPathData() :
        origin_(),
        anchorAdjustment_(),
        rayReferenceData_()
    {
    }

    MOZ_IMPLICIT MotionPathData(
            const CSSPoint& _origin,
            const CSSPoint& _anchorAdjustment,
            const RayReferenceData& _rayReferenceData) :
        origin_(_origin),
        anchorAdjustment_(_anchorAdjustment),
        rayReferenceData_(_rayReferenceData)
    {
    }

    bool
    operator==(const MotionPathData& _o) const;

    bool
    operator!=(const MotionPathData& _o) const;

    CSSPoint&
    origin()
    {
        return origin_;
    }
    const CSSPoint&
    origin() const
    {
        return origin_;
    }

    CSSPoint&
    anchorAdjustment()
    {
        return anchorAdjustment_;
    }
    const CSSPoint&
    anchorAdjustment() const
    {
        return anchorAdjustment_;
    }

    RayReferenceData&
    rayReferenceData()
    {
        return rayReferenceData_;
    }
    const RayReferenceData&
    rayReferenceData() const
    {
        return rayReferenceData_;
    }

private:
    CSSPoint origin_;
    CSSPoint anchorAdjustment_;
    RayReferenceData rayReferenceData_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::MotionPathData>
{
    typedef mozilla::layers::MotionPathData paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct PartialPrerenderData|
//
namespace mozilla {
namespace layers {
class PartialPrerenderData final
{
private:
    typedef mozilla::LayoutDeviceRect LayoutDeviceRect;
    typedef mozilla::SideBits SideBits;
    typedef mozilla::layers::ScrollableLayerGuid::ViewID ViewID;
    typedef mozilla::ParentLayerRect ParentLayerRect;
    typedef mozilla::gfx::Matrix4x4 Matrix4x4;
    typedef mozilla::LayoutDevicePoint LayoutDevicePoint;

public:
    MOZ_IMPLICIT PartialPrerenderData() :
        rect_(),
        overflowedSides_(),
        scrollId_(),
        clipRect_(),
        transformInClip_(),
        position_()
    {
    }

    MOZ_IMPLICIT PartialPrerenderData(
            const LayoutDeviceRect& _rect,
            const SideBits& _overflowedSides,
            const ViewID& _scrollId,
            const ParentLayerRect& _clipRect,
            const Matrix4x4& _transformInClip,
            const LayoutDevicePoint& _position) :
        rect_(_rect),
        overflowedSides_(_overflowedSides),
        scrollId_(_scrollId),
        clipRect_(_clipRect),
        transformInClip_(_transformInClip),
        position_(_position)
    {
    }

    bool
    operator==(const PartialPrerenderData& _o) const;

    bool
    operator!=(const PartialPrerenderData& _o) const;

    LayoutDeviceRect&
    rect()
    {
        return rect_;
    }
    const LayoutDeviceRect&
    rect() const
    {
        return rect_;
    }

    SideBits&
    overflowedSides()
    {
        return overflowedSides_;
    }
    const SideBits&
    overflowedSides() const
    {
        return overflowedSides_;
    }

    ViewID&
    scrollId()
    {
        return scrollId_;
    }
    const ViewID&
    scrollId() const
    {
        return scrollId_;
    }

    ParentLayerRect&
    clipRect()
    {
        return clipRect_;
    }
    const ParentLayerRect&
    clipRect() const
    {
        return clipRect_;
    }

    Matrix4x4&
    transformInClip()
    {
        return transformInClip_;
    }
    const Matrix4x4&
    transformInClip() const
    {
        return transformInClip_;
    }

    LayoutDevicePoint&
    position()
    {
        return position_;
    }
    const LayoutDevicePoint&
    position() const
    {
        return position_;
    }

private:
    LayoutDeviceRect rect_;
    SideBits overflowedSides_;
    ViewID scrollId_;
    ParentLayerRect clipRect_;
    Matrix4x4 transformInClip_;
    LayoutDevicePoint position_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::PartialPrerenderData>
{
    typedef mozilla::layers::PartialPrerenderData paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TransformData|
//
namespace mozilla {
namespace layers {
class TransformData final
{
private:
    typedef mozilla::gfx::Point3D Point3D;
    typedef mozilla::layers::MotionPathData MotionPathData;
    typedef mozilla::layers::PartialPrerenderData PartialPrerenderData;

public:
    MOZ_IMPLICIT TransformData() :
        origin_(),
        transformOrigin_(),
        bounds_(),
        motionPathData_(),
        partialPrerenderData_(),
        appUnitsPerDevPixel_()
    {
    }

    MOZ_IMPLICIT TransformData(
            const nsPoint& _origin,
            const Point3D& _transformOrigin,
            const nsRect& _bounds,
            const int32_t& _appUnitsPerDevPixel,
            const mozilla::Maybe<MotionPathData>& _motionPathData,
            const mozilla::Maybe<PartialPrerenderData>& _partialPrerenderData) :
        origin_(_origin),
        transformOrigin_(_transformOrigin),
        bounds_(_bounds),
        motionPathData_(_motionPathData),
        partialPrerenderData_(_partialPrerenderData),
        appUnitsPerDevPixel_(_appUnitsPerDevPixel)
    {
    }

    bool
    operator==(const TransformData& _o) const;

    bool
    operator!=(const TransformData& _o) const;

    nsPoint&
    origin()
    {
        return origin_;
    }
    const nsPoint&
    origin() const
    {
        return origin_;
    }

    Point3D&
    transformOrigin()
    {
        return transformOrigin_;
    }
    const Point3D&
    transformOrigin() const
    {
        return transformOrigin_;
    }

    nsRect&
    bounds()
    {
        return bounds_;
    }
    const nsRect&
    bounds() const
    {
        return bounds_;
    }

    int32_t&
    appUnitsPerDevPixel()
    {
        return appUnitsPerDevPixel_;
    }
    const int32_t&
    appUnitsPerDevPixel() const
    {
        return appUnitsPerDevPixel_;
    }

    mozilla::Maybe<MotionPathData>&
    motionPathData()
    {
        return motionPathData_;
    }
    const mozilla::Maybe<MotionPathData>&
    motionPathData() const
    {
        return motionPathData_;
    }

    mozilla::Maybe<PartialPrerenderData>&
    partialPrerenderData()
    {
        return partialPrerenderData_;
    }
    const mozilla::Maybe<PartialPrerenderData>&
    partialPrerenderData() const
    {
        return partialPrerenderData_;
    }

private:
    nsPoint origin_;
    Point3D transformOrigin_;
    nsRect bounds_;
    mozilla::Maybe<MotionPathData> motionPathData_;
    mozilla::Maybe<PartialPrerenderData> partialPrerenderData_;
    int32_t appUnitsPerDevPixel_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::TransformData>
{
    typedef mozilla::layers::TransformData paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ScrollTimelineOptions|
//
namespace mozilla {
namespace layers {
class ScrollTimelineOptions final
{
private:
    typedef mozilla::layers::ScrollableLayerGuid::ViewID ViewID;
    typedef mozilla::layers::ScrollDirection ScrollDirection;

public:
    MOZ_IMPLICIT ScrollTimelineOptions() :
        source_(),
        axis_()
    {
    }

    MOZ_IMPLICIT ScrollTimelineOptions(
            const ViewID& _source,
            const ScrollDirection& _axis) :
        source_(_source),
        axis_(_axis)
    {
    }

    ViewID&
    source()
    {
        return source_;
    }
    const ViewID&
    source() const
    {
        return source_;
    }

    ScrollDirection&
    axis()
    {
        return axis_;
    }
    const ScrollDirection&
    axis() const
    {
        return axis_;
    }

private:
    ViewID source_;
    ScrollDirection axis_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::ScrollTimelineOptions>
{
    typedef mozilla::layers::ScrollTimelineOptions paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct Animation|
//
namespace mozilla {
namespace layers {
class Animation final
{
private:
    typedef mozilla::TimeStamp TimeStamp;
    typedef mozilla::TimeDuration TimeDuration;
    typedef mozilla::layers::AnimationSegment AnimationSegment;
    typedef mozilla::layers::TimingFunction TimingFunction;
    typedef mozilla::layers::Animatable Animatable;
    typedef mozilla::layers::TransformData TransformData;
    typedef mozilla::layers::ScrollTimelineOptions ScrollTimelineOptions;

public:
    MOZ_IMPLICIT Animation() :
        originTime_(),
        startTime_(),
        delay_(),
        endDelay_(),
        holdTime_(),
        duration_(),
        segments_(),
        property_(),
        easingFunction_(),
        isNotPlaying_(),
        isNotAnimating_(),
        baseStyle_(),
        transformData_(),
        scrollTimelineOptions_(),
        iterations_(),
        iterationStart_(),
        playbackRate_(),
        previousPlaybackRate_(),
        direction_(),
        fillMode_(),
        iterationComposite_()
    {
    }

    MOZ_IMPLICIT Animation(
            const TimeStamp& _originTime,
            const mozilla::Maybe<TimeDuration>& _startTime,
            const TimeDuration& _delay,
            const TimeDuration& _endDelay,
            const TimeDuration& _holdTime,
            const TimeDuration& _duration,
            const nsTArray<AnimationSegment>& _segments,
            const float& _iterations,
            const float& _iterationStart,
            const uint8_t& _direction,
            const uint8_t& _fillMode,
            const nsCSSPropertyID& _property,
            const float& _playbackRate,
            const float& _previousPlaybackRate,
            const TimingFunction& _easingFunction,
            const uint8_t& _iterationComposite,
            const bool& _isNotPlaying,
            const bool& _isNotAnimating,
            const Animatable& _baseStyle,
            const mozilla::Maybe<TransformData>& _transformData,
            const mozilla::Maybe<ScrollTimelineOptions>& _scrollTimelineOptions) :
        originTime_(_originTime),
        startTime_(_startTime),
        delay_(_delay),
        endDelay_(_endDelay),
        holdTime_(_holdTime),
        duration_(_duration),
        segments_(_segments),
        property_(_property),
        easingFunction_(_easingFunction),
        isNotPlaying_(_isNotPlaying),
        isNotAnimating_(_isNotAnimating),
        baseStyle_(_baseStyle),
        transformData_(_transformData),
        scrollTimelineOptions_(_scrollTimelineOptions),
        iterations_(_iterations),
        iterationStart_(_iterationStart),
        playbackRate_(_playbackRate),
        previousPlaybackRate_(_previousPlaybackRate),
        direction_(_direction),
        fillMode_(_fillMode),
        iterationComposite_(_iterationComposite)
    {
    }

    TimeStamp&
    originTime()
    {
        return originTime_;
    }
    const TimeStamp&
    originTime() const
    {
        return originTime_;
    }

    mozilla::Maybe<TimeDuration>&
    startTime()
    {
        return startTime_;
    }
    const mozilla::Maybe<TimeDuration>&
    startTime() const
    {
        return startTime_;
    }

    TimeDuration&
    delay()
    {
        return delay_;
    }
    const TimeDuration&
    delay() const
    {
        return delay_;
    }

    TimeDuration&
    endDelay()
    {
        return endDelay_;
    }
    const TimeDuration&
    endDelay() const
    {
        return endDelay_;
    }

    TimeDuration&
    holdTime()
    {
        return holdTime_;
    }
    const TimeDuration&
    holdTime() const
    {
        return holdTime_;
    }

    TimeDuration&
    duration()
    {
        return duration_;
    }
    const TimeDuration&
    duration() const
    {
        return duration_;
    }

    nsTArray<AnimationSegment>&
    segments()
    {
        return segments_;
    }
    const nsTArray<AnimationSegment>&
    segments() const
    {
        return segments_;
    }

    float&
    iterations()
    {
        return iterations_;
    }
    const float&
    iterations() const
    {
        return iterations_;
    }

    float&
    iterationStart()
    {
        return iterationStart_;
    }
    const float&
    iterationStart() const
    {
        return iterationStart_;
    }

    uint8_t&
    direction()
    {
        return direction_;
    }
    const uint8_t&
    direction() const
    {
        return direction_;
    }

    uint8_t&
    fillMode()
    {
        return fillMode_;
    }
    const uint8_t&
    fillMode() const
    {
        return fillMode_;
    }

    nsCSSPropertyID&
    property()
    {
        return property_;
    }
    const nsCSSPropertyID&
    property() const
    {
        return property_;
    }

    float&
    playbackRate()
    {
        return playbackRate_;
    }
    const float&
    playbackRate() const
    {
        return playbackRate_;
    }

    float&
    previousPlaybackRate()
    {
        return previousPlaybackRate_;
    }
    const float&
    previousPlaybackRate() const
    {
        return previousPlaybackRate_;
    }

    TimingFunction&
    easingFunction()
    {
        return easingFunction_;
    }
    const TimingFunction&
    easingFunction() const
    {
        return easingFunction_;
    }

    uint8_t&
    iterationComposite()
    {
        return iterationComposite_;
    }
    const uint8_t&
    iterationComposite() const
    {
        return iterationComposite_;
    }

    bool&
    isNotPlaying()
    {
        return isNotPlaying_;
    }
    const bool&
    isNotPlaying() const
    {
        return isNotPlaying_;
    }

    bool&
    isNotAnimating()
    {
        return isNotAnimating_;
    }
    const bool&
    isNotAnimating() const
    {
        return isNotAnimating_;
    }

    Animatable&
    baseStyle()
    {
        return baseStyle_;
    }
    const Animatable&
    baseStyle() const
    {
        return baseStyle_;
    }

    mozilla::Maybe<TransformData>&
    transformData()
    {
        return transformData_;
    }
    const mozilla::Maybe<TransformData>&
    transformData() const
    {
        return transformData_;
    }

    mozilla::Maybe<ScrollTimelineOptions>&
    scrollTimelineOptions()
    {
        return scrollTimelineOptions_;
    }
    const mozilla::Maybe<ScrollTimelineOptions>&
    scrollTimelineOptions() const
    {
        return scrollTimelineOptions_;
    }

private:
    void
    StaticAssertions() const;
    TimeStamp originTime_;
    mozilla::Maybe<TimeDuration> startTime_;
    TimeDuration delay_;
    TimeDuration endDelay_;
    TimeDuration holdTime_;
    TimeDuration duration_;
    CopyableTArray<AnimationSegment> segments_;
    nsCSSPropertyID property_;
    TimingFunction easingFunction_;
    bool isNotPlaying_;
    bool isNotAnimating_;
    Animatable baseStyle_;
    mozilla::Maybe<TransformData> transformData_;
    mozilla::Maybe<ScrollTimelineOptions> scrollTimelineOptions_;
    float iterations_;
    float iterationStart_;
    float playbackRate_;
    float previousPlaybackRate_;
    uint8_t direction_;
    uint8_t fillMode_;
    uint8_t iterationComposite_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::Animation>
{
    typedef mozilla::layers::Animation paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CompositorAnimations|
//
namespace mozilla {
namespace layers {
class CompositorAnimations final
{
private:
    typedef mozilla::layers::Animation Animation;

public:
    MOZ_IMPLICIT CompositorAnimations() :
        animations_(),
        id_()
    {
    }

    MOZ_IMPLICIT CompositorAnimations(
            const nsTArray<Animation>& _animations,
            const uint64_t& _id) :
        animations_(_animations),
        id_(_id)
    {
    }

    nsTArray<Animation>&
    animations()
    {
        return animations_;
    }
    const nsTArray<Animation>&
    animations() const
    {
        return animations_;
    }

    uint64_t&
    id()
    {
        return id_;
    }
    const uint64_t&
    id() const
    {
        return id_;
    }

private:
    CopyableTArray<Animation> animations_;
    uint64_t id_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::CompositorAnimations>
{
    typedef mozilla::layers::CompositorAnimations paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ShmemSection|
//
namespace mozilla {
namespace layers {
class ShmemSection final
{
private:
    typedef mozilla::ipc::Shmem Shmem;

public:
    MOZ_IMPLICIT ShmemSection() :
        shmem_(),
        offset_(),
        size_()
    {
    }

    MOZ_IMPLICIT ShmemSection(
            Shmem& _shmem,
            const uint32_t& _offset,
            const uint32_t& _size) :
        shmem_(_shmem),
        offset_(_offset),
        size_(_size)
    {
    }

    Shmem&
    shmem()
    {
        return shmem_;
    }
    Shmem&
    shmem() const
    {
        return const_cast<Shmem&>(shmem_);
    }

    uint32_t&
    offset()
    {
        return offset_;
    }
    const uint32_t&
    offset() const
    {
        return offset_;
    }

    uint32_t&
    size()
    {
        return size_;
    }
    const uint32_t&
    size() const
    {
        return size_;
    }

private:
    void
    StaticAssertions() const;
    Shmem shmem_;
    uint32_t offset_;
    uint32_t size_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::ShmemSection>
{
    typedef mozilla::layers::ShmemSection paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CrossProcessSemaphoreDescriptor|
//
namespace mozilla {
namespace layers {
class CrossProcessSemaphoreDescriptor final
{
private:
    typedef mozilla::CrossProcessSemaphoreHandle CrossProcessSemaphoreHandle;

public:
    MOZ_IMPLICIT CrossProcessSemaphoreDescriptor() :
        sem_()
    {
    }

    MOZ_IMPLICIT CrossProcessSemaphoreDescriptor(CrossProcessSemaphoreHandle&& _sem) :
        sem_(std::move(_sem))
    {
    }

    CrossProcessSemaphoreHandle&
    sem()
    {
        return sem_;
    }
    const CrossProcessSemaphoreHandle&
    sem() const
    {
        return sem_;
    }

private:
    CrossProcessSemaphoreHandle sem_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::CrossProcessSemaphoreDescriptor>
{
    typedef mozilla::layers::CrossProcessSemaphoreDescriptor paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            paramType&& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union ReadLockDescriptor|
//
namespace mozilla {
namespace layers {
class ReadLockDescriptor final
{
public:
    enum Type {
        T__None,
        TShmemSection = 1,
        TCrossProcessSemaphoreDescriptor,
        Tuintptr_t,
        Tnull_t,
        T__Last = Tnull_t
    };

private:
    typedef mozilla::layers::ShmemSection ShmemSection;
    typedef mozilla::layers::CrossProcessSemaphoreDescriptor CrossProcessSemaphoreDescriptor;
    typedef mozilla::null_t null_t;
    typedef ShmemSection ShmemSection__tdef;
    typedef CrossProcessSemaphoreDescriptor CrossProcessSemaphoreDescriptor__tdef;
    typedef uintptr_t uintptr_t__tdef;
    typedef null_t null_t__tdef;

    union Value {
        mozilla::AlignedStorage2<ShmemSection> VShmemSection;
        mozilla::AlignedStorage2<CrossProcessSemaphoreDescriptor> VCrossProcessSemaphoreDescriptor;
        mozilla::AlignedStorage2<uintptr_t> Vuintptr_t;
        mozilla::AlignedStorage2<null_t> Vnull_t;
    };

    ShmemSection*
    ptr_ShmemSection()
    {
        return ((mValue).VShmemSection).addr();
    }
    const ShmemSection*
    constptr_ShmemSection() const
    {
        return ((mValue).VShmemSection).addr();
    }
    CrossProcessSemaphoreDescriptor*
    ptr_CrossProcessSemaphoreDescriptor()
    {
        return ((mValue).VCrossProcessSemaphoreDescriptor).addr();
    }
    const CrossProcessSemaphoreDescriptor*
    constptr_CrossProcessSemaphoreDescriptor() const
    {
        return ((mValue).VCrossProcessSemaphoreDescriptor).addr();
    }
    uintptr_t*
    ptr_uintptr_t()
    {
        return ((mValue).Vuintptr_t).addr();
    }
    const uintptr_t*
    constptr_uintptr_t() const
    {
        return ((mValue).Vuintptr_t).addr();
    }
    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT ReadLockDescriptor() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT ReadLockDescriptor(const ShmemSection& aOther);

    MOZ_IMPLICIT ReadLockDescriptor(ShmemSection&& aOther);

    MOZ_IMPLICIT ReadLockDescriptor(CrossProcessSemaphoreDescriptor&& aOther);

    MOZ_IMPLICIT ReadLockDescriptor(const uintptr_t& aOther);

    MOZ_IMPLICIT ReadLockDescriptor(uintptr_t&& aOther);

    MOZ_IMPLICIT ReadLockDescriptor(const null_t& aOther);

    MOZ_IMPLICIT ReadLockDescriptor(null_t&& aOther);

    MOZ_IMPLICIT ReadLockDescriptor(ReadLockDescriptor&& aOther);

    ~ReadLockDescriptor();

    Type
    type() const
    {
        return mType;
    }

    ReadLockDescriptor&
    operator=(const ShmemSection& aRhs);

    ReadLockDescriptor&
    operator=(ShmemSection&& aRhs);

    ReadLockDescriptor&
    operator=(CrossProcessSemaphoreDescriptor&& aRhs);

    ReadLockDescriptor&
    operator=(const uintptr_t& aRhs);

    ReadLockDescriptor&
    operator=(uintptr_t&& aRhs);

    ReadLockDescriptor&
    operator=(const null_t& aRhs);

    ReadLockDescriptor&
    operator=(null_t&& aRhs);

    ReadLockDescriptor&
    operator=(ReadLockDescriptor&& aRhs);

    ShmemSection&
    get_ShmemSection()
    {
        AssertSanity(TShmemSection);
        return (*(ptr_ShmemSection()));
    }
    const ShmemSection&
    get_ShmemSection() const
    {
        AssertSanity(TShmemSection);
        return (*(constptr_ShmemSection()));
    }
    operator ShmemSection&()
    {
        return get_ShmemSection();
    }
    operator const ShmemSection&() const
    {
        return get_ShmemSection();
    }

    CrossProcessSemaphoreDescriptor&
    get_CrossProcessSemaphoreDescriptor()
    {
        AssertSanity(TCrossProcessSemaphoreDescriptor);
        return (*(ptr_CrossProcessSemaphoreDescriptor()));
    }
    const CrossProcessSemaphoreDescriptor&
    get_CrossProcessSemaphoreDescriptor() const
    {
        AssertSanity(TCrossProcessSemaphoreDescriptor);
        return (*(constptr_CrossProcessSemaphoreDescriptor()));
    }
    operator CrossProcessSemaphoreDescriptor&()
    {
        return get_CrossProcessSemaphoreDescriptor();
    }
    operator const CrossProcessSemaphoreDescriptor&() const
    {
        return get_CrossProcessSemaphoreDescriptor();
    }

    uintptr_t&
    get_uintptr_t()
    {
        AssertSanity(Tuintptr_t);
        return (*(ptr_uintptr_t()));
    }
    const uintptr_t&
    get_uintptr_t() const
    {
        AssertSanity(Tuintptr_t);
        return (*(constptr_uintptr_t()));
    }
    operator uintptr_t&()
    {
        return get_uintptr_t();
    }
    operator const uintptr_t&() const
    {
        return get_uintptr_t();
    }

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::ReadLockDescriptor>
{
    typedef mozilla::layers::ReadLockDescriptor paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            paramType&& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpRemoveTexture|
//
namespace mozilla {
namespace layers {
class OpRemoveTexture final
{
private:
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;

public:
    MOZ_IMPLICIT OpRemoveTexture() :
        textureParent_(),
        textureChild_()
    {
    }

    MOZ_IMPLICIT OpRemoveTexture(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild) :
        textureParent_(_textureParent),
        textureChild_(_textureChild)
    {
    }

    PTextureParent*&
    textureParent()
    {
        return textureParent_;
    }
    PTextureParent*
    textureParent() const
    {
        return textureParent_;
    }

    PTextureChild*&
    textureChild()
    {
        return textureChild_;
    }
    PTextureChild*
    textureChild() const
    {
        return textureChild_;
    }

private:
    PTextureParent* textureParent_;
    PTextureChild* textureChild_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::OpRemoveTexture>
{
    typedef mozilla::layers::OpRemoveTexture paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct TimedTexture|
//
namespace mozilla {
namespace layers {
class TimedTexture final
{
private:
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;
    typedef mozilla::TimeStamp TimeStamp;
    typedef mozilla::gfx::IntRect IntRect;

public:
    MOZ_IMPLICIT TimedTexture() :
        textureParent_(),
        textureChild_(),
        timeStamp_(),
        picture_(),
        readLocked_(),
        frameID_(),
        producerID_()
    {
    }

    MOZ_IMPLICIT TimedTexture(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild,
            const TimeStamp& _timeStamp,
            const IntRect& _picture,
            const uint32_t& _frameID,
            const uint32_t& _producerID,
            const bool& _readLocked) :
        textureParent_(_textureParent),
        textureChild_(_textureChild),
        timeStamp_(_timeStamp),
        picture_(_picture),
        readLocked_(_readLocked),
        frameID_(_frameID),
        producerID_(_producerID)
    {
    }

    PTextureParent*&
    textureParent()
    {
        return textureParent_;
    }
    PTextureParent*
    textureParent() const
    {
        return textureParent_;
    }

    PTextureChild*&
    textureChild()
    {
        return textureChild_;
    }
    PTextureChild*
    textureChild() const
    {
        return textureChild_;
    }

    TimeStamp&
    timeStamp()
    {
        return timeStamp_;
    }
    const TimeStamp&
    timeStamp() const
    {
        return timeStamp_;
    }

    IntRect&
    picture()
    {
        return picture_;
    }
    const IntRect&
    picture() const
    {
        return picture_;
    }

    uint32_t&
    frameID()
    {
        return frameID_;
    }
    const uint32_t&
    frameID() const
    {
        return frameID_;
    }

    uint32_t&
    producerID()
    {
        return producerID_;
    }
    const uint32_t&
    producerID() const
    {
        return producerID_;
    }

    bool&
    readLocked()
    {
        return readLocked_;
    }
    const bool&
    readLocked() const
    {
        return readLocked_;
    }

private:
    void
    StaticAssertions() const;
    PTextureParent* textureParent_;
    PTextureChild* textureChild_;
    TimeStamp timeStamp_;
    IntRect picture_;
    bool readLocked_;
    uint32_t frameID_;
    uint32_t producerID_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::TimedTexture>
{
    typedef mozilla::layers::TimedTexture paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpUseTexture|
//
namespace mozilla {
namespace layers {
class OpUseTexture final
{
private:
    typedef mozilla::layers::TimedTexture TimedTexture;

public:
    MOZ_IMPLICIT OpUseTexture() :
        textures_()
    {
    }

    MOZ_IMPLICIT OpUseTexture(const nsTArray<TimedTexture>& _textures) :
        textures_(_textures)
    {
    }

    nsTArray<TimedTexture>&
    textures()
    {
        return textures_;
    }
    const nsTArray<TimedTexture>&
    textures() const
    {
        return textures_;
    }

private:
    CopyableTArray<TimedTexture> textures_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::OpUseTexture>
{
    typedef mozilla::layers::OpUseTexture paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpNotifyNotUsed|
//
namespace mozilla {
namespace layers {
class OpNotifyNotUsed final
{
private:

public:
    MOZ_IMPLICIT OpNotifyNotUsed() :
        TextureId_(),
        fwdTransactionId_()
    {
    }

    MOZ_IMPLICIT OpNotifyNotUsed(
            const uint64_t& _TextureId,
            const uint64_t& _fwdTransactionId) :
        TextureId_(_TextureId),
        fwdTransactionId_(_fwdTransactionId)
    {
    }

    uint64_t&
    TextureId()
    {
        return TextureId_;
    }
    const uint64_t&
    TextureId() const
    {
        return TextureId_;
    }

    uint64_t&
    fwdTransactionId()
    {
        return fwdTransactionId_;
    }
    const uint64_t&
    fwdTransactionId() const
    {
        return fwdTransactionId_;
    }

private:
    void
    StaticAssertions() const;
    uint64_t TextureId_;
    uint64_t fwdTransactionId_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::OpNotifyNotUsed>
{
    typedef mozilla::layers::OpNotifyNotUsed paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpDeliverAcquireFence|
//
namespace mozilla {
namespace layers {
class OpDeliverAcquireFence final
{
private:
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;

public:
    MOZ_IMPLICIT OpDeliverAcquireFence() :
        textureParent_(),
        textureChild_(),
        fenceFd_()
    {
    }

    MOZ_IMPLICIT OpDeliverAcquireFence(
            PTextureParent* _textureParent,
            PTextureChild* _textureChild,
            const FileDescriptor& _fenceFd) :
        textureParent_(_textureParent),
        textureChild_(_textureChild),
        fenceFd_(_fenceFd)
    {
    }

    PTextureParent*&
    textureParent()
    {
        return textureParent_;
    }
    PTextureParent*
    textureParent() const
    {
        return textureParent_;
    }

    PTextureChild*&
    textureChild()
    {
        return textureChild_;
    }
    PTextureChild*
    textureChild() const
    {
        return textureChild_;
    }

    FileDescriptor&
    fenceFd()
    {
        return fenceFd_;
    }
    const FileDescriptor&
    fenceFd() const
    {
        return fenceFd_;
    }

private:
    PTextureParent* textureParent_;
    PTextureChild* textureChild_;
    FileDescriptor fenceFd_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::OpDeliverAcquireFence>
{
    typedef mozilla::layers::OpDeliverAcquireFence paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpDeliverReleaseFence|
//
namespace mozilla {
namespace layers {
class OpDeliverReleaseFence final
{
private:
    typedef mozilla::ipc::FileDescriptor FileDescriptor;

public:
    MOZ_IMPLICIT OpDeliverReleaseFence() :
        fenceFd_(),
        usesImageBridge_(),
        bufferId_(),
        fwdTransactionId_()
    {
    }

    MOZ_IMPLICIT OpDeliverReleaseFence(
            const mozilla::Maybe<FileDescriptor>& _fenceFd,
            const uint64_t& _bufferId,
            const uint64_t& _fwdTransactionId,
            const bool& _usesImageBridge) :
        fenceFd_(_fenceFd),
        usesImageBridge_(_usesImageBridge),
        bufferId_(_bufferId),
        fwdTransactionId_(_fwdTransactionId)
    {
    }

    mozilla::Maybe<FileDescriptor>&
    fenceFd()
    {
        return fenceFd_;
    }
    const mozilla::Maybe<FileDescriptor>&
    fenceFd() const
    {
        return fenceFd_;
    }

    uint64_t&
    bufferId()
    {
        return bufferId_;
    }
    const uint64_t&
    bufferId() const
    {
        return bufferId_;
    }

    uint64_t&
    fwdTransactionId()
    {
        return fwdTransactionId_;
    }
    const uint64_t&
    fwdTransactionId() const
    {
        return fwdTransactionId_;
    }

    bool&
    usesImageBridge()
    {
        return usesImageBridge_;
    }
    const bool&
    usesImageBridge() const
    {
        return usesImageBridge_;
    }

private:
    void
    StaticAssertions() const;
    mozilla::Maybe<FileDescriptor> fenceFd_;
    bool usesImageBridge_;
    uint64_t bufferId_;
    uint64_t fwdTransactionId_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::OpDeliverReleaseFence>
{
    typedef mozilla::layers::OpDeliverReleaseFence paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union CompositableOperationDetail|
//
namespace mozilla {
namespace layers {
class CompositableOperationDetail final
{
public:
    enum Type {
        T__None,
        TOpRemoveTexture = 1,
        TOpUseTexture,
        TOpDeliverAcquireFence,
        T__Last = TOpDeliverAcquireFence
    };

private:
    typedef mozilla::layers::OpRemoveTexture OpRemoveTexture;
    typedef mozilla::layers::OpUseTexture OpUseTexture;
    typedef mozilla::layers::OpDeliverAcquireFence OpDeliverAcquireFence;
    typedef OpRemoveTexture OpRemoveTexture__tdef;
    typedef OpUseTexture OpUseTexture__tdef;
    typedef OpDeliverAcquireFence OpDeliverAcquireFence__tdef;

    union Value {
        mozilla::AlignedStorage2<OpRemoveTexture> VOpRemoveTexture;
        mozilla::AlignedStorage2<OpUseTexture> VOpUseTexture;
        mozilla::AlignedStorage2<OpDeliverAcquireFence> VOpDeliverAcquireFence;
    };

    OpRemoveTexture*
    ptr_OpRemoveTexture()
    {
        return ((mValue).VOpRemoveTexture).addr();
    }
    const OpRemoveTexture*
    constptr_OpRemoveTexture() const
    {
        return ((mValue).VOpRemoveTexture).addr();
    }
    OpUseTexture*
    ptr_OpUseTexture()
    {
        return ((mValue).VOpUseTexture).addr();
    }
    const OpUseTexture*
    constptr_OpUseTexture() const
    {
        return ((mValue).VOpUseTexture).addr();
    }
    OpDeliverAcquireFence*
    ptr_OpDeliverAcquireFence()
    {
        return ((mValue).VOpDeliverAcquireFence).addr();
    }
    const OpDeliverAcquireFence*
    constptr_OpDeliverAcquireFence() const
    {
        return ((mValue).VOpDeliverAcquireFence).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT CompositableOperationDetail() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT CompositableOperationDetail(const OpRemoveTexture& aOther);

    MOZ_IMPLICIT CompositableOperationDetail(OpRemoveTexture&& aOther);

    MOZ_IMPLICIT CompositableOperationDetail(const OpUseTexture& aOther);

    MOZ_IMPLICIT CompositableOperationDetail(OpUseTexture&& aOther);

    MOZ_IMPLICIT CompositableOperationDetail(const OpDeliverAcquireFence& aOther);

    MOZ_IMPLICIT CompositableOperationDetail(OpDeliverAcquireFence&& aOther);

    MOZ_IMPLICIT CompositableOperationDetail(const CompositableOperationDetail& aOther);

    MOZ_IMPLICIT CompositableOperationDetail(CompositableOperationDetail&& aOther);

    ~CompositableOperationDetail();

    Type
    type() const
    {
        return mType;
    }

    CompositableOperationDetail&
    operator=(const OpRemoveTexture& aRhs);

    CompositableOperationDetail&
    operator=(OpRemoveTexture&& aRhs);

    CompositableOperationDetail&
    operator=(const OpUseTexture& aRhs);

    CompositableOperationDetail&
    operator=(OpUseTexture&& aRhs);

    CompositableOperationDetail&
    operator=(const OpDeliverAcquireFence& aRhs);

    CompositableOperationDetail&
    operator=(OpDeliverAcquireFence&& aRhs);

    CompositableOperationDetail&
    operator=(const CompositableOperationDetail& aRhs);

    CompositableOperationDetail&
    operator=(CompositableOperationDetail&& aRhs);

    OpRemoveTexture&
    get_OpRemoveTexture()
    {
        AssertSanity(TOpRemoveTexture);
        return (*(ptr_OpRemoveTexture()));
    }
    const OpRemoveTexture&
    get_OpRemoveTexture() const
    {
        AssertSanity(TOpRemoveTexture);
        return (*(constptr_OpRemoveTexture()));
    }
    operator OpRemoveTexture&()
    {
        return get_OpRemoveTexture();
    }
    operator const OpRemoveTexture&() const
    {
        return get_OpRemoveTexture();
    }

    OpUseTexture&
    get_OpUseTexture()
    {
        AssertSanity(TOpUseTexture);
        return (*(ptr_OpUseTexture()));
    }
    const OpUseTexture&
    get_OpUseTexture() const
    {
        AssertSanity(TOpUseTexture);
        return (*(constptr_OpUseTexture()));
    }
    operator OpUseTexture&()
    {
        return get_OpUseTexture();
    }
    operator const OpUseTexture&() const
    {
        return get_OpUseTexture();
    }

    OpDeliverAcquireFence&
    get_OpDeliverAcquireFence()
    {
        AssertSanity(TOpDeliverAcquireFence);
        return (*(ptr_OpDeliverAcquireFence()));
    }
    const OpDeliverAcquireFence&
    get_OpDeliverAcquireFence() const
    {
        AssertSanity(TOpDeliverAcquireFence);
        return (*(constptr_OpDeliverAcquireFence()));
    }
    operator OpDeliverAcquireFence&()
    {
        return get_OpDeliverAcquireFence();
    }
    operator const OpDeliverAcquireFence&() const
    {
        return get_OpDeliverAcquireFence();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::CompositableOperationDetail>
{
    typedef mozilla::layers::CompositableOperationDetail paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct CompositableOperation|
//
namespace mozilla {
namespace layers {
class CompositableOperation final
{
private:
    typedef mozilla::layers::CompositableHandle CompositableHandle;
    typedef mozilla::layers::CompositableOperationDetail CompositableOperationDetail;

public:
    MOZ_IMPLICIT CompositableOperation() :
        compositable_(),
        detail_()
    {
    }

    MOZ_IMPLICIT CompositableOperation(
            const CompositableHandle& _compositable,
            const CompositableOperationDetail& _detail) :
        compositable_(_compositable),
        detail_(_detail)
    {
    }

    CompositableHandle&
    compositable()
    {
        return compositable_;
    }
    const CompositableHandle&
    compositable() const
    {
        return compositable_;
    }

    CompositableOperationDetail&
    detail()
    {
        return detail_;
    }
    const CompositableOperationDetail&
    detail() const
    {
        return detail_;
    }

private:
    CompositableHandle compositable_;
    CompositableOperationDetail detail_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::CompositableOperation>
{
    typedef mozilla::layers::CompositableOperation paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

namespace mozilla {
namespace layers {
class PTextureParent;
} // namespace layers
} // namespace mozilla

namespace mozilla {
namespace layers {
class PTextureChild;
} // namespace layers
} // namespace mozilla


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OpDestroy|
//
namespace mozilla {
namespace layers {
class OpDestroy final
{
public:
    enum Type {
        T__None,
        TPTextureParent = 1,
        TPTextureChild,
        TCompositableHandle,
        T__Last = TCompositableHandle
    };

private:
    typedef mozilla::layers::PTextureParent PTextureParent;
    typedef mozilla::layers::PTextureChild PTextureChild;
    typedef mozilla::layers::CompositableHandle CompositableHandle;
    typedef PTextureParent* PTextureParent__tdef;
    typedef PTextureChild* PTextureChild__tdef;
    typedef CompositableHandle CompositableHandle__tdef;

    union Value {
        mozilla::AlignedStorage2<PTextureParent*> VPTextureParent;
        mozilla::AlignedStorage2<PTextureChild*> VPTextureChild;
        mozilla::AlignedStorage2<CompositableHandle> VCompositableHandle;
    };

    PTextureParent**
    ptr_PTextureParent()
    {
        return ((mValue).VPTextureParent).addr();
    }
    PTextureParent* const*
    constptr_PTextureParent() const
    {
        return ((mValue).VPTextureParent).addr();
    }
    PTextureChild**
    ptr_PTextureChild()
    {
        return ((mValue).VPTextureChild).addr();
    }
    PTextureChild* const*
    constptr_PTextureChild() const
    {
        return ((mValue).VPTextureChild).addr();
    }
    CompositableHandle*
    ptr_CompositableHandle()
    {
        return ((mValue).VCompositableHandle).addr();
    }
    const CompositableHandle*
    constptr_CompositableHandle() const
    {
        return ((mValue).VCompositableHandle).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OpDestroy() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OpDestroy(PTextureParent* aOther);

    MOZ_IMPLICIT OpDestroy(PTextureChild* aOther);

    MOZ_IMPLICIT OpDestroy(const CompositableHandle& aOther);

    MOZ_IMPLICIT OpDestroy(CompositableHandle&& aOther);

    MOZ_IMPLICIT OpDestroy(const OpDestroy& aOther);

    MOZ_IMPLICIT OpDestroy(OpDestroy&& aOther);

    ~OpDestroy();

    Type
    type() const
    {
        return mType;
    }

    OpDestroy&
    operator=(PTextureParent* aRhs);

    OpDestroy&
    operator=(PTextureChild* aRhs);

    OpDestroy&
    operator=(const CompositableHandle& aRhs);

    OpDestroy&
    operator=(CompositableHandle&& aRhs);

    OpDestroy&
    operator=(const OpDestroy& aRhs);

    OpDestroy&
    operator=(OpDestroy&& aRhs);

    PTextureParent*&
    get_PTextureParent()
    {
        AssertSanity(TPTextureParent);
        return (*(ptr_PTextureParent()));
    }
    PTextureParent*
    get_PTextureParent() const
    {
        AssertSanity(TPTextureParent);
        return (*(constptr_PTextureParent()));
    }
    operator PTextureParent*&()
    {
        return get_PTextureParent();
    }
    operator PTextureParent*() const
    {
        return get_PTextureParent();
    }

    PTextureChild*&
    get_PTextureChild()
    {
        AssertSanity(TPTextureChild);
        return (*(ptr_PTextureChild()));
    }
    PTextureChild*
    get_PTextureChild() const
    {
        AssertSanity(TPTextureChild);
        return (*(constptr_PTextureChild()));
    }
    operator PTextureChild*&()
    {
        return get_PTextureChild();
    }
    operator PTextureChild*() const
    {
        return get_PTextureChild();
    }

    CompositableHandle&
    get_CompositableHandle()
    {
        AssertSanity(TCompositableHandle);
        return (*(ptr_CompositableHandle()));
    }
    const CompositableHandle&
    get_CompositableHandle() const
    {
        AssertSanity(TCompositableHandle);
        return (*(constptr_CompositableHandle()));
    }
    operator CompositableHandle&()
    {
        return get_CompositableHandle();
    }
    operator const CompositableHandle&() const
    {
        return get_CompositableHandle();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::OpDestroy>
{
    typedef mozilla::layers::OpDestroy paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct OpContentBufferSwap|
//
namespace mozilla {
namespace layers {
class OpContentBufferSwap final
{
private:
    typedef mozilla::layers::CompositableHandle CompositableHandle;

public:
    MOZ_IMPLICIT OpContentBufferSwap() :
        compositable_(),
        frontUpdatedRegion_()
    {
    }

    MOZ_IMPLICIT OpContentBufferSwap(
            const CompositableHandle& _compositable,
            const nsIntRegion& _frontUpdatedRegion) :
        compositable_(_compositable),
        frontUpdatedRegion_(_frontUpdatedRegion)
    {
    }

    CompositableHandle&
    compositable()
    {
        return compositable_;
    }
    const CompositableHandle&
    compositable() const
    {
        return compositable_;
    }

    nsIntRegion&
    frontUpdatedRegion()
    {
        return frontUpdatedRegion_;
    }
    const nsIntRegion&
    frontUpdatedRegion() const
    {
        return frontUpdatedRegion_;
    }

private:
    CompositableHandle compositable_;
    nsIntRegion frontUpdatedRegion_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::OpContentBufferSwap>
{
    typedef mozilla::layers::OpContentBufferSwap paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct ImageCompositeNotification|
//
namespace mozilla {
namespace layers {
class ImageCompositeNotification final
{
private:
    typedef mozilla::layers::CompositableHandle CompositableHandle;
    typedef mozilla::TimeStamp TimeStamp;

public:
    MOZ_IMPLICIT ImageCompositeNotification() :
        compositable_(),
        imageTimeStamp_(),
        firstCompositeTimeStamp_(),
        frameID_(),
        producerID_()
    {
    }

    MOZ_IMPLICIT ImageCompositeNotification(
            const CompositableHandle& _compositable,
            const TimeStamp& _imageTimeStamp,
            const TimeStamp& _firstCompositeTimeStamp,
            const uint32_t& _frameID,
            const uint32_t& _producerID) :
        compositable_(_compositable),
        imageTimeStamp_(_imageTimeStamp),
        firstCompositeTimeStamp_(_firstCompositeTimeStamp),
        frameID_(_frameID),
        producerID_(_producerID)
    {
    }

    CompositableHandle&
    compositable()
    {
        return compositable_;
    }
    const CompositableHandle&
    compositable() const
    {
        return compositable_;
    }

    TimeStamp&
    imageTimeStamp()
    {
        return imageTimeStamp_;
    }
    const TimeStamp&
    imageTimeStamp() const
    {
        return imageTimeStamp_;
    }

    TimeStamp&
    firstCompositeTimeStamp()
    {
        return firstCompositeTimeStamp_;
    }
    const TimeStamp&
    firstCompositeTimeStamp() const
    {
        return firstCompositeTimeStamp_;
    }

    uint32_t&
    frameID()
    {
        return frameID_;
    }
    const uint32_t&
    frameID() const
    {
        return frameID_;
    }

    uint32_t&
    producerID()
    {
        return producerID_;
    }
    const uint32_t&
    producerID() const
    {
        return producerID_;
    }

private:
    void
    StaticAssertions() const;
    CompositableHandle compositable_;
    TimeStamp imageTimeStamp_;
    TimeStamp firstCompositeTimeStamp_;
    uint32_t frameID_;
    uint32_t producerID_;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::ImageCompositeNotification>
{
    typedef mozilla::layers::ImageCompositeNotification paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union AsyncParentMessageData|
//
namespace mozilla {
namespace layers {
class AsyncParentMessageData final
{
public:
    enum Type {
        T__None,
        TOpNotifyNotUsed = 1,
        TOpDeliverReleaseFence,
        T__Last = TOpDeliverReleaseFence
    };

private:
    typedef mozilla::layers::OpNotifyNotUsed OpNotifyNotUsed;
    typedef mozilla::layers::OpDeliverReleaseFence OpDeliverReleaseFence;
    typedef OpNotifyNotUsed OpNotifyNotUsed__tdef;
    typedef OpDeliverReleaseFence OpDeliverReleaseFence__tdef;

    union Value {
        mozilla::AlignedStorage2<OpNotifyNotUsed> VOpNotifyNotUsed;
        mozilla::AlignedStorage2<OpDeliverReleaseFence> VOpDeliverReleaseFence;
    };

    OpNotifyNotUsed*
    ptr_OpNotifyNotUsed()
    {
        return ((mValue).VOpNotifyNotUsed).addr();
    }
    const OpNotifyNotUsed*
    constptr_OpNotifyNotUsed() const
    {
        return ((mValue).VOpNotifyNotUsed).addr();
    }
    OpDeliverReleaseFence*
    ptr_OpDeliverReleaseFence()
    {
        return ((mValue).VOpDeliverReleaseFence).addr();
    }
    const OpDeliverReleaseFence*
    constptr_OpDeliverReleaseFence() const
    {
        return ((mValue).VOpDeliverReleaseFence).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT AsyncParentMessageData() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT AsyncParentMessageData(const OpNotifyNotUsed& aOther);

    MOZ_IMPLICIT AsyncParentMessageData(OpNotifyNotUsed&& aOther);

    MOZ_IMPLICIT AsyncParentMessageData(const OpDeliverReleaseFence& aOther);

    MOZ_IMPLICIT AsyncParentMessageData(OpDeliverReleaseFence&& aOther);

    MOZ_IMPLICIT AsyncParentMessageData(const AsyncParentMessageData& aOther);

    MOZ_IMPLICIT AsyncParentMessageData(AsyncParentMessageData&& aOther);

    ~AsyncParentMessageData();

    Type
    type() const
    {
        return mType;
    }

    AsyncParentMessageData&
    operator=(const OpNotifyNotUsed& aRhs);

    AsyncParentMessageData&
    operator=(OpNotifyNotUsed&& aRhs);

    AsyncParentMessageData&
    operator=(const OpDeliverReleaseFence& aRhs);

    AsyncParentMessageData&
    operator=(OpDeliverReleaseFence&& aRhs);

    AsyncParentMessageData&
    operator=(const AsyncParentMessageData& aRhs);

    AsyncParentMessageData&
    operator=(AsyncParentMessageData&& aRhs);

    OpNotifyNotUsed&
    get_OpNotifyNotUsed()
    {
        AssertSanity(TOpNotifyNotUsed);
        return (*(ptr_OpNotifyNotUsed()));
    }
    const OpNotifyNotUsed&
    get_OpNotifyNotUsed() const
    {
        AssertSanity(TOpNotifyNotUsed);
        return (*(constptr_OpNotifyNotUsed()));
    }
    operator OpNotifyNotUsed&()
    {
        return get_OpNotifyNotUsed();
    }
    operator const OpNotifyNotUsed&() const
    {
        return get_OpNotifyNotUsed();
    }

    OpDeliverReleaseFence&
    get_OpDeliverReleaseFence()
    {
        AssertSanity(TOpDeliverReleaseFence);
        return (*(ptr_OpDeliverReleaseFence()));
    }
    const OpDeliverReleaseFence&
    get_OpDeliverReleaseFence() const
    {
        AssertSanity(TOpDeliverReleaseFence);
        return (*(constptr_OpDeliverReleaseFence()));
    }
    operator OpDeliverReleaseFence&()
    {
        return get_OpDeliverReleaseFence();
    }
    operator const OpDeliverReleaseFence&() const
    {
        return get_OpDeliverReleaseFence();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::AsyncParentMessageData>
{
    typedef mozilla::layers::AsyncParentMessageData paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |union OMTAValue|
//
namespace mozilla {
namespace layers {
class OMTAValue final
{
public:
    enum Type {
        T__None,
        Tnull_t = 1,
        Tnscolor,
        Tfloat,
        TMatrix4x4,
        T__Last = TMatrix4x4
    };

private:
    typedef mozilla::null_t null_t;
    typedef mozilla::gfx::Matrix4x4 Matrix4x4;
    typedef null_t null_t__tdef;
    typedef nscolor nscolor__tdef;
    typedef float float__tdef;
    typedef Matrix4x4 Matrix4x4__tdef;

    union Value {
        mozilla::AlignedStorage2<null_t> Vnull_t;
        mozilla::AlignedStorage2<nscolor> Vnscolor;
        mozilla::AlignedStorage2<float> Vfloat;
        mozilla::AlignedStorage2<Matrix4x4> VMatrix4x4;
    };

    null_t*
    ptr_null_t()
    {
        return ((mValue).Vnull_t).addr();
    }
    const null_t*
    constptr_null_t() const
    {
        return ((mValue).Vnull_t).addr();
    }
    nscolor*
    ptr_nscolor()
    {
        return ((mValue).Vnscolor).addr();
    }
    const nscolor*
    constptr_nscolor() const
    {
        return ((mValue).Vnscolor).addr();
    }
    float*
    ptr_float()
    {
        return ((mValue).Vfloat).addr();
    }
    const float*
    constptr_float() const
    {
        return ((mValue).Vfloat).addr();
    }
    Matrix4x4*
    ptr_Matrix4x4()
    {
        return ((mValue).VMatrix4x4).addr();
    }
    const Matrix4x4*
    constptr_Matrix4x4() const
    {
        return ((mValue).VMatrix4x4).addr();
    }

    bool
    MaybeDestroy(Type aNewType);

    void
    AssertSanity() const
    {
        MOZ_RELEASE_ASSERT((T__None) <= (mType), "invalid type tag");
        MOZ_RELEASE_ASSERT((mType) <= (T__Last), "invalid type tag");
    }
    void
    AssertSanity(Type aType) const
    {
        AssertSanity();
        MOZ_RELEASE_ASSERT((mType) == (aType), "unexpected type tag");
    }

public:
    MOZ_IMPLICIT OMTAValue() :
        mType(T__None)
    {
    }

    MOZ_IMPLICIT OMTAValue(const null_t& aOther);

    MOZ_IMPLICIT OMTAValue(null_t&& aOther);

    MOZ_IMPLICIT OMTAValue(const nscolor& aOther);

    MOZ_IMPLICIT OMTAValue(nscolor&& aOther);

    MOZ_IMPLICIT OMTAValue(const float& aOther);

    MOZ_IMPLICIT OMTAValue(float&& aOther);

    MOZ_IMPLICIT OMTAValue(const Matrix4x4& aOther);

    MOZ_IMPLICIT OMTAValue(Matrix4x4&& aOther);

    MOZ_IMPLICIT OMTAValue(const OMTAValue& aOther);

    MOZ_IMPLICIT OMTAValue(OMTAValue&& aOther);

    ~OMTAValue();

    Type
    type() const
    {
        return mType;
    }

    OMTAValue&
    operator=(const null_t& aRhs);

    OMTAValue&
    operator=(null_t&& aRhs);

    OMTAValue&
    operator=(const nscolor& aRhs);

    OMTAValue&
    operator=(nscolor&& aRhs);

    OMTAValue&
    operator=(const float& aRhs);

    OMTAValue&
    operator=(float&& aRhs);

    OMTAValue&
    operator=(const Matrix4x4& aRhs);

    OMTAValue&
    operator=(Matrix4x4&& aRhs);

    OMTAValue&
    operator=(const OMTAValue& aRhs);

    OMTAValue&
    operator=(OMTAValue&& aRhs);

    null_t&
    get_null_t()
    {
        AssertSanity(Tnull_t);
        return (*(ptr_null_t()));
    }
    const null_t&
    get_null_t() const
    {
        AssertSanity(Tnull_t);
        return (*(constptr_null_t()));
    }
    operator null_t&()
    {
        return get_null_t();
    }
    operator const null_t&() const
    {
        return get_null_t();
    }

    nscolor&
    get_nscolor()
    {
        AssertSanity(Tnscolor);
        return (*(ptr_nscolor()));
    }
    const nscolor&
    get_nscolor() const
    {
        AssertSanity(Tnscolor);
        return (*(constptr_nscolor()));
    }
    operator nscolor&()
    {
        return get_nscolor();
    }
    operator const nscolor&() const
    {
        return get_nscolor();
    }

    float&
    get_float()
    {
        AssertSanity(Tfloat);
        return (*(ptr_float()));
    }
    const float&
    get_float() const
    {
        AssertSanity(Tfloat);
        return (*(constptr_float()));
    }
    operator float&()
    {
        return get_float();
    }
    operator const float&() const
    {
        return get_float();
    }

    Matrix4x4&
    get_Matrix4x4()
    {
        AssertSanity(TMatrix4x4);
        return (*(ptr_Matrix4x4()));
    }
    const Matrix4x4&
    get_Matrix4x4() const
    {
        AssertSanity(TMatrix4x4);
        return (*(constptr_Matrix4x4()));
    }
    operator Matrix4x4&()
    {
        return get_Matrix4x4();
    }
    operator const Matrix4x4&() const
    {
        return get_Matrix4x4();
    }

private:
    Value mValue;
    Type mType;
};
} // namespace layers
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::layers::OMTAValue>
{
    typedef mozilla::layers::OMTAValue paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

#endif // ifndef LayersMessages_h
