//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef PWebGPUChild_h
#define PWebGPUChild_h

#include "mozilla/webgpu/PWebGPU.h"
#ifdef DEBUG
#include "prenv.h"
#endif  // DEBUG

#include "mozilla/Tainting.h"
#include "mozilla/ipc/MessageChannel.h"
#include "mozilla/ipc/ProtocolUtils.h"
// Headers for things that cannot be forward declared
#include "mozilla/dom/WebGPUBinding.h"
#include "mozilla/layers/LayersSurfaces.h"
#include "mozilla/layers/LayersTypes.h"
#include "mozilla/webgpu/WebGPUTypes.h"
#include "mozilla/webgpu/ffi/wgpu.h"

namespace mozilla {
namespace gfx {
class PCanvasManagerChild;
} // namespace gfx
} // namespace mozilla
namespace mozilla {
namespace gfx {
class PCanvasManagerParent;
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace gfx {
class PCanvasManagerChild;
} // namespace gfx
} // namespace mozilla

namespace mozilla {
namespace webgpu {


class PWebGPUChild :
    public mozilla::ipc::IProtocol
{
private:
    friend class mozilla::gfx::PCanvasManagerChild;
protected:
    typedef mozilla::ipc::ActorHandle ActorHandle;
    typedef mozilla::ipc::ByteBuf ByteBuf;
    typedef layers::CompositableHandle CompositableHandle;
    template<class FooSide> using Endpoint = mozilla::ipc::Endpoint<FooSide>;
    typedef mozilla::ipc::FileDescriptor FileDescriptor;
    typedef dom::GPUCommandBufferDescriptor GPUCommandBufferDescriptor;
    typedef dom::GPURequestAdapterOptions GPURequestAdapterOptions;
    template<class FooSide> using ManagedEndpoint = mozilla::ipc::ManagedEndpoint<FooSide>;
    typedef mozilla::gfx::PCanvasManagerChild PCanvasManagerChild;
    typedef mozilla::gfx::PCanvasManagerParent PCanvasManagerParent;
    typedef base::ProcessId ProcessId;
    typedef mozilla::ipc::ProtocolId ProtocolId;
    typedef layers::RGBDescriptor RGBDescriptor;
    typedef mozilla::ipc::ResponseRejectReason ResponseRejectReason;
    typedef mozilla::ipc::Shmem Shmem;
    template<class T> using UniquePtr = mozilla::UniquePtr<T>;
    typedef webgpu::ffi::WGPUHostMap WGPUHostMap;

public:
    typedef MozPromise<bool, ResponseRejectReason, true> DeviceActionWithAckPromise;
    typedef MozPromise<ByteBuf, ResponseRejectReason, true> InstanceRequestAdapterPromise;
    typedef MozPromise<bool, ResponseRejectReason, true> AdapterRequestDevicePromise;
    typedef MozPromise<Shmem, ResponseRejectReason, true> BufferMapPromise;
    typedef MozPromise<MaybeScopedError, ResponseRejectReason, true> DevicePopErrorScopePromise;

protected:
    virtual mozilla::ipc::IPCResult
    Recv__delete__();
public:
    typedef mozilla::ipc::IProtocol IProtocol;
    typedef IPC::Message Message;
    typedef base::ProcessHandle ProcessHandle;
    typedef mozilla::ipc::MessageChannel MessageChannel;
    typedef mozilla::ipc::SharedMemory SharedMemory;

public:
    MOZ_IMPLICIT PWebGPUChild();

    virtual ~PWebGPUChild();

    NS_INLINE_DECL_PURE_VIRTUAL_REFCOUNTING
protected:
    void ActorAlloc() final { AddRef(); }
    void ActorDealloc() final { Release(); }
public:
    ::base::ProcessId
    OtherPid() const;

    PCanvasManagerChild*
    Manager() const;

    void
    AllManagedActors(nsTArray<RefPtr<mozilla::ipc::ActorLifecycleProxy>>& arr__) const override;

    bool
    SendDeviceAction(
            const RawId& selfId,
            ByteBuf&& buf);

    void
    SendDeviceActionWithAck(
            const RawId& selfId,
            ByteBuf&& buf,
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<DeviceActionWithAckPromise>
    SendDeviceActionWithAck(
            const RawId& selfId,
            ByteBuf&& buf);

    bool
    SendTextureAction(
            const RawId& selfId,
            const RawId& aDeviceId,
            ByteBuf&& buf);

    bool
    SendCommandEncoderAction(
            const RawId& selfId,
            const RawId& aDeviceId,
            ByteBuf&& buf);

    bool
    SendBumpImplicitBindGroupLayout(
            const RawId& pipelineId,
            const bool& isCompute,
            const uint32_t& index,
            const RawId& assignId);

    void
    SendInstanceRequestAdapter(
            const GPURequestAdapterOptions& options,
            const nsTArray<RawId>& ids,
            mozilla::ipc::ResolveCallback<ByteBuf>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<InstanceRequestAdapterPromise>
    SendInstanceRequestAdapter(
            const GPURequestAdapterOptions& options,
            const nsTArray<RawId>& ids);

    void
    SendAdapterRequestDevice(
            const RawId& selfId,
            ByteBuf&& buf,
            const RawId& newId,
            mozilla::ipc::ResolveCallback<bool>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<AdapterRequestDevicePromise>
    SendAdapterRequestDevice(
            const RawId& selfId,
            ByteBuf&& buf,
            const RawId& newId);

    bool
    SendAdapterDestroy(const RawId& selfId);

    bool
    SendBufferReturnShmem(
            const RawId& selfId,
            Shmem&& shmem);

    void
    SendBufferMap(
            const RawId& selfId,
            const WGPUHostMap& hostMap,
            const uint64_t& offset,
            const uint64_t& size,
            mozilla::ipc::ResolveCallback<Shmem>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<BufferMapPromise>
    SendBufferMap(
            const RawId& selfId,
            const WGPUHostMap& hostMap,
            const uint64_t& offset,
            const uint64_t& size);

    bool
    SendBufferUnmap(
            const RawId& selfId,
            Shmem&& shmem,
            const bool& flush,
            const bool& keepShmem);

    bool
    SendBufferDestroy(const RawId& selfId);

    bool
    SendTextureDestroy(const RawId& selfId);

    bool
    SendTextureViewDestroy(const RawId& selfId);

    bool
    SendSamplerDestroy(const RawId& selfId);

    bool
    SendDeviceDestroy(const RawId& selfId);

    bool
    SendCommandEncoderFinish(
            const RawId& selfId,
            const RawId& deviceId,
            const GPUCommandBufferDescriptor& desc);

    bool
    SendCommandEncoderDestroy(const RawId& selfId);

    bool
    SendCommandBufferDestroy(const RawId& selfId);

    bool
    SendRenderBundleDestroy(const RawId& selfId);

    bool
    SendQueueSubmit(
            const RawId& selfId,
            const RawId& aDeviceId,
            const nsTArray<RawId>& commandBuffers);

    bool
    SendQueueWriteAction(
            const RawId& selfId,
            const RawId& aDeviceId,
            ByteBuf&& buf,
            Shmem&& shmem);

    bool
    SendBindGroupLayoutDestroy(const RawId& selfId);

    bool
    SendPipelineLayoutDestroy(const RawId& selfId);

    bool
    SendBindGroupDestroy(const RawId& selfId);

    bool
    SendShaderModuleDestroy(const RawId& selfId);

    bool
    SendComputePipelineDestroy(const RawId& selfId);

    bool
    SendRenderPipelineDestroy(const RawId& selfId);

    bool
    SendImplicitLayoutDestroy(
            const RawId& implicitPlId,
            const nsTArray<RawId>& implicitBglIds);

    bool
    SendDeviceCreateSwapChain(
            const RawId& selfId,
            const RawId& queueId,
            const RGBDescriptor& desc,
            const nsTArray<RawId>& bufferIds,
            const CompositableHandle& handle);

    bool
    SendSwapChainPresent(
            const CompositableHandle& handle,
            const RawId& textureId,
            const RawId& commandEncoderId);

    bool
    SendSwapChainDestroy(const CompositableHandle& handle);

    bool
    SendDevicePushErrorScope(const RawId& selfId);

    void
    SendDevicePopErrorScope(
            const RawId& selfId,
            mozilla::ipc::ResolveCallback<MaybeScopedError>&& aResolve,
            mozilla::ipc::RejectCallback&& aReject);

    RefPtr<DevicePopErrorScopePromise>
    SendDevicePopErrorScope(const RawId& selfId);

    bool
    SendGenerateError(
            const RawId& deviceId,
            const nsCString& message);

    void
    RemoveManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;
    void
    DeallocManagee(
            int32_t aProtocolId,
            IProtocol* aListener) override;

    Result
    OnMessageReceived(const Message& msg__) override;

    Result
    OnMessageReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

    Result
    OnCallReceived(
            const Message& msg__,
            UniquePtr<Message>& reply__) override;

private:
    void
    ClearSubtree();

    bool mAwaitingManagedEndpointBind = false;

};


} // namespace webgpu
} // namespace mozilla
namespace IPC {
template<>
struct ParamTraits <mozilla::webgpu::PWebGPUChild*>
{
    typedef mozilla::webgpu::PWebGPUChild* paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

#endif // ifndef PWebGPUChild_h
