//
// Automatically generated by ipdlc.
// Edit at your own risk
//

#ifndef LookAndFeelTypes_h
#define LookAndFeelTypes_h

#include "mozilla/Attributes.h"
#include "IPCMessageStart.h"
#include "mozilla/RefPtr.h"
#include "nsString.h"
#include "nsTArray.h"
#include "nsTHashtable.h"
#include "mozilla/MozPromise.h"
#include "mozilla/OperatorNewExtensions.h"
#include "mozilla/UniquePtr.h"
#include "mozilla/ipc/ByteBuf.h"
#include "mozilla/ipc/FileDescriptor.h"
#include "mozilla/ipc/ProtocolUtilsFwd.h"
#include "mozilla/ipc/Shmem.h"

// Headers for typedefs
#include "nsColor.h"


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LookAndFeelFont|
//
namespace mozilla {
namespace widget {
class LookAndFeelFont final
{
private:

public:
    MOZ_IMPLICIT LookAndFeelFont() :
        haveFont_(),
        name_(),
        italic_(),
        size_(),
        weight_()
    {
    }

    MOZ_IMPLICIT LookAndFeelFont(
            const bool& _haveFont,
            const nsString& _name,
            const float& _size,
            const float& _weight,
            const bool& _italic) :
        haveFont_(_haveFont),
        name_(_name),
        italic_(_italic),
        size_(_size),
        weight_(_weight)
    {
    }

    bool
    operator==(const LookAndFeelFont& _o) const;

    bool
    operator!=(const LookAndFeelFont& _o) const;

    bool&
    haveFont()
    {
        return haveFont_;
    }
    const bool&
    haveFont() const
    {
        return haveFont_;
    }

    nsString&
    name()
    {
        return name_;
    }
    const nsString&
    name() const
    {
        return name_;
    }

    float&
    size()
    {
        return size_;
    }
    const float&
    size() const
    {
        return size_;
    }

    float&
    weight()
    {
        return weight_;
    }
    const float&
    weight() const
    {
        return weight_;
    }

    bool&
    italic()
    {
        return italic_;
    }
    const bool&
    italic() const
    {
        return italic_;
    }

private:
    void
    StaticAssertions() const;
    bool haveFont_;
    nsString name_;
    bool italic_;
    float size_;
    float weight_;
};
} // namespace widget
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::widget::LookAndFeelFont>
{
    typedef mozilla::widget::LookAndFeelFont paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LookAndFeelTables|
//
namespace mozilla {
namespace widget {
class LookAndFeelTables final
{
private:
    typedef mozilla::widget::LookAndFeelFont LookAndFeelFont;

public:
    MOZ_IMPLICIT LookAndFeelTables() :
        ints_(),
        floats_(),
        fonts_(),
        lightColors_(),
        darkColors_(),
        intMap_(),
        floatMap_(),
        fontMap_(),
        lightColorMap_(),
        darkColorMap_(),
        passwordEcho_(),
        passwordChar_()
    {
    }

    MOZ_IMPLICIT LookAndFeelTables(
            const nsTArray<int32_t>& _ints,
            const nsTArray<float>& _floats,
            const nsTArray<LookAndFeelFont>& _fonts,
            const nsTArray<nscolor>& _lightColors,
            const nsTArray<nscolor>& _darkColors,
            const nsTArray<uint8_t>& _intMap,
            const nsTArray<uint8_t>& _floatMap,
            const nsTArray<uint8_t>& _fontMap,
            const nsTArray<uint8_t>& _lightColorMap,
            const nsTArray<uint8_t>& _darkColorMap,
            const uint16_t& _passwordChar,
            const bool& _passwordEcho) :
        ints_(_ints),
        floats_(_floats),
        fonts_(_fonts),
        lightColors_(_lightColors),
        darkColors_(_darkColors),
        intMap_(_intMap),
        floatMap_(_floatMap),
        fontMap_(_fontMap),
        lightColorMap_(_lightColorMap),
        darkColorMap_(_darkColorMap),
        passwordEcho_(_passwordEcho),
        passwordChar_(_passwordChar)
    {
    }

    nsTArray<int32_t>&
    ints()
    {
        return ints_;
    }
    const nsTArray<int32_t>&
    ints() const
    {
        return ints_;
    }

    nsTArray<float>&
    floats()
    {
        return floats_;
    }
    const nsTArray<float>&
    floats() const
    {
        return floats_;
    }

    nsTArray<LookAndFeelFont>&
    fonts()
    {
        return fonts_;
    }
    const nsTArray<LookAndFeelFont>&
    fonts() const
    {
        return fonts_;
    }

    nsTArray<nscolor>&
    lightColors()
    {
        return lightColors_;
    }
    const nsTArray<nscolor>&
    lightColors() const
    {
        return lightColors_;
    }

    nsTArray<nscolor>&
    darkColors()
    {
        return darkColors_;
    }
    const nsTArray<nscolor>&
    darkColors() const
    {
        return darkColors_;
    }

    nsTArray<uint8_t>&
    intMap()
    {
        return intMap_;
    }
    const nsTArray<uint8_t>&
    intMap() const
    {
        return intMap_;
    }

    nsTArray<uint8_t>&
    floatMap()
    {
        return floatMap_;
    }
    const nsTArray<uint8_t>&
    floatMap() const
    {
        return floatMap_;
    }

    nsTArray<uint8_t>&
    fontMap()
    {
        return fontMap_;
    }
    const nsTArray<uint8_t>&
    fontMap() const
    {
        return fontMap_;
    }

    nsTArray<uint8_t>&
    lightColorMap()
    {
        return lightColorMap_;
    }
    const nsTArray<uint8_t>&
    lightColorMap() const
    {
        return lightColorMap_;
    }

    nsTArray<uint8_t>&
    darkColorMap()
    {
        return darkColorMap_;
    }
    const nsTArray<uint8_t>&
    darkColorMap() const
    {
        return darkColorMap_;
    }

    uint16_t&
    passwordChar()
    {
        return passwordChar_;
    }
    const uint16_t&
    passwordChar() const
    {
        return passwordChar_;
    }

    bool&
    passwordEcho()
    {
        return passwordEcho_;
    }
    const bool&
    passwordEcho() const
    {
        return passwordEcho_;
    }

private:
    CopyableTArray<int32_t> ints_;
    CopyableTArray<float> floats_;
    CopyableTArray<LookAndFeelFont> fonts_;
    CopyableTArray<nscolor> lightColors_;
    CopyableTArray<nscolor> darkColors_;
    CopyableTArray<uint8_t> intMap_;
    CopyableTArray<uint8_t> floatMap_;
    CopyableTArray<uint8_t> fontMap_;
    CopyableTArray<uint8_t> lightColorMap_;
    CopyableTArray<uint8_t> darkColorMap_;
    bool passwordEcho_;
    uint16_t passwordChar_;
};
} // namespace widget
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::widget::LookAndFeelTables>
{
    typedef mozilla::widget::LookAndFeelTables paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct LookAndFeelTheme|
//
namespace mozilla {
namespace widget {
class LookAndFeelTheme final
{
private:

public:
    MOZ_IMPLICIT LookAndFeelTheme() :
        themeName_(),
        preferDarkTheme_()
    {
    }

    MOZ_IMPLICIT LookAndFeelTheme(
            const nsCString& _themeName,
            const bool& _preferDarkTheme) :
        themeName_(_themeName),
        preferDarkTheme_(_preferDarkTheme)
    {
    }

    nsCString&
    themeName()
    {
        return themeName_;
    }
    const nsCString&
    themeName() const
    {
        return themeName_;
    }

    bool&
    preferDarkTheme()
    {
        return preferDarkTheme_;
    }
    const bool&
    preferDarkTheme() const
    {
        return preferDarkTheme_;
    }

private:
    nsCString themeName_;
    bool preferDarkTheme_;
};
} // namespace widget
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::widget::LookAndFeelTheme>
{
    typedef mozilla::widget::LookAndFeelTheme paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC


//-----------------------------------------------------------------------------
// Declaration of the IPDL type |struct FullLookAndFeel|
//
namespace mozilla {
namespace widget {
class FullLookAndFeel final
{
private:
    typedef mozilla::widget::LookAndFeelTables LookAndFeelTables;
    typedef mozilla::widget::LookAndFeelTheme LookAndFeelTheme;

public:
    MOZ_IMPLICIT FullLookAndFeel() :
        tables_(),
        theme_()
    {
    }

    MOZ_IMPLICIT FullLookAndFeel(
            const LookAndFeelTables& _tables,
            const LookAndFeelTheme& _theme) :
        tables_(_tables),
        theme_(_theme)
    {
    }

    LookAndFeelTables&
    tables()
    {
        return tables_;
    }
    const LookAndFeelTables&
    tables() const
    {
        return tables_;
    }

    LookAndFeelTheme&
    theme()
    {
        return theme_;
    }
    const LookAndFeelTheme&
    theme() const
    {
        return theme_;
    }

private:
    LookAndFeelTables tables_;
    LookAndFeelTheme theme_;
};
} // namespace widget
} // namespace mozilla

namespace IPC {
template<>
struct ParamTraits <mozilla::widget::FullLookAndFeel>
{
    typedef mozilla::widget::FullLookAndFeel paramType;
    static void
    Write(
            IPC::MessageWriter* aWriter,
            const paramType& aVar);
    static bool
    Read(
            IPC::MessageReader* aReader,
            paramType* aVar);
};
} // namespace IPC

#endif // ifndef LookAndFeelTypes_h
