#include "brush_blend.h"
#include "brush_blend_ALPHA_PASS.h"
#include "brush_blend_DEBUG_OVERDRAW.h"
#include "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D.h"
#include "brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT.h"
#include "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D.h"
#include "brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT.h"
#include "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D.h"
#include "brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT.h"
#include "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D.h"
#include "brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT.h"
#include "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D.h"
#include "brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT.h"
#include "brush_image_ALPHA_PASS_TEXTURE_2D.h"
#include "brush_image_ALPHA_PASS_TEXTURE_RECT.h"
#include "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D.h"
#include "brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT.h"
#include "brush_image_ANTIALIASING_REPETITION_TEXTURE_2D.h"
#include "brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT.h"
#include "brush_image_DEBUG_OVERDRAW_TEXTURE_2D.h"
#include "brush_image_DEBUG_OVERDRAW_TEXTURE_RECT.h"
#include "brush_image_TEXTURE_2D.h"
#include "brush_image_TEXTURE_RECT.h"
#include "brush_linear_gradient.h"
#include "brush_linear_gradient_ALPHA_PASS.h"
#include "brush_linear_gradient_DEBUG_OVERDRAW.h"
#include "brush_mix_blend.h"
#include "brush_mix_blend_ALPHA_PASS.h"
#include "brush_mix_blend_DEBUG_OVERDRAW.h"
#include "brush_opacity.h"
#include "brush_opacity_ALPHA_PASS.h"
#include "brush_opacity_ALPHA_PASS_ANTIALIASING.h"
#include "brush_opacity_ANTIALIASING.h"
#include "brush_opacity_ANTIALIASING_DEBUG_OVERDRAW.h"
#include "brush_opacity_DEBUG_OVERDRAW.h"
#include "brush_solid.h"
#include "brush_solid_ALPHA_PASS.h"
#include "brush_solid_DEBUG_OVERDRAW.h"
#include "brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV.h"
#include "brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV.h"
#include "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV.h"
#include "brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV.h"
#include "brush_yuv_image_TEXTURE_2D_YUV.h"
#include "brush_yuv_image_TEXTURE_RECT_YUV.h"
#include "composite_FAST_PATH_TEXTURE_2D.h"
#include "composite_FAST_PATH_TEXTURE_RECT.h"
#include "composite_TEXTURE_2D.h"
#include "composite_TEXTURE_2D_YUV.h"
#include "composite_TEXTURE_RECT.h"
#include "composite_TEXTURE_RECT_YUV.h"
#include "cs_blur_ALPHA_TARGET.h"
#include "cs_blur_COLOR_TARGET.h"
#include "cs_border_segment.h"
#include "cs_border_solid.h"
#include "cs_clip_box_shadow_TEXTURE_2D.h"
#include "cs_clip_image_TEXTURE_2D.h"
#include "cs_clip_rectangle.h"
#include "cs_clip_rectangle_FAST_PATH.h"
#include "cs_conic_gradient.h"
#include "cs_fast_linear_gradient.h"
#include "cs_line_decoration.h"
#include "cs_linear_gradient.h"
#include "cs_radial_gradient.h"
#include "cs_scale_TEXTURE_2D.h"
#include "cs_scale_TEXTURE_RECT.h"
#include "cs_svg_filter.h"
#include "debug_color.h"
#include "debug_font.h"
#include "ps_clear.h"
#include "ps_copy.h"
#include "ps_split_composite.h"
#include "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D.h"
#include "ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D.h"
#include "ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D.h"
#include "ps_text_run_ALPHA_PASS_TEXTURE_2D.h"
#include "ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D.h"
#include "ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D.h"
ProgramLoader load_shader(const char* name) {
  if (!strcmp(name, "brush_blend")) { return brush_blend_program::loader; }
  if (!strcmp(name, "brush_blend ALPHA_PASS")) { return brush_blend_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_blend DEBUG_OVERDRAW")) { return brush_blend_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_image ADVANCED_BLEND,ALPHA_PASS,ANTIALIASING,REPETITION,TEXTURE_2D")) { return brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "brush_image ADVANCED_BLEND,ALPHA_PASS,ANTIALIASING,REPETITION,TEXTURE_RECT")) { return brush_image_ADVANCED_BLEND_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "brush_image ADVANCED_BLEND,ALPHA_PASS,TEXTURE_2D")) { return brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "brush_image ADVANCED_BLEND,ALPHA_PASS,TEXTURE_RECT")) { return brush_image_ADVANCED_BLEND_ALPHA_PASS_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "brush_image ALPHA_PASS,ANTIALIASING,DUAL_SOURCE_BLENDING,REPETITION,TEXTURE_2D")) { return brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "brush_image ALPHA_PASS,ANTIALIASING,DUAL_SOURCE_BLENDING,REPETITION,TEXTURE_RECT")) { return brush_image_ALPHA_PASS_ANTIALIASING_DUAL_SOURCE_BLENDING_REPETITION_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "brush_image ALPHA_PASS,ANTIALIASING,REPETITION,TEXTURE_2D")) { return brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "brush_image ALPHA_PASS,ANTIALIASING,REPETITION,TEXTURE_RECT")) { return brush_image_ALPHA_PASS_ANTIALIASING_REPETITION_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "brush_image ALPHA_PASS,DUAL_SOURCE_BLENDING,TEXTURE_2D")) { return brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "brush_image ALPHA_PASS,DUAL_SOURCE_BLENDING,TEXTURE_RECT")) { return brush_image_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "brush_image ALPHA_PASS,TEXTURE_2D")) { return brush_image_ALPHA_PASS_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "brush_image ALPHA_PASS,TEXTURE_RECT")) { return brush_image_ALPHA_PASS_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "brush_image ANTIALIASING,DEBUG_OVERDRAW,REPETITION,TEXTURE_2D")) { return brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "brush_image ANTIALIASING,DEBUG_OVERDRAW,REPETITION,TEXTURE_RECT")) { return brush_image_ANTIALIASING_DEBUG_OVERDRAW_REPETITION_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "brush_image ANTIALIASING,REPETITION,TEXTURE_2D")) { return brush_image_ANTIALIASING_REPETITION_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "brush_image ANTIALIASING,REPETITION,TEXTURE_RECT")) { return brush_image_ANTIALIASING_REPETITION_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "brush_image DEBUG_OVERDRAW,TEXTURE_2D")) { return brush_image_DEBUG_OVERDRAW_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "brush_image DEBUG_OVERDRAW,TEXTURE_RECT")) { return brush_image_DEBUG_OVERDRAW_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "brush_image TEXTURE_2D")) { return brush_image_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "brush_image TEXTURE_RECT")) { return brush_image_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "brush_linear_gradient")) { return brush_linear_gradient_program::loader; }
  if (!strcmp(name, "brush_linear_gradient ALPHA_PASS")) { return brush_linear_gradient_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_linear_gradient DEBUG_OVERDRAW")) { return brush_linear_gradient_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_mix_blend")) { return brush_mix_blend_program::loader; }
  if (!strcmp(name, "brush_mix_blend ALPHA_PASS")) { return brush_mix_blend_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_mix_blend DEBUG_OVERDRAW")) { return brush_mix_blend_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_opacity")) { return brush_opacity_program::loader; }
  if (!strcmp(name, "brush_opacity ALPHA_PASS")) { return brush_opacity_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_opacity ALPHA_PASS,ANTIALIASING")) { return brush_opacity_ALPHA_PASS_ANTIALIASING_program::loader; }
  if (!strcmp(name, "brush_opacity ANTIALIASING")) { return brush_opacity_ANTIALIASING_program::loader; }
  if (!strcmp(name, "brush_opacity ANTIALIASING,DEBUG_OVERDRAW")) { return brush_opacity_ANTIALIASING_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_opacity DEBUG_OVERDRAW")) { return brush_opacity_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_solid")) { return brush_solid_program::loader; }
  if (!strcmp(name, "brush_solid ALPHA_PASS")) { return brush_solid_ALPHA_PASS_program::loader; }
  if (!strcmp(name, "brush_solid DEBUG_OVERDRAW")) { return brush_solid_DEBUG_OVERDRAW_program::loader; }
  if (!strcmp(name, "brush_yuv_image ALPHA_PASS,TEXTURE_2D,YUV")) { return brush_yuv_image_ALPHA_PASS_TEXTURE_2D_YUV_program::loader; }
  if (!strcmp(name, "brush_yuv_image ALPHA_PASS,TEXTURE_RECT,YUV")) { return brush_yuv_image_ALPHA_PASS_TEXTURE_RECT_YUV_program::loader; }
  if (!strcmp(name, "brush_yuv_image DEBUG_OVERDRAW,TEXTURE_2D,YUV")) { return brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_2D_YUV_program::loader; }
  if (!strcmp(name, "brush_yuv_image DEBUG_OVERDRAW,TEXTURE_RECT,YUV")) { return brush_yuv_image_DEBUG_OVERDRAW_TEXTURE_RECT_YUV_program::loader; }
  if (!strcmp(name, "brush_yuv_image TEXTURE_2D,YUV")) { return brush_yuv_image_TEXTURE_2D_YUV_program::loader; }
  if (!strcmp(name, "brush_yuv_image TEXTURE_RECT,YUV")) { return brush_yuv_image_TEXTURE_RECT_YUV_program::loader; }
  if (!strcmp(name, "composite FAST_PATH,TEXTURE_2D")) { return composite_FAST_PATH_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "composite FAST_PATH,TEXTURE_RECT")) { return composite_FAST_PATH_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "composite TEXTURE_2D")) { return composite_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "composite TEXTURE_2D,YUV")) { return composite_TEXTURE_2D_YUV_program::loader; }
  if (!strcmp(name, "composite TEXTURE_RECT")) { return composite_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "composite TEXTURE_RECT,YUV")) { return composite_TEXTURE_RECT_YUV_program::loader; }
  if (!strcmp(name, "cs_blur ALPHA_TARGET")) { return cs_blur_ALPHA_TARGET_program::loader; }
  if (!strcmp(name, "cs_blur COLOR_TARGET")) { return cs_blur_COLOR_TARGET_program::loader; }
  if (!strcmp(name, "cs_border_segment")) { return cs_border_segment_program::loader; }
  if (!strcmp(name, "cs_border_solid")) { return cs_border_solid_program::loader; }
  if (!strcmp(name, "cs_clip_box_shadow TEXTURE_2D")) { return cs_clip_box_shadow_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "cs_clip_image TEXTURE_2D")) { return cs_clip_image_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "cs_clip_rectangle")) { return cs_clip_rectangle_program::loader; }
  if (!strcmp(name, "cs_clip_rectangle FAST_PATH")) { return cs_clip_rectangle_FAST_PATH_program::loader; }
  if (!strcmp(name, "cs_conic_gradient")) { return cs_conic_gradient_program::loader; }
  if (!strcmp(name, "cs_fast_linear_gradient")) { return cs_fast_linear_gradient_program::loader; }
  if (!strcmp(name, "cs_line_decoration")) { return cs_line_decoration_program::loader; }
  if (!strcmp(name, "cs_linear_gradient")) { return cs_linear_gradient_program::loader; }
  if (!strcmp(name, "cs_radial_gradient")) { return cs_radial_gradient_program::loader; }
  if (!strcmp(name, "cs_scale TEXTURE_2D")) { return cs_scale_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "cs_scale TEXTURE_RECT")) { return cs_scale_TEXTURE_RECT_program::loader; }
  if (!strcmp(name, "cs_svg_filter")) { return cs_svg_filter_program::loader; }
  if (!strcmp(name, "debug_color")) { return debug_color_program::loader; }
  if (!strcmp(name, "debug_font")) { return debug_font_program::loader; }
  if (!strcmp(name, "ps_clear")) { return ps_clear_program::loader; }
  if (!strcmp(name, "ps_copy")) { return ps_copy_program::loader; }
  if (!strcmp(name, "ps_split_composite")) { return ps_split_composite_program::loader; }
  if (!strcmp(name, "ps_text_run ALPHA_PASS,DUAL_SOURCE_BLENDING,GLYPH_TRANSFORM,TEXTURE_2D")) { return ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_GLYPH_TRANSFORM_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "ps_text_run ALPHA_PASS,DUAL_SOURCE_BLENDING,TEXTURE_2D")) { return ps_text_run_ALPHA_PASS_DUAL_SOURCE_BLENDING_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "ps_text_run ALPHA_PASS,GLYPH_TRANSFORM,TEXTURE_2D")) { return ps_text_run_ALPHA_PASS_GLYPH_TRANSFORM_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "ps_text_run ALPHA_PASS,TEXTURE_2D")) { return ps_text_run_ALPHA_PASS_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "ps_text_run DEBUG_OVERDRAW,DUAL_SOURCE_BLENDING,TEXTURE_2D")) { return ps_text_run_DEBUG_OVERDRAW_DUAL_SOURCE_BLENDING_TEXTURE_2D_program::loader; }
  if (!strcmp(name, "ps_text_run DEBUG_OVERDRAW,TEXTURE_2D")) { return ps_text_run_DEBUG_OVERDRAW_TEXTURE_2D_program::loader; }
  return nullptr;
}
