/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/. */

// `data` comes from components/style/properties.mako.rs; see build.rs for more details.




use crate::Atom;
use app_units::Au;
use crate::computed_value_flags::*;
use crate::custom_properties::CustomPropertiesMap;
use crate::gecko_bindings::bindings;
use crate::gecko_bindings::structs::nsStyleBackground;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleBackground;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleBackground;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleBackground;
use crate::gecko_bindings::structs::nsStyleBorder;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleBorder;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleBorder;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleBorder;
use crate::gecko_bindings::structs::nsStyleDisplay;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleDisplay;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleDisplay;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleDisplay;
use crate::gecko_bindings::structs::nsStyleColumn;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleColumn;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleColumn;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleColumn;
use crate::gecko_bindings::structs::nsStyleContent;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleContent;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleContent;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleContent;
use crate::gecko_bindings::structs::nsStyleEffects;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleEffects;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleEffects;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleEffects;
use crate::gecko_bindings::structs::nsStyleFont;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleFont;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleFont;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleFont;
use crate::gecko_bindings::structs::nsStyleVisibility;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleVisibility;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleVisibility;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleVisibility;
use crate::gecko_bindings::structs::nsStyleSVG;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleSVG;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleSVG;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleSVG;
use crate::gecko_bindings::structs::nsStyleTableBorder;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleTableBorder;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleTableBorder;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleTableBorder;
use crate::gecko_bindings::structs::nsStyleText;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleText;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleText;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleText;
use crate::gecko_bindings::structs::nsStyleUI;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleUI;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleUI;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleUI;
use crate::gecko_bindings::structs::nsStyleList;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleList;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleList;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleList;
use crate::gecko_bindings::structs::nsStyleMargin;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleMargin;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleMargin;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleMargin;
use crate::gecko_bindings::structs::nsStyleOutline;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleOutline;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleOutline;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleOutline;
use crate::gecko_bindings::structs::nsStylePage;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStylePage;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStylePage;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStylePage;
use crate::gecko_bindings::structs::nsStylePadding;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStylePadding;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStylePadding;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStylePadding;
use crate::gecko_bindings::structs::nsStylePosition;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStylePosition;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStylePosition;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStylePosition;
use crate::gecko_bindings::structs::nsStyleSVGReset;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleSVGReset;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleSVGReset;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleSVGReset;
use crate::gecko_bindings::structs::nsStyleTable;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleTable;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleTable;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleTable;
use crate::gecko_bindings::structs::nsStyleTextReset;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleTextReset;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleTextReset;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleTextReset;
use crate::gecko_bindings::structs::nsStyleUIReset;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleUIReset;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleUIReset;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleUIReset;
use crate::gecko_bindings::structs::nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_Construct_Default_nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_CopyConstruct_nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_Destroy_nsStyleXUL;
use crate::gecko_bindings::bindings::Gecko_CopyCounterStyle;
use crate::gecko_bindings::bindings::Gecko_EnsureImageLayersLength;
use crate::gecko_bindings::bindings::Gecko_nsStyleFont_SetLang;
use crate::gecko_bindings::bindings::Gecko_nsStyleFont_CopyLangFrom;
use crate::gecko_bindings::structs;
use crate::gecko_bindings::structs::nsCSSPropertyID;
use crate::gecko_bindings::structs::mozilla::PseudoStyleType;
use crate::gecko::data::PerDocumentStyleData;
use crate::gecko::values::round_border_to_device_pixels;
use crate::logical_geometry::WritingMode;
use crate::media_queries::Device;
use crate::properties::longhands;
use crate::rule_tree::StrongRuleNode;
use crate::selector_parser::PseudoElement;
use servo_arc::{Arc, RawOffsetArc, UniqueArc};
use std::mem::{forget, MaybeUninit};
use std::{cmp, ops, ptr};
use crate::values::{self, CustomIdent, Either, KeyframesName, None_};
use crate::values::computed::{Percentage, TransitionProperty};
use crate::values::computed::BorderStyle;
use crate::values::computed::font::FontSize;
use crate::values::generics::column::ColumnCount;


pub mod style_structs {
    pub use super::GeckoBackground as Background;

    unsafe impl Send for Background {}
    unsafe impl Sync for Background {}
    pub use super::GeckoBorder as Border;

    unsafe impl Send for Border {}
    unsafe impl Sync for Border {}
    pub use super::GeckoBox as Box;

    unsafe impl Send for Box {}
    unsafe impl Sync for Box {}
    pub use super::GeckoColumn as Column;

    unsafe impl Send for Column {}
    unsafe impl Sync for Column {}
    pub use super::GeckoCounters as Counters;

    unsafe impl Send for Counters {}
    unsafe impl Sync for Counters {}
    pub use super::GeckoEffects as Effects;

    unsafe impl Send for Effects {}
    unsafe impl Sync for Effects {}
    pub use super::GeckoFont as Font;

    unsafe impl Send for Font {}
    unsafe impl Sync for Font {}
    pub use super::GeckoInheritedBox as InheritedBox;

    unsafe impl Send for InheritedBox {}
    unsafe impl Sync for InheritedBox {}
    pub use super::GeckoInheritedSVG as InheritedSVG;

    unsafe impl Send for InheritedSVG {}
    unsafe impl Sync for InheritedSVG {}
    pub use super::GeckoInheritedTable as InheritedTable;

    unsafe impl Send for InheritedTable {}
    unsafe impl Sync for InheritedTable {}
    pub use super::GeckoInheritedText as InheritedText;

    unsafe impl Send for InheritedText {}
    unsafe impl Sync for InheritedText {}
    pub use super::GeckoInheritedUI as InheritedUI;

    unsafe impl Send for InheritedUI {}
    unsafe impl Sync for InheritedUI {}
    pub use super::GeckoList as List;

    unsafe impl Send for List {}
    unsafe impl Sync for List {}
    pub use super::GeckoMargin as Margin;

    unsafe impl Send for Margin {}
    unsafe impl Sync for Margin {}
    pub use super::GeckoOutline as Outline;

    unsafe impl Send for Outline {}
    unsafe impl Sync for Outline {}
    pub use super::GeckoPage as Page;

    unsafe impl Send for Page {}
    unsafe impl Sync for Page {}
    pub use super::GeckoPadding as Padding;

    unsafe impl Send for Padding {}
    unsafe impl Sync for Padding {}
    pub use super::GeckoPosition as Position;

    unsafe impl Send for Position {}
    unsafe impl Sync for Position {}
    pub use super::GeckoSVG as SVG;

    unsafe impl Send for SVG {}
    unsafe impl Sync for SVG {}
    pub use super::GeckoTable as Table;

    unsafe impl Send for Table {}
    unsafe impl Sync for Table {}
    pub use super::GeckoText as Text;

    unsafe impl Send for Text {}
    unsafe impl Sync for Text {}
    pub use super::GeckoUI as UI;

    unsafe impl Send for UI {}
    unsafe impl Sync for UI {}
    pub use super::GeckoXUL as XUL;

    unsafe impl Send for XUL {}
    unsafe impl Sync for XUL {}

}

/// FIXME(emilio): This is completely duplicated with the other properties code.
pub type ComputedValuesInner = structs::ServoComputedData;

#[repr(C)]
pub struct ComputedValues(structs::mozilla::ComputedStyle);

impl ComputedValues {
    #[inline]
    pub (crate) fn as_gecko_computed_style(&self) -> &structs::ComputedStyle {
        &self.0
    }

    pub fn new(
        pseudo: Option<&PseudoElement>,
        custom_properties: Option<Arc<CustomPropertiesMap>>,
        writing_mode: WritingMode,
        flags: ComputedValueFlags,
        rules: Option<StrongRuleNode>,
        visited_style: Option<Arc<ComputedValues>>,
        background: Arc<style_structs::Background>,
        border: Arc<style_structs::Border>,
        box_: Arc<style_structs::Box>,
        column: Arc<style_structs::Column>,
        counters: Arc<style_structs::Counters>,
        effects: Arc<style_structs::Effects>,
        font: Arc<style_structs::Font>,
        inherited_box: Arc<style_structs::InheritedBox>,
        inherited_svg: Arc<style_structs::InheritedSVG>,
        inherited_table: Arc<style_structs::InheritedTable>,
        inherited_text: Arc<style_structs::InheritedText>,
        inherited_ui: Arc<style_structs::InheritedUI>,
        list: Arc<style_structs::List>,
        margin: Arc<style_structs::Margin>,
        outline: Arc<style_structs::Outline>,
        page: Arc<style_structs::Page>,
        padding: Arc<style_structs::Padding>,
        position: Arc<style_structs::Position>,
        svg: Arc<style_structs::SVG>,
        table: Arc<style_structs::Table>,
        text: Arc<style_structs::Text>,
        ui: Arc<style_structs::UI>,
        xul: Arc<style_structs::XUL>,
    ) -> Arc<Self> {
        ComputedValuesInner::new(
            custom_properties,
            writing_mode,
            flags,
            rules,
            visited_style,
            background,
            border,
            box_,
            column,
            counters,
            effects,
            font,
            inherited_box,
            inherited_svg,
            inherited_table,
            inherited_text,
            inherited_ui,
            list,
            margin,
            outline,
            page,
            padding,
            position,
            svg,
            table,
            text,
            ui,
            xul,
        ).to_outer(pseudo)
    }

    pub fn default_values(doc: &structs::Document) -> Arc<Self> {
        ComputedValuesInner::new(
            /* custom_properties = */ None,
            /* writing_mode = */ WritingMode::empty(), // FIXME(bz): This seems dubious
            ComputedValueFlags::empty(),
            /* rules = */ None,
            /* visited_style = */ None,
            style_structs::Background::default(doc),
            style_structs::Border::default(doc),
            style_structs::Box::default(doc),
            style_structs::Column::default(doc),
            style_structs::Counters::default(doc),
            style_structs::Effects::default(doc),
            style_structs::Font::default(doc),
            style_structs::InheritedBox::default(doc),
            style_structs::InheritedSVG::default(doc),
            style_structs::InheritedTable::default(doc),
            style_structs::InheritedText::default(doc),
            style_structs::InheritedUI::default(doc),
            style_structs::List::default(doc),
            style_structs::Margin::default(doc),
            style_structs::Outline::default(doc),
            style_structs::Page::default(doc),
            style_structs::Padding::default(doc),
            style_structs::Position::default(doc),
            style_structs::SVG::default(doc),
            style_structs::Table::default(doc),
            style_structs::Text::default(doc),
            style_structs::UI::default(doc),
            style_structs::XUL::default(doc),
        ).to_outer(None)
    }

    #[inline]
    pub fn is_pseudo_style(&self) -> bool {
        self.0.mPseudoType != PseudoStyleType::NotPseudo
    }

    #[inline]
    pub fn pseudo(&self) -> Option<PseudoElement> {
        if !self.is_pseudo_style() {
            return None;
        }
        PseudoElement::from_pseudo_type(self.0.mPseudoType)
    }

    #[inline]
    pub fn is_first_line_style(&self) -> bool {
        self.pseudo() == Some(PseudoElement::FirstLine)
    }

    /// Returns true if the display property is changed from 'none' to others.
    pub fn is_display_property_changed_from_none(
        &self,
        old_values: Option<&ComputedValues>
    ) -> bool {
        use crate::properties::longhands::display::computed_value::T as Display;

        old_values.map_or(false, |old| {
            let old_display_style = old.get_box().clone_display();
            let new_display_style = self.get_box().clone_display();
            old_display_style == Display::None &&
            new_display_style != Display::None
        })
    }

}

impl Drop for ComputedValues {
    fn drop(&mut self) {
        unsafe {
            bindings::Gecko_ComputedStyle_Destroy(&mut self.0);
        }
    }
}

unsafe impl Sync for ComputedValues {}
unsafe impl Send for ComputedValues {}

impl Clone for ComputedValues {
    fn clone(&self) -> Self {
        unreachable!()
    }
}

impl Clone for ComputedValuesInner {
    fn clone(&self) -> Self {
        ComputedValuesInner {
                Background: self.Background.clone(),
                Border: self.Border.clone(),
                Display: self.Display.clone(),
                Column: self.Column.clone(),
                Content: self.Content.clone(),
                Effects: self.Effects.clone(),
                Font: self.Font.clone(),
                Visibility: self.Visibility.clone(),
                SVG: self.SVG.clone(),
                TableBorder: self.TableBorder.clone(),
                Text: self.Text.clone(),
                UI: self.UI.clone(),
                List: self.List.clone(),
                Margin: self.Margin.clone(),
                Outline: self.Outline.clone(),
                Page: self.Page.clone(),
                Padding: self.Padding.clone(),
                Position: self.Position.clone(),
                SVGReset: self.SVGReset.clone(),
                Table: self.Table.clone(),
                TextReset: self.TextReset.clone(),
                UIReset: self.UIReset.clone(),
                XUL: self.XUL.clone(),
            custom_properties: self.custom_properties.clone(),
            writing_mode: self.writing_mode.clone(),
            flags: self.flags.clone(),
            rules: self.rules.clone(),
            visited_style: self.visited_style.clone(),
        }
    }
}

impl ComputedValuesInner {
    pub fn new(
        custom_properties: Option<Arc<CustomPropertiesMap>>,
        writing_mode: WritingMode,
        flags: ComputedValueFlags,
        rules: Option<StrongRuleNode>,
        visited_style: Option<Arc<ComputedValues>>,
        background: Arc<style_structs::Background>,
        border: Arc<style_structs::Border>,
        box_: Arc<style_structs::Box>,
        column: Arc<style_structs::Column>,
        counters: Arc<style_structs::Counters>,
        effects: Arc<style_structs::Effects>,
        font: Arc<style_structs::Font>,
        inherited_box: Arc<style_structs::InheritedBox>,
        inherited_svg: Arc<style_structs::InheritedSVG>,
        inherited_table: Arc<style_structs::InheritedTable>,
        inherited_text: Arc<style_structs::InheritedText>,
        inherited_ui: Arc<style_structs::InheritedUI>,
        list: Arc<style_structs::List>,
        margin: Arc<style_structs::Margin>,
        outline: Arc<style_structs::Outline>,
        page: Arc<style_structs::Page>,
        padding: Arc<style_structs::Padding>,
        position: Arc<style_structs::Position>,
        svg: Arc<style_structs::SVG>,
        table: Arc<style_structs::Table>,
        text: Arc<style_structs::Text>,
        ui: Arc<style_structs::UI>,
        xul: Arc<style_structs::XUL>,
    ) -> Self {
        Self {
            custom_properties,
            writing_mode,
            rules,
            visited_style: visited_style.map(Arc::into_raw_offset),
            flags,
            Background: Arc::into_raw_offset(background),
            Border: Arc::into_raw_offset(border),
            Display: Arc::into_raw_offset(box_),
            Column: Arc::into_raw_offset(column),
            Content: Arc::into_raw_offset(counters),
            Effects: Arc::into_raw_offset(effects),
            Font: Arc::into_raw_offset(font),
            Visibility: Arc::into_raw_offset(inherited_box),
            SVG: Arc::into_raw_offset(inherited_svg),
            TableBorder: Arc::into_raw_offset(inherited_table),
            Text: Arc::into_raw_offset(inherited_text),
            UI: Arc::into_raw_offset(inherited_ui),
            List: Arc::into_raw_offset(list),
            Margin: Arc::into_raw_offset(margin),
            Outline: Arc::into_raw_offset(outline),
            Page: Arc::into_raw_offset(page),
            Padding: Arc::into_raw_offset(padding),
            Position: Arc::into_raw_offset(position),
            SVGReset: Arc::into_raw_offset(svg),
            Table: Arc::into_raw_offset(table),
            TextReset: Arc::into_raw_offset(text),
            UIReset: Arc::into_raw_offset(ui),
            XUL: Arc::into_raw_offset(xul),
        }
    }

    fn to_outer(
        self,
        pseudo: Option<&PseudoElement>,
    ) -> Arc<ComputedValues> {
        let pseudo_ty = match pseudo {
            Some(p) => p.pseudo_type(),
            None => structs::PseudoStyleType::NotPseudo,
        };
        unsafe {
            let mut arc = UniqueArc::<ComputedValues>::new_uninit();
            bindings::Gecko_ComputedStyle_Init(
                arc.as_mut_ptr() as *mut _,
                &self,
                pseudo_ty,
            );
            // We're simulating move semantics by having C++ do a memcpy and then forgetting
            // it on this end.
            forget(self);
            UniqueArc::assume_init(arc).shareable()
        }
    }
}

impl ops::Deref for ComputedValues {
    type Target = ComputedValuesInner;
    fn deref(&self) -> &ComputedValuesInner {
        &self.0.mSource
    }
}

impl ops::DerefMut for ComputedValues {
    fn deref_mut(&mut self) -> &mut ComputedValuesInner {
        &mut self.0.mSource
    }
}

impl ComputedValuesInner {
    /// Returns true if the value of the `content` property would make a
    /// pseudo-element not rendered.
    #[inline]
    pub fn ineffective_content_property(&self) -> bool {
        self.get_counters().ineffective_content_property()
    }

    #[inline]
    pub fn clone_background(&self) -> Arc<style_structs::Background> {
        Arc::from_raw_offset(self.Background.clone())
    }
    #[inline]
    pub fn get_background(&self) -> &style_structs::Background {
        &self.Background
    }


    pub fn background_arc(&self) -> &RawOffsetArc<style_structs::Background> {
        &self.Background
    }

    #[inline]
    pub fn mutate_background(&mut self) -> &mut style_structs::Background {
        RawOffsetArc::make_mut(&mut self.Background)
    }
    #[inline]
    pub fn clone_border(&self) -> Arc<style_structs::Border> {
        Arc::from_raw_offset(self.Border.clone())
    }
    #[inline]
    pub fn get_border(&self) -> &style_structs::Border {
        &self.Border
    }


    pub fn border_arc(&self) -> &RawOffsetArc<style_structs::Border> {
        &self.Border
    }

    #[inline]
    pub fn mutate_border(&mut self) -> &mut style_structs::Border {
        RawOffsetArc::make_mut(&mut self.Border)
    }
    #[inline]
    pub fn clone_box(&self) -> Arc<style_structs::Box> {
        Arc::from_raw_offset(self.Display.clone())
    }
    #[inline]
    pub fn get_box(&self) -> &style_structs::Box {
        &self.Display
    }


    pub fn box_arc(&self) -> &RawOffsetArc<style_structs::Box> {
        &self.Display
    }

    #[inline]
    pub fn mutate_box(&mut self) -> &mut style_structs::Box {
        RawOffsetArc::make_mut(&mut self.Display)
    }
    #[inline]
    pub fn clone_column(&self) -> Arc<style_structs::Column> {
        Arc::from_raw_offset(self.Column.clone())
    }
    #[inline]
    pub fn get_column(&self) -> &style_structs::Column {
        &self.Column
    }


    pub fn column_arc(&self) -> &RawOffsetArc<style_structs::Column> {
        &self.Column
    }

    #[inline]
    pub fn mutate_column(&mut self) -> &mut style_structs::Column {
        RawOffsetArc::make_mut(&mut self.Column)
    }
    #[inline]
    pub fn clone_counters(&self) -> Arc<style_structs::Counters> {
        Arc::from_raw_offset(self.Content.clone())
    }
    #[inline]
    pub fn get_counters(&self) -> &style_structs::Counters {
        &self.Content
    }


    pub fn counters_arc(&self) -> &RawOffsetArc<style_structs::Counters> {
        &self.Content
    }

    #[inline]
    pub fn mutate_counters(&mut self) -> &mut style_structs::Counters {
        RawOffsetArc::make_mut(&mut self.Content)
    }
    #[inline]
    pub fn clone_effects(&self) -> Arc<style_structs::Effects> {
        Arc::from_raw_offset(self.Effects.clone())
    }
    #[inline]
    pub fn get_effects(&self) -> &style_structs::Effects {
        &self.Effects
    }


    pub fn effects_arc(&self) -> &RawOffsetArc<style_structs::Effects> {
        &self.Effects
    }

    #[inline]
    pub fn mutate_effects(&mut self) -> &mut style_structs::Effects {
        RawOffsetArc::make_mut(&mut self.Effects)
    }
    #[inline]
    pub fn clone_font(&self) -> Arc<style_structs::Font> {
        Arc::from_raw_offset(self.Font.clone())
    }
    #[inline]
    pub fn get_font(&self) -> &style_structs::Font {
        &self.Font
    }


    pub fn font_arc(&self) -> &RawOffsetArc<style_structs::Font> {
        &self.Font
    }

    #[inline]
    pub fn mutate_font(&mut self) -> &mut style_structs::Font {
        RawOffsetArc::make_mut(&mut self.Font)
    }
    #[inline]
    pub fn clone_inherited_box(&self) -> Arc<style_structs::InheritedBox> {
        Arc::from_raw_offset(self.Visibility.clone())
    }
    #[inline]
    pub fn get_inherited_box(&self) -> &style_structs::InheritedBox {
        &self.Visibility
    }


    pub fn inherited_box_arc(&self) -> &RawOffsetArc<style_structs::InheritedBox> {
        &self.Visibility
    }

    #[inline]
    pub fn mutate_inherited_box(&mut self) -> &mut style_structs::InheritedBox {
        RawOffsetArc::make_mut(&mut self.Visibility)
    }
    #[inline]
    pub fn clone_inherited_svg(&self) -> Arc<style_structs::InheritedSVG> {
        Arc::from_raw_offset(self.SVG.clone())
    }
    #[inline]
    pub fn get_inherited_svg(&self) -> &style_structs::InheritedSVG {
        &self.SVG
    }


    pub fn inherited_svg_arc(&self) -> &RawOffsetArc<style_structs::InheritedSVG> {
        &self.SVG
    }

    #[inline]
    pub fn mutate_inherited_svg(&mut self) -> &mut style_structs::InheritedSVG {
        RawOffsetArc::make_mut(&mut self.SVG)
    }
    #[inline]
    pub fn clone_inherited_table(&self) -> Arc<style_structs::InheritedTable> {
        Arc::from_raw_offset(self.TableBorder.clone())
    }
    #[inline]
    pub fn get_inherited_table(&self) -> &style_structs::InheritedTable {
        &self.TableBorder
    }


    pub fn inherited_table_arc(&self) -> &RawOffsetArc<style_structs::InheritedTable> {
        &self.TableBorder
    }

    #[inline]
    pub fn mutate_inherited_table(&mut self) -> &mut style_structs::InheritedTable {
        RawOffsetArc::make_mut(&mut self.TableBorder)
    }
    #[inline]
    pub fn clone_inherited_text(&self) -> Arc<style_structs::InheritedText> {
        Arc::from_raw_offset(self.Text.clone())
    }
    #[inline]
    pub fn get_inherited_text(&self) -> &style_structs::InheritedText {
        &self.Text
    }


    pub fn inherited_text_arc(&self) -> &RawOffsetArc<style_structs::InheritedText> {
        &self.Text
    }

    #[inline]
    pub fn mutate_inherited_text(&mut self) -> &mut style_structs::InheritedText {
        RawOffsetArc::make_mut(&mut self.Text)
    }
    #[inline]
    pub fn clone_inherited_ui(&self) -> Arc<style_structs::InheritedUI> {
        Arc::from_raw_offset(self.UI.clone())
    }
    #[inline]
    pub fn get_inherited_ui(&self) -> &style_structs::InheritedUI {
        &self.UI
    }


    pub fn inherited_ui_arc(&self) -> &RawOffsetArc<style_structs::InheritedUI> {
        &self.UI
    }

    #[inline]
    pub fn mutate_inherited_ui(&mut self) -> &mut style_structs::InheritedUI {
        RawOffsetArc::make_mut(&mut self.UI)
    }
    #[inline]
    pub fn clone_list(&self) -> Arc<style_structs::List> {
        Arc::from_raw_offset(self.List.clone())
    }
    #[inline]
    pub fn get_list(&self) -> &style_structs::List {
        &self.List
    }


    pub fn list_arc(&self) -> &RawOffsetArc<style_structs::List> {
        &self.List
    }

    #[inline]
    pub fn mutate_list(&mut self) -> &mut style_structs::List {
        RawOffsetArc::make_mut(&mut self.List)
    }
    #[inline]
    pub fn clone_margin(&self) -> Arc<style_structs::Margin> {
        Arc::from_raw_offset(self.Margin.clone())
    }
    #[inline]
    pub fn get_margin(&self) -> &style_structs::Margin {
        &self.Margin
    }


    pub fn margin_arc(&self) -> &RawOffsetArc<style_structs::Margin> {
        &self.Margin
    }

    #[inline]
    pub fn mutate_margin(&mut self) -> &mut style_structs::Margin {
        RawOffsetArc::make_mut(&mut self.Margin)
    }
    #[inline]
    pub fn clone_outline(&self) -> Arc<style_structs::Outline> {
        Arc::from_raw_offset(self.Outline.clone())
    }
    #[inline]
    pub fn get_outline(&self) -> &style_structs::Outline {
        &self.Outline
    }


    pub fn outline_arc(&self) -> &RawOffsetArc<style_structs::Outline> {
        &self.Outline
    }

    #[inline]
    pub fn mutate_outline(&mut self) -> &mut style_structs::Outline {
        RawOffsetArc::make_mut(&mut self.Outline)
    }
    #[inline]
    pub fn clone_page(&self) -> Arc<style_structs::Page> {
        Arc::from_raw_offset(self.Page.clone())
    }
    #[inline]
    pub fn get_page(&self) -> &style_structs::Page {
        &self.Page
    }


    pub fn page_arc(&self) -> &RawOffsetArc<style_structs::Page> {
        &self.Page
    }

    #[inline]
    pub fn mutate_page(&mut self) -> &mut style_structs::Page {
        RawOffsetArc::make_mut(&mut self.Page)
    }
    #[inline]
    pub fn clone_padding(&self) -> Arc<style_structs::Padding> {
        Arc::from_raw_offset(self.Padding.clone())
    }
    #[inline]
    pub fn get_padding(&self) -> &style_structs::Padding {
        &self.Padding
    }


    pub fn padding_arc(&self) -> &RawOffsetArc<style_structs::Padding> {
        &self.Padding
    }

    #[inline]
    pub fn mutate_padding(&mut self) -> &mut style_structs::Padding {
        RawOffsetArc::make_mut(&mut self.Padding)
    }
    #[inline]
    pub fn clone_position(&self) -> Arc<style_structs::Position> {
        Arc::from_raw_offset(self.Position.clone())
    }
    #[inline]
    pub fn get_position(&self) -> &style_structs::Position {
        &self.Position
    }


    pub fn position_arc(&self) -> &RawOffsetArc<style_structs::Position> {
        &self.Position
    }

    #[inline]
    pub fn mutate_position(&mut self) -> &mut style_structs::Position {
        RawOffsetArc::make_mut(&mut self.Position)
    }
    #[inline]
    pub fn clone_svg(&self) -> Arc<style_structs::SVG> {
        Arc::from_raw_offset(self.SVGReset.clone())
    }
    #[inline]
    pub fn get_svg(&self) -> &style_structs::SVG {
        &self.SVGReset
    }


    pub fn svg_arc(&self) -> &RawOffsetArc<style_structs::SVG> {
        &self.SVGReset
    }

    #[inline]
    pub fn mutate_svg(&mut self) -> &mut style_structs::SVG {
        RawOffsetArc::make_mut(&mut self.SVGReset)
    }
    #[inline]
    pub fn clone_table(&self) -> Arc<style_structs::Table> {
        Arc::from_raw_offset(self.Table.clone())
    }
    #[inline]
    pub fn get_table(&self) -> &style_structs::Table {
        &self.Table
    }


    pub fn table_arc(&self) -> &RawOffsetArc<style_structs::Table> {
        &self.Table
    }

    #[inline]
    pub fn mutate_table(&mut self) -> &mut style_structs::Table {
        RawOffsetArc::make_mut(&mut self.Table)
    }
    #[inline]
    pub fn clone_text(&self) -> Arc<style_structs::Text> {
        Arc::from_raw_offset(self.TextReset.clone())
    }
    #[inline]
    pub fn get_text(&self) -> &style_structs::Text {
        &self.TextReset
    }


    pub fn text_arc(&self) -> &RawOffsetArc<style_structs::Text> {
        &self.TextReset
    }

    #[inline]
    pub fn mutate_text(&mut self) -> &mut style_structs::Text {
        RawOffsetArc::make_mut(&mut self.TextReset)
    }
    #[inline]
    pub fn clone_ui(&self) -> Arc<style_structs::UI> {
        Arc::from_raw_offset(self.UIReset.clone())
    }
    #[inline]
    pub fn get_ui(&self) -> &style_structs::UI {
        &self.UIReset
    }


    pub fn ui_arc(&self) -> &RawOffsetArc<style_structs::UI> {
        &self.UIReset
    }

    #[inline]
    pub fn mutate_ui(&mut self) -> &mut style_structs::UI {
        RawOffsetArc::make_mut(&mut self.UIReset)
    }
    #[inline]
    pub fn clone_xul(&self) -> Arc<style_structs::XUL> {
        Arc::from_raw_offset(self.XUL.clone())
    }
    #[inline]
    pub fn get_xul(&self) -> &style_structs::XUL {
        &self.XUL
    }


    pub fn xul_arc(&self) -> &RawOffsetArc<style_structs::XUL> {
        &self.XUL
    }

    #[inline]
    pub fn mutate_xul(&mut self) -> &mut style_structs::XUL {
        RawOffsetArc::make_mut(&mut self.XUL)
    }

    /// Gets the raw visited style. Useful for memory reporting.
    pub fn get_raw_visited_style(&self) -> &Option<RawOffsetArc<ComputedValues>> {
        &self.visited_style
    }
}







































#[allow(dead_code)]
fn static_assert() {
    // Note: using the above technique with an enum hits a rust bug when |structs| is in a different crate.
    { const DETAIL: u32 = [0][(structs::Side::eSideTop as usize != 0) as usize]; let _ = DETAIL; }
    { const DETAIL: u32 = [0][(structs::Side::eSideRight as usize != 1) as usize]; let _ = DETAIL; }
    { const DETAIL: u32 = [0][(structs::Side::eSideBottom as usize != 2) as usize]; let _ = DETAIL; }
    { const DETAIL: u32 = [0][(structs::Side::eSideLeft as usize != 3) as usize]; let _ = DETAIL; }
}






impl GeckoBorder {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_border_top_style(&mut self, v: BorderStyle) {
        self.gecko.mBorderStyle[0] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.gecko.mComputedBorder.top = self.gecko.mBorder.top;
    }

    pub fn copy_border_top_style_from(&mut self, other: &Self) {
        self.gecko.mBorderStyle[0] = other.gecko.mBorderStyle[0];
        self.gecko.mComputedBorder.top = self.gecko.mBorder.top;
    }

    pub fn reset_border_top_style(&mut self, other: &Self) {
        self.copy_border_top_style_from(other);
    }

    #[inline]
    pub fn clone_border_top_style(&self) -> BorderStyle {
        self.gecko.mBorderStyle[0]
    }

    

    #[allow(non_snake_case)]
    pub fn set_border_top_color(&mut self, v: longhands::border_top_color::computed_value::T) {
        self.gecko.mBorderTopColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_top_color_from(&mut self, other: &Self) {
        self.gecko.mBorderTopColor = other.gecko.mBorderTopColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_top_color(&mut self, other: &Self) {
        self.copy_border_top_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_top_color(&self) -> longhands::border_top_color::computed_value::T {
        From::from(self.gecko.mBorderTopColor.clone())
    }



    
    #[allow(non_snake_case)]
    pub fn set_border_top_width(&mut self, v: longhands::border_top_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mBorder.top = value;
        self.gecko.mComputedBorder.top = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_top_width_from(&mut self, other: &Self) {
        self.gecko.mBorder.top = other.gecko.mBorder.top;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mComputedBorder.top = other.gecko.mBorder.top;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_top_width(&mut self, other: &Self) {
        self.copy_border_top_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_top_width(&self) -> longhands::border_top_width::computed_value::T {
        Au(self.gecko.mComputedBorder.top).into()
    }


    pub fn border_top_has_nonzero_width(&self) -> bool {
        self.gecko.mComputedBorder.top != 0
    }
    pub fn set_border_right_style(&mut self, v: BorderStyle) {
        self.gecko.mBorderStyle[1] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.gecko.mComputedBorder.right = self.gecko.mBorder.right;
    }

    pub fn copy_border_right_style_from(&mut self, other: &Self) {
        self.gecko.mBorderStyle[1] = other.gecko.mBorderStyle[1];
        self.gecko.mComputedBorder.right = self.gecko.mBorder.right;
    }

    pub fn reset_border_right_style(&mut self, other: &Self) {
        self.copy_border_right_style_from(other);
    }

    #[inline]
    pub fn clone_border_right_style(&self) -> BorderStyle {
        self.gecko.mBorderStyle[1]
    }

    

    #[allow(non_snake_case)]
    pub fn set_border_right_color(&mut self, v: longhands::border_right_color::computed_value::T) {
        self.gecko.mBorderRightColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_right_color_from(&mut self, other: &Self) {
        self.gecko.mBorderRightColor = other.gecko.mBorderRightColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_right_color(&mut self, other: &Self) {
        self.copy_border_right_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_right_color(&self) -> longhands::border_right_color::computed_value::T {
        From::from(self.gecko.mBorderRightColor.clone())
    }



    
    #[allow(non_snake_case)]
    pub fn set_border_right_width(&mut self, v: longhands::border_right_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mBorder.right = value;
        self.gecko.mComputedBorder.right = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_right_width_from(&mut self, other: &Self) {
        self.gecko.mBorder.right = other.gecko.mBorder.right;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mComputedBorder.right = other.gecko.mBorder.right;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_right_width(&mut self, other: &Self) {
        self.copy_border_right_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_right_width(&self) -> longhands::border_right_width::computed_value::T {
        Au(self.gecko.mComputedBorder.right).into()
    }


    pub fn border_right_has_nonzero_width(&self) -> bool {
        self.gecko.mComputedBorder.right != 0
    }
    pub fn set_border_bottom_style(&mut self, v: BorderStyle) {
        self.gecko.mBorderStyle[2] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.gecko.mComputedBorder.bottom = self.gecko.mBorder.bottom;
    }

    pub fn copy_border_bottom_style_from(&mut self, other: &Self) {
        self.gecko.mBorderStyle[2] = other.gecko.mBorderStyle[2];
        self.gecko.mComputedBorder.bottom = self.gecko.mBorder.bottom;
    }

    pub fn reset_border_bottom_style(&mut self, other: &Self) {
        self.copy_border_bottom_style_from(other);
    }

    #[inline]
    pub fn clone_border_bottom_style(&self) -> BorderStyle {
        self.gecko.mBorderStyle[2]
    }

    

    #[allow(non_snake_case)]
    pub fn set_border_bottom_color(&mut self, v: longhands::border_bottom_color::computed_value::T) {
        self.gecko.mBorderBottomColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_bottom_color_from(&mut self, other: &Self) {
        self.gecko.mBorderBottomColor = other.gecko.mBorderBottomColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_bottom_color(&mut self, other: &Self) {
        self.copy_border_bottom_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_bottom_color(&self) -> longhands::border_bottom_color::computed_value::T {
        From::from(self.gecko.mBorderBottomColor.clone())
    }



    
    #[allow(non_snake_case)]
    pub fn set_border_bottom_width(&mut self, v: longhands::border_bottom_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mBorder.bottom = value;
        self.gecko.mComputedBorder.bottom = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_bottom_width_from(&mut self, other: &Self) {
        self.gecko.mBorder.bottom = other.gecko.mBorder.bottom;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mComputedBorder.bottom = other.gecko.mBorder.bottom;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_bottom_width(&mut self, other: &Self) {
        self.copy_border_bottom_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_bottom_width(&self) -> longhands::border_bottom_width::computed_value::T {
        Au(self.gecko.mComputedBorder.bottom).into()
    }


    pub fn border_bottom_has_nonzero_width(&self) -> bool {
        self.gecko.mComputedBorder.bottom != 0
    }
    pub fn set_border_left_style(&mut self, v: BorderStyle) {
        self.gecko.mBorderStyle[3] = v;

        // This is needed because the initial mComputedBorder value is set to
        // zero.
        //
        // In order to compute stuff, we start from the initial struct, and keep
        // going down the tree applying properties.
        //
        // That means, effectively, that when we set border-style to something
        // non-hidden, we should use the initial border instead.
        //
        // Servo stores the initial border-width in the initial struct, and then
        // adjusts as needed in the fixup phase. This means that the initial
        // struct is technically not valid without fixups, and that you lose
        // pretty much any sharing of the initial struct, which is kind of
        // unfortunate.
        //
        // Gecko has two fields for this, one that stores the "specified"
        // border, and other that stores the actual computed one. That means
        // that when we set border-style, border-width may change and we need to
        // sync back to the specified one. This is what this function does.
        //
        // Note that this doesn't impose any dependency in the order of
        // computation of the properties. This is only relevant if border-style
        // is specified, but border-width isn't. If border-width is specified at
        // some point, the two mBorder and mComputedBorder fields would be the
        // same already.
        //
        // Once we're here, we know that we'll run style fixups, so it's fine to
        // just copy the specified border here, we'll adjust it if it's
        // incorrect later.
        self.gecko.mComputedBorder.left = self.gecko.mBorder.left;
    }

    pub fn copy_border_left_style_from(&mut self, other: &Self) {
        self.gecko.mBorderStyle[3] = other.gecko.mBorderStyle[3];
        self.gecko.mComputedBorder.left = self.gecko.mBorder.left;
    }

    pub fn reset_border_left_style(&mut self, other: &Self) {
        self.copy_border_left_style_from(other);
    }

    #[inline]
    pub fn clone_border_left_style(&self) -> BorderStyle {
        self.gecko.mBorderStyle[3]
    }

    

    #[allow(non_snake_case)]
    pub fn set_border_left_color(&mut self, v: longhands::border_left_color::computed_value::T) {
        self.gecko.mBorderLeftColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_left_color_from(&mut self, other: &Self) {
        self.gecko.mBorderLeftColor = other.gecko.mBorderLeftColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_left_color(&mut self, other: &Self) {
        self.copy_border_left_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_left_color(&self) -> longhands::border_left_color::computed_value::T {
        From::from(self.gecko.mBorderLeftColor.clone())
    }



    
    #[allow(non_snake_case)]
    pub fn set_border_left_width(&mut self, v: longhands::border_left_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mBorder.left = value;
        self.gecko.mComputedBorder.left = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_border_left_width_from(&mut self, other: &Self) {
        self.gecko.mBorder.left = other.gecko.mBorder.left;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mComputedBorder.left = other.gecko.mBorder.left;
    }

    #[allow(non_snake_case)]
    pub fn reset_border_left_width(&mut self, other: &Self) {
        self.copy_border_left_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_border_left_width(&self) -> longhands::border_left_width::computed_value::T {
        Au(self.gecko.mComputedBorder.left).into()
    }


    pub fn border_left_has_nonzero_width(&self) -> bool {
        self.gecko.mComputedBorder.left != 0
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_top_left_radius(&mut self, v: longhands::border_top_left_radius::computed_value::T) {
        self.gecko.mBorderRadius.top_left = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_border_top_left_radius_from(&mut self, other: &Self) {
        self.gecko.mBorderRadius.top_left =
            other.gecko.mBorderRadius.top_left.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_border_top_left_radius(&mut self, other: &Self) {
        self.copy_border_top_left_radius_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone_border_top_left_radius(&self) -> longhands::border_top_left_radius::computed_value::T {
        self.gecko.mBorderRadius.top_left.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_top_right_radius(&mut self, v: longhands::border_top_right_radius::computed_value::T) {
        self.gecko.mBorderRadius.top_right = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_border_top_right_radius_from(&mut self, other: &Self) {
        self.gecko.mBorderRadius.top_right =
            other.gecko.mBorderRadius.top_right.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_border_top_right_radius(&mut self, other: &Self) {
        self.copy_border_top_right_radius_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone_border_top_right_radius(&self) -> longhands::border_top_right_radius::computed_value::T {
        self.gecko.mBorderRadius.top_right.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_bottom_right_radius(&mut self, v: longhands::border_bottom_right_radius::computed_value::T) {
        self.gecko.mBorderRadius.bottom_right = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_border_bottom_right_radius_from(&mut self, other: &Self) {
        self.gecko.mBorderRadius.bottom_right =
            other.gecko.mBorderRadius.bottom_right.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_border_bottom_right_radius(&mut self, other: &Self) {
        self.copy_border_bottom_right_radius_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone_border_bottom_right_radius(&self) -> longhands::border_bottom_right_radius::computed_value::T {
        self.gecko.mBorderRadius.bottom_right.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_border_bottom_left_radius(&mut self, v: longhands::border_bottom_left_radius::computed_value::T) {
        self.gecko.mBorderRadius.bottom_left = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_border_bottom_left_radius_from(&mut self, other: &Self) {
        self.gecko.mBorderRadius.bottom_left =
            other.gecko.mBorderRadius.bottom_left.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_border_bottom_left_radius(&mut self, other: &Self) {
        self.copy_border_bottom_left_radius_from(other)
    }
    #[allow(non_snake_case)]
    pub fn clone_border_bottom_left_radius(&self) -> longhands::border_bottom_left_radius::computed_value::T {
        self.gecko.mBorderRadius.bottom_left.clone()
    }


    

    pub fn set_border_image_repeat(&mut self, v: longhands::border_image_repeat::computed_value::T) {
        use crate::values::specified::border::BorderImageRepeatKeyword;
        use crate::gecko_bindings::structs::StyleBorderImageRepeat;

            self.gecko.mBorderImageRepeatH = match v.0 {
                BorderImageRepeatKeyword::Stretch => StyleBorderImageRepeat::Stretch,
                BorderImageRepeatKeyword::Repeat => StyleBorderImageRepeat::Repeat,
                BorderImageRepeatKeyword::Round => StyleBorderImageRepeat::Round,
                BorderImageRepeatKeyword::Space => StyleBorderImageRepeat::Space,
            };
            self.gecko.mBorderImageRepeatV = match v.1 {
                BorderImageRepeatKeyword::Stretch => StyleBorderImageRepeat::Stretch,
                BorderImageRepeatKeyword::Repeat => StyleBorderImageRepeat::Repeat,
                BorderImageRepeatKeyword::Round => StyleBorderImageRepeat::Round,
                BorderImageRepeatKeyword::Space => StyleBorderImageRepeat::Space,
            };
    }

    pub fn copy_border_image_repeat_from(&mut self, other: &Self) {
        self.gecko.mBorderImageRepeatH = other.gecko.mBorderImageRepeatH;
        self.gecko.mBorderImageRepeatV = other.gecko.mBorderImageRepeatV;
    }

    pub fn reset_border_image_repeat(&mut self, other: &Self) {
        self.copy_border_image_repeat_from(other)
    }

    pub fn clone_border_image_repeat(&self) -> longhands::border_image_repeat::computed_value::T {
        use crate::values::specified::border::BorderImageRepeatKeyword;
        use crate::gecko_bindings::structs::StyleBorderImageRepeat;

        let servo_h = match self.gecko.mBorderImageRepeatH {
            StyleBorderImageRepeat::Stretch => BorderImageRepeatKeyword::Stretch,
            StyleBorderImageRepeat::Repeat => BorderImageRepeatKeyword::Repeat,
            StyleBorderImageRepeat::Round => BorderImageRepeatKeyword::Round,
            StyleBorderImageRepeat::Space => BorderImageRepeatKeyword::Space,
        };
        let servo_v = match self.gecko.mBorderImageRepeatV {
            StyleBorderImageRepeat::Stretch => BorderImageRepeatKeyword::Stretch,
            StyleBorderImageRepeat::Repeat => BorderImageRepeatKeyword::Repeat,
            StyleBorderImageRepeat::Round => BorderImageRepeatKeyword::Round,
            StyleBorderImageRepeat::Space => BorderImageRepeatKeyword::Space,
        };
        longhands::border_image_repeat::computed_value::T(servo_h, servo_v)
    }


    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for border-block-start-color given a writing mode.
    pub fn set_border_block_start_color(&mut self,
                                      v: longhands::border_block_start_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-color
    /// given a writing mode.
    pub fn copy_border_block_start_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-color
    /// given a writing mode.
    pub fn reset_border_block_start_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-color given a writing mode.
    pub fn clone_border_block_start_color(&self, wm: WritingMode)
        -> longhands::border_block_start_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-start-style given a writing mode.
    pub fn set_border_block_start_style(&mut self,
                                      v: longhands::border_block_start_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-style
    /// given a writing mode.
    pub fn copy_border_block_start_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-style
    /// given a writing mode.
    pub fn reset_border_block_start_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-style given a writing mode.
    pub fn clone_border_block_start_style(&self, wm: WritingMode)
        -> longhands::border_block_start_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-start-width given a writing mode.
    pub fn set_border_block_start_width(&mut self,
                                      v: longhands::border_block_start_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-width
    /// given a writing mode.
    pub fn copy_border_block_start_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-start-width
    /// given a writing mode.
    pub fn reset_border_block_start_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_start_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-start-width given a writing mode.
    pub fn clone_border_block_start_width(&self, wm: WritingMode)
        -> longhands::border_block_start_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-end-color given a writing mode.
    pub fn set_border_block_end_color(&mut self,
                                      v: longhands::border_block_end_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-color
    /// given a writing mode.
    pub fn copy_border_block_end_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-color
    /// given a writing mode.
    pub fn reset_border_block_end_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-color given a writing mode.
    pub fn clone_border_block_end_color(&self, wm: WritingMode)
        -> longhands::border_block_end_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-end-style given a writing mode.
    pub fn set_border_block_end_style(&mut self,
                                      v: longhands::border_block_end_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-style
    /// given a writing mode.
    pub fn copy_border_block_end_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-style
    /// given a writing mode.
    pub fn reset_border_block_end_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-style given a writing mode.
    pub fn clone_border_block_end_style(&self, wm: WritingMode)
        -> longhands::border_block_end_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-block-end-width given a writing mode.
    pub fn set_border_block_end_width(&mut self,
                                      v: longhands::border_block_end_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-width
    /// given a writing mode.
    pub fn copy_border_block_end_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-block-end-width
    /// given a writing mode.
    pub fn reset_border_block_end_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_block_end_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-block-end-width given a writing mode.
    pub fn clone_border_block_end_width(&self, wm: WritingMode)
        -> longhands::border_block_end_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-start-color given a writing mode.
    pub fn set_border_inline_start_color(&mut self,
                                      v: longhands::border_inline_start_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-color
    /// given a writing mode.
    pub fn copy_border_inline_start_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-color
    /// given a writing mode.
    pub fn reset_border_inline_start_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-color given a writing mode.
    pub fn clone_border_inline_start_color(&self, wm: WritingMode)
        -> longhands::border_inline_start_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-start-style given a writing mode.
    pub fn set_border_inline_start_style(&mut self,
                                      v: longhands::border_inline_start_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-style
    /// given a writing mode.
    pub fn copy_border_inline_start_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-style
    /// given a writing mode.
    pub fn reset_border_inline_start_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-style given a writing mode.
    pub fn clone_border_inline_start_style(&self, wm: WritingMode)
        -> longhands::border_inline_start_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-start-width given a writing mode.
    pub fn set_border_inline_start_width(&mut self,
                                      v: longhands::border_inline_start_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-width
    /// given a writing mode.
    pub fn copy_border_inline_start_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-start-width
    /// given a writing mode.
    pub fn reset_border_inline_start_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_start_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-start-width given a writing mode.
    pub fn clone_border_inline_start_width(&self, wm: WritingMode)
        -> longhands::border_inline_start_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-end-color given a writing mode.
    pub fn set_border_inline_end_color(&mut self,
                                      v: longhands::border_inline_end_color::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_color(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_color(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_color(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_color(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-color
    /// given a writing mode.
    pub fn copy_border_inline_end_color_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_color_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_color_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_color_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_color_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-color
    /// given a writing mode.
    pub fn reset_border_inline_end_color(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_color_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-color given a writing mode.
    pub fn clone_border_inline_end_color(&self, wm: WritingMode)
        -> longhands::border_inline_end_color::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_color()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_color()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_color()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_color()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-end-style given a writing mode.
    pub fn set_border_inline_end_style(&mut self,
                                      v: longhands::border_inline_end_style::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_style(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_style(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_style(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_style(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-style
    /// given a writing mode.
    pub fn copy_border_inline_end_style_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_style_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_style_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_style_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_style_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-style
    /// given a writing mode.
    pub fn reset_border_inline_end_style(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_style_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-style given a writing mode.
    pub fn clone_border_inline_end_style(&self, wm: WritingMode)
        -> longhands::border_inline_end_style::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_style()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_style()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_style()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_style()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-inline-end-width given a writing mode.
    pub fn set_border_inline_end_width(&mut self,
                                      v: longhands::border_inline_end_width::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_border_top_width(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_border_right_width(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_border_bottom_width(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_border_left_width(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-width
    /// given a writing mode.
    pub fn copy_border_inline_end_width_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_border_top_width_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_border_right_width_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_border_bottom_width_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_border_left_width_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-inline-end-width
    /// given a writing mode.
    pub fn reset_border_inline_end_width(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_inline_end_width_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-inline-end-width given a writing mode.
    pub fn clone_border_inline_end_width(&self, wm: WritingMode)
        -> longhands::border_inline_end_width::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_border_top_width()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_border_right_width()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_border_bottom_width()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_border_left_width()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-start-start-radius given a writing mode.
    pub fn set_border_start_start_radius(&mut self,
                                      v: longhands::border_start_start_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-start-radius
    /// given a writing mode.
    pub fn copy_border_start_start_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-start-radius
    /// given a writing mode.
    pub fn reset_border_start_start_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_start_start_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-start-start-radius given a writing mode.
    pub fn clone_border_start_start_radius(&self, wm: WritingMode)
        -> longhands::border_start_start_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-start-end-radius given a writing mode.
    pub fn set_border_start_end_radius(&mut self,
                                      v: longhands::border_start_end_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-end-radius
    /// given a writing mode.
    pub fn copy_border_start_end_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-start-end-radius
    /// given a writing mode.
    pub fn reset_border_start_end_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_start_end_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-start-end-radius given a writing mode.
    pub fn clone_border_start_end_radius(&self, wm: WritingMode)
        -> longhands::border_start_end_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.start_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-end-start-radius given a writing mode.
    pub fn set_border_end_start_radius(&mut self,
                                      v: longhands::border_end_start_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-start-radius
    /// given a writing mode.
    pub fn copy_border_end_start_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-start-radius
    /// given a writing mode.
    pub fn reset_border_end_start_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_end_start_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-end-start-radius given a writing mode.
    pub fn clone_border_end_start_radius(&self, wm: WritingMode)
        -> longhands::border_end_start_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_start_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }


    
    /// Set the appropriate physical property for border-end-end-radius given a writing mode.
    pub fn set_border_end_end_radius(&mut self,
                                      v: longhands::border_end_end_radius::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.set_border_top_left_radius(v)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.set_border_top_right_radius(v)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.set_border_bottom_right_radius(v)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.set_border_bottom_left_radius(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-end-radius
    /// given a writing mode.
    pub fn copy_border_end_end_radius_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
                self.copy_border_top_left_radius_from(other)
            
                }
                PhysicalCorner::TopRight => {
                    
                self.copy_border_top_right_radius_from(other)
            
                }
                PhysicalCorner::BottomRight => {
                    
                self.copy_border_bottom_right_radius_from(other)
            
                }
                PhysicalCorner::BottomLeft => {
                    
                self.copy_border_bottom_left_radius_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for border-end-end-radius
    /// given a writing mode.
    pub fn reset_border_end_end_radius(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_border_end_end_radius_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// border-end-end-radius given a writing mode.
    pub fn clone_border_end_end_radius(&self, wm: WritingMode)
        -> longhands::border_end_end_radius::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalCorner;
        match wm.end_end_physical_corner() {
                PhysicalCorner::TopLeft => {
                    
            self.clone_border_top_left_radius()
        
                }
                PhysicalCorner::TopRight => {
                    
            self.clone_border_top_right_radius()
        
                }
                PhysicalCorner::BottomRight => {
                    
            self.clone_border_bottom_right_radius()
        
                }
                PhysicalCorner::BottomLeft => {
                    
            self.clone_border_bottom_left_radius()
        
                }
        }

    }



    #[allow(non_snake_case)]
    pub fn set_box_decoration_break(&mut self, v: longhands::box_decoration_break::computed_value::T) {
        use crate::properties::longhands::box_decoration_break::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Slice =>
                    structs::StyleBoxDecorationBreak::Slice ,
                Keyword::Clone =>
                    structs::StyleBoxDecorationBreak::Clone ,
        };
        self.gecko.mBoxDecorationBreak = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_box_decoration_break_from(&mut self, other: &Self) {
        self.gecko.mBoxDecorationBreak = other.gecko.mBoxDecorationBreak.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_box_decoration_break(&mut self, other: &Self) {
        self.copy_box_decoration_break_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_box_decoration_break(&self) -> longhands::box_decoration_break::computed_value::T {
        use crate::properties::longhands::box_decoration_break::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxDecorationBreak {
            structs::StyleBoxDecorationBreak::Slice => Keyword::Slice,
            structs::StyleBoxDecorationBreak::Clone => Keyword::Clone,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_float_edge(&mut self, v: longhands::_moz_float_edge::computed_value::T) {
        use crate::properties::longhands::_moz_float_edge::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::ContentBox =>
                    structs::StyleFloatEdge::ContentBox ,
                Keyword::MarginBox =>
                    structs::StyleFloatEdge::MarginBox ,
        };
        self.gecko.mFloatEdge = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_float_edge_from(&mut self, other: &Self) {
        self.gecko.mFloatEdge = other.gecko.mFloatEdge.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_float_edge(&mut self, other: &Self) {
        self.copy__moz_float_edge_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_float_edge(&self) -> longhands::_moz_float_edge::computed_value::T {
        use crate::properties::longhands::_moz_float_edge::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mFloatEdge {
            structs::StyleFloatEdge::ContentBox => Keyword::ContentBox,
            structs::StyleFloatEdge::MarginBox => Keyword::MarginBox,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_border_image_source(&mut self, v: longhands::border_image_source::computed_value::T) {
        self.gecko.mBorderImageSource = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_image_source_from(&mut self, other: &Self) {
        self.gecko.mBorderImageSource = other.gecko.mBorderImageSource.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_image_source(&mut self, other: &Self) {
        self.copy_border_image_source_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_image_source(&self) -> longhands::border_image_source::computed_value::T {
        From::from(self.gecko.mBorderImageSource.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_border_image_outset(&mut self, v: longhands::border_image_outset::computed_value::T) {
        self.gecko.mBorderImageOutset = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_image_outset_from(&mut self, other: &Self) {
        self.gecko.mBorderImageOutset = other.gecko.mBorderImageOutset.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_image_outset(&mut self, other: &Self) {
        self.copy_border_image_outset_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_image_outset(&self) -> longhands::border_image_outset::computed_value::T {
        From::from(self.gecko.mBorderImageOutset.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_border_image_width(&mut self, v: longhands::border_image_width::computed_value::T) {
        self.gecko.mBorderImageWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_image_width_from(&mut self, other: &Self) {
        self.gecko.mBorderImageWidth = other.gecko.mBorderImageWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_image_width(&mut self, other: &Self) {
        self.copy_border_image_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_image_width(&self) -> longhands::border_image_width::computed_value::T {
        From::from(self.gecko.mBorderImageWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_border_image_slice(&mut self, v: longhands::border_image_slice::computed_value::T) {
        self.gecko.mBorderImageSlice = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_border_image_slice_from(&mut self, other: &Self) {
        self.gecko.mBorderImageSlice = other.gecko.mBorderImageSlice.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_image_slice(&mut self, other: &Self) {
        self.copy_border_image_slice_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_image_slice(&self) -> longhands::border_image_slice::computed_value::T {
        From::from(self.gecko.mBorderImageSlice.clone())
    }


}






impl GeckoMargin {
    /*
     * Manually-Implemented Methods.
     */
    
    
    #[allow(non_snake_case)]
    pub fn set_margin_top(&mut self, v: longhands::margin_top::computed_value::T) {
        self.gecko.mMargin.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_top_from(&mut self, other: &Self) {
        self.gecko.mMargin.0 =
            other.gecko.mMargin.0.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_top(&mut self, other: &Self) {
        self.copy_margin_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_top(&self) -> longhands::margin_top::computed_value::T {
        self.gecko.mMargin.0.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_top(&mut self, v: longhands::scroll_margin_top::computed_value::T) {
        self.gecko.mScrollMargin.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_margin_top_from(&mut self, other: &Self) {
        self.gecko.mScrollMargin.0 =
            other.gecko.mScrollMargin.0.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_margin_top(&mut self, other: &Self) {
        self.copy_scroll_margin_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_top(&self) -> longhands::scroll_margin_top::computed_value::T {
        self.gecko.mScrollMargin.0.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_margin_right(&mut self, v: longhands::margin_right::computed_value::T) {
        self.gecko.mMargin.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_right_from(&mut self, other: &Self) {
        self.gecko.mMargin.1 =
            other.gecko.mMargin.1.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_right(&mut self, other: &Self) {
        self.copy_margin_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_right(&self) -> longhands::margin_right::computed_value::T {
        self.gecko.mMargin.1.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_right(&mut self, v: longhands::scroll_margin_right::computed_value::T) {
        self.gecko.mScrollMargin.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_margin_right_from(&mut self, other: &Self) {
        self.gecko.mScrollMargin.1 =
            other.gecko.mScrollMargin.1.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_margin_right(&mut self, other: &Self) {
        self.copy_scroll_margin_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_right(&self) -> longhands::scroll_margin_right::computed_value::T {
        self.gecko.mScrollMargin.1.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_margin_bottom(&mut self, v: longhands::margin_bottom::computed_value::T) {
        self.gecko.mMargin.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_bottom_from(&mut self, other: &Self) {
        self.gecko.mMargin.2 =
            other.gecko.mMargin.2.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_bottom(&mut self, other: &Self) {
        self.copy_margin_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_bottom(&self) -> longhands::margin_bottom::computed_value::T {
        self.gecko.mMargin.2.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_bottom(&mut self, v: longhands::scroll_margin_bottom::computed_value::T) {
        self.gecko.mScrollMargin.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_margin_bottom_from(&mut self, other: &Self) {
        self.gecko.mScrollMargin.2 =
            other.gecko.mScrollMargin.2.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_margin_bottom(&mut self, other: &Self) {
        self.copy_scroll_margin_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_bottom(&self) -> longhands::scroll_margin_bottom::computed_value::T {
        self.gecko.mScrollMargin.2.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_margin_left(&mut self, v: longhands::margin_left::computed_value::T) {
        self.gecko.mMargin.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_margin_left_from(&mut self, other: &Self) {
        self.gecko.mMargin.3 =
            other.gecko.mMargin.3.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_margin_left(&mut self, other: &Self) {
        self.copy_margin_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_margin_left(&self) -> longhands::margin_left::computed_value::T {
        self.gecko.mMargin.3.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_margin_left(&mut self, v: longhands::scroll_margin_left::computed_value::T) {
        self.gecko.mScrollMargin.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_margin_left_from(&mut self, other: &Self) {
        self.gecko.mScrollMargin.3 =
            other.gecko.mScrollMargin.3.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_margin_left(&mut self, other: &Self) {
        self.copy_scroll_margin_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_margin_left(&self) -> longhands::scroll_margin_left::computed_value::T {
        self.gecko.mScrollMargin.3.clone()
    }



    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for margin-block-start given a writing mode.
    pub fn set_margin_block_start(&mut self,
                                      v: longhands::margin_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-start
    /// given a writing mode.
    pub fn copy_margin_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-start
    /// given a writing mode.
    pub fn reset_margin_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-block-start given a writing mode.
    pub fn clone_margin_block_start(&self, wm: WritingMode)
        -> longhands::margin_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for margin-block-end given a writing mode.
    pub fn set_margin_block_end(&mut self,
                                      v: longhands::margin_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-end
    /// given a writing mode.
    pub fn copy_margin_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-block-end
    /// given a writing mode.
    pub fn reset_margin_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-block-end given a writing mode.
    pub fn clone_margin_block_end(&self, wm: WritingMode)
        -> longhands::margin_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for margin-inline-start given a writing mode.
    pub fn set_margin_inline_start(&mut self,
                                      v: longhands::margin_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-start
    /// given a writing mode.
    pub fn copy_margin_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-start
    /// given a writing mode.
    pub fn reset_margin_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-inline-start given a writing mode.
    pub fn clone_margin_inline_start(&self, wm: WritingMode)
        -> longhands::margin_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for margin-inline-end given a writing mode.
    pub fn set_margin_inline_end(&mut self,
                                      v: longhands::margin_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-end
    /// given a writing mode.
    pub fn copy_margin_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for margin-inline-end
    /// given a writing mode.
    pub fn reset_margin_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_margin_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// margin-inline-end given a writing mode.
    pub fn clone_margin_inline_end(&self, wm: WritingMode)
        -> longhands::margin_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_margin_left()
        
                }
        }

    }



    #[allow(non_snake_case)]
    pub fn set_overflow_clip_margin(&mut self, v: longhands::overflow_clip_margin::computed_value::T) {
        self.gecko.mOverflowClipMargin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_clip_margin_from(&mut self, other: &Self) {
        self.gecko.mOverflowClipMargin = other.gecko.mOverflowClipMargin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_clip_margin(&mut self, other: &Self) {
        self.copy_overflow_clip_margin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_clip_margin(&self) -> longhands::overflow_clip_margin::computed_value::T {
        From::from(self.gecko.mOverflowClipMargin.clone())
    }


    
    /// Set the appropriate physical property for scroll-margin-block-start given a writing mode.
    pub fn set_scroll_margin_block_start(&mut self,
                                      v: longhands::scroll_margin_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-start
    /// given a writing mode.
    pub fn copy_scroll_margin_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-start
    /// given a writing mode.
    pub fn reset_scroll_margin_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-block-start given a writing mode.
    pub fn clone_scroll_margin_block_start(&self, wm: WritingMode)
        -> longhands::scroll_margin_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-margin-block-end given a writing mode.
    pub fn set_scroll_margin_block_end(&mut self,
                                      v: longhands::scroll_margin_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-end
    /// given a writing mode.
    pub fn copy_scroll_margin_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-block-end
    /// given a writing mode.
    pub fn reset_scroll_margin_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-block-end given a writing mode.
    pub fn clone_scroll_margin_block_end(&self, wm: WritingMode)
        -> longhands::scroll_margin_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-margin-inline-start given a writing mode.
    pub fn set_scroll_margin_inline_start(&mut self,
                                      v: longhands::scroll_margin_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-start
    /// given a writing mode.
    pub fn copy_scroll_margin_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-start
    /// given a writing mode.
    pub fn reset_scroll_margin_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-inline-start given a writing mode.
    pub fn clone_scroll_margin_inline_start(&self, wm: WritingMode)
        -> longhands::scroll_margin_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-margin-inline-end given a writing mode.
    pub fn set_scroll_margin_inline_end(&mut self,
                                      v: longhands::scroll_margin_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_margin_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_margin_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_margin_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_margin_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-end
    /// given a writing mode.
    pub fn copy_scroll_margin_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_margin_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_margin_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_margin_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_margin_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-margin-inline-end
    /// given a writing mode.
    pub fn reset_scroll_margin_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_margin_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-margin-inline-end given a writing mode.
    pub fn clone_scroll_margin_inline_end(&self, wm: WritingMode)
        -> longhands::scroll_margin_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_margin_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_margin_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_margin_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_margin_left()
        
                }
        }

    }


}






impl GeckoPadding {
    /*
     * Manually-Implemented Methods.
     */
    

    
    #[allow(non_snake_case)]
    pub fn set_padding_top(&mut self, v: longhands::padding_top::computed_value::T) {
        self.gecko.mPadding.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_top_from(&mut self, other: &Self) {
        self.gecko.mPadding.0 =
            other.gecko.mPadding.0.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_top(&mut self, other: &Self) {
        self.copy_padding_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_top(&self) -> longhands::padding_top::computed_value::T {
        self.gecko.mPadding.0.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_top(&mut self, v: longhands::scroll_padding_top::computed_value::T) {
        self.gecko.mScrollPadding.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_padding_top_from(&mut self, other: &Self) {
        self.gecko.mScrollPadding.0 =
            other.gecko.mScrollPadding.0.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_padding_top(&mut self, other: &Self) {
        self.copy_scroll_padding_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_top(&self) -> longhands::scroll_padding_top::computed_value::T {
        self.gecko.mScrollPadding.0.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_padding_right(&mut self, v: longhands::padding_right::computed_value::T) {
        self.gecko.mPadding.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_right_from(&mut self, other: &Self) {
        self.gecko.mPadding.1 =
            other.gecko.mPadding.1.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_right(&mut self, other: &Self) {
        self.copy_padding_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_right(&self) -> longhands::padding_right::computed_value::T {
        self.gecko.mPadding.1.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_right(&mut self, v: longhands::scroll_padding_right::computed_value::T) {
        self.gecko.mScrollPadding.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_padding_right_from(&mut self, other: &Self) {
        self.gecko.mScrollPadding.1 =
            other.gecko.mScrollPadding.1.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_padding_right(&mut self, other: &Self) {
        self.copy_scroll_padding_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_right(&self) -> longhands::scroll_padding_right::computed_value::T {
        self.gecko.mScrollPadding.1.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_padding_bottom(&mut self, v: longhands::padding_bottom::computed_value::T) {
        self.gecko.mPadding.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_bottom_from(&mut self, other: &Self) {
        self.gecko.mPadding.2 =
            other.gecko.mPadding.2.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_bottom(&mut self, other: &Self) {
        self.copy_padding_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_bottom(&self) -> longhands::padding_bottom::computed_value::T {
        self.gecko.mPadding.2.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_bottom(&mut self, v: longhands::scroll_padding_bottom::computed_value::T) {
        self.gecko.mScrollPadding.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_padding_bottom_from(&mut self, other: &Self) {
        self.gecko.mScrollPadding.2 =
            other.gecko.mScrollPadding.2.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_padding_bottom(&mut self, other: &Self) {
        self.copy_scroll_padding_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_bottom(&self) -> longhands::scroll_padding_bottom::computed_value::T {
        self.gecko.mScrollPadding.2.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_padding_left(&mut self, v: longhands::padding_left::computed_value::T) {
        self.gecko.mPadding.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_padding_left_from(&mut self, other: &Self) {
        self.gecko.mPadding.3 =
            other.gecko.mPadding.3.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_padding_left(&mut self, other: &Self) {
        self.copy_padding_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_padding_left(&self) -> longhands::padding_left::computed_value::T {
        self.gecko.mPadding.3.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_scroll_padding_left(&mut self, v: longhands::scroll_padding_left::computed_value::T) {
        self.gecko.mScrollPadding.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_scroll_padding_left_from(&mut self, other: &Self) {
        self.gecko.mScrollPadding.3 =
            other.gecko.mScrollPadding.3.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_scroll_padding_left(&mut self, other: &Self) {
        self.copy_scroll_padding_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_scroll_padding_left(&self) -> longhands::scroll_padding_left::computed_value::T {
        self.gecko.mScrollPadding.3.clone()
    }



    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for padding-block-start given a writing mode.
    pub fn set_padding_block_start(&mut self,
                                      v: longhands::padding_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-start
    /// given a writing mode.
    pub fn copy_padding_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-start
    /// given a writing mode.
    pub fn reset_padding_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-block-start given a writing mode.
    pub fn clone_padding_block_start(&self, wm: WritingMode)
        -> longhands::padding_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for padding-block-end given a writing mode.
    pub fn set_padding_block_end(&mut self,
                                      v: longhands::padding_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-end
    /// given a writing mode.
    pub fn copy_padding_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-block-end
    /// given a writing mode.
    pub fn reset_padding_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-block-end given a writing mode.
    pub fn clone_padding_block_end(&self, wm: WritingMode)
        -> longhands::padding_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for padding-inline-start given a writing mode.
    pub fn set_padding_inline_start(&mut self,
                                      v: longhands::padding_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-start
    /// given a writing mode.
    pub fn copy_padding_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-start
    /// given a writing mode.
    pub fn reset_padding_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-inline-start given a writing mode.
    pub fn clone_padding_inline_start(&self, wm: WritingMode)
        -> longhands::padding_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for padding-inline-end given a writing mode.
    pub fn set_padding_inline_end(&mut self,
                                      v: longhands::padding_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-end
    /// given a writing mode.
    pub fn copy_padding_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for padding-inline-end
    /// given a writing mode.
    pub fn reset_padding_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_padding_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// padding-inline-end given a writing mode.
    pub fn clone_padding_inline_end(&self, wm: WritingMode)
        -> longhands::padding_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-padding-block-start given a writing mode.
    pub fn set_scroll_padding_block_start(&mut self,
                                      v: longhands::scroll_padding_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-start
    /// given a writing mode.
    pub fn copy_scroll_padding_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-start
    /// given a writing mode.
    pub fn reset_scroll_padding_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-block-start given a writing mode.
    pub fn clone_scroll_padding_block_start(&self, wm: WritingMode)
        -> longhands::scroll_padding_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-padding-block-end given a writing mode.
    pub fn set_scroll_padding_block_end(&mut self,
                                      v: longhands::scroll_padding_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-end
    /// given a writing mode.
    pub fn copy_scroll_padding_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-block-end
    /// given a writing mode.
    pub fn reset_scroll_padding_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-block-end given a writing mode.
    pub fn clone_scroll_padding_block_end(&self, wm: WritingMode)
        -> longhands::scroll_padding_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-padding-inline-start given a writing mode.
    pub fn set_scroll_padding_inline_start(&mut self,
                                      v: longhands::scroll_padding_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-start
    /// given a writing mode.
    pub fn copy_scroll_padding_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-start
    /// given a writing mode.
    pub fn reset_scroll_padding_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-inline-start given a writing mode.
    pub fn clone_scroll_padding_inline_start(&self, wm: WritingMode)
        -> longhands::scroll_padding_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for scroll-padding-inline-end given a writing mode.
    pub fn set_scroll_padding_inline_end(&mut self,
                                      v: longhands::scroll_padding_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_scroll_padding_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_scroll_padding_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_scroll_padding_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_scroll_padding_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-end
    /// given a writing mode.
    pub fn copy_scroll_padding_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_scroll_padding_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_scroll_padding_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_scroll_padding_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_scroll_padding_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for scroll-padding-inline-end
    /// given a writing mode.
    pub fn reset_scroll_padding_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_scroll_padding_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// scroll-padding-inline-end given a writing mode.
    pub fn clone_scroll_padding_inline_end(&self, wm: WritingMode)
        -> longhands::scroll_padding_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_scroll_padding_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_scroll_padding_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_scroll_padding_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_scroll_padding_left()
        
                }
        }

    }


}




impl GeckoPage {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_size(&mut self, v: longhands::size::computed_value::T) {
        self.gecko.mSize = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_size_from(&mut self, other: &Self) {
        self.gecko.mSize = other.gecko.mSize.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_size(&mut self, other: &Self) {
        self.copy_size_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_size(&self) -> longhands::size::computed_value::T {
        From::from(self.gecko.mSize.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_page(&mut self, v: longhands::page::computed_value::T) {
        self.gecko.mPage = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_page_from(&mut self, other: &Self) {
        self.gecko.mPage = other.gecko.mPage.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_page(&mut self, other: &Self) {
        self.copy_page_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_page(&self) -> longhands::page::computed_value::T {
        From::from(self.gecko.mPage.clone())
    }


}





impl GeckoPosition {
    /*
     * Manually-Implemented Methods.
     */
    
    
    #[allow(non_snake_case)]
    pub fn set_top(&mut self, v: longhands::top::computed_value::T) {
        self.gecko.mOffset.0 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_top_from(&mut self, other: &Self) {
        self.gecko.mOffset.0 =
            other.gecko.mOffset.0.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_top(&mut self, other: &Self) {
        self.copy_top_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_top(&self) -> longhands::top::computed_value::T {
        self.gecko.mOffset.0.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_right(&mut self, v: longhands::right::computed_value::T) {
        self.gecko.mOffset.1 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_right_from(&mut self, other: &Self) {
        self.gecko.mOffset.1 =
            other.gecko.mOffset.1.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_right(&mut self, other: &Self) {
        self.copy_right_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_right(&self) -> longhands::right::computed_value::T {
        self.gecko.mOffset.1.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_bottom(&mut self, v: longhands::bottom::computed_value::T) {
        self.gecko.mOffset.2 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_bottom_from(&mut self, other: &Self) {
        self.gecko.mOffset.2 =
            other.gecko.mOffset.2.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_bottom(&mut self, other: &Self) {
        self.copy_bottom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_bottom(&self) -> longhands::bottom::computed_value::T {
        self.gecko.mOffset.2.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_left(&mut self, v: longhands::left::computed_value::T) {
        self.gecko.mOffset.3 = v;
    }
    #[allow(non_snake_case)]
    pub fn copy_left_from(&mut self, other: &Self) {
        self.gecko.mOffset.3 =
            other.gecko.mOffset.3.clone();
    }
    #[allow(non_snake_case)]
    pub fn reset_left(&mut self, other: &Self) {
        self.copy_left_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_left(&self) -> longhands::left::computed_value::T {
        self.gecko.mOffset.3.clone()
    }

    pub fn set_computed_justify_items(&mut self, v: values::specified::JustifyItems) {
        debug_assert_ne!(v.0, crate::values::specified::align::AlignFlags::LEGACY);
        self.gecko.mJustifyItems.computed = v;
    }

    
    #[allow(non_snake_case)]
    pub fn set_masonry_auto_flow(&mut self, v: longhands::masonry_auto_flow::computed_value::T) {
        self.gecko.mMasonryAutoFlow = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_masonry_auto_flow_from(&mut self, other: &Self) {
        self.gecko.mMasonryAutoFlow = other.gecko.mMasonryAutoFlow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_masonry_auto_flow(&mut self, other: &Self) {
        self.copy_masonry_auto_flow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_masonry_auto_flow(&self) -> longhands::masonry_auto_flow::computed_value::T {
        From::from(self.gecko.mMasonryAutoFlow)
    }



    /*
     * Auto-Generated Methods.
     */
    
    
    /// Set the appropriate physical property for inset-block-start given a writing mode.
    pub fn set_inset_block_start(&mut self,
                                      v: longhands::inset_block_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-start
    /// given a writing mode.
    pub fn copy_inset_block_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-start
    /// given a writing mode.
    pub fn reset_inset_block_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_block_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-block-start given a writing mode.
    pub fn clone_inset_block_start(&self, wm: WritingMode)
        -> longhands::inset_block_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for inset-block-end given a writing mode.
    pub fn set_inset_block_end(&mut self,
                                      v: longhands::inset_block_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-end
    /// given a writing mode.
    pub fn copy_inset_block_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-block-end
    /// given a writing mode.
    pub fn reset_inset_block_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_block_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-block-end given a writing mode.
    pub fn clone_inset_block_end(&self, wm: WritingMode)
        -> longhands::inset_block_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.block_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for inset-inline-start given a writing mode.
    pub fn set_inset_inline_start(&mut self,
                                      v: longhands::inset_inline_start::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-start
    /// given a writing mode.
    pub fn copy_inset_inline_start_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-start
    /// given a writing mode.
    pub fn reset_inset_inline_start(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_inline_start_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-inline-start given a writing mode.
    pub fn clone_inset_inline_start(&self, wm: WritingMode)
        -> longhands::inset_inline_start::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_start_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }


    
    /// Set the appropriate physical property for inset-inline-end given a writing mode.
    pub fn set_inset_inline_end(&mut self,
                                      v: longhands::inset_inline_end::computed_value::T,
                                      wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.set_top(v)
            
                }
                PhysicalSide::Right => {
                    
                self.set_right(v)
            
                }
                PhysicalSide::Bottom => {
                    
                self.set_bottom(v)
            
                }
                PhysicalSide::Left => {
                    
                self.set_left(v)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-end
    /// given a writing mode.
    pub fn copy_inset_inline_end_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
                self.copy_top_from(other)
            
                }
                PhysicalSide::Right => {
                    
                self.copy_right_from(other)
            
                }
                PhysicalSide::Bottom => {
                    
                self.copy_bottom_from(other)
            
                }
                PhysicalSide::Left => {
                    
                self.copy_left_from(other)
            
                }
        }

    }

    /// Copy the appropriate physical property from another struct for inset-inline-end
    /// given a writing mode.
    pub fn reset_inset_inline_end(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inset_inline_end_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inset-inline-end given a writing mode.
    pub fn clone_inset_inline_end(&self, wm: WritingMode)
        -> longhands::inset_inline_end::computed_value::T {
    
    
        use crate::logical_geometry::PhysicalSide;
        match wm.inline_end_physical_side() {
                PhysicalSide::Top => {
                    
            self.clone_top()
        
                }
                PhysicalSide::Right => {
                    
            self.clone_right()
        
                }
                PhysicalSide::Bottom => {
                    
            self.clone_bottom()
        
                }
                PhysicalSide::Left => {
                    
            self.clone_left()
        
                }
        }

    }



    #[allow(non_snake_case)]
    pub fn set_z_index(&mut self, v: longhands::z_index::computed_value::T) {
        self.gecko.mZIndex = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_z_index_from(&mut self, other: &Self) {
        self.gecko.mZIndex = other.gecko.mZIndex.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_z_index(&mut self, other: &Self) {
        self.copy_z_index_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_z_index(&self) -> longhands::z_index::computed_value::T {
        From::from(self.gecko.mZIndex.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flex_direction(&mut self, v: longhands::flex_direction::computed_value::T) {
        use crate::properties::longhands::flex_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Row =>
                    structs::StyleFlexDirection::Row ,
                Keyword::RowReverse =>
                    structs::StyleFlexDirection::RowReverse ,
                Keyword::Column =>
                    structs::StyleFlexDirection::Column ,
                Keyword::ColumnReverse =>
                    structs::StyleFlexDirection::ColumnReverse ,
        };
        self.gecko.mFlexDirection = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_direction_from(&mut self, other: &Self) {
        self.gecko.mFlexDirection = other.gecko.mFlexDirection.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_direction(&mut self, other: &Self) {
        self.copy_flex_direction_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_direction(&self) -> longhands::flex_direction::computed_value::T {
        use crate::properties::longhands::flex_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mFlexDirection {
            structs::StyleFlexDirection::Row => Keyword::Row,
            structs::StyleFlexDirection::RowReverse => Keyword::RowReverse,
            structs::StyleFlexDirection::Column => Keyword::Column,
            structs::StyleFlexDirection::ColumnReverse => Keyword::ColumnReverse,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_flex_wrap(&mut self, v: longhands::flex_wrap::computed_value::T) {
        use crate::properties::longhands::flex_wrap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Nowrap =>
                    structs::StyleFlexWrap::Nowrap ,
                Keyword::Wrap =>
                    structs::StyleFlexWrap::Wrap ,
                Keyword::WrapReverse =>
                    structs::StyleFlexWrap::WrapReverse ,
        };
        self.gecko.mFlexWrap = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_wrap_from(&mut self, other: &Self) {
        self.gecko.mFlexWrap = other.gecko.mFlexWrap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_wrap(&mut self, other: &Self) {
        self.copy_flex_wrap_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_wrap(&self) -> longhands::flex_wrap::computed_value::T {
        use crate::properties::longhands::flex_wrap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mFlexWrap {
            structs::StyleFlexWrap::Nowrap => Keyword::Nowrap,
            structs::StyleFlexWrap::Wrap => Keyword::Wrap,
            structs::StyleFlexWrap::WrapReverse => Keyword::WrapReverse,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_justify_content(&mut self, v: longhands::justify_content::computed_value::T) {
        self.gecko.mJustifyContent = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_justify_content_from(&mut self, other: &Self) {
        self.gecko.mJustifyContent = other.gecko.mJustifyContent.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_justify_content(&mut self, other: &Self) {
        self.copy_justify_content_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_justify_content(&self) -> longhands::justify_content::computed_value::T {
        From::from(self.gecko.mJustifyContent.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_justify_tracks(&mut self, v: longhands::justify_tracks::computed_value::T) {
        self.gecko.mJustifyTracks = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_justify_tracks_from(&mut self, other: &Self) {
        self.gecko.mJustifyTracks = other.gecko.mJustifyTracks.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_justify_tracks(&mut self, other: &Self) {
        self.copy_justify_tracks_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_justify_tracks(&self) -> longhands::justify_tracks::computed_value::T {
        From::from(self.gecko.mJustifyTracks.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_align_content(&mut self, v: longhands::align_content::computed_value::T) {
        self.gecko.mAlignContent = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_align_content_from(&mut self, other: &Self) {
        self.gecko.mAlignContent = other.gecko.mAlignContent.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_align_content(&mut self, other: &Self) {
        self.copy_align_content_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_align_content(&self) -> longhands::align_content::computed_value::T {
        From::from(self.gecko.mAlignContent.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_align_tracks(&mut self, v: longhands::align_tracks::computed_value::T) {
        self.gecko.mAlignTracks = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_align_tracks_from(&mut self, other: &Self) {
        self.gecko.mAlignTracks = other.gecko.mAlignTracks.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_align_tracks(&mut self, other: &Self) {
        self.copy_align_tracks_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_align_tracks(&self) -> longhands::align_tracks::computed_value::T {
        From::from(self.gecko.mAlignTracks.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_align_items(&mut self, v: longhands::align_items::computed_value::T) {
        self.gecko.mAlignItems = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_align_items_from(&mut self, other: &Self) {
        self.gecko.mAlignItems = other.gecko.mAlignItems.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_align_items(&mut self, other: &Self) {
        self.copy_align_items_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_align_items(&self) -> longhands::align_items::computed_value::T {
        From::from(self.gecko.mAlignItems.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_justify_items(&mut self, v: longhands::justify_items::computed_value::T) {
        self.gecko.mJustifyItems = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_justify_items_from(&mut self, other: &Self) {
        self.gecko.mJustifyItems = other.gecko.mJustifyItems.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_justify_items(&mut self, other: &Self) {
        self.copy_justify_items_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_justify_items(&self) -> longhands::justify_items::computed_value::T {
        From::from(self.gecko.mJustifyItems.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flex_grow(&mut self, v: longhands::flex_grow::computed_value::T) {
        self.gecko.mFlexGrow = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_grow_from(&mut self, other: &Self) {
        self.gecko.mFlexGrow = other.gecko.mFlexGrow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_grow(&mut self, other: &Self) {
        self.copy_flex_grow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_grow(&self) -> longhands::flex_grow::computed_value::T {
        From::from(self.gecko.mFlexGrow.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flex_shrink(&mut self, v: longhands::flex_shrink::computed_value::T) {
        self.gecko.mFlexShrink = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_shrink_from(&mut self, other: &Self) {
        self.gecko.mFlexShrink = other.gecko.mFlexShrink.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_shrink(&mut self, other: &Self) {
        self.copy_flex_shrink_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_shrink(&self) -> longhands::flex_shrink::computed_value::T {
        From::from(self.gecko.mFlexShrink.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_align_self(&mut self, v: longhands::align_self::computed_value::T) {
        self.gecko.mAlignSelf = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_align_self_from(&mut self, other: &Self) {
        self.gecko.mAlignSelf = other.gecko.mAlignSelf.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_align_self(&mut self, other: &Self) {
        self.copy_align_self_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_align_self(&self) -> longhands::align_self::computed_value::T {
        From::from(self.gecko.mAlignSelf.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_justify_self(&mut self, v: longhands::justify_self::computed_value::T) {
        self.gecko.mJustifySelf = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_justify_self_from(&mut self, other: &Self) {
        self.gecko.mJustifySelf = other.gecko.mJustifySelf.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_justify_self(&mut self, other: &Self) {
        self.copy_justify_self_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_justify_self(&self) -> longhands::justify_self::computed_value::T {
        From::from(self.gecko.mJustifySelf.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_order(&mut self, v: longhands::order::computed_value::T) {
        self.gecko.mOrder = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_order_from(&mut self, other: &Self) {
        self.gecko.mOrder = other.gecko.mOrder.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_order(&mut self, other: &Self) {
        self.copy_order_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_order(&self) -> longhands::order::computed_value::T {
        From::from(self.gecko.mOrder.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flex_basis(&mut self, v: longhands::flex_basis::computed_value::T) {
        self.gecko.mFlexBasis = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flex_basis_from(&mut self, other: &Self) {
        self.gecko.mFlexBasis = other.gecko.mFlexBasis.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flex_basis(&mut self, other: &Self) {
        self.copy_flex_basis_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flex_basis(&self) -> longhands::flex_basis::computed_value::T {
        From::from(self.gecko.mFlexBasis.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_width(&mut self, v: longhands::width::computed_value::T) {
        self.gecko.mWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_width_from(&mut self, other: &Self) {
        self.gecko.mWidth = other.gecko.mWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_width(&mut self, other: &Self) {
        self.copy_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_width(&self) -> longhands::width::computed_value::T {
        From::from(self.gecko.mWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_min_width(&mut self, v: longhands::min_width::computed_value::T) {
        self.gecko.mMinWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_min_width_from(&mut self, other: &Self) {
        self.gecko.mMinWidth = other.gecko.mMinWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_min_width(&mut self, other: &Self) {
        self.copy_min_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_min_width(&self) -> longhands::min_width::computed_value::T {
        From::from(self.gecko.mMinWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_max_width(&mut self, v: longhands::max_width::computed_value::T) {
        self.gecko.mMaxWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_max_width_from(&mut self, other: &Self) {
        self.gecko.mMaxWidth = other.gecko.mMaxWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_max_width(&mut self, other: &Self) {
        self.copy_max_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_max_width(&self) -> longhands::max_width::computed_value::T {
        From::from(self.gecko.mMaxWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_height(&mut self, v: longhands::height::computed_value::T) {
        self.gecko.mHeight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_height_from(&mut self, other: &Self) {
        self.gecko.mHeight = other.gecko.mHeight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_height(&mut self, other: &Self) {
        self.copy_height_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_height(&self) -> longhands::height::computed_value::T {
        From::from(self.gecko.mHeight.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_min_height(&mut self, v: longhands::min_height::computed_value::T) {
        self.gecko.mMinHeight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_min_height_from(&mut self, other: &Self) {
        self.gecko.mMinHeight = other.gecko.mMinHeight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_min_height(&mut self, other: &Self) {
        self.copy_min_height_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_min_height(&self) -> longhands::min_height::computed_value::T {
        From::from(self.gecko.mMinHeight.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_max_height(&mut self, v: longhands::max_height::computed_value::T) {
        self.gecko.mMaxHeight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_max_height_from(&mut self, other: &Self) {
        self.gecko.mMaxHeight = other.gecko.mMaxHeight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_max_height(&mut self, other: &Self) {
        self.copy_max_height_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_max_height(&self) -> longhands::max_height::computed_value::T {
        From::from(self.gecko.mMaxHeight.clone())
    }


    
    /// Set the appropriate physical property for block-size given a writing mode.
    pub fn set_block_size(&mut self,
                                      v: longhands::block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_width(v)
            
        } else {
            
                self.set_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for block-size
    /// given a writing mode.
    pub fn copy_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_width_from(other)
            
        } else {
            
                self.copy_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for block-size
    /// given a writing mode.
    pub fn reset_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// block-size given a writing mode.
    pub fn clone_block_size(&self, wm: WritingMode)
        -> longhands::block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_width()
        
        } else {
            
            self.clone_height()
        
        }

    }


    
    /// Set the appropriate physical property for min-block-size given a writing mode.
    pub fn set_min_block_size(&mut self,
                                      v: longhands::min_block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_min_width(v)
            
        } else {
            
                self.set_min_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-block-size
    /// given a writing mode.
    pub fn copy_min_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_min_width_from(other)
            
        } else {
            
                self.copy_min_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-block-size
    /// given a writing mode.
    pub fn reset_min_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_min_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// min-block-size given a writing mode.
    pub fn clone_min_block_size(&self, wm: WritingMode)
        -> longhands::min_block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_min_width()
        
        } else {
            
            self.clone_min_height()
        
        }

    }


    
    /// Set the appropriate physical property for max-block-size given a writing mode.
    pub fn set_max_block_size(&mut self,
                                      v: longhands::max_block_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_max_width(v)
            
        } else {
            
                self.set_max_height(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-block-size
    /// given a writing mode.
    pub fn copy_max_block_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_max_width_from(other)
            
        } else {
            
                self.copy_max_height_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-block-size
    /// given a writing mode.
    pub fn reset_max_block_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_max_block_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// max-block-size given a writing mode.
    pub fn clone_max_block_size(&self, wm: WritingMode)
        -> longhands::max_block_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_max_width()
        
        } else {
            
            self.clone_max_height()
        
        }

    }


    
    /// Set the appropriate physical property for inline-size given a writing mode.
    pub fn set_inline_size(&mut self,
                                      v: longhands::inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_height(v)
            
        } else {
            
                self.set_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for inline-size
    /// given a writing mode.
    pub fn copy_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_height_from(other)
            
        } else {
            
                self.copy_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for inline-size
    /// given a writing mode.
    pub fn reset_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// inline-size given a writing mode.
    pub fn clone_inline_size(&self, wm: WritingMode)
        -> longhands::inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_height()
        
        } else {
            
            self.clone_width()
        
        }

    }


    
    /// Set the appropriate physical property for min-inline-size given a writing mode.
    pub fn set_min_inline_size(&mut self,
                                      v: longhands::min_inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_min_height(v)
            
        } else {
            
                self.set_min_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-inline-size
    /// given a writing mode.
    pub fn copy_min_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_min_height_from(other)
            
        } else {
            
                self.copy_min_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for min-inline-size
    /// given a writing mode.
    pub fn reset_min_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_min_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// min-inline-size given a writing mode.
    pub fn clone_min_inline_size(&self, wm: WritingMode)
        -> longhands::min_inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_min_height()
        
        } else {
            
            self.clone_min_width()
        
        }

    }


    
    /// Set the appropriate physical property for max-inline-size given a writing mode.
    pub fn set_max_inline_size(&mut self,
                                      v: longhands::max_inline_size::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_max_height(v)
            
        } else {
            
                self.set_max_width(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-inline-size
    /// given a writing mode.
    pub fn copy_max_inline_size_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_max_height_from(other)
            
        } else {
            
                self.copy_max_width_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for max-inline-size
    /// given a writing mode.
    pub fn reset_max_inline_size(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_max_inline_size_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// max-inline-size given a writing mode.
    pub fn clone_max_inline_size(&self, wm: WritingMode)
        -> longhands::max_inline_size::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_max_height()
        
        } else {
            
            self.clone_max_width()
        
        }

    }



    #[allow(non_snake_case)]
    pub fn set_box_sizing(&mut self, v: longhands::box_sizing::computed_value::T) {
        use crate::properties::longhands::box_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::ContentBox =>
                    structs::StyleBoxSizing::Content ,
                Keyword::BorderBox =>
                    structs::StyleBoxSizing::Border ,
        };
        self.gecko.mBoxSizing = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_box_sizing_from(&mut self, other: &Self) {
        self.gecko.mBoxSizing = other.gecko.mBoxSizing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_box_sizing(&mut self, other: &Self) {
        self.copy_box_sizing_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_box_sizing(&self) -> longhands::box_sizing::computed_value::T {
        use crate::properties::longhands::box_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxSizing {
            structs::StyleBoxSizing::Content => Keyword::ContentBox,
            structs::StyleBoxSizing::Border => Keyword::BorderBox,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_object_fit(&mut self, v: longhands::object_fit::computed_value::T) {
        use crate::properties::longhands::object_fit::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Fill =>
                    structs::StyleObjectFit::Fill ,
                Keyword::Contain =>
                    structs::StyleObjectFit::Contain ,
                Keyword::Cover =>
                    structs::StyleObjectFit::Cover ,
                Keyword::None =>
                    structs::StyleObjectFit::None ,
                Keyword::ScaleDown =>
                    structs::StyleObjectFit::ScaleDown ,
        };
        self.gecko.mObjectFit = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_object_fit_from(&mut self, other: &Self) {
        self.gecko.mObjectFit = other.gecko.mObjectFit.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_object_fit(&mut self, other: &Self) {
        self.copy_object_fit_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_object_fit(&self) -> longhands::object_fit::computed_value::T {
        use crate::properties::longhands::object_fit::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mObjectFit {
            structs::StyleObjectFit::Fill => Keyword::Fill,
            structs::StyleObjectFit::Contain => Keyword::Contain,
            structs::StyleObjectFit::Cover => Keyword::Cover,
            structs::StyleObjectFit::None => Keyword::None,
            structs::StyleObjectFit::ScaleDown => Keyword::ScaleDown,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_object_position(&mut self, v: longhands::object_position::computed_value::T) {
        self.gecko.mObjectPosition = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_object_position_from(&mut self, other: &Self) {
        self.gecko.mObjectPosition = other.gecko.mObjectPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_object_position(&mut self, other: &Self) {
        self.copy_object_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_object_position(&self) -> longhands::object_position::computed_value::T {
        From::from(self.gecko.mObjectPosition.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_row_start(&mut self, v: longhands::grid_row_start::computed_value::T) {
        self.gecko.mGridRowStart = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_row_start_from(&mut self, other: &Self) {
        self.gecko.mGridRowStart = other.gecko.mGridRowStart.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_row_start(&mut self, other: &Self) {
        self.copy_grid_row_start_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_row_start(&self) -> longhands::grid_row_start::computed_value::T {
        From::from(self.gecko.mGridRowStart.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_row_end(&mut self, v: longhands::grid_row_end::computed_value::T) {
        self.gecko.mGridRowEnd = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_row_end_from(&mut self, other: &Self) {
        self.gecko.mGridRowEnd = other.gecko.mGridRowEnd.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_row_end(&mut self, other: &Self) {
        self.copy_grid_row_end_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_row_end(&self) -> longhands::grid_row_end::computed_value::T {
        From::from(self.gecko.mGridRowEnd.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_auto_rows(&mut self, v: longhands::grid_auto_rows::computed_value::T) {
        self.gecko.mGridAutoRows = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_auto_rows_from(&mut self, other: &Self) {
        self.gecko.mGridAutoRows = other.gecko.mGridAutoRows.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_auto_rows(&mut self, other: &Self) {
        self.copy_grid_auto_rows_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_auto_rows(&self) -> longhands::grid_auto_rows::computed_value::T {
        From::from(self.gecko.mGridAutoRows.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_template_rows(&mut self, v: longhands::grid_template_rows::computed_value::T) {
        self.gecko.mGridTemplateRows = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_template_rows_from(&mut self, other: &Self) {
        self.gecko.mGridTemplateRows = other.gecko.mGridTemplateRows.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_template_rows(&mut self, other: &Self) {
        self.copy_grid_template_rows_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_template_rows(&self) -> longhands::grid_template_rows::computed_value::T {
        From::from(self.gecko.mGridTemplateRows.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_column_start(&mut self, v: longhands::grid_column_start::computed_value::T) {
        self.gecko.mGridColumnStart = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_column_start_from(&mut self, other: &Self) {
        self.gecko.mGridColumnStart = other.gecko.mGridColumnStart.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_column_start(&mut self, other: &Self) {
        self.copy_grid_column_start_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_column_start(&self) -> longhands::grid_column_start::computed_value::T {
        From::from(self.gecko.mGridColumnStart.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_column_end(&mut self, v: longhands::grid_column_end::computed_value::T) {
        self.gecko.mGridColumnEnd = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_column_end_from(&mut self, other: &Self) {
        self.gecko.mGridColumnEnd = other.gecko.mGridColumnEnd.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_column_end(&mut self, other: &Self) {
        self.copy_grid_column_end_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_column_end(&self) -> longhands::grid_column_end::computed_value::T {
        From::from(self.gecko.mGridColumnEnd.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_auto_columns(&mut self, v: longhands::grid_auto_columns::computed_value::T) {
        self.gecko.mGridAutoColumns = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_auto_columns_from(&mut self, other: &Self) {
        self.gecko.mGridAutoColumns = other.gecko.mGridAutoColumns.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_auto_columns(&mut self, other: &Self) {
        self.copy_grid_auto_columns_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_auto_columns(&self) -> longhands::grid_auto_columns::computed_value::T {
        From::from(self.gecko.mGridAutoColumns.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_template_columns(&mut self, v: longhands::grid_template_columns::computed_value::T) {
        self.gecko.mGridTemplateColumns = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_template_columns_from(&mut self, other: &Self) {
        self.gecko.mGridTemplateColumns = other.gecko.mGridTemplateColumns.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_template_columns(&mut self, other: &Self) {
        self.copy_grid_template_columns_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_template_columns(&self) -> longhands::grid_template_columns::computed_value::T {
        From::from(self.gecko.mGridTemplateColumns.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_auto_flow(&mut self, v: longhands::grid_auto_flow::computed_value::T) {
        self.gecko.mGridAutoFlow = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_auto_flow_from(&mut self, other: &Self) {
        self.gecko.mGridAutoFlow = other.gecko.mGridAutoFlow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_auto_flow(&mut self, other: &Self) {
        self.copy_grid_auto_flow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_auto_flow(&self) -> longhands::grid_auto_flow::computed_value::T {
        From::from(self.gecko.mGridAutoFlow.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_grid_template_areas(&mut self, v: longhands::grid_template_areas::computed_value::T) {
        self.gecko.mGridTemplateAreas = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_grid_template_areas_from(&mut self, other: &Self) {
        self.gecko.mGridTemplateAreas = other.gecko.mGridTemplateAreas.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_grid_template_areas(&mut self, other: &Self) {
        self.copy_grid_template_areas_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_grid_template_areas(&self) -> longhands::grid_template_areas::computed_value::T {
        From::from(self.gecko.mGridTemplateAreas.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_column_gap(&mut self, v: longhands::column_gap::computed_value::T) {
        self.gecko.mColumnGap = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_column_gap_from(&mut self, other: &Self) {
        self.gecko.mColumnGap = other.gecko.mColumnGap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_gap(&mut self, other: &Self) {
        self.copy_column_gap_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_gap(&self) -> longhands::column_gap::computed_value::T {
        From::from(self.gecko.mColumnGap.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_row_gap(&mut self, v: longhands::row_gap::computed_value::T) {
        self.gecko.mRowGap = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_row_gap_from(&mut self, other: &Self) {
        self.gecko.mRowGap = other.gecko.mRowGap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_row_gap(&mut self, other: &Self) {
        self.copy_row_gap_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_row_gap(&self) -> longhands::row_gap::computed_value::T {
        From::from(self.gecko.mRowGap.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_aspect_ratio(&mut self, v: longhands::aspect_ratio::computed_value::T) {
        self.gecko.mAspectRatio = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_aspect_ratio_from(&mut self, other: &Self) {
        self.gecko.mAspectRatio = other.gecko.mAspectRatio.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_aspect_ratio(&mut self, other: &Self) {
        self.copy_aspect_ratio_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_aspect_ratio(&self) -> longhands::aspect_ratio::computed_value::T {
        From::from(self.gecko.mAspectRatio.clone())
    }


}




impl GeckoOutline {
    /*
     * Manually-Implemented Methods.
     */
    

    pub fn set_outline_style(&mut self, v: longhands::outline_style::computed_value::T) {
        self.gecko.mOutlineStyle = v;
        // NB: This is needed to correctly handling the initial value of
        // outline-width when outline-style changes, see the
        // update_border_left comment for more details.
        self.gecko.mActualOutlineWidth = self.gecko.mOutlineWidth;
    }

    pub fn copy_outline_style_from(&mut self, other: &Self) {
        // FIXME(emilio): Why doesn't this need to reset mActualOutlineWidth?
        // Looks fishy.
        self.gecko.mOutlineStyle = other.gecko.mOutlineStyle;
    }

    pub fn reset_outline_style(&mut self, other: &Self) {
        self.copy_outline_style_from(other)
    }

    pub fn clone_outline_style(&self) -> longhands::outline_style::computed_value::T {
        self.gecko.mOutlineStyle.clone()
    }

    
    #[allow(non_snake_case)]
    pub fn set_outline_width(&mut self, v: longhands::outline_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mOutlineWidth = value;
        self.gecko.mActualOutlineWidth = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_outline_width_from(&mut self, other: &Self) {
        self.gecko.mOutlineWidth = other.gecko.mOutlineWidth;
        // NOTE: This is needed to easily handle the `unset` and `initial`
        // keywords, which are implemented calling this function.
        //
        // In practice, this means that we may have an incorrect value here, but
        // we'll adjust that properly in the style fixup phase.
        //
        // FIXME(emilio): We could clean this up a bit special-casing the reset_
        // function below.
        self.gecko.mActualOutlineWidth = other.gecko.mOutlineWidth;
    }

    #[allow(non_snake_case)]
    pub fn reset_outline_width(&mut self, other: &Self) {
        self.copy_outline_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_outline_width(&self) -> longhands::outline_width::computed_value::T {
        Au(self.gecko.mActualOutlineWidth).into()
    }


    pub fn outline_has_nonzero_width(&self) -> bool {
        self.gecko.mActualOutlineWidth != 0
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_outline_color(&mut self, v: longhands::outline_color::computed_value::T) {
        self.gecko.mOutlineColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_outline_color_from(&mut self, other: &Self) {
        self.gecko.mOutlineColor = other.gecko.mOutlineColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_outline_color(&mut self, other: &Self) {
        self.copy_outline_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_outline_color(&self) -> longhands::outline_color::computed_value::T {
        From::from(self.gecko.mOutlineColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_outline_offset(&mut self, v: longhands::outline_offset::computed_value::T) {
        self.gecko.mOutlineOffset = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_outline_offset_from(&mut self, other: &Self) {
        self.gecko.mOutlineOffset = other.gecko.mOutlineOffset.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_outline_offset(&mut self, other: &Self) {
        self.copy_outline_offset_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_outline_offset(&self) -> longhands::outline_offset::computed_value::T {
        From::from(self.gecko.mOutlineOffset.clone())
    }


}





impl GeckoFont {
    /*
     * Manually-Implemented Methods.
     */
    

    // Negative numbers are invalid at parse time, but <integer> is still an
    // i32.
    
    

    pub fn set_font_feature_settings(&mut self, v: longhands::font_feature_settings::computed_value::T) {
        let iter = v.0.iter().map(|other| structs::gfxFontFeature {
            mTag: other.tag.0,
            mValue: other.value as u32,
        });
        self.gecko.mFont.fontFeatureSettings.assign_from_iter_pod(iter);
    }

    pub fn copy_font_feature_settings_from(&mut self, other: &Self) {
        let iter = other.gecko.mFont.fontFeatureSettings.iter().map(|s| *s);
        self.gecko.mFont.fontFeatureSettings.assign_from_iter_pod(iter);
    }

    pub fn reset_font_feature_settings(&mut self, other: &Self) {
        self.copy_font_feature_settings_from(other)
    }

    pub fn clone_font_feature_settings(&self) -> longhands::font_feature_settings::computed_value::T {
        use crate::values::generics::font::{FontSettings, FontTag, FeatureTagValue};

        FontSettings(
            self.gecko.mFont.fontFeatureSettings.iter().map(|gecko_font_setting| {
                FeatureTagValue {
                    tag: FontTag(gecko_font_setting.mTag),
                    value: gecko_font_setting.mValue as i32,
                }
            }).collect::<Vec<_>>().into_boxed_slice()
        )
    }

    
    

    pub fn set_font_variation_settings(&mut self, v: longhands::font_variation_settings::computed_value::T) {
        let iter = v.0.iter().map(|other| structs::gfxFontVariation {
            mTag: other.tag.0,
            mValue: other.value as f32,
        });
        self.gecko.mFont.fontVariationSettings.assign_from_iter_pod(iter);
    }

    pub fn copy_font_variation_settings_from(&mut self, other: &Self) {
        let iter = other.gecko.mFont.fontVariationSettings.iter().map(|s| *s);
        self.gecko.mFont.fontVariationSettings.assign_from_iter_pod(iter);
    }

    pub fn reset_font_variation_settings(&mut self, other: &Self) {
        self.copy_font_variation_settings_from(other)
    }

    pub fn clone_font_variation_settings(&self) -> longhands::font_variation_settings::computed_value::T {
        use crate::values::generics::font::{FontSettings, FontTag, VariationValue};

        FontSettings(
            self.gecko.mFont.fontVariationSettings.iter().map(|gecko_font_setting| {
                VariationValue {
                    tag: FontTag(gecko_font_setting.mTag),
                    value: gecko_font_setting.mValue as f32,
                }
            }).collect::<Vec<_>>().into_boxed_slice()
        )
    }


    pub fn unzoom_fonts(&mut self, device: &Device) {
        use crate::values::generics::NonNegative;
        self.gecko.mSize = NonNegative(device.unzoom_text(self.gecko.mSize.0));
        self.gecko.mScriptUnconstrainedSize = NonNegative(device.unzoom_text(self.gecko.mScriptUnconstrainedSize.0));
        self.gecko.mFont.size = NonNegative(device.unzoom_text(self.gecko.mFont.size.0));
    }

    pub fn copy_font_size_from(&mut self, other: &Self) {
        self.gecko.mScriptUnconstrainedSize = other.gecko.mScriptUnconstrainedSize;

        self.gecko.mSize = other.gecko.mScriptUnconstrainedSize;
        self.gecko.mFont.size = other.gecko.mSize;
        self.gecko.mFontSizeKeyword = other.gecko.mFontSizeKeyword;

        // TODO(emilio): Should we really copy over these two?
        self.gecko.mFontSizeFactor = other.gecko.mFontSizeFactor;
        self.gecko.mFontSizeOffset = other.gecko.mFontSizeOffset;
    }

    pub fn reset_font_size(&mut self, other: &Self) {
        self.copy_font_size_from(other)
    }

    pub fn set_font_size(&mut self, v: FontSize) {
        let size = v.size;
        self.gecko.mScriptUnconstrainedSize = size;

        // These two may be changed from Cascade::fixup_font_stuff.
        self.gecko.mSize = size;
        self.gecko.mFont.size = size;

        self.gecko.mFontSizeKeyword = v.keyword_info.kw;
        self.gecko.mFontSizeFactor = v.keyword_info.factor;
        self.gecko.mFontSizeOffset = v.keyword_info.offset;
    }

    pub fn clone_font_size(&self) -> FontSize {
        use crate::values::specified::font::KeywordInfo;

        FontSize {
            size: self.gecko.mSize,
            keyword_info: KeywordInfo {
                kw: self.gecko.mFontSizeKeyword,
                factor: self.gecko.mFontSizeFactor,
                offset: self.gecko.mFontSizeOffset,
            }
        }
    }

    pub fn set_font_weight(&mut self, v: longhands::font_weight::computed_value::T) {
        unsafe { bindings::Gecko_FontWeight_SetFloat(&mut self.gecko.mFont.weight, v.0) };
    }
    
    #[allow(non_snake_case)]
    pub fn copy_font_weight_from(&mut self, other: &Self) {
        self.gecko.mFont.weight = other.gecko.mFont.weight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_weight(&mut self, other: &Self) {
        self.copy_font_weight_from(other)
    }


    pub fn clone_font_weight(&self) -> longhands::font_weight::computed_value::T {
        let weight: f32 = unsafe {
            bindings::Gecko_FontWeight_ToFloat(self.gecko.mFont.weight)
        };
        longhands::font_weight::computed_value::T(weight)
    }

    pub fn set_font_stretch(&mut self, v: longhands::font_stretch::computed_value::T) {
        unsafe {
            bindings::Gecko_FontStretch_SetFloat(
                &mut self.gecko.mFont.stretch,
                v.value(),
            )
        };
    }
    
    #[allow(non_snake_case)]
    pub fn copy_font_stretch_from(&mut self, other: &Self) {
        self.gecko.mFont.stretch = other.gecko.mFont.stretch.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_stretch(&mut self, other: &Self) {
        self.copy_font_stretch_from(other)
    }

    pub fn clone_font_stretch(&self) -> longhands::font_stretch::computed_value::T {
        use crate::values::computed::font::FontStretch;
        use crate::values::computed::Percentage;
        use crate::values::generics::NonNegative;

        let stretch =
            unsafe { bindings::Gecko_FontStretch_ToFloat(self.gecko.mFont.stretch) };
        debug_assert!(stretch >= 0.);

        FontStretch(NonNegative(Percentage(stretch)))
    }

    pub fn set_font_style(&mut self, v: longhands::font_style::computed_value::T) {
        use crate::values::generics::font::FontStyle;
        let s = &mut self.gecko.mFont.style;
        unsafe {
            match v {
                FontStyle::Normal => bindings::Gecko_FontSlantStyle_SetNormal(s),
                FontStyle::Italic => bindings::Gecko_FontSlantStyle_SetItalic(s),
                FontStyle::Oblique(ref angle) => {
                    bindings::Gecko_FontSlantStyle_SetOblique(s, angle.0.degrees())
                }
            }
        }
    }
    
    #[allow(non_snake_case)]
    pub fn copy_font_style_from(&mut self, other: &Self) {
        self.gecko.mFont.style = other.gecko.mFont.style.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_style(&mut self, other: &Self) {
        self.copy_font_style_from(other)
    }

    pub fn clone_font_style(&self) -> longhands::font_style::computed_value::T {
        use crate::values::computed::font::FontStyle;
        FontStyle::from_gecko(self.gecko.mFont.style)
    }

    
    #[allow(non_snake_case)]
    pub fn set_font_synthesis(&mut self, v: longhands::font_synthesis::computed_value::T) {
        self.gecko.mFont.synthesis = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_synthesis_from(&mut self, other: &Self) {
        self.gecko.mFont.synthesis = other.gecko.mFont.synthesis.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_synthesis(&mut self, other: &Self) {
        self.copy_font_synthesis_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_synthesis(&self) -> longhands::font_synthesis::computed_value::T {
        From::from(self.gecko.mFont.synthesis)
    }


    

    #[allow(non_snake_case)]
    pub fn set_font_variant_alternates(&mut self, v: longhands::font_variant_alternates::computed_value::T) {
        self.gecko.mFont.variantAlternates = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_font_variant_alternates_from(&mut self, other: &Self) {
        self.gecko.mFont.variantAlternates = other.gecko.mFont.variantAlternates.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_alternates(&mut self, other: &Self) {
        self.copy_font_variant_alternates_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_alternates(&self) -> longhands::font_variant_alternates::computed_value::T {
        From::from(self.gecko.mFont.variantAlternates.clone())
    }



    

    #[allow(non_snake_case)]
    pub fn set_font_size_adjust(&mut self, v: longhands::font_size_adjust::computed_value::T) {
        self.gecko.mFont.sizeAdjust = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_font_size_adjust_from(&mut self, other: &Self) {
        self.gecko.mFont.sizeAdjust = other.gecko.mFont.sizeAdjust.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_size_adjust(&mut self, other: &Self) {
        self.copy_font_size_adjust_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_size_adjust(&self) -> longhands::font_size_adjust::computed_value::T {
        From::from(self.gecko.mFont.sizeAdjust.clone())
    }



    

    #[allow(non_snake_case)]
    pub fn set_font_family(&mut self, v: longhands::font_family::computed_value::T) {
        self.gecko.mFont.family = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_font_family_from(&mut self, other: &Self) {
        self.gecko.mFont.family = other.gecko.mFont.family.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_family(&mut self, other: &Self) {
        self.copy_font_family_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_family(&self) -> longhands::font_family::computed_value::T {
        From::from(self.gecko.mFont.family.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__x_lang(&mut self, v: longhands::_x_lang::computed_value::T) {
        let ptr = v.0.as_ptr();
        forget(v);
        unsafe {
            Gecko_nsStyleFont_SetLang(&mut *self.gecko, ptr);
        }
    }

    #[allow(non_snake_case)]
    pub fn copy__x_lang_from(&mut self, other: &Self) {
        unsafe {
            Gecko_nsStyleFont_CopyLangFrom(&mut *self.gecko, &*other.gecko);
        }
    }

    #[allow(non_snake_case)]
    pub fn reset__x_lang(&mut self, other: &Self) {
        self.copy__x_lang_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__x_lang(&self) -> longhands::_x_lang::computed_value::T {
        longhands::_x_lang::computed_value::T(unsafe {
            Atom::from_raw(self.gecko.mLanguage.mRawPtr)
        })
    }

    #[allow(non_snake_case)]
    pub fn set__x_text_zoom(&mut self, v: longhands::_x_text_zoom::computed_value::T) {
        self.gecko.mAllowZoomAndMinSize = v.0;
    }

    #[allow(non_snake_case)]
    pub fn copy__x_text_zoom_from(&mut self, other: &Self) {
        self.gecko.mAllowZoomAndMinSize = other.gecko.mAllowZoomAndMinSize;
    }

    #[allow(non_snake_case)]
    pub fn reset__x_text_zoom(&mut self, other: &Self) {
        self.copy__x_text_zoom_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__x_text_zoom(&self) -> longhands::_x_text_zoom::computed_value::T {
        longhands::_x_text_zoom::computed_value::T(self.gecko.mAllowZoomAndMinSize)
    }

    
    #[allow(non_snake_case)]
    pub fn set_font_language_override(&mut self, v: longhands::font_language_override::computed_value::T) {
        self.gecko.mFont.languageOverride = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_language_override_from(&mut self, other: &Self) {
        self.gecko.mFont.languageOverride = other.gecko.mFont.languageOverride.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_language_override(&mut self, other: &Self) {
        self.copy_font_language_override_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_language_override(&self) -> longhands::font_language_override::computed_value::T {
        From::from(self.gecko.mFont.languageOverride)
    }

    
    #[allow(non_snake_case)]
    pub fn set_font_variant_ligatures(&mut self, v: longhands::font_variant_ligatures::computed_value::T) {
        self.gecko.mFont.variantLigatures = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_variant_ligatures_from(&mut self, other: &Self) {
        self.gecko.mFont.variantLigatures = other.gecko.mFont.variantLigatures.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_ligatures(&mut self, other: &Self) {
        self.copy_font_variant_ligatures_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_ligatures(&self) -> longhands::font_variant_ligatures::computed_value::T {
        From::from(self.gecko.mFont.variantLigatures)
    }

    
    #[allow(non_snake_case)]
    pub fn set_font_variant_east_asian(&mut self, v: longhands::font_variant_east_asian::computed_value::T) {
        self.gecko.mFont.variantEastAsian = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_variant_east_asian_from(&mut self, other: &Self) {
        self.gecko.mFont.variantEastAsian = other.gecko.mFont.variantEastAsian.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_east_asian(&mut self, other: &Self) {
        self.copy_font_variant_east_asian_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_east_asian(&self) -> longhands::font_variant_east_asian::computed_value::T {
        From::from(self.gecko.mFont.variantEastAsian)
    }

    
    #[allow(non_snake_case)]
    pub fn set_font_variant_numeric(&mut self, v: longhands::font_variant_numeric::computed_value::T) {
        self.gecko.mFont.variantNumeric = From::from(v)
    }

    
    #[allow(non_snake_case)]
    pub fn copy_font_variant_numeric_from(&mut self, other: &Self) {
        self.gecko.mFont.variantNumeric = other.gecko.mFont.variantNumeric.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_numeric(&mut self, other: &Self) {
        self.copy_font_variant_numeric_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_numeric(&self) -> longhands::font_variant_numeric::computed_value::T {
        From::from(self.gecko.mFont.variantNumeric)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_min_font_size_ratio(
        &self,
    ) -> longhands::_moz_min_font_size_ratio::computed_value::T {
        Percentage(self.gecko.mMinFontSizeRatio as f32 / 100.)
    }

    #[allow(non_snake_case)]
    pub fn set__moz_min_font_size_ratio(&mut self, v: longhands::_moz_min_font_size_ratio::computed_value::T) {
        let scaled = v.0 * 100.;
        let percentage = if scaled > 255. {
            255.
        } else if scaled < 0. {
            0.
        } else {
            scaled
        };

        self.gecko.mMinFontSizeRatio = percentage as u8;
    }

    
    #[allow(non_snake_case)]
    pub fn copy__moz_min_font_size_ratio_from(&mut self, other: &Self) {
        self.gecko.mMinFontSizeRatio = other.gecko.mMinFontSizeRatio.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_min_font_size_ratio(&mut self, other: &Self) {
        self.copy__moz_min_font_size_ratio_from(other)
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_font_variant_caps(&mut self, v: longhands::font_variant_caps::computed_value::T) {
        use crate::properties::longhands::font_variant_caps::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_FONT_VARIANT_CAPS_NORMAL as u8,
                Keyword::SmallCaps =>
                    structs::NS_FONT_VARIANT_CAPS_SMALLCAPS as u8,
                Keyword::AllSmallCaps =>
                    structs::NS_FONT_VARIANT_CAPS_ALLSMALL as u8,
                Keyword::PetiteCaps =>
                    structs::NS_FONT_VARIANT_CAPS_PETITECAPS as u8,
                Keyword::AllPetiteCaps =>
                    structs::NS_FONT_VARIANT_CAPS_ALLPETITE as u8,
                Keyword::Unicase =>
                    structs::NS_FONT_VARIANT_CAPS_UNICASE as u8,
                Keyword::TitlingCaps =>
                    structs::NS_FONT_VARIANT_CAPS_TITLING as u8,
        };
        self.gecko.mFont.variantCaps = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_variant_caps_from(&mut self, other: &Self) {
        self.gecko.mFont.variantCaps = other.gecko.mFont.variantCaps.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_caps(&mut self, other: &Self) {
        self.copy_font_variant_caps_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_caps(&self) -> longhands::font_variant_caps::computed_value::T {
        use crate::properties::longhands::font_variant_caps::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_VARIANT_CAPS_NORMAL : u8 =
            structs::NS_FONT_VARIANT_CAPS_NORMAL as u8;
        const U8_NS_FONT_VARIANT_CAPS_SMALLCAPS : u8 =
            structs::NS_FONT_VARIANT_CAPS_SMALLCAPS as u8;
        const U8_NS_FONT_VARIANT_CAPS_ALLSMALL : u8 =
            structs::NS_FONT_VARIANT_CAPS_ALLSMALL as u8;
        const U8_NS_FONT_VARIANT_CAPS_PETITECAPS : u8 =
            structs::NS_FONT_VARIANT_CAPS_PETITECAPS as u8;
        const U8_NS_FONT_VARIANT_CAPS_ALLPETITE : u8 =
            structs::NS_FONT_VARIANT_CAPS_ALLPETITE as u8;
        const U8_NS_FONT_VARIANT_CAPS_UNICASE : u8 =
            structs::NS_FONT_VARIANT_CAPS_UNICASE as u8;
        const U8_NS_FONT_VARIANT_CAPS_TITLING : u8 =
            structs::NS_FONT_VARIANT_CAPS_TITLING as u8;

        match self.gecko.mFont.variantCaps as u8 {
            U8_NS_FONT_VARIANT_CAPS_NORMAL => Keyword::Normal,
            U8_NS_FONT_VARIANT_CAPS_SMALLCAPS => Keyword::SmallCaps,
            U8_NS_FONT_VARIANT_CAPS_ALLSMALL => Keyword::AllSmallCaps,
            U8_NS_FONT_VARIANT_CAPS_PETITECAPS => Keyword::PetiteCaps,
            U8_NS_FONT_VARIANT_CAPS_ALLPETITE => Keyword::AllPetiteCaps,
            U8_NS_FONT_VARIANT_CAPS_UNICASE => Keyword::Unicase,
            U8_NS_FONT_VARIANT_CAPS_TITLING => Keyword::TitlingCaps,
            _ => panic!("Found unexpected value in style struct for font_variant_caps property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_font_kerning(&mut self, v: longhands::font_kerning::computed_value::T) {
        use crate::properties::longhands::font_kerning::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_FONT_KERNING_AUTO as u8,
                Keyword::None =>
                    structs::NS_FONT_KERNING_NONE as u8,
                Keyword::Normal =>
                    structs::NS_FONT_KERNING_NORMAL as u8,
        };
        self.gecko.mFont.kerning = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_kerning_from(&mut self, other: &Self) {
        self.gecko.mFont.kerning = other.gecko.mFont.kerning.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_kerning(&mut self, other: &Self) {
        self.copy_font_kerning_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_kerning(&self) -> longhands::font_kerning::computed_value::T {
        use crate::properties::longhands::font_kerning::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_KERNING_AUTO : u8 =
            structs::NS_FONT_KERNING_AUTO as u8;
        const U8_NS_FONT_KERNING_NONE : u8 =
            structs::NS_FONT_KERNING_NONE as u8;
        const U8_NS_FONT_KERNING_NORMAL : u8 =
            structs::NS_FONT_KERNING_NORMAL as u8;

        match self.gecko.mFont.kerning as u8 {
            U8_NS_FONT_KERNING_AUTO => Keyword::Auto,
            U8_NS_FONT_KERNING_NONE => Keyword::None,
            U8_NS_FONT_KERNING_NORMAL => Keyword::Normal,
            _ => panic!("Found unexpected value in style struct for font_kerning property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_font_variant_position(&mut self, v: longhands::font_variant_position::computed_value::T) {
        use crate::properties::longhands::font_variant_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_FONT_VARIANT_POSITION_NORMAL as u8,
                Keyword::Sub =>
                    structs::NS_FONT_VARIANT_POSITION_SUB as u8,
                Keyword::Super =>
                    structs::NS_FONT_VARIANT_POSITION_SUPER as u8,
        };
        self.gecko.mFont.variantPosition = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_variant_position_from(&mut self, other: &Self) {
        self.gecko.mFont.variantPosition = other.gecko.mFont.variantPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_variant_position(&mut self, other: &Self) {
        self.copy_font_variant_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_variant_position(&self) -> longhands::font_variant_position::computed_value::T {
        use crate::properties::longhands::font_variant_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_VARIANT_POSITION_NORMAL : u8 =
            structs::NS_FONT_VARIANT_POSITION_NORMAL as u8;
        const U8_NS_FONT_VARIANT_POSITION_SUB : u8 =
            structs::NS_FONT_VARIANT_POSITION_SUB as u8;
        const U8_NS_FONT_VARIANT_POSITION_SUPER : u8 =
            structs::NS_FONT_VARIANT_POSITION_SUPER as u8;

        match self.gecko.mFont.variantPosition as u8 {
            U8_NS_FONT_VARIANT_POSITION_NORMAL => Keyword::Normal,
            U8_NS_FONT_VARIANT_POSITION_SUB => Keyword::Sub,
            U8_NS_FONT_VARIANT_POSITION_SUPER => Keyword::Super,
            _ => panic!("Found unexpected value in style struct for font_variant_position property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_font_optical_sizing(&mut self, v: longhands::font_optical_sizing::computed_value::T) {
        use crate::properties::longhands::font_optical_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_FONT_OPTICAL_SIZING_AUTO as u8,
                Keyword::None =>
                    structs::NS_FONT_OPTICAL_SIZING_NONE as u8,
        };
        self.gecko.mFont.opticalSizing = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_font_optical_sizing_from(&mut self, other: &Self) {
        self.gecko.mFont.opticalSizing = other.gecko.mFont.opticalSizing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_font_optical_sizing(&mut self, other: &Self) {
        self.copy_font_optical_sizing_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_font_optical_sizing(&self) -> longhands::font_optical_sizing::computed_value::T {
        use crate::properties::longhands::font_optical_sizing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_OPTICAL_SIZING_AUTO : u8 =
            structs::NS_FONT_OPTICAL_SIZING_AUTO as u8;
        const U8_NS_FONT_OPTICAL_SIZING_NONE : u8 =
            structs::NS_FONT_OPTICAL_SIZING_NONE as u8;

        match self.gecko.mFont.opticalSizing as u8 {
            U8_NS_FONT_OPTICAL_SIZING_AUTO => Keyword::Auto,
            U8_NS_FONT_OPTICAL_SIZING_NONE => Keyword::None,
            _ => panic!("Found unexpected value in style struct for font_optical_sizing property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_script_size_multiplier(&mut self, v: longhands::_moz_script_size_multiplier::computed_value::T) {
        self.gecko.mScriptSizeMultiplier = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_script_size_multiplier_from(&mut self, other: &Self) {
        self.gecko.mScriptSizeMultiplier = other.gecko.mScriptSizeMultiplier.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_script_size_multiplier(&mut self, other: &Self) {
        self.copy__moz_script_size_multiplier_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_script_size_multiplier(&self) -> longhands::_moz_script_size_multiplier::computed_value::T {
        From::from(self.gecko.mScriptSizeMultiplier.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_math_depth(&mut self, v: longhands::math_depth::computed_value::T) {
        self.gecko.mMathDepth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_math_depth_from(&mut self, other: &Self) {
        self.gecko.mMathDepth = other.gecko.mMathDepth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_math_depth(&mut self, other: &Self) {
        self.copy_math_depth_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_math_depth(&self) -> longhands::math_depth::computed_value::T {
        From::from(self.gecko.mMathDepth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_math_style(&mut self, v: longhands::math_style::computed_value::T) {
        use crate::properties::longhands::math_style::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_STYLE_MATH_STYLE_NORMAL as u8,
                Keyword::Compact =>
                    structs::NS_STYLE_MATH_STYLE_COMPACT as u8,
        };
        self.gecko.mMathStyle = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_math_style_from(&mut self, other: &Self) {
        self.gecko.mMathStyle = other.gecko.mMathStyle.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_math_style(&mut self, other: &Self) {
        self.copy_math_style_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_math_style(&self) -> longhands::math_style::computed_value::T {
        use crate::properties::longhands::math_style::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_MATH_STYLE_NORMAL : u8 =
            structs::NS_STYLE_MATH_STYLE_NORMAL as u8;
        const U8_NS_STYLE_MATH_STYLE_COMPACT : u8 =
            structs::NS_STYLE_MATH_STYLE_COMPACT as u8;

        match self.gecko.mMathStyle as u8 {
            U8_NS_STYLE_MATH_STYLE_NORMAL => Keyword::Normal,
            U8_NS_STYLE_MATH_STYLE_COMPACT => Keyword::Compact,
            _ => panic!("Found unexpected value in style struct for math_style property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_math_variant(&mut self, v: longhands::_moz_math_variant::computed_value::T) {
        use crate::properties::longhands::_moz_math_variant::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleMathVariant::None ,
                Keyword::Normal =>
                    structs::StyleMathVariant::Normal ,
                Keyword::Bold =>
                    structs::StyleMathVariant::Bold ,
                Keyword::Italic =>
                    structs::StyleMathVariant::Italic ,
                Keyword::BoldItalic =>
                    structs::StyleMathVariant::BoldItalic ,
                Keyword::Script =>
                    structs::StyleMathVariant::Script ,
                Keyword::BoldScript =>
                    structs::StyleMathVariant::BoldScript ,
                Keyword::Fraktur =>
                    structs::StyleMathVariant::Fraktur ,
                Keyword::DoubleStruck =>
                    structs::StyleMathVariant::DoubleStruck ,
                Keyword::BoldFraktur =>
                    structs::StyleMathVariant::BoldFraktur ,
                Keyword::SansSerif =>
                    structs::StyleMathVariant::SansSerif ,
                Keyword::BoldSansSerif =>
                    structs::StyleMathVariant::BoldSansSerif ,
                Keyword::SansSerifItalic =>
                    structs::StyleMathVariant::SansSerifItalic ,
                Keyword::SansSerifBoldItalic =>
                    structs::StyleMathVariant::SansSerifBoldItalic ,
                Keyword::Monospace =>
                    structs::StyleMathVariant::Monospace ,
                Keyword::Initial =>
                    structs::StyleMathVariant::Initial ,
                Keyword::Tailed =>
                    structs::StyleMathVariant::Tailed ,
                Keyword::Looped =>
                    structs::StyleMathVariant::Looped ,
                Keyword::Stretched =>
                    structs::StyleMathVariant::Stretched ,
        };
        self.gecko.mMathVariant = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_math_variant_from(&mut self, other: &Self) {
        self.gecko.mMathVariant = other.gecko.mMathVariant.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_math_variant(&mut self, other: &Self) {
        self.copy__moz_math_variant_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_math_variant(&self) -> longhands::_moz_math_variant::computed_value::T {
        use crate::properties::longhands::_moz_math_variant::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mMathVariant {
            structs::StyleMathVariant::None => Keyword::None,
            structs::StyleMathVariant::Normal => Keyword::Normal,
            structs::StyleMathVariant::Bold => Keyword::Bold,
            structs::StyleMathVariant::Italic => Keyword::Italic,
            structs::StyleMathVariant::BoldItalic => Keyword::BoldItalic,
            structs::StyleMathVariant::Script => Keyword::Script,
            structs::StyleMathVariant::BoldScript => Keyword::BoldScript,
            structs::StyleMathVariant::Fraktur => Keyword::Fraktur,
            structs::StyleMathVariant::DoubleStruck => Keyword::DoubleStruck,
            structs::StyleMathVariant::BoldFraktur => Keyword::BoldFraktur,
            structs::StyleMathVariant::SansSerif => Keyword::SansSerif,
            structs::StyleMathVariant::BoldSansSerif => Keyword::BoldSansSerif,
            structs::StyleMathVariant::SansSerifItalic => Keyword::SansSerifItalic,
            structs::StyleMathVariant::SansSerifBoldItalic => Keyword::SansSerifBoldItalic,
            structs::StyleMathVariant::Monospace => Keyword::Monospace,
            structs::StyleMathVariant::Initial => Keyword::Initial,
            structs::StyleMathVariant::Tailed => Keyword::Tailed,
            structs::StyleMathVariant::Looped => Keyword::Looped,
            structs::StyleMathVariant::Stretched => Keyword::Stretched,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_script_min_size(&mut self, v: longhands::_moz_script_min_size::computed_value::T) {
        self.gecko.mScriptMinSize = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_script_min_size_from(&mut self, other: &Self) {
        self.gecko.mScriptMinSize = other.gecko.mScriptMinSize.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_script_min_size(&mut self, other: &Self) {
        self.copy__moz_script_min_size_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_script_min_size(&self) -> longhands::_moz_script_min_size::computed_value::T {
        From::from(self.gecko.mScriptMinSize.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_osx_font_smoothing(&mut self, v: longhands::_moz_osx_font_smoothing::computed_value::T) {
        use crate::properties::longhands::_moz_osx_font_smoothing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::NS_FONT_SMOOTHING_AUTO as u8,
                Keyword::Grayscale =>
                    structs::NS_FONT_SMOOTHING_GRAYSCALE as u8,
        };
        self.gecko.mFont.smoothing = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_osx_font_smoothing_from(&mut self, other: &Self) {
        self.gecko.mFont.smoothing = other.gecko.mFont.smoothing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_osx_font_smoothing(&mut self, other: &Self) {
        self.copy__moz_osx_font_smoothing_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_osx_font_smoothing(&self) -> longhands::_moz_osx_font_smoothing::computed_value::T {
        use crate::properties::longhands::_moz_osx_font_smoothing::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_FONT_SMOOTHING_AUTO : u8 =
            structs::NS_FONT_SMOOTHING_AUTO as u8;
        const U8_NS_FONT_SMOOTHING_GRAYSCALE : u8 =
            structs::NS_FONT_SMOOTHING_GRAYSCALE as u8;

        match self.gecko.mFont.smoothing as u8 {
            U8_NS_FONT_SMOOTHING_AUTO => Keyword::Auto,
            U8_NS_FONT_SMOOTHING_GRAYSCALE => Keyword::Grayscale,
            _ => panic!("Found unexpected value in style struct for _moz_osx_font_smoothing property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_font_smoothing_background_color(&mut self, v: longhands::_moz_font_smoothing_background_color::computed_value::T) {
        self.gecko.mFont.fontSmoothingBackgroundColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_font_smoothing_background_color_from(&mut self, other: &Self) {
        self.gecko.mFont.fontSmoothingBackgroundColor = other.gecko.mFont.fontSmoothingBackgroundColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_font_smoothing_background_color(&mut self, other: &Self) {
        self.copy__moz_font_smoothing_background_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_font_smoothing_background_color(&self) -> longhands::_moz_font_smoothing_background_color::computed_value::T {
        From::from(self.gecko.mFont.fontSmoothingBackgroundColor.clone())
    }


}


























impl GeckoBox {
    /*
     * Manually-Implemented Methods.
     */
    
    #[inline]
    pub fn set_display(&mut self, v: longhands::display::computed_value::T) {
        self.gecko.mDisplay = v;
        self.gecko.mOriginalDisplay = v;
    }

    #[inline]
    pub fn copy_display_from(&mut self, other: &Self) {
        self.gecko.mDisplay = other.gecko.mDisplay;
        self.gecko.mOriginalDisplay = other.gecko.mDisplay;
    }

    #[inline]
    pub fn reset_display(&mut self, other: &Self) {
        self.copy_display_from(other)
    }

    #[inline]
    pub fn set_adjusted_display(
        &mut self,
        v: longhands::display::computed_value::T,
        _is_item_or_root: bool
    ) {
        self.gecko.mDisplay = v;
    }

    #[inline]
    pub fn clone_display(&self) -> longhands::display::computed_value::T {
        self.gecko.mDisplay
    }

    
    

    #[allow(non_snake_case)]
    pub fn set_clear(&mut self, v: longhands::clear::computed_value::T) {
        use crate::properties::longhands::clear::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Left =>
                    structs::StyleClear::Left ,
                Keyword::Right =>
                    structs::StyleClear::Right ,
                Keyword::None =>
                    structs::StyleClear::None ,
                Keyword::Both =>
                    structs::StyleClear::Both ,
        };
        self.gecko.mBreakType = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_clear_from(&mut self, other: &Self) {
        self.gecko.mBreakType = other.gecko.mBreakType.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_clear(&mut self, other: &Self) {
        self.copy_clear_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_clear(&self) -> longhands::clear::computed_value::T {
        use crate::properties::longhands::clear::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBreakType {
            structs::StyleClear::Left => Keyword::Left,
            structs::StyleClear::Right => Keyword::Right,
            structs::StyleClear::None => Keyword::None,
            structs::StyleClear::Both => Keyword::Both,
            _ => panic!("Found unexpected value in style struct for clear property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__webkit_line_clamp(&mut self, v: longhands::_webkit_line_clamp::computed_value::T) {
        self.gecko.mLineClamp = match v {
            Either::First(n) => n.0 as u32,
            Either::Second(None_) => 0,
        };
    }

    
    #[allow(non_snake_case)]
    pub fn copy__webkit_line_clamp_from(&mut self, other: &Self) {
        self.gecko.mLineClamp = other.gecko.mLineClamp.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_line_clamp(&mut self, other: &Self) {
        self.copy__webkit_line_clamp_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__webkit_line_clamp(&self) -> longhands::_webkit_line_clamp::computed_value::T {
        match self.gecko.mLineClamp {
            0 => Either::Second(None_),
            n => {
                debug_assert!(n <= std::i32::MAX as u32);
                Either::First((n as i32).into())
            }
        }
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set__moz_top_layer(&mut self, v: longhands::_moz_top_layer::computed_value::T) {
        use crate::properties::longhands::_moz_top_layer::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleTopLayer::None ,
                Keyword::Top =>
                    structs::StyleTopLayer::Top ,
        };
        self.gecko.mTopLayer = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_top_layer_from(&mut self, other: &Self) {
        self.gecko.mTopLayer = other.gecko.mTopLayer.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_top_layer(&mut self, other: &Self) {
        self.copy__moz_top_layer_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_top_layer(&self) -> longhands::_moz_top_layer::computed_value::T {
        use crate::properties::longhands::_moz_top_layer::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mTopLayer {
            structs::StyleTopLayer::None => Keyword::None,
            structs::StyleTopLayer::Top => Keyword::Top,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_position(&mut self, v: longhands::position::computed_value::T) {
        use crate::properties::longhands::position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Static =>
                    structs::StylePositionProperty::Static ,
                Keyword::Absolute =>
                    structs::StylePositionProperty::Absolute ,
                Keyword::Relative =>
                    structs::StylePositionProperty::Relative ,
                Keyword::Fixed =>
                    structs::StylePositionProperty::Fixed ,
                Keyword::Sticky =>
                    structs::StylePositionProperty::Sticky ,
        };
        self.gecko.mPosition = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_position_from(&mut self, other: &Self) {
        self.gecko.mPosition = other.gecko.mPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_position(&mut self, other: &Self) {
        self.copy_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_position(&self) -> longhands::position::computed_value::T {
        use crate::properties::longhands::position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mPosition {
            structs::StylePositionProperty::Static => Keyword::Static,
            structs::StylePositionProperty::Absolute => Keyword::Absolute,
            structs::StylePositionProperty::Relative => Keyword::Relative,
            structs::StylePositionProperty::Fixed => Keyword::Fixed,
            structs::StylePositionProperty::Sticky => Keyword::Sticky,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_float(&mut self, v: longhands::float::computed_value::T) {
        self.gecko.mFloat = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_float_from(&mut self, other: &Self) {
        self.gecko.mFloat = other.gecko.mFloat.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_float(&mut self, other: &Self) {
        self.copy_float_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_float(&self) -> longhands::float::computed_value::T {
        From::from(self.gecko.mFloat.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_vertical_align(&mut self, v: longhands::vertical_align::computed_value::T) {
        self.gecko.mVerticalAlign = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_vertical_align_from(&mut self, other: &Self) {
        self.gecko.mVerticalAlign = other.gecko.mVerticalAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_vertical_align(&mut self, other: &Self) {
        self.copy_vertical_align_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_vertical_align(&self) -> longhands::vertical_align::computed_value::T {
        From::from(self.gecko.mVerticalAlign.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_clip_box_inline(&mut self, v: longhands::overflow_clip_box_inline::computed_value::T) {
        self.gecko.mOverflowClipBoxInline = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_clip_box_inline_from(&mut self, other: &Self) {
        self.gecko.mOverflowClipBoxInline = other.gecko.mOverflowClipBoxInline.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_clip_box_inline(&mut self, other: &Self) {
        self.copy_overflow_clip_box_inline_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_clip_box_inline(&self) -> longhands::overflow_clip_box_inline::computed_value::T {
        From::from(self.gecko.mOverflowClipBoxInline.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_clip_box_block(&mut self, v: longhands::overflow_clip_box_block::computed_value::T) {
        self.gecko.mOverflowClipBoxBlock = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_clip_box_block_from(&mut self, other: &Self) {
        self.gecko.mOverflowClipBoxBlock = other.gecko.mOverflowClipBoxBlock.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_clip_box_block(&mut self, other: &Self) {
        self.copy_overflow_clip_box_block_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_clip_box_block(&self) -> longhands::overflow_clip_box_block::computed_value::T {
        From::from(self.gecko.mOverflowClipBoxBlock.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_x(&mut self, v: longhands::overflow_x::computed_value::T) {
        self.gecko.mOverflowX = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_x_from(&mut self, other: &Self) {
        self.gecko.mOverflowX = other.gecko.mOverflowX.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_x(&mut self, other: &Self) {
        self.copy_overflow_x_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_x(&self) -> longhands::overflow_x::computed_value::T {
        From::from(self.gecko.mOverflowX.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_y(&mut self, v: longhands::overflow_y::computed_value::T) {
        self.gecko.mOverflowY = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_y_from(&mut self, other: &Self) {
        self.gecko.mOverflowY = other.gecko.mOverflowY.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_y(&mut self, other: &Self) {
        self.copy_overflow_y_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_y(&self) -> longhands::overflow_y::computed_value::T {
        From::from(self.gecko.mOverflowY.clone())
    }


    
    /// Set the appropriate physical property for overflow-inline given a writing mode.
    pub fn set_overflow_inline(&mut self,
                                      v: longhands::overflow_inline::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_overflow_y(v)
            
        } else {
            
                self.set_overflow_x(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overflow-inline
    /// given a writing mode.
    pub fn copy_overflow_inline_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_overflow_y_from(other)
            
        } else {
            
                self.copy_overflow_x_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overflow-inline
    /// given a writing mode.
    pub fn reset_overflow_inline(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_overflow_inline_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// overflow-inline given a writing mode.
    pub fn clone_overflow_inline(&self, wm: WritingMode)
        -> longhands::overflow_inline::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_overflow_y()
        
        } else {
            
            self.clone_overflow_x()
        
        }

    }


    
    /// Set the appropriate physical property for overflow-block given a writing mode.
    pub fn set_overflow_block(&mut self,
                                      v: longhands::overflow_block::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_overflow_x(v)
            
        } else {
            
                self.set_overflow_y(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overflow-block
    /// given a writing mode.
    pub fn copy_overflow_block_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_overflow_x_from(other)
            
        } else {
            
                self.copy_overflow_y_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overflow-block
    /// given a writing mode.
    pub fn reset_overflow_block(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_overflow_block_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// overflow-block given a writing mode.
    pub fn clone_overflow_block(&self, wm: WritingMode)
        -> longhands::overflow_block::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_overflow_x()
        
        } else {
            
            self.clone_overflow_y()
        
        }

    }



    #[allow(non_snake_case)]
    pub fn set_overflow_anchor(&mut self, v: longhands::overflow_anchor::computed_value::T) {
        self.gecko.mOverflowAnchor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_anchor_from(&mut self, other: &Self) {
        self.gecko.mOverflowAnchor = other.gecko.mOverflowAnchor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_anchor(&mut self, other: &Self) {
        self.copy_overflow_anchor_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_anchor(&self) -> longhands::overflow_anchor::computed_value::T {
        From::from(self.gecko.mOverflowAnchor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_transform(&mut self, v: longhands::transform::computed_value::T) {
        self.gecko.mTransform = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_transform_from(&mut self, other: &Self) {
        self.gecko.mTransform = other.gecko.mTransform.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_transform(&mut self, other: &Self) {
        self.copy_transform_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_transform(&self) -> longhands::transform::computed_value::T {
        From::from(self.gecko.mTransform.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_rotate(&mut self, v: longhands::rotate::computed_value::T) {
        self.gecko.mRotate = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_rotate_from(&mut self, other: &Self) {
        self.gecko.mRotate = other.gecko.mRotate.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_rotate(&mut self, other: &Self) {
        self.copy_rotate_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_rotate(&self) -> longhands::rotate::computed_value::T {
        From::from(self.gecko.mRotate.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scale(&mut self, v: longhands::scale::computed_value::T) {
        self.gecko.mScale = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scale_from(&mut self, other: &Self) {
        self.gecko.mScale = other.gecko.mScale.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scale(&mut self, other: &Self) {
        self.copy_scale_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scale(&self) -> longhands::scale::computed_value::T {
        From::from(self.gecko.mScale.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_translate(&mut self, v: longhands::translate::computed_value::T) {
        self.gecko.mTranslate = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_translate_from(&mut self, other: &Self) {
        self.gecko.mTranslate = other.gecko.mTranslate.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_translate(&mut self, other: &Self) {
        self.copy_translate_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_translate(&self) -> longhands::translate::computed_value::T {
        From::from(self.gecko.mTranslate.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_offset_path(&mut self, v: longhands::offset_path::computed_value::T) {
        self.gecko.mOffsetPath = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_offset_path_from(&mut self, other: &Self) {
        self.gecko.mOffsetPath = other.gecko.mOffsetPath.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_offset_path(&mut self, other: &Self) {
        self.copy_offset_path_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_offset_path(&self) -> longhands::offset_path::computed_value::T {
        From::from(self.gecko.mOffsetPath.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_offset_distance(&mut self, v: longhands::offset_distance::computed_value::T) {
        self.gecko.mOffsetDistance = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_offset_distance_from(&mut self, other: &Self) {
        self.gecko.mOffsetDistance = other.gecko.mOffsetDistance.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_offset_distance(&mut self, other: &Self) {
        self.copy_offset_distance_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_offset_distance(&self) -> longhands::offset_distance::computed_value::T {
        From::from(self.gecko.mOffsetDistance.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_offset_rotate(&mut self, v: longhands::offset_rotate::computed_value::T) {
        self.gecko.mOffsetRotate = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_offset_rotate_from(&mut self, other: &Self) {
        self.gecko.mOffsetRotate = other.gecko.mOffsetRotate.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_offset_rotate(&mut self, other: &Self) {
        self.copy_offset_rotate_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_offset_rotate(&self) -> longhands::offset_rotate::computed_value::T {
        From::from(self.gecko.mOffsetRotate.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_offset_anchor(&mut self, v: longhands::offset_anchor::computed_value::T) {
        self.gecko.mOffsetAnchor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_offset_anchor_from(&mut self, other: &Self) {
        self.gecko.mOffsetAnchor = other.gecko.mOffsetAnchor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_offset_anchor(&mut self, other: &Self) {
        self.copy_offset_anchor_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_offset_anchor(&self) -> longhands::offset_anchor::computed_value::T {
        From::from(self.gecko.mOffsetAnchor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scroll_behavior(&mut self, v: longhands::scroll_behavior::computed_value::T) {
        use crate::properties::longhands::scroll_behavior::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleScrollBehavior::Auto ,
                Keyword::Smooth =>
                    structs::StyleScrollBehavior::Smooth ,
        };
        self.gecko.mScrollBehavior = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_scroll_behavior_from(&mut self, other: &Self) {
        self.gecko.mScrollBehavior = other.gecko.mScrollBehavior.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_behavior(&mut self, other: &Self) {
        self.copy_scroll_behavior_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scroll_behavior(&self) -> longhands::scroll_behavior::computed_value::T {
        use crate::properties::longhands::scroll_behavior::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mScrollBehavior {
            structs::StyleScrollBehavior::Auto => Keyword::Auto,
            structs::StyleScrollBehavior::Smooth => Keyword::Smooth,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_scroll_snap_align(&mut self, v: longhands::scroll_snap_align::computed_value::T) {
        self.gecko.mScrollSnapAlign = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_align_from(&mut self, other: &Self) {
        self.gecko.mScrollSnapAlign = other.gecko.mScrollSnapAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_align(&mut self, other: &Self) {
        self.copy_scroll_snap_align_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_align(&self) -> longhands::scroll_snap_align::computed_value::T {
        From::from(self.gecko.mScrollSnapAlign.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scroll_snap_type(&mut self, v: longhands::scroll_snap_type::computed_value::T) {
        self.gecko.mScrollSnapType = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scroll_snap_type_from(&mut self, other: &Self) {
        self.gecko.mScrollSnapType = other.gecko.mScrollSnapType.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scroll_snap_type(&mut self, other: &Self) {
        self.copy_scroll_snap_type_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scroll_snap_type(&self) -> longhands::scroll_snap_type::computed_value::T {
        From::from(self.gecko.mScrollSnapType.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overscroll_behavior_x(&mut self, v: longhands::overscroll_behavior_x::computed_value::T) {
        self.gecko.mOverscrollBehaviorX = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overscroll_behavior_x_from(&mut self, other: &Self) {
        self.gecko.mOverscrollBehaviorX = other.gecko.mOverscrollBehaviorX.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overscroll_behavior_x(&mut self, other: &Self) {
        self.copy_overscroll_behavior_x_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overscroll_behavior_x(&self) -> longhands::overscroll_behavior_x::computed_value::T {
        From::from(self.gecko.mOverscrollBehaviorX.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overscroll_behavior_y(&mut self, v: longhands::overscroll_behavior_y::computed_value::T) {
        self.gecko.mOverscrollBehaviorY = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overscroll_behavior_y_from(&mut self, other: &Self) {
        self.gecko.mOverscrollBehaviorY = other.gecko.mOverscrollBehaviorY.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overscroll_behavior_y(&mut self, other: &Self) {
        self.copy_overscroll_behavior_y_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overscroll_behavior_y(&self) -> longhands::overscroll_behavior_y::computed_value::T {
        From::from(self.gecko.mOverscrollBehaviorY.clone())
    }


    
    /// Set the appropriate physical property for overscroll-behavior-inline given a writing mode.
    pub fn set_overscroll_behavior_inline(&mut self,
                                      v: longhands::overscroll_behavior_inline::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_overscroll_behavior_y(v)
            
        } else {
            
                self.set_overscroll_behavior_x(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overscroll-behavior-inline
    /// given a writing mode.
    pub fn copy_overscroll_behavior_inline_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_overscroll_behavior_y_from(other)
            
        } else {
            
                self.copy_overscroll_behavior_x_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overscroll-behavior-inline
    /// given a writing mode.
    pub fn reset_overscroll_behavior_inline(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_overscroll_behavior_inline_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// overscroll-behavior-inline given a writing mode.
    pub fn clone_overscroll_behavior_inline(&self, wm: WritingMode)
        -> longhands::overscroll_behavior_inline::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_overscroll_behavior_y()
        
        } else {
            
            self.clone_overscroll_behavior_x()
        
        }

    }


    
    /// Set the appropriate physical property for overscroll-behavior-block given a writing mode.
    pub fn set_overscroll_behavior_block(&mut self,
                                      v: longhands::overscroll_behavior_block::computed_value::T,
                                      wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.set_overscroll_behavior_x(v)
            
        } else {
            
                self.set_overscroll_behavior_y(v)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overscroll-behavior-block
    /// given a writing mode.
    pub fn copy_overscroll_behavior_block_from(&mut self,
                                            other: &Self,
                                            wm: WritingMode) {
        
    
        
        if wm.is_vertical() {
            
                self.copy_overscroll_behavior_x_from(other)
            
        } else {
            
                self.copy_overscroll_behavior_y_from(other)
            
        }

    }

    /// Copy the appropriate physical property from another struct for overscroll-behavior-block
    /// given a writing mode.
    pub fn reset_overscroll_behavior_block(&mut self,
                                        other: &Self,
                                        wm: WritingMode) {
        self.copy_overscroll_behavior_block_from(other, wm)
    }

    /// Get the computed value for the appropriate physical property for
    /// overscroll-behavior-block given a writing mode.
    pub fn clone_overscroll_behavior_block(&self, wm: WritingMode)
        -> longhands::overscroll_behavior_block::computed_value::T {
    
    
        
        if wm.is_vertical() {
            
            self.clone_overscroll_behavior_x()
        
        } else {
            
            self.clone_overscroll_behavior_y()
        
        }

    }



    #[allow(non_snake_case)]
    pub fn set_isolation(&mut self, v: longhands::isolation::computed_value::T) {
        use crate::properties::longhands::isolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleIsolation::Auto ,
                Keyword::Isolate =>
                    structs::StyleIsolation::Isolate ,
        };
        self.gecko.mIsolation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_isolation_from(&mut self, other: &Self) {
        self.gecko.mIsolation = other.gecko.mIsolation.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_isolation(&mut self, other: &Self) {
        self.copy_isolation_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_isolation(&self) -> longhands::isolation::computed_value::T {
        use crate::properties::longhands::isolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mIsolation {
            structs::StyleIsolation::Auto => Keyword::Auto,
            structs::StyleIsolation::Isolate => Keyword::Isolate,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_break_after(&mut self, v: longhands::break_after::computed_value::T) {
        self.gecko.mBreakAfter = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_break_after_from(&mut self, other: &Self) {
        self.gecko.mBreakAfter = other.gecko.mBreakAfter.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_break_after(&mut self, other: &Self) {
        self.copy_break_after_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_break_after(&self) -> longhands::break_after::computed_value::T {
        From::from(self.gecko.mBreakAfter.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_break_before(&mut self, v: longhands::break_before::computed_value::T) {
        self.gecko.mBreakBefore = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_break_before_from(&mut self, other: &Self) {
        self.gecko.mBreakBefore = other.gecko.mBreakBefore.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_break_before(&mut self, other: &Self) {
        self.copy_break_before_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_break_before(&self) -> longhands::break_before::computed_value::T {
        From::from(self.gecko.mBreakBefore.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_break_inside(&mut self, v: longhands::break_inside::computed_value::T) {
        self.gecko.mBreakInside = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_break_inside_from(&mut self, other: &Self) {
        self.gecko.mBreakInside = other.gecko.mBreakInside.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_break_inside(&mut self, other: &Self) {
        self.copy_break_inside_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_break_inside(&self) -> longhands::break_inside::computed_value::T {
        From::from(self.gecko.mBreakInside.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_resize(&mut self, v: longhands::resize::computed_value::T) {
        self.gecko.mResize = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_resize_from(&mut self, other: &Self) {
        self.gecko.mResize = other.gecko.mResize.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_resize(&mut self, other: &Self) {
        self.copy_resize_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_resize(&self) -> longhands::resize::computed_value::T {
        From::from(self.gecko.mResize.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_perspective(&mut self, v: longhands::perspective::computed_value::T) {
        self.gecko.mChildPerspective = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_perspective_from(&mut self, other: &Self) {
        self.gecko.mChildPerspective = other.gecko.mChildPerspective.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_perspective(&mut self, other: &Self) {
        self.copy_perspective_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_perspective(&self) -> longhands::perspective::computed_value::T {
        From::from(self.gecko.mChildPerspective.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_perspective_origin(&mut self, v: longhands::perspective_origin::computed_value::T) {
        self.gecko.mPerspectiveOrigin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_perspective_origin_from(&mut self, other: &Self) {
        self.gecko.mPerspectiveOrigin = other.gecko.mPerspectiveOrigin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_perspective_origin(&mut self, other: &Self) {
        self.copy_perspective_origin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_perspective_origin(&self) -> longhands::perspective_origin::computed_value::T {
        From::from(self.gecko.mPerspectiveOrigin.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_backface_visibility(&mut self, v: longhands::backface_visibility::computed_value::T) {
        use crate::properties::longhands::backface_visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Visible =>
                    structs::StyleBackfaceVisibility::Visible ,
                Keyword::Hidden =>
                    structs::StyleBackfaceVisibility::Hidden ,
        };
        self.gecko.mBackfaceVisibility = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_backface_visibility_from(&mut self, other: &Self) {
        self.gecko.mBackfaceVisibility = other.gecko.mBackfaceVisibility.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_backface_visibility(&mut self, other: &Self) {
        self.copy_backface_visibility_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_backface_visibility(&self) -> longhands::backface_visibility::computed_value::T {
        use crate::properties::longhands::backface_visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBackfaceVisibility {
            structs::StyleBackfaceVisibility::Visible => Keyword::Visible,
            structs::StyleBackfaceVisibility::Hidden => Keyword::Hidden,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_transform_box(&mut self, v: longhands::transform_box::computed_value::T) {
        use crate::properties::longhands::transform_box::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::BorderBox =>
                    structs::StyleGeometryBox::BorderBox ,
                Keyword::FillBox =>
                    structs::StyleGeometryBox::FillBox ,
                Keyword::ViewBox =>
                    structs::StyleGeometryBox::ViewBox ,
        };
        self.gecko.mTransformBox = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_transform_box_from(&mut self, other: &Self) {
        self.gecko.mTransformBox = other.gecko.mTransformBox.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_transform_box(&mut self, other: &Self) {
        self.copy_transform_box_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_transform_box(&self) -> longhands::transform_box::computed_value::T {
        use crate::properties::longhands::transform_box::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mTransformBox {
            structs::StyleGeometryBox::BorderBox => Keyword::BorderBox,
            structs::StyleGeometryBox::FillBox => Keyword::FillBox,
            structs::StyleGeometryBox::ViewBox => Keyword::ViewBox,
            _ => panic!("Found unexpected value in style struct for transform_box property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_transform_style(&mut self, v: longhands::transform_style::computed_value::T) {
        self.gecko.mTransformStyle = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_transform_style_from(&mut self, other: &Self) {
        self.gecko.mTransformStyle = other.gecko.mTransformStyle.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_transform_style(&mut self, other: &Self) {
        self.copy_transform_style_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_transform_style(&self) -> longhands::transform_style::computed_value::T {
        From::from(self.gecko.mTransformStyle.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_transform_origin(&mut self, v: longhands::transform_origin::computed_value::T) {
        self.gecko.mTransformOrigin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_transform_origin_from(&mut self, other: &Self) {
        self.gecko.mTransformOrigin = other.gecko.mTransformOrigin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_transform_origin(&mut self, other: &Self) {
        self.copy_transform_origin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_transform_origin(&self) -> longhands::transform_origin::computed_value::T {
        From::from(self.gecko.mTransformOrigin.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_contain(&mut self, v: longhands::contain::computed_value::T) {
        self.gecko.mContain = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_contain_from(&mut self, other: &Self) {
        self.gecko.mContain = other.gecko.mContain.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_contain(&mut self, other: &Self) {
        self.copy_contain_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_contain(&self) -> longhands::contain::computed_value::T {
        From::from(self.gecko.mContain.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_content_visibility(&mut self, v: longhands::content_visibility::computed_value::T) {
        self.gecko.mContentVisibility = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_content_visibility_from(&mut self, other: &Self) {
        self.gecko.mContentVisibility = other.gecko.mContentVisibility.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_content_visibility(&mut self, other: &Self) {
        self.copy_content_visibility_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_content_visibility(&self) -> longhands::content_visibility::computed_value::T {
        From::from(self.gecko.mContentVisibility.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_container_type(&mut self, v: longhands::container_type::computed_value::T) {
        self.gecko.mContainerType = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_container_type_from(&mut self, other: &Self) {
        self.gecko.mContainerType = other.gecko.mContainerType.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_container_type(&mut self, other: &Self) {
        self.copy_container_type_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_container_type(&self) -> longhands::container_type::computed_value::T {
        From::from(self.gecko.mContainerType.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_container_name(&mut self, v: longhands::container_name::computed_value::T) {
        self.gecko.mContainerName = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_container_name_from(&mut self, other: &Self) {
        self.gecko.mContainerName = other.gecko.mContainerName.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_container_name(&mut self, other: &Self) {
        self.copy_container_name_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_container_name(&self) -> longhands::container_name::computed_value::T {
        From::from(self.gecko.mContainerName.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_appearance(&mut self, v: longhands::appearance::computed_value::T) {
        self.gecko.mAppearance = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_appearance_from(&mut self, other: &Self) {
        self.gecko.mAppearance = other.gecko.mAppearance.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_appearance(&mut self, other: &Self) {
        self.copy_appearance_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_appearance(&self) -> longhands::appearance::computed_value::T {
        From::from(self.gecko.mAppearance.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_default_appearance(&mut self, v: longhands::_moz_default_appearance::computed_value::T) {
        self.gecko.mDefaultAppearance = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_default_appearance_from(&mut self, other: &Self) {
        self.gecko.mDefaultAppearance = other.gecko.mDefaultAppearance.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_default_appearance(&mut self, other: &Self) {
        self.copy__moz_default_appearance_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_default_appearance(&self) -> longhands::_moz_default_appearance::computed_value::T {
        From::from(self.gecko.mDefaultAppearance.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_orient(&mut self, v: longhands::_moz_orient::computed_value::T) {
        use crate::properties::longhands::_moz_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Inline =>
                    structs::StyleOrient::Inline ,
                Keyword::Block =>
                    structs::StyleOrient::Block ,
                Keyword::Horizontal =>
                    structs::StyleOrient::Horizontal ,
                Keyword::Vertical =>
                    structs::StyleOrient::Vertical ,
        };
        self.gecko.mOrient = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_orient_from(&mut self, other: &Self) {
        self.gecko.mOrient = other.gecko.mOrient.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_orient(&mut self, other: &Self) {
        self.copy__moz_orient_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_orient(&self) -> longhands::_moz_orient::computed_value::T {
        use crate::properties::longhands::_moz_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mOrient {
            structs::StyleOrient::Inline => Keyword::Inline,
            structs::StyleOrient::Block => Keyword::Block,
            structs::StyleOrient::Horizontal => Keyword::Horizontal,
            structs::StyleOrient::Vertical => Keyword::Vertical,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_will_change(&mut self, v: longhands::will_change::computed_value::T) {
        self.gecko.mWillChange = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_will_change_from(&mut self, other: &Self) {
        self.gecko.mWillChange = other.gecko.mWillChange.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_will_change(&mut self, other: &Self) {
        self.copy_will_change_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_will_change(&self) -> longhands::will_change::computed_value::T {
        From::from(self.gecko.mWillChange.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_shape_image_threshold(&mut self, v: longhands::shape_image_threshold::computed_value::T) {
        self.gecko.mShapeImageThreshold = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_shape_image_threshold_from(&mut self, other: &Self) {
        self.gecko.mShapeImageThreshold = other.gecko.mShapeImageThreshold.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_shape_image_threshold(&mut self, other: &Self) {
        self.copy_shape_image_threshold_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_shape_image_threshold(&self) -> longhands::shape_image_threshold::computed_value::T {
        From::from(self.gecko.mShapeImageThreshold.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_shape_margin(&mut self, v: longhands::shape_margin::computed_value::T) {
        self.gecko.mShapeMargin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_shape_margin_from(&mut self, other: &Self) {
        self.gecko.mShapeMargin = other.gecko.mShapeMargin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_shape_margin(&mut self, other: &Self) {
        self.copy_shape_margin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_shape_margin(&self) -> longhands::shape_margin::computed_value::T {
        From::from(self.gecko.mShapeMargin.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_shape_outside(&mut self, v: longhands::shape_outside::computed_value::T) {
        self.gecko.mShapeOutside = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_shape_outside_from(&mut self, other: &Self) {
        self.gecko.mShapeOutside = other.gecko.mShapeOutside.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_shape_outside(&mut self, other: &Self) {
        self.copy_shape_outside_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_shape_outside(&self) -> longhands::shape_outside::computed_value::T {
        From::from(self.gecko.mShapeOutside.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_touch_action(&mut self, v: longhands::touch_action::computed_value::T) {
        self.gecko.mTouchAction = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_touch_action_from(&mut self, other: &Self) {
        self.gecko.mTouchAction = other.gecko.mTouchAction.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_touch_action(&mut self, other: &Self) {
        self.copy_touch_action_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_touch_action(&self) -> longhands::touch_action::computed_value::T {
        From::from(self.gecko.mTouchAction.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scrollbar_gutter(&mut self, v: longhands::scrollbar_gutter::computed_value::T) {
        self.gecko.mScrollbarGutter = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scrollbar_gutter_from(&mut self, other: &Self) {
        self.gecko.mScrollbarGutter = other.gecko.mScrollbarGutter.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scrollbar_gutter(&mut self, other: &Self) {
        self.copy_scrollbar_gutter_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scrollbar_gutter(&self) -> longhands::scrollbar_gutter::computed_value::T {
        From::from(self.gecko.mScrollbarGutter.clone())
    }


}










// TODO: Gecko accepts lists in most background-related properties. We just use
// the first element (which is the common case), but at some point we want to
// add support for parsing these lists in servo and pushing to nsTArray's.



impl GeckoBackground {
    /*
     * Manually-Implemented Methods.
     */
    

    
    

    
    
    pub fn copy_background_repeat_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mRepeatCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mRepeat = other.mRepeat.clone();
        }
        self.gecko.mImage.mRepeatCount = count;
    }

    pub fn reset_background_repeat(&mut self, other: &Self) {
        self.copy_background_repeat_from(other)
    }


    pub fn set_background_repeat<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::background_repeat::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mRepeatCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mRepeat = {
                
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_Repeat;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_ns(repeat: BackgroundRepeatKeyword) -> StyleImageLayerRepeat {
            match repeat {
                BackgroundRepeatKeyword::Repeat => StyleImageLayerRepeat::Repeat,
                BackgroundRepeatKeyword::Space => StyleImageLayerRepeat::Space,
                BackgroundRepeatKeyword::Round => StyleImageLayerRepeat::Round,
                BackgroundRepeatKeyword::NoRepeat => StyleImageLayerRepeat::NoRepeat,
            }
        }

        let repeat_x = to_ns(servo.0);
        let repeat_y = to_ns(servo.1);
        nsStyleImageLayers_Repeat {
              mXRepeat: repeat_x,
              mYRepeat: repeat_y,
        }
    
            };
        }
    }


    pub fn clone_background_repeat(&self) -> longhands::background_repeat::computed_value::T {
        use crate::properties::longhands::background_repeat::single_value::computed_value::T;
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_servo(repeat: StyleImageLayerRepeat) -> BackgroundRepeatKeyword {
            match repeat {
                StyleImageLayerRepeat::Repeat => BackgroundRepeatKeyword::Repeat,
                StyleImageLayerRepeat::Space => BackgroundRepeatKeyword::Space,
                StyleImageLayerRepeat::Round => BackgroundRepeatKeyword::Round,
                StyleImageLayerRepeat::NoRepeat => BackgroundRepeatKeyword::NoRepeat,
                _ => panic!("Found unexpected value in style struct for background_repeat property"),
            }
        }

        longhands::background_repeat::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mRepeatCount as usize)
                .map(|ref layer| {
                    T(to_servo(layer.mRepeat.mXRepeat), to_servo(layer.mRepeat.mYRepeat))
                }).collect()
        )
    }

    
    

    
    pub fn copy_background_clip_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mClipCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mClip = other.mClip.clone();
        }
        self.gecko.mImage.mClipCount = count;
    }

    pub fn reset_background_clip(&mut self, other: &Self) {
        self.copy_background_clip_from(other)
    }


    pub fn set_background_clip<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_clip::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_clip::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mClipCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mClip = {
                match servo {
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                    Keyword::Text =>
                        structs::StyleGeometryBox::Text ,
                }
            };
        }
    }

    pub fn clone_background_clip(&self) -> longhands::background_clip::computed_value::T {
        use crate::properties::longhands::background_clip::single_value::computed_value::T as Keyword;


        longhands::background_clip::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mClipCount as usize)
                .map(|ref layer| {
                    match layer.mClip {
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        structs::StyleGeometryBox::Text
                            => Keyword::Text,
                        _ => panic!("Found unexpected value in style struct for background_clip property"),
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_background_origin_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mOriginCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mOrigin = other.mOrigin.clone();
        }
        self.gecko.mImage.mOriginCount = count;
    }

    pub fn reset_background_origin(&mut self, other: &Self) {
        self.copy_background_origin_from(other)
    }


    pub fn set_background_origin<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_origin::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_origin::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mOriginCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mOrigin = {
                match servo {
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                }
            };
        }
    }

    pub fn clone_background_origin(&self) -> longhands::background_origin::computed_value::T {
        use crate::properties::longhands::background_origin::single_value::computed_value::T as Keyword;


        longhands::background_origin::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mOriginCount as usize)
                .map(|ref layer| {
                    match layer.mOrigin {
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        _ => panic!("Found unexpected value in style struct for background_origin property"),
                    }
                }).collect()
        )
    }


    pub fn copy_background_position_x_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mPositionXCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }

        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.horizontal = other.mPosition.horizontal.clone();
        }
        self.gecko.mImage.mPositionXCount = count;
    }

    pub fn reset_background_position_x(&mut self, other: &Self) {
        self.copy_background_position_x_from(other)
    }

    pub fn clone_background_position_x(&self)
        -> longhands::background_position_x::computed_value::T {
        longhands::background_position_x::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mPositionXCount as usize)
                .map(|position| position.mPosition.horizontal.clone())
                .collect()
        )
    }

    pub fn set_background_position_x<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::background_position_x
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mPositionXCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.horizontal = servo;
        }
    }
    pub fn copy_background_position_y_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mPositionYCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }

        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.vertical = other.mPosition.vertical.clone();
        }
        self.gecko.mImage.mPositionYCount = count;
    }

    pub fn reset_background_position_y(&mut self, other: &Self) {
        self.copy_background_position_y_from(other)
    }

    pub fn clone_background_position_y(&self)
        -> longhands::background_position_y::computed_value::T {
        longhands::background_position_y::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mPositionYCount as usize)
                .map(|position| position.mPosition.vertical.clone())
                .collect()
        )
    }

    pub fn set_background_position_y<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::background_position_y
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mPositionYCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.vertical = servo;
        }
    }

    
    
    pub fn copy_background_size_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mSizeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mSize = other.mSize.clone();
        }
        self.gecko.mImage.mSizeCount = count;
    }

    pub fn reset_background_size(&mut self, other: &Self) {
        self.copy_background_size_from(other)
    }


    pub fn set_background_size<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::background_size::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mSizeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mSize = {
                
        servo
    
            };
        }
    }


    pub fn clone_background_size(&self) -> longhands::background_size::computed_value::T {
        longhands::background_size::computed_value::List(
            self.gecko.mImage.mLayers.iter().map(|layer| layer.mSize.clone()).collect()
        )
    }

    pub fn copy_background_image_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        unsafe {
            let count = other.gecko.mImage.mImageCount;
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);

            for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                      .zip(other.gecko.mImage.mLayers.iter())
                                      .take(count as usize) {
                layer.mImage = other.mImage.clone();
            }
            self.gecko.mImage.mImageCount = count;
        }
    }

    pub fn reset_background_image(&mut self, other: &Self) {
        self.copy_background_image_from(other)
    }

    #[allow(unused_variables)]
    pub fn set_background_image<I>(&mut self, images: I)
        where I: IntoIterator<Item = longhands::background_image::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let images = images.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(
                &mut self.gecko.mImage,
                images.len(),
                LayerType::Background,
            );
        }

        self.gecko.mImage.mImageCount = images.len() as u32;
        for (image, geckoimage) in images.zip(self.gecko.mImage
                                                  .mLayers.iter_mut()) {
            geckoimage.mImage = image;
        }
    }

    pub fn clone_background_image(&self) -> longhands::background_image::computed_value::T {
        longhands::background_image::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mImageCount as usize)
                .map(|layer| layer.mImage.clone())
                .collect()
        )
    }

    
    pub fn fill_arrays(&mut self) {
        use crate::gecko_bindings::bindings::Gecko_FillAllImageLayers;
        use std::cmp;
        let mut max_len = 1;
            max_len = cmp::max(max_len, self.gecko.mImage.mRepeatCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mClipCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mOriginCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mPositionXCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mPositionYCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mImageCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mSizeCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mAttachmentCount);
            max_len = cmp::max(max_len, self.gecko.mImage.mBlendModeCount);
        unsafe {
            // While we could do this manually, we'd need to also manually
            // run all the copy constructors, so we just delegate to gecko
            Gecko_FillAllImageLayers(&mut self.gecko.mImage, max_len);
        }
    }

    
    

    
    pub fn copy_background_attachment_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mAttachmentCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mAttachment = other.mAttachment.clone();
        }
        self.gecko.mImage.mAttachmentCount = count;
    }

    pub fn reset_background_attachment(&mut self, other: &Self) {
        self.copy_background_attachment_from(other)
    }


    pub fn set_background_attachment<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_attachment::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_attachment::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mAttachmentCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mAttachment = {
                match servo {
                    Keyword::Scroll =>
                        structs::StyleImageLayerAttachment::Scroll ,
                    Keyword::Fixed =>
                        structs::StyleImageLayerAttachment::Fixed ,
                    Keyword::Local =>
                        structs::StyleImageLayerAttachment::Local ,
                }
            };
        }
    }

    pub fn clone_background_attachment(&self) -> longhands::background_attachment::computed_value::T {
        use crate::properties::longhands::background_attachment::single_value::computed_value::T as Keyword;


        longhands::background_attachment::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mAttachmentCount as usize)
                .map(|ref layer| {
                    match layer.mAttachment {
                        structs::StyleImageLayerAttachment::Scroll
                            => Keyword::Scroll,
                        structs::StyleImageLayerAttachment::Fixed
                            => Keyword::Fixed,
                        structs::StyleImageLayerAttachment::Local
                            => Keyword::Local,
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_background_blend_mode_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mImage.mBlendModeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mImage,
                                          count as usize,
                                          LayerType::Background);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mImage.mLayers.iter_mut()
                                  .zip(other.gecko.mImage.mLayers.iter())
                                  .take(count as usize) {
            layer.mBlendMode = other.mBlendMode.clone();
        }
        self.gecko.mImage.mBlendModeCount = count;
    }

    pub fn reset_background_blend_mode(&mut self, other: &Self) {
        self.copy_background_blend_mode_from(other)
    }


    pub fn set_background_blend_mode<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::background_blend_mode::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::background_blend_mode::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mImage, v.len(),
                                        LayerType::Background);
        }

        self.gecko.mImage.mBlendModeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mImage.mLayers.iter_mut()) {
            geckolayer.mBlendMode = {
                match servo {
                    Keyword::Normal =>
                        structs::StyleBlend::Normal ,
                    Keyword::Multiply =>
                        structs::StyleBlend::Multiply ,
                    Keyword::Screen =>
                        structs::StyleBlend::Screen ,
                    Keyword::Overlay =>
                        structs::StyleBlend::Overlay ,
                    Keyword::Darken =>
                        structs::StyleBlend::Darken ,
                    Keyword::Lighten =>
                        structs::StyleBlend::Lighten ,
                    Keyword::ColorDodge =>
                        structs::StyleBlend::ColorDodge ,
                    Keyword::ColorBurn =>
                        structs::StyleBlend::ColorBurn ,
                    Keyword::HardLight =>
                        structs::StyleBlend::HardLight ,
                    Keyword::SoftLight =>
                        structs::StyleBlend::SoftLight ,
                    Keyword::Difference =>
                        structs::StyleBlend::Difference ,
                    Keyword::Exclusion =>
                        structs::StyleBlend::Exclusion ,
                    Keyword::Hue =>
                        structs::StyleBlend::Hue ,
                    Keyword::Saturation =>
                        structs::StyleBlend::Saturation ,
                    Keyword::Color =>
                        structs::StyleBlend::Color ,
                    Keyword::Luminosity =>
                        structs::StyleBlend::Luminosity ,
                }
            };
        }
    }

    pub fn clone_background_blend_mode(&self) -> longhands::background_blend_mode::computed_value::T {
        use crate::properties::longhands::background_blend_mode::single_value::computed_value::T as Keyword;


        longhands::background_blend_mode::computed_value::List(
            self.gecko.mImage.mLayers.iter()
                .take(self.gecko.mImage.mBlendModeCount as usize)
                .map(|ref layer| {
                    match layer.mBlendMode {
                        structs::StyleBlend::Normal
                            => Keyword::Normal,
                        structs::StyleBlend::Multiply
                            => Keyword::Multiply,
                        structs::StyleBlend::Screen
                            => Keyword::Screen,
                        structs::StyleBlend::Overlay
                            => Keyword::Overlay,
                        structs::StyleBlend::Darken
                            => Keyword::Darken,
                        structs::StyleBlend::Lighten
                            => Keyword::Lighten,
                        structs::StyleBlend::ColorDodge
                            => Keyword::ColorDodge,
                        structs::StyleBlend::ColorBurn
                            => Keyword::ColorBurn,
                        structs::StyleBlend::HardLight
                            => Keyword::HardLight,
                        structs::StyleBlend::SoftLight
                            => Keyword::SoftLight,
                        structs::StyleBlend::Difference
                            => Keyword::Difference,
                        structs::StyleBlend::Exclusion
                            => Keyword::Exclusion,
                        structs::StyleBlend::Hue
                            => Keyword::Hue,
                        structs::StyleBlend::Saturation
                            => Keyword::Saturation,
                        structs::StyleBlend::Color
                            => Keyword::Color,
                        structs::StyleBlend::Luminosity
                            => Keyword::Luminosity,
                        _ => panic!("Found unexpected value in style struct for background_blend_mode property"),
                    }
                }).collect()
        )
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_background_color(&mut self, v: longhands::background_color::computed_value::T) {
        self.gecko.mBackgroundColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_background_color_from(&mut self, other: &Self) {
        self.gecko.mBackgroundColor = other.gecko.mBackgroundColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_background_color(&mut self, other: &Self) {
        self.copy_background_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_background_color(&self) -> longhands::background_color::computed_value::T {
        From::from(self.gecko.mBackgroundColor.clone())
    }


}




impl GeckoList {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_list_style_type(&mut self, v: longhands::list_style_type::computed_value::T) {
        use nsstring::{nsACString, nsCStr};
        use self::longhands::list_style_type::computed_value::T;
        match v {
            T::None => unsafe {
                bindings::Gecko_SetCounterStyleToNone(&mut self.gecko.mCounterStyle)
            }
            T::CounterStyle(s) => s.to_gecko_value(&mut self.gecko.mCounterStyle),
            T::String(s) => unsafe {
                bindings::Gecko_SetCounterStyleToString(
                    &mut self.gecko.mCounterStyle,
                    &nsCStr::from(&s) as &nsACString,
                )
            }
        }
    }

    pub fn copy_list_style_type_from(&mut self, other: &Self) {
        unsafe {
            Gecko_CopyCounterStyle(&mut self.gecko.mCounterStyle, &other.gecko.mCounterStyle);
        }
    }

    pub fn reset_list_style_type(&mut self, other: &Self) {
        self.copy_list_style_type_from(other)
    }

    pub fn clone_list_style_type(&self) -> longhands::list_style_type::computed_value::T {
        use self::longhands::list_style_type::computed_value::T;
        use crate::values::Either;
        use crate::values::generics::CounterStyle;
        use crate::gecko_bindings::bindings;

        let name = unsafe {
            bindings::Gecko_CounterStyle_GetName(&self.gecko.mCounterStyle)
        };
        if !name.is_null() {
            let name = unsafe { Atom::from_raw(name) };
            if name == atom!("none") {
                return T::None;
            }
        }
        let result = CounterStyle::from_gecko_value(&self.gecko.mCounterStyle);
        match result {
            Either::First(counter_style) => T::CounterStyle(counter_style),
            Either::Second(string) => T::String(string),
        }
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_list_style_position(&mut self, v: longhands::list_style_position::computed_value::T) {
        use crate::properties::longhands::list_style_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Outside =>
                    structs::NS_STYLE_LIST_STYLE_POSITION_OUTSIDE as u8,
                Keyword::Inside =>
                    structs::NS_STYLE_LIST_STYLE_POSITION_INSIDE as u8,
        };
        self.gecko.mListStylePosition = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_list_style_position_from(&mut self, other: &Self) {
        self.gecko.mListStylePosition = other.gecko.mListStylePosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_list_style_position(&mut self, other: &Self) {
        self.copy_list_style_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_list_style_position(&self) -> longhands::list_style_position::computed_value::T {
        use crate::properties::longhands::list_style_position::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_LIST_STYLE_POSITION_OUTSIDE : u8 =
            structs::NS_STYLE_LIST_STYLE_POSITION_OUTSIDE as u8;
        const U8_NS_STYLE_LIST_STYLE_POSITION_INSIDE : u8 =
            structs::NS_STYLE_LIST_STYLE_POSITION_INSIDE as u8;

        match self.gecko.mListStylePosition as u8 {
            U8_NS_STYLE_LIST_STYLE_POSITION_OUTSIDE => Keyword::Outside,
            U8_NS_STYLE_LIST_STYLE_POSITION_INSIDE => Keyword::Inside,
            _ => panic!("Found unexpected value in style struct for list_style_position property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_list_style_image(&mut self, v: longhands::list_style_image::computed_value::T) {
        self.gecko.mListStyleImage = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_list_style_image_from(&mut self, other: &Self) {
        self.gecko.mListStyleImage = other.gecko.mListStyleImage.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_list_style_image(&mut self, other: &Self) {
        self.copy_list_style_image_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_list_style_image(&self) -> longhands::list_style_image::computed_value::T {
        From::from(self.gecko.mListStyleImage.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_quotes(&mut self, v: longhands::quotes::computed_value::T) {
        self.gecko.mQuotes = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_quotes_from(&mut self, other: &Self) {
        self.gecko.mQuotes = other.gecko.mQuotes.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_quotes(&mut self, other: &Self) {
        self.copy_quotes_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_quotes(&self) -> longhands::quotes::computed_value::T {
        From::from(self.gecko.mQuotes.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_image_region(&mut self, v: longhands::_moz_image_region::computed_value::T) {
        self.gecko.mImageRegion = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_image_region_from(&mut self, other: &Self) {
        self.gecko.mImageRegion = other.gecko.mImageRegion.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_image_region(&mut self, other: &Self) {
        self.copy__moz_image_region_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_image_region(&self) -> longhands::_moz_image_region::computed_value::T {
        From::from(self.gecko.mImageRegion.clone())
    }


}




impl GeckoTable {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_table_layout(&mut self, v: longhands::table_layout::computed_value::T) {
        use crate::properties::longhands::table_layout::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleTableLayout::Auto ,
                Keyword::Fixed =>
                    structs::StyleTableLayout::Fixed ,
        };
        self.gecko.mLayoutStrategy = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_table_layout_from(&mut self, other: &Self) {
        self.gecko.mLayoutStrategy = other.gecko.mLayoutStrategy.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_table_layout(&mut self, other: &Self) {
        self.copy_table_layout_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_table_layout(&self) -> longhands::table_layout::computed_value::T {
        use crate::properties::longhands::table_layout::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mLayoutStrategy {
            structs::StyleTableLayout::Auto => Keyword::Auto,
            structs::StyleTableLayout::Fixed => Keyword::Fixed,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__x_span(&mut self, v: longhands::_x_span::computed_value::T) {
        self.gecko.mXSpan = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__x_span_from(&mut self, other: &Self) {
        self.gecko.mXSpan = other.gecko.mXSpan.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__x_span(&mut self, other: &Self) {
        self.copy__x_span_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__x_span(&self) -> longhands::_x_span::computed_value::T {
        From::from(self.gecko.mXSpan.clone())
    }


}




impl GeckoEffects {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_opacity(&mut self, v: longhands::opacity::computed_value::T) {
        self.gecko.mOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_opacity_from(&mut self, other: &Self) {
        self.gecko.mOpacity = other.gecko.mOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_opacity(&mut self, other: &Self) {
        self.copy_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_opacity(&self) -> longhands::opacity::computed_value::T {
        From::from(self.gecko.mOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_box_shadow(&mut self, v: longhands::box_shadow::computed_value::T) {
        self.gecko.mBoxShadow = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_box_shadow_from(&mut self, other: &Self) {
        self.gecko.mBoxShadow = other.gecko.mBoxShadow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_box_shadow(&mut self, other: &Self) {
        self.copy_box_shadow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_box_shadow(&self) -> longhands::box_shadow::computed_value::T {
        From::from(self.gecko.mBoxShadow.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_clip(&mut self, v: longhands::clip::computed_value::T) {
        self.gecko.mClip = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_clip_from(&mut self, other: &Self) {
        self.gecko.mClip = other.gecko.mClip.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_clip(&mut self, other: &Self) {
        self.copy_clip_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_clip(&self) -> longhands::clip::computed_value::T {
        From::from(self.gecko.mClip.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_filter(&mut self, v: longhands::filter::computed_value::T) {
        self.gecko.mFilters = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_filter_from(&mut self, other: &Self) {
        self.gecko.mFilters = other.gecko.mFilters.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_filter(&mut self, other: &Self) {
        self.copy_filter_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_filter(&self) -> longhands::filter::computed_value::T {
        From::from(self.gecko.mFilters.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_backdrop_filter(&mut self, v: longhands::backdrop_filter::computed_value::T) {
        self.gecko.mBackdropFilters = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_backdrop_filter_from(&mut self, other: &Self) {
        self.gecko.mBackdropFilters = other.gecko.mBackdropFilters.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_backdrop_filter(&mut self, other: &Self) {
        self.copy_backdrop_filter_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_backdrop_filter(&self) -> longhands::backdrop_filter::computed_value::T {
        From::from(self.gecko.mBackdropFilters.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_mix_blend_mode(&mut self, v: longhands::mix_blend_mode::computed_value::T) {
        use crate::properties::longhands::mix_blend_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::StyleBlend::Normal ,
                Keyword::Multiply =>
                    structs::StyleBlend::Multiply ,
                Keyword::Screen =>
                    structs::StyleBlend::Screen ,
                Keyword::Overlay =>
                    structs::StyleBlend::Overlay ,
                Keyword::Darken =>
                    structs::StyleBlend::Darken ,
                Keyword::Lighten =>
                    structs::StyleBlend::Lighten ,
                Keyword::ColorDodge =>
                    structs::StyleBlend::ColorDodge ,
                Keyword::ColorBurn =>
                    structs::StyleBlend::ColorBurn ,
                Keyword::HardLight =>
                    structs::StyleBlend::HardLight ,
                Keyword::SoftLight =>
                    structs::StyleBlend::SoftLight ,
                Keyword::Difference =>
                    structs::StyleBlend::Difference ,
                Keyword::Exclusion =>
                    structs::StyleBlend::Exclusion ,
                Keyword::Hue =>
                    structs::StyleBlend::Hue ,
                Keyword::Saturation =>
                    structs::StyleBlend::Saturation ,
                Keyword::Color =>
                    structs::StyleBlend::Color ,
                Keyword::Luminosity =>
                    structs::StyleBlend::Luminosity ,
                Keyword::PlusLighter =>
                    structs::StyleBlend::PlusLighter ,
        };
        self.gecko.mMixBlendMode = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_mix_blend_mode_from(&mut self, other: &Self) {
        self.gecko.mMixBlendMode = other.gecko.mMixBlendMode.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_mix_blend_mode(&mut self, other: &Self) {
        self.copy_mix_blend_mode_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_mix_blend_mode(&self) -> longhands::mix_blend_mode::computed_value::T {
        use crate::properties::longhands::mix_blend_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mMixBlendMode {
            structs::StyleBlend::Normal => Keyword::Normal,
            structs::StyleBlend::Multiply => Keyword::Multiply,
            structs::StyleBlend::Screen => Keyword::Screen,
            structs::StyleBlend::Overlay => Keyword::Overlay,
            structs::StyleBlend::Darken => Keyword::Darken,
            structs::StyleBlend::Lighten => Keyword::Lighten,
            structs::StyleBlend::ColorDodge => Keyword::ColorDodge,
            structs::StyleBlend::ColorBurn => Keyword::ColorBurn,
            structs::StyleBlend::HardLight => Keyword::HardLight,
            structs::StyleBlend::SoftLight => Keyword::SoftLight,
            structs::StyleBlend::Difference => Keyword::Difference,
            structs::StyleBlend::Exclusion => Keyword::Exclusion,
            structs::StyleBlend::Hue => Keyword::Hue,
            structs::StyleBlend::Saturation => Keyword::Saturation,
            structs::StyleBlend::Color => Keyword::Color,
            structs::StyleBlend::Luminosity => Keyword::Luminosity,
            structs::StyleBlend::PlusLighter => Keyword::PlusLighter,
        }
    }


}




impl GeckoInheritedBox {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_visibility(&mut self, v: longhands::visibility::computed_value::T) {
        use crate::properties::longhands::visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Visible =>
                    structs::StyleVisibility::Visible ,
                Keyword::Hidden =>
                    structs::StyleVisibility::Hidden ,
                Keyword::Collapse =>
                    structs::StyleVisibility::Collapse ,
        };
        self.gecko.mVisible = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_visibility_from(&mut self, other: &Self) {
        self.gecko.mVisible = other.gecko.mVisible.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_visibility(&mut self, other: &Self) {
        self.copy_visibility_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_visibility(&self) -> longhands::visibility::computed_value::T {
        use crate::properties::longhands::visibility::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mVisible {
            structs::StyleVisibility::Visible => Keyword::Visible,
            structs::StyleVisibility::Hidden => Keyword::Hidden,
            structs::StyleVisibility::Collapse => Keyword::Collapse,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_writing_mode(&mut self, v: longhands::writing_mode::computed_value::T) {
        use crate::properties::longhands::writing_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::HorizontalTb =>
                    structs::StyleWritingModeProperty::HorizontalTb ,
                Keyword::VerticalRl =>
                    structs::StyleWritingModeProperty::VerticalRl ,
                Keyword::VerticalLr =>
                    structs::StyleWritingModeProperty::VerticalLr ,
                Keyword::SidewaysRl =>
                    structs::StyleWritingModeProperty::SidewaysRl ,
                Keyword::SidewaysLr =>
                    structs::StyleWritingModeProperty::SidewaysLr ,
        };
        self.gecko.mWritingMode = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_writing_mode_from(&mut self, other: &Self) {
        self.gecko.mWritingMode = other.gecko.mWritingMode.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_writing_mode(&mut self, other: &Self) {
        self.copy_writing_mode_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_writing_mode(&self) -> longhands::writing_mode::computed_value::T {
        use crate::properties::longhands::writing_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mWritingMode {
            structs::StyleWritingModeProperty::HorizontalTb => Keyword::HorizontalTb,
            structs::StyleWritingModeProperty::VerticalRl => Keyword::VerticalRl,
            structs::StyleWritingModeProperty::VerticalLr => Keyword::VerticalLr,
            structs::StyleWritingModeProperty::SidewaysRl => Keyword::SidewaysRl,
            structs::StyleWritingModeProperty::SidewaysLr => Keyword::SidewaysLr,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_direction(&mut self, v: longhands::direction::computed_value::T) {
        use crate::properties::longhands::direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Ltr =>
                    structs::StyleDirection::Ltr ,
                Keyword::Rtl =>
                    structs::StyleDirection::Rtl ,
        };
        self.gecko.mDirection = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_direction_from(&mut self, other: &Self) {
        self.gecko.mDirection = other.gecko.mDirection.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_direction(&mut self, other: &Self) {
        self.copy_direction_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_direction(&self) -> longhands::direction::computed_value::T {
        use crate::properties::longhands::direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mDirection {
            structs::StyleDirection::Ltr => Keyword::Ltr,
            structs::StyleDirection::Rtl => Keyword::Rtl,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_orientation(&mut self, v: longhands::text_orientation::computed_value::T) {
        use crate::properties::longhands::text_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Mixed =>
                    structs::StyleTextOrientation::Mixed ,
                Keyword::Upright =>
                    structs::StyleTextOrientation::Upright ,
                Keyword::Sideways =>
                    structs::StyleTextOrientation::Sideways ,
        };
        self.gecko.mTextOrientation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_orientation_from(&mut self, other: &Self) {
        self.gecko.mTextOrientation = other.gecko.mTextOrientation.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_orientation(&mut self, other: &Self) {
        self.copy_text_orientation_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_orientation(&self) -> longhands::text_orientation::computed_value::T {
        use crate::properties::longhands::text_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mTextOrientation {
            structs::StyleTextOrientation::Mixed => Keyword::Mixed,
            structs::StyleTextOrientation::Upright => Keyword::Upright,
            structs::StyleTextOrientation::Sideways => Keyword::Sideways,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_print_color_adjust(&mut self, v: longhands::print_color_adjust::computed_value::T) {
        self.gecko.mPrintColorAdjust = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_print_color_adjust_from(&mut self, other: &Self) {
        self.gecko.mPrintColorAdjust = other.gecko.mPrintColorAdjust.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_print_color_adjust(&mut self, other: &Self) {
        self.copy_print_color_adjust_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_print_color_adjust(&self) -> longhands::print_color_adjust::computed_value::T {
        From::from(self.gecko.mPrintColorAdjust.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_image_rendering(&mut self, v: longhands::image_rendering::computed_value::T) {
        self.gecko.mImageRendering = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_image_rendering_from(&mut self, other: &Self) {
        self.gecko.mImageRendering = other.gecko.mImageRendering.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_image_rendering(&mut self, other: &Self) {
        self.copy_image_rendering_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_image_rendering(&self) -> longhands::image_rendering::computed_value::T {
        From::from(self.gecko.mImageRendering.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_image_orientation(&mut self, v: longhands::image_orientation::computed_value::T) {
        use crate::properties::longhands::image_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::FromImage =>
                    structs::StyleImageOrientation::FromImage ,
                Keyword::None =>
                    structs::StyleImageOrientation::None ,
        };
        self.gecko.mImageOrientation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_image_orientation_from(&mut self, other: &Self) {
        self.gecko.mImageOrientation = other.gecko.mImageOrientation.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_image_orientation(&mut self, other: &Self) {
        self.copy_image_orientation_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_image_orientation(&self) -> longhands::image_orientation::computed_value::T {
        use crate::properties::longhands::image_orientation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mImageOrientation {
            structs::StyleImageOrientation::FromImage => Keyword::FromImage,
            structs::StyleImageOrientation::None => Keyword::None,
        }
    }


}




impl GeckoInheritedTable {
    /*
     * Manually-Implemented Methods.
     */
    

    pub fn set_border_spacing(&mut self, v: longhands::border_spacing::computed_value::T) {
        self.gecko.mBorderSpacingCol = v.horizontal().0;
        self.gecko.mBorderSpacingRow = v.vertical().0;
    }

    pub fn copy_border_spacing_from(&mut self, other: &Self) {
        self.gecko.mBorderSpacingCol = other.gecko.mBorderSpacingCol;
        self.gecko.mBorderSpacingRow = other.gecko.mBorderSpacingRow;
    }

    pub fn reset_border_spacing(&mut self, other: &Self) {
        self.copy_border_spacing_from(other)
    }

    pub fn clone_border_spacing(&self) -> longhands::border_spacing::computed_value::T {
        longhands::border_spacing::computed_value::T::new(
            Au(self.gecko.mBorderSpacingCol).into(),
            Au(self.gecko.mBorderSpacingRow).into()
        )
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_border_collapse(&mut self, v: longhands::border_collapse::computed_value::T) {
        use crate::properties::longhands::border_collapse::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Separate =>
                    structs::StyleBorderCollapse::Separate ,
                Keyword::Collapse =>
                    structs::StyleBorderCollapse::Collapse ,
        };
        self.gecko.mBorderCollapse = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_border_collapse_from(&mut self, other: &Self) {
        self.gecko.mBorderCollapse = other.gecko.mBorderCollapse.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_border_collapse(&mut self, other: &Self) {
        self.copy_border_collapse_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_border_collapse(&self) -> longhands::border_collapse::computed_value::T {
        use crate::properties::longhands::border_collapse::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBorderCollapse {
            structs::StyleBorderCollapse::Separate => Keyword::Separate,
            structs::StyleBorderCollapse::Collapse => Keyword::Collapse,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_empty_cells(&mut self, v: longhands::empty_cells::computed_value::T) {
        use crate::properties::longhands::empty_cells::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Show =>
                    structs::StyleEmptyCells::Show ,
                Keyword::Hide =>
                    structs::StyleEmptyCells::Hide ,
        };
        self.gecko.mEmptyCells = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_empty_cells_from(&mut self, other: &Self) {
        self.gecko.mEmptyCells = other.gecko.mEmptyCells.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_empty_cells(&mut self, other: &Self) {
        self.copy_empty_cells_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_empty_cells(&self) -> longhands::empty_cells::computed_value::T {
        use crate::properties::longhands::empty_cells::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mEmptyCells {
            structs::StyleEmptyCells::Show => Keyword::Show,
            structs::StyleEmptyCells::Hide => Keyword::Hide,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_caption_side(&mut self, v: longhands::caption_side::computed_value::T) {
        self.gecko.mCaptionSide = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_caption_side_from(&mut self, other: &Self) {
        self.gecko.mCaptionSide = other.gecko.mCaptionSide.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_caption_side(&mut self, other: &Self) {
        self.copy_caption_side_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_caption_side(&self) -> longhands::caption_side::computed_value::T {
        From::from(self.gecko.mCaptionSide.clone())
    }


}





impl GeckoInheritedText {
    /*
     * Manually-Implemented Methods.
     */
    
    
    #[allow(non_snake_case)]
    pub fn set__webkit_text_stroke_width(&mut self, v: longhands::_webkit_text_stroke_width::computed_value::T) {
        let value = {
            v.0.to_i32_au()
        };

        self.gecko.mWebkitTextStrokeWidth = value;
    }

    #[allow(non_snake_case)]
    pub fn copy__webkit_text_stroke_width_from(&mut self, other: &Self) {
        self.gecko.mWebkitTextStrokeWidth = other.gecko.mWebkitTextStrokeWidth;
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_text_stroke_width(&mut self, other: &Self) {
        self.copy__webkit_text_stroke_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone__webkit_text_stroke_width(&self) -> longhands::_webkit_text_stroke_width::computed_value::T {
        Au(self.gecko.mWebkitTextStrokeWidth).into()
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_color(&mut self, v: longhands::color::computed_value::T) {
        self.gecko.mColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_color_from(&mut self, other: &Self) {
        self.gecko.mColor = other.gecko.mColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_color(&mut self, other: &Self) {
        self.copy_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_color(&self) -> longhands::color::computed_value::T {
        From::from(self.gecko.mColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_line_height(&mut self, v: longhands::line_height::computed_value::T) {
        self.gecko.mLineHeight = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_line_height_from(&mut self, other: &Self) {
        self.gecko.mLineHeight = other.gecko.mLineHeight.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_line_height(&mut self, other: &Self) {
        self.copy_line_height_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_line_height(&self) -> longhands::line_height::computed_value::T {
        From::from(self.gecko.mLineHeight.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_transform(&mut self, v: longhands::text_transform::computed_value::T) {
        self.gecko.mTextTransform = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_transform_from(&mut self, other: &Self) {
        self.gecko.mTextTransform = other.gecko.mTextTransform.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_transform(&mut self, other: &Self) {
        self.copy_text_transform_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_transform(&self) -> longhands::text_transform::computed_value::T {
        From::from(self.gecko.mTextTransform.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_hyphens(&mut self, v: longhands::hyphens::computed_value::T) {
        use crate::properties::longhands::hyphens::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Manual =>
                    structs::StyleHyphens::Manual ,
                Keyword::None =>
                    structs::StyleHyphens::None ,
                Keyword::Auto =>
                    structs::StyleHyphens::Auto ,
        };
        self.gecko.mHyphens = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_hyphens_from(&mut self, other: &Self) {
        self.gecko.mHyphens = other.gecko.mHyphens.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_hyphens(&mut self, other: &Self) {
        self.copy_hyphens_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_hyphens(&self) -> longhands::hyphens::computed_value::T {
        use crate::properties::longhands::hyphens::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mHyphens {
            structs::StyleHyphens::Manual => Keyword::Manual,
            structs::StyleHyphens::None => Keyword::None,
            structs::StyleHyphens::Auto => Keyword::Auto,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_text_size_adjust(&mut self, v: longhands::_moz_text_size_adjust::computed_value::T) {
        use crate::properties::longhands::_moz_text_size_adjust::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleTextSizeAdjust::Auto ,
                Keyword::None =>
                    structs::StyleTextSizeAdjust::None ,
        };
        self.gecko.mTextSizeAdjust = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_text_size_adjust_from(&mut self, other: &Self) {
        self.gecko.mTextSizeAdjust = other.gecko.mTextSizeAdjust.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_text_size_adjust(&mut self, other: &Self) {
        self.copy__moz_text_size_adjust_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_text_size_adjust(&self) -> longhands::_moz_text_size_adjust::computed_value::T {
        use crate::properties::longhands::_moz_text_size_adjust::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mTextSizeAdjust {
            structs::StyleTextSizeAdjust::Auto => Keyword::Auto,
            structs::StyleTextSizeAdjust::None => Keyword::None,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_indent(&mut self, v: longhands::text_indent::computed_value::T) {
        self.gecko.mTextIndent = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_indent_from(&mut self, other: &Self) {
        self.gecko.mTextIndent = other.gecko.mTextIndent.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_indent(&mut self, other: &Self) {
        self.copy_text_indent_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_indent(&self) -> longhands::text_indent::computed_value::T {
        From::from(self.gecko.mTextIndent.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_overflow_wrap(&mut self, v: longhands::overflow_wrap::computed_value::T) {
        self.gecko.mOverflowWrap = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_overflow_wrap_from(&mut self, other: &Self) {
        self.gecko.mOverflowWrap = other.gecko.mOverflowWrap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_overflow_wrap(&mut self, other: &Self) {
        self.copy_overflow_wrap_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_overflow_wrap(&self) -> longhands::overflow_wrap::computed_value::T {
        From::from(self.gecko.mOverflowWrap.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_word_break(&mut self, v: longhands::word_break::computed_value::T) {
        self.gecko.mWordBreak = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_word_break_from(&mut self, other: &Self) {
        self.gecko.mWordBreak = other.gecko.mWordBreak.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_word_break(&mut self, other: &Self) {
        self.copy_word_break_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_word_break(&self) -> longhands::word_break::computed_value::T {
        From::from(self.gecko.mWordBreak.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_justify(&mut self, v: longhands::text_justify::computed_value::T) {
        self.gecko.mTextJustify = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_justify_from(&mut self, other: &Self) {
        self.gecko.mTextJustify = other.gecko.mTextJustify.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_justify(&mut self, other: &Self) {
        self.copy_text_justify_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_justify(&self) -> longhands::text_justify::computed_value::T {
        From::from(self.gecko.mTextJustify.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_align_last(&mut self, v: longhands::text_align_last::computed_value::T) {
        self.gecko.mTextAlignLast = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_align_last_from(&mut self, other: &Self) {
        self.gecko.mTextAlignLast = other.gecko.mTextAlignLast.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_align_last(&mut self, other: &Self) {
        self.copy_text_align_last_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_align_last(&self) -> longhands::text_align_last::computed_value::T {
        From::from(self.gecko.mTextAlignLast.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_align(&mut self, v: longhands::text_align::computed_value::T) {
        self.gecko.mTextAlign = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_align_from(&mut self, other: &Self) {
        self.gecko.mTextAlign = other.gecko.mTextAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_align(&mut self, other: &Self) {
        self.copy_text_align_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_align(&self) -> longhands::text_align::computed_value::T {
        From::from(self.gecko.mTextAlign.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_letter_spacing(&mut self, v: longhands::letter_spacing::computed_value::T) {
        self.gecko.mLetterSpacing = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_letter_spacing_from(&mut self, other: &Self) {
        self.gecko.mLetterSpacing = other.gecko.mLetterSpacing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_letter_spacing(&mut self, other: &Self) {
        self.copy_letter_spacing_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_letter_spacing(&self) -> longhands::letter_spacing::computed_value::T {
        From::from(self.gecko.mLetterSpacing.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_word_spacing(&mut self, v: longhands::word_spacing::computed_value::T) {
        self.gecko.mWordSpacing = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_word_spacing_from(&mut self, other: &Self) {
        self.gecko.mWordSpacing = other.gecko.mWordSpacing.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_word_spacing(&mut self, other: &Self) {
        self.copy_word_spacing_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_word_spacing(&self) -> longhands::word_spacing::computed_value::T {
        From::from(self.gecko.mWordSpacing.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_white_space(&mut self, v: longhands::white_space::computed_value::T) {
        use crate::properties::longhands::white_space::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::StyleWhiteSpace::Normal ,
                Keyword::Pre =>
                    structs::StyleWhiteSpace::Pre ,
                Keyword::Nowrap =>
                    structs::StyleWhiteSpace::Nowrap ,
                Keyword::PreWrap =>
                    structs::StyleWhiteSpace::PreWrap ,
                Keyword::PreLine =>
                    structs::StyleWhiteSpace::PreLine ,
                Keyword::BreakSpaces =>
                    structs::StyleWhiteSpace::BreakSpaces ,
                Keyword::MozPreSpace =>
                    structs::StyleWhiteSpace::PreSpace ,
        };
        self.gecko.mWhiteSpace = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_white_space_from(&mut self, other: &Self) {
        self.gecko.mWhiteSpace = other.gecko.mWhiteSpace.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_white_space(&mut self, other: &Self) {
        self.copy_white_space_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_white_space(&self) -> longhands::white_space::computed_value::T {
        use crate::properties::longhands::white_space::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mWhiteSpace {
            structs::StyleWhiteSpace::Normal => Keyword::Normal,
            structs::StyleWhiteSpace::Pre => Keyword::Pre,
            structs::StyleWhiteSpace::Nowrap => Keyword::Nowrap,
            structs::StyleWhiteSpace::PreWrap => Keyword::PreWrap,
            structs::StyleWhiteSpace::PreLine => Keyword::PreLine,
            structs::StyleWhiteSpace::BreakSpaces => Keyword::BreakSpaces,
            structs::StyleWhiteSpace::PreSpace => Keyword::MozPreSpace,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_shadow(&mut self, v: longhands::text_shadow::computed_value::T) {
        self.gecko.mTextShadow = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_shadow_from(&mut self, other: &Self) {
        self.gecko.mTextShadow = other.gecko.mTextShadow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_shadow(&mut self, other: &Self) {
        self.copy_text_shadow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_shadow(&self) -> longhands::text_shadow::computed_value::T {
        From::from(self.gecko.mTextShadow.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_emphasis_style(&mut self, v: longhands::text_emphasis_style::computed_value::T) {
        self.gecko.mTextEmphasisStyle = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_emphasis_style_from(&mut self, other: &Self) {
        self.gecko.mTextEmphasisStyle = other.gecko.mTextEmphasisStyle.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_emphasis_style(&mut self, other: &Self) {
        self.copy_text_emphasis_style_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_emphasis_style(&self) -> longhands::text_emphasis_style::computed_value::T {
        From::from(self.gecko.mTextEmphasisStyle.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_emphasis_position(&mut self, v: longhands::text_emphasis_position::computed_value::T) {
        self.gecko.mTextEmphasisPosition = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_emphasis_position_from(&mut self, other: &Self) {
        self.gecko.mTextEmphasisPosition = other.gecko.mTextEmphasisPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_emphasis_position(&mut self, other: &Self) {
        self.copy_text_emphasis_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_emphasis_position(&self) -> longhands::text_emphasis_position::computed_value::T {
        From::from(self.gecko.mTextEmphasisPosition.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_emphasis_color(&mut self, v: longhands::text_emphasis_color::computed_value::T) {
        self.gecko.mTextEmphasisColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_emphasis_color_from(&mut self, other: &Self) {
        self.gecko.mTextEmphasisColor = other.gecko.mTextEmphasisColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_emphasis_color(&mut self, other: &Self) {
        self.copy_text_emphasis_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_emphasis_color(&self) -> longhands::text_emphasis_color::computed_value::T {
        From::from(self.gecko.mTextEmphasisColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_tab_size(&mut self, v: longhands::tab_size::computed_value::T) {
        self.gecko.mTabSize = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_tab_size_from(&mut self, other: &Self) {
        self.gecko.mTabSize = other.gecko.mTabSize.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_tab_size(&mut self, other: &Self) {
        self.copy_tab_size_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_tab_size(&self) -> longhands::tab_size::computed_value::T {
        From::from(self.gecko.mTabSize.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_line_break(&mut self, v: longhands::line_break::computed_value::T) {
        self.gecko.mLineBreak = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_line_break_from(&mut self, other: &Self) {
        self.gecko.mLineBreak = other.gecko.mLineBreak.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_line_break(&mut self, other: &Self) {
        self.copy_line_break_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_line_break(&self) -> longhands::line_break::computed_value::T {
        From::from(self.gecko.mLineBreak.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__webkit_text_fill_color(&mut self, v: longhands::_webkit_text_fill_color::computed_value::T) {
        self.gecko.mWebkitTextFillColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__webkit_text_fill_color_from(&mut self, other: &Self) {
        self.gecko.mWebkitTextFillColor = other.gecko.mWebkitTextFillColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_text_fill_color(&mut self, other: &Self) {
        self.copy__webkit_text_fill_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__webkit_text_fill_color(&self) -> longhands::_webkit_text_fill_color::computed_value::T {
        From::from(self.gecko.mWebkitTextFillColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__webkit_text_stroke_color(&mut self, v: longhands::_webkit_text_stroke_color::computed_value::T) {
        self.gecko.mWebkitTextStrokeColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__webkit_text_stroke_color_from(&mut self, other: &Self) {
        self.gecko.mWebkitTextStrokeColor = other.gecko.mWebkitTextStrokeColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__webkit_text_stroke_color(&mut self, other: &Self) {
        self.copy__webkit_text_stroke_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__webkit_text_stroke_color(&self) -> longhands::_webkit_text_stroke_color::computed_value::T {
        From::from(self.gecko.mWebkitTextStrokeColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_ruby_align(&mut self, v: longhands::ruby_align::computed_value::T) {
        use crate::properties::longhands::ruby_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::SpaceAround =>
                    structs::StyleRubyAlign::SpaceAround ,
                Keyword::Start =>
                    structs::StyleRubyAlign::Start ,
                Keyword::Center =>
                    structs::StyleRubyAlign::Center ,
                Keyword::SpaceBetween =>
                    structs::StyleRubyAlign::SpaceBetween ,
        };
        self.gecko.mRubyAlign = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_ruby_align_from(&mut self, other: &Self) {
        self.gecko.mRubyAlign = other.gecko.mRubyAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_ruby_align(&mut self, other: &Self) {
        self.copy_ruby_align_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_ruby_align(&self) -> longhands::ruby_align::computed_value::T {
        use crate::properties::longhands::ruby_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mRubyAlign {
            structs::StyleRubyAlign::SpaceAround => Keyword::SpaceAround,
            structs::StyleRubyAlign::Start => Keyword::Start,
            structs::StyleRubyAlign::Center => Keyword::Center,
            structs::StyleRubyAlign::SpaceBetween => Keyword::SpaceBetween,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_ruby_position(&mut self, v: longhands::ruby_position::computed_value::T) {
        self.gecko.mRubyPosition = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_ruby_position_from(&mut self, other: &Self) {
        self.gecko.mRubyPosition = other.gecko.mRubyPosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_ruby_position(&mut self, other: &Self) {
        self.copy_ruby_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_ruby_position(&self) -> longhands::ruby_position::computed_value::T {
        From::from(self.gecko.mRubyPosition.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_combine_upright(&mut self, v: longhands::text_combine_upright::computed_value::T) {
        use crate::properties::longhands::text_combine_upright::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::NS_STYLE_TEXT_COMBINE_UPRIGHT_NONE as u8,
                Keyword::All =>
                    structs::NS_STYLE_TEXT_COMBINE_UPRIGHT_ALL as u8,
        };
        self.gecko.mTextCombineUpright = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_combine_upright_from(&mut self, other: &Self) {
        self.gecko.mTextCombineUpright = other.gecko.mTextCombineUpright.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_combine_upright(&mut self, other: &Self) {
        self.copy_text_combine_upright_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_combine_upright(&self) -> longhands::text_combine_upright::computed_value::T {
        use crate::properties::longhands::text_combine_upright::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_COMBINE_UPRIGHT_NONE : u8 =
            structs::NS_STYLE_TEXT_COMBINE_UPRIGHT_NONE as u8;
        const U8_NS_STYLE_TEXT_COMBINE_UPRIGHT_ALL : u8 =
            structs::NS_STYLE_TEXT_COMBINE_UPRIGHT_ALL as u8;

        match self.gecko.mTextCombineUpright as u8 {
            U8_NS_STYLE_TEXT_COMBINE_UPRIGHT_NONE => Keyword::None,
            U8_NS_STYLE_TEXT_COMBINE_UPRIGHT_ALL => Keyword::All,
            _ => panic!("Found unexpected value in style struct for text_combine_upright property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_rendering(&mut self, v: longhands::text_rendering::computed_value::T) {
        use crate::properties::longhands::text_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleTextRendering::Auto ,
                Keyword::Optimizespeed =>
                    structs::StyleTextRendering::Optimizespeed ,
                Keyword::Optimizelegibility =>
                    structs::StyleTextRendering::Optimizelegibility ,
                Keyword::Geometricprecision =>
                    structs::StyleTextRendering::Geometricprecision ,
        };
        self.gecko.mTextRendering = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_rendering_from(&mut self, other: &Self) {
        self.gecko.mTextRendering = other.gecko.mTextRendering.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_rendering(&mut self, other: &Self) {
        self.copy_text_rendering_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_rendering(&self) -> longhands::text_rendering::computed_value::T {
        use crate::properties::longhands::text_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mTextRendering {
            structs::StyleTextRendering::Auto => Keyword::Auto,
            structs::StyleTextRendering::Optimizespeed => Keyword::Optimizespeed,
            structs::StyleTextRendering::Optimizelegibility => Keyword::Optimizelegibility,
            structs::StyleTextRendering::Geometricprecision => Keyword::Geometricprecision,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_control_character_visibility(&mut self, v: longhands::_moz_control_character_visibility::computed_value::T) {
        self.gecko.mMozControlCharacterVisibility = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_control_character_visibility_from(&mut self, other: &Self) {
        self.gecko.mMozControlCharacterVisibility = other.gecko.mMozControlCharacterVisibility.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_control_character_visibility(&mut self, other: &Self) {
        self.copy__moz_control_character_visibility_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_control_character_visibility(&self) -> longhands::_moz_control_character_visibility::computed_value::T {
        From::from(self.gecko.mMozControlCharacterVisibility.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_underline_offset(&mut self, v: longhands::text_underline_offset::computed_value::T) {
        self.gecko.mTextUnderlineOffset = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_underline_offset_from(&mut self, other: &Self) {
        self.gecko.mTextUnderlineOffset = other.gecko.mTextUnderlineOffset.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_underline_offset(&mut self, other: &Self) {
        self.copy_text_underline_offset_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_underline_offset(&self) -> longhands::text_underline_offset::computed_value::T {
        From::from(self.gecko.mTextUnderlineOffset.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_underline_position(&mut self, v: longhands::text_underline_position::computed_value::T) {
        self.gecko.mTextUnderlinePosition = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_underline_position_from(&mut self, other: &Self) {
        self.gecko.mTextUnderlinePosition = other.gecko.mTextUnderlinePosition.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_underline_position(&mut self, other: &Self) {
        self.copy_text_underline_position_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_underline_position(&self) -> longhands::text_underline_position::computed_value::T {
        From::from(self.gecko.mTextUnderlinePosition.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_decoration_skip_ink(&mut self, v: longhands::text_decoration_skip_ink::computed_value::T) {
        self.gecko.mTextDecorationSkipInk = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_skip_ink_from(&mut self, other: &Self) {
        self.gecko.mTextDecorationSkipInk = other.gecko.mTextDecorationSkipInk.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_skip_ink(&mut self, other: &Self) {
        self.copy_text_decoration_skip_ink_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_decoration_skip_ink(&self) -> longhands::text_decoration_skip_ink::computed_value::T {
        From::from(self.gecko.mTextDecorationSkipInk.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_hyphenate_character(&mut self, v: longhands::hyphenate_character::computed_value::T) {
        self.gecko.mHyphenateCharacter = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_hyphenate_character_from(&mut self, other: &Self) {
        self.gecko.mHyphenateCharacter = other.gecko.mHyphenateCharacter.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_hyphenate_character(&mut self, other: &Self) {
        self.copy_hyphenate_character_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_hyphenate_character(&self) -> longhands::hyphenate_character::computed_value::T {
        From::from(self.gecko.mHyphenateCharacter.clone())
    }


}




impl GeckoText {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn set_initial_letter(&mut self, v: longhands::initial_letter::computed_value::T) {
        use crate::values::generics::text::InitialLetter;
        match v {
            InitialLetter::Normal => {
                self.gecko.mInitialLetterSize = 0.;
                self.gecko.mInitialLetterSink = 0;
            },
            InitialLetter::Specified(size, sink) => {
                self.gecko.mInitialLetterSize = size;
                if let Some(sink) = sink {
                    self.gecko.mInitialLetterSink = sink;
                } else {
                    self.gecko.mInitialLetterSink = size.floor() as i32;
                }
            }
        }
    }

    pub fn copy_initial_letter_from(&mut self, other: &Self) {
        self.gecko.mInitialLetterSize = other.gecko.mInitialLetterSize;
        self.gecko.mInitialLetterSink = other.gecko.mInitialLetterSink;
    }

    pub fn reset_initial_letter(&mut self, other: &Self) {
        self.copy_initial_letter_from(other)
    }

    pub fn clone_initial_letter(&self) -> longhands::initial_letter::computed_value::T {
        use crate::values::generics::text::InitialLetter;

        if self.gecko.mInitialLetterSize == 0. && self.gecko.mInitialLetterSink == 0 {
            InitialLetter::Normal
        } else if self.gecko.mInitialLetterSize.floor() as i32 == self.gecko.mInitialLetterSink {
            InitialLetter::Specified(self.gecko.mInitialLetterSize, None)
        } else {
            InitialLetter::Specified(self.gecko.mInitialLetterSize, Some(self.gecko.mInitialLetterSink))
        }
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_text_overflow(&mut self, v: longhands::text_overflow::computed_value::T) {
        self.gecko.mTextOverflow = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_overflow_from(&mut self, other: &Self) {
        self.gecko.mTextOverflow = other.gecko.mTextOverflow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_overflow(&mut self, other: &Self) {
        self.copy_text_overflow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_overflow(&self) -> longhands::text_overflow::computed_value::T {
        From::from(self.gecko.mTextOverflow.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_unicode_bidi(&mut self, v: longhands::unicode_bidi::computed_value::T) {
        use crate::properties::longhands::unicode_bidi::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::NS_STYLE_UNICODE_BIDI_NORMAL as u8,
                Keyword::Embed =>
                    structs::NS_STYLE_UNICODE_BIDI_EMBED as u8,
                Keyword::Isolate =>
                    structs::NS_STYLE_UNICODE_BIDI_ISOLATE as u8,
                Keyword::BidiOverride =>
                    structs::NS_STYLE_UNICODE_BIDI_BIDI_OVERRIDE as u8,
                Keyword::IsolateOverride =>
                    structs::NS_STYLE_UNICODE_BIDI_ISOLATE_OVERRIDE as u8,
                Keyword::Plaintext =>
                    structs::NS_STYLE_UNICODE_BIDI_PLAINTEXT as u8,
        };
        self.gecko.mUnicodeBidi = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_unicode_bidi_from(&mut self, other: &Self) {
        self.gecko.mUnicodeBidi = other.gecko.mUnicodeBidi.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_unicode_bidi(&mut self, other: &Self) {
        self.copy_unicode_bidi_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_unicode_bidi(&self) -> longhands::unicode_bidi::computed_value::T {
        use crate::properties::longhands::unicode_bidi::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_UNICODE_BIDI_NORMAL : u8 =
            structs::NS_STYLE_UNICODE_BIDI_NORMAL as u8;
        const U8_NS_STYLE_UNICODE_BIDI_EMBED : u8 =
            structs::NS_STYLE_UNICODE_BIDI_EMBED as u8;
        const U8_NS_STYLE_UNICODE_BIDI_ISOLATE : u8 =
            structs::NS_STYLE_UNICODE_BIDI_ISOLATE as u8;
        const U8_NS_STYLE_UNICODE_BIDI_BIDI_OVERRIDE : u8 =
            structs::NS_STYLE_UNICODE_BIDI_BIDI_OVERRIDE as u8;
        const U8_NS_STYLE_UNICODE_BIDI_ISOLATE_OVERRIDE : u8 =
            structs::NS_STYLE_UNICODE_BIDI_ISOLATE_OVERRIDE as u8;
        const U8_NS_STYLE_UNICODE_BIDI_PLAINTEXT : u8 =
            structs::NS_STYLE_UNICODE_BIDI_PLAINTEXT as u8;

        match self.gecko.mUnicodeBidi as u8 {
            U8_NS_STYLE_UNICODE_BIDI_NORMAL => Keyword::Normal,
            U8_NS_STYLE_UNICODE_BIDI_EMBED => Keyword::Embed,
            U8_NS_STYLE_UNICODE_BIDI_ISOLATE => Keyword::Isolate,
            U8_NS_STYLE_UNICODE_BIDI_BIDI_OVERRIDE => Keyword::BidiOverride,
            U8_NS_STYLE_UNICODE_BIDI_ISOLATE_OVERRIDE => Keyword::IsolateOverride,
            U8_NS_STYLE_UNICODE_BIDI_PLAINTEXT => Keyword::Plaintext,
            _ => panic!("Found unexpected value in style struct for unicode_bidi property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_decoration_line(&mut self, v: longhands::text_decoration_line::computed_value::T) {
        self.gecko.mTextDecorationLine = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_line_from(&mut self, other: &Self) {
        self.gecko.mTextDecorationLine = other.gecko.mTextDecorationLine.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_line(&mut self, other: &Self) {
        self.copy_text_decoration_line_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_decoration_line(&self) -> longhands::text_decoration_line::computed_value::T {
        From::from(self.gecko.mTextDecorationLine.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_decoration_style(&mut self, v: longhands::text_decoration_style::computed_value::T) {
        use crate::properties::longhands::text_decoration_style::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Solid =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_SOLID as u8,
                Keyword::Double =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_DOUBLE as u8,
                Keyword::Dotted =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_DOTTED as u8,
                Keyword::Dashed =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_DASHED as u8,
                Keyword::Wavy =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_WAVY as u8,
                Keyword::MozNone =>
                    structs::NS_STYLE_TEXT_DECORATION_STYLE_NONE as u8,
        };
        self.gecko.mTextDecorationStyle = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_style_from(&mut self, other: &Self) {
        self.gecko.mTextDecorationStyle = other.gecko.mTextDecorationStyle.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_style(&mut self, other: &Self) {
        self.copy_text_decoration_style_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_decoration_style(&self) -> longhands::text_decoration_style::computed_value::T {
        use crate::properties::longhands::text_decoration_style::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_SOLID : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_SOLID as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_DOUBLE : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_DOUBLE as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_DOTTED : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_DOTTED as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_DASHED : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_DASHED as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_WAVY : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_WAVY as u8;
        const U8_NS_STYLE_TEXT_DECORATION_STYLE_NONE : u8 =
            structs::NS_STYLE_TEXT_DECORATION_STYLE_NONE as u8;

        match self.gecko.mTextDecorationStyle as u8 {
            U8_NS_STYLE_TEXT_DECORATION_STYLE_SOLID => Keyword::Solid,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_DOUBLE => Keyword::Double,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_DOTTED => Keyword::Dotted,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_DASHED => Keyword::Dashed,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_WAVY => Keyword::Wavy,
            U8_NS_STYLE_TEXT_DECORATION_STYLE_NONE => Keyword::MozNone,
            _ => panic!("Found unexpected value in style struct for text_decoration_style property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_decoration_color(&mut self, v: longhands::text_decoration_color::computed_value::T) {
        self.gecko.mTextDecorationColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_color_from(&mut self, other: &Self) {
        self.gecko.mTextDecorationColor = other.gecko.mTextDecorationColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_color(&mut self, other: &Self) {
        self.copy_text_decoration_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_decoration_color(&self) -> longhands::text_decoration_color::computed_value::T {
        From::from(self.gecko.mTextDecorationColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_text_decoration_thickness(&mut self, v: longhands::text_decoration_thickness::computed_value::T) {
        self.gecko.mTextDecorationThickness = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_text_decoration_thickness_from(&mut self, other: &Self) {
        self.gecko.mTextDecorationThickness = other.gecko.mTextDecorationThickness.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_decoration_thickness(&mut self, other: &Self) {
        self.copy_text_decoration_thickness_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_decoration_thickness(&self) -> longhands::text_decoration_thickness::computed_value::T {
        From::from(self.gecko.mTextDecorationThickness.clone())
    }


}





impl GeckoSVG {
    /*
     * Manually-Implemented Methods.
     */
    
    
    

    
    
    pub fn copy_mask_repeat_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mRepeatCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mRepeat = other.mRepeat.clone();
        }
        self.gecko.mMask.mRepeatCount = count;
    }

    pub fn reset_mask_repeat(&mut self, other: &Self) {
        self.copy_mask_repeat_from(other)
    }


    pub fn set_mask_repeat<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::mask_repeat::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mRepeatCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mRepeat = {
                
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_Repeat;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_ns(repeat: BackgroundRepeatKeyword) -> StyleImageLayerRepeat {
            match repeat {
                BackgroundRepeatKeyword::Repeat => StyleImageLayerRepeat::Repeat,
                BackgroundRepeatKeyword::Space => StyleImageLayerRepeat::Space,
                BackgroundRepeatKeyword::Round => StyleImageLayerRepeat::Round,
                BackgroundRepeatKeyword::NoRepeat => StyleImageLayerRepeat::NoRepeat,
            }
        }

        let repeat_x = to_ns(servo.0);
        let repeat_y = to_ns(servo.1);
        nsStyleImageLayers_Repeat {
              mXRepeat: repeat_x,
              mYRepeat: repeat_y,
        }
    
            };
        }
    }


    pub fn clone_mask_repeat(&self) -> longhands::mask_repeat::computed_value::T {
        use crate::properties::longhands::mask_repeat::single_value::computed_value::T;
        use crate::values::specified::background::BackgroundRepeatKeyword;
        use crate::gecko_bindings::structs::StyleImageLayerRepeat;

        fn to_servo(repeat: StyleImageLayerRepeat) -> BackgroundRepeatKeyword {
            match repeat {
                StyleImageLayerRepeat::Repeat => BackgroundRepeatKeyword::Repeat,
                StyleImageLayerRepeat::Space => BackgroundRepeatKeyword::Space,
                StyleImageLayerRepeat::Round => BackgroundRepeatKeyword::Round,
                StyleImageLayerRepeat::NoRepeat => BackgroundRepeatKeyword::NoRepeat,
                _ => panic!("Found unexpected value in style struct for mask_repeat property"),
            }
        }

        longhands::mask_repeat::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mRepeatCount as usize)
                .map(|ref layer| {
                    T(to_servo(layer.mRepeat.mXRepeat), to_servo(layer.mRepeat.mYRepeat))
                }).collect()
        )
    }

    
    

    
    pub fn copy_mask_clip_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mClipCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mClip = other.mClip.clone();
        }
        self.gecko.mMask.mClipCount = count;
    }

    pub fn reset_mask_clip(&mut self, other: &Self) {
        self.copy_mask_clip_from(other)
    }


    pub fn set_mask_clip<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_clip::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_clip::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mClipCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mClip = {
                match servo {
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::FillBox =>
                        structs::StyleGeometryBox::FillBox ,
                    Keyword::StrokeBox =>
                        structs::StyleGeometryBox::StrokeBox ,
                    Keyword::ViewBox =>
                        structs::StyleGeometryBox::ViewBox ,
                    Keyword::NoClip =>
                        structs::StyleGeometryBox::NoClip ,
                }
            };
        }
    }

    pub fn clone_mask_clip(&self) -> longhands::mask_clip::computed_value::T {
        use crate::properties::longhands::mask_clip::single_value::computed_value::T as Keyword;


        longhands::mask_clip::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mClipCount as usize)
                .map(|ref layer| {
                    match layer.mClip {
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::FillBox
                            => Keyword::FillBox,
                        structs::StyleGeometryBox::StrokeBox
                            => Keyword::StrokeBox,
                        structs::StyleGeometryBox::ViewBox
                            => Keyword::ViewBox,
                        structs::StyleGeometryBox::NoClip
                            => Keyword::NoClip,
                        _ => panic!("Found unexpected value in style struct for mask_clip property"),
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_mask_origin_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mOriginCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mOrigin = other.mOrigin.clone();
        }
        self.gecko.mMask.mOriginCount = count;
    }

    pub fn reset_mask_origin(&mut self, other: &Self) {
        self.copy_mask_origin_from(other)
    }


    pub fn set_mask_origin<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_origin::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_origin::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mOriginCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mOrigin = {
                match servo {
                    Keyword::BorderBox =>
                        structs::StyleGeometryBox::BorderBox ,
                    Keyword::ContentBox =>
                        structs::StyleGeometryBox::ContentBox ,
                    Keyword::PaddingBox =>
                        structs::StyleGeometryBox::PaddingBox ,
                    Keyword::FillBox =>
                        structs::StyleGeometryBox::FillBox ,
                    Keyword::StrokeBox =>
                        structs::StyleGeometryBox::StrokeBox ,
                    Keyword::ViewBox =>
                        structs::StyleGeometryBox::ViewBox ,
                }
            };
        }
    }

    pub fn clone_mask_origin(&self) -> longhands::mask_origin::computed_value::T {
        use crate::properties::longhands::mask_origin::single_value::computed_value::T as Keyword;


        longhands::mask_origin::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mOriginCount as usize)
                .map(|ref layer| {
                    match layer.mOrigin {
                        structs::StyleGeometryBox::BorderBox
                            => Keyword::BorderBox,
                        structs::StyleGeometryBox::ContentBox
                            => Keyword::ContentBox,
                        structs::StyleGeometryBox::PaddingBox
                            => Keyword::PaddingBox,
                        structs::StyleGeometryBox::FillBox
                            => Keyword::FillBox,
                        structs::StyleGeometryBox::StrokeBox
                            => Keyword::StrokeBox,
                        structs::StyleGeometryBox::ViewBox
                            => Keyword::ViewBox,
                        _ => panic!("Found unexpected value in style struct for mask_origin property"),
                    }
                }).collect()
        )
    }


    pub fn copy_mask_position_x_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mPositionXCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }

        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.horizontal = other.mPosition.horizontal.clone();
        }
        self.gecko.mMask.mPositionXCount = count;
    }

    pub fn reset_mask_position_x(&mut self, other: &Self) {
        self.copy_mask_position_x_from(other)
    }

    pub fn clone_mask_position_x(&self)
        -> longhands::mask_position_x::computed_value::T {
        longhands::mask_position_x::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mPositionXCount as usize)
                .map(|position| position.mPosition.horizontal.clone())
                .collect()
        )
    }

    pub fn set_mask_position_x<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::mask_position_x
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mPositionXCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.horizontal = servo;
        }
    }
    pub fn copy_mask_position_y_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mPositionYCount;

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }

        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mPosition.vertical = other.mPosition.vertical.clone();
        }
        self.gecko.mMask.mPositionYCount = count;
    }

    pub fn reset_mask_position_y(&mut self, other: &Self) {
        self.copy_mask_position_y_from(other)
    }

    pub fn clone_mask_position_y(&self)
        -> longhands::mask_position_y::computed_value::T {
        longhands::mask_position_y::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mPositionYCount as usize)
                .map(|position| position.mPosition.vertical.clone())
                .collect()
        )
    }

    pub fn set_mask_position_y<I>(&mut self,
                                     v: I)
        where I: IntoIterator<Item = longhands::mask_position_y
                                              ::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mPositionYCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask
                                                           .mLayers.iter_mut()) {
            geckolayer.mPosition.vertical = servo;
        }
    }

    
    
    pub fn copy_mask_size_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mSizeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mSize = other.mSize.clone();
        }
        self.gecko.mMask.mSizeCount = count;
    }

    pub fn reset_mask_size(&mut self, other: &Self) {
        self.copy_mask_size_from(other)
    }


    pub fn set_mask_size<I>(&mut self, v: I)
        where I: IntoIterator<Item=longhands::mask_size::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mSizeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mSize = {
                
        servo
    
            };
        }
    }


    pub fn clone_mask_size(&self) -> longhands::mask_size::computed_value::T {
        longhands::mask_size::computed_value::List(
            self.gecko.mMask.mLayers.iter().map(|layer| layer.mSize.clone()).collect()
        )
    }

    pub fn copy_mask_image_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;
        unsafe {
            let count = other.gecko.mMask.mImageCount;
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);

            for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                      .zip(other.gecko.mMask.mLayers.iter())
                                      .take(count as usize) {
                layer.mImage = other.mImage.clone();
            }
            self.gecko.mMask.mImageCount = count;
        }
    }

    pub fn reset_mask_image(&mut self, other: &Self) {
        self.copy_mask_image_from(other)
    }

    #[allow(unused_variables)]
    pub fn set_mask_image<I>(&mut self, images: I)
        where I: IntoIterator<Item = longhands::mask_image::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let images = images.into_iter();

        unsafe {
            Gecko_EnsureImageLayersLength(
                &mut self.gecko.mMask,
                images.len(),
                LayerType::Mask,
            );
        }

        self.gecko.mMask.mImageCount = images.len() as u32;
        for (image, geckoimage) in images.zip(self.gecko.mMask
                                                  .mLayers.iter_mut()) {
            geckoimage.mImage = image;
        }
    }

    pub fn clone_mask_image(&self) -> longhands::mask_image::computed_value::T {
        longhands::mask_image::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mImageCount as usize)
                .map(|layer| layer.mImage.clone())
                .collect()
        )
    }

    
    pub fn fill_arrays(&mut self) {
        use crate::gecko_bindings::bindings::Gecko_FillAllImageLayers;
        use std::cmp;
        let mut max_len = 1;
            max_len = cmp::max(max_len, self.gecko.mMask.mRepeatCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mClipCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mOriginCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mPositionXCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mPositionYCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mImageCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mSizeCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mMaskModeCount);
            max_len = cmp::max(max_len, self.gecko.mMask.mCompositeCount);
        unsafe {
            // While we could do this manually, we'd need to also manually
            // run all the copy constructors, so we just delegate to gecko
            Gecko_FillAllImageLayers(&mut self.gecko.mMask, max_len);
        }
    }

    
    

    
    pub fn copy_mask_mode_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mMaskModeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mMaskMode = other.mMaskMode.clone();
        }
        self.gecko.mMask.mMaskModeCount = count;
    }

    pub fn reset_mask_mode(&mut self, other: &Self) {
        self.copy_mask_mode_from(other)
    }


    pub fn set_mask_mode<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_mode::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_mode::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mMaskModeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mMaskMode = {
                match servo {
                    Keyword::MatchSource =>
                        structs::StyleMaskMode::MatchSource ,
                    Keyword::Alpha =>
                        structs::StyleMaskMode::Alpha ,
                    Keyword::Luminance =>
                        structs::StyleMaskMode::Luminance ,
                }
            };
        }
    }

    pub fn clone_mask_mode(&self) -> longhands::mask_mode::computed_value::T {
        use crate::properties::longhands::mask_mode::single_value::computed_value::T as Keyword;


        longhands::mask_mode::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mMaskModeCount as usize)
                .map(|ref layer| {
                    match layer.mMaskMode {
                        structs::StyleMaskMode::MatchSource
                            => Keyword::MatchSource,
                        structs::StyleMaskMode::Alpha
                            => Keyword::Alpha,
                        structs::StyleMaskMode::Luminance
                            => Keyword::Luminance,
                    }
                }).collect()
        )
    }

    
    

    
    pub fn copy_mask_composite_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let count = other.gecko.mMask.mCompositeCount;
        unsafe {
            Gecko_EnsureImageLayersLength(&mut self.gecko.mMask,
                                          count as usize,
                                          LayerType::Mask);
        }
        // FIXME(emilio): This may be bogus in the same way as bug 1426246.
        for (layer, other) in self.gecko.mMask.mLayers.iter_mut()
                                  .zip(other.gecko.mMask.mLayers.iter())
                                  .take(count as usize) {
            layer.mComposite = other.mComposite.clone();
        }
        self.gecko.mMask.mCompositeCount = count;
    }

    pub fn reset_mask_composite(&mut self, other: &Self) {
        self.copy_mask_composite_from(other)
    }


    pub fn set_mask_composite<I>(&mut self, v: I)
    where
        I: IntoIterator<Item=longhands::mask_composite::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator,
    {
        use crate::properties::longhands::mask_composite::single_value::computed_value::T as Keyword;
        use crate::gecko_bindings::structs::nsStyleImageLayers_LayerType as LayerType;

        let v = v.into_iter();

        unsafe {
          Gecko_EnsureImageLayersLength(&mut self.gecko.mMask, v.len(),
                                        LayerType::Mask);
        }

        self.gecko.mMask.mCompositeCount = v.len() as u32;
        for (servo, geckolayer) in v.zip(self.gecko.mMask.mLayers.iter_mut()) {
            geckolayer.mComposite = {
                match servo {
                    Keyword::Add =>
                        structs::StyleMaskComposite::Add ,
                    Keyword::Subtract =>
                        structs::StyleMaskComposite::Subtract ,
                    Keyword::Intersect =>
                        structs::StyleMaskComposite::Intersect ,
                    Keyword::Exclude =>
                        structs::StyleMaskComposite::Exclude ,
                }
            };
        }
    }

    pub fn clone_mask_composite(&self) -> longhands::mask_composite::computed_value::T {
        use crate::properties::longhands::mask_composite::single_value::computed_value::T as Keyword;


        longhands::mask_composite::computed_value::List(
            self.gecko.mMask.mLayers.iter()
                .take(self.gecko.mMask.mCompositeCount as usize)
                .map(|ref layer| {
                    match layer.mComposite {
                        structs::StyleMaskComposite::Add
                            => Keyword::Add,
                        structs::StyleMaskComposite::Subtract
                            => Keyword::Subtract,
                        structs::StyleMaskComposite::Intersect
                            => Keyword::Intersect,
                        structs::StyleMaskComposite::Exclude
                            => Keyword::Exclude,
                    }
                }).collect()
        )
    }



    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_vector_effect(&mut self, v: longhands::vector_effect::computed_value::T) {
        use crate::properties::longhands::vector_effect::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleVectorEffect::None ,
                Keyword::NonScalingStroke =>
                    structs::StyleVectorEffect::NonScalingStroke ,
        };
        self.gecko.mVectorEffect = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_vector_effect_from(&mut self, other: &Self) {
        self.gecko.mVectorEffect = other.gecko.mVectorEffect.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_vector_effect(&mut self, other: &Self) {
        self.copy_vector_effect_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_vector_effect(&self) -> longhands::vector_effect::computed_value::T {
        use crate::properties::longhands::vector_effect::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mVectorEffect {
            structs::StyleVectorEffect::None => Keyword::None,
            structs::StyleVectorEffect::NonScalingStroke => Keyword::NonScalingStroke,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_stop_color(&mut self, v: longhands::stop_color::computed_value::T) {
        self.gecko.mStopColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stop_color_from(&mut self, other: &Self) {
        self.gecko.mStopColor = other.gecko.mStopColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stop_color(&mut self, other: &Self) {
        self.copy_stop_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stop_color(&self) -> longhands::stop_color::computed_value::T {
        From::from(self.gecko.mStopColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_stop_opacity(&mut self, v: longhands::stop_opacity::computed_value::T) {
        self.gecko.mStopOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stop_opacity_from(&mut self, other: &Self) {
        self.gecko.mStopOpacity = other.gecko.mStopOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stop_opacity(&mut self, other: &Self) {
        self.copy_stop_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stop_opacity(&self) -> longhands::stop_opacity::computed_value::T {
        From::from(self.gecko.mStopOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flood_color(&mut self, v: longhands::flood_color::computed_value::T) {
        self.gecko.mFloodColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flood_color_from(&mut self, other: &Self) {
        self.gecko.mFloodColor = other.gecko.mFloodColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flood_color(&mut self, other: &Self) {
        self.copy_flood_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flood_color(&self) -> longhands::flood_color::computed_value::T {
        From::from(self.gecko.mFloodColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_flood_opacity(&mut self, v: longhands::flood_opacity::computed_value::T) {
        self.gecko.mFloodOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_flood_opacity_from(&mut self, other: &Self) {
        self.gecko.mFloodOpacity = other.gecko.mFloodOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_flood_opacity(&mut self, other: &Self) {
        self.copy_flood_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_flood_opacity(&self) -> longhands::flood_opacity::computed_value::T {
        From::from(self.gecko.mFloodOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_lighting_color(&mut self, v: longhands::lighting_color::computed_value::T) {
        self.gecko.mLightingColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_lighting_color_from(&mut self, other: &Self) {
        self.gecko.mLightingColor = other.gecko.mLightingColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_lighting_color(&mut self, other: &Self) {
        self.copy_lighting_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_lighting_color(&self) -> longhands::lighting_color::computed_value::T {
        From::from(self.gecko.mLightingColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_mask_type(&mut self, v: longhands::mask_type::computed_value::T) {
        use crate::properties::longhands::mask_type::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Luminance =>
                    structs::StyleMaskType::Luminance ,
                Keyword::Alpha =>
                    structs::StyleMaskType::Alpha ,
        };
        self.gecko.mMaskType = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_mask_type_from(&mut self, other: &Self) {
        self.gecko.mMaskType = other.gecko.mMaskType.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_mask_type(&mut self, other: &Self) {
        self.copy_mask_type_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_mask_type(&self) -> longhands::mask_type::computed_value::T {
        use crate::properties::longhands::mask_type::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mMaskType {
            structs::StyleMaskType::Luminance => Keyword::Luminance,
            structs::StyleMaskType::Alpha => Keyword::Alpha,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_clip_path(&mut self, v: longhands::clip_path::computed_value::T) {
        self.gecko.mClipPath = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_clip_path_from(&mut self, other: &Self) {
        self.gecko.mClipPath = other.gecko.mClipPath.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_clip_path(&mut self, other: &Self) {
        self.copy_clip_path_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_clip_path(&self) -> longhands::clip_path::computed_value::T {
        From::from(self.gecko.mClipPath.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_x(&mut self, v: longhands::x::computed_value::T) {
        self.gecko.mX = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_x_from(&mut self, other: &Self) {
        self.gecko.mX = other.gecko.mX.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_x(&mut self, other: &Self) {
        self.copy_x_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_x(&self) -> longhands::x::computed_value::T {
        From::from(self.gecko.mX.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_y(&mut self, v: longhands::y::computed_value::T) {
        self.gecko.mY = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_y_from(&mut self, other: &Self) {
        self.gecko.mY = other.gecko.mY.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_y(&mut self, other: &Self) {
        self.copy_y_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_y(&self) -> longhands::y::computed_value::T {
        From::from(self.gecko.mY.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_cx(&mut self, v: longhands::cx::computed_value::T) {
        self.gecko.mCx = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_cx_from(&mut self, other: &Self) {
        self.gecko.mCx = other.gecko.mCx.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_cx(&mut self, other: &Self) {
        self.copy_cx_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_cx(&self) -> longhands::cx::computed_value::T {
        From::from(self.gecko.mCx.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_cy(&mut self, v: longhands::cy::computed_value::T) {
        self.gecko.mCy = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_cy_from(&mut self, other: &Self) {
        self.gecko.mCy = other.gecko.mCy.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_cy(&mut self, other: &Self) {
        self.copy_cy_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_cy(&self) -> longhands::cy::computed_value::T {
        From::from(self.gecko.mCy.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_rx(&mut self, v: longhands::rx::computed_value::T) {
        self.gecko.mRx = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_rx_from(&mut self, other: &Self) {
        self.gecko.mRx = other.gecko.mRx.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_rx(&mut self, other: &Self) {
        self.copy_rx_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_rx(&self) -> longhands::rx::computed_value::T {
        From::from(self.gecko.mRx.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_ry(&mut self, v: longhands::ry::computed_value::T) {
        self.gecko.mRy = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_ry_from(&mut self, other: &Self) {
        self.gecko.mRy = other.gecko.mRy.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_ry(&mut self, other: &Self) {
        self.copy_ry_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_ry(&self) -> longhands::ry::computed_value::T {
        From::from(self.gecko.mRy.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_r(&mut self, v: longhands::r::computed_value::T) {
        self.gecko.mR = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_r_from(&mut self, other: &Self) {
        self.gecko.mR = other.gecko.mR.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_r(&mut self, other: &Self) {
        self.copy_r_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_r(&self) -> longhands::r::computed_value::T {
        From::from(self.gecko.mR.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_d(&mut self, v: longhands::d::computed_value::T) {
        self.gecko.mD = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_d_from(&mut self, other: &Self) {
        self.gecko.mD = other.gecko.mD.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_d(&mut self, other: &Self) {
        self.copy_d_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_d(&self) -> longhands::d::computed_value::T {
        From::from(self.gecko.mD.clone())
    }


}




impl GeckoInheritedSVG {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_dominant_baseline(&mut self, v: longhands::dominant_baseline::computed_value::T) {
        use crate::properties::longhands::dominant_baseline::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleDominantBaseline::Auto ,
                Keyword::Ideographic =>
                    structs::StyleDominantBaseline::Ideographic ,
                Keyword::Alphabetic =>
                    structs::StyleDominantBaseline::Alphabetic ,
                Keyword::Hanging =>
                    structs::StyleDominantBaseline::Hanging ,
                Keyword::Mathematical =>
                    structs::StyleDominantBaseline::Mathematical ,
                Keyword::Central =>
                    structs::StyleDominantBaseline::Central ,
                Keyword::Middle =>
                    structs::StyleDominantBaseline::Middle ,
                Keyword::TextAfterEdge =>
                    structs::StyleDominantBaseline::TextAfterEdge ,
                Keyword::TextBeforeEdge =>
                    structs::StyleDominantBaseline::TextBeforeEdge ,
        };
        self.gecko.mDominantBaseline = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_dominant_baseline_from(&mut self, other: &Self) {
        self.gecko.mDominantBaseline = other.gecko.mDominantBaseline.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_dominant_baseline(&mut self, other: &Self) {
        self.copy_dominant_baseline_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_dominant_baseline(&self) -> longhands::dominant_baseline::computed_value::T {
        use crate::properties::longhands::dominant_baseline::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mDominantBaseline {
            structs::StyleDominantBaseline::Auto => Keyword::Auto,
            structs::StyleDominantBaseline::Ideographic => Keyword::Ideographic,
            structs::StyleDominantBaseline::Alphabetic => Keyword::Alphabetic,
            structs::StyleDominantBaseline::Hanging => Keyword::Hanging,
            structs::StyleDominantBaseline::Mathematical => Keyword::Mathematical,
            structs::StyleDominantBaseline::Central => Keyword::Central,
            structs::StyleDominantBaseline::Middle => Keyword::Middle,
            structs::StyleDominantBaseline::TextAfterEdge => Keyword::TextAfterEdge,
            structs::StyleDominantBaseline::TextBeforeEdge => Keyword::TextBeforeEdge,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_text_anchor(&mut self, v: longhands::text_anchor::computed_value::T) {
        use crate::properties::longhands::text_anchor::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Start =>
                    structs::StyleTextAnchor::Start ,
                Keyword::Middle =>
                    structs::StyleTextAnchor::Middle ,
                Keyword::End =>
                    structs::StyleTextAnchor::End ,
        };
        self.gecko.mTextAnchor = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_text_anchor_from(&mut self, other: &Self) {
        self.gecko.mTextAnchor = other.gecko.mTextAnchor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_text_anchor(&mut self, other: &Self) {
        self.copy_text_anchor_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_text_anchor(&self) -> longhands::text_anchor::computed_value::T {
        use crate::properties::longhands::text_anchor::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mTextAnchor {
            structs::StyleTextAnchor::Start => Keyword::Start,
            structs::StyleTextAnchor::Middle => Keyword::Middle,
            structs::StyleTextAnchor::End => Keyword::End,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_color_interpolation(&mut self, v: longhands::color_interpolation::computed_value::T) {
        use crate::properties::longhands::color_interpolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Srgb =>
                    structs::StyleColorInterpolation::Srgb ,
                Keyword::Auto =>
                    structs::StyleColorInterpolation::Auto ,
                Keyword::Linearrgb =>
                    structs::StyleColorInterpolation::Linearrgb ,
        };
        self.gecko.mColorInterpolation = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_color_interpolation_from(&mut self, other: &Self) {
        self.gecko.mColorInterpolation = other.gecko.mColorInterpolation.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_color_interpolation(&mut self, other: &Self) {
        self.copy_color_interpolation_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_color_interpolation(&self) -> longhands::color_interpolation::computed_value::T {
        use crate::properties::longhands::color_interpolation::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mColorInterpolation {
            structs::StyleColorInterpolation::Srgb => Keyword::Srgb,
            structs::StyleColorInterpolation::Auto => Keyword::Auto,
            structs::StyleColorInterpolation::Linearrgb => Keyword::Linearrgb,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_color_interpolation_filters(&mut self, v: longhands::color_interpolation_filters::computed_value::T) {
        use crate::properties::longhands::color_interpolation_filters::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Linearrgb =>
                    structs::StyleColorInterpolation::Linearrgb ,
                Keyword::Auto =>
                    structs::StyleColorInterpolation::Auto ,
                Keyword::Srgb =>
                    structs::StyleColorInterpolation::Srgb ,
        };
        self.gecko.mColorInterpolationFilters = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_color_interpolation_filters_from(&mut self, other: &Self) {
        self.gecko.mColorInterpolationFilters = other.gecko.mColorInterpolationFilters.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_color_interpolation_filters(&mut self, other: &Self) {
        self.copy_color_interpolation_filters_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_color_interpolation_filters(&self) -> longhands::color_interpolation_filters::computed_value::T {
        use crate::properties::longhands::color_interpolation_filters::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mColorInterpolationFilters {
            structs::StyleColorInterpolation::Linearrgb => Keyword::Linearrgb,
            structs::StyleColorInterpolation::Auto => Keyword::Auto,
            structs::StyleColorInterpolation::Srgb => Keyword::Srgb,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_fill(&mut self, v: longhands::fill::computed_value::T) {
        self.gecko.mFill = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_fill_from(&mut self, other: &Self) {
        self.gecko.mFill = other.gecko.mFill.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_fill(&mut self, other: &Self) {
        self.copy_fill_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_fill(&self) -> longhands::fill::computed_value::T {
        From::from(self.gecko.mFill.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_fill_opacity(&mut self, v: longhands::fill_opacity::computed_value::T) {
        self.gecko.mFillOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_fill_opacity_from(&mut self, other: &Self) {
        self.gecko.mFillOpacity = other.gecko.mFillOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_fill_opacity(&mut self, other: &Self) {
        self.copy_fill_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_fill_opacity(&self) -> longhands::fill_opacity::computed_value::T {
        From::from(self.gecko.mFillOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_fill_rule(&mut self, v: longhands::fill_rule::computed_value::T) {
        self.gecko.mFillRule = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_fill_rule_from(&mut self, other: &Self) {
        self.gecko.mFillRule = other.gecko.mFillRule.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_fill_rule(&mut self, other: &Self) {
        self.copy_fill_rule_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_fill_rule(&self) -> longhands::fill_rule::computed_value::T {
        From::from(self.gecko.mFillRule.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_shape_rendering(&mut self, v: longhands::shape_rendering::computed_value::T) {
        use crate::properties::longhands::shape_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleShapeRendering::Auto ,
                Keyword::Optimizespeed =>
                    structs::StyleShapeRendering::Optimizespeed ,
                Keyword::Crispedges =>
                    structs::StyleShapeRendering::Crispedges ,
                Keyword::Geometricprecision =>
                    structs::StyleShapeRendering::Geometricprecision ,
        };
        self.gecko.mShapeRendering = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_shape_rendering_from(&mut self, other: &Self) {
        self.gecko.mShapeRendering = other.gecko.mShapeRendering.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_shape_rendering(&mut self, other: &Self) {
        self.copy_shape_rendering_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_shape_rendering(&self) -> longhands::shape_rendering::computed_value::T {
        use crate::properties::longhands::shape_rendering::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mShapeRendering {
            structs::StyleShapeRendering::Auto => Keyword::Auto,
            structs::StyleShapeRendering::Optimizespeed => Keyword::Optimizespeed,
            structs::StyleShapeRendering::Crispedges => Keyword::Crispedges,
            structs::StyleShapeRendering::Geometricprecision => Keyword::Geometricprecision,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_stroke(&mut self, v: longhands::stroke::computed_value::T) {
        self.gecko.mStroke = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_from(&mut self, other: &Self) {
        self.gecko.mStroke = other.gecko.mStroke.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke(&mut self, other: &Self) {
        self.copy_stroke_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke(&self) -> longhands::stroke::computed_value::T {
        From::from(self.gecko.mStroke.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_width(&mut self, v: longhands::stroke_width::computed_value::T) {
        self.gecko.mStrokeWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_width_from(&mut self, other: &Self) {
        self.gecko.mStrokeWidth = other.gecko.mStrokeWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_width(&mut self, other: &Self) {
        self.copy_stroke_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_width(&self) -> longhands::stroke_width::computed_value::T {
        From::from(self.gecko.mStrokeWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_linecap(&mut self, v: longhands::stroke_linecap::computed_value::T) {
        use crate::properties::longhands::stroke_linecap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Butt =>
                    structs::StyleStrokeLinecap::Butt ,
                Keyword::Round =>
                    structs::StyleStrokeLinecap::Round ,
                Keyword::Square =>
                    structs::StyleStrokeLinecap::Square ,
        };
        self.gecko.mStrokeLinecap = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_linecap_from(&mut self, other: &Self) {
        self.gecko.mStrokeLinecap = other.gecko.mStrokeLinecap.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_linecap(&mut self, other: &Self) {
        self.copy_stroke_linecap_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_linecap(&self) -> longhands::stroke_linecap::computed_value::T {
        use crate::properties::longhands::stroke_linecap::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mStrokeLinecap {
            structs::StyleStrokeLinecap::Butt => Keyword::Butt,
            structs::StyleStrokeLinecap::Round => Keyword::Round,
            structs::StyleStrokeLinecap::Square => Keyword::Square,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_linejoin(&mut self, v: longhands::stroke_linejoin::computed_value::T) {
        use crate::properties::longhands::stroke_linejoin::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Miter =>
                    structs::StyleStrokeLinejoin::Miter ,
                Keyword::Round =>
                    structs::StyleStrokeLinejoin::Round ,
                Keyword::Bevel =>
                    structs::StyleStrokeLinejoin::Bevel ,
        };
        self.gecko.mStrokeLinejoin = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_linejoin_from(&mut self, other: &Self) {
        self.gecko.mStrokeLinejoin = other.gecko.mStrokeLinejoin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_linejoin(&mut self, other: &Self) {
        self.copy_stroke_linejoin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_linejoin(&self) -> longhands::stroke_linejoin::computed_value::T {
        use crate::properties::longhands::stroke_linejoin::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mStrokeLinejoin {
            structs::StyleStrokeLinejoin::Miter => Keyword::Miter,
            structs::StyleStrokeLinejoin::Round => Keyword::Round,
            structs::StyleStrokeLinejoin::Bevel => Keyword::Bevel,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_miterlimit(&mut self, v: longhands::stroke_miterlimit::computed_value::T) {
        self.gecko.mStrokeMiterlimit = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_miterlimit_from(&mut self, other: &Self) {
        self.gecko.mStrokeMiterlimit = other.gecko.mStrokeMiterlimit.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_miterlimit(&mut self, other: &Self) {
        self.copy_stroke_miterlimit_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_miterlimit(&self) -> longhands::stroke_miterlimit::computed_value::T {
        From::from(self.gecko.mStrokeMiterlimit.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_opacity(&mut self, v: longhands::stroke_opacity::computed_value::T) {
        self.gecko.mStrokeOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_opacity_from(&mut self, other: &Self) {
        self.gecko.mStrokeOpacity = other.gecko.mStrokeOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_opacity(&mut self, other: &Self) {
        self.copy_stroke_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_opacity(&self) -> longhands::stroke_opacity::computed_value::T {
        From::from(self.gecko.mStrokeOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_dasharray(&mut self, v: longhands::stroke_dasharray::computed_value::T) {
        self.gecko.mStrokeDasharray = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_dasharray_from(&mut self, other: &Self) {
        self.gecko.mStrokeDasharray = other.gecko.mStrokeDasharray.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_dasharray(&mut self, other: &Self) {
        self.copy_stroke_dasharray_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_dasharray(&self) -> longhands::stroke_dasharray::computed_value::T {
        From::from(self.gecko.mStrokeDasharray.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_stroke_dashoffset(&mut self, v: longhands::stroke_dashoffset::computed_value::T) {
        self.gecko.mStrokeDashoffset = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_stroke_dashoffset_from(&mut self, other: &Self) {
        self.gecko.mStrokeDashoffset = other.gecko.mStrokeDashoffset.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_stroke_dashoffset(&mut self, other: &Self) {
        self.copy_stroke_dashoffset_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_stroke_dashoffset(&self) -> longhands::stroke_dashoffset::computed_value::T {
        From::from(self.gecko.mStrokeDashoffset.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_clip_rule(&mut self, v: longhands::clip_rule::computed_value::T) {
        self.gecko.mClipRule = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_clip_rule_from(&mut self, other: &Self) {
        self.gecko.mClipRule = other.gecko.mClipRule.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_clip_rule(&mut self, other: &Self) {
        self.copy_clip_rule_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_clip_rule(&self) -> longhands::clip_rule::computed_value::T {
        From::from(self.gecko.mClipRule.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_marker_start(&mut self, v: longhands::marker_start::computed_value::T) {
        self.gecko.mMarkerStart = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_marker_start_from(&mut self, other: &Self) {
        self.gecko.mMarkerStart = other.gecko.mMarkerStart.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_marker_start(&mut self, other: &Self) {
        self.copy_marker_start_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_marker_start(&self) -> longhands::marker_start::computed_value::T {
        From::from(self.gecko.mMarkerStart.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_marker_mid(&mut self, v: longhands::marker_mid::computed_value::T) {
        self.gecko.mMarkerMid = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_marker_mid_from(&mut self, other: &Self) {
        self.gecko.mMarkerMid = other.gecko.mMarkerMid.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_marker_mid(&mut self, other: &Self) {
        self.copy_marker_mid_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_marker_mid(&self) -> longhands::marker_mid::computed_value::T {
        From::from(self.gecko.mMarkerMid.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_marker_end(&mut self, v: longhands::marker_end::computed_value::T) {
        self.gecko.mMarkerEnd = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_marker_end_from(&mut self, other: &Self) {
        self.gecko.mMarkerEnd = other.gecko.mMarkerEnd.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_marker_end(&mut self, other: &Self) {
        self.copy_marker_end_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_marker_end(&self) -> longhands::marker_end::computed_value::T {
        From::from(self.gecko.mMarkerEnd.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_paint_order(&mut self, v: longhands::paint_order::computed_value::T) {
        self.gecko.mPaintOrder = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_paint_order_from(&mut self, other: &Self) {
        self.gecko.mPaintOrder = other.gecko.mPaintOrder.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_paint_order(&mut self, other: &Self) {
        self.copy_paint_order_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_paint_order(&self) -> longhands::paint_order::computed_value::T {
        From::from(self.gecko.mPaintOrder.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_context_properties(&mut self, v: longhands::_moz_context_properties::computed_value::T) {
        self.gecko.mMozContextProperties = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_context_properties_from(&mut self, other: &Self) {
        self.gecko.mMozContextProperties = other.gecko.mMozContextProperties.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_context_properties(&mut self, other: &Self) {
        self.copy__moz_context_properties_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_context_properties(&self) -> longhands::_moz_context_properties::computed_value::T {
        From::from(self.gecko.mMozContextProperties.clone())
    }


}




impl GeckoInheritedUI {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_cursor(&mut self, v: longhands::cursor::computed_value::T) {
        self.gecko.mCursor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_cursor_from(&mut self, other: &Self) {
        self.gecko.mCursor = other.gecko.mCursor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_cursor(&mut self, other: &Self) {
        self.copy_cursor_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_cursor(&self) -> longhands::cursor::computed_value::T {
        From::from(self.gecko.mCursor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_pointer_events(&mut self, v: longhands::pointer_events::computed_value::T) {
        use crate::properties::longhands::pointer_events::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StylePointerEvents::Auto ,
                Keyword::None =>
                    structs::StylePointerEvents::None ,
                Keyword::Visiblepainted =>
                    structs::StylePointerEvents::Visiblepainted ,
                Keyword::Visiblefill =>
                    structs::StylePointerEvents::Visiblefill ,
                Keyword::Visiblestroke =>
                    structs::StylePointerEvents::Visiblestroke ,
                Keyword::Visible =>
                    structs::StylePointerEvents::Visible ,
                Keyword::Painted =>
                    structs::StylePointerEvents::Painted ,
                Keyword::Fill =>
                    structs::StylePointerEvents::Fill ,
                Keyword::Stroke =>
                    structs::StylePointerEvents::Stroke ,
                Keyword::All =>
                    structs::StylePointerEvents::All ,
        };
        self.gecko.mPointerEvents = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_pointer_events_from(&mut self, other: &Self) {
        self.gecko.mPointerEvents = other.gecko.mPointerEvents.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_pointer_events(&mut self, other: &Self) {
        self.copy_pointer_events_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_pointer_events(&self) -> longhands::pointer_events::computed_value::T {
        use crate::properties::longhands::pointer_events::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mPointerEvents {
            structs::StylePointerEvents::Auto => Keyword::Auto,
            structs::StylePointerEvents::None => Keyword::None,
            structs::StylePointerEvents::Visiblepainted => Keyword::Visiblepainted,
            structs::StylePointerEvents::Visiblefill => Keyword::Visiblefill,
            structs::StylePointerEvents::Visiblestroke => Keyword::Visiblestroke,
            structs::StylePointerEvents::Visible => Keyword::Visible,
            structs::StylePointerEvents::Painted => Keyword::Painted,
            structs::StylePointerEvents::Fill => Keyword::Fill,
            structs::StylePointerEvents::Stroke => Keyword::Stroke,
            structs::StylePointerEvents::All => Keyword::All,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_inert(&mut self, v: longhands::_moz_inert::computed_value::T) {
        use crate::properties::longhands::_moz_inert::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleInert::None ,
                Keyword::Inert =>
                    structs::StyleInert::Inert ,
        };
        self.gecko.mInert = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_inert_from(&mut self, other: &Self) {
        self.gecko.mInert = other.gecko.mInert.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_inert(&mut self, other: &Self) {
        self.copy__moz_inert_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_inert(&self) -> longhands::_moz_inert::computed_value::T {
        use crate::properties::longhands::_moz_inert::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mInert {
            structs::StyleInert::None => Keyword::None,
            structs::StyleInert::Inert => Keyword::Inert,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_user_input(&mut self, v: longhands::_moz_user_input::computed_value::T) {
        use crate::properties::longhands::_moz_user_input::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleUserInput::Auto ,
                Keyword::None =>
                    structs::StyleUserInput::None ,
        };
        self.gecko.mUserInput = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_user_input_from(&mut self, other: &Self) {
        self.gecko.mUserInput = other.gecko.mUserInput.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_user_input(&mut self, other: &Self) {
        self.copy__moz_user_input_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_user_input(&self) -> longhands::_moz_user_input::computed_value::T {
        use crate::properties::longhands::_moz_user_input::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mUserInput {
            structs::StyleUserInput::Auto => Keyword::Auto,
            structs::StyleUserInput::None => Keyword::None,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_user_modify(&mut self, v: longhands::_moz_user_modify::computed_value::T) {
        use crate::properties::longhands::_moz_user_modify::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::ReadOnly =>
                    structs::StyleUserModify::ReadOnly ,
                Keyword::ReadWrite =>
                    structs::StyleUserModify::ReadWrite ,
                Keyword::WriteOnly =>
                    structs::StyleUserModify::WriteOnly ,
        };
        self.gecko.mUserModify = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_user_modify_from(&mut self, other: &Self) {
        self.gecko.mUserModify = other.gecko.mUserModify.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_user_modify(&mut self, other: &Self) {
        self.copy__moz_user_modify_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_user_modify(&self) -> longhands::_moz_user_modify::computed_value::T {
        use crate::properties::longhands::_moz_user_modify::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mUserModify {
            structs::StyleUserModify::ReadOnly => Keyword::ReadOnly,
            structs::StyleUserModify::ReadWrite => Keyword::ReadWrite,
            structs::StyleUserModify::WriteOnly => Keyword::WriteOnly,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_user_focus(&mut self, v: longhands::_moz_user_focus::computed_value::T) {
        use crate::properties::longhands::_moz_user_focus::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleUserFocus::None ,
                Keyword::Ignore =>
                    structs::StyleUserFocus::Ignore ,
                Keyword::Normal =>
                    structs::StyleUserFocus::Normal ,
                Keyword::SelectAfter =>
                    structs::StyleUserFocus::SelectAfter ,
                Keyword::SelectBefore =>
                    structs::StyleUserFocus::SelectBefore ,
                Keyword::SelectMenu =>
                    structs::StyleUserFocus::SelectMenu ,
                Keyword::SelectSame =>
                    structs::StyleUserFocus::SelectSame ,
                Keyword::SelectAll =>
                    structs::StyleUserFocus::SelectAll ,
        };
        self.gecko.mUserFocus = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_user_focus_from(&mut self, other: &Self) {
        self.gecko.mUserFocus = other.gecko.mUserFocus.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_user_focus(&mut self, other: &Self) {
        self.copy__moz_user_focus_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_user_focus(&self) -> longhands::_moz_user_focus::computed_value::T {
        use crate::properties::longhands::_moz_user_focus::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mUserFocus {
            structs::StyleUserFocus::None => Keyword::None,
            structs::StyleUserFocus::Ignore => Keyword::Ignore,
            structs::StyleUserFocus::Normal => Keyword::Normal,
            structs::StyleUserFocus::SelectAfter => Keyword::SelectAfter,
            structs::StyleUserFocus::SelectBefore => Keyword::SelectBefore,
            structs::StyleUserFocus::SelectMenu => Keyword::SelectMenu,
            structs::StyleUserFocus::SelectSame => Keyword::SelectSame,
            structs::StyleUserFocus::SelectAll => Keyword::SelectAll,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_caret_color(&mut self, v: longhands::caret_color::computed_value::T) {
        self.gecko.mCaretColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_caret_color_from(&mut self, other: &Self) {
        self.gecko.mCaretColor = other.gecko.mCaretColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_caret_color(&mut self, other: &Self) {
        self.copy_caret_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_caret_color(&self) -> longhands::caret_color::computed_value::T {
        From::from(self.gecko.mCaretColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_accent_color(&mut self, v: longhands::accent_color::computed_value::T) {
        self.gecko.mAccentColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_accent_color_from(&mut self, other: &Self) {
        self.gecko.mAccentColor = other.gecko.mAccentColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_accent_color(&mut self, other: &Self) {
        self.copy_accent_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_accent_color(&self) -> longhands::accent_color::computed_value::T {
        From::from(self.gecko.mAccentColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_color_scheme(&mut self, v: longhands::color_scheme::computed_value::T) {
        self.gecko.mColorScheme = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_color_scheme_from(&mut self, other: &Self) {
        self.gecko.mColorScheme = other.gecko.mColorScheme.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_color_scheme(&mut self, other: &Self) {
        self.copy_color_scheme_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_color_scheme(&self) -> longhands::color_scheme::computed_value::T {
        From::from(self.gecko.mColorScheme.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_scrollbar_color(&mut self, v: longhands::scrollbar_color::computed_value::T) {
        self.gecko.mScrollbarColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_scrollbar_color_from(&mut self, other: &Self) {
        self.gecko.mScrollbarColor = other.gecko.mScrollbarColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scrollbar_color(&mut self, other: &Self) {
        self.copy_scrollbar_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scrollbar_color(&self) -> longhands::scrollbar_color::computed_value::T {
        From::from(self.gecko.mScrollbarColor.clone())
    }


}




impl GeckoColumn {
    /*
     * Manually-Implemented Methods.
     */
    

    #[allow(unused_unsafe)]
    pub fn set_column_count(&mut self, v: longhands::column_count::computed_value::T) {
        use crate::gecko_bindings::structs::{nsStyleColumn_kColumnCountAuto, nsStyleColumn_kMaxColumnCount};

        self.gecko.mColumnCount = match v {
            ColumnCount::Integer(integer) => {
                cmp::min(integer.0 as u32, unsafe { nsStyleColumn_kMaxColumnCount })
            },
            ColumnCount::Auto => nsStyleColumn_kColumnCountAuto
        };
    }

    
    #[allow(non_snake_case)]
    pub fn copy_column_count_from(&mut self, other: &Self) {
        self.gecko.mColumnCount = other.gecko.mColumnCount.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_count(&mut self, other: &Self) {
        self.copy_column_count_from(other)
    }


    pub fn clone_column_count(&self) -> longhands::column_count::computed_value::T {
        use crate::gecko_bindings::structs::{nsStyleColumn_kColumnCountAuto, nsStyleColumn_kMaxColumnCount};
        if self.gecko.mColumnCount != nsStyleColumn_kColumnCountAuto {
            debug_assert!(self.gecko.mColumnCount >= 1 &&
                          self.gecko.mColumnCount <= nsStyleColumn_kMaxColumnCount);
            ColumnCount::Integer((self.gecko.mColumnCount as i32).into())
        } else {
            ColumnCount::Auto
        }
    }

    
    #[allow(non_snake_case)]
    pub fn set_column_rule_width(&mut self, v: longhands::column_rule_width::computed_value::T) {
        let value = {
            let au_per_device_px = Au(self.gecko.mTwipsPerPixel);
            round_border_to_device_pixels(Au::from(v), au_per_device_px).0
        };

        self.gecko.mColumnRuleWidth = value;
    }

    #[allow(non_snake_case)]
    pub fn copy_column_rule_width_from(&mut self, other: &Self) {
        self.gecko.mColumnRuleWidth = other.gecko.mColumnRuleWidth;
    }

    #[allow(non_snake_case)]
    pub fn reset_column_rule_width(&mut self, other: &Self) {
        self.copy_column_rule_width_from(other)
    }

    #[allow(non_snake_case)]
    pub fn clone_column_rule_width(&self) -> longhands::column_rule_width::computed_value::T {
        Au(self.gecko.mColumnRuleWidth).into()
    }

    

    #[allow(non_snake_case)]
    pub fn set_column_rule_style(&mut self, v: longhands::column_rule_style::computed_value::T) {
        self.gecko.mColumnRuleStyle = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_column_rule_style_from(&mut self, other: &Self) {
        self.gecko.mColumnRuleStyle = other.gecko.mColumnRuleStyle.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_rule_style(&mut self, other: &Self) {
        self.copy_column_rule_style_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_rule_style(&self) -> longhands::column_rule_style::computed_value::T {
        From::from(self.gecko.mColumnRuleStyle.clone())
    }




    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_column_width(&mut self, v: longhands::column_width::computed_value::T) {
        self.gecko.mColumnWidth = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_column_width_from(&mut self, other: &Self) {
        self.gecko.mColumnWidth = other.gecko.mColumnWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_width(&mut self, other: &Self) {
        self.copy_column_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_width(&self) -> longhands::column_width::computed_value::T {
        From::from(self.gecko.mColumnWidth.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_column_fill(&mut self, v: longhands::column_fill::computed_value::T) {
        use crate::properties::longhands::column_fill::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Balance =>
                    structs::StyleColumnFill::Balance ,
                Keyword::Auto =>
                    structs::StyleColumnFill::Auto ,
        };
        self.gecko.mColumnFill = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_column_fill_from(&mut self, other: &Self) {
        self.gecko.mColumnFill = other.gecko.mColumnFill.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_fill(&mut self, other: &Self) {
        self.copy_column_fill_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_fill(&self) -> longhands::column_fill::computed_value::T {
        use crate::properties::longhands::column_fill::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mColumnFill {
            structs::StyleColumnFill::Balance => Keyword::Balance,
            structs::StyleColumnFill::Auto => Keyword::Auto,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_column_rule_color(&mut self, v: longhands::column_rule_color::computed_value::T) {
        self.gecko.mColumnRuleColor = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_column_rule_color_from(&mut self, other: &Self) {
        self.gecko.mColumnRuleColor = other.gecko.mColumnRuleColor.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_rule_color(&mut self, other: &Self) {
        self.copy_column_rule_color_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_rule_color(&self) -> longhands::column_rule_color::computed_value::T {
        From::from(self.gecko.mColumnRuleColor.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_column_span(&mut self, v: longhands::column_span::computed_value::T) {
        use crate::properties::longhands::column_span::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::None =>
                    structs::StyleColumnSpan::None ,
                Keyword::All =>
                    structs::StyleColumnSpan::All ,
        };
        self.gecko.mColumnSpan = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_column_span_from(&mut self, other: &Self) {
        self.gecko.mColumnSpan = other.gecko.mColumnSpan.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_column_span(&mut self, other: &Self) {
        self.copy_column_span_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_column_span(&self) -> longhands::column_span::computed_value::T {
        use crate::properties::longhands::column_span::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mColumnSpan {
            structs::StyleColumnSpan::None => Keyword::None,
            structs::StyleColumnSpan::All => Keyword::All,
        }
    }


}




impl GeckoCounters {
    /*
     * Manually-Implemented Methods.
     */
    
    pub fn ineffective_content_property(&self) -> bool {
        !self.gecko.mContent.is_items()
    }


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_content(&mut self, v: longhands::content::computed_value::T) {
        self.gecko.mContent = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_content_from(&mut self, other: &Self) {
        self.gecko.mContent = other.gecko.mContent.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_content(&mut self, other: &Self) {
        self.copy_content_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_content(&self) -> longhands::content::computed_value::T {
        From::from(self.gecko.mContent.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_counter_increment(&mut self, v: longhands::counter_increment::computed_value::T) {
        self.gecko.mCounterIncrement = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_counter_increment_from(&mut self, other: &Self) {
        self.gecko.mCounterIncrement = other.gecko.mCounterIncrement.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_counter_increment(&mut self, other: &Self) {
        self.copy_counter_increment_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_counter_increment(&self) -> longhands::counter_increment::computed_value::T {
        From::from(self.gecko.mCounterIncrement.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_counter_reset(&mut self, v: longhands::counter_reset::computed_value::T) {
        self.gecko.mCounterReset = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_counter_reset_from(&mut self, other: &Self) {
        self.gecko.mCounterReset = other.gecko.mCounterReset.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_counter_reset(&mut self, other: &Self) {
        self.copy_counter_reset_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_counter_reset(&self) -> longhands::counter_reset::computed_value::T {
        From::from(self.gecko.mCounterReset.clone())
    }



    #[allow(non_snake_case)]
    pub fn set_counter_set(&mut self, v: longhands::counter_set::computed_value::T) {
        self.gecko.mCounterSet = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_counter_set_from(&mut self, other: &Self) {
        self.gecko.mCounterSet = other.gecko.mCounterSet.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_counter_set(&mut self, other: &Self) {
        self.copy_counter_set_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_counter_set(&self) -> longhands::counter_set::computed_value::T {
        From::from(self.gecko.mCounterSet.clone())
    }


}






impl GeckoUI {
    /*
     * Manually-Implemented Methods.
     */
    
    
    
    #[allow(non_snake_case)]
    pub fn set_transition_delay<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::transition_delay::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mTransitions.ensure_len(input_len);

        self.gecko.mTransitionDelayCount = input_len as u32;
        for (gecko, servo) in self.gecko.mTransitions.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDelay = servo.seconds() * 1000.;
        }
    }
    #[allow(non_snake_case)]
    pub fn transition_delay_at(&self, index: usize)
        -> longhands::transition_delay::computed_value::SingleComputedValue {
        use crate::values::computed::Time;
        Time::from_seconds(self.gecko.mTransitions[index].mDelay / 1000.)
    }
    
    #[allow(non_snake_case)]
    pub fn transition_delay_count(&self) -> usize {
        self.gecko.mTransitionDelayCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_transition_delay_from(&mut self, other: &Self) {
        self.gecko.mTransitions.ensure_len(other.gecko.mTransitions.len());

        let count = other.gecko.mTransitionDelayCount;
        self.gecko.mTransitionDelayCount = count;

        let iter = self.gecko.mTransitions.iter_mut().take(count as usize).zip(
            other.gecko.mTransitions.iter()
        );

        for (ours, others) in iter {
            ours.mDelay = others.mDelay.clone();
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_transition_delay(&mut self, other: &Self) {
        self.copy_transition_delay_from(other)
    }



    
    
    #[allow(non_snake_case)]
    pub fn set_transition_duration<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::transition_duration::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mTransitions.ensure_len(input_len);

        self.gecko.mTransitionDurationCount = input_len as u32;
        for (gecko, servo) in self.gecko.mTransitions.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDuration = servo.seconds() * 1000.;
        }
    }
    #[allow(non_snake_case)]
    pub fn transition_duration_at(&self, index: usize)
        -> longhands::transition_duration::computed_value::SingleComputedValue {
        use crate::values::computed::Time;
        Time::from_seconds(self.gecko.mTransitions[index].mDuration / 1000.)
    }
    
    #[allow(non_snake_case)]
    pub fn transition_duration_count(&self) -> usize {
        self.gecko.mTransitionDurationCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_transition_duration_from(&mut self, other: &Self) {
        self.gecko.mTransitions.ensure_len(other.gecko.mTransitions.len());

        let count = other.gecko.mTransitionDurationCount;
        self.gecko.mTransitionDurationCount = count;

        let iter = self.gecko.mTransitions.iter_mut().take(count as usize).zip(
            other.gecko.mTransitions.iter()
        );

        for (ours, others) in iter {
            ours.mDuration = others.mDuration.clone();
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_transition_duration(&mut self, other: &Self) {
        self.copy_transition_duration_from(other)
    }



    
    pub fn set_transition_timing_function<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::transition_timing_function::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mTransitions.ensure_len(input_len);

        self.gecko.mTransitionTimingFunctionCount = input_len as u32;
        for (gecko, servo) in self.gecko.mTransitions.iter_mut().take(input_len as usize).zip(v) {
            gecko.mTimingFunction.mTiming = servo;
        }
    }
    
    #[allow(non_snake_case)]
    pub fn transition_timing_function_count(&self) -> usize {
        self.gecko.mTransitionTimingFunctionCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_transition_timing_function_from(&mut self, other: &Self) {
        self.gecko.mTransitions.ensure_len(other.gecko.mTransitions.len());

        let count = other.gecko.mTransitionTimingFunctionCount;
        self.gecko.mTransitionTimingFunctionCount = count;

        let iter = self.gecko.mTransitions.iter_mut().take(count as usize).zip(
            other.gecko.mTransitions.iter()
        );

        for (ours, others) in iter {
            ours.mTimingFunction.mTiming = others.mTimingFunction.mTiming;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_transition_timing_function(&mut self, other: &Self) {
        self.copy_transition_timing_function_from(other)
    }

    pub fn transition_timing_function_at(&self, index: usize)
        -> longhands::transition_timing_function::computed_value::SingleComputedValue {
        self.gecko.mTransitions[index].mTimingFunction.mTiming
    }


    pub fn transition_combined_duration_at(&self, index: usize) -> f32 {
        // https://drafts.csswg.org/css-transitions/#transition-combined-duration
        self.gecko.mTransitions[index % self.gecko.mTransitionDurationCount as usize].mDuration.max(0.0)
            + self.gecko.mTransitions[index % self.gecko.mTransitionDelayCount as usize].mDelay
    }

    pub fn set_transition_property<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::transition_property::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_no_properties;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_variable;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSProperty_UNKNOWN;

        let v = v.into_iter();

        if v.len() != 0 {
            self.gecko.mTransitions.ensure_len(v.len());
            self.gecko.mTransitionPropertyCount = v.len() as u32;
            for (servo, gecko) in v.zip(self.gecko.mTransitions.iter_mut()) {
                unsafe { gecko.mUnknownProperty.clear() };

                match servo {
                    TransitionProperty::Unsupported(ident) => {
                        gecko.mProperty = eCSSProperty_UNKNOWN;
                        gecko.mUnknownProperty.mRawPtr = ident.0.into_addrefed();
                    },
                    TransitionProperty::Custom(name) => {
                        gecko.mProperty = eCSSPropertyExtra_variable;
                        gecko.mUnknownProperty.mRawPtr = name.into_addrefed();
                    }
                    _ => gecko.mProperty = servo.to_nscsspropertyid().unwrap(),
                }
            }
        } else {
            // In gecko |none| is represented by eCSSPropertyExtra_no_properties.
            self.gecko.mTransitionPropertyCount = 1;
            self.gecko.mTransitions[0].mProperty = eCSSPropertyExtra_no_properties;
        }
    }

    /// Returns whether there are any transitions specified.
    pub fn specifies_transitions(&self) -> bool {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_all_properties;
        if self.gecko.mTransitionPropertyCount == 1 &&
            self.gecko.mTransitions[0].mProperty == eCSSPropertyExtra_all_properties &&
            self.transition_combined_duration_at(0) <= 0.0f32 {
            return false;
        }

        self.gecko.mTransitionPropertyCount > 0
    }

    pub fn transition_property_at(&self, index: usize)
        -> longhands::transition_property::computed_value::SingleComputedValue {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_no_properties;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_variable;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSProperty_UNKNOWN;

        let property = self.gecko.mTransitions[index].mProperty;
        if property == eCSSProperty_UNKNOWN {
            let atom = self.gecko.mTransitions[index].mUnknownProperty.mRawPtr;
            debug_assert!(!atom.is_null());
            TransitionProperty::Unsupported(CustomIdent(unsafe{
                Atom::from_raw(atom)
            }))
        } else if property == eCSSPropertyExtra_variable {
            let atom = self.gecko.mTransitions[index].mUnknownProperty.mRawPtr;
            debug_assert!(!atom.is_null());
            TransitionProperty::Custom(unsafe{
                Atom::from_raw(atom)
            })
        } else if property == eCSSPropertyExtra_no_properties {
            // Actually, we don't expect TransitionProperty::Unsupported also
            // represents "none", but if the caller wants to convert it, it is
            // fine. Please use it carefully.
            //
            // FIXME(emilio): This is a hack, is this reachable?
            TransitionProperty::Unsupported(CustomIdent(atom!("none")))
        } else {
            property.into()
        }
    }

    pub fn transition_nscsspropertyid_at(&self, index: usize) -> nsCSSPropertyID {
        self.gecko.mTransitions[index].mProperty
    }

    pub fn copy_transition_property_from(&mut self, other: &Self) {
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSPropertyExtra_variable;
        use crate::gecko_bindings::structs::nsCSSPropertyID::eCSSProperty_UNKNOWN;
        self.gecko.mTransitions.ensure_len(other.gecko.mTransitions.len());

        let count = other.gecko.mTransitionPropertyCount;
        self.gecko.mTransitionPropertyCount = count;

        for (index, transition) in self.gecko.mTransitions.iter_mut().enumerate().take(count as usize) {
            transition.mProperty = other.gecko.mTransitions[index].mProperty;
            unsafe { transition.mUnknownProperty.clear() };
            if transition.mProperty == eCSSProperty_UNKNOWN ||
               transition.mProperty == eCSSPropertyExtra_variable {
                let atom = other.gecko.mTransitions[index].mUnknownProperty.mRawPtr;
                debug_assert!(!atom.is_null());
                transition.mUnknownProperty.mRawPtr = unsafe { Atom::from_raw(atom) }.into_addrefed();
            }
        }
    }

    pub fn reset_transition_property(&mut self, other: &Self) {
        self.copy_transition_property_from(other)
    }

    
    
    #[allow(non_snake_case)]
    pub fn transition_property_count(&self) -> usize {
        self.gecko.mTransitionPropertyCount as usize
    }



    pub fn animations_equals(&self, other: &Self) -> bool {
        return self.gecko.mAnimationNameCount == other.gecko.mAnimationNameCount
            && self.gecko.mAnimationDelayCount == other.gecko.mAnimationDelayCount
            && self.gecko.mAnimationDirectionCount == other.gecko.mAnimationDirectionCount
            && self.gecko.mAnimationDurationCount == other.gecko.mAnimationDurationCount
            && self.gecko.mAnimationFillModeCount == other.gecko.mAnimationFillModeCount
            && self.gecko.mAnimationIterationCountCount == other.gecko.mAnimationIterationCountCount
            && self.gecko.mAnimationPlayStateCount == other.gecko.mAnimationPlayStateCount
            && self.gecko.mAnimationTimingFunctionCount == other.gecko.mAnimationTimingFunctionCount
            && unsafe { bindings::Gecko_StyleAnimationsEquals(&self.gecko.mAnimations, &other.gecko.mAnimations) }
    }

    pub fn set_animation_name<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_name::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        self.gecko.mAnimations.ensure_len(v.len());

        self.gecko.mAnimationNameCount = v.len() as u32;
        for (servo, gecko) in v.zip(self.gecko.mAnimations.iter_mut()) {
            let atom = servo.0.as_atom().clone();
            unsafe { bindings::Gecko_SetAnimationName(gecko, atom.into_addrefed()); }
        }
    }
    pub fn animation_name_at(&self, index: usize)
        -> longhands::animation_name::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_name::single_value::SpecifiedValue as AnimationName;

        let atom = self.gecko.mAnimations[index].mName.mRawPtr;
        AnimationName(KeyframesName::from_atom(unsafe { Atom::from_raw(atom) }))
    }
    pub fn copy_animation_name_from(&mut self, other: &Self) {
        self.gecko.mAnimationNameCount = other.gecko.mAnimationNameCount;
        unsafe { bindings::Gecko_CopyAnimationNames(&mut self.gecko.mAnimations, &other.gecko.mAnimations); }
    }

    pub fn reset_animation_name(&mut self, other: &Self) {
        self.copy_animation_name_from(other)
    }

    
    
    #[allow(non_snake_case)]
    pub fn animation_name_count(&self) -> usize {
        self.gecko.mAnimationNameCount as usize
    }



    
    
    #[allow(non_snake_case)]
    pub fn set_animation_delay<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_delay::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationDelayCount = input_len as u32;
        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDelay = servo.seconds() * 1000.;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_delay_at(&self, index: usize)
        -> longhands::animation_delay::computed_value::SingleComputedValue {
        use crate::values::computed::Time;
        Time::from_seconds(self.gecko.mAnimations[index].mDelay / 1000.)
    }
    
    #[allow(non_snake_case)]
    pub fn animation_delay_count(&self) -> usize {
        self.gecko.mAnimationDelayCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_animation_delay_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationDelayCount;
        self.gecko.mAnimationDelayCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mDelay = others.mDelay.clone();
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_delay(&mut self, other: &Self) {
        self.copy_animation_delay_from(other)
    }



    
    
    #[allow(non_snake_case)]
    pub fn set_animation_duration<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_duration::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationDurationCount = input_len as u32;
        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mDuration = servo.seconds() * 1000.;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_duration_at(&self, index: usize)
        -> longhands::animation_duration::computed_value::SingleComputedValue {
        use crate::values::computed::Time;
        Time::from_seconds(self.gecko.mAnimations[index].mDuration / 1000.)
    }
    
    #[allow(non_snake_case)]
    pub fn animation_duration_count(&self) -> usize {
        self.gecko.mAnimationDurationCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_animation_duration_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationDurationCount;
        self.gecko.mAnimationDurationCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mDuration = others.mDuration.clone();
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_duration(&mut self, other: &Self) {
        self.copy_animation_duration_from(other)
    }




    
    #[allow(non_snake_case)]
    pub fn set_animation_direction<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_direction::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        use crate::properties::longhands::animation_direction::single_value::computed_value::T as Keyword;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationDirectionCount = input_len as u32;

        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            let result = match servo {
                    Keyword::Normal =>
                        structs::PlaybackDirection::Normal ,
                    Keyword::Reverse =>
                        structs::PlaybackDirection::Reverse ,
                    Keyword::Alternate =>
                        structs::PlaybackDirection::Alternate ,
                    Keyword::AlternateReverse =>
                        structs::PlaybackDirection::Alternate_reverse ,
            };
            gecko.mDirection = result;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_direction_at(&self, index: usize)
        -> longhands::animation_direction::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_direction::single_value::computed_value::T as Keyword;
        match self.gecko.mAnimations[index].mDirection  {
                structs::PlaybackDirection::Normal => Keyword::Normal,
                structs::PlaybackDirection::Reverse => Keyword::Reverse,
                structs::PlaybackDirection::Alternate => Keyword::Alternate,
                structs::PlaybackDirection::Alternate_reverse => Keyword::AlternateReverse,
            _ => panic!("Found unexpected value for animation-direction"),
        }
    }
    
    
    #[allow(non_snake_case)]
    pub fn animation_direction_count(&self) -> usize {
        self.gecko.mAnimationDirectionCount as usize
    }


    
    
    #[allow(non_snake_case)]
    pub fn copy_animation_direction_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationDirectionCount;
        self.gecko.mAnimationDirectionCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mDirection = others.mDirection.clone();
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_direction(&mut self, other: &Self) {
        self.copy_animation_direction_from(other)
    }



    
    #[allow(non_snake_case)]
    pub fn set_animation_fill_mode<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_fill_mode::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        use crate::properties::longhands::animation_fill_mode::single_value::computed_value::T as Keyword;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationFillModeCount = input_len as u32;

        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            let result = match servo {
                    Keyword::None =>
                        structs::FillMode::None ,
                    Keyword::Forwards =>
                        structs::FillMode::Forwards ,
                    Keyword::Backwards =>
                        structs::FillMode::Backwards ,
                    Keyword::Both =>
                        structs::FillMode::Both ,
            };
            gecko.mFillMode = result;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_fill_mode_at(&self, index: usize)
        -> longhands::animation_fill_mode::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_fill_mode::single_value::computed_value::T as Keyword;
        match self.gecko.mAnimations[index].mFillMode  {
                structs::FillMode::None => Keyword::None,
                structs::FillMode::Forwards => Keyword::Forwards,
                structs::FillMode::Backwards => Keyword::Backwards,
                structs::FillMode::Both => Keyword::Both,
            _ => panic!("Found unexpected value for animation-fill_mode"),
        }
    }
    
    
    #[allow(non_snake_case)]
    pub fn animation_fill_mode_count(&self) -> usize {
        self.gecko.mAnimationFillModeCount as usize
    }


    
    
    #[allow(non_snake_case)]
    pub fn copy_animation_fill_mode_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationFillModeCount;
        self.gecko.mAnimationFillModeCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mFillMode = others.mFillMode.clone();
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_fill_mode(&mut self, other: &Self) {
        self.copy_animation_fill_mode_from(other)
    }



    
    #[allow(non_snake_case)]
    pub fn set_animation_play_state<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_play_state::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        use crate::properties::longhands::animation_play_state::single_value::computed_value::T as Keyword;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationPlayStateCount = input_len as u32;

        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            let result = match servo {
                    Keyword::Running =>
                        structs::StyleAnimationPlayState::Running ,
                    Keyword::Paused =>
                        structs::StyleAnimationPlayState::Paused ,
            };
            gecko.mPlayState = result;
        }
    }
    #[allow(non_snake_case)]
    pub fn animation_play_state_at(&self, index: usize)
        -> longhands::animation_play_state::computed_value::SingleComputedValue {
        use crate::properties::longhands::animation_play_state::single_value::computed_value::T as Keyword;
        match self.gecko.mAnimations[index].mPlayState  {
                structs::StyleAnimationPlayState::Running => Keyword::Running,
                structs::StyleAnimationPlayState::Paused => Keyword::Paused,
        }
    }
    
    
    #[allow(non_snake_case)]
    pub fn animation_play_state_count(&self) -> usize {
        self.gecko.mAnimationPlayStateCount as usize
    }


    
    
    #[allow(non_snake_case)]
    pub fn copy_animation_play_state_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationPlayStateCount;
        self.gecko.mAnimationPlayStateCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mPlayState = others.mPlayState.clone();
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_play_state(&mut self, other: &Self) {
        self.copy_animation_play_state_from(other)
    }




    pub fn set_animation_iteration_count<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = values::computed::AnimationIterationCount>,
        I::IntoIter: ExactSizeIterator + Clone
    {
        use std::f32;
        use crate::values::generics::box_::AnimationIterationCount;

        let v = v.into_iter();

        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationIterationCountCount = input_len as u32;
        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            match servo {
                AnimationIterationCount::Number(n) => gecko.mIterationCount = n,
                AnimationIterationCount::Infinite => gecko.mIterationCount = f32::INFINITY,
            }
        }
    }

    pub fn animation_iteration_count_at(
        &self,
        index: usize,
    ) -> values::computed::AnimationIterationCount {
        use crate::values::generics::box_::AnimationIterationCount;

        if self.gecko.mAnimations[index].mIterationCount.is_infinite() {
            AnimationIterationCount::Infinite
        } else {
            AnimationIterationCount::Number(self.gecko.mAnimations[index].mIterationCount)
        }
    }

    
    
    #[allow(non_snake_case)]
    pub fn animation_iteration_count_count(&self) -> usize {
        self.gecko.mAnimationIterationCountCount as usize
    }


    
    
    #[allow(non_snake_case)]
    pub fn copy_animation_iteration_count_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationIterationCountCount;
        self.gecko.mAnimationIterationCountCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mIterationCount = others.mIterationCount.clone();
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_iteration_count(&mut self, other: &Self) {
        self.copy_animation_iteration_count_from(other)
    }


    
    pub fn set_animation_timing_function<I>(&mut self, v: I)
        where I: IntoIterator<Item = longhands::animation_timing_function::computed_value::single_value::T>,
              I::IntoIter: ExactSizeIterator + Clone
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationTimingFunctionCount = input_len as u32;
        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mTimingFunction.mTiming = servo;
        }
    }
    
    #[allow(non_snake_case)]
    pub fn animation_timing_function_count(&self) -> usize {
        self.gecko.mAnimationTimingFunctionCount as usize
    }

    
    #[allow(non_snake_case)]
    pub fn copy_animation_timing_function_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationTimingFunctionCount;
        self.gecko.mAnimationTimingFunctionCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mTimingFunction.mTiming = others.mTimingFunction.mTiming;
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_timing_function(&mut self, other: &Self) {
        self.copy_animation_timing_function_from(other)
    }

    pub fn animation_timing_function_at(&self, index: usize)
        -> longhands::animation_timing_function::computed_value::SingleComputedValue {
        self.gecko.mAnimations[index].mTimingFunction.mTiming
    }


    pub fn set_animation_timeline<I>(&mut self, v: I)
    where
        I: IntoIterator<Item = longhands::animation_timeline::computed_value::single_value::T>,
        I::IntoIter: ExactSizeIterator
    {
        let v = v.into_iter();
        debug_assert_ne!(v.len(), 0);
        let input_len = v.len();
        self.gecko.mAnimations.ensure_len(input_len);

        self.gecko.mAnimationTimelineCount = input_len as u32;
        for (gecko, servo) in self.gecko.mAnimations.iter_mut().take(input_len as usize).zip(v) {
            gecko.mTimeline = servo;
        }
    }
    pub fn animation_timeline_at(&self, index: usize) -> values::specified::box_::AnimationTimeline {
        self.gecko.mAnimations[index].mTimeline.clone()
    }
    
    
    #[allow(non_snake_case)]
    pub fn animation_timeline_count(&self) -> usize {
        self.gecko.mAnimationTimelineCount as usize
    }


    
    
    #[allow(non_snake_case)]
    pub fn copy_animation_timeline_from(&mut self, other: &Self) {
        self.gecko.mAnimations.ensure_len(other.gecko.mAnimations.len());

        let count = other.gecko.mAnimationTimelineCount;
        self.gecko.mAnimationTimelineCount = count;

        let iter = self.gecko.mAnimations.iter_mut().take(count as usize).zip(
            other.gecko.mAnimations.iter()
        );

        for (ours, others) in iter {
            ours.mTimeline = others.mTimeline.clone();
        }
    }

    #[allow(non_snake_case)]
    pub fn reset_animation_timeline(&mut self, other: &Self) {
        self.copy_animation_timeline_from(other)
    }





    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set_ime_mode(&mut self, v: longhands::ime_mode::computed_value::T) {
        use crate::properties::longhands::ime_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleImeMode::Auto ,
                Keyword::Normal =>
                    structs::StyleImeMode::Normal ,
                Keyword::Active =>
                    structs::StyleImeMode::Active ,
                Keyword::Disabled =>
                    structs::StyleImeMode::Disabled ,
                Keyword::Inactive =>
                    structs::StyleImeMode::Inactive ,
        };
        self.gecko.mIMEMode = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_ime_mode_from(&mut self, other: &Self) {
        self.gecko.mIMEMode = other.gecko.mIMEMode.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_ime_mode(&mut self, other: &Self) {
        self.copy_ime_mode_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_ime_mode(&self) -> longhands::ime_mode::computed_value::T {
        use crate::properties::longhands::ime_mode::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mIMEMode {
            structs::StyleImeMode::Auto => Keyword::Auto,
            structs::StyleImeMode::Normal => Keyword::Normal,
            structs::StyleImeMode::Active => Keyword::Active,
            structs::StyleImeMode::Disabled => Keyword::Disabled,
            structs::StyleImeMode::Inactive => Keyword::Inactive,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_scrollbar_width(&mut self, v: longhands::scrollbar_width::computed_value::T) {
        use crate::properties::longhands::scrollbar_width::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Auto =>
                    structs::StyleScrollbarWidth::Auto ,
                Keyword::Thin =>
                    structs::StyleScrollbarWidth::Thin ,
                Keyword::None =>
                    structs::StyleScrollbarWidth::None ,
        };
        self.gecko.mScrollbarWidth = result;
    }


    #[allow(non_snake_case)]
    pub fn copy_scrollbar_width_from(&mut self, other: &Self) {
        self.gecko.mScrollbarWidth = other.gecko.mScrollbarWidth.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_scrollbar_width(&mut self, other: &Self) {
        self.copy_scrollbar_width_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_scrollbar_width(&self) -> longhands::scrollbar_width::computed_value::T {
        use crate::properties::longhands::scrollbar_width::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mScrollbarWidth {
            structs::StyleScrollbarWidth::Auto => Keyword::Auto,
            structs::StyleScrollbarWidth::Thin => Keyword::Thin,
            structs::StyleScrollbarWidth::None => Keyword::None,
        }
    }



    #[allow(non_snake_case)]
    pub fn set_user_select(&mut self, v: longhands::user_select::computed_value::T) {
        self.gecko.mUserSelect = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy_user_select_from(&mut self, other: &Self) {
        self.gecko.mUserSelect = other.gecko.mUserSelect.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset_user_select(&mut self, other: &Self) {
        self.copy_user_select_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone_user_select(&self) -> longhands::user_select::computed_value::T {
        From::from(self.gecko.mUserSelect.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_dragging(&mut self, v: longhands::_moz_window_dragging::computed_value::T) {
        use crate::properties::longhands::_moz_window_dragging::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Default =>
                    structs::StyleWindowDragging::Default ,
                Keyword::Drag =>
                    structs::StyleWindowDragging::Drag ,
                Keyword::NoDrag =>
                    structs::StyleWindowDragging::NoDrag ,
        };
        self.gecko.mWindowDragging = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_dragging_from(&mut self, other: &Self) {
        self.gecko.mWindowDragging = other.gecko.mWindowDragging.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_dragging(&mut self, other: &Self) {
        self.copy__moz_window_dragging_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_dragging(&self) -> longhands::_moz_window_dragging::computed_value::T {
        use crate::properties::longhands::_moz_window_dragging::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mWindowDragging {
            structs::StyleWindowDragging::Default => Keyword::Default,
            structs::StyleWindowDragging::Drag => Keyword::Drag,
            structs::StyleWindowDragging::NoDrag => Keyword::NoDrag,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_shadow(&mut self, v: longhands::_moz_window_shadow::computed_value::T) {
        use crate::properties::longhands::_moz_window_shadow::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Default =>
                    structs::StyleWindowShadow::Default ,
                Keyword::None =>
                    structs::StyleWindowShadow::None ,
        };
        self.gecko.mWindowShadow = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_shadow_from(&mut self, other: &Self) {
        self.gecko.mWindowShadow = other.gecko.mWindowShadow.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_shadow(&mut self, other: &Self) {
        self.copy__moz_window_shadow_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_shadow(&self) -> longhands::_moz_window_shadow::computed_value::T {
        use crate::properties::longhands::_moz_window_shadow::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mWindowShadow {
            structs::StyleWindowShadow::Default => Keyword::Default,
            structs::StyleWindowShadow::None => Keyword::None,
            _ => panic!("Found unexpected value in style struct for _moz_window_shadow property"),
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_opacity(&mut self, v: longhands::_moz_window_opacity::computed_value::T) {
        self.gecko.mWindowOpacity = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_opacity_from(&mut self, other: &Self) {
        self.gecko.mWindowOpacity = other.gecko.mWindowOpacity.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_opacity(&mut self, other: &Self) {
        self.copy__moz_window_opacity_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_opacity(&self) -> longhands::_moz_window_opacity::computed_value::T {
        From::from(self.gecko.mWindowOpacity.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_transform(&mut self, v: longhands::_moz_window_transform::computed_value::T) {
        self.gecko.mMozWindowTransform = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_transform_from(&mut self, other: &Self) {
        self.gecko.mMozWindowTransform = other.gecko.mMozWindowTransform.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_transform(&mut self, other: &Self) {
        self.copy__moz_window_transform_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_transform(&self) -> longhands::_moz_window_transform::computed_value::T {
        From::from(self.gecko.mMozWindowTransform.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_window_transform_origin(&mut self, v: longhands::_moz_window_transform_origin::computed_value::T) {
        self.gecko.mWindowTransformOrigin = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_window_transform_origin_from(&mut self, other: &Self) {
        self.gecko.mWindowTransformOrigin = other.gecko.mWindowTransformOrigin.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_window_transform_origin(&mut self, other: &Self) {
        self.copy__moz_window_transform_origin_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_window_transform_origin(&self) -> longhands::_moz_window_transform_origin::computed_value::T {
        From::from(self.gecko.mWindowTransformOrigin.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_force_broken_image_icon(&mut self, v: longhands::_moz_force_broken_image_icon::computed_value::T) {
        self.gecko.mMozForceBrokenImageIcon = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_force_broken_image_icon_from(&mut self, other: &Self) {
        self.gecko.mMozForceBrokenImageIcon = other.gecko.mMozForceBrokenImageIcon.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_force_broken_image_icon(&mut self, other: &Self) {
        self.copy__moz_force_broken_image_icon_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_force_broken_image_icon(&self) -> longhands::_moz_force_broken_image_icon::computed_value::T {
        From::from(self.gecko.mMozForceBrokenImageIcon.clone())
    }


}




impl GeckoXUL {
    /*
     * Manually-Implemented Methods.
     */
    


    /*
     * Auto-Generated Methods.
     */
    

    #[allow(non_snake_case)]
    pub fn set__moz_box_align(&mut self, v: longhands::_moz_box_align::computed_value::T) {
        use crate::properties::longhands::_moz_box_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Stretch =>
                    structs::StyleBoxAlign::Stretch ,
                Keyword::Start =>
                    structs::StyleBoxAlign::Start ,
                Keyword::Center =>
                    structs::StyleBoxAlign::Center ,
                Keyword::Baseline =>
                    structs::StyleBoxAlign::Baseline ,
                Keyword::End =>
                    structs::StyleBoxAlign::End ,
        };
        self.gecko.mBoxAlign = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_align_from(&mut self, other: &Self) {
        self.gecko.mBoxAlign = other.gecko.mBoxAlign.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_align(&mut self, other: &Self) {
        self.copy__moz_box_align_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_align(&self) -> longhands::_moz_box_align::computed_value::T {
        use crate::properties::longhands::_moz_box_align::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxAlign {
            structs::StyleBoxAlign::Stretch => Keyword::Stretch,
            structs::StyleBoxAlign::Start => Keyword::Start,
            structs::StyleBoxAlign::Center => Keyword::Center,
            structs::StyleBoxAlign::Baseline => Keyword::Baseline,
            structs::StyleBoxAlign::End => Keyword::End,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_direction(&mut self, v: longhands::_moz_box_direction::computed_value::T) {
        use crate::properties::longhands::_moz_box_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Normal =>
                    structs::StyleBoxDirection::Normal ,
                Keyword::Reverse =>
                    structs::StyleBoxDirection::Reverse ,
        };
        self.gecko.mBoxDirection = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_direction_from(&mut self, other: &Self) {
        self.gecko.mBoxDirection = other.gecko.mBoxDirection.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_direction(&mut self, other: &Self) {
        self.copy__moz_box_direction_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_direction(&self) -> longhands::_moz_box_direction::computed_value::T {
        use crate::properties::longhands::_moz_box_direction::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxDirection {
            structs::StyleBoxDirection::Normal => Keyword::Normal,
            structs::StyleBoxDirection::Reverse => Keyword::Reverse,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_flex(&mut self, v: longhands::_moz_box_flex::computed_value::T) {
        self.gecko.mBoxFlex = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_flex_from(&mut self, other: &Self) {
        self.gecko.mBoxFlex = other.gecko.mBoxFlex.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_flex(&mut self, other: &Self) {
        self.copy__moz_box_flex_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_flex(&self) -> longhands::_moz_box_flex::computed_value::T {
        From::from(self.gecko.mBoxFlex.clone())
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_orient(&mut self, v: longhands::_moz_box_orient::computed_value::T) {
        use crate::properties::longhands::_moz_box_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Horizontal =>
                    structs::StyleBoxOrient::Horizontal ,
                Keyword::Vertical =>
                    structs::StyleBoxOrient::Vertical ,
        };
        self.gecko.mBoxOrient = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_orient_from(&mut self, other: &Self) {
        self.gecko.mBoxOrient = other.gecko.mBoxOrient.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_orient(&mut self, other: &Self) {
        self.copy__moz_box_orient_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_orient(&self) -> longhands::_moz_box_orient::computed_value::T {
        use crate::properties::longhands::_moz_box_orient::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxOrient {
            structs::StyleBoxOrient::Horizontal => Keyword::Horizontal,
            structs::StyleBoxOrient::Vertical => Keyword::Vertical,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_pack(&mut self, v: longhands::_moz_box_pack::computed_value::T) {
        use crate::properties::longhands::_moz_box_pack::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts
        let result = match v {
                Keyword::Start =>
                    structs::StyleBoxPack::Start ,
                Keyword::Center =>
                    structs::StyleBoxPack::Center ,
                Keyword::End =>
                    structs::StyleBoxPack::End ,
                Keyword::Justify =>
                    structs::StyleBoxPack::Justify ,
        };
        self.gecko.mBoxPack = result;
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_pack_from(&mut self, other: &Self) {
        self.gecko.mBoxPack = other.gecko.mBoxPack.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_pack(&mut self, other: &Self) {
        self.copy__moz_box_pack_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_pack(&self) -> longhands::_moz_box_pack::computed_value::T {
        use crate::properties::longhands::_moz_box_pack::computed_value::T as Keyword;
        // FIXME(bholley): Align binary representations and ditch |match| for cast + static_asserts

        // Some constant macros in the gecko are defined as negative integer(e.g. font-stretch).
        // And they are convert to signed integer in Rust bindings. We need to cast then
        // as signed type when we have both signed/unsigned integer in order to use them
        // as match's arms.
        // Also, to use same implementation here we use casted constant if we have only singed values.
        match self.gecko.mBoxPack {
            structs::StyleBoxPack::Start => Keyword::Start,
            structs::StyleBoxPack::Center => Keyword::Center,
            structs::StyleBoxPack::End => Keyword::End,
            structs::StyleBoxPack::Justify => Keyword::Justify,
        }
    }



    #[allow(non_snake_case)]
    pub fn set__moz_box_ordinal_group(&mut self, v: longhands::_moz_box_ordinal_group::computed_value::T) {
        self.gecko.mBoxOrdinal = From::from(v);
    }


    #[allow(non_snake_case)]
    pub fn copy__moz_box_ordinal_group_from(&mut self, other: &Self) {
        self.gecko.mBoxOrdinal = other.gecko.mBoxOrdinal.clone();
    }

    #[allow(non_snake_case)]
    pub fn reset__moz_box_ordinal_group(&mut self, other: &Self) {
        self.copy__moz_box_ordinal_group_from(other)
    }


    #[allow(non_snake_case)]
    pub fn clone__moz_box_ordinal_group(&self) -> longhands::_moz_box_ordinal_group::computed_value::T {
        From::from(self.gecko.mBoxOrdinal.clone())
    }


}



pub use crate::gecko_bindings::structs::mozilla::GeckoBackground as GeckoBackground;
impl GeckoBackground {
    pub fn gecko(&self) -> &nsStyleBackground {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleBackground {
        &mut self.gecko
    }
}


impl GeckoBackground {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleBackground(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoBackground {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleBackground(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoBackground {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleBackground(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoBorder as GeckoBorder;
impl GeckoBorder {
    pub fn gecko(&self) -> &nsStyleBorder {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleBorder {
        &mut self.gecko
    }
}


impl GeckoBorder {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleBorder(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoBorder {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleBorder(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoBorder {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleBorder(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoDisplay as GeckoBox;
impl GeckoBox {
    pub fn gecko(&self) -> &nsStyleDisplay {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleDisplay {
        &mut self.gecko
    }
}


impl GeckoBox {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleDisplay(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoBox {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleDisplay(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoBox {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleDisplay(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoColumn as GeckoColumn;
impl GeckoColumn {
    pub fn gecko(&self) -> &nsStyleColumn {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleColumn {
        &mut self.gecko
    }
}


impl GeckoColumn {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleColumn(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoColumn {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleColumn(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoColumn {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleColumn(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoContent as GeckoCounters;
impl GeckoCounters {
    pub fn gecko(&self) -> &nsStyleContent {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleContent {
        &mut self.gecko
    }
}


impl GeckoCounters {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleContent(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoCounters {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleContent(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoCounters {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleContent(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoEffects as GeckoEffects;
impl GeckoEffects {
    pub fn gecko(&self) -> &nsStyleEffects {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleEffects {
        &mut self.gecko
    }
}


impl GeckoEffects {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleEffects(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoEffects {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleEffects(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoEffects {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleEffects(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoFont as GeckoFont;
impl GeckoFont {
    pub fn gecko(&self) -> &nsStyleFont {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleFont {
        &mut self.gecko
    }
}


impl GeckoFont {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleFont(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoFont {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleFont(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoFont {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleFont(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoVisibility as GeckoInheritedBox;
impl GeckoInheritedBox {
    pub fn gecko(&self) -> &nsStyleVisibility {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleVisibility {
        &mut self.gecko
    }
}


impl GeckoInheritedBox {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleVisibility(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoInheritedBox {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleVisibility(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoInheritedBox {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleVisibility(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoSVG as GeckoInheritedSVG;
impl GeckoInheritedSVG {
    pub fn gecko(&self) -> &nsStyleSVG {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleSVG {
        &mut self.gecko
    }
}


impl GeckoInheritedSVG {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleSVG(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoInheritedSVG {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleSVG(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoInheritedSVG {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleSVG(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoTableBorder as GeckoInheritedTable;
impl GeckoInheritedTable {
    pub fn gecko(&self) -> &nsStyleTableBorder {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleTableBorder {
        &mut self.gecko
    }
}


impl GeckoInheritedTable {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleTableBorder(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoInheritedTable {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleTableBorder(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoInheritedTable {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleTableBorder(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoText as GeckoInheritedText;
impl GeckoInheritedText {
    pub fn gecko(&self) -> &nsStyleText {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleText {
        &mut self.gecko
    }
}


impl GeckoInheritedText {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleText(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoInheritedText {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleText(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoInheritedText {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleText(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoUI as GeckoInheritedUI;
impl GeckoInheritedUI {
    pub fn gecko(&self) -> &nsStyleUI {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleUI {
        &mut self.gecko
    }
}


impl GeckoInheritedUI {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleUI(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoInheritedUI {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleUI(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoInheritedUI {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleUI(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoList as GeckoList;
impl GeckoList {
    pub fn gecko(&self) -> &nsStyleList {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleList {
        &mut self.gecko
    }
}


impl GeckoList {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleList(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoList {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleList(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoList {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleList(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoMargin as GeckoMargin;
impl GeckoMargin {
    pub fn gecko(&self) -> &nsStyleMargin {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleMargin {
        &mut self.gecko
    }
}


impl GeckoMargin {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleMargin(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoMargin {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleMargin(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoMargin {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleMargin(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoOutline as GeckoOutline;
impl GeckoOutline {
    pub fn gecko(&self) -> &nsStyleOutline {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleOutline {
        &mut self.gecko
    }
}


impl GeckoOutline {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleOutline(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoOutline {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleOutline(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoOutline {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleOutline(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoPage as GeckoPage;
impl GeckoPage {
    pub fn gecko(&self) -> &nsStylePage {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStylePage {
        &mut self.gecko
    }
}


impl GeckoPage {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStylePage(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoPage {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStylePage(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoPage {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStylePage(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoPadding as GeckoPadding;
impl GeckoPadding {
    pub fn gecko(&self) -> &nsStylePadding {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStylePadding {
        &mut self.gecko
    }
}


impl GeckoPadding {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStylePadding(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoPadding {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStylePadding(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoPadding {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStylePadding(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoPosition as GeckoPosition;
impl GeckoPosition {
    pub fn gecko(&self) -> &nsStylePosition {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStylePosition {
        &mut self.gecko
    }
}


impl GeckoPosition {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStylePosition(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoPosition {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStylePosition(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoPosition {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStylePosition(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoSVGReset as GeckoSVG;
impl GeckoSVG {
    pub fn gecko(&self) -> &nsStyleSVGReset {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleSVGReset {
        &mut self.gecko
    }
}


impl GeckoSVG {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleSVGReset(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoSVG {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleSVGReset(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoSVG {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleSVGReset(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoTable as GeckoTable;
impl GeckoTable {
    pub fn gecko(&self) -> &nsStyleTable {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleTable {
        &mut self.gecko
    }
}


impl GeckoTable {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleTable(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoTable {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleTable(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoTable {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleTable(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoTextReset as GeckoText;
impl GeckoText {
    pub fn gecko(&self) -> &nsStyleTextReset {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleTextReset {
        &mut self.gecko
    }
}


impl GeckoText {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleTextReset(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoText {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleTextReset(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoText {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleTextReset(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoUIReset as GeckoUI;
impl GeckoUI {
    pub fn gecko(&self) -> &nsStyleUIReset {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleUIReset {
        &mut self.gecko
    }
}


impl GeckoUI {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleUIReset(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoUI {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleUIReset(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoUI {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleUIReset(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



pub use crate::gecko_bindings::structs::mozilla::GeckoXUL as GeckoXUL;
impl GeckoXUL {
    pub fn gecko(&self) -> &nsStyleXUL {
        &self.gecko
    }
    pub fn gecko_mut(&mut self) -> &mut nsStyleXUL {
        &mut self.gecko
    }
}


impl GeckoXUL {
    #[allow(dead_code, unused_variables)]
    pub fn default(document: &structs::Document) -> Arc<Self> {
        unsafe {
            let mut result = UniqueArc::<Self>::new_uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_Construct_Default_nsStyleXUL(
                result.as_mut_ptr() as *mut _,
                document,
            );
            UniqueArc::assume_init(result).shareable()
        }
    }
}
impl Drop for GeckoXUL {
    fn drop(&mut self) {
        unsafe {
            Gecko_Destroy_nsStyleXUL(&mut *self.gecko);
        }
    }
}
impl Clone for GeckoXUL {
    fn clone(&self) -> Self {
        unsafe {
            let mut result = MaybeUninit::<Self>::uninit();
            // FIXME(bug 1595895): Zero the memory to keep valgrind happy, but
            // these looks like Valgrind false-positives at a quick glance.
            ptr::write_bytes::<Self>(result.as_mut_ptr(), 0, 1);
            Gecko_CopyConstruct_nsStyleXUL(result.as_mut_ptr() as *mut _, &*self.gecko);
            result.assume_init()
        }
    }
}



/// Assert that the initial values set in Gecko style struct constructors
/// match the values returned by `get_initial_value()` for each longhand.
#[cfg(feature = "gecko")]
#[inline]
pub fn assert_initial_values_match(data: &PerDocumentStyleData) {
    if cfg!(debug_assertions) {
        let data = data.borrow();
        let cv = data.stylist.device().default_computed_values();
        
        assert_eq!(
            cv.clone_align_content(),
            longhands::align_content::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(align_content),
                " must match longhands::",
                stringify!(align_content),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_align_items(),
            longhands::align_items::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(align_items),
                " must match longhands::",
                stringify!(align_items),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_align_self(),
            longhands::align_self::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(align_self),
                " must match longhands::",
                stringify!(align_self),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_aspect_ratio(),
            longhands::aspect_ratio::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(aspect_ratio),
                " must match longhands::",
                stringify!(aspect_ratio),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_backface_visibility(),
            longhands::backface_visibility::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(backface_visibility),
                " must match longhands::",
                stringify!(backface_visibility),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_collapse(),
            longhands::border_collapse::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_collapse),
                " must match longhands::",
                stringify!(border_collapse),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_image_repeat(),
            longhands::border_image_repeat::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_image_repeat),
                " must match longhands::",
                stringify!(border_image_repeat),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_box_decoration_break(),
            longhands::box_decoration_break::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(box_decoration_break),
                " must match longhands::",
                stringify!(box_decoration_break),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_box_sizing(),
            longhands::box_sizing::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(box_sizing),
                " must match longhands::",
                stringify!(box_sizing),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_break_inside(),
            longhands::break_inside::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(break_inside),
                " must match longhands::",
                stringify!(break_inside),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_caption_side(),
            longhands::caption_side::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(caption_side),
                " must match longhands::",
                stringify!(caption_side),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_clear(),
            longhands::clear::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(clear),
                " must match longhands::",
                stringify!(clear),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_color_interpolation(),
            longhands::color_interpolation::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(color_interpolation),
                " must match longhands::",
                stringify!(color_interpolation),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_color_interpolation_filters(),
            longhands::color_interpolation_filters::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(color_interpolation_filters),
                " must match longhands::",
                stringify!(color_interpolation_filters),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_count(),
            longhands::column_count::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_count),
                " must match longhands::",
                stringify!(column_count),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_fill(),
            longhands::column_fill::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_fill),
                " must match longhands::",
                stringify!(column_fill),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_span(),
            longhands::column_span::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_span),
                " must match longhands::",
                stringify!(column_span),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_contain(),
            longhands::contain::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(contain),
                " must match longhands::",
                stringify!(contain),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_container_type(),
            longhands::container_type::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(container_type),
                " must match longhands::",
                stringify!(container_type),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_content_visibility(),
            longhands::content_visibility::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(content_visibility),
                " must match longhands::",
                stringify!(content_visibility),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_direction(),
            longhands::direction::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(direction),
                " must match longhands::",
                stringify!(direction),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_display(),
            longhands::display::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(display),
                " must match longhands::",
                stringify!(display),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_dominant_baseline(),
            longhands::dominant_baseline::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(dominant_baseline),
                " must match longhands::",
                stringify!(dominant_baseline),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_empty_cells(),
            longhands::empty_cells::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(empty_cells),
                " must match longhands::",
                stringify!(empty_cells),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_flex_direction(),
            longhands::flex_direction::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(flex_direction),
                " must match longhands::",
                stringify!(flex_direction),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_flex_wrap(),
            longhands::flex_wrap::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(flex_wrap),
                " must match longhands::",
                stringify!(flex_wrap),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_float(),
            longhands::float::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(float),
                " must match longhands::",
                stringify!(float),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_kerning(),
            longhands::font_kerning::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_kerning),
                " must match longhands::",
                stringify!(font_kerning),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_optical_sizing(),
            longhands::font_optical_sizing::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_optical_sizing),
                " must match longhands::",
                stringify!(font_optical_sizing),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_size_adjust(),
            longhands::font_size_adjust::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_size_adjust),
                " must match longhands::",
                stringify!(font_size_adjust),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_stretch(),
            longhands::font_stretch::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_stretch),
                " must match longhands::",
                stringify!(font_stretch),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_style(),
            longhands::font_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_style),
                " must match longhands::",
                stringify!(font_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_synthesis(),
            longhands::font_synthesis::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_synthesis),
                " must match longhands::",
                stringify!(font_synthesis),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variant_caps(),
            longhands::font_variant_caps::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variant_caps),
                " must match longhands::",
                stringify!(font_variant_caps),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variant_east_asian(),
            longhands::font_variant_east_asian::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variant_east_asian),
                " must match longhands::",
                stringify!(font_variant_east_asian),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variant_ligatures(),
            longhands::font_variant_ligatures::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variant_ligatures),
                " must match longhands::",
                stringify!(font_variant_ligatures),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variant_numeric(),
            longhands::font_variant_numeric::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variant_numeric),
                " must match longhands::",
                stringify!(font_variant_numeric),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variant_position(),
            longhands::font_variant_position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variant_position),
                " must match longhands::",
                stringify!(font_variant_position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_weight(),
            longhands::font_weight::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_weight),
                " must match longhands::",
                stringify!(font_weight),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_auto_flow(),
            longhands::grid_auto_flow::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_auto_flow),
                " must match longhands::",
                stringify!(grid_auto_flow),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_hyphens(),
            longhands::hyphens::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(hyphens),
                " must match longhands::",
                stringify!(hyphens),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_image_orientation(),
            longhands::image_orientation::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(image_orientation),
                " must match longhands::",
                stringify!(image_orientation),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_image_rendering(),
            longhands::image_rendering::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(image_rendering),
                " must match longhands::",
                stringify!(image_rendering),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_ime_mode(),
            longhands::ime_mode::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(ime_mode),
                " must match longhands::",
                stringify!(ime_mode),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_initial_letter(),
            longhands::initial_letter::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(initial_letter),
                " must match longhands::",
                stringify!(initial_letter),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_isolation(),
            longhands::isolation::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(isolation),
                " must match longhands::",
                stringify!(isolation),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_justify_content(),
            longhands::justify_content::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(justify_content),
                " must match longhands::",
                stringify!(justify_content),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_justify_items(),
            longhands::justify_items::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(justify_items),
                " must match longhands::",
                stringify!(justify_items),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_justify_self(),
            longhands::justify_self::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(justify_self),
                " must match longhands::",
                stringify!(justify_self),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_line_break(),
            longhands::line_break::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(line_break),
                " must match longhands::",
                stringify!(line_break),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_list_style_position(),
            longhands::list_style_position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(list_style_position),
                " must match longhands::",
                stringify!(list_style_position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_type(),
            longhands::mask_type::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_type),
                " must match longhands::",
                stringify!(mask_type),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_masonry_auto_flow(),
            longhands::masonry_auto_flow::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(masonry_auto_flow),
                " must match longhands::",
                stringify!(masonry_auto_flow),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_math_depth(),
            longhands::math_depth::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(math_depth),
                " must match longhands::",
                stringify!(math_depth),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_math_style(),
            longhands::math_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(math_style),
                " must match longhands::",
                stringify!(math_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mix_blend_mode(),
            longhands::mix_blend_mode::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mix_blend_mode),
                " must match longhands::",
                stringify!(mix_blend_mode),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_box_align(),
            longhands::_moz_box_align::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_box_align),
                " must match longhands::",
                stringify!(_moz_box_align),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_box_direction(),
            longhands::_moz_box_direction::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_box_direction),
                " must match longhands::",
                stringify!(_moz_box_direction),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_box_orient(),
            longhands::_moz_box_orient::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_box_orient),
                " must match longhands::",
                stringify!(_moz_box_orient),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_box_pack(),
            longhands::_moz_box_pack::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_box_pack),
                " must match longhands::",
                stringify!(_moz_box_pack),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_control_character_visibility(),
            longhands::_moz_control_character_visibility::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_control_character_visibility),
                " must match longhands::",
                stringify!(_moz_control_character_visibility),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_float_edge(),
            longhands::_moz_float_edge::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_float_edge),
                " must match longhands::",
                stringify!(_moz_float_edge),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_force_broken_image_icon(),
            longhands::_moz_force_broken_image_icon::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_force_broken_image_icon),
                " must match longhands::",
                stringify!(_moz_force_broken_image_icon),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_inert(),
            longhands::_moz_inert::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_inert),
                " must match longhands::",
                stringify!(_moz_inert),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_min_font_size_ratio(),
            longhands::_moz_min_font_size_ratio::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_min_font_size_ratio),
                " must match longhands::",
                stringify!(_moz_min_font_size_ratio),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_orient(),
            longhands::_moz_orient::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_orient),
                " must match longhands::",
                stringify!(_moz_orient),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_osx_font_smoothing(),
            longhands::_moz_osx_font_smoothing::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_osx_font_smoothing),
                " must match longhands::",
                stringify!(_moz_osx_font_smoothing),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_text_size_adjust(),
            longhands::_moz_text_size_adjust::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_text_size_adjust),
                " must match longhands::",
                stringify!(_moz_text_size_adjust),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_top_layer(),
            longhands::_moz_top_layer::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_top_layer),
                " must match longhands::",
                stringify!(_moz_top_layer),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_user_focus(),
            longhands::_moz_user_focus::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_user_focus),
                " must match longhands::",
                stringify!(_moz_user_focus),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_user_input(),
            longhands::_moz_user_input::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_user_input),
                " must match longhands::",
                stringify!(_moz_user_input),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_user_modify(),
            longhands::_moz_user_modify::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_user_modify),
                " must match longhands::",
                stringify!(_moz_user_modify),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_window_dragging(),
            longhands::_moz_window_dragging::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_window_dragging),
                " must match longhands::",
                stringify!(_moz_window_dragging),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_window_shadow(),
            longhands::_moz_window_shadow::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_window_shadow),
                " must match longhands::",
                stringify!(_moz_window_shadow),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_object_fit(),
            longhands::object_fit::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(object_fit),
                " must match longhands::",
                stringify!(object_fit),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_offset_rotate(),
            longhands::offset_rotate::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(offset_rotate),
                " must match longhands::",
                stringify!(offset_rotate),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_outline_style(),
            longhands::outline_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(outline_style),
                " must match longhands::",
                stringify!(outline_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overflow_anchor(),
            longhands::overflow_anchor::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overflow_anchor),
                " must match longhands::",
                stringify!(overflow_anchor),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overflow_wrap(),
            longhands::overflow_wrap::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overflow_wrap),
                " must match longhands::",
                stringify!(overflow_wrap),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_paint_order(),
            longhands::paint_order::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(paint_order),
                " must match longhands::",
                stringify!(paint_order),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_pointer_events(),
            longhands::pointer_events::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(pointer_events),
                " must match longhands::",
                stringify!(pointer_events),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_position(),
            longhands::position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(position),
                " must match longhands::",
                stringify!(position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_print_color_adjust(),
            longhands::print_color_adjust::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(print_color_adjust),
                " must match longhands::",
                stringify!(print_color_adjust),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_resize(),
            longhands::resize::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(resize),
                " must match longhands::",
                stringify!(resize),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_ruby_align(),
            longhands::ruby_align::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(ruby_align),
                " must match longhands::",
                stringify!(ruby_align),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_ruby_position(),
            longhands::ruby_position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(ruby_position),
                " must match longhands::",
                stringify!(ruby_position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_behavior(),
            longhands::scroll_behavior::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_behavior),
                " must match longhands::",
                stringify!(scroll_behavior),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_snap_align(),
            longhands::scroll_snap_align::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_snap_align),
                " must match longhands::",
                stringify!(scroll_snap_align),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_snap_type(),
            longhands::scroll_snap_type::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_snap_type),
                " must match longhands::",
                stringify!(scroll_snap_type),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scrollbar_gutter(),
            longhands::scrollbar_gutter::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scrollbar_gutter),
                " must match longhands::",
                stringify!(scrollbar_gutter),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scrollbar_width(),
            longhands::scrollbar_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scrollbar_width),
                " must match longhands::",
                stringify!(scrollbar_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_shape_rendering(),
            longhands::shape_rendering::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(shape_rendering),
                " must match longhands::",
                stringify!(shape_rendering),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke_linecap(),
            longhands::stroke_linecap::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke_linecap),
                " must match longhands::",
                stringify!(stroke_linecap),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke_linejoin(),
            longhands::stroke_linejoin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke_linejoin),
                " must match longhands::",
                stringify!(stroke_linejoin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_table_layout(),
            longhands::table_layout::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(table_layout),
                " must match longhands::",
                stringify!(table_layout),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_align(),
            longhands::text_align::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_align),
                " must match longhands::",
                stringify!(text_align),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_align_last(),
            longhands::text_align_last::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_align_last),
                " must match longhands::",
                stringify!(text_align_last),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_anchor(),
            longhands::text_anchor::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_anchor),
                " must match longhands::",
                stringify!(text_anchor),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_combine_upright(),
            longhands::text_combine_upright::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_combine_upright),
                " must match longhands::",
                stringify!(text_combine_upright),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_decoration_line(),
            longhands::text_decoration_line::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_decoration_line),
                " must match longhands::",
                stringify!(text_decoration_line),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_decoration_skip_ink(),
            longhands::text_decoration_skip_ink::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_decoration_skip_ink),
                " must match longhands::",
                stringify!(text_decoration_skip_ink),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_decoration_style(),
            longhands::text_decoration_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_decoration_style),
                " must match longhands::",
                stringify!(text_decoration_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_emphasis_position(),
            longhands::text_emphasis_position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_emphasis_position),
                " must match longhands::",
                stringify!(text_emphasis_position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_justify(),
            longhands::text_justify::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_justify),
                " must match longhands::",
                stringify!(text_justify),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_orientation(),
            longhands::text_orientation::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_orientation),
                " must match longhands::",
                stringify!(text_orientation),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_rendering(),
            longhands::text_rendering::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_rendering),
                " must match longhands::",
                stringify!(text_rendering),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_transform(),
            longhands::text_transform::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_transform),
                " must match longhands::",
                stringify!(text_transform),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_underline_position(),
            longhands::text_underline_position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_underline_position),
                " must match longhands::",
                stringify!(text_underline_position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_touch_action(),
            longhands::touch_action::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(touch_action),
                " must match longhands::",
                stringify!(touch_action),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transform_box(),
            longhands::transform_box::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transform_box),
                " must match longhands::",
                stringify!(transform_box),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transform_style(),
            longhands::transform_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transform_style),
                " must match longhands::",
                stringify!(transform_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_unicode_bidi(),
            longhands::unicode_bidi::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(unicode_bidi),
                " must match longhands::",
                stringify!(unicode_bidi),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_user_select(),
            longhands::user_select::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(user_select),
                " must match longhands::",
                stringify!(user_select),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_vector_effect(),
            longhands::vector_effect::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(vector_effect),
                " must match longhands::",
                stringify!(vector_effect),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_visibility(),
            longhands::visibility::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(visibility),
                " must match longhands::",
                stringify!(visibility),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__webkit_line_clamp(),
            longhands::_webkit_line_clamp::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_webkit_line_clamp),
                " must match longhands::",
                stringify!(_webkit_line_clamp),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_white_space(),
            longhands::white_space::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(white_space),
                " must match longhands::",
                stringify!(white_space),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_word_break(),
            longhands::word_break::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(word_break),
                " must match longhands::",
                stringify!(word_break),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_writing_mode(),
            longhands::writing_mode::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(writing_mode),
                " must match longhands::",
                stringify!(writing_mode),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_z_index(),
            longhands::z_index::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(z_index),
                " must match longhands::",
                stringify!(z_index),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_appearance(),
            longhands::appearance::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(appearance),
                " must match longhands::",
                stringify!(appearance),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_default_appearance(),
            longhands::_moz_default_appearance::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_default_appearance),
                " must match longhands::",
                stringify!(_moz_default_appearance),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_break_after(),
            longhands::break_after::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(break_after),
                " must match longhands::",
                stringify!(break_after),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_break_before(),
            longhands::break_before::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(break_before),
                " must match longhands::",
                stringify!(break_before),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_clip_rule(),
            longhands::clip_rule::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(clip_rule),
                " must match longhands::",
                stringify!(clip_rule),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_fill_rule(),
            longhands::fill_rule::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(fill_rule),
                " must match longhands::",
                stringify!(fill_rule),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overflow_clip_box_block(),
            longhands::overflow_clip_box_block::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overflow_clip_box_block),
                " must match longhands::",
                stringify!(overflow_clip_box_block),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overflow_clip_box_inline(),
            longhands::overflow_clip_box_inline::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overflow_clip_box_inline),
                " must match longhands::",
                stringify!(overflow_clip_box_inline),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_fill_opacity(),
            longhands::fill_opacity::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(fill_opacity),
                " must match longhands::",
                stringify!(fill_opacity),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke_opacity(),
            longhands::stroke_opacity::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke_opacity),
                " must match longhands::",
                stringify!(stroke_opacity),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_box_ordinal_group(),
            longhands::_moz_box_ordinal_group::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_box_ordinal_group),
                " must match longhands::",
                stringify!(_moz_box_ordinal_group),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_order(),
            longhands::order::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(order),
                " must match longhands::",
                stringify!(order),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_flex_grow(),
            longhands::flex_grow::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(flex_grow),
                " must match longhands::",
                stringify!(flex_grow),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_flex_shrink(),
            longhands::flex_shrink::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(flex_shrink),
                " must match longhands::",
                stringify!(flex_shrink),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_box_flex(),
            longhands::_moz_box_flex::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_box_flex),
                " must match longhands::",
                stringify!(_moz_box_flex),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke_miterlimit(),
            longhands::stroke_miterlimit::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke_miterlimit),
                " must match longhands::",
                stringify!(stroke_miterlimit),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overflow_x(),
            longhands::overflow_x::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overflow_x),
                " must match longhands::",
                stringify!(overflow_x),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overflow_y(),
            longhands::overflow_y::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overflow_y),
                " must match longhands::",
                stringify!(overflow_y),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overscroll_behavior_x(),
            longhands::overscroll_behavior_x::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overscroll_behavior_x),
                " must match longhands::",
                stringify!(overscroll_behavior_x),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overscroll_behavior_y(),
            longhands::overscroll_behavior_y::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overscroll_behavior_y),
                " must match longhands::",
                stringify!(overscroll_behavior_y),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_flood_opacity(),
            longhands::flood_opacity::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(flood_opacity),
                " must match longhands::",
                stringify!(flood_opacity),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_window_opacity(),
            longhands::_moz_window_opacity::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_window_opacity),
                " must match longhands::",
                stringify!(_moz_window_opacity),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_opacity(),
            longhands::opacity::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(opacity),
                " must match longhands::",
                stringify!(opacity),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_shape_image_threshold(),
            longhands::shape_image_threshold::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(shape_image_threshold),
                " must match longhands::",
                stringify!(shape_image_threshold),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stop_opacity(),
            longhands::stop_opacity::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stop_opacity),
                " must match longhands::",
                stringify!(stop_opacity),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_bottom_style(),
            longhands::border_bottom_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_bottom_style),
                " must match longhands::",
                stringify!(border_bottom_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_left_style(),
            longhands::border_left_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_left_style),
                " must match longhands::",
                stringify!(border_left_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_right_style(),
            longhands::border_right_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_right_style),
                " must match longhands::",
                stringify!(border_right_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_top_style(),
            longhands::border_top_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_top_style),
                " must match longhands::",
                stringify!(border_top_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_rule_style(),
            longhands::column_rule_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_rule_style),
                " must match longhands::",
                stringify!(column_rule_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_accent_color(),
            longhands::accent_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(accent_color),
                " must match longhands::",
                stringify!(accent_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_align_tracks(),
            longhands::align_tracks::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(align_tracks),
                " must match longhands::",
                stringify!(align_tracks),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_delay(),
            longhands::animation_delay::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_delay),
                " must match longhands::",
                stringify!(animation_delay),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_direction(),
            longhands::animation_direction::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_direction),
                " must match longhands::",
                stringify!(animation_direction),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_duration(),
            longhands::animation_duration::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_duration),
                " must match longhands::",
                stringify!(animation_duration),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_fill_mode(),
            longhands::animation_fill_mode::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_fill_mode),
                " must match longhands::",
                stringify!(animation_fill_mode),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_iteration_count(),
            longhands::animation_iteration_count::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_iteration_count),
                " must match longhands::",
                stringify!(animation_iteration_count),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_name(),
            longhands::animation_name::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_name),
                " must match longhands::",
                stringify!(animation_name),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_play_state(),
            longhands::animation_play_state::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_play_state),
                " must match longhands::",
                stringify!(animation_play_state),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_timeline(),
            longhands::animation_timeline::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_timeline),
                " must match longhands::",
                stringify!(animation_timeline),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_animation_timing_function(),
            longhands::animation_timing_function::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(animation_timing_function),
                " must match longhands::",
                stringify!(animation_timing_function),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_backdrop_filter(),
            longhands::backdrop_filter::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(backdrop_filter),
                " must match longhands::",
                stringify!(backdrop_filter),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_attachment(),
            longhands::background_attachment::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_attachment),
                " must match longhands::",
                stringify!(background_attachment),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_blend_mode(),
            longhands::background_blend_mode::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_blend_mode),
                " must match longhands::",
                stringify!(background_blend_mode),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_clip(),
            longhands::background_clip::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_clip),
                " must match longhands::",
                stringify!(background_clip),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_image(),
            longhands::background_image::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_image),
                " must match longhands::",
                stringify!(background_image),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_origin(),
            longhands::background_origin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_origin),
                " must match longhands::",
                stringify!(background_origin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_position_x(),
            longhands::background_position_x::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_position_x),
                " must match longhands::",
                stringify!(background_position_x),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_position_y(),
            longhands::background_position_y::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_position_y),
                " must match longhands::",
                stringify!(background_position_y),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_repeat(),
            longhands::background_repeat::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_repeat),
                " must match longhands::",
                stringify!(background_repeat),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_size(),
            longhands::background_size::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_size),
                " must match longhands::",
                stringify!(background_size),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_image_outset(),
            longhands::border_image_outset::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_image_outset),
                " must match longhands::",
                stringify!(border_image_outset),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_image_slice(),
            longhands::border_image_slice::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_image_slice),
                " must match longhands::",
                stringify!(border_image_slice),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_image_width(),
            longhands::border_image_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_image_width),
                " must match longhands::",
                stringify!(border_image_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_spacing(),
            longhands::border_spacing::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_spacing),
                " must match longhands::",
                stringify!(border_spacing),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_box_shadow(),
            longhands::box_shadow::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(box_shadow),
                " must match longhands::",
                stringify!(box_shadow),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_caret_color(),
            longhands::caret_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(caret_color),
                " must match longhands::",
                stringify!(caret_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_clip_path(),
            longhands::clip_path::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(clip_path),
                " must match longhands::",
                stringify!(clip_path),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_color_scheme(),
            longhands::color_scheme::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(color_scheme),
                " must match longhands::",
                stringify!(color_scheme),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_width(),
            longhands::column_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_width),
                " must match longhands::",
                stringify!(column_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_container_name(),
            longhands::container_name::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(container_name),
                " must match longhands::",
                stringify!(container_name),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_content(),
            longhands::content::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(content),
                " must match longhands::",
                stringify!(content),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_counter_increment(),
            longhands::counter_increment::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(counter_increment),
                " must match longhands::",
                stringify!(counter_increment),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_counter_reset(),
            longhands::counter_reset::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(counter_reset),
                " must match longhands::",
                stringify!(counter_reset),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_counter_set(),
            longhands::counter_set::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(counter_set),
                " must match longhands::",
                stringify!(counter_set),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_cursor(),
            longhands::cursor::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(cursor),
                " must match longhands::",
                stringify!(cursor),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_d(),
            longhands::d::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(d),
                " must match longhands::",
                stringify!(d),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_filter(),
            longhands::filter::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(filter),
                " must match longhands::",
                stringify!(filter),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_flex_basis(),
            longhands::flex_basis::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(flex_basis),
                " must match longhands::",
                stringify!(flex_basis),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_feature_settings(),
            longhands::font_feature_settings::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_feature_settings),
                " must match longhands::",
                stringify!(font_feature_settings),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_language_override(),
            longhands::font_language_override::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_language_override),
                " must match longhands::",
                stringify!(font_language_override),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variant_alternates(),
            longhands::font_variant_alternates::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variant_alternates),
                " must match longhands::",
                stringify!(font_variant_alternates),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_font_variation_settings(),
            longhands::font_variation_settings::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(font_variation_settings),
                " must match longhands::",
                stringify!(font_variation_settings),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_template_areas(),
            longhands::grid_template_areas::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_template_areas),
                " must match longhands::",
                stringify!(grid_template_areas),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_hyphenate_character(),
            longhands::hyphenate_character::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(hyphenate_character),
                " must match longhands::",
                stringify!(hyphenate_character),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_justify_tracks(),
            longhands::justify_tracks::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(justify_tracks),
                " must match longhands::",
                stringify!(justify_tracks),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_letter_spacing(),
            longhands::letter_spacing::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(letter_spacing),
                " must match longhands::",
                stringify!(letter_spacing),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_line_height(),
            longhands::line_height::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(line_height),
                " must match longhands::",
                stringify!(line_height),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_list_style_type(),
            longhands::list_style_type::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(list_style_type),
                " must match longhands::",
                stringify!(list_style_type),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_clip(),
            longhands::mask_clip::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_clip),
                " must match longhands::",
                stringify!(mask_clip),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_composite(),
            longhands::mask_composite::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_composite),
                " must match longhands::",
                stringify!(mask_composite),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_image(),
            longhands::mask_image::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_image),
                " must match longhands::",
                stringify!(mask_image),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_mode(),
            longhands::mask_mode::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_mode),
                " must match longhands::",
                stringify!(mask_mode),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_origin(),
            longhands::mask_origin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_origin),
                " must match longhands::",
                stringify!(mask_origin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_position_x(),
            longhands::mask_position_x::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_position_x),
                " must match longhands::",
                stringify!(mask_position_x),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_position_y(),
            longhands::mask_position_y::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_position_y),
                " must match longhands::",
                stringify!(mask_position_y),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_repeat(),
            longhands::mask_repeat::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_repeat),
                " must match longhands::",
                stringify!(mask_repeat),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_mask_size(),
            longhands::mask_size::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(mask_size),
                " must match longhands::",
                stringify!(mask_size),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_context_properties(),
            longhands::_moz_context_properties::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_context_properties),
                " must match longhands::",
                stringify!(_moz_context_properties),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_font_smoothing_background_color(),
            longhands::_moz_font_smoothing_background_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_font_smoothing_background_color),
                " must match longhands::",
                stringify!(_moz_font_smoothing_background_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_offset_anchor(),
            longhands::offset_anchor::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(offset_anchor),
                " must match longhands::",
                stringify!(offset_anchor),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_offset_path(),
            longhands::offset_path::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(offset_path),
                " must match longhands::",
                stringify!(offset_path),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_page(),
            longhands::page::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(page),
                " must match longhands::",
                stringify!(page),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_perspective(),
            longhands::perspective::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(perspective),
                " must match longhands::",
                stringify!(perspective),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_quotes(),
            longhands::quotes::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(quotes),
                " must match longhands::",
                stringify!(quotes),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_rotate(),
            longhands::rotate::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(rotate),
                " must match longhands::",
                stringify!(rotate),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scale(),
            longhands::scale::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scale),
                " must match longhands::",
                stringify!(scale),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scrollbar_color(),
            longhands::scrollbar_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scrollbar_color),
                " must match longhands::",
                stringify!(scrollbar_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_shape_outside(),
            longhands::shape_outside::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(shape_outside),
                " must match longhands::",
                stringify!(shape_outside),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_size(),
            longhands::size::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(size),
                " must match longhands::",
                stringify!(size),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke_dasharray(),
            longhands::stroke_dasharray::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke_dasharray),
                " must match longhands::",
                stringify!(stroke_dasharray),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke_dashoffset(),
            longhands::stroke_dashoffset::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke_dashoffset),
                " must match longhands::",
                stringify!(stroke_dashoffset),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke_width(),
            longhands::stroke_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke_width),
                " must match longhands::",
                stringify!(stroke_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_tab_size(),
            longhands::tab_size::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(tab_size),
                " must match longhands::",
                stringify!(tab_size),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_decoration_thickness(),
            longhands::text_decoration_thickness::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_decoration_thickness),
                " must match longhands::",
                stringify!(text_decoration_thickness),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_emphasis_style(),
            longhands::text_emphasis_style::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_emphasis_style),
                " must match longhands::",
                stringify!(text_emphasis_style),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_overflow(),
            longhands::text_overflow::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_overflow),
                " must match longhands::",
                stringify!(text_overflow),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_shadow(),
            longhands::text_shadow::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_shadow),
                " must match longhands::",
                stringify!(text_shadow),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transition_delay(),
            longhands::transition_delay::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transition_delay),
                " must match longhands::",
                stringify!(transition_delay),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transition_duration(),
            longhands::transition_duration::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transition_duration),
                " must match longhands::",
                stringify!(transition_duration),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transition_property(),
            longhands::transition_property::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transition_property),
                " must match longhands::",
                stringify!(transition_property),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transition_timing_function(),
            longhands::transition_timing_function::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transition_timing_function),
                " must match longhands::",
                stringify!(transition_timing_function),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_translate(),
            longhands::translate::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(translate),
                " must match longhands::",
                stringify!(translate),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_vertical_align(),
            longhands::vertical_align::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(vertical_align),
                " must match longhands::",
                stringify!(vertical_align),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_will_change(),
            longhands::will_change::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(will_change),
                " must match longhands::",
                stringify!(will_change),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_word_spacing(),
            longhands::word_spacing::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(word_spacing),
                " must match longhands::",
                stringify!(word_spacing),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_clip(),
            longhands::clip::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(clip),
                " must match longhands::",
                stringify!(clip),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_image_region(),
            longhands::_moz_image_region::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_image_region),
                " must match longhands::",
                stringify!(_moz_image_region),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_object_position(),
            longhands::object_position::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(object_position),
                " must match longhands::",
                stringify!(object_position),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_perspective_origin(),
            longhands::perspective_origin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(perspective_origin),
                " must match longhands::",
                stringify!(perspective_origin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_fill(),
            longhands::fill::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(fill),
                " must match longhands::",
                stringify!(fill),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stroke(),
            longhands::stroke::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stroke),
                " must match longhands::",
                stringify!(stroke),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_window_transform_origin(),
            longhands::_moz_window_transform_origin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_window_transform_origin),
                " must match longhands::",
                stringify!(_moz_window_transform_origin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transform_origin(),
            longhands::transform_origin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transform_origin),
                " must match longhands::",
                stringify!(transform_origin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_template_columns(),
            longhands::grid_template_columns::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_template_columns),
                " must match longhands::",
                stringify!(grid_template_columns),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_template_rows(),
            longhands::grid_template_rows::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_template_rows),
                " must match longhands::",
                stringify!(grid_template_rows),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_image_source(),
            longhands::border_image_source::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_image_source),
                " must match longhands::",
                stringify!(border_image_source),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_list_style_image(),
            longhands::list_style_image::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(list_style_image),
                " must match longhands::",
                stringify!(list_style_image),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_auto_columns(),
            longhands::grid_auto_columns::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_auto_columns),
                " must match longhands::",
                stringify!(grid_auto_columns),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_auto_rows(),
            longhands::grid_auto_rows::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_auto_rows),
                " must match longhands::",
                stringify!(grid_auto_rows),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__moz_window_transform(),
            longhands::_moz_window_transform::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_moz_window_transform),
                " must match longhands::",
                stringify!(_moz_window_transform),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_transform(),
            longhands::transform::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(transform),
                " must match longhands::",
                stringify!(transform),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_gap(),
            longhands::column_gap::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_gap),
                " must match longhands::",
                stringify!(column_gap),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_row_gap(),
            longhands::row_gap::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(row_gap),
                " must match longhands::",
                stringify!(row_gap),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_marker_end(),
            longhands::marker_end::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(marker_end),
                " must match longhands::",
                stringify!(marker_end),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_marker_mid(),
            longhands::marker_mid::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(marker_mid),
                " must match longhands::",
                stringify!(marker_mid),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_marker_start(),
            longhands::marker_start::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(marker_start),
                " must match longhands::",
                stringify!(marker_start),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_column_end(),
            longhands::grid_column_end::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_column_end),
                " must match longhands::",
                stringify!(grid_column_end),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_column_start(),
            longhands::grid_column_start::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_column_start),
                " must match longhands::",
                stringify!(grid_column_start),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_row_end(),
            longhands::grid_row_end::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_row_end),
                " must match longhands::",
                stringify!(grid_row_end),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_grid_row_start(),
            longhands::grid_row_start::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(grid_row_start),
                " must match longhands::",
                stringify!(grid_row_start),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_max_height(),
            longhands::max_height::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(max_height),
                " must match longhands::",
                stringify!(max_height),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_max_width(),
            longhands::max_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(max_width),
                " must match longhands::",
                stringify!(max_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_cx(),
            longhands::cx::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(cx),
                " must match longhands::",
                stringify!(cx),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_cy(),
            longhands::cy::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(cy),
                " must match longhands::",
                stringify!(cy),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_offset_distance(),
            longhands::offset_distance::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(offset_distance),
                " must match longhands::",
                stringify!(offset_distance),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_indent(),
            longhands::text_indent::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_indent),
                " must match longhands::",
                stringify!(text_indent),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_x(),
            longhands::x::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(x),
                " must match longhands::",
                stringify!(x),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_y(),
            longhands::y::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(y),
                " must match longhands::",
                stringify!(y),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_bottom_left_radius(),
            longhands::border_bottom_left_radius::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_bottom_left_radius),
                " must match longhands::",
                stringify!(border_bottom_left_radius),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_bottom_right_radius(),
            longhands::border_bottom_right_radius::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_bottom_right_radius),
                " must match longhands::",
                stringify!(border_bottom_right_radius),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_top_left_radius(),
            longhands::border_top_left_radius::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_top_left_radius),
                " must match longhands::",
                stringify!(border_top_left_radius),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_top_right_radius(),
            longhands::border_top_right_radius::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_top_right_radius),
                " must match longhands::",
                stringify!(border_top_right_radius),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_height(),
            longhands::height::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(height),
                " must match longhands::",
                stringify!(height),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_min_height(),
            longhands::min_height::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(min_height),
                " must match longhands::",
                stringify!(min_height),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_min_width(),
            longhands::min_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(min_width),
                " must match longhands::",
                stringify!(min_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_width(),
            longhands::width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(width),
                " must match longhands::",
                stringify!(width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_outline_offset(),
            longhands::outline_offset::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(outline_offset),
                " must match longhands::",
                stringify!(outline_offset),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_overflow_clip_margin(),
            longhands::overflow_clip_margin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(overflow_clip_margin),
                " must match longhands::",
                stringify!(overflow_clip_margin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_margin_bottom(),
            longhands::scroll_margin_bottom::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_margin_bottom),
                " must match longhands::",
                stringify!(scroll_margin_bottom),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_margin_left(),
            longhands::scroll_margin_left::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_margin_left),
                " must match longhands::",
                stringify!(scroll_margin_left),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_margin_right(),
            longhands::scroll_margin_right::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_margin_right),
                " must match longhands::",
                stringify!(scroll_margin_right),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_margin_top(),
            longhands::scroll_margin_top::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_margin_top),
                " must match longhands::",
                stringify!(scroll_margin_top),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_padding_bottom(),
            longhands::padding_bottom::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(padding_bottom),
                " must match longhands::",
                stringify!(padding_bottom),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_padding_left(),
            longhands::padding_left::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(padding_left),
                " must match longhands::",
                stringify!(padding_left),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_padding_right(),
            longhands::padding_right::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(padding_right),
                " must match longhands::",
                stringify!(padding_right),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_padding_top(),
            longhands::padding_top::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(padding_top),
                " must match longhands::",
                stringify!(padding_top),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_r(),
            longhands::r::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(r),
                " must match longhands::",
                stringify!(r),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_shape_margin(),
            longhands::shape_margin::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(shape_margin),
                " must match longhands::",
                stringify!(shape_margin),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_rx(),
            longhands::rx::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(rx),
                " must match longhands::",
                stringify!(rx),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_ry(),
            longhands::ry::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(ry),
                " must match longhands::",
                stringify!(ry),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_padding_bottom(),
            longhands::scroll_padding_bottom::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_padding_bottom),
                " must match longhands::",
                stringify!(scroll_padding_bottom),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_padding_left(),
            longhands::scroll_padding_left::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_padding_left),
                " must match longhands::",
                stringify!(scroll_padding_left),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_padding_right(),
            longhands::scroll_padding_right::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_padding_right),
                " must match longhands::",
                stringify!(scroll_padding_right),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_scroll_padding_top(),
            longhands::scroll_padding_top::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(scroll_padding_top),
                " must match longhands::",
                stringify!(scroll_padding_top),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_rule_width(),
            longhands::column_rule_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_rule_width),
                " must match longhands::",
                stringify!(column_rule_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__webkit_text_stroke_width(),
            longhands::_webkit_text_stroke_width::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_webkit_text_stroke_width),
                " must match longhands::",
                stringify!(_webkit_text_stroke_width),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_bottom(),
            longhands::bottom::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(bottom),
                " must match longhands::",
                stringify!(bottom),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_left(),
            longhands::left::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(left),
                " must match longhands::",
                stringify!(left),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_margin_bottom(),
            longhands::margin_bottom::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(margin_bottom),
                " must match longhands::",
                stringify!(margin_bottom),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_margin_left(),
            longhands::margin_left::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(margin_left),
                " must match longhands::",
                stringify!(margin_left),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_margin_right(),
            longhands::margin_right::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(margin_right),
                " must match longhands::",
                stringify!(margin_right),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_margin_top(),
            longhands::margin_top::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(margin_top),
                " must match longhands::",
                stringify!(margin_top),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_right(),
            longhands::right::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(right),
                " must match longhands::",
                stringify!(right),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_underline_offset(),
            longhands::text_underline_offset::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_underline_offset),
                " must match longhands::",
                stringify!(text_underline_offset),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_top(),
            longhands::top::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(top),
                " must match longhands::",
                stringify!(top),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_background_color(),
            longhands::background_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(background_color),
                " must match longhands::",
                stringify!(background_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_bottom_color(),
            longhands::border_bottom_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_bottom_color),
                " must match longhands::",
                stringify!(border_bottom_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_left_color(),
            longhands::border_left_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_left_color),
                " must match longhands::",
                stringify!(border_left_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_right_color(),
            longhands::border_right_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_right_color),
                " must match longhands::",
                stringify!(border_right_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_border_top_color(),
            longhands::border_top_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(border_top_color),
                " must match longhands::",
                stringify!(border_top_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_column_rule_color(),
            longhands::column_rule_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(column_rule_color),
                " must match longhands::",
                stringify!(column_rule_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_flood_color(),
            longhands::flood_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(flood_color),
                " must match longhands::",
                stringify!(flood_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_lighting_color(),
            longhands::lighting_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(lighting_color),
                " must match longhands::",
                stringify!(lighting_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_outline_color(),
            longhands::outline_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(outline_color),
                " must match longhands::",
                stringify!(outline_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_stop_color(),
            longhands::stop_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(stop_color),
                " must match longhands::",
                stringify!(stop_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_decoration_color(),
            longhands::text_decoration_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_decoration_color),
                " must match longhands::",
                stringify!(text_decoration_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone_text_emphasis_color(),
            longhands::text_emphasis_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(text_emphasis_color),
                " must match longhands::",
                stringify!(text_emphasis_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__webkit_text_fill_color(),
            longhands::_webkit_text_fill_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_webkit_text_fill_color),
                " must match longhands::",
                stringify!(_webkit_text_fill_color),
                "::get_initial_value()"
            )
        );
        assert_eq!(
            cv.clone__webkit_text_stroke_color(),
            longhands::_webkit_text_stroke_color::get_initial_value(),
            concat!(
                "initial value in Gecko style struct for ",
                stringify!(_webkit_text_stroke_color),
                " must match longhands::",
                stringify!(_webkit_text_stroke_color),
                "::get_initial_value()"
            )
        );
    }
}
